<?php
include "../common.php";
include "../include/config_admin.php";
include "../include/functions_admin.php";
include "../include/function_usa_convert.php";

if ($user['root']==0 || $user['id'] == 0 || !isset($user['id'])){
	PermissionError($lang['err']['not_perm']);
	exit;
}else{
	$sel = $_GET["sel"]?$_GET["sel"]:$_POST["sel"];
	$convertto = $_GET["convertto"]?$_GET["convertto"]:$_POST["convertto"];
	$mode_form = $_GET["mode_form"]?$_GET["mode_form"]:$_POST["mode_form"];
	
	switch($sel){
		case "view"		:	ViewForm($mode_form);break;
		case "convert"	:	ConvertTo($convertto,$mode_form);break;
		case "delete"	:	DeleteForm($mode_form);break;
		case "print"	:	PrintForm($mode_form);break;
		default			: 	ViewForm($mode_form);
	}
}

function ConvertTo($convertto,$mode_form){
	global $smarty, $dbconn, $config, $config_admin, $lang,$user,$admin_lang;
	AdminMainMenu();
	
	$result = array();
	for ($i=1; $i<15; $i++){
		$rs = $dbconn->Execute("select * from ".constant("APP_FORM_".$i."_TABLE")." where id='".intval($_REQUEST['id'])."'");
		$result = array_merge($result,$rs->GetRowAssoc(false));
    }
	$date = date("Y_m_d");
    switch($convertto){
		case "calyx"	: 
				$data = ConvertToPoint ($result,"calyx_".$id."_".$date);
				$filename = "calyx_".$id."_".$date.".a";
				$header = "Content-Description: PHP Generated Calyx Point Data";
				$header1= "Content-type: text/a";
				break;
		case "fannie"	: 
				$data = ConvertToFannie($result,"fannie_".$id."_".date("Y_m_d"));
				$filename = "fannie_".$id."_".$date.".fnm";
				$header = "Content-Description: PHP Generated Calyx Point Data";
				$header1= "Content-type: text/fnm";
				break;
		case "csv"		: 
				$data = db2csv($mode_form, ",",intval($_REQUEST['id']));
				$filename = "temp_csv_".$date.".csv";
				$header = "Content-Description: PHP Generated CSV Data";
				$header1= "Content-type: text/csv";
				break;
	}
    
	if (!is_dir($config["site_path"]."/export/")) {
		mkdir($config["site_path"]."/export/",0777);
	}
	$fd = fopen ($config["site_path"]."/export/".$filename, "w");
	fputs ($fd, $data);
	fclose ($fd);
	
	header ( "Cache-Control: public" );
	header ( $header );
	header ( "Content-Disposition: attachment; filename=$filename" );
	header ( $header1 );
	echo $data;
	exit;
	
}

function DeleteForm($mode_form){
	global $smarty, $dbconn, $config, $config_admin, $lang,$user,$admin_lang;
	
	$id = intval($_GET["did"]);
	if (isset($id) && $id>0) {
		switch ($mode_form) {
			case "refinance":
				$rs = $dbconn->Execute("delete from ".REFINANCE_TABLE." where id=".$id);
				break;
			case "prequalify":
				$rs = $dbconn->Execute("delete from ".PREQUALIFY_TABLE." where id=".$id);
				break;
			case "full":
				$dbconn->Execute("delete from ".APPLICATION_FORM_TABLE." where id_form=".$id);
				for ($i=1; $i<15; $i++)
					$rs = $dbconn->Execute("delete from ".constant("APP_FORM_".$i."_TABLE")." where id=".$id);
				break;
		}
	}
	ViewForm($mode_form);
	exit;
}

function PrintForm($mode_form){
	global $smarty, $dbconn, $config, $config_admin, $lang,$user,$admin_lang;
	AdminMainMenu();
	
	if (isset($_GET["id"]) && !empty($_GET["id"])) {
    	$id = intval($_GET["id"]);
	
		switch($mode_form){
        case "refinance":
        	$rs = $dbconn->Execute("select * from ".REFINANCE_TABLE." where id={$id}");
        	$row = $rs->GetRowAssoc(false);
	        foreach ($row as $key=>$value) {
   		     	switch ($key){
       		 		case "property_will_be":
        				$value = GetProperty($value);
        				break;
        			case "prop_type":
        				$value = GetPropertyType ($value);
        				break;
        			case "loan_type":
        				$value = GetLoanType ($value);
        				break;
        			case "refi_reason":
        				$value = GetRefReason ($value);
        				break;
        			case "self_grade_credit_score":
        				$value = GetScore ($value);
        				break;
       		 		case "application_type":
        				$value = GetApplicationType ($value);
        				break;
     		   		case "security_question":
        				$value = GetSecurityQuestion($value);
        				break;
        		}
        		$data[$key] = $value;
        	}
        	$smarty->assign("data",$data);
        	$smarty->assign("id",$id);
        	$table = $smarty->fetch(TrimSlash($config["admin_theme_path"])."/admin_print_refinance_table.tpl");
        	break;

        case "prequalify":
        	$rs = $dbconn->Execute("select * from ".PREQUALIFY_TABLE." where id=".$id);
        	$row = $rs->GetRowAssoc();
    		foreach($row as $key=>$value){
    			switch($key){
    				case "proptype":
    					$value = GetPropType ($value);
   						break;
   					case "creditrating":
   						$value = GetCreditRating($value);
    					break;
    				case "empstatus":
    					$value = GetEmpStatus($value);
    					break;
    				case "keepconsolidate":
    					$value = GetKeepConsolidate($value);
    					break;
    				case "mortgageinsurance":
    					$value = GetYesNo($value);
    					break;
    				case "lineofcredit":
    					$value = GetYesNo($value);
    					break;
    				case "lineofcreditwithdrawn":
    					$value = GetYesNo($value);
    					break;
    				case "secondmortgage":
    					$value = GetYesNo($value);
    					break;
   				}
   				$data[$key] = $value;
   			}
			$smarty->assign("data",$data);
			$smarty->assign("id",$id);
			$table = $smarty->fetch(TrimSlash($config["admin_theme_path"])."/admin_print_prequalify_table.tpl");
        	break;

        case "full":
			for ($j=1; $j<15; $j++) {
				$SQL = "SELECT * FROM ".constant("APP_FORM_".$j."_TABLE")." WHERE	id = ".$id;
				$res = $dbconn->Execute($SQL);
				if(!$res){
					echo $dbconn->ErrorMsg();
				}else{
					$result = $res->GetRowAssoc(false);
					$num = $res->FieldCount();
					for ($i=1;$i<$num;$i++){
						$fld = $res->FetchField($i);
						$FieldName[$i] = $fld->name;
        
						$FieldType[$i] = $res->MetaType($fld->type);
						if($FieldType[$i] != 'I' && $FieldType[$i] != 'N' && $FieldType[$i] != 'D'  && $FieldType[$i] != 'T'){
							if ($j != 7 && $j !=11){           
								if ($result[$FieldName[$i]] == "chb_yes")
									$result[$FieldName[$i]] = "X";                  
								if ($result[$FieldName[$i]] == "chb_no")
									$result[$FieldName[$i]] = ""; 
							} 
							if($j == 7){    //values from tab7
								if ($result[$FieldName[$i]] == "chb_yes") {
									$chr = substr($FieldName[$i],0,1);
									if ($chr == "b")
										$result[$FieldName[$i]] = "B";
									if ($chr == "c")
										$result[$FieldName[$i]] = "C";
								}
								if ($result[$FieldName[$i]] == "chb_no")
									$result[$FieldName[$i]] ="";          
							}
							if($j == 11){    //values from tab11
								$chr = substr($FieldName[$i],0,7);
								if ($chr == "pay_off"){
									if ($result[$FieldName[$i]] == "chb_yes")
										$result[$FieldName[$i]] = "*";
									else 
										$result[$FieldName[$i]] = "";
								}else{  
									if ($result[$FieldName[$i]] == "chb_yes")
										$result[$FieldName[$i]] = "X";                  
									if ($result[$FieldName[$i]] == "chb_no")
										$result[$FieldName[$i]] = "";  
								}
							}
						}
					}    
					$name_res = "res".$j;
					$smarty->assign($name_res,$result);
				}
	    	}
	    	$rs = $dbconn->Execute("select name from ".LOAN_OFFICER_TABLE." where id={$res1["AGENT_NAME"]}");
			
			$smarty->assign("AGENT_NAME", $rs->fields[0]);
			$smarty->assign("id",$id);
	    	$table = $smarty->fetch(TrimSlash($config["index_theme_path"])."/tab_res.tpl");
			break;
    	}
    
		$smarty->assign("form",$mode_form);
	    print $table;
		print "<script language='Javascript'>window.print();window.close()</script>";
		exit;
	}else{
		ViewForm($mode_form);
		exit;
	}
}

function ViewForm($mode_form){
	global $smarty, $dbconn, $config, $config_admin, $lang,$user,$admin_lang;
	AdminMainMenu();
	
	if(isset($_SERVER["PHP_SELF"]))
		$form["action"] = AfterLastSlash($_SERVER["PHP_SELF"]);
	else
		$form["action"] = "admin_forms_usa.php";
	
	switch ($mode_form){
		case "refinance":
			if (!isset($_GET["id"]) || empty($_GET["id"]) ){
				$rs = $dbconn->Execute("select min(id) from ".REFINANCE_TABLE);
				$id = $rs->RowCount()? intval($rs->fields[0]):0;
			}else{
				$id = intval($_GET["id"]);
			}
			
			$rs = $dbconn->Execute("select min(id) from ".REFINANCE_TABLE." where id>".$id);
			$next = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select max(id) from ".REFINANCE_TABLE." where id<".$id);
			$prev = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select count(*) from ".REFINANCE_TABLE." where id<".$id." or id=".$id);
			$num = $rs->RowCount()? intval($rs->fields[0]):0;
			
			$rs = $dbconn->Execute("select count(*) from ".REFINANCE_TABLE);
			$count = $rs->RowCount()? intval($rs->fields[0]):0;
			
			$rs = $dbconn->Execute("select * from ".REFINANCE_TABLE." where id=".$id);
			if ($rs->RowCount() || $rs_count == "true") {
				$row = $rs->GetRowAssoc();
				foreach ($row as $key=>$value){
					switch ($key){
						case "PROPERTY_WILL_BE":
							$value = GetProperty($value);
							break;
						case "PROP_TYPE":
							$value = GetPropertyType ($value);
							break;
						case "LOAN_TYPE":
							$value = GetLoanType ($value);
							break;
						case "REFI_REASON":
							$value = GetRefReason ($value);
							break;
						case "SELF_GRADE_CREDIT_SCORE":
							$value = GetScore ($value);
							break;
						case "APPLICATION_TYPE":
							$value = GetApplicationType ($value);
							break;
						case "SECURITY_QUESTION":
							$value = GetSecurityQuestion($value);
							break;
					}
					$data[$key] = $value;
				}
				$smarty->assign("data",$data);
			}else{
				$smarty->assign("data",array());
			}
			$smarty->assign("id", $id);
			$table = $smarty->fetch(TrimSlash($config["admin_theme_path"])."/admin_refinance_table.tpl");
			$smarty->assign("header2", $admin_lang["header"]["forms_usa_refinance"]["header2"]);
			break;
		case "prequalify":
			if (!isset($_GET["id"]) || empty($_GET["id"]) ){
				$rs = $dbconn->Execute("select min(id) from ".PREQUALIFY_TABLE);
				$id = $rs->RowCount()? intval($rs->fields[0]):0;
			}else{
				$id = intval($_GET["id"]);
			}
			
			$rs = $dbconn->Execute("select min(id) from ".PREQUALIFY_TABLE." where id>".$id);
			$next = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select max(id) from ".PREQUALIFY_TABLE." where id<".$id);
			$prev = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select count(*) from ".PREQUALIFY_TABLE." where id<".$id." or id=".$id);
			$num = $rs->RowCount()? intval($rs->fields[0]):0;
			
			$rs = $dbconn->Execute("select count(*) from ".PREQUALIFY_TABLE);
			$count = $rs->RowCount()? intval($rs->fields[0]):0;
			
			$rs = $dbconn->Execute("select * from ".PREQUALIFY_TABLE." where id=".$id);
			if ($rs->RowCount() || $rs_count == "true") {
				$row = $rs->GetRowAssoc();
				foreach ($row as $key=>$value) {
					switch ($key) {
						case "PROPTYPE":
							$value = GetPropType ($value);
							break;
						case "CREDITRATING":
							$value = GetCreditRating($value);
							break;
						case "EMPSTATUS":
							$value = GetEmpStatus($value);
							break;
						case "KEEPCONSOLIDATE":
							$value = GetKeepConsolidate($value);
							break;
						case "MORTGAGEINSURANCE":
							$value = GetYesNo($value);
							break;
						case "LINEOFCREDIT":
							$value = GetYesNo($value);
							break;
						case "LINEOFCREDITWITHDRAWN":
							$value = GetYesNo($value);
							break;
						case "SECONDMORTGAGE":
							$value = GetYesNo($value);
							break;
					}
					$data[$key] = $value;
				}
				$smarty->assign("data",$data);
			}else{
				$smarty->assign("data",array());
			}
			$smarty->assign("id", $id);
			$table = $smarty->fetch(TrimSlash($config["admin_theme_path"])."/admin_prequalify_table.tpl");
			$smarty->assign("header2", $admin_lang["header"]["forms_usa_prequalify"]["header2"]);
			break;
		case "full":
			if (!isset($_GET["id"]) || empty($_GET["id"]) ){
				$rs = $dbconn->Execute("select min(id) from ".APP_FORM_1_TABLE);
				$id = $rs->RowCount()? intval($rs->fields[0]):0;
			}else{
				$id = intval($_GET["id"]);
			}
			$rs = $dbconn->Execute("select min(id) from ".APP_FORM_1_TABLE." where id>".$id);
			$next = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select max(id) from ".APP_FORM_1_TABLE." where id<".$id);
			$prev = $rs->RowCount()? $rs->fields[0]:"";
			
			$rs = $dbconn->Execute("select count(*) from ".APP_FORM_1_TABLE." where id<".$id." or id=".$id);
			$num = $rs->RowCount()? intval($rs->fields[0]):0;
			
			$rs = $dbconn->Execute("select count(*) from ".APP_FORM_1_TABLE);
			$count = $rs->RowCount()? intval($rs->fields[0]):0;
			
			for ($i=1; $i<15; $i++){
				$rs = $dbconn->Execute("select * from ".constant("APP_FORM_".$i."_TABLE")." where id=".$id);
				if ($rs->RowCount() && $i == 1)
					$rs_count = "true";
				$num_fields = $rs->FieldCount();
				if ($i == 13){
					for ($j=1; $j<$num_fields; $j++){
						if ($rs->fields[$j] == "chb_yes")
							$rs->fields[$j] = "X";
						if ($rs->fields[$j] == "chb_no")
							$rs->fields[$j] = "  ";
					}
				}
				for ($j=1; $j<$num_fields; $j++){
					if ($rs->fields[$j] == "chb_yes")
						$rs->fields[$j] = "Yes";
				}
				if ($i == 14){
					for ($j=1; $j<$num_fields; $j++){
						if ($rs->fields[$j] == "chb_no")
							$rs->fields[$j] = "No";
					}
				}
				$result[$i] = $rs;
			}
			for ($i=1; $i<15; $i++){
				$data[$i] = $result[$i]->GetRowAssoc();
				$smarty->assign("data".$i, $data[$i]);
			}
			$rs = $dbconn->Execute("select name from ".LOAN_OFFICER_TABLE." where id={$data1["AGENT_NAME"]}");
			
			$smarty->assign("AGENT_NAME", $rs->fields[0]);
			$smarty->assign("id", $id);
			
			$table = $smarty->fetch(TrimSlash($config["admin_theme_path"])."/admin_full_app_table.tpl");
			$smarty->assign("header2", $admin_lang["header"]["forms_usa_full"]["header2"]);
			break;
	}
	
	$rs = $dbconn->Execute("select id, name,alias from ".FORMS_TABLE." where id_location=".$config["default_location"]);
	$i = 0;
	while(!$rs->EOF){
		$row = $rs->GetRowAssoc(false);
		$forms[$i]["id"] = $row["id"];
		$forms[$i]["name"] = $row["name"];
		$forms[$i]["alias"] = $row["alias"];
		$rs->MoveNext(); $i++;
	}
	

	$smarty->assign("id",$id);
	$smarty->assign("next",$next);
	$smarty->assign("prev",$prev);
	$smarty->assign("count",$count);
	$smarty->assign("num",$num);
	$smarty->assign("table",$table);
	$smarty->assign("mode_form",$mode_form);
	$smarty->assign("form",$form);
	$smarty->assign("forms",$forms);
	$smarty->assign("header1", $admin_lang["header"]["customers_management"]["header1"]);
	$smarty->assign("hint",str_replace("[filename]","calyx_".$id."_".date("Y_m_d").".a",$admin_lang["admin_help"]["forms"]));
	
	$smarty->display(TrimSlash($config["admin_theme_path"])."/admin_customer.tpl");
}
?>