<?php
define('FPDF_FONTPATH','./');
require('fpdf.php');
class PDF extends FPDF
{
//Page header
function Header()
{
	global $title,$session,$e,$lang,$title_link;


	//Logo
    $this->Image('crm.png',10,8,10,'','','http://crm.it-combine.com');

    //Arial bold 15
    //$this->Ln(15);
    $this->SetFont('Arial','',8);
    //Move to the right
    //$this->Cell(20);
    //Title
    $this->Cell(0,10,$title,0,0,'L',0,$title_link);
    //Line break
    //$this->Ln(20);
	$this->Ln(15);
}
function PutLink($URL,$txt)
{
    //Put a hyperlink
    $this->SetTextColor(0,0,255);
    $this->SetStyle('U',true);
    $this->Write(5,$txt,$URL);
    $this->SetStyle('U',false);
    $this->SetTextColor(0);
}
function SetStyle($tag,$enable)
{
    //Modify style and select corresponding font
    $this->$tag+=($enable ? 1 : -1);
    $style='';
    foreach(array('B','I','U') as $s)
        if($this->$s>0)
            $style.=$s;
    $this->SetFont('',$style);
}
//Page footer
function Footer()
{
    //Position at 1.5 cm from bottom
    $this->SetY(-15);
    //Arial italic 8
    $this->SetFont('Arial','I',8);
    //Page number
    $this->Cell(0,10,'Page '.$this->PageNo().'/{nb}',0,0,'C');
}

function FancyTable4colSinglePDF($header,$data)
{
    //Colors, line width and bold font
    $this->SetFillColor(128,0,0);
    $this->SetTextColor(255);
    $this->SetDrawColor(128,0,0);
    $this->SetLineWidth(.3);
    $this->SetFont('','B');
    //Header
    $w=array(30,20,30,110);
    for($i=0;$i<count($header);$i++)
        $this->Cell($w[$i],7,$header[$i],1,0,'C',1);
    $this->Ln();
    //Color and font restoration
    $this->SetFillColor(224,235,255);
    $this->SetTextColor(0);
    $this->SetFont('');
    //Data
    $fill=0;
    foreach($data as $row)
    {
        $this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
        $this->Cell($w[1],6,$row[1],'LR',0,'L',$fill);
        $this->Cell($w[2],6,$row[2],'LR',0,'L',$fill);
		$this->Cell($w[4],6,$row[4],'LR',0,'L',$fill,$row[3]);
        $this->Ln();
        $fill=!$fill;
    }
    $this->Cell(array_sum($w),0,'','T');
}

function FancyTable2col($header,$data)
{
//		return(1);
    //Colors, line width and bold font
    $this->SetFillColor(128,0,0);
    $this->SetTextColor(255);
    $this->SetDrawColor(128,0,0);
    $this->SetLineWidth(.3);
    $this->SetFont('','B');
    //Header
    $w=array(80,80);

    $this->Cell($w[0],7,$header[0],1,0,'C',1);
    $this->Cell(0,7,$header[1],1,0,'C',1);

	$this->Ln();
    //Color and font restoration
    $this->SetFillColor(224,235,255);
    $this->SetTextColor(0);
    $this->SetFont('');
    //Data
    $fill=0;
    foreach($data as $row)
    {
        $this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
        $this->Cell(0,6,$row[1],'LR',0,'L',$fill);
        $this->Ln();
        $fill=!$fill;
    }
    $this->Cell(0,0,'','T');
}
function FancyTable3col($header,$data)
{
    //Colors, line width and bold font
    $this->SetFillColor(128,0,0);
    $this->SetTextColor(255);
    $this->SetDrawColor(128,0,0);
    $this->SetLineWidth(.3);
    $this->SetFont('','B');
    //Header
    $w=array(80,10,10);
    for($i=0;$i<count($header);$i++)
        $this->Cell($w[$i],7,$header[$i],1,0,'C',1);
    $this->Ln();
    //Color and font restoration
    $this->SetFillColor(224,235,255);
    $this->SetTextColor(0);
    $this->SetFont('');
    //Data
    $fill=0;
    foreach($data as $row)
    {
		if ($row[3]<>"" && $row[4]<>"" && $row[5]<>"") {
			    $this->SetFillColor($row[3], $row[4], $row[5]);
				if ($fill==0) {
					$fill=1;
					$fillset=1;
				}
		}
        $this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
		if ($fillset) {
			$fill=0;
		}
		unset($fillset);
	    $this->SetFillColor(224,235,255);
        $this->Cell($w[1],6,$row[1],'LR',0,'L',$fill);
        $this->Cell($w[2],6,$row[2],'LR',0,'L',$fill);
        $this->Ln();
        $fill=!$fill;
    }
    $this->Cell(array_sum($w),0,'','T');
}
function FancyTable5col($header,$data)
{
    //Colors, line width and bold font
    $this->SetFillColor(128,0,0);
    $this->SetTextColor(255);
    $this->SetDrawColor(128,0,0);
    $this->SetLineWidth(.3);
    $this->SetFont('','B');
    //Header
    $w=array(10,10,10,10,80);
    for($i=0;$i<count($header);$i++)
        $this->Cell($w[$i],7,$header[$i],1,0,'C',1);
    $this->Ln();
    //Color and font restoration
    $this->SetFillColor(224,235,255);
    $this->SetTextColor(0);
    $this->SetFont('');
    //Data
    $fill=0;
    foreach($data as $row)
    {
        $this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
        $this->Cell($w[1],6,$row[1],'LR',0,'L',$fill);
        $this->Cell($w[2],6,$row[2],'LR',0,'L',$fill);
        $this->Cell($w[3],6,$row[3],'LR',0,'L',$fill);
        $this->Cell($w[4],6,$row[4],'LR',0,'L',$fill);
        $this->Ln();
        $fill=!$fill;
    }
    $this->Cell(array_sum($w),0,'','T');
}
}

function hex2rgb($hex) {
    preg_replace('/([0-9a-f]{2})/ie', '$rgb[] = hexdec(\1)', $hex);
    return $rgb;
}
function line() {
		global $pdf;
	    $pdf->SetFillColor(128,0,0);
		$pdf->Cell(0,.2,"",0,1,'L',1);
		$pdf->Ln(1);
}

?>