<?php

/**
* Data selection module. Dependency - Smarty class.
* @package Module Data Selection
* @copyright Pilot Group <http://www.pilotgroup.net/>
* @author $Author: sharapov $
* @version 1.0 $Revision: 1.1 $ $Date: 2007/08/02 11:05:53 $
* @todo    
**/
class DateSelection {
	
	/**
	* List of errors
	* @access public
	* @var array
	**/
	var $errors = array();
	
	/**
	* First day of the week - sunday or monday
	* @access public
	* @var string
	**/
	var $first_day = "monday";
	
	/**
	* Selected year
	* @access public
	* @var integer
	**/
	var $selected_year = 0;
	
	/**
	* Selected month
	* @access public
	* @var integer
	**/
	var $selected_month = 0;
	
	/**
	* Displayed language
	* @access public
	* @var string
	**/
	var $language = "eng";
	
	/**
	* Skin
	* @access public
	* @var string
	**/	
	var $skin = "default";
	
	/**
	* 
	* @access public
	* @var integer
	**/
	var $year_diapason = 70;
	
	/**
	* Response URL
	* @access public
	* @var string
	**/
	var $response_url = "";
	
	/**
	* Additional parameters of response
	* @access public
	* @var string
	**/
	var $response_additional = "";
	
	/**
	* Link to Smarty object
	* @access private
	* @var object
	**/
	var $__obj_smarty;
	
	/**
	* Constructor
	* @access public
	* @param void
	* @return void
	**/
	function DateSelection( &$smarty, $response_url, $response_additional = "" ) {
		if ( is_object( $smarty ) ) {
			$this->__obj_smarty = $smarty;
		} else {
			$this->errors[] = "Required Smarty object!";
			return false;
		}
		if ( empty( $response_url ) ) {
			$this->errors[] = "Required response URL!";
			return false;
		} else {
			$this->response_url = $response_url;
		}
		if ( !empty( $response_additional ) ) {
			$this->response_additional = $response_additional;
		}
		if ( !defined( "DATE_SELECTION_CONFIG" ) ) {
			$this->errors[] = "data_selection.config.php must be included!";
			return false;
		}
		
	}
	
	/**
	* Display calendar
	* @access public
	* @param void
	* @return void
	**/
	function Display() {
				
		$lang_file = DATE_SELECTION_LANGS_PATH.$this->language.".php";
		
		if ( !file_exists( $lang_file ) ) {
			$this->errors[] = "Language file \"{$lang_file}\" not exist!";
			return false;
		} else {
			include_once $lang_file;
		}
		
		$skin_template = DATE_SELECTION_SKINS_PATH.$this->skin."/calendar.tpl";
		
		if ( !file_exists( $skin_template ) ) {
			$this->errors[] = "Template file \"{$skin_template}\" not exist!";
			return false;
		} else {
			$this->__obj_smarty->template_dir = dirname( $skin_template );
			$this->__obj_smarty->compile_dir = dirname( $skin_template );
		}
		
		$this->__obj_smarty->assign( "st", $st );
		
		$this->__obj_smarty->assign( "response_url", $this->response_url );
		$this->__obj_smarty->assign( "response_additional", $this->response_additional );
		
		$current_day = adodb_getdate();
		
		//$selected_month = $this->selected_month == 0 ? $current_day["mon"] : $this->selected_month;
		
		$months = array();
		for ( $cnt = 1; $cnt <= 12; $cnt++ ) {
			$months[$cnt] = $this->selected_month == $cnt ? true : false;
		}
		$this->__obj_smarty->assign( "months", $months );
		$this->__obj_smarty->assign( "selected_month", $this->selected_month );
		
		//$selected_year = $this->selected_year == 0 ? $current_day["year"] : $this->selected_year;
		
		$years = array();
		for ( $cnt = ( $this->selected_year - $this->year_diapason ); $cnt <= ( $this->selected_year/* + $this->year_diapason */); $cnt++ ) {
			$years[$cnt] = $this->selected_year == $cnt ? true : false;
		}
		$this->__obj_smarty->assign( "years", $years );
		$this->__obj_smarty->assign( "selected_year", $this->selected_year );
		
		$amount_days = adodb_date( "t", adodb_mktime( 0, 0, 0, $this->selected_month, 1, $this->selected_year ) );
		$first_day = adodb_getdate( adodb_mktime( 0, 0, 0, $this->selected_month, 1, $this->selected_year ) );
		//redefine selected_month!!!
		$selected_month = adodb_getdate( adodb_mktime( 0, 0, 0, $this->selected_month, 1, $this->selected_year ) );
		
		
		$calendar = array();
		
		$week = array(	0 => "false",
						1 => "false",
						2 => "false",
						3 => "false",
						4 => "false",
						5 => "false",
						6 => "false");
		
		$week[$first_day["wday"]] = array(	"mday" => $first_day["mday"],
											"wday" => $first_day["wday"] );
		if ( $current_day["mday"] == $first_day["mday"] &&
			 $current_day["mon"] == $first_day["mon"] && 
			 $current_day["year"] == $first_day["year"] ) 
		{
			$week[$first_day["wday"]]["current_day"] = "true";
		} else {
			$week[$first_day["wday"]]["current_day"] = "false";
		}
		for ( $days_cnt = 2; $days_cnt <= $amount_days; $days_cnt++ ) {
			$this_day = adodb_getdate( adodb_mktime(0, 0, 0, $first_day["mon"], $days_cnt, $first_day["year"]) );
			
			if ( $this_day["wday"] == 1 ) {
				$calendar[] = $week;
				$week = array(	
								0 => "false",
								1 => "false",
								2 => "false",
								3 => "false",
								4 => "false",
								5 => "false",
								6 => "false");
			}
			$week[$this_day["wday"]] = array(	"mday" => $this_day["mday"],
												"wday" => $this_day["wday"] );
			if ( $current_day["mday"] == $this_day["mday"] &&
				 $current_day["mon"] == $this_day["mon"] &&
				 $current_day["year"] == $this_day["year"] ) 
			{
				$week[$this_day["wday"]]["current_day"] = "true";
			} else {
				$week[$this_day["wday"]]["current_day"] = "false";
			}
		}
		$calendar[] = $week;
		$this->__obj_smarty->assign( "calendar", $calendar );
		
		$this->__obj_smarty->assign( "page_path", DATE_SELECTION_VIRTUAL_PATH."date_selection.php" );
		
		$this->__obj_smarty->display( "calendar.tpl" );
	}
}

?>