<?php
function Menu( $menu_index ){
	global $config;
	$lang = parse("{$config["site_path"]}{$_SESSION["path_lang"]}/menu.xml");
	$res = CreateMenu("menu");
	$use_rate_information = intval(GetSiteSettings('use_rate_information'));
	$menu = array();
	if(count($res[$menu_index])>0){
		foreach ( $res[$menu_index][1] as $cnt => $item){
			if($item[0][2] != 0){
				if($item[0][0] == 'mortgage_rates' && !$use_rate_information){
					continue;
				}else{
					$menu[$cnt]["name"]=$lang[$item[0][0]]["name"];
					$menu[$cnt]["img"]=$item[0][3];	
					$menu[$cnt]["href"]=$item[0][1];
				}
			}
		}
	}
	return $menu;
}

function CreateMenu( $menu_name ){
	global $config; //, $smarty
	$xml_parser = new SimpleXmlParser( $config["site_path"]."/include/".$menu_name.".xml" );
	$xml_root = $xml_parser->getRoot();
	
	$menu_arr = array();
	$menu_arr = XMLMenu( $xml_root );
	unset( $xml_parser, $xml_root );
	return $menu_arr;
}

function XMLMenu( $root ) {
	//global $config, $lang;
	$menu = array();
	foreach ( $root->children as $cnt => $node ) {
		switch($node->tag){
			case "section":
				$menu[$cnt] = array();
				$menu[$cnt][0] = $node->attrs["name"];
				$menu[$cnt][1] = array();
				if ($node->childrenCount > 0) {
					$menu[$cnt][1] = XMLMenu( $node );
				}
				break;
			case "item":
				$menu[$cnt] = array();
				$menu[$cnt][0] = array();
				$menu[$cnt][0][0] = $node->attrs["name"];
				$menu[$cnt][0][1] = $node->attrs["href"];
				$menu[$cnt][0][2] = $node->attrs["activ"];
				$menu[$cnt][0][3] = isset($node->attrs["img"]) ? $node->attrs["img"] : "";
				$menu[$cnt][1] = array();
				if ($node->childrenCount > 0) {
					$menu[$cnt][1] = XMLMenu( $node );
				}
				break;
			case "subitem":
				$menu[$cnt] = array();
				$menu[$cnt][0] = $node->attrs["name"];
				$menu[$cnt][1] = $node->attrs["href"];
				$menu[$cnt][2] = $node->attrs["activ"];
				$menu[$cnt][3] = isset($node->attrs["img"]) ? $node->attrs["img"] : "";
				break;
		}
	}
	return $menu;
}

function GetErrors($err_name){
	global $config, $smarty;
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"]."errors.xml" );
	$xml_root = $xml_parser->getRoot();
	$i = 0;
	foreach ( $xml_root->children as $cnt => $node ) {
		switch($node->tag){
			case $err_name:
				$error[$i] = $node->value;
				break;
		}
		++$i;
	}
	$smarty->assign("error", $error);
	return ;
}

function GetLangContent($content_name){
	global $config; //, $smarty
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"].$content_name.".xml" );
	$xml_root = $xml_parser->getRoot();
	foreach ( $xml_root->children as $cnt => $node ) {
		$lang_content[$node->tag] = $node->value;
	}
	return $lang_content;	
}

function GetMonth(){
	global $config;
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"]."month.xml" );
	$xml_root = $xml_parser->getRoot();
	foreach ( $xml_root->children as $cnt => $node ) {
		$month_name[$node->tag] = $node->value;
	}
	return $month_name;
}

function GetTypesName(){
	global $config;
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"]."users_types.xml" );
	$xml_root = $xml_parser->getRoot();
	foreach ( $xml_root->children as $cnt => $node ) {
		$users_types[$node->tag] = $node->value;
	}
	return $users_types;
}

function GetAlertsName(){
	global $config;
	$alerts = array();
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"]."alerts.xml" );
	$xml_root = $xml_parser->getRoot();
	foreach ( $xml_root->children as $cnt => $node ) {
		switch($node->tag){
			case "item":
				$alerts[$cnt]["name"] = $node->attrs["name"];
				if (!empty($node->attrs["id"])) {
					$alerts[$cnt]["id"] = $node->attrs["id"];
				}
				break;
		}
	}
	return $alerts;
}

function GetMailContent($mail_template_name){
	global $config;
	$xml_parser = new SimpleXmlParser( $config["site_path"].$config["lang_path"].$mail_template_name.".xml" );
	$xml_root = $xml_parser->getRoot();
	foreach ( $xml_root->children as $cnt => $node ) {
		$mail_content[$node->tag] = $node->value;
	}
	return $mail_content;
}
?>