<?php
/* ********************************************************************
 * CRM
 * Copyright (c) 2001-2004 Hidde Fennema (hidde@it-combine.com)
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file does several things :)
 *
 * Check http://crm.it-combine.com/ for more information
 **********************************************************************
 */

// user defined error handling function
function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars)
{
   // timestamp for the error entry
   $dt = date("Y-m-d H:i:s (T)");

   // define an assoc array of error string
   // in reality the only entries we should
   // consider are E_WARNING, E_NOTICE, E_USER_ERROR,
   // E_USER_WARNING and E_USER_NOTICE
   $errortype = array (
               E_ERROR          => "Error",
               E_WARNING        => "Warning",
               E_PARSE          => "Parsing Error",
               E_NOTICE          => "Notice",
               E_CORE_ERROR      => "Core Error",
               E_CORE_WARNING    => "Core Warning",
               E_COMPILE_ERROR  => "Compile Error",
               E_COMPILE_WARNING => "Compile Warning",
               E_USER_ERROR      => "User Error",
               E_USER_WARNING    => "User Warning",
               E_USER_NOTICE    => "User Notice",
               E_STRICT          => "Runtime Notice"
               );
   // set of errors for which a var trace will be saved
   $user_errors = array(E_USER_ERROR, E_USER_WARNING, E_USER_NOTICE);

   $err = "<errorentry>\n";
   $err .= "\t<datetime>" . $dt . "</datetime>\n";
   $err .= "\t<errornum>" . $errno . "</errornum>\n";
   $err .= "\t<errortype>" . $errortype[$errno] . "</errortype>\n";
   $err .= "\t<errormsg>" . $errmsg . "</errormsg>\n";
   $err .= "\t<scriptname>" . $filename . "</scriptname>\n";
   $err .= "\t<scriptlinenum>" . $linenum . "</scriptlinenum>\n";

   if (in_array($errno, $user_errors))
       $err .= "\t<vartrace>" . wddx_serialize_value($vars, "Variables") . "</vartrace>\n";
   $err .= "</errorentry>\n\n";

   // for testing
	if (stristr($errortype[$errno],"error")) {
		echo $err;
		exit;
	} else {
		//echo "NIE-EG: " . $err;
	}

}

function handle_error($mysqlerror,$sql) {
	global $REMOTE_ADDR, $HTTP_SERVER_VARS, $HTTP_POST_VARS, $HTTP_USER_AGENT, $CRM_SHORTVERSION;
	$GLOBALS['CURFUNC'] = "HandleError::";
	qlog("Error occured. " . $mysqlerror);
	?>
	<SCRIPT LANGUAGE="JavaScript">
		<!--
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');

		//-->
		</SCRIPT>
	<?php
	//@SetCookie('repository','');
	//@SetCookie('session','expire');
	$mysqlerror = ereg_replace("You have an error in your SQL syntax near","SQL Syntax error near",$mysqlerror);
	print "<table><tr><td><fieldset><legend><img src='error.gif'>&nbsp;<b>An internal error occured&nbsp;</font></b></legend><br><b>This error is fatal.</b><br>";
	print "<br>";
	print "This procedure cannot tell you exactly what went wrong. Your database action is cancelled, but previous database actions in the CRM page you're running are executed.<br><br>";
	print "<table width=90% border=0><tr><td>The error message from the database is:</td></tr>";
	print "<tr><td><font face='courier new'>" . $mysqlerror . "</font></td></tr>";
	print "<tr><td>&nbsp;</td></tr>";
	print "<tr><td>The concerning query is:</td></tr>";
	print "<tr><td><font face='courier new'>$sql</font></td></tr>";
	$deb .= "Host: " . getenv("SERVER_NAME") . "<br>";
	$deb .= "Client: $REMOTE_ADDR<br>";
	$deb .= "Location: " . $_SERVER['PHP_SELF'] . "<br>";
	print "<tr><td>&nbsp;</td></tr>";

	$mysqlerror = base64_encode($mysqlerror);
	$sql = base64_encode($sql);
	$script = base64_encode($_SERVER['PHP_SELF']);
	$version = base64_encode($CRM_SHORTVERSION);

	$errorcode = "CEC|e|$mysqlerror|q|$sql|s|$script|v|$version";

	print "<tr><td>CRM Error code is : <pre>$errorcode</pre></td></tr>";

	print "<tr><td><font face='courier new'>Cookie reset - try to login again</font><br><br>If this happens often on the same query, please inform us by clicking <a class='bigsort' href='mailto:hidde_crm@users.sourceforge.net?Subject=CRM%20Error&body=PLEASE MAIL THIS MESSAGE - ADD COMMENTS IF YOU LIKE - error message is below $errorcode'>";

	print "here (e-mail)</a>, or click <a href='http://crmstage.it-combine.com/crm%20distributed/compose/autosubmit_error.php?errorcode=$errorcode'  class='bigsort' target='_top'>here</a> to submit the error to the CRM project page (automated)</td></tr>";
	print "<tr><td><br><br><a href='index.php?logout=1' class='bigsort'>To login page</a></td></tr></table></body></html>";
}


// The general query handler

function mcq($sql,$db) {
	global $mysql_query_counter, $logqueries, $name, $debug, $title;
//	$GLOBALS['CURFUNC'] = "ExecuteMySQLQuery::";
	if ($logqueries) {
		$mysql_query_counter++;
		@$fp = fopen("qlist.txt","a");
		@fputs($fp,"$mysql_query_counter:  ($name) ($title) (" . date('U') . "): " . $GLOBALS['CURFUNC'] . " " . $sql ."\n");
		@fclose($fp);
	}
	if ($debug && !stristr("select * from ".CRM_SETTINGS_TABLE,$sql)) {
		print "<!--$mysql_query_counter: ($name) : $sql-->\n";
	}

	$a = mysql_query($sql) or die (handle_error(mysql_error(),$sql));
	return($a);
}

// The supporting qlog function to log custom text to qlist.txt
function qlog($msg) {
	global $logtext, $name, $debug, $title, $cachecounter;
//	return(0);
	if ($logtext) {
		if (strstr($msg,"CACHE")) {
			$cachecounter++;
			$msg = "hit " . $cachecounter . " " . $msg;
		}
		@$fp = fopen("qlist.txt","a");
		@fputs($fp,"REM: ($name) ($title): " . $GLOBALS['CURFUNC'] . " " . $msg . "\n");
		@fclose($fp);
	}
	if ($debug) {
		print "<!--REM: ($name) ($title) : $msg-->\n";
	}
	return(0);
}

// caching functions:

function ClearCacheArrays() {
	$a = sizeof($GLOBALS['customers']);
	$a += sizeof($GLOBALS['usernames']);
	$a += sizeof($GLOBALS['useremails']);
	$a += sizeof($GLOBALS['CLLEVELS']);
	$a += sizeof($GLOBALS['statuscolor']);
	$a += sizeof($GLOBALS['prioritycolor']);

	unset($GLOBALS['customers']);
	unset($GLOBALS['usernames']);
	unset($GLOBALS['useremails']);
	unset($GLOBALS['CLLEVELS']);
	unset($GLOBALS['statuscolor']);
	unset($GLOBALS['prioritycolor']);

	$GLOBALS['CURFUNC'] = "ClearCacheArrays::";
	qlog("Cache arrays emptied - " . $a . " records");
	$GLOBALS['CURFUNC'] = "";

}

function GetCustomerName($customer_id) {
	$GLOBALS['CURFUNC'] = "GetCustomerName::";
	if ($customer_id) {
		if (!$GLOBALS['customers'][$customer_id]) {
			$sql = "SELECT custname FROM ".CRM_CUSTOMER_TABLE." WHERE id=" . $customer_id;
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);
			$GLOBALS['customers'][$customer_id] = $result1[0];
			$ret = $result1[0];
		} else {
			qlog("CACHE GetCustomerName $customer_id " . $GLOBALS['customers'][$customer_id]);
			$ret = $GLOBALS['customers'][$customer_id];
		}
	} else {
		$ret = "n/a";
		qlog("WARNING - GetCustomerName function called with empty customer_id param!");
	}
	$GLOBALS['CURFUNC'] = "";
	return($ret);
}

function GetUserName($userid) {
	$GLOBALS['CURFUNC'] = "GetUserName::";
	if (!$GLOBALS['usernames'][$userid]) {
		if ($userid) {
			$sql = "SELECT FULLNAME,name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id=" . $userid;
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);
			if ($result1[FULLNAME]=="") $result1[FULLNAME] = $result1[name];
			$GLOBALS['usernames'][$userid] = $result1[FULLNAME];
			$ret = $result1[FULLNAME];
			if ($ret=="") {
				$ret = "n/a";
			}
		} else {
			$ret = "n/a";
			qlog("WARNING - GetUserName function called with empty userid param!");
		}
	} else {
		$ret = $GLOBALS['usernames'][$userid];
		qlog("CACHE GetUserName getset $userid " . $GLOBALS['usernames'][$userid]);
	}
	$GLOBALS['CURFUNC'] = "";
	if ($ret=="") {
				$ret = "n/a";
	}
	return($ret);
}

function GetUserEmail($userid) {
	$GLOBALS['CURFUNC'] = "GetUserEmail::";
	if (!$GLOBALS['useremails'][$userid]) {
		if ($userid) {
			$sql = "SELECT email FROM ".CRM_LOGIN_USERS_TABLE." WHERE id=" . $userid;
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);
			$GLOBALS['useremails'][$userid] = $result1['email'];
			$ret = $result1['email'];
			if ($ret=="") {
				$ret = "n/a";
			}
		} else {
			$ret = "n/a";
			qlog("WARNING - GetUserName function called with empty userid param!");
		}
	} else {
		$ret = $GLOBALS['useremails'][$userid];
		qlog("CACHE GetUserEmail getset $userid " . $GLOBALS['useremails'][$userid]);
	}
	$GLOBALS['CURFUNC'] = "";
	if ($ret=="") {
				$ret = "n/a";
	}
	return($ret);
}

function GetUserNameByName($userid) {
	$GLOBALS['CURFUNC'] = "GetUserNameByName::";
	if ($userid) {
		if (!$GLOBALS['usernames'][$userid]) {
			$sql = "SELECT FULLNAME,name FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $userid ."'";
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);
			if ($result1[FULLNAME]=="") $result1[FULLNAME] = $result1[name];
			$GLOBALS['usernames'][$userid] = $result1[FULLNAME];
			$ret = $result1[FULLNAME];
		} else {
			$ret = $GLOBALS['usernames'][$userid];
			qlog("CACHE GetUserNameByName getset $userid " . $GLOBALS['usernames'][$userid]);
		}
	} else {
		$ret = "n/a";
		qlog("WARNING - GetUserNameByName function called with empty username param!");
	}
	$GLOBALS['CURFUNC'] = "";
	if ($ret=="") {
				$ret = "n/a";
	}
	return($ret);

}

function GetFileName($fileid) {
	$GLOBALS['CURFUNC'] = "GetFileName::";
	// not caching
	if ($fileid) {
		$sql = "SELECT filename FROM ".CRM_BINFILES_TABLE." WHERE fileid=" . $fileid;
		$result= mcq($sql,$db);
		$result1= mysql_fetch_array($result);
		$GLOBALS['CURFUNC'] = "";
		return($result1['filename']);
	} else {
		$GLOBALS['CURFUNC'] = "";
		return false;
	}
}

function GetClearanceLevel($userid) {
		$GLOBALS['CURFUNC'] = "GetClearanceLevel::";
		if ($userid) {
			if (!$GLOBALS['CLLEVELS'][$userid]) {

				$sql = "SELECT CLLEVEL FROM ".CRM_LOGIN_USERS_TABLE." WHERE id=" . $userid;
				$result= mcq($sql,$db);
				$result1= mysql_fetch_array($result);
				$a = $result1[CLLEVEL];
				if ($a=="rw") {
					$sql = "SELECT administrator FROM ".CRM_LOGIN_USERS_TABLE." WHERE id=" . $userid;
					$result= mcq($sql,$db);
					$result1= mysql_fetch_array($result);
					if ($result1[administrator]=="yes") {
						$a = "administrator";
					}
				}
				$GLOBALS['CLLEVELS'][$userid] = $a;
				$ret = $a;
			} else {
				$ret = $GLOBALS['CLLEVELS'][$userid];
				qlog("CACHE GetClearanceLevel $userid $a");
			}
		} else {
			$ret = "[unkown]";
			qlog("Function called with empty userid param!");
		}
		$GLOBALS['CURFUNC'] = "";
		return($ret);
}
function GetStatusColor($StatusName) {
	$GLOBALS['CURFUNC'] = "GetStatusColor::";
	if (!$GLOBALS['statuscolor'][$StatusName]) {
		$sql = "SELECT color,varname FROM ".CRM_STATUS_VARS_TABLE;
		$result= mcq($sql,$db);

		// For performance, read all colors into memory as soon as
		// 1 color is queried for.

		while ($row = mysql_fetch_array($result)) {
			$GLOBALS['statuscolor'][$row['varname']] = $row[0];
		}
		return($GLOBALS['statuscolor'][$StatusName]);
	} else {
		qlog("CACHE Statuscolor $StatusName");
	}

	// Anyway, now it is in memory
	$GLOBALS['CURFUNC'] = "";
	return($GLOBALS['statuscolor'][$StatusName]);
}

function GetPriorityColor($PriorityName) {
	$GLOBALS['CURFUNC'] = "GetPriorityColor::";
	if (!$GLOBALS['prioritycolor'][$PriorityName]) {
		$sql = "SELECT color,varname FROM ".CRM_PRIORITY_VARS_TABLE;
		$result= mcq($sql,$db);

		// For performance, read all colors into memory as soon as
		// 1 color is queried for.

		while ($row = mysql_fetch_array($result)) {
			$GLOBALS['prioritycolor'][$row['varname']] = $row[0];
		}
	} else {
		qlog("CACHE Prioritycolor $PriorityName");
	}

	// Anyway, now it is in memory
	$GLOBALS['CURFUNC'] = "";

	return($GLOBALS['prioritycolor'][$PriorityName]);

}
// --------- end caching functions

function Geti18nDate($FormatFrom,$FormatTo,$Date) {
	$GLOBALS['CURFUNC'] = "Geti18nDate::";
	switch ($FormatTo) {
		case "mm-dd-yyyy":
			if (strlen($Date)<>10) {
	//			echo "Input date not 10 characters - stopping function $Date<br>\n";
				$Return = $Date;
			} else {
				$d = substr($Date,0,2);
				$m = substr($Date,3,2);
				$y = substr($Date,6,4);
				$Return = $m . "-" . $d . "-" . $y;
			}
	   break;
	   default:
		$Return = $Date;
	}
	$GLOBALS['CURFUNC'] = "";
	return $Return;
}

function is_administrator() {
	global $name;
	$GLOBALS['CURFUNC'] = "IsAdminstrator::";
	$sql = "SELECT administrator FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" .$GLOBALS['USERID'] . "'";
	$result = mcq($sql,$db);
	$list = mysql_fetch_array($result);
	$list = $list[administrator];

	if ($list<>"Yes" && $list<>"yes") {
		return false;
	}
	$GLOBALS['CURFUNC'] = "";
	return true;
}

function is_administrator_by_id($uid) {
	$GLOBALS['CURFUNC'] = "IsAdminstrator::";
	$sql = "SELECT administrator FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $uid . "'";
	$result = mcq($sql,$db);
	$list = mysql_fetch_array($result);
	$list = $list[administrator];

	if ($list<>"Yes" && $list<>"yes") {
		return false;
	}
	$GLOBALS['CURFUNC'] = "";
	return true;
}

function ShowEntitiesOpen() {
	global $filter, $desc, $lang, $sort, $ShowFilterInMainList, $QUERY_STRING, $query, $ONLY_SHOW_CUSTOMER;
	global $ONLY_SHOW_OWNER, $query64, $DontShowPopupWindow,$ShowNumOfAttachments,$MainListColumnsToShow;
	global $pdfiltercustomer, $pdfilterstatus, $pdfilterpriority, $pdfilterowner, $pdfilterassignee;
	global $LetUserSelectOwnListLayout, $brief, $ShowSortLink, $teller, $EnableEditButton, $ForceGlobalLayout;
	global $MainListColumnsToShowGlobal,$ComingFromCustInsert,$tab,$ShowDeletedViewOption;

	$pdfilterextrafield = array();

	$GLOBALS['CURFUNC'] = "ShowEntitiesOpen::";

	if (stristr($_SERVER['REQUEST_URI'],"index.php")) {
		$return_to_list = 1;
	} elseif (stristr($_SERVER['REQUEST_URI'],"summary.php")) {
		$return_to_list = "____b64-" . base64_encode($_SERVER['REQUEST_URI']);
	}


	if ($filter=="viewdel" && (strtoupper($ShowDeletedViewOption)<>"YES") && !is_administrator()) {
		print "<table>";

		// security

		PrintAdminError();
		EndHTML;
		exit;
	}


	print "\n\n<!-- Entering function ShowEntitiesOpen [mark] -->\n\n";

	if (!$sort  && !$filter=="viewdel" && !$filter=="custinsert") {
		$sql = "SELECT LASTSORT FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $GLOBALS['USERID'] . "'";
		$result = mcq($sql,$db);
		$list = mysql_fetch_array($result);
		$sort = $list['LASTSORT'];

		if (stristr($sort,"-----DESC")) {
			$sort = ereg_replace("-----DESC","",$sort);
			$desc = 1;
		}
		print "\n\n<!-- LAST SORT APPLIED -->\n\n";

	} else {
		if (!$filter=="viewdel" && !$filer=="custinsert") {
			$tmpsort = $sort;

			if ($desc) {
				$tmpsort .= "-----DESC";
			}

			$sql = "UPDATE ".CRM_LOGIN_USERS_TABLE." SET LASTSORT='" . $tmpsort . "' WHERE id='" . $GLOBALS['USERID'] . "'";
			mcq($sql,$db);

			print "\n\n<!-- THIS SORT SAVED -->\n\n";
		}
	}


	$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra fields list'";
	$result = mcq($sql,$db);
	$list = mysql_fetch_array($result);
	$list = $list[value];
	$ExtraFieldsList = @explode(",",$list);

	foreach($ExtraFieldsList as $element) {
		$element = base64_encode($element);
		if ($_POST[$element]<>"all" && $_POST[$element]<>"") {
			$ExtraFieldSearched=true;
			$pdfilterextrafield[base64_decode($element)] = $_POST[$element];
			//print "ELEMENT RECOGNIZED - " . base64_decode($element) . "<pre>";
			//print_r($_POST);

		}
	}


	//if (($pdfiltercustomer=="" || $pdfiltercustomer=="all") && ($pdfilterstatus=="" || $pdfilterstatus=="all") && ($pdfilterpriority=="" || $pdfilterpriority=="all") && ($pdfilterowner=="" || $pdfilterowner=="all") && ($pdfilterassignee=="" || $pdfilterassignee=="all") && $filter<>"custinsert" && $filter=="" && !$ExtraFieldSearched) {

	if (!$_POST['newfilter']) {
		// No filter options given, retrieve old filter from database
		qlog("No new filter found");
		$sql = "SELECT LASTFILTER FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $GLOBALS['USERID'] . "'";
		$result = mcq($sql,$db);
		$list = mysql_fetch_array($result);
		$list = $list['LASTFILTER'];

		$list = unserialize($list);

		if ($filter=="viewdel") {
			$pdfiltercustomer = $list['vd_pdfiltercustomer'];
			$pdfilterstatus   = $list['vd_pdfilterstatus'];
			$pdfilterpriority = $list['vd_pdfilterpriority'];
			$pdfilterowner    = $list['vd_pdfilterowner'];
			$pdfilterassignee = $list['vd_pdfilterassignee'];
		} else {
			$pdfiltercustomer = $list['pdfiltercustomer'];
			$pdfilterstatus   = $list['pdfilterstatus'];
			$pdfilterpriority = $list['pdfilterpriority'];
			$pdfilterowner    = $list['pdfilterowner'];
			$pdfilterassignee = $list['pdfilterassignee'];
			$pdfilterextrafield = unserialize(base64_decode($list['pdfilterextrafield']));
			//print "<pre>";
			//print_r($pdfilterextrafield);
			foreach($ExtraFieldsList as $element) {
					if ($pdfilterextrafield[$element]<>"") {
						$ExtraFieldSearched=true;
						//print "JAAAAAAAAA $element";
					}
			}
		}
		print "\n\n<!-- LAST FILTER APPLIED -->\n\n";

//		print "Query restored<br><br>";


	} else {
		qlog("Saving this nice new filter");
		// Store current filter in database serialized array
		if ($filter<>"custinsert") {

			// first collect current stored array

			$sql = "SELECT LASTFILTER FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $GLOBALS['USERID'] . "'";
			$result = mcq($sql,$db);
			$list = mysql_fetch_array($result);
			$list = $list['LASTFILTER'];

			$last_filter = unserialize($list);

			if ($filter=="viewdel") {

				$last_filter['vd_pdfiltercustomer'] = $pdfiltercustomer;
				$last_filter['vd_pdfilterstatus']   = $pdfilterstatus;
				$last_filter['vd_pdfilterpriority'] = $pdfilterpriority;
				$last_filter['vd_pdfilterowner']    = $pdfilterowner;
				$last_filter['vd_pdfilterassignee'] = $pdfilterassignee;

			} else {

				$last_filter['pdfiltercustomer'] = $pdfiltercustomer;
				$last_filter['pdfilterstatus']   = $pdfilterstatus;
				$last_filter['pdfilterpriority'] = $pdfilterpriority;
				$last_filter['pdfilterowner']    = $pdfilterowner;
				$last_filter['pdfilterassignee'] = $pdfilterassignee;
				$last_filter['pdfilterextrafield'] = base64_encode(serialize($pdfilterextrafield));


			}


			$last_filter = serialize($last_filter);

			$sql = "UPDATE ".CRM_LOGIN_USERS_TABLE." SET LASTFILTER='" . $last_filter . "' WHERE id='" . $GLOBALS['USERID'] . "'";
			mcq($sql,$db);



			print "\n\n<!-- THIS FILTER SAVED -->\n\n";
		}
//		print "Query stored<br><br>";

	}


	if ($ForceGlobalLayout) {
		$MainListColumnsToShow = $MainListColumnsToShowGlobal;
	}

	if ($query64) {
		$query = base64_decode($query64);
//		print $query;
	}

	if ($ONLY_SHOW_CUSTOMER) {
				$pdfiltercustomer = $ONLY_SHOW_CUSTOMER;
				$dis = "DISABLED";
				$filter = "custinsert";
	}
	if ($ONLY_SHOW_OWNER) {
				$pdfilterassignee = $ONLY_SHOW_OWNER;
				$dis = "DISABLED";
	}
	//if ($filter=="custinsert") {
	//		$dis = "DISABLED";
	//}


	// Check which extra fields we need to show

	$topost = $_SERVER['PHP_SELF'];
		if (!stristr($QUERY_STRING,"logout")) {
			$ins = $QUERY_STRING;
		}
	$countertje=0;
	print "<form name='mpfilter' method='POST' ACTION='" .$topost . "?" . $ins . "'><input type='hidden' name='newfilter' value='1'";
	print "<table witdh='100%' border=0><tr><td>";
    $date = date('d-m-Y');
    $sqldate = date('Y-m-d');


	if (strtoupper($LetUserSelectOwnListLayout)=="YES") {
		$CurURL = base64_encode(($_SERVER['PHP_SELF'] . "?" .$QUERY_STRING));
		$customize = " <font size='-2'><img src='arrow.gif'>&nbsp;<a href='choose_cols.php?dothis=personal&cur=" . $CurURL . "' class='bigsort'>" . strtolower($lang['edit']) . "</a>&nbsp;</font>";
	}


	if ($filter=="viewdel") {
		print "<fieldset><legend><font size=+1>". $lang['delentities'] ."</font>&nbsp;</legend>";
	} elseif ($filter=="custinsert") {
		print "<fieldset><legend><font size=+1>". $lang['viewinsertedentities'] . "</font>&nbsp;</legend>";
	} else {
		print "<fieldset><legend><font size=+1>". $lang['briefover'] . $customize . "</font>&nbsp;</legend><font size=-2>";
	}

	if ($sort == "eid" && !$desc) {
		$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=eid&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
	} else {
		$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=eid&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
	}


	$outputbuffer .= "<table cellspacing='0' cellpadding='4' width=100% border=1 bordercolor='#F0F0F0'><tr><td><b>" . $link . "ID</a></b></td>";

	if ($MainListColumnsToShow['cb_cust']) {
		$outputbuffer .= "<td nowrap><b>";


		if ($sort == CRM_CUSTOMER_TABLE.".custname" && !$desc) {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=".CRM_CUSTOMER_TABLE.".custname&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
		} else {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=".CRM_CUSTOMER_TABLE.".custname&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
		}

		if ($ShowSortLink=="no") unset($link);

		$outputbuffer .= "$link$lang[customer]</a></b>";

		// FILTER PULLDOWN CUSTOMER
		if (strtoupper($ShowFilterInMainList)=="YES") {

			$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='pdfiltercustomer' $dis>";
			$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";

			$sql= "SELECT * FROM ".CRM_CUSTOMER_TABLE." ORDER BY custname";
			$result= mcq($sql,$db);

			while ($UsersArray= mysql_fetch_array($result)) {
				if ($UsersArray[id]==$pdfiltercustomer) {
						$a = "SELECTED";
				} else {
						$a = "";
				}
				 $outputbuffer .=  "<option value='$UsersArray[id]' $a size='1'>$UsersArray[custname]</option>";
			}

			$outputbuffer .= "</select>";
		}
	$outputbuffer .= "</td>";
} // end MainListColumnsToShow[cust]

//if ($filter<>"custinsert") {
		if ($MainListColumnsToShow['cb_owner']) {

			$outputbuffer .=  "<td nowrap><b>$lang[owner]</b>";
			unset($link);

		//	$outputbuffer .= "</td><td nowrap><b>$lang[owner]</b>";
			// FILTER PULLDOWN OWNER
			if (strtoupper($ShowFilterInMainList)=="YES") {
				$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='pdfilterowner' $dis>";
				$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE active='yes' ORDER BY FULLNAME";
				$result= mcq($sql,$db);
				$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";
				while ($UsersArray= mysql_fetch_array($result)) {
					if ($UsersArray[id]==$pdfilterowner) {
							$a = "SELECTED";
					} else {
							$a = "";
					}
					if (!stristr($UsersArray[FULLNAME],"@@@:")) {
					 $outputbuffer .=  "<option value='$UsersArray[id]' $a size='1'>$UsersArray[FULLNAME]</option>";
					}

				}

				$outputbuffer .=  "</select>";
			}
			$outputbuffer .=  "</td>";
			unset($link);
		} // end MainList etc owner

		if ($MainListColumnsToShow['cb_assignee']) {
			$outputbuffer .= "<td nowrap><b>$lang[assignee]</b>";
			//";
			if (strtoupper($ShowFilterInMainList)=="YES") {
				$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='pdfilterassignee' $dis>";
				$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE active='yes' ORDER BY FULLNAME";
				$result= mcq($sql,$db);
				$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";
				while ($UsersArray= mysql_fetch_array($result)) {
					if ($UsersArray[id]==$pdfilterassignee) {
							$a = "SELECTED";
					} else {
							$a = "";
					}

					if (!stristr($UsersArray[FULLNAME],"@@@:")) {
						 $outputbuffer .=  "<option value='$UsersArray[id]' $a size='1'>$UsersArray[FULLNAME]</option>";
					}

				}
				$outputbuffer .= "</select>";
			}
				$outputbuffer .=  "</td>";
		} // end mainlistcolumn assignee
//} else {
//	$outputbuffer .= "</td>";
//}

	if ($sort == "status" && !$desc) {
		$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=status&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
	} else {
		$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=status&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
	}
	if ($ShowSortLink=="no") unset($link);

	if ($MainListColumnsToShow['cb_status']) {
		$outputbuffer .= "<td nowrap><b>$link$lang[status]</a></b>";
		if (strtoupper($ShowFilterInMainList)=="YES") {
			$sql = "SELECT varname,id,color FROM ".CRM_STATUS_VARS_TABLE." ORDER BY varname";
			$result= mcq($sql,$db);
			$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='pdfilterstatus'>";
			$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";
			while ($result1= mysql_fetch_array($result)) {
						if ($result1['varname']==$pdfilterstatus) {
								$a = "SELECTED";
						} else {
								$a = "";
						}


						$outputbuffer .=  "<option style='background:" . $result1[color] . "' value='$result1[varname]' $a size='1'>$result1[varname]</option>";
				}
			$outputbuffer .= "</select>";
		}
		$outputbuffer .= "</td>";
	}
	if ($MainListColumnsToShow['cb_priority']) {
		if ($sort == "priority" && !$desc) {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=priority&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		} else {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=priority&desc=0&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		}
		if ($ShowSortLink=="no") unset($link);
		$outputbuffer .= "<td nowrap><b>$link$lang[priority]</a></b>";
		if (strtoupper($ShowFilterInMainList)=="YES") {
			$sql = "SELECT varname,id,color FROM ".CRM_PRIORITY_VARS_TABLE." ORDER BY varname";
			$result= mcq($sql,$db);
			$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='pdfilterpriority'>";
			$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";
			while ($result1= mysql_fetch_array($result)) {
						if ($result1['varname']==$pdfilterpriority) {
								$a = "SELECTED";
						} else {
								$a = "";
						}
						$outputbuffer .=  "<option style='background:" . $result1[color] . "' value='$result1[varname]' $a size='1'>$result1[varname]</option>";
				}
			$outputbuffer .= "</select>";
		}
		$outputbuffer .= "</td>";
	}
	if ($MainListColumnsToShow['cb_category']) {
		if ($sort == "category" && !$desc) {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=category&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		} else {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=category&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		}
		if ($ShowSortLink=="no") unset($link);
		$outputbuffer .= "<td><b>$link$lang[category]</a></b></td>";
	}

	if (sizeof($ExtraFieldsList)>0 && $ExtraFieldsList[0]<>"") {
		for ($x=0;$x<sizeof($ExtraFieldsList);$x++) {
			if ($MainListColumnsToShow[$ExtraFieldsList[$x]]) {
				$toshow = $ExtraFieldsList[$x];
				if (stristr($ExtraFieldsList[$x],"TB_")) {
					$toshow = ereg_replace("TB_","",$ExtraFieldsList[$x]);
				}
				if (stristr($ExtraFieldsList[$x],"DD_")) {
					$toshow = ereg_replace("DD_","",$ExtraFieldsList[$x]);
					$tmp = explode("|",$toshow);
					$toshow = $tmp[0];
				}

				$outputbuffer .= "<td><b>" . $toshow . "</b>";

				if (strtoupper($ShowFilterInMainList)=="YES") {
					$VarName = base64_encode($ExtraFieldsList[$x]);
					$outputbuffer .= "<br><select OnChange='javascript:document.mpfilter.submit()' name='" . $VarName ."'>";
					$outputbuffer .=  "<option value='all' $a size='1'>$lang[all]</option>";

					$sql = "SELECT DISTINCT(value) FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE type<>'cust' AND name='" . $ExtraFieldsList[$x] . "' ORDER BY value";
					$result = mcq($sql,$db);

					$CurField = $ExtraFieldsList[$x];

					while ($result1= mysql_fetch_array($result)) {
							if ($pdfilterextrafield[$CurField] == $result1['value']) {
									$a = "SELECTED";
							} else {
									$a = "";
							}
							$outputbuffer .=  "<option value='" . $result1['value'] . "' $a size='1'>" . $result1['value'] . "</option>";
						}
					$outputbuffer .= "</select>";
				}
				$outputbuffer .= "</td>";
			}
		}
	}

	if (strtolower($ShowNumOfAttachments)=="yes" && !$brief) {
		$outputbuffer .="<td><b>#Attm</b></td>";
	}

	if ($MainListColumnsToShow['cb_duedate']) {

		if ($sort == "sqldate" && !$desc) {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=sqldate&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
		} else {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&sort=sqldate&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee&$epoch' class='bigsort'>";
		}
		$outputbuffer .= "<td nowrap><b>$link$lang[duedate]</a></b></td>";
	}

	if ($MainListColumnsToShow['cb_lastupdate']) {
		$outputbuffer .= "<td nowrap><b>$lang[lastupdate]</b></td>";
	}


	if ($MainListColumnsToShow['cb_alarmdate']) {
		if ($sort == "alarmdate" && !$desc) {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=alarmdate&desc=1&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		} else {
			$link = "<a href='$topost?ShowEntitiesOpen=1&tab=$tab&filter=$filter&$epoch&sort=alarmdate&pdfiltercustomer=$pdfiltercustomer&pdfilterstatus=$pdfilterstatus&pdfilterpriority=$pdfilterpriority&pdfilterowner=$pdfilterowner&pdfilterassignee=$pdfilterassignee' class='bigsort'>";
		}
		if ($ShowSortLink=="no") unset($link);
		$outputbuffer .= "<td nowrap><b>$lang[alarmdate]<b></td>";
	}

	$outputbuffer .= "</tr>";

	if (!$sort) {
			$sort = "sqldate,status,priority";
	} else {
			// $outputbuffer .= "Sort adjusted";
	}
	if ($desc) {
			$sort .= " DESC";
	}
    if ($query) {
		$sql = $query;
	} else {
		$mpfilter = "";
		if ($pdfiltercustomer && $pdfiltercustomer<>"all") {
			$mpfilter .= " AND CRMcustomer = '" . $pdfiltercustomer . "'";
		}
		if ($pdfilterstatus && $pdfilterstatus<>"all") {
			$mpfilter .= " AND status = '" . $pdfilterstatus . "'";
		}
		if ($pdfilterpriority && $pdfilterpriority<>"all") {
			$mpfilter .= " AND priority = '" . $pdfilterpriority . "'";
		}
		if ($pdfilterowner && $pdfilterowner<>"all") {
			$mpfilter .= " AND owner = '" . $pdfilterowner . "'";
		}
		if ($pdfilterassignee && $pdfilterassignee<>"all") {
			$mpfilter .= " AND assignee = '" . $pdfilterassignee . "'";
		}

		if ($ComingFromCustInsert<>"1") {
			$insSql = "AND ".CRM_ENTITY_TABLE.".owner='2147483647' AND ".CRM_ENTITY_TABLE.".assignee='2147483647'";
		}

		if ($filter=="custinsert") {
			$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer " . $insSql ." AND deleted<>'y' " . $mpfilter . " ORDER BY " . $sort;
			//
		} elseif ($filter=="viewdel") {
			$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND owner<>'2147483647' AND assignee<>'2147483647' AND deleted='y' " . $mpfilter . " ORDER BY " . $sort;
		} elseif ($ONLY_SHOW_OWNER) {
			if ($ONLY_SHOW_OWNER=="read-only-all") {
					$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND deleted='n' ORDER BY " . $sort;
				} else {
					$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND deleted='n' AND ".CRM_ENTITY_TABLE.".assignee='$ONLY_SHOW_OWNER' " . $mpfilter . " ORDER BY " . $sort;
//					print $sql;
				}

		} else {
			if ($ExtraFieldSearched) {
				// AND
				$tataa = "(";

				foreach ($ExtraFieldsList as $element) {
					if ($pdfilterextrafield[$element]) { // array element contains a value
						if ($pdfilterextrafield[$element]=="") {
							$pdfilterextrafield[$element]="%";
						}
						$tataa .= "(".CRM_CUSTOM_ADDONS_TABLE.".name='" . $element . "' AND ".CRM_CUSTOM_ADDONS_TABLE.".value='" . $pdfilterextrafield[$element] . "' AND ".CRM_CUSTOM_ADDONS_TABLE.".type<>'cust') OR ";
					}
				}
				$tataa .= "1=0) AND ";

				$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." LEFT JOIN ".CRM_CUSTOM_ADDONS_TABLE." ON (".CRM_ENTITY_TABLE.".eid=".CRM_CUSTOM_ADDONS_TABLE.".eid) WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND  ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND ".CRM_CUSTOM_ADDONS_TABLE.".type<>'cust' AND " . $tataa . " ".CRM_ENTITY_TABLE.".deleted<>'y' AND owner<>'2147483647' AND assignee<>'2147483647' " . $mpfilter . " ORDER BY " . $sort;
				$filter = "normal";
			} else {
				$sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND deleted<>'y' AND owner<>'2147483647' AND assignee<>'2147483647' " . $mpfilter . " ORDER BY " . $sort;
				$filter = "normal";
			}
		}
	}

	print $outputbuffer;
	unset($outputbuffer);

	$usernames = array(); // cache array
	$result= mcq($sql,$db);

	$displayed = array(); // de-double array

	while ($e= mysql_fetch_array($result)) {
		if (!in_array($e['eid'],$displayed)) {
				$teller++;
					array_push($displayed,$e[eid]);
					$usernames[$e[assignee]] = GetUserName($e[assignee]);
					$e1[FULLNAME] = $usernames[$e[assignee]];

					$e[category] = ereg_replace("\"","&quot;", $e[category]);
					$e[category] = ereg_replace("\'","\\'", $e[category]);

					if (strtolower($DontShowPopupWindow)<>"yes" && !$ONLY_SHOW_CUSTOMER && !$ONLY_SHOW_OWNER) {

						$html = "<table width=\'100%\' cellspacing=\'0\' cellpadding=\'3\' border=\'0\'><tr><td bgcolor=\'#CCCCCC\'><b>$e[category]</b></td></tr>";

						$html .= "<tr><td><img src=\'arrow.gif\'>&nbsp;<a class=\'bigsort\' href=\'javascript:popupdater($e[eid]);\' title=\'$lang[uinw]\'>$lang[uinw]</a></td></tr>";
						$html .= "<tr><td><img src=\'arrow.gif\'>&nbsp;<a class=\'bigsort\' href=\'edit.php?e=$e[eid]&fromlist=$return_to_list\' title=\'$lang[editthis]\'>$lang[editthis]</a></td></tr>";

						$html .= "<tr><td><img src=\'arrow.gif\'>&nbsp;<a class=\'bigsort\' href=\'date.php?eID=$e[eid]\' title=\'$lang[alarmsettings]\'>$lang[alarmsettings]</a></td></tr>";

						$html .= "<tr><td><img src=\'arrow.gif\'>&nbsp;<a class=\'bigsort\' href=\'edit.php?d=$e[eid]\' title=\'$lang[deletethisentity]\'>$lang[delete]</a></td></tr>";
						$html .= "<tr><td><img src=\'arrow.gif\'>&nbsp;<a class=\'bigsort\' title=\'$lang[downloadpdf]\' href=\'sumpdf.php?pdf=$e[eid]\' target=\'pdf\'>$lang[pdfreport]</a>&nbsp;&nbsp;<a OnClick=\'javascript:pophelp(19);\' class=\'topnav\' cursor=\'click\' style=\'cursor: help\'><img src=\'info.gif\'></a></td></tr>";
						$html .= "</table>";

						if ($e[FULLNAME]=="") { $e[FULLNAME] = "-"; }
						$outputbuffer .= "<tr onmouseover=\"javascript:style.background='#E9E9E9';return overlib('" . $html . "', STICKY)\"  onmouseout=\"javascript:style.background='#FFFFFF';nd();\"><td><b>" . $e[0] . "</b></td>";

						if ($MainListColumnsToShow['cb_cust']) {
							$outputbuffer .= "<td NOWRAP>$e[custname]</td>";
						}

						if ($MainListColumnsToShow['cb_owner']) {
//								if ($filter<>"custinsert") {

									if ($ComingFromCustInsert<>"1" && $filter=="custinsert") {
										$e[FULLNAME]="-";
									}

									$outputbuffer .= "<td NOWRAP>$e[FULLNAME]</td>";
//								}
						}


					} else {
						if ($ONLY_SHOW_CUSTOMER || $ONLY_SHOW_OWNER) {

							//if ($ComingFromCustInsert=="1") {
								$fullname = GetUserName($e['owner']);
							//} else {
							//	$fullname = "hops";
							//}



							if ($fullname=="") { $fullname = "-"; }

							$outputbuffer .= "<tr onmouseover=\"javascript:style.background='#E9E9E9';\" onmouseout=\"javascript:style.background='#FFFFFF';nd();\"><td><b>$e[eid]</b></td>";
							if ($MainListColumnsToShow['cb_cust']) {
								$outputbuffer .= "<td NOWRAP>$e[custname]</td>";
							}
							if ($MainListColumnsToShow['cb_owner']) {
//								if ($filter<>"custinsert") {
									$outputbuffer .= "<td NOWRAP>$fullname</td>";
//								}
							}
						} else {
							if ($e[FULLNAME]=="") { $e[FULLNAME] = "-"; }
							$outputbuffer .= "<tr onmouseover=\"javascript:style.background='#E9E9E9';\" onmouseout=\"javascript:style.background='#FFFFFF';nd();\" OnClick='javascript:document.location=\"edit.php?e=$e[eid]&fromlist=$return_to_list\";' style='cursor: hand'><td><b>$e[eid]</b></td>";
							if ($MainListColumnsToShow['cb_cust']) {
								$outputbuffer .= "<td NOWRAP>$e[custname]</td>";
							}
							if ($MainListColumnsToShow['cb_owner']) {
								if ($filter<>"custinsert") {
									$outputbuffer .= "<td NOWRAP>$e[FULLNAME]</td>";
								} else {
                                    $outputbuffer .= "<td NOWRAP>-</td>";
                                }

							}
						}

					}


					if ($MainListColumnsToShow['cb_assignee']) {
							if ($e1[FULLNAME]=="") { $e1[FULLNAME] = "-"; }
							$outputbuffer .= "<td NOWRAP>$e1[FULLNAME]</td>";
					}
					if ($MainListColumnsToShow['cb_status']) {
						if (!$colortustat[$e['status']]) {
							$colortustat[$e['status']] = GetStatusColor($e[status]);
						}
					}
					if ($MainListColumnsToShow['cb_status']) {
						$outputbuffer .= "<td width='1%' bgcolor='" . $colortustat[$e['status']] . "' NOWRAP>";
						$outputbuffer .= "$e[status]</td>";
					}
					if ($MainListColumnsToShow['cb_priority']) {
						if (!$colortuprio[$e['priority']]) {
							$colortuprio[$e['priority']] = GetPriorityColor($e[priority]);
						}
						$outputbuffer .= "<td width='1%' bgcolor='" . $colortuprio[$e['priority']] . "' NOWRAP>";
						$outputbuffer .= "$e[priority]</td>";
					}
					if ($MainListColumnsToShow['cb_category']) {
						$outputbuffer .= "<td>$e[category]&nbsp;</td>";
					}

					if (sizeof($ExtraFieldsList)>0 && $ExtraFieldsList[0]<>"") {
						for ($x=0;$x<sizeof($ExtraFieldsList);$x++) {
							if ($MainListColumnsToShow[$ExtraFieldsList[$x]]) {
				//				$outputbuffer .= "<td>" . $ExtraFieldsList[$x] . "</td>";
								$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE type<>'cust' AND eid='" . $e[eid] . "' AND name='" . $ExtraFieldsList[$x] ."' LIMIT 1";
								$result33 = mcq($sql,$db);
								$gh = mysql_fetch_array($result33);
								if (stristr($list[$x],"TB_")) {
									$gh[0] = eregi_replace("\n","<BR>",$gh[0]);
								}
								$outputbuffer .= "<td>" . $gh[0] . "&nbsp;</td>";

							}
						}
					}


					if (strtolower($ShowNumOfAttachments)=="yes" && !$brief) {
						$sql = "SELECT COUNT(filename) FROM ".CRM_BINFILES_TABLE." WHERE koppelid=$e[eid]";
						$count = mcq($sql,$db);
						$resarr1 = mysql_fetch_array($count);
						$outputbuffer .= "<td NOWRAP>" . $resarr1[0] . "</td>";
					}


					if ($MainListColumnsToShow['cb_duedate']) {
						 if ($e[duedate]==$date) {
										$tmp="</font>";
										$outputbuffer .= "<td NOWRAP><font color='FF3300' width='70'>";
									}
									elseif ($e[sqldate]<$sqldate) {
										$tmp1="</u></font>";
										$outputbuffer .= "<td NOWRAP><font color='FF3300' width='70'><u>";
									}
									else
									{
										$outputbuffer .= "<td width='70' NOWRAP>";
									}
						if ($e[duedate]=="") {
								$e[duedate] = "<font color='FF3300'>none</font>";
						}
						$outputbuffer .= TransformDate($e[duedate]) . $tmp1 . "&nbsp;</td>";
					}
					if ($MainListColumnsToShow['cb_lastupdate']) {
						$t = $e[tp]; // timestamp last edit
						$tp[jaar] = substr($t,0,4);
						$tp[maand] = substr($t,4,2);
						$tp[dag] = substr($t,6,2);
						$tp[uur] = substr($t,8,2);
						$tp[min] = substr($t,10,2);
						$cdate = explode("-",$ea[cdate]);

						// Add zero's ie. 2-7-2003 must become 02-07-2003

						if (strlen($cdate[0])==1) {
								$cdate[0] = "0" . $cdate[0];
						}
						if (strlen($cdate[1])==1) {
								$cdate[1] = "0" . $cdate[1];
						}

						$lastupdate = "$tp[dag]-$tp[maand]-$tp[jaar] $tp[uur]:$tp[min]h.";
						$outputbuffer .= "<td NOWRAP>" . $lastupdate . "</td>";
					}
					if ($MainListColumnsToShow['cb_alarmdate']) {
						$sql3 = "SELECT basicdate FROM ".CRM_CALENDAR_TABLE." WHERE eID='$e[eid]'";
						$rult2= mcq($sql3,$db);
						if ($e5= mysql_fetch_array($rult2)) {
								$e5[basicdate] = substr($e5[basicdate],0,2) . "-" . substr($e5[basicdate],2,2) . "-" . substr($e5[basicdate],4,4);
								$outputbuffer .= "<td width='70' NOWRAP>" . TransformDate($e5[basicdate]) . "</td>";
						} else {
								$outputbuffer .= "<td NOWRAP><font color='FF3300'>none</font></td>";
						}
					}
					if ($ONLY_SHOW_OWNER) {
							$outputbuffer .= "<td width='70'><img src='arrow.gif'>&nbsp;<a class='bigsort' href='management.php?e=$e[eid]' title='Edit this entity'>$lang[edit]</a>&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' href='sumpdf.php?pdf=$e[eid]'>PDF</a></td>";
					}
					if ($EnableEditButton) {
							$outputbuffer .= "<td width='70'><img src='arrow.gif'>&nbsp;<a class='bigsort' href='cust-insert.php?e=$e[eid]&tab=200' title='Edit this entity'>$lang[edit]</a>&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' href='sumpdf.php?pdf=$e[eid]'>PDF</a></td>";
					}


					$outputbuffer .= "</tr>";
					print $outputbuffer;
					if ($countertje==0) { $header = $outputbuffer; }
					unset($outputbuffer);
					$countertje++;
	} // end if not in array $displayed
} // end while SQL returns

//print_r($displayed);
	if ($countertje<1) {
		if (strtoupper($ShowFilterInMainList)=="YES") {
			print $header;
		}
		print "<tr><td colspan=9>$lang[noresults]</td></tr>";
	}
	print "</table></form>";
	uselogger("Open entity list viewed","");
	$GLOBALS['CURFUNC'] = "";

}


// the form function for management interface and for cust-insert ro+ user
function editform($e,$loguser) {
	global $title,$department,$lang,$AutoCompleteCustomerNames,$AutoCompleteCategory,$eid;
	$GLOBALS['CURFUNC'] = "EditForm::";
	if ($e=="_new_") { // catch hackers
		$e = "";
	}
	$nanavbar = 0;

	print "<form name='EditEntity' method='POST' ENCTYPE='multipart/form-data' id='dashed'>";
			$curid = $e; // tmp save
					print "<input DISABLED class='txt' type=hidden name='changed' value='0'>";
					if ($e=="_new_") {
					print "<input DISABLED type='hidden' name='tab' value='800'>";
						$enetjes = $lang[newentity];
					} else {
						$enetjes = $e;
					}
			if ($e=="_new_") {

			} else {

					$sql = "SELECT id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$name'";
					$result = mcq($sql,$db);
					$res = mysql_fetch_array($result);
					$CurUserID = $res[id];

					$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE eid='$e'";
					$result= mcq($sql,$db);
					$ea = mysql_fetch_array($result);

					if ($ea[readonly]=='y' && $CurUserID<>$ea[owner] && $CurUserID<>$ea[assignee]) {
							// print "<font size=+3>This entity is read-only $name $ea[owner]</font>";
							$readonly=1;
							$roins= "DISABLED";
						}
					if (!$ea[owner] && !$ea[assignee] && !$ea[eid]) {
						print "<img src='error.gif'>&nbsp;&nbsp;<B>$lang[nonexistent]</b> :: $e";
						print "</body></html>";
						exit;
					}

					print "<input class='txt' type=hidden name='e' value='$e'>";

					$owner = GetUserName($ea['owner']);
					$assignee = GetUserName($ea['assignee']);

					$t = $ea[tp]; // timestamp last edit
					$tp[jaar] = substr($t,0,4);
					$tp[maand] = substr($t,4,2);
					$tp[dag] = substr($t,6,2);
					$tp[uur] = substr($t,8,2);
					$tp[min] = substr($t,10,2);
					$cdate = explode("-",$ea[cdate]);

					// Add zero's ie. 2-7-2003 must become 02-07-2003

					if (strlen($cdate[0])==1) {
							$cdate[0] = "0" . $cdate[0];
					}
					if (strlen($duedate[1])==1) {
							$cdate[1] = "0" . $cdate[1];
					}

					$cdate = $cdate[2] . "-" . $cdate[1] . "-" . $cdate[0];

					print "<input class='txt' type=hidden name='action' value='edit'>";
					print "</table>";

// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=== Here comes the header  ============================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================


					print "<table width='80%'><tr><td>&nbsp;</td><td><fieldset><legend align='left'><font size=+1>$enetjes&nbsp;</font></legend>";
					print "<table width='100%'>";
					print "<tr><td>";
					print "<div id='IsChanged' style='display: none'>";

					print "<table><tr><td><fieldset><font color='#FF0000'>Changed</font></fieldset></td></tr></table>";

					print "</div>";

					if ($ea['closeepoch']=="") {
						$nowepoch = date('U');
						$txt = "Age";
					} else {
						$nowepoch = $ea['closeepoch'];
						$txt = "Duration";
					}

					if ($ea['openepoch']=="") {
						$age = "";
					} else {
						$age_in_seconds = $nowepoch - $ea['openepoch'];

						if ($age_in_seconds>86400) {
							$age = "($txt: " . ceil($age_in_seconds/86400) . " days)";
						} elseif ($age_in_seconds>3600) {
							$age = "($txt: " . ceil($age_in_seconds/3600) . " hours)";
						} elseif ($age_in_seconds>60) {
							$age = "($txt: " . ceil($age_in_seconds/60) . " minutes)";
						} elseif ($age_in_seconds<>$nowepoch) {
							$age = "($txt: " . ceil($age_in_seconds) . " seconds)";
						}
					}

					print "$lang[editing] $lang[entity] <b>$e</b> $lang[ownedby] $owner, $lang[assignedto] $assignee.<br>";
					print "$lang[curstat]: $ea[status], $lang[created] " . TransformDate($cdate) . ", $lang[lastupdate] " . TransformDate("$tp[dag]-$tp[maand]-$tp[jaar]") . " $tp[uur]:$tp[min]h. " . $age . "<br>";

					print "$lang[priority]: $ea[priority], $lang[category]: $ea[category]";

					print "</td><td align='right' valign='top'>";

					if ($e!="_new_") {
						print "<font face='MS Shell DLG' size='-1'><a class='bigsort' title='$lang[downloadpdf]' href='sumpdf.php?pdf=$e'><img style='border:0' src='pdf.gif'></a>";
						print "&nbsp;<a class='bigsort' style='cursor:hand' title='Print on default printer' href=\"javascript:popPDFprintwindow('sumpdf.php?pdf=$e&print=1')\"><img src='print.gif' style='border:0'></a>";
					}
					print "</td></tr>";
					print "</table>";
					print "</fieldset>";
					print "<br>";


// +=======================================================================================
//		end header
// +=======================================================================================

					print "<table border='0' cellpadding='3' cellspacing='0' bgcolor='' width='100%'><tr><td align='left'><fieldset><legend align='left'>$e&nbsp;</legend><table><tr><td>";


					if ($nonavbar) {
						print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[saveclose]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
						//print "<input DISABLED class='txt' type=submit name=sb value='$lang[saveclose]' align='right' $roins>";
						print "<input DISABLED type='hidden' name='NoMenu' value='1'>";
						if (strtoupper($ShowEmailButton) == "YES") {
							print "&nbsp;&nbsp;&nbsp;<input class='txt' OnClick=\"javascript:document.EditEntity.changed.value='0'\" type=submit name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
						}
						print "<input class='txt' type=submit name=sb value='$lang[cancel]' OnClick=\"javascript:document.EditEntity.changed.value='0'\" align='right' OnClick='javascript:window.close();'></td></tr>";
					} else {
						print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[save]'  $roins>";
						if (strtoupper($ShowEmailButton) == "YES") {
							print "&nbsp;&nbsp;&nbsp;<input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>";
						}
						print "</td></tr>";
					}

						print "</table>";


			}

// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=== Here comes the main form  =========================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================

			print "<input DISABLED class='txt' type=hidden name='eid' value='$e' $roins>";
			print "<tr><td><table><tr><td>";


			if (strtoupper($AutoCompleteCustomerNames)<>"YES") {
				print "<fieldset><legend align='left'>$lang[customer]&nbsp;</legend><select DISABLED name=CRMcustomer size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
				$sql= "SELECT * FROM ".CRM_CUSTOMER_TABLE." WHERE active='yes' ORDER BY custname";
				$result= mcq($sql,$db);

				if ($SetCustTo) $ea[CRMcustomer] = $SetCustTo; // pre-set customer from customers page

				while ($UsersArray= mysql_fetch_array($result)) {
					if ($UsersArray[id]==$ea[CRMcustomer]) {
							$a = "SELECTED";
							$Customer = $ea[CRMcustomer];
					} else {
							$a = "";
					}
					 print "<option value='$UsersArray[id]' $a size='1'>$UsersArray[custname]</option>";
				}

				print "</select></fieldset>";

			} else {  // Customer AutoComplete option
				if ($SetCustTo) $ea[CRMcustomer] = $SetCustTo; // pre-set customer from customers page

				?>
				<fieldset><legend align='left'><?php echo $lang[customer];?></legend><input DISABLED TYPE="text" NAME="CRMcustomername" SIZE='50' OnChange="javascript:AlertUser('IsChanged');" ONKEYUP='autoComplete(this,this.form.CRMcustomer,"Fullname",true)' value='<?php echo GetCustomerName($ea[CRMcustomer]);?>'>

				<?php
				print "<DIV style='display: none; cursor: hand' id='plaatsen'>";
				?>
				<select DISABLED NAME="CRMcustomer" type="hidden"
				onChange="this.form.CRMcustomer.value=this.CRMcustomer[this.selectedIndex].nummer">
				<?php
					$sql = "SELECT * FROM ".CRM_CUSTOMER_TABLE." WHERE active='yes'";
					$custs= mcq($sql,$db);
					while ($record= @mysql_fetch_array($custs)) {
						if ($record[id]==$ea[CRMcustomer]) {
							$a = "SELECTED";
							$Customer = $ea[CRMcustomer];
						} else {
								$a = "";
						}
						print "<option Fullname=\"" . GetCustomerName($record[id]) . "\" value=\"" . $record[id] ."\" nummer=\"" . $record[id] ."\" $a>" . $record[id] . "</option>\n";
					}


				print "</SELECT>";
				print "</DIV>";
				print "</fieldset>";

			}

			print "</td><td>";
			print "<fieldset><legend align='left'>$lang[priority]&nbsp;</legend><select DISABLED name='prioty' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
			$sql = "SELECT varname,id,color FROM ".CRM_PRIORITY_VARS_TABLE;
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[priority]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}

			print "</select></fieldset>";

			print "</td><td><fieldset><legend align='left'>$lang[status]&nbsp;</legend><select DISABLED name=status size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
			$sql = "SELECT varname,id,color FROM ".CRM_STATUS_VARS_TABLE;
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[status]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}

			print "</select></fieldset></td><td>";

			print "<fieldset><legend align='left'>$lang[owner]&nbsp;</legend><select DISABLED name='ownerNEW' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";

			if ($e=="_new_") {
				$sql = "SELECT id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$name'";
				$result= mcq($sql,$db);
				$result = mysql_fetch_array($result);

				$ea[owner] = $result[0];
			}
			$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE LEFT(FULLNAME,3) <> '@@@' ORDER BY FULLNAME";
			$result= mcq($sql,$db);

			while ($UsersArray= mysql_fetch_array($result)) {
					if ($UsersArray[id]==$ea[owner]) {
									$a = "SELECTED";
									$ok = 1;
					} else {
									$a = "";
					}
				if (!trim($UsersArray[FULLNAME])== "") {
					print "<option value='$UsersArray[id]' size='1' $a>$UsersArray[FULLNAME]</option>";
				}
			}
			if (!$ok && !$e="_new_") {
					print "<option value='2147483647' SELECTED> - </option>";
			}
			unset($ok);
			print "</select></fieldset></td><td><fieldset><legend align='left'>$lang[assignee]&nbsp;</legend>";
			print "<select DISABLED name='assigneeNEW' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";

			$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE LEFT(FULLNAME,3) <> '@@@' ORDER BY FULLNAME";
			$result= mcq($sql,$db);



			while ($UsersArray= mysql_fetch_array($result)) {
					if ($UsersArray[id]==$ea[assignee]) {
									$a = "SELECTED";
									$ok = 1;
					} else {
									$a = "";
					}
				if (!trim($UsersArray[FULLNAME])== "") {
					print "<option value='$UsersArray[id]' size='1' $a>$UsersArray[FULLNAME]</option>";
				}
			}
			if (!$ok && !$e="_new_") {
					print "<option value='2147483647' SELECTED> - </option>";
			}
			print "</select></fieldset></td></tr></table>";
			print "</table><table><tr><td><fieldset><legend align='left'>$lang[category]&nbsp;</legend>";

			if (strtoupper($ForceCategoryPulldown)=="YES") {
				print "<select DISABLED name='cat' class='text' width=50 OnChange=\"javascript:AlertUser('IsChanged');\">";
				$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Category pulldown list'";
				$result = mcq($sql,$db);
				$list = mysql_fetch_array($result);
				$list = $list[value];
				$list = @explode(",",$list);

				if (sizeof($list)>0 && $list[0]<>"") {

					for ($t=0;$t<sizeof($list);$t++) {
						if ($ea[category]==$list[$t]) {
							$roins = "SELECTED";
						} else {
							unset($roins);
						}
						print "<option $roins value='$list[$t]'>$list[$t]</option>";
					}

				}
				print "</select>";

			} else {
				print "<input DISABLED class='txt' type=text name=cat size=50 value='$ea[category]' $roins OnKeyUp=\"javascript:AlertUser('IsChanged');\">";
			}
			print "</fieldset></td><td><fieldset><legend align='left'>$lang[duedate]&nbsp;</legend><input DISABLED type='text' size='13' name='duedate' value='" . TransformDate($ea[duedate]) . "' OnFocus=\"javascript:popcalendar();AlertUser('IsChanged');\" $roins>";

			print "</fieldset></td></tr></table>";

					print "<font color='ff0000'>Do not edit the underlying field. It will be ignored.</font><br>";
					print "<TEXTAREA READONLY rows=5 cols=100 name='bla' wrap='virtual' OnClick=\"javascript:alert('Do not edit this field! You can add your comments in the second text field.');\">$ea[content]</TEXTAREA><br>";
					print "<font color='ff0000'>Add your comments here:</font><br>";
					print "<TEXTAREA rows=5 cols=100 name='addcontent' wrap='virtual' class='txt'></TEXTAREA><br>";
					//print "<br><table><tr><td>$lang[owner]:</td><td>$lang[assignee]:</td></tr>";
					print "<table><tr><td><br><fieldset><table>";
				if ($e<>"_new_") {
					if ($ea[deleted]=='y') {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=deleted value='y' CHECKED $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[isdeleted]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(12)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a>";
					} else {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=deleted value='y' $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[isdeleted]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(12)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a>";
					}
				}
				if ($ea[waiting]=='y') {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=waiting value='y' CHECKED $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[iswaiting]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				} else {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=waiting value='y' $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[iswaiting]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				}
				if ($ea[obsolete]=='y') {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=obsolete value='y' CHECKED $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[doesntbelonghere]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(11)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				} else {
						print "<tr><td><input DISABLED type='checkbox' class='radio' name=obsolete value='y' $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[doesntbelonghere]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(11)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				}
// =========================================>>
				if ($ea[readonly]=='y') {

							print "<tr><td><input DISABLED type='checkbox' class='radio' name=readonly value='y' CHECKED $roins OnClick='javascript:document.EditEntity.readonly.style.background=\"#FFFFFF\"' OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[readonly]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'></a></td></tr>";
							?>
							<SCRIPT LANGUAGE="JavaScript">
                              <!--
                                      document.EditEntity.readonly.style.background='#FF0000';
                              //-->
                              </SCRIPT>
							<?php

				} else {

						print "<tr><td><input DISABLED type='checkbox' class='radio' name='readonly' value='y' $roins OnClick='javascript:document.EditEntity.readonly.style.background=\"#FF0000\"' OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[readonly]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'></a></td></tr>";
				}

			print "</table></fieldset></td></tr></table><br>";
			print "<table>";
			$toprint = "<tr><td><fieldset><legend align='left'>$lang[listofatt]&nbsp;</legend><table border=0>";


			$sql= "SELECT filename,creation_date,date_format(creation_date, '%a %M %e, %Y %H:%i') AS dt,filesize,fileid,username FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$curid' ORDER BY filename,creation_date";
			$result= mcq($sql,$db);



			$toprint .= "<tr><td>$lang[filename]</td><td>$lang[filesize]</td><td>$lang[creationdate]</td><td>$lang[owner]</td><td>$lang[deletefile]</td></tr>";




			while ($files= mysql_fetch_array($result)) {
				$sql = "SELECT FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$files[username]'";
				$res1 = mcq($sql,$db);
				$owner = mysql_fetch_array($res1);
				$ownert = $owner[FULLNAME];

				if (stristr("@@@:",$ownert[FULLNAME])) {
					$ownert = "&nbsp;&nbsp;&nbsp;n/a";
				}

				$toprint .= "<tr><td><img src='arrow.gif'>&nbsp;<a href=csv.php?fileid=$files[fileid] class='bigsort'>$files[filename]</a></td><td>";
				$toprint .= round(($files[filesize]/1024)). "K";
				$toprint .= "</td><td>$files[dt]</td><td>$ownert</td><td><input DISABLED type='checkbox' class='radio' name=deletefile[] value='$files[fileid]' $roins></td></tr>";
				$ftel++;
			}
			if ($ftel) {
				print $toprint . "</fieldset></td></tr></table>";
				}

			print "<tr><td colspan=6><fieldset><legend align='left'>$lang[attachfile]&nbsp;</legend><input DISABLED TYPE='hidden' name='MAX_FILE_SIZE' value='52428800'><input NAME='userfile' TYPE='file' $roins>&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(9)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></fieldset></tr></td>";

			print "</table><br>";

			// Custom fields list

			$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra fields list'";
			$result = mcq($sql,$db);
			$list = mysql_fetch_array($result);
			$list = $list[value];
			$list = @explode(",",$list);

			if (sizeof($list)>0 && $list[0]<>"") {
				print "<table><tr><td>";
				print "<fieldset><legend align='left'>Custom fields&nbsp;</legend>";
				print "<table>";


				for ($x=0;$x<sizeof($list);$x++) {

						$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$enetjes' AND deleted<>'y' AND name='$list[$x]' ORDER BY name";
//						print $sql;
						$result = mcq($sql,$db);
						$cust= mysql_fetch_array($result);
						$val = $cust[value];

						if (stristr($list[$x],"DD_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							$list[$x] = ereg_replace("DD_","",$list[$x]);
							$tmp = explode("|",$list[$x]);
							$list[$x] = $tmp[0];
							print "<tr><td>" . $tmp[0] . "</td><td>";
							print "<select DISABLED name='" . $orig . "' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
							print "<option value=''>-</option>";
							for ($t=1;$t<(sizeof($tmp)+0);$t++) {
								if ($val==$tmp[$t]) {
									$u = "SELECTED";
								} else {
									unset($u);
								}
								print "<option $u>" . $tmp[$t] . "</option>";
							}
							print "</select></td></tr>";
						} elseif (stristr($list[$x],"TB_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
								print "<tr><td>" . ereg_replace("TB_","",$list[$x]) . "</td><td><textarea rows=8 cols=60 wrap='virtual' class='txt' name='$orig' OnKeyUp=\"javascript:AlertUser('IsChanged');\">$val</textarea></td></tr>";
						} else {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							print "<tr><td>$list[$x]</td><td><input DISABLED TYPE='text' NAME='$orig' size=50 VALUE='$val' $roins OnKeyUp=\"javascript:AlertUser('IsChanged');\"></td></tr>";
						}
				}
			}
			print "</table></td></tr></table>";

			if ($nonavbar) {
				print "<input DISABLED TYPE='hidden' name='close_on_next_load' value='1'>";
//				$add1 = " OnClick='javascript:window.close()' ";
				}
			if ($nonavbar) {
				if ($e=="_new_") {
					print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[saveclose]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					if (strtoupper($ShowEmailButton) == "YES") {
						print "&nbsp;&nbsp;&nbsp;<input class='txt' OnClick=\"javascript:document.EditEntity.changed.value='0'\" type=submit name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					}
				} else {
					print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[saveclose]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					if (strtoupper($ShowEmailButton) == "YES") {
						print "&nbsp;&nbsp;&nbsp;<input DISABLED class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					}
				}
				print "<input class='txt' type=submit name=sb OnClick=\"javascript:document.EditEntity.changed.value='0'\" value='$lang[cancel]' align='right' OnClick='javascript:window.close();'></td></tr></table>";
			} else {
				print "<table width='90%'><tr><td><input class='txt' type=submit name=sb OnClick=\"javascript:document.EditEntity.changed.value='0'\" value='$lang[save]' $roins>";
				if (strtoupper($ShowEmailButton) == "YES") {
					print "&nbsp;&nbsp;&nbsp;<input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>";
				}
				print "</td></tr></table>";
			}
			/*
			if ($nonavbar) {
				print "<input DISABLED class='txt' type=submit name=sb value='$lang[saveclose]'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				print "<input DISABLED class='txt' type=submit name=sb value='$lang[cancel]' OnClick='javascript:window.close();'></form>";
			} else {
				print "<input DISABLED class='txt' type=submit name=sb value='$lang[save]'></form>";
			}
			*/
			print "</form>";
			$GLOBALS['CURFUNC'] = "";
}

function EndHTML() {
	print "\n\n<!-- This is the end of the page. -->\n";
	print "</BODY></HTML>";
	//ClearCacheArrays();
}



function SendEmail($eid,$who,$NewOrChanged, $BodyData, $SubjectData, $FromName, $FromAddress) {
	global $BODY_ENTITY_EDIT,$BODY_ENTITY_ADD,$BODY_ENTITY_CUSTOMER_ADD,$session,$NoImageInclude;
	global $admemail,$SMTPserver,$title,$add_to_journal,$recp_list,$EmailNewEntities,$pdf,$lim_to;
	$GLOBALS['CURFUNC'] = "SendEmail::";
	// Fetch the content of the entity

	$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE eid='$eid'";
	$res1 = mcq($sql,$db);
	$enti = mysql_fetch_array($res1);

	// Set the default (local) journal type (may be changed)

	$JournalType = "entity";

	qlog("Sending e-mail fucntions.php 1685: $who");

	// Determine the receipient_name and the receipient_mail address

	if ($who=="owner") {

			qlog("Sendmail email to owner");

			$sql = "SELECT FULLNAME,EMAIL FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $enti['owner'] . "'";
			$res1 = mcq($sql,$db);
			$tmp = mysql_fetch_array($res1);

			$receipient_name = $tmp['FULLNAME'];
			$receipient_mail = $tmp['EMAIL'];

			if ($NewOrChanged=="new") {
				$MailBody = $BODY_ENTITY_ADD;
				$MailSubject = "A new entity was added to repository " . $title;
			} elseif ($NewOrChanged=="changed") {

				if ($BodyData) {
					$MailBody = $BODY_ENTITY_EDIT . "<br>" . $BodyData;
				} else {
					$MailBody = $BODY_ENTITY_EDIT;
				}
				$MailSubject = "One of your entities was updated in repository " . $title;
			} else {
				print "Mail Module: Error mailing - is this entity new, or changed?";
				return;
			}

	} elseif ($who=="customer") {

			qlog("Sending email to customer");

			if ($BodyData=="") {
				print "Mail Module: Error. No data received";
				return;
			}

			$sql = "SELECT id,custname,contact,contact_email FROM ".CRM_CUSTOMER_TABLE." WHERE id='" . $enti['CRMcustomer'] . "'";
			$res1 = mcq($sql,$db);
			$tmp = mysql_fetch_array($res1);

			$receipient_name = $tmp['contact'];

			if ($recp_list) {
				$receipient_mail = "ARRAY";
			} else {
				$receipient_mail = $tmp['contact_email'];
			}

			$MailBody = $BodyData;
			$MailSubject = $SubjectData;

			$JournalType = "customer";
			$JournalCustomer = $tmp['id'];
			$DoNotAttach = 1;

	} elseif ($who=="customer_owner") {

			// eid contains customer number, $BodyData contains EID (yes this is weird, i know)

			$sql = "SELECT customer_owner FROM ".CRM_CUSTOMER_TABLE." WHERE id='" . $eid . "'";
			$res1 = mcq($sql,$db);
			$tmp = mysql_fetch_array($res1);

			// use proper var names

			$customer = $eid;

			// Get the owner of the customer

			$sql = "SELECT FULLNAME,EMAIL FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $tmp['customer_owner'] . "'";
			$res1 = mcq($sql,$db);
			$row = mysql_fetch_array($res1);

			$receipient_name = $row['FULLNAME'];
			$receipient_mail = $row['EMAIL'];

			if ($receipient_mail=="") {
					print "Mail Module: No e-mail address found - fatal ($who $receipient_name)";
					return;
			}

			$MailBody = $BODY_ENTITY_CUSTOMER_ADD;
			$MailSubject = "Your customer got a new entity coupled in repository " . $title;

			$eid = $BodyData;

			$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE eid='$eid'";
			$res1 = mcq($sql,$db);
			$enti = mysql_fetch_array($res1);

			// Set the customer right because the next routine must use the new one,
			// though it's not yet updated in the database.

			$enti['CRMcustomer'] = $customer;

			// We don't want an attachment containing the entity body because
			// the body is also not yet updated; it would be confusing

			//$DoNotAttach = 1;
			$JournalType = "customer";
			$JournalCustomer = $eid;

	} elseif ($who=="customerdirect") {

			if ($BodyData=="") {
				print "Error. No data received";
				return;
			}

			$sql = "SELECT id,custname,contact,contact_email FROM ".CRM_CUSTOMER_TABLE." WHERE id='" . $eid . "'";
			$res1 = mcq($sql,$db);
			$tmp = mysql_fetch_array($res1);

			$receipient_name = $tmp['contact'];

			if ($recp_list) {
				$receipient_mail = "ARRAY";
			} else {
				$receipient_mail = $tmp['contact_email'];
			}

			$MailBody = $BodyData;
			$MailSubject = $SubjectData;
			$JournalType = "customer";
			$JournalCustomer = $tmp['id'];

	} elseif ($who=="assignee") {

			qlog("Sending e-mail to assignee");

			$sql = "SELECT FULLNAME,EMAIL FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $enti['assignee'] . "'";
			$res1 = mcq($sql,$db);
			$tmp = mysql_fetch_array($res1);

			$receipient_name = $tmp['FULLNAME'];
			$receipient_mail = $tmp['EMAIL'];

			if ($NewOrChanged=="new") {
				$MailBody = $BODY_ENTITY_ADD;
				$MailSubject = "A new entity was added to repository " . $title;
			} elseif ($NewOrChanged=="changed") {
				if ($BodyData) {
					$MailBody = $BODY_ENTITY_EDIT . "<br>" . $BodyData;
				} else {
					$MailBody = $BODY_ENTITY_EDIT;
				}
				$MailSubject = "One of your entities was updated in repository " . $title;
			} else {
				print "Error mailing - is this entity new, or changed?";
				return;
			}

	} elseif ($who=="global_new_entity") {

			$receipient_name = "CRM Administrator";
			$receipient_mail = $EmailNewEntities;

			$MailBody = $BODY_ENTITY_ADD;
			$MailSubject = "A new entity was added to repository " . $title;

	} elseif ($who=="limited_add") {
			if (!$lim_to) {
				print "Error sending notification e-mail: receipient not set (#3345)";
				return(false);
			} else {

				$receipient_name = "CRM Administrator";
				$receipient_mail = $lim_to;

				$MailBody = $BODY_ENTITY_ADD;
				$MailSubject = "A new entity was added to repository " . $title;

			}
	} else {
		print "Error mailing - to who should this mail be sent?";
		return;
	}

	$customer = GetCustomerName($enti['CRMcustomer']);
	$owner = GetUserName($enti['owner']);
	$assignee = GetUserName($enti['assignee']);

	$webhost = getenv("HOSTNAME");

	// Create a new mail class

	$mail = new PHPMailer();

	if ($FromAddress) {
		$mail->From     = $FromAddress;
	} else {
		$mail->From     = $admemail;
	}

	if ($FromName) {
		$mail->FromName = $FromName;
	} else {
		$mail->FromName = "CRM Notification manager";
	}
	$mail->Host     = $SMTPserver;
	$mail->Mailer   = "smtp";
	$mail->IsHTML(true);

	$MailBody = ereg_replace('@ADMINEMAIL@',$admemail,$MailBody);
	$MailBody = ereg_replace('@WEBHOST@',$webhost,$MailBody);
	$MailBody = ereg_replace('@TITLE@',$title,$MailBody);
	$MailBody = ereg_replace('@ENTITYID@',$enti['eid'],$MailBody);
	$MailBody = ereg_replace('@CATEGORY@',$enti['category'],$MailBody);
	$MailBody = ereg_replace('@OWNER@',$owner,$MailBody);
	$MailBody = ereg_replace('@ASSIGNEE@',$assignee,$MailBody);
	$MailBody = ereg_replace('@CONTENTS@',$enti['content'],$MailBody);
	$MailBody = ereg_replace('@CUSTOMER@',$customer,$MailBody);
	$MailBody = ereg_replace('@DUEDATE@',$enti['duedate'],$MailBody);

	$ColoredStatus = "<a style='background:" . GetStatusColor($enti['status']) . "'>" . $enti['status'] . "</a>";

	$MailBody = ereg_replace('@STATUS@',$ColoredStatus,$MailBody);

	$ColoredPrio = "<a style='background:" . GetPriorityColor($enti['priority']) . "'>" . $enti['priority'] . "</a>";

	$MailBody = ereg_replace('@PRIORITY@',$ColoredPrio,$MailBody);

	$text_MailBody = ereg_replace("<([^>]+)>", "", (eregi_replace("<br>","\015\012",$MailBody)));


	// ------------ JOURNAL THIS EVENT

	$text_to_journal = "E-mail sent ----- body follows:\n" . $text_MailBody;

	journal($enti['eid'],$text_to_journal);

	if ($JournalType=="customer") {
			journal($JournalCustomer,$text_to_journal,"customer");
	}

	// ------------ END JOURNAL

	if (trim($enti['content'])<>"" && !$DoNotAttach && !trim($_SERVER['SERVER_NAME'])=="") {
		$include=1; // tell sumpdf she's included
		require_once("sumpdf.php");

		$eid = $enti['eid']; // the PDF routine likes this

		// create temp file
		$file = tempnam("","CRM_TMP_BIN_");
		$file_cache = $file;

		// wake up pdf object
		StartPDF();

		// we don't want images
		//$NoImageInclude=1;

		// create pdf in object
		cat_sum($eid);

		$date = date("F j, Y, H:i") . "h";

		// spool pdf to file
		$pdf->Output($file);

		// open file, read contents
		$fp = fopen($file,"r");
		while (!feof($fp)) {
			$file .= fread($fp,1024);
		}
		fclose($fp);

		// delete temp file
		unlink($file_cache);

		$mail->AddStringAttachment($file, "EntityReport-" . $enti['eid'] . ".pdf");

	} elseif (trim($_SERVER['SERVER_NAME'])=="") {
		uselogger("ERROR - PDF - SERVER_NAME variable is empty","");
	}

	$mail->Body    = stripslashes($MailBody);
	$mail->AltBody = stripslashes($text_MailBody);

	if ($receipient_mail=="ARRAY") {
		for ($i=1;$i<sizeof($recp_list);$i++) {
			$mail->AddAddress($recp_list[$i],"CRM Administrator");
		}
	} else {
		$mail->AddAddress($receipient_mail,"CRM Administrator");
	}

	$mail->Subject = $MailSubject;
	$GLOBALS['CURFUNC'] = "SendEmail::";
	if(!$mail->Send()) {
		echo "<font color='#FF0000'>There has been a mail error sending to $EmailNewEntities:" . $mail->ErrorInfo . ". Please contact your system administrator.</font><br>";
		uselogger("Sending e-mail to $who $receipient_mail failed:" . $mail->ErrorInfo,"");
		$add_to_journal .= "\nSending e-mail to $who $receipient_mail failed:" . $mail->ErrorInfo;
		qlog("E-mail NOT sent.. ERROR: " . $mail->ErrorInfo);

	} else {
		uselogger("Notification e-mail sent to $who $receipient_mail","");
		$add_to_journal .= "\nNotification e-mail sent to $who $receipient_mail";
		qlog("A nice e-mail was sent.");
	}


	$mail->ClearAddresses();
	$mail->ClearAttachments();
	$GLOBALS['CURFUNC'] = "";
}

function CheckEntityAccess($EntityID) {
	// This routine checks if the current $GLOBALS[USERID] has access to $EntityID
	$GLOBALS['CURFUNC'] = "CheckEntityAccess::";
	$cll = GetClearanceLevel($GLOBALS[USERID]);

	if ($cll=="administrator") {
		$ret = "ok";
	} elseif ($cll=="ooro") {
		// only own ENTITIES (not files) read-only

		$sql = "SELECT assignee FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $EntityID . "'";
		$out = mcq($sql,$db);
		$row = mysql_fetch_array($out);

		if ($GLOBALS[USERID]<>$row['assignee']) {
			print "Access to this entity is denied - this entity is not assigned to you";
			exit;
		} else {
			$ret = "ok";
		}
	} elseif ($cll=="read-only-all") {
		$ret = "ok";
	} elseif ($cll=="full-access-own-entities") {
		$ret = "ok";
	}

	$sql = "SELECT readonly,assignee,owner FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $EntityID . "'";
	$out = mcq($sql,$db);
	$row = mysql_fetch_array($out);

	if (($row['readonly']=="y") && $GLOBALS[USERID]<>$row['assignee'] && $GLOBALS[USERID]<>$row['owner']) {
		$ret="readonly";
	}
	$GLOBALS['CURFUNC'] = "";
	return($ret);

	// TMP
	//print $cll;
	//exit;
}

function CheckFileAccess($fileid) {
	// This routine checks if the current $GLOBALS[USERID] has access to $fileid
	$GLOBALS['CURFUNC'] = "CheckFileAccess::";
	$cll = GetClearanceLevel($GLOBALS[USERID]);

	$sql = "SELECT koppelid FROM ".CRM_BINFILES_TABLE." WHERE fileid='" . $fileid . "'";
	$out = mcq($sql,$db);
	$row = mysql_fetch_array($out);
	$eid = $row['koppelid'];

	if ($cll=="administrator") {
		$ret = "ok";
	} elseif ($cll=="ooro") {
		// only own ENTITIES (not files) read-only


		$entity_id = $row['koppelid'];

		$sql = "SELECT assignee FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $entity_id . "'";
		$out = mcq($sql,$db);
		$row = mysql_fetch_array($out);



		if ($GLOBALS[USERID]<>$row['assignee']) {
			print "Access to this file is denied - this entity is not assigned to you";
			exit;
		}

	} elseif ($cll=="read-only-all") {
		$ret = "ok";
	} elseif ($cll=="full-access-own-entities") {
		$ret = "ok";
	}

	$sql = "SELECT readonly,assignee,owner FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $eid . "'";
	$out = mcq($sql,$db);
	$row = mysql_fetch_array($out);

	if (($row['readonly']=="y") && $GLOBALS[USERID]<>$row['assignee'] && $GLOBALS[USERID]<>$row['owner']) {
		$ret="readonly";
	}
	$GLOBALS['CURFUNC'] = "";
	return($ret);

	// TMP
//	print $cll;
//	exit;
}

/**
* Function TransformDate
*
* Transforms a given date to the american format
* if the date format is set to mm-dd-yyyy (global setting)
*
* @param	date_to_print	The european-formatted date in dd-mm-yyyy format
*/
function TransformDate($date_to_print) {
	global $DateFormat;
	$GLOBALS['CURFUNC'] = "TransformDate::";

	if ($DateFormat=="mm-dd-yyyy") {

		if (strlen($date_to_print)<>10) {
			$Return = $date_to_print;
		} else {
			$d = substr($date_to_print,0,2);
			$m = substr($date_to_print,3,2);
			$y = substr($date_to_print,6,4);
			$Return = $m . "-" . $d . "-" . $y;
		}
	} else {
		$Return = $date_to_print;
	}
	$GLOBALS['CURFUNC'] = "";
	return($Return);
}

/**
* Function DisplayEntityActivityGraph
*
* Creates the array needed by TekenGrafiek() to draw
* the Entity Activity graph.
*
* @param	eid		The entity id
*/
function DisplayEntityActivityGraph($eid) {
		global $lang,$in_line,$filename_to_disk_to_use;
		$GLOBALS['CURFUNC'] = "DisplayEntityActivityGraph::";
		require_once("fgrph.php");

		CheckEntityAccess($eid);

		$sql= "SELECT timestamp FROM ".CRM_JOURNAL_TABLE." WHERE eid='" . $eid  . "'";
		if ($debug) { print "\nSQL: $sql\n"; }
		$result= mcq($sql,$db);
		while ($resarr=mysql_fetch_array($result)){
				$x++;
				$table_array[$x] = substr($resarr[timestamp],0,8);
				$results++;
		}

		$desc = "Activity of entity $eid";

		if ($results<3) {
			$table_array[0] = "0";
			$table_array[1] = "0";
			$table_array[2] = "0";
			$table_array[3] = "0";
			$table_array[4] = "0";
			$table_array[5] = "0";
			$table_array[6] = "0";
			$table_array[7] = "0";
			$table_array[8] = "0";
			$table_array[9] = "0";
			$table_array[10] = "0";
			$results=11;
		}

		sort($table_array);

		$unique = array();
		$count = array();
		$inarray = 0;

		for ($y=0;$y<sizeof($table_array);$y++) {

			if (!in_array($table_array[$y], $unique)) {
				// Found a unique entry....
				$unique[$inarray] = $table_array[$y];
				$inarray++;
			}
		}

		for ($y=0;$y<sizeof($table_array);$y++) {
			for ($z=0;$z<$inarray;$z++ ) {
					if ($unique[$z]==$table_array[$y]) {
						$count[$z] = $count[$z] + 1;
						$totcount++;
					}
				}
		}



		$leeg = array();
		tekenGrafiek($unique, $count, $leeg, true, $desc, 300, 175);
		$GLOBALS['CURFUNC'] = "";
}


/**
* Function DisplayCustomerActivityGraph
*
* Creates the array needed by TekenGrafiek() to draw
* the Customer Activity graph.
*
* @param	cust_id		The entity id
*/
function DisplayCustomerActivityGraph($cust_id) {
		$GLOBALS['CURFUNC'] = "DisplayCustomeryActivityGraph::";
		global $lang;
		require_once("fgrph.php");

		$sql= "SELECT timestamp FROM ".CRM_JOURNAL_TABLE." WHERE eid='" . $cust_id  . "' AND type='customer'";

		$result= mcq($sql,$db);
		while ($resarr=mysql_fetch_array($result)){
				$x++;
				$table_array[$x] = substr($resarr[timestamp],0,8);
				$results++;
		}

		if ($results<3) {
			print "<title>C R M - " . $title . "</title>";
			?>
			<HTML>
			<META HTTP-EQUIV="Expires" CONTENT="0">
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
			<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
			<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
			<META HTTP-EQUIV="Refresh" CONTENT="<?php echo $timeoutsec;?>;url=index.php?logout=1&expire=1">
			</head>
			<SCRIPT LANGUAGE="JavaScript">
			<!--
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
			//-->
			</SCRIPT>
			<body>
			<?php
			print "<table><tr><td><img src='error.gif'>&nbsp;Not enough journal information to build graph</td></tr></table>";
			print "</body></html>";
			exit;
		}

		$desc = "Activity of " . strtolower($lang[customer]) . " " . $cust_id;

		sort($table_array);
		//print "<pre>";
		//print_r($table_array);

		$unique = array();
		$count = array();
		//$count[0] = "0";
		//$count[1] = "0";
		$inarray = 0;

		for ($y=0;$y<sizeof($table_array);$y++) {

			if (!in_array($table_array[$y], $unique)) {
				// Found a unique entry....
				$unique[$inarray] = $table_array[$y];
				$inarray++;
			}
		}

		for ($y=0;$y<sizeof($table_array);$y++) {
			for ($z=0;$z<$inarray;$z++ ) {
					if ($unique[$z]==$table_array[$y]) {
						$count[$z] = $count[$z] + 1;
						$totcount++;
					}
				}
		}

	$leeg = array();
	//print "<pre>";
	//print_r($unique);
	//print_r($count);
	//exit;
	tekenGrafiek($unique, $count, $leeg, true, $desc, 300, 175);
	$GLOBALS['CURFUNC'] = "";
}
/**
* Function DisplayUserActivityGraph
*
* Creates the array needed by TekenGrafiek() to draw
* the User Activity graph.
*
* @param	cust_id		The entity id
*/
function DisplayUserActivityGraph($user_id) {
		global $lang;
		$GLOBALS['CURFUNC'] = "DisplayUserActivityGraph::";
		require_once("fgrph.php");

		// first, fetch the user name

		$sql = "SELECT name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $user_id . "'";
		$result = mcq($sql,$db);
		$result = mysql_fetch_array($result);
		$username = $result[name];

		$sql= "SELECT tijd FROM ".CRM_USELOG_PERIOD_TABLE." WHERE user='" . $username  . "'";

		$result= mcq($sql,$db);
		while ($resarr=mysql_fetch_array($result)){
				$x++;
				$table_array[$x] = substr($resarr[tijd],0,8);
				$results++;
		}
		if ($results<3) {
			$table_array[0] = "0";
			$table_array[1] = "0";
			$table_array[2] = "0";
			$table_array[3] = "0";
			$table_array[4] = "0";
			$table_array[5] = "0";
			$table_array[6] = "0";
			$table_array[7] = "0";
			$table_array[8] = "0";
			$table_array[9] = "0";
			$table_array[10] = "0";
			$results=11;
		}

		if ($results<3) {
			print "<title>C R M - " . $title . "</title>";
			?>
			<HTML>
			<META HTTP-EQUIV="Expires" CONTENT="0">
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
			<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
			<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
			<META HTTP-EQUIV="Refresh" CONTENT="<?php echo $timeoutsec;?>;url=index.php?logout=1&expire=1">
			</head>
			<SCRIPT LANGUAGE="JavaScript">
			<!--
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
			//-->
			</SCRIPT>
			<body>
			<?php
			print "<table><tr><td><img src='error.gif'>&nbsp;Not enough journal information to build graph</td></tr></table>";
			print "</body></html>";
			exit;
		}

		$desc = "Activity of user " . GetUserName($user_id) . " based on " . $results . " log entries";

		sort($table_array);

		$unique = array();
		$count = array();
		$inarray = 0;

		for ($y=0;$y<sizeof($table_array);$y++) {

			if (!in_array($table_array[$y], $unique)) {
				// Found a unique entry....
				$unique[$inarray] = $table_array[$y];
				$inarray++;
			}
		}

		for ($y=0;$y<sizeof($table_array);$y++) {
			for ($z=0;$z<$inarray;$z++ ) {
					if ($unique[$z]==$table_array[$y]) {
						$count[$z] = $count[$z] + 1;
						$totcount++;
					}
				}
		}

	$leeg = array();

	tekenGrafiek($unique, $count, $leeg, true, $desc, 570, 275);
	$GLOBALS['CURFUNC'] = "";
}
/**
* Function DisplayUserActivityGraphJournal
*
* Creates the array needed by TekenGrafiek() to draw
* the User Activity graph based on the journal.
*
* @param	cust_id		The entity id
*/
function DisplayUserActivityGraphJournal($user_id) {
		global $lang;
		$GLOBALS['CURFUNC'] = "DisplayUserActivityGraphJournal::";
		require_once("fgrph.php");

		// first, fetch the user name

		$sql = "SELECT name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='" . $user_id . "'";
		$result = mcq($sql,$db);
		$result = mysql_fetch_array($result);
		$username = $result[name];

		$sql= "SELECT timestamp FROM ".CRM_JOURNAL_TABLE." WHERE user='" . $user_id  . "'";

		$result= mcq($sql,$db);
		while ($resarr=mysql_fetch_array($result)){
				$x++;
				$table_array[$x] = substr($resarr[timestamp],0,8);
				$results++;
		}
		if ($results<3) {
			$table_array[0] = "0";
			$table_array[1] = "0";
			$table_array[2] = "0";
			$table_array[3] = "0";
			$table_array[4] = "0";
			$table_array[5] = "0";
			$table_array[6] = "0";
			$table_array[7] = "0";
			$table_array[8] = "0";
			$table_array[9] = "0";
			$table_array[10] = "0";
			$results=11;
		}

		if ($results<3) {
			print "<title>C R M - " . $title . "</title>";
			?>
			<HTML>
			<META HTTP-EQUIV="Expires" CONTENT="0">
			<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
			<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
			<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
			<META HTTP-EQUIV="Refresh" CONTENT="<?php echo $timeoutsec;?>;url=index.php?logout=1&expire=1">
			</head>
			<SCRIPT LANGUAGE="JavaScript">
			<!--
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
			//-->
			</SCRIPT>
			<body>
			<?php
			print "<table><tr><td><img src='error.gif'>&nbsp;Not enough journal information to build graph</td></tr></table>";
			print "</body></html>";
			exit;
		}

		$desc = "Activity of user " . GetUserName($user_id) . " based on " . $results . " journal entries";

		sort($table_array);

		$unique = array();
		$count = array();
		$inarray = 0;

		for ($y=0;$y<sizeof($table_array);$y++) {

			if (!in_array($table_array[$y], $unique)) {
				// Found a unique entry....
				$unique[$inarray] = $table_array[$y];
				$inarray++;
			}
		}

		for ($y=0;$y<sizeof($table_array);$y++) {
			for ($z=0;$z<$inarray;$z++ ) {
					if ($unique[$z]==$table_array[$y]) {
						$count[$z] = $count[$z] + 1;
						$totcount++;
					}
				}
		}

	$leeg = array();

	tekenGrafiek($unique, $count, $leeg, true, $desc, 570, 275);
	$GLOBALS['CURFUNC'] = "";
}


function LogFunction() {
	global $logquery, $anyway, $password,$warnings;
	$GLOBALS['CURFUNC'] = "LogFunction::";
	uselogger("Log viewed","");
	print "<tr><td>";
	print "<table><tr><td colspan=8><fieldset><legend>Query the log</legend>";
	print "<form name='nm' method='GET'><input type='hidden' name='log' value='1'><input type='hidden' name='password' value='$password'><input type='text' name='logquery' value='" . $logquery . "'>&nbsp;<input type='submit'></form>";
	print "<br>Or:<br>";
	print "<img src='arrow.gif'>&nbsp;<a href='admin.php?logquery=" . $logquery . "&warnings=1&log=1&password=" . $password . "' class='bigsort'>View errors and warnings only";
	print "</fieldset></tr></td></table>";
	print "<table><tr><td colspan=8><fieldset><legend>To download the log file in CSV click on one of the following</legend>";
	print "<img src='arrow.gif'>&nbsp;<a href='csv.php?exportlog=1&sep=;' class='bigsort'>Semicolon separated (;)</a><br>";
	print "<img src='arrow.gif'>&nbsp;<a href='csv.php?exportlog=1&sep=,' class='bigsort'>Comma separated (,)</a><br>";
	print "<img src='arrow.gif'>&nbsp;<a href='csv.php?exportlog=1&sep=:' class='bigsort'>Colon separated (:)</a><br>";

	print "</td></tr><tr><td>";
	printbox("<img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&joepie=1' style='cursor:hand'>Back to main administration page</a>");
	print "</td></tr>";
    print "</table></td></tr></table></fieldset><br><br>";

	if ($logquery || $warnings) {
		print "<table border=1 width='100%' cellpadding=4 cellspacing=4>";

		if (!$warnings) {
			$sql = "SELECT * FROM ".CRM_USELOG_PERIOD_TABLE." WHERE qs LIKE '%" . $logquery . "%'";
			$result= mcq($sql,$db);
		} else {
			$sql = "SELECT * FROM ".CRM_USELOG_PERIOD_TABLE." WHERE qs LIKE '%error%' OR qs LIKE '%warning%' OR qs LIKE '%illegal%' OR qs LIKE '%PHYSICAL ENTITY%'";
			$result= mcq($sql,$db);
		}

		while ($row = mysql_fetch_array($result)) {
			$tp .= "<td>" . $row[0] . "</td><td>" . $row[1] . "</td><td>" . $row[4] . "</td><td>" . $row[2] . "</td><td NOWRAP>" . $row[5] . "</td><td NOWRAP>" . $row[6] . "</td></tr>\n";
			$ltp++;
		}
		if ($ltp<1000 || $anyway) {
			if ($tp<>"") {
				print $tp;
				print "<tr><td colspan=5>" . $ltp . " results</td></tr>";
			} else {
				print "<tr><td>No results.</td></tr>";
			}
		} else {
			print "<tr><td><img src='error.gif'>&nbsp;More than 1,000 results. Please refine your query. <img src='arrow.gif'>&nbsp;<a href='admin.php?logquery=" . $logquery . "&anyway=1&warnings=$warnings&log=1&password=" . $password . "' class='bigsort'>execute anyway</a></td></tr>";
		}
		print "</table>";
	}
	$GLOBALS['CURFUNC'] = "";
}

function DeleteExpiredTempFiles() {
	$GLOBALS['CURFUNC'] = "DeleteExpiredTempFiles::";

	$dir = ini_get("session.save_path") . "/";

	if ($dir=="/") {
		qlog("Error fetching temporary file space. Temp files left behind cannot be deleted.");
		uselogger("Error fetching temporary file space. Temp files left behind cannot be deleted. This will also cause problems when using exports and such. Check if your php.ini variable 'session.save_path' is set to a proper location.","");
	} else {



		if($dir[(strlen($dir)-1)]!= "/") $dir .= "/"; //check for trailing slash

		$d = dir($dir);
		$date = date(U);

		while($f = $d->read()){
			$date2 = @fileMtime($dir.$f); //change to A C or M
			if(($date - $date2) > 120) { // 120 seconds

				if (strstr($f,"CRM_TMP_") && $f <> ".") {

					if(@unlink($dir . $f)) {
						qlog("Deleted expired temp file " . $dir . $f);
						uselogger("Deleted expired temporary file " . $dir . $f,"");
					} else {
						qlog("NOT Deleted expired temp file " . $dir . $f . " - unknown error - probably no access");
						uselogger("NOT Deleted expired temp file " . $dir . $f . " - unknown error - probably no access","");
					}
				}
			} else {
				//qlog("NOT Deleted expired temp file " . $dir . $f);
			}
		}
		$d->close();
	}
	$GLOBALS['CURFUNC'] = "";
}

function RealExcel($excel,$CSVseparator) {
	// HANDLES CSV OUTPUT SEPARATED BY @@@REALEXCEL@@@@ ASSUMES FIRST LINE IS LEGEND
	// $WrappedCellsEachLine must contain array with horiz. fields list (numbers) of cells
	// that must be wrapped
	$GLOBALS['CURFUNC'] = "RealExcel";

	require('Writer.php');


	$filename = "CRM-export-" . date("m-j-Y-Hi") . "h.xls";
	$summ = "CRM-export-" . date("m-j-Y-Hi") . "h";

	//$filename = "bla.xls";
	//$summ = "bla.xls";

	// Creating a workbook
	$workbook = new Spreadsheet_Excel_Writer();
	// $workbook = new Workbook("-");
	// sending HTTP headers
	$workbook->send($filename);

	// Creating a worksheet
	$worksheet =& $workbook->addWorksheet($summ);
	$worksheet -> setLandscape();
	$worksheet -> setHeader($summ);

	$format_normal =& $workbook->addFormat();
	$format_normal -> setSize(9);
	$format_normal -> setBorder(1);

	$format_bold =& $workbook->addFormat();
	$format_bold -> setBold();
	$format_bold -> setColor('white');
	$format_bold -> setPattern(1);
	$format_bold -> setFgColor('blue');
	$format_bold -> setSize(9);
	$format_bold -> setBorder(1);

	$format_wrapped =& $workbook->addFormat();
	$format_wrapped -> setTextWrap();
	$format_wrapped -> setSize(9);
	$format_wrapped -> setBorder(1);

	$format_rowheader =& $workbook->addFormat();
	$format_rowheader -> setBold();
	$format_rowheader -> setFgColor('gray');
	$format_rowheader -> setSize(9);
	$format_rowheader -> setBorder(1);

	$line = 0;
	$cell = 0;

	$max_col_width = array();

	// Create header in format_bold

	$header = split($CSVseparator,$excel[0]);

	for ($i=0;$i<sizeof($header);$i++) {
				$worksheet->write(0, $i, $header[$i], $format_bold);
				$max_col_width[$i] = strlen($header[$i]);
	}

	$linecount = 1;


	for ($i=1;$i<sizeof($excel);$i++) {

		$line = split($CSVseparator,$excel[$i]);	// get current line and array' it

		for ($u=0;$u<sizeof($line);$u++) {

					if ($u==0) {
						$worksheet->write($linecount, $u, $line[$u], $format_rowheader);
					} elseif (stristr($line[$u],"@@@@WRAPPED@@@@")) {
						$line[$u] = ereg_replace("@@@@WRAPPED@@@@","",$line[$u]);
						$worksheet->write($linecount, $u, $line[$u], $format_wrapped);

					} elseif (stristr($line[$u],"@@@@HEXCOLOR")) {

						$tmp = split("@@@@HEXCOLOR",$line[$u]);

						$hex = ltrim($tmp[1],"#");

						$tmpvar = "format_" . $hex;

						if (!$$tmpvar) {
							$$tmpvar =& $workbook->addFormat();
						}
						$ExcelColor = GetExcelColorName($hex);
						$$tmpvar -> setSize(9);
						$$tmpvar -> setBorder(1);

						$$tmpvar -> setFgColor($ExcelColor);
						$worksheet->write($linecount, $u, $tmp[2], $$tmpvar);


					} else {
						$worksheet->write($linecount, $u, $line[$u], $format_normal);
					}
					if ($max_col_width[$u] < strlen($header[$u])) {
							$max_col_width[$u] = strlen($header[$u]);
					}

		}

		$linecount++;

	}

	// Now adjust the cell width

	for ($i=0;$i<sizeof($max_col_width);$i++) {
		if ($max_col_width[$i]) {
			$worksheet -> setColumn($i, $i, ($max_col_width[$i]*2));
		}
	}

	// Let's send the file
	$workbook->close();
}

function GetExcelColorName($hex) {
	// array met excel kleuren
	$color = array();
	   array_push($color,array('00','00','00',8));  // 8
	   array_push($color,array('ff','ff','ff',9));   // 9
	   array_push($color,array('ff','00','00',10)); // 10
	   array_push($color,array('00','ff','00',11)); // 11
	   array_push($color,array('00','00','ff',12)); // 12
	   array_push($color,array('ff','ff','00',13)); // 13
	   array_push($color,array('ff','00','ff',14)); // 14
	   array_push($color,array('00','ff','ff',15)); // 15
	   array_push($color,array('80','00','00',16)); // 16
	   array_push($color,array('00','80','00',17)); // 17
	   array_push($color,array('00','00','80',18)); // 18
	   array_push($color,array('80','80','00',19)); // 19
	   array_push($color,array('80','00','80',20)); // 20
	   array_push($color,array('00','80','80',21)); // 21
	   array_push($color,array('c0','c0','c0',22)); // 22
	   array_push($color,array('80','80','80',23)); // 23
	   array_push($color,array('99','99','ff',24)); // 24
	   array_push($color,array('99','33','66',25)); // 25
	   array_push($color,array('ff','ff','cc',26)); // 26
	   array_push($color,array('cc','ff','ff',27)); // 27
	   array_push($color,array('66','00','66',28)); // 28
	   array_push($color,array('ff','80','80',29)); // 29
	   array_push($color,array('00','66','cc',30)); // 30
	   array_push($color,array('cc','cc','ff',31)); // 31
	   array_push($color,array('00','00','80',32)); // 32
	   array_push($color,array('ff','00','ff',33)); // 33
	   array_push($color,array('ff','ff','00',34)); // 34
	   array_push($color,array('00','ff','ff',35)); // 35
	   array_push($color,array('80','00','80',36)); // 36
	   array_push($color,array('80','00','00',37)); // 37
	   array_push($color,array('00','80','80',38)); // 38
	   array_push($color,array('00','00','ff',39)); // 39
	   array_push($color,array('00','cc','ff',40)); // 40
	   array_push($color,array('cc','ff','ff',41)); // 41
	   array_push($color,array('cc','ff','cc',42)); // 42
	   array_push($color,array('ff','ff','99',43)); // 43
	   array_push($color,array('99','cc','ff',44)); // 44
	   array_push($color,array('ff','99','cc',45)); // 45
	   array_push($color,array('cc','99','ff',46)); // 46
	   array_push($color,array('ff','cc','99',47)); // 47
	   array_push($color,array('33','66','ff',48)); // 48
	   array_push($color,array('33','cc','cc',49)); // 49
	   array_push($color,array('99','cc','00',50)); // 50
	   array_push($color,array('ff','cc','00',51)); // 51
	   array_push($color,array('ff','99','00',52)); // 52
	   array_push($color,array('ff','66','00',53)); // 53
	   array_push($color,array('66','66','99',54)); // 54
	   array_push($color,array('96','96','96',55)); // 55
	   array_push($color,array('00','33','66',56)); // 56
	   array_push($color,array('33','99','66',57)); // 57
	   array_push($color,array('00','33','00',58)); // 58
	   array_push($color,array('33','33','00',59)); // 59
	   array_push($color,array('99','33','00',60)); // 60
	   array_push($color,array('99','33','66',61)); // 61
	   array_push($color,array('33','33','99',62)); // 62
	   array_push($color,array('33','33','33',63)); // 63



	$ir = hexdec(substr($hex,0,2));
	$ig = hexdec(substr($hex,2,2));
	$ib = hexdec(substr($hex,4,2));

	$currnaast = 255*255*255; // max wat naast is
	$currkleurnaam = "fout!";
	$currrgb = "fout";

	for ($i=0;$i<sizeof($color);$i++) {

		$r = $color[$i][0];
		$g = $color[$i][1];
		$b = $color[$i][2];
		$kleurnaam = $color[$i][3];

		$tmpnaast = (abs($ir - hexdec($r)) + abs($ig - hexdec($g)) + abs($ib - hexdec($b)));
		if ($tmpnaast < $currnaast) {
			$currkleurnaam = $kleurnaam;
			$currrgb =  $r . $g . $b;
			$currnaast = $tmpnaast;
		}
	}
return $currkleurnaam;
}

function CheckForDueDates() {
		global $admemail,$reposnr,$repository_nr,$title,$BODY_DUEDATE,$SMTPserver,$webhost;
		$GLOBALS['CURFUNC'] = "CheckForDueDates::";
		qlog("Checking duedates to mail in repository " . $repository_nr);
		$debug=0;
		$teller = 0;
		$bdate=date("dmY");
		print "Current bdate is $bdate\n--------------------------------------------------------------------\n";

		$sql="SELECT basicdate, emailadress, eID FROM ".CRM_CALENDAR_TABLE." WHERE basicdate='$bdate'";
		$result= mcq($sql,$db);

		//require("class.phpmailer.php");

		while ($ra = mysql_fetch_array($result)) {
			if ($ra[emailadress]) {
					$mail = new PHPMailer();
					$mail->FromName = "CRM Notification manager";
					$mail->Host     = $SMTPserver;
					$mail->Mailer   = "smtp";
					$mail->IsHTML(true);

					print "Processing $ra[emailadress]<BR>\n";

					$sql= "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE eid='$ra[eID]'";
					$res= mcq($sql,$db);
					$res= mysql_fetch_array($res);

					$sql = "SELECT fullname AS name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$res[owner]'";
					$res1 = mcq($sql,$db);
					$owner = mysql_fetch_array($res1);
					$OWNER = $owner[name];

					$sql = "SELECT fullname AS name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$res[assignee]'";
					$res1 = mcq($sql,$db);
					$assignee = mysql_fetch_array($res1);
					$ASSIGNEE = $assignee[name];

					if ($res[CRMcustomer]=="") {
						$res[CRMcustomer]=="bla";
					}
					$sql = "SELECT custname FROM ".CRM_CUSTOMER_TABLE." WHERE id='$res[CRMcustomer]'";
					$res1 = mcq($sql,$db);
					$cust = mysql_fetch_array($res1);
					$customer = $cust[custname];



					$CONTENTS = ereg_replace("\n","<BR>\n",$res[content]);
					$ENTITYID = $ra[eID];
					$CATEGORY = $ra[category];

					$body = $BODY_DUEDATE;

					$body = ereg_replace('@ENTITYID@',$ENTITYID,$body);
					$body = ereg_replace('@CATEGORY@',$res[category],$body);
					$body = ereg_replace('@OWNER@',$OWNER,$body);
					$body = ereg_replace('@ASSIGNEE@',$ASSIGNEE,$body);
					$body = ereg_replace('@CONTENTS@',$CONTENTS,$body);
					$body = ereg_replace('@ADMINEMAIL@',$admemail,$body);
					$body = ereg_replace('@WEBHOST@',$webhost,$body);
					$body = ereg_replace('@TITLE@',$title,$body);

					$body = ereg_replace('@CUSTOMER@',$customer,$body);
					$body = ereg_replace('@DUEDATE@',$res[duedate],$body);
					$body = ereg_replace('@STATUS@',$res[status],$body);
					$body = ereg_replace('@PRIORITY@',$res[priority],$body);
					$contents = eregi_replace("<BR>\n","\n",$contents);

					$text_body = ereg_replace("<([^>]+)>", "", (eregi_replace("<BR>\n","\n",$body)));

					$mail->From    = $admemail;
					$mail->Body    = $body;
					$mail->AltBody = $text_body;

					$t = split(",",$ra[emailadress]);
					for ($y=0;$y<sizeof($t);$y++) {
						$mail->AddAddress(trim($t[$y]),"CRM Administrator");
						print "Adding " . trim($t[$y]) . " to receipient list...\n";
					}


					$mail->Subject = "Alarm notification for entity $ra[eID] ($res[category])";

					if (trim($CONTENTS)<>"") {
						$mail->AddStringAttachment($CONTENTS, "EntityContents.txt");
						$extra = "Entity contents attached\n";
					}	else {
						unset($extra);
					}


					if(!$mail->Send()) {
						echo "There has been a mail error sending to $ra[emailadress]:" . $mail->ErrorInfo . ". Please contact your system administrator.\n";
						$success = "0";
//						uselogger("Sending e-mail to $EmailNewEntities failed:" . $mail->ErrorInfo,"");
					} else {
						$success = "1";
						$teller++;
					}
					// Clear all addresses and attachments for next loop

					$mail->ClearAddresses();
					$mail->ClearAttachments();
					$mail->ClearAllRecipients();
					$mail->ClearCustomHeaders();
					print "$extra";
					print "Repos: $reposnr ($title), Succes: $success\n--------------------------------------------------------------------\n";

			} // End if email adress exists.
//			sleep(3);
			}

		print "$teller Notifications submitted.\n";
	$GLOBALS['CURFUNC'] = "";
}


function SendPersonificatedDailyOverviewMail() {
	global $admemail,$reposnr,$repository_nr,$title,$BODY_DUEDATE,$SMTPserver,$webhost,$lang;

	$GLOBALS['CURFUNC'] = "SendPersonificatedDailyOverviewMail::";

	$sql = "SELECT id,name,EMAIL,RECEIVEDAILYMAIL,FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." WHERE name NOT LIKE 'deleted_user_%' AND (CLLEVEL='rw' OR CLLEVEL='ro+')";
	$result = mcq($sql,$db);

	while ($row = mysql_fetch_array($result)) {

			if ($row['RECEIVEDAILYMAIL']=="Yes") {


				$sql = "SELECT ".CRM_ENTITY_TABLE.".category AS category, ".CRM_ENTITY_TABLE.".duedate, ".CRM_ENTITY_TABLE.".owner AS owner,".CRM_CUSTOMER_TABLE.".custname AS custname,".CRM_ENTITY_TABLE.".status AS status ,".CRM_ENTITY_TABLE.".priority AS prio,".CRM_STATUS_VARS_TABLE.".color AS statuscolor,".CRM_PRIORITY_VARS_TABLE.".color AS priocolor, ".CRM_LOGIN_USERS_TABLE.".FULLNAME AS assignee FROM ".CRM_ENTITY_TABLE.",".CRM_STATUS_VARS_TABLE.",".CRM_PRIORITY_VARS_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_ENTITY_TABLE.".assignee='" . $row['id'] . "' AND ".CRM_ENTITY_TABLE.".assignee=".CRM_LOGIN_USERS_TABLE.".id AND ".CRM_ENTITY_TABLE.".CRMcustomer=".CRM_CUSTOMER_TABLE.".id AND ".CRM_STATUS_VARS_TABLE.".varname=".CRM_ENTITY_TABLE.".status AND ".CRM_PRIORITY_VARS_TABLE.".varname=".CRM_ENTITY_TABLE.".priority AND ".CRM_ENTITY_TABLE.".deleted<>'y' AND ".CRM_ENTITY_TABLE.".assignee<>'2147483647' AND ".CRM_ENTITY_TABLE.".owner<>'2147483647' ORDER BY ".CRM_ENTITY_TABLE.".status,".CRM_ENTITY_TABLE.".priority,".CRM_ENTITY_TABLE.".duedate, ".CRM_ENTITY_TABLE.".eid";
				$result1 = mcq($sql,$db);
				$html = "<html><body><table border=1>";
				$html .= "<tr><td><font face='MS Shell dlg' size='-1'>" . $lang['customer'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['assignee'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['owner'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['status'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['priority'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['category'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $lang['duedate'] . "</font></td></tr>";

				$count = 0;

				while ($row2 = mysql_fetch_array($result1)) {


					$html .= "<tr><td><font face='MS Shell dlg' size='-1'>" . $row2['custname'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $row2['assignee'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . GetUserName($row2['owner']) . "</font></td><td bgcolor='" . $row2['statuscolor'] . "'><font face='MS Shell dlg' size='-1'>" . $row2['status'] . "</font></td><td bgcolor='" . $row2['priocolor'] . "'><font face='MS Shell dlg' size='-1'>" . $row2['prio'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . $row2['category'] . "</font></td><td><font face='MS Shell dlg' size='-1'>" . TransformDate($row2['duedate']) . "&nbsp;</font></td></tr>";
					$GLOBALS['CURFUNC'] = "SendPersonificatedDailyOverviewMail::";
					$count++;

				}
				$html .= "</table></body></html>";
				$mail = new PHPMailer();

				$mail->From     = $admemail;

				$mail->FromName = "CRM Notification manager";

				$mail->Host     = $SMTPserver;
				$mail->Mailer   = "smtp";
				$mail->IsHTML(true);

				$mail->Body    = stripslashes($html);
				$text_MailBody = ereg_replace("<([^>]+)>", "", (eregi_replace("<br>","\015\012",$html)));
				$mail->AltBody = stripslashes($text_MailBody);

				$mail->AddAddress($row['EMAIL'],$row['FULLNAME']);
				$mail->Subject = $row['FULLNAME'] . "'s " . $lang['entities'] . " ($title)";


				if (!trim($row['EMAIL']=="") && $count>0) {
	    			qlog("Sending daily entity overview to " . $row['name'] . " (" . $row['EMAIL'] . ") - $count");
					print "Sending entity overview to " . $row['FULLNAME'] . " ($count entities)\n";
					if(!$mail->Send()) {
						echo "<font color='#FF0000'>There has been a mail error sending to ". $row['EMAIL'] . ":" . $mail->ErrorInfo . ". Please contact your system administrator.</font><br>";
						//uselogger("Sending e-mail to $who $receipient_mail failed:" . $mail->ErrorInfo,"");
						$add_to_journal .= "\nSending e-mail to $who $receipient_mail failed:" . $mail->ErrorInfo;
						qlog("E-mail NOT sent.. ERROR: " . $mail->ErrorInfo);
					} else {
						//uselogger("Notification e-mail sent to $who $receipient_mail","");
						$add_to_journal .= "\nNotification e-mail sent to $who $receipient_mail";
					}
				}

				$mail->ClearAddresses();
				$mail->ClearAttachments();


			} else {
				qlog("User " . $row['name'] . " doesn't want this update.");
			}

	}

	$GLOBALS['CURFUNC'] = "";
}

function check_config($tbl) {
	global $lang;
	$p = array();
	$sql= "SELECT * FROM ".CRM_SETTINGS_TABLE;
	$result= mcq($sql,$db);
	while ($resarr=mysql_fetch_array($result)){
		if (in_array($resarr[setting],$p)) {
			printbox("<font color='#FF0000'> Double config entry for $resarr[setting] found - fixed by deleting the last one</font>");
			$sql = "DELETE FROM ".CRM_SETTINGS_TABLE." WHERE settingid = '$resarr[settingid]'";
			mcq($sql,$db);
			$fixed = 1;
			//printbox($sql);
		}
		$p[$t] = $resarr[setting];
		$t++;
	}
	if (!$fixed) {
		printbox("Your configuration is consistant, no double entries found.");
	}


}

function ImportSettings() {
	global $lang,$_FILES;
	print "IN_FUNC::ImportSettings";
	if ($_FILES['userfile']['tmp_name']) {
		$fp=fopen($_FILES['userfile']['tmp_name'],"rb");
		while (!feof($fp)) {
			$fc[$t] = fgets($fp,1024);
			$t++;
		}
		fclose($fp);

		for ($x=0;$x<$t;$x++ ) {
				$tmp=split(",",$fc[$x]);
				if (base64_decode($tmp[0]=="@@/loginusers@@")) {
					print "Login user section exit<br>";
					$login = 0;
				}
				if ($login==1) {
					print "<pre>";
					/*
					  `name` varchar(50) NOT NULL default '',
					  `password` varchar(50) default NULL,
					  `type` enum('normal','limited') NOT NULL default 'normal',
					  `active` enum('yes','no') NOT NULL default 'yes',
					  `exptime` varchar(40) NOT NULL default '',
					  `noexp` enum('n','y') NOT NULL default 'n',
					  `administrator` enum('yes','no') NOT NULL default 'no',
					  `FULLNAME` varchar(150) NOT NULL default '',
					  `EMAIL` varchar(150) NOT NULL default '',
					  `CLLEVEL` varchar(50) NOT NULL default 'ro',
					*/
					$tmp[0] = base64_decode($tmp[0]);
					$tmp[1] = base64_decode($tmp[1]);
					$tmp[2] = base64_decode($tmp[2]);
					$tmp[3] = base64_decode($tmp[3]);
					$tmp[4] = base64_decode($tmp[4]);
					$tmp[5] = base64_decode($tmp[5]);
					$tmp[6] = base64_decode($tmp[6]);
					$tmp[7] = base64_decode($tmp[7]);

					print "name:		$tmp[0]\n";
					print "password:	$tmp[1]\n";

					print "</pre>";
				}

				$tmp[0] = base64_decode(ereg_replace("\n","",$tmp[0]));
				print "<pre>$tmp[0]</pre>";
				if ($tmp[0]=="@@loginusers@@") {
					print "Login user section<br>";
					$login = 1;
					$customer = 0;
					$settings = 0;
				}

				if ($tmp[0]=="@@settings@@") {
					print "Settings section<br>";
					$login = 0;
					$customer = 0;
					$settings = 1;
				}
				if ($tmp[0]=="@@customer@@") {
					print "Customersection<br>";
					$login = 0;
					$customer = 1;
					$settings = 0;
				}

//				for ($k=0;$k<sizeof($tmp);$k++) {
//					print base64_decode($tmp[$k]) . "<br>";
//				}


//				if (base64_decode($tpm[0]=="<loginusers>")) {
//					print "<br>- loginusers";
//				}
		}

		exit;
	} else {
		// Normal upload form
		$a = "<table>";
		$a .=  "<tr><td colspan=6><form method='POST' name='bla' ENCTYPE='multipart/form-data'>Import repository settings file<br><br><INPUT TYPE='hidden' name='MAX_FILE_SIZE' value='52428800'><INPUT TYPE='hidden' name='ImportSettings' value='1'>$lang[attachfile]: <br><INPUT NAME='userfile' TYPE='file'>&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(9)' class='topnav' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
		$a .= "<tr><td><input class='txt' type=submit name=sb value='Upload'></form></td></table>";
		printbox($a);
		print "</body></html>";
		exit;
	}
}

function ExportSettings() {

	include("config.inc.php");
	include("getset.php");
	require("auth3.inc.php");
	require("language.php");
/*
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `password` varchar(50) default NULL,
  `type` enum('normal','limited') NOT NULL default 'normal',
  `active` enum('yes','no') NOT NULL default 'yes',
  `exptime` varchar(40) NOT NULL default '',
  `noexp` enum('n','y') NOT NULL default 'n',
  `administrator` enum('yes','no') NOT NULL default 'no',
  `FULLNAME` varchar(150) NOT NULL default '',
  `EMAIL` varchar(150) NOT NULL default '',
  `CLLEVEL` varchar(50) NOT NULL default 'ro',
*/
	$sql = "SELECT * FROM ".CRM_LOGIN_USERS_TABLE."";
	$result= mcq($sql,$db);
	$export = "\n" . base64_encode("@@loginusers@@") . "\n";
	while ($r=mysql_fetch_array($result)){
		$export .=  base64_encode($r[name]) . "," . base64_encode($r[password]) . "," . base64_encode($r[type]) . "," . base64_encode($r[active]) . "," . base64_encode($r[exptime]) . "," . base64_encode($r[noexp]) . "," . base64_encode($r[administrator]) . "," . base64_encode($r[FULLNAME]) . "," . base64_encode($r[EMAIL]) . "," . base64_encode($r[CLLEVEL]) . "\n";
	}
	$export .=  base64_encode("@@/loginusers@@") . "\n";
	/*
  `id` int(11) NOT NULL auto_increment,
  `custname` varchar(200) NOT NULL default '',
  `contact` varchar(240) NOT NULL default '',
  `contact_title` varchar(240) NOT NULL default '',
  `contact_phone` varchar(15) NOT NULL default '',
  `contact_email` varchar(240) NOT NULL default '',
  `cust_address` longtext NOT NULL,
  `cust_remarks` longtext NOT NULL,
  `cust_homepage` varchar(240) NOT NULL default '',
	*/
	$sql = "SELECT * FROM ".CRM_CUSTOMER_TABLE."";
	$result= mcq($sql,$db);
	$export .=  base64_encode("@@customer@@") . "\n";
	while ($r=mysql_fetch_array($result)){
		$export .= base64_encode($r[custname]) . "," . base64_encode($r[contact]) . "," . base64_encode($r[contact_title]) . "," . base64_encode($r[contact_phone]) . "," . base64_encode($r[contact_email]) . "," . base64_encode($r[cust_address]) . "," . base64_encode($r[cust_remarks]) . "," . base64_encode($r[cust_homepage]) . "\n";
	}
	$export .=  base64_encode("@@/customer@@") . "\n";
/*
  `settingid` bigint(20) NOT NULL auto_increment,
  `setting` varchar(150) NOT NULL default '',
  `value` longtext NOT NULL,
  `datetime` timestamp(14) NOT NULL,
  `discription` varchar(250) NOT NULL default '',

*/
	$sql = "SELECT * FROM ".CRM_SETTINGS_TABLE."";
	$result= mcq($sql,$db);
	$export .=  base64_encode("@@settings@@") . "\n";
	while ($r=mysql_fetch_array($result)){
		$export .=  base64_encode($r[setting]) . "," . base64_encode($r[value]) . "," . base64_encode($r[discription]) . "\n";
	}
	$export .=  base64_encode("@@/settings@@") . "\n";

	header("Content-Type: text/plain");
	header("Content-Disposition: attachment; filename=settings" );
	header("Content-Description: CRM Generated Data" );
	header("Window-target: _top");

	print $export;

	exit;
}

function ViewJournal($VJ)
{
	global $EnableEntityJournaling, $logquery, $anyway;

	if (!$VJ) {
		// Show select box
		// but first, show nice stats

		$sql = "SELECT COUNT(*) AS bla FROM ".CRM_JOURNAL_TABLE."";
		$result= mcq($sql,$db);
		$r=mysql_fetch_array($result);

		print "<tr><td colspan=8>The journal contains $r[bla] entries.<br>&nbsp;</td></tr>";

		print "<tr><td colspan=8>Please enter the ID of the entity</td></tr>";
		print "<tr><td colspan=8><form name='fd' method='GET'><input type='hidden' name='ViewJournal' value='1'><input type='hidden' name='password' value='$password'>";
		print "<input type='text' size=3 name='VJ'>&nbsp;&nbsp;<input type='submit' name='knopje' value='View journal by eID'></form></td></tr>";
		print "<tr><td colspan=8><hr>Search in all journal entries:<br><form name='nm' method='GET'><input type='hidden' name='ViewJournal' value='1'><input type='hidden' name='password' value='$password'><input type='text' name='logquery' value='" . $logquery . "'>&nbsp;&nbsp;<input type='submit'></form>";
		print "<tr><td colspan=8></td></tr>";
		print "<tr><td colspan=8><hr>Select the entity in the drop-down box:</td></tr>";
		print "<tr><td colspan=8><form name='fd' method='GET'><input type='hidden' name='ViewJournal' value='1'><input type='hidden' name='password' value='$password'>";
		print "<select name='VJ'>";
		$sql = "SELECT category,eid,CRMcustomer FROM ".CRM_ENTITY_TABLE." ORDER BY eid";
		$result= mcq($sql,$db);
		while ($r=mysql_fetch_array($result)){
			print "<option value='$r[eid]'>$r[eid]:" . GetCustomerName($r[CRMcustomer]) . ":$r[category]</option>";
		}
		print "</select>";
		print "<br><br><input type='submit' name='knopje' value='View journal by dropdown box'></form></td></tr>";

		print "</table></body></html>";



	} else {
		// EID is in $VJ
		// First check if this is legal

		$eid = $VJ;

		if (strtoupper($EnableEntityJournaling)<>"YES") {
			print "<tr><td><img src='error.gif'>&nbsp;<font face='Trebuchet MS'>Error! Journaling is disabled.</font></td></tr>";
			uselogger("Illegal attempt to access entity journal #$eid (journaling is disabled)","");
			print "</body></html>";
			exit;
		}

		print "<font face='Trebuchet MS'>Journal for entity #$eid</font><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&joepie=1' style='cursor:hand'>Back to main administration page</a>&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&ViewJournal=1' style='cursor:hand'>back to journal page</a><br><TABLE CELLPADDING='2' CELLSPACING='4' BORDER='0' WIDTH='100%'><TR VALIGN=TOP><TD VALIGN=TOP><font face='Courier New' size='2'><b>Time</TD><TD VALIGN='top'><font face='Courier New' size='2'><b>User</TD><TD><font face='Courier New' size='2'><b>Action</TD></TR>";
		print "<tr><td colspan=3></td></tr>";
		$sql = "SELECT user,message,date_format(timestamp, '%a %M %e, %Y %H:%i') AS ts FROM ".CRM_JOURNAL_TABLE." WHERE eid='$eid' ORDER BY timestamp DESC";
		$result= mcq($sql,$db);
		while ($jn= mysql_fetch_array($result)) {
			print "<tr><td VALIGN='top'><font face='Courier New' size='2'>" . $jn[ts] . "</font></td><td VALIGN='top'><font face='Courier New' size='2'>" . GetUserName($jn[user]) . "</font></td><td><font face='Courier New' size='2'>" . ereg_replace("\n","<BR>",$jn[message]) . "</font></td></tr>";
			print "<tr><td colspan=3></td></tr>";
		}


	}
	if ($logquery) {
			print "<table border=1 width='100%' cellpadding=4 cellspacing=4>";

			$sql = "SELECT * FROM ".CRM_JOURNAL_TABLE." WHERE message LIKE '%" . $logquery . "%'";

			$result= mcq($sql,$db);

			print "<tr><td>id</td><td>eid</td><td>msg</td><td>timestamp</td><td>user</td><td>type</td></tr>";

			while ($row = mysql_fetch_array($result)) {
				$tp .= "<td>" . $row[0] . "</td><td>" . $row[1] . "</td><td><pre>" . $row[4] . "</pre></td><td>" . $row[2] . "</td><td NOWRAP>" . GetUserName($row[user]) . "</td><td NOWRAP>" . $row[5] . "</td><td NOWRAP>" . $row[6] . "</td></tr>\n";
				$ltp++;
			}
			if ($ltp<1000 || $anyway) {
				if ($tp<>"") {
					print $tp;
					print "<tr><td colspan=6>" . $ltp . " results</td></tr>";
				} else {
					print "<tr><td>No results.</td></tr>";
				}
			} else {
				print "<tr><td><img src='error.gif'>&nbsp;More than 1,000 results ($ltp) Please refine your query. <img src='arrow.gif'>&nbsp;<a href='admin.php?logquery=" . $logquery . "&anyway=1&warnings=$warnings&ViewJournal=1&password=" . $password . "' class='bigsort'>execute anyway</a></td></tr>";
			}
			print "</table>";
	}

print "</body></html>";
exit;

}
function AdvQuery() {
	global $lang,$advquery,$what,$action,$newval,$custfields,$oldval,$do_query,$direct_query,$Disable_direct,$method,$name;

	MustBeAdmin();

	if ($direct_query) {
		if (!$Disable_direct) {
			if ($direct_query=="Please, please, please be careful") {
				print "<tr><td>Hey! Don't play around with this kind of functions!</td></tr>";
			} else {
				if (stristr($direct_query,"delete ") || stristr($direct_query,"truncate") || stristr($direct_query,"drop") ) {
					print "<tr><td><img src='error.gif'> Illegal (you cannot use DELETE, TRUNCATE and DROP)</td></tr>";

				} else {
					print "<tr><td>OK, executing your query.</td></tr></table></table></table>";
					$result=mcq(stripslashes($direct_query),$db);
					if ($method=='table') {
						print "<table width='100%' border=1>";
					} elseif ($method=='CSV') {
						print "<pre>";
					}
					if (stristr($direct_query,"select") || stristr($direct_query,"show")) {
						while ($jn= mysql_fetch_array($result)) {
								if ($method=='table') {
										print "<tr>";
										for ($x=0;$x<sizeof($jn);$x++) {
											print "<td><pre>" . htmlspecialchars($jn[$x]) . "</pre>&nbsp;</td>";
										}
										print "</tr>";
								} elseif ($method=='CSV') {
										for ($x=0;$x<sizeof($jn);$x++) {
											print eregi_replace("\015\012","",eregi_replace("<br>","",ereg_replace("\n","",($jn[$x])))) . ";";
										}
										print "\n";
								}
						}
					}
					print "<table>";
					print "<tr><td>Query executed</td></tr>";
					print "<tr><td>" . mysql_affected_rows() . " affected records.</td></tr>";
				}
			}
		} else {
				print "<tr><td><img src='error.gif'> Disabled</td></tr>";
		}
	}

	if ($advquery==1) {
		print "<tr><td><fieldset><legend>CRM Advanced Query Interface&nbsp;</legend><table>";

		print "<tr><td>Advanced query step 1 - select what you want to do:</td></tr>";
		print "<tr><td><form name='adv' method='post'>";
		print "<select name='action'><option>Update</option><option>Delete</option></select>";
		print "<select name='what'><option value='customers'>$lang[customers]</option><option value='entities'>$lang[entities]</option></select>";
		print "<input type='hidden' value='next1' name='advquery'>";
		print "&nbsp;<input type='submit' name='1' value='Go to step 2'>";
		print "</form></td></tr></fieldset></td></tr></table>";
		print "<tr><td></td></tr>";
		print <<< WHATEVER
				<SCRIPT LANGUAGE="JavaScript">
				<!--
				function confbla() {
					if (confirm('Does your system admin know you\'re doing this?')) {
						if (confirm('OK, so, are your sure?')) {
									if (confirm('Really?')) {
										alert('OK, suit yourself. Click OK to execute...');
										document.DirectQuery.submit();
									}
						}
					}
				}
				//-->
				</SCRIPT>
WHATEVER;
		print "<tr><td><fieldset><legend>Execute an SQL query directly (be careful!)&nbsp;</legend><table>";
		print "<tr><td><form name='DirectQuery' OnSubmit='javascript:confbla();'><input type='text' size='100' name='direct_query' value='Please, please, please be careful'></td></tr>";
		print "<input type='hidden' value='HoelaHoeps' name='advquery'>";
		print "<table><tr><td>CSV:</td><td><input class='radio' type='radio' name ='method' value='CSV'></td></tr>";
		print "<tr><td>Table</td><td><input class='radio' type='radio' name ='method' value='table' CHECKED></td></tr></table>";
		print "<tr><td><input type='submit' name='1' value='Execute (be sure - no confirmation behind this button!)'></td></tr>";
		print "</table></fieldset></td></tr>";

	} elseif ($advquery=="next1") {
		print "<tr><td>Advanced query step 2 - select the concering fields:</td></tr>";
		print "<tr><td><form name='adv' method='post'><br><br>";

		if ($action=='Delete') {
			print "Delete&nbsp;&nbsp;";
			print "<input type='hidden' name='action' value='Delete'>";
		} elseif ($action=='Update') {
			print "Update&nbsp;&nbsp;";
			print "<input type='hidden' name='action' value='Update'>";
		}
		if ($what=='customers') {
			print $lang[customers] ."&nbsp;&nbsp;";
			print "<input type='hidden' name='what' value='customers'>";
		} elseif ($what=='entities') {
			print $lang[entities] ."&nbsp;&nbsp;";
			print "<input type='hidden' name='what' value='entities'>";
		}
		if ($action=='Delete') {

			if ($what=='customers') {

					print "<br><br><img src='error.gif'>&nbsp; Illegal combination. To delete customers, please set customers to active='no' using the update function";

				} elseif ($what=='entities') {
				print <<<BLA
				<br><br>where the field<br><br>
				<select name='custfields'>
				<option>category
				<option>status
				<option>priority
				<option value='owner'>owner (use numbers, not names - see below!)</option>
				<option value='assignee'>assignee (use numbers, not names - see below!)</option>
				<option value='CRMcustomer'>customer (use numbers, not names - see below!)</option>
				<option value='deleted'>deleted (only y or n)</option>
				<option value='duedate'>duedate (DD-MM-YYYY)</option>
				<option value='obsolete'>obsolete (only y or n)</option>
				<option value='waiting'>waiting (only y or n)</option>
				<option value='readonly'>readonly (only y or n)</option>
				</select>
				<input type='hidden' value='what' name='entities'>
				<input type='hidden' value='action' name='Delete'>
				<br><br>&nbsp;&nbsp;contains the value&nbsp;&nbsp;<br><br>
				<input type='text' name='oldval' size='50'>
				<br><br>
				<input type='hidden' value='next2' name='advquery'>
				<input type='submit' name='bla' value='Go to step 3'>
				</form>
BLA;
				print "</td></tr></table>";
				print "<br><br><table border=1 bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'><tr><td colspan=2>$lang[customers]</td><td colspan=2>People</td></tr>";
				print "<tr><td>Number</td><td>Name</td><td>Number</td><td>Name</td></tr>";

				$sql1 = "SELECT id,custname FROM ".CRM_CUSTOMER_TABLE."";
				$result= mcq($sql1,$db);
				$custs=array();
				while ($bla= mysql_fetch_array($result)) {
						array_push($custs,"<td>$bla[0]</td><td>$bla[1]</td>");
				}
				$lus = array();
				$sql2 = "SELECT id,FULLNAME FROM ".CRM_LOGIN_USERS_TABLE."";
				$result= mcq($sql2,$db);
				while ($bla= mysql_fetch_array($result)) {
						array_push($lus,"<td>$bla[0]</td><td>$bla[1]</td>");
				}

				for ($x=0;$x<(sizeof($custs)+sizeof($lus));$x++) {
						print "<tr>" . $custs[$x]  .  $lus[$x] . "</tr>";
				}


				}

		} // end if delete
		if ($action=='Update') {
				print "<br><br><b>set</b><br><br>";
			if ($what=='customers') {

				print <<<EOT
				<select name='custfields'>
				<option>contact
				<option>contact_title
				<option>contact_phone
				<option>contact_email
				<option>cust_address
				<option>cust_remarks
				<option>cust_homepage
				<option value='active'>active (only yes or no)</option>
				</select>
				<br><br>&nbsp;&nbsp;to value&nbsp;&nbsp;<br><br>
				<input type='text' name='newval' size='50'>
				<br><br>&nbsp;&nbsp;where the value currently is &nbsp;&nbsp;<br><br>
				<input type='text' name='oldval' size='50'>
					<br><br>
				<input type='hidden' value='next2' name='advquery'>
				<input type='submit' name='bla' value='Go to step 3'>
				</form>

EOT;


				} elseif ($what=='entities') {
				print <<<BLA
				<select name='custfields'>
				<option>category
				<option>status
				<option>priority
				<option value='owner'>owner (use numbers, not names - see below!)</option>
				<option value='assignee'>assignee (use numbers, not names - see below!)</option>
				<option value='CRMcustomer'>customer (use numbers, not names - see below!)</option>
				<option value='deleted'>deleted (only y or n)</option>
				<option value='duedate'>duedate (DD-MM-YYYY)</option>
				<option value='obsolete'>obsolete (only y or n)</option>
				<option value='waiting'>waiting (only y or n)</option>
				<option value='readonly'>readonly (only y or n)</option>
				</select>
				<br><br>&nbsp;&nbsp;to value&nbsp;&nbsp;<br><br>
				<input type='text' name='newval' size='50'>
				<br><br>&nbsp;&nbsp;where the value currently is &nbsp;&nbsp;<br><br>
				<input type='text' name='oldval' size='50'>
				<br><br>
				<input type='hidden' value='next2' name='advquery'>
				<input type='submit' name='bla' value='Go to step 3'>
				</form>
BLA;
				print "</td></tr></table>";
				print "<br><br><table border=1 bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'><tr><td colspan=2>$lang[customers]</td><td colspan=2>People</td></tr>";
				print "<tr><td>Number</td><td>Name</td><td>Number</td><td>Name</td></tr>";

				$sql1 = "SELECT id,custname FROM ".CRM_CUSTOMER_TABLE."";
				$result= mcq($sql1,$db);
				$custs=array();
				while ($bla= mysql_fetch_array($result)) {
						array_push($custs,"<td>$bla[0]</td><td>$bla[1]</td>");
				}
				$lus = array();
				$sql2 = "SELECT id,FULLNAME FROM ".CRM_LOGIN_USERS_TABLE."";
				$result= mcq($sql2,$db);
				while ($bla= mysql_fetch_array($result)) {
						array_push($lus,"<td>$bla[0]</td><td>$bla[1]</td>");
				}

				for ($x=0;$x<(sizeof($custs)+sizeof($lus));$x++) {
						print "<tr>" . $custs[$x]  .  $lus[$x] . "</tr>";
				}


				}
			}
		}

		if ($advquery=='next2') {
			print "<tr><td>Advanced query step 3 - Check your query</td></tr>";
			print "<tr><td><form name='adv' method='post'>";

			if ($action=='Update') {
				if ($what=='customers') {
					$sql_to_query = "UPDATE ".CRM_CUSTOMER_TABLE." SET $custfields='$newval' WHERE $custfields='$oldval'";
					print "<pre>" . $sql_to_query . "</pre>";
					print "<input type='hidden' name='do_query' value='" . base64_encode($sql_to_query) . "'>";
					print "<input type='submit' name='1' value='Execute my query'><br><br>";
					print "<input type='hidden' value='execute' name='advquery'>";
					$sql = "SELECT COUNT(*) FROM ".CRM_CUSTOMER_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					$bla= mysql_fetch_array($result);
					print "This query will affect the following $bla[0] records:<br>";
					$sql = "SELECT custname,$custfields FROM ".CRM_CUSTOMER_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					print "<table border=1 cellpadding=4 cellspacing=4><tr><td>-</td><td>$lang[customer]</td><td>$custfields</td></tr>";
					while ($bla= mysql_fetch_array($result)) {
						print "<tr><td>" . $lang[customer] . "</td><td>" . $bla[0] . "</td><td>" . $bla[1] . "</td></tr>";
					}
					print "</table></form>";
				} elseif ($what=='entities') {
					$sql_to_query = "UPDATE ".CRM_ENTITY_TABLE." SET $custfields='$newval' WHERE $custfields='$oldval'";
					print "<pre>" . $sql_to_query . "</pre>";
					print "<input type='hidden' name='do_query' value='" . base64_encode($sql_to_query) . "'>";
					print "<input type='submit' name='1' value='Execute my query'><br><br>";
					print "<input type='hidden' value='execute' name='advquery'>";
					$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					$bla= mysql_fetch_array($result);
					print "This query will affect the following $bla[0] records:<br>";
					$sql = "SELECT eid,$custfields FROM ".CRM_ENTITY_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					print "<table border=1 cellpadding=4 cellspacing=4><tr><td>-</td><td>$lang[customer]</td><td>$custfields</td></tr>";
					while ($bla= mysql_fetch_array($result)) {
						print "<tr><td>" . $lang[customer] . "</td><td>" . $bla[0] . "</td><td>" . $bla[1] . "</td></tr>";
					}
					print "</table></form>";
				}
			} elseif ($action=='Delete') {
				if ($what=='entities') {
					$sql_to_query = "UPDATE ".CRM_ENTITY_TABLE." SET deleted='y' WHERE $custfields='$oldval'";
					print "<pre>" . $sql_to_query . "</pre>";
					print "<input type='hidden' name='do_query' value='" . base64_encode($sql_to_query) . "'>";
					print "<input type='submit' name='1' value='Execute my query'><br><br>";
					print "<input type='hidden' value='execute' name='advquery'>";
					$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					$bla= mysql_fetch_array($result);
					print "This query will affect the following $bla[0] records:<br>";
					$sql = "SELECT eid,category,$custfields FROM ".CRM_ENTITY_TABLE." WHERE $custfields='$oldval'";
					$result= mcq($sql,$db);
					print "<table border=1 cellpadding=4 cellspacing=4><tr><td>-</td><td>$lang[customer]</td><td>$lang[category]</td><td>$custfields</td></tr>";
					while ($bla= mysql_fetch_array($result)) {
						print "<tr><td>" . $lang[customer] . "</td><td>" . $bla[0] . "</td><td>" . $bla[1] . "</td><td>" . $bla[2] . "</td></tr>";
					}
					print "</table></form>";
				}
			}

		}
		if ($advquery=="execute") {
			print "<tr><td>Advanced query executed</td></tr>";
			mcq(base64_decode($do_query),$db);
			print "<tr><td>" . mysql_affected_rows() . " affected records.</td></tr>";
		}

	print "</table><br><table><tr><td nowrap><img src='arrow.gif'>&nbsp;<a href='admin.php?advquery=1' class='bigsort'>Create query from start</a></td></tr><tr><td nowrap><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?1&6' style='cursor:hand'>Back to main administration page</a></td></tr></table></body></html>";
	exit;
}

function MustBeAdmin() {
	if (!is_administrator($GLOBALS['USERID'])) {
		PrintAdminError();
		EndHTML();
		exit;
		// Yes, i know this is dirty.
	}
}
function MustBeAdminUser() {
	if (!is_administrator($GLOBALS['USERID'])) {

		print "<table><tr><td><img src='error.gif'>&nbsp;Access denied (disabled by administrator)</td></tr></table>";

		EndHTML();
		exit;
		// Yes, i know this is dirty.
	}
}

function PrintAdminError() {
			print "<td><img src='error.gif'>&nbsp;&nbsp;This section can only be accessed by user who have administrator rights set to their <b>user profile</b>.Only entering the correct password is not enough. Please contact your system administrator.<br><br></td></tr>";
			print "<tr><td><img src='arrow.gif'>&nbsp;<a class='bigsort' href='javascript:history.back(1);' style='cursor:hand'>Back to main administration page</a></td></tr>";
			print "</table>";
}
function pushentity($eid) {
    $sql= "SELECT * FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".owner AND deleted='y' AND eid='$eid' ORDER BY sqldate,status,priority";
    $result= mcq($sql,$db);

    while ($e= mysql_fetch_array($result)) {
      $tot++;
	  print "<tr><td>$e[custname]</td><td>$e[name]</td><td>";

	$sql1 = "SELECT name FROM ".CRM_USERS_TABLE." WHERE id='$e[assignee]'";
	$rult= mcq($sql1,$db);
	$e1= mysql_fetch_array($rult);

	print "$e1[name]</td>";

	if ($e[status]=='close') {
	print "<td bgcolor='FF3300'>";
	} elseif ($e[status]=='open') {
	print "<td bgcolor='#33FF00'>";
	} else {
	print "<td bgcolor='#3300FF'>";
	}


	print "$e[status]</td>";

     if ($e[priority]=="critical") {
              print "<td bgcolor='#FFFF00'><font color='#FF0000'>";
	    } elseif ($e[priority]=="high") {
	    print "<td bgcolor='#FFFF66'>";
	    } elseif ($e[priority]=="medium") {
	    print "<td bgcolor='#FFFF99'>";

	      } else {
	          print "<td bgcolor='#FFFFCC'>";
	}




	print "$e[priority]</td><td><b>$e[category]</b></td>";

	 if ($e[duedate]==$date) {
					$tmp="</font>";
					print "<td><font color='FF3300' width='70'>";
				}
				elseif ($e[sqldate]<$sqldate) {
		            $tmp="</u></font>";
					print "<td><font color='FF3300' width='70'><u>";
				}
				else
				{
					print "<td width='70'>";
				}
	if ($e[duedate]=="") {
			$e[duedate] = "<font color='FF3300'>none</font>";
	}
	print "$e[duedate]$tmp</td>";

	$sql3 = "SELECT basicdate FROM ".CRM_CALENDAR_TABLE." WHERE eID='$e[eid]'";
	$rult2= mcq($sql3,$db);
	if ($e5= mysql_fetch_array($rult2)) {
			$e5[basicdate] = substr($e5[basicdate],0,2) . "-" . substr($e5[basicdate],2,2) . "-" . substr($e5[basicdate],4,4);
			print "<td width='70'>$e5[basicdate]</td>";
	} else {
			print "<td><font color='FF3300'>none</font></td>";
	}



	print "</tr>";
	    $cont = ereg_replace("\n","<BR>",$e[content]);
	    print "<tr><td colspan=12><table border='1' width='100%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='8' bordercolor='#CECECE'><tr><td>$cont</td></tr></table>";
	}
return($tot);
}



function usermanager($user_to_edit)
{
	global $password,$userman,$accname,$accpass1,$accpass2,$type,$delete,$admini,$lang,$FULLNAME,$EMAIL,$CLLEVEL,$name,$EnableCustInsert,$administrator,$active,$dailymail;
	uselogger("User manager started","");
	$sql = "SELECT administrator FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $name . "'";
	$result= mcq($sql,$db);
	$CRMuser= mysql_fetch_array($result);

	$administrator = $CRMuser[administrator];



	if (!$user_to_edit) {
//			print "&nbsp;<br>";


//    UPDATE person SET password= encrypt('$newpassword1','$selectedusername') WHERE username='$selectedusername'";
			print "<tr><td><fieldset><legend>$lang[addaccount]&nbsp;</legend><table><tr><td><form name=adduser method=POST></td></tr>";
			print "<tr><td>$lang[name]:</td><td><input type='text' name='newuser'></td></tr>";
			print "<tr><td>$lang[password]:</td><td><input type='password' name='newpassword'></td></tr>";
			print "<tr><td>$lang[password]:</td><td><input type='password' name='newpasswordconfirm'></td></tr>";
			print "<tr><td></td><td><input type='hidden' name='password' value='$password'></td></tr>";



			print "<tr><td>Full name:</td><td><input size=50 type='text' name='FULLNAME' value='$result[FULLNAME]'></td></tr>";
			print "<tr><td>Daily " . $lang['briefover'] . " e-mail:</td><td><select name='dailymail'><option value='No'>No</option><option value='Yes' " . $ins . ">Yes</option></select></td></tr>";
			print "<tr><td>E-mail:</td><td><input type='text' size=50 name='EMAIL' value='$result[EMAIL]'></td></tr>";
			print "<tr><td nowrap>Clearance level:</td><td>";


			print "<select name='CLLEVEL'>";
			if ($result["CLLEVEL"]=="rw") {
				$a = "SELECTED";
			} else {
				unset($a);
			}

			print "<option $a value='rw'>Full access to all entities</option>";

			if ($result["CLLEVEL"]=="ro") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option value='ro' $a>Insert-only $lang[customer]-user unable to read contents of added entities</option>";
			if ($result["CLLEVEL"]=="ro+") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option value='ro+' $a>Insert-only $lang[customer]-user able to read contents of added entities</option>";


			if ($result["CLLEVEL"]=="ooro") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='ooro'>Read-only own-assigned entities</option>";

			if ($result["CLLEVEL"]=="read-only-all") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='read-only-all'>Read-only all entities</option>";

			if ($result["CLLEVEL"]=="full-access-own-entities") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='full-access-own-entities'>Full access though only edit own assigned entities</option>";



			if ($administrator=="yes" || $administrator=="Yes") { // Only print this option when the current user is an administrator
					if ($result["administrator"]=="Yes") {
						$a = "SELECTED";
					} else {
						unset($a);
					}
					print "<option $a value='administrator'>Administrator</option>";
			}
			print "</select>";
			print "</td></tr>";


			print "<tr><td colspan=2><input type=submit name=bla value='$lang[addu]'></form></td></tr></table></fieldset></td></tr>";
			print "<tr><td colspan=2><table border=0 width='100%'><tr><td colspan=2><fieldset><legend>$lang[editaccount]&nbsp;</legend><table border='0' width='100%' cellspacing='0' cellpadding='4'>";
			print "<tr><td><form name='selectuser' method=post></td></tr><tr><td><select name='user_to_edit'>";
			$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE active='yes' ORDER BY name";
					$result= mcq($sql,$db);

							while ($CRMUusersArray= mysql_fetch_array($result)) {
							if ($CRMUusersArray[id]==$ea[owner]) {
											$a = "SELECTED";
							} else {
											$a = "";
							}
						if (stristr($CRMUusersArray[FULLNAME],"@@@")) { $joepie=1; }
						$CRMUusersArray[FULLNAME] = ereg_replace("@@@",$lang[customer],$CRMUusersArray[FULLNAME]);
					if (trim($CRMUusersArray[FULLNAME])== "" && $joepie) {
						$CRMUusersArray[FULLNAME]="disabled";
					} elseif (trim($CRMUusersArray[FULLNAME])== "") {
						$CRMUusersArray[FULLNAME]="uncoupled/disabled";
					}
						print "<option value='$CRMUusersArray[id]' size='1' $a>$CRMUusersArray[name] [$CRMUusersArray[FULLNAME]]</option>";
					}
			print "</select>&nbsp;<input type='submit' value='Select'></td></tr></table></fieldset></td></tr></table>";
			print "<input type='hidden' name='password' value='$password'>";
			print "<input type='hidden' name='userman' value='1'>";
			print "<tr><td>";
			print "</form></td></tr>";
			print "<tr><td colspan=4></td></tr>";

			print "<tr><td><fieldset><legend>Options&nbsp;</legend>";
			print "<img src='arrow.gif'>&nbsp;<a href='admin.php?ExportUsers=1' class='bigsort'> Export  accounts</a><br>";
			print "<img src='arrow.gif'>&nbsp;<a href='admin.php?ImportUsers=1' class='bigsort'> Import accounts</a><br>";
			print "<img src='arrow.gif' style=border:0> <a href='admin.php?SuperListUsers=1' class='bigsort'>&nbsp;User activity statistics</a> <IMG SRC='graph.gif' style=border:0></fieldset>";
			print "</td></tr>";
			print "<tr><td colspan=2><br><img src='arrow.gif'>&nbsp;<a href='admin.php?password=$password' class='bigsort'>$lang[btmap]</a></td></tr>";

			print "</table></body></html>";

	} elseif ($userman=='1') {

		$sql= "SELECT * FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$user_to_edit'";
		if ($debug) { print "\nSQL: $sql\n"; }
		$result= mcq($sql,$db);
		$result= mysql_fetch_array($result);

		if ($administrator<>"yes" && $result[administrator] == "yes") {
			print "<td><img src='error.gif'>&nbsp;&nbsp;You can not edit this user because this user is an administrator, and you are not.<br><br></td></tr>";
			print "<tr><td><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?userman=1&password=$password' style='cursor:hand'>back to user management page</a></td></tr>";
			print "</body></html>";
			uselogger("Edit user $user_to_edit denied","");
			exit;
		} else {
			uselogger("Edit user $user_to_edit","");
		}
	    print "<tr><td><form name='updacc' action='admin.php' method='POST'></td></tr>";

		if ($result[CLLEVEL]=="ro" && !$EnableCustInsert=="yes" && !$EnableCustInsert=="Yes") {
			print "<TR><TD><b><font color='#FF0000'>Warning: The customer insert subsystem is disabled! This user will see an error when trying to log in.<br>Enable System value 'EnableCustInsert' to enable this subsystem.</font></b></TD></TR>";
		}


		if ($result[type]=='normal') {
		    $in1 = "CHECKED";
		} else {
		    $in2 = "CHECKED";
		}
		if ($result[administrator]=='yes') {
		    $in3 = "CHECKED";
		} else {
		    $in4 = "CHECKED";
		}
		if ($result[active]=='yes') {
		    $in5 = "CHECKED";
		} else {
		    $in6 = "CHECKED";
		}

		print "<table border='0' width='90%'><tr><td><fieldset><legend>" . str_replace("@@@:","",GetUserName($user_to_edit)) . "&nbsp;</legend><table>";
		print "<TR><TD><a href='javascript:popUserActivityGraph(". $user_to_edit . ")' class='bigsort'><IMG SRC='graph.gif' style=border:0></a></TD></TR>";
		print "<tr><td nowrap>Account $lang[name]:</td><td><input type='text' name='bla' value='$result[name]' DISABLED></td></tr>";
		print "<tr><td nowrap>Account $lang[password]: <br>($lang[passwarn])</td><td><input type='password' name='accpass1' value=''></td></tr>";
		print "<tr><td nowrap>Account $lang[password]:</td><td><input type='password' name='accpass2' value=''></td></tr>";

		if ($result[CLLEVEL]=="ro" || $result[CLLEVEL]=="ro+") {
			print "<tr><td nowrap>Coupled $lang[customer]:</td><td>";
			print "<select name='FULLNAME'>";
			print "<option value=''> - </option>";
			$sql = "SELECT id, custname FROM ".CRM_CUSTOMER_TABLE." ORDER BY custname";
			$res = mcq($sql,$db);
			while ($bla = mysql_fetch_array($res)) {
					$bla1 = split(":",$result[FULLNAME]);
					$bla2 = trim($bla1[1]);

					if ($bla2==$bla[id]) {
						$t = "SELECTED";
						$ok=1;
					} else {
						unset($t);
					}
					print "<option value='@@@:$bla[id]:$bla[custname]' $t>$bla[custname]</option>";
				}


			print "</select>";
			if (!$ok==1) {
					?>
					<SCRIPT LANGUAGE="JavaScript">
					<!--
						document.updacc.FULLNAME.style.background='#FF6666';
					//-->
					</SCRIPT>
					<?php
					print "Un-coupled accounts are disabled!";
			}
			print "</td></tr>";
			print "<tr><td nowrap>When a new entity is added, send an email to:</td><td><input type='text' size=50 name='EMAIL' value='$result[EMAIL]'></td></tr>";
		} else {

			print "<tr><td nowrap>Full name:</td><td><input size=50 type='text' name='FULLNAME' value='$result[FULLNAME]'></td></tr>";
			print "<tr><td>E-mail:</td><td><input type='text' size=50 name='EMAIL' value='$result[EMAIL]'></td></tr>";
		}

		if ($result['RECEIVEDAILYMAIL']=="Yes") {
			$ins = "SELECTED";
		}
		print "<tr><td>Daily " . $lang['briefover'] . " e-mail:</td><td><select name='dailymail'><option value='No'>No</option><option value='Yes' " . $ins . ">Yes</option></select></td></tr>";
		print "<tr><td nowrap>Clearance level:</td><td>";

		if ($result["administrator"]=="yes" && $administrator<>"yes") {
			print "<select name='CLLEVEL' DISABLED>";
		} else {
			print "<select name='CLLEVEL'>";
		}

			if ($result["CLLEVEL"]=="rw") {
				$a = "SELECTED";
			} else {
				unset($a);
			}


			print "<option $a value='rw'>Full access to all entities</option>";

			if ($result["CLLEVEL"]=="ro") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option value='ro' $a>Insert-only $lang[customer]-user unable to read contents of added entities</option>";
			if ($result["CLLEVEL"]=="ro+") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option value='ro+' $a>Insert-only $lang[customer]-user able to read contents of added entities</option>";

			if ($result["CLLEVEL"]=="ooro") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='ooro'>Read-only own-assigned entities</option>";

			if ($result["CLLEVEL"]=="read-only-all") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='read-only-all'>Read-only all entities</option>";

			if ($result["CLLEVEL"]=="full-access-own-entities") {
				$a = "SELECTED";
			} else {
				unset($a);
			}
			print "<option $a value='full-access-own-entities'>Full access though only edit own assigned entities</option>";


			// This is the edit user section, not the add user section

			if ($administrator=="yes") { // Only print this option when the current user is an administrator
					if ($result["administrator"]=="yes") {
						$a = "SELECTED";
					} else {
						unset($a);
					}
					print "<option $a value='administrator'>Administrator</option>";
			} elseif ($administrator<>"yes" && $result["administrator"]=="yes") {
					print "<option SELECTED value='administrator'>Administrator</option>";
			}

			print "</select>";
			print "</td></tr></table></fieldset></td></tr>";
			print "<tr><td colspan=2>";
			print "<input type='hidden' name='password' value='$password'>";
			print "<input type='hidden' name='userman' value='2'>";
			print "<input type='hidden' name='accname' value='$result[name]'>";
			print "<input type='hidden' name='user_to_edit' value='$user_to_edit'>";
			print "<br><input type='submit' name='a' value='$lang[apply]'>&nbsp;&nbsp;";
			print "<input type='submit' name='delete' value='$lang[dta]'>&nbsp;&nbsp;";
			print "<input type='button' name='cancel' value='Back' OnClick=\"javascript:document.location='admin.php?userman=1&password=$password';\">";
			print "</form></td></tr>";

			print "</table></body></html>";
	} elseif ($userman=='2') {
		if ($delete) {
		    print "<tr><td>Account $user_to_edit $lang[wasdeleted]!<br><br></td></tr>";

			$epoch = date("U");

			$sql= "SELECT name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$user_to_edit'";
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);


			// we must not delete somebody physical!
			// $sql= "DELETE FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$user_to_edit'";

			$sql = "UPDATE ".CRM_LOGIN_USERS_TABLE." SET active='no',name='deleted_user_" . $epoch ."_" . $result1[name] . "' WHERE id='$user_to_edit'";

			if ($debug) { print "\nSQL: $sql\n"; }
			$result= mcq($sql,$db);
			unset($user_to_edit);
			uselogger("ACCOUNT DISABLED - $result1[name]","ACCOUNT DISABLED - $result1[name]");
			usermanager("");
			exit;
		}
		if ($accpass1!=$accpass2) {
		    print "<tr><td>$lang[passmatcherror]</td></tr>";
			print "</table></body></html>";
			exit;
		}

			$sql= "SELECT name FROM ".CRM_LOGIN_USERS_TABLE." WHERE id='$user_to_edit'";
			$result= mcq($sql,$db);
			$result1= mysql_fetch_array($result);


			if ($accpass1!="") {
				uselogger("ACCOUNT ADJUSTED - $result1[name] - password changed","ACCOUNT ADJUSTED - $result1[name] - password changed");
				$pwd = "password=PASSWORD('$accpass1'),";
			} else {
				unset($pwd);
			}
			if ($CLLEVEL=="administrator") {
						$CLLEVEL = "rw";
						$ADMIN = "Yes";
				}
			if ($CLLEVEL<>"ro" && $CLLEVEL<>"ro+" && stristr($FULLNAME,"@@@")) { $FULLNAME=$accname; }

			$sql= "UPDATE ".CRM_LOGIN_USERS_TABLE." SET name='$accname',$pwd type='$type',administrator='$ADMIN', CLLEVEL='$CLLEVEL', EMAIL='$EMAIL', FULLNAME='$FULLNAME',active='yes',RECEIVEDAILYMAIL='" . $dailymail . "' WHERE id='$user_to_edit'";




		$result= mcq($sql,$db);
		if ($debug) { print "\nSQL: $sql\n"; }
		print "<tr><td>$lang[tawu].</td></tr>";
		//unset($user_to_edit);
		$userman=1;
		usermanager($user_to_edit);



	}

} // end func

function StatusVars() {
			global $statusvar, $colsubmitted, $var_id, $varcolor, $varname, $oldvarname, $isnew, $deletestatusvar, $password, $legend, $printbox_size;
			if ($deletestatusvar) {
						$deletestatusvar = base64_decode($deletestatusvar);
						$sql = "DELETE FROM ".CRM_STATUS_VARS_TABLE." WHERE id='$deletestatusvar'";
						mcq($sql,$db);
						uselogger("Status var $deletestatusvar deleted","");
			}
			if ($colsubmitted) {
				if ($isnew) {
						$sql = "INSERT INTO ".CRM_STATUS_VARS_TABLE."(varname,color) VALUES('$varname','$varcolor')";
						mcq($sql,$db);
						$added=1;
						uselogger("Status var $varname added","");
				}
				if (!$added) {
					if ($varname!=$oldvarname) {
							$sql = "UPDATE ".CRM_ENTITY_TABLE." SET status='$varname' WHERE status='$oldvarname'";
							mcq($sql,$db);
							$add = "All entities with status '$oldvarname' were updated to status '$varname'.";
					}
					$sql = "UPDATE ".CRM_STATUS_VARS_TABLE." SET varname='$varname',color='$varcolor' WHERE id='$var_id'";
					//print $sql;
					mcq($sql,$db);
				}
			//	print "<tr><td>Saving $varname with color $varcolor. $add</td></tr>";
				uselogger("Saving $varname with color $varcolor. $add","");
			}

			$printbox_size = "100%";

			if (!$statusvar) {
				$sql = "SELECT varname,id,color FROM ".CRM_STATUS_VARS_TABLE." ORDER BY varname";
				$result= mcq($sql,$db);
				//$a = "<table border='1' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
				$a = "Please choose the status variable you want to edit or delete:<br><br><center><table border='1' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
				while ($result1= mysql_fetch_array($result)) {
					$a .=  "<tr><td style='cursor:hand' bgcolor='$result1[color]' OnClick='javascript:document.location=\"admin.php?password=$password&statusvar=" . base64_encode($result1[id]) . "&StatusVars=1\"'>";
					$a .= "<a href='admin.php?statusvar=" . base64_encode($result1[id]) . "&password=$password&StatusVars=1' class='bigsort'><font color='#000000'>$result1[varname]</font></a></td><td><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?&password=$password&deletestatusvar=" . base64_encode($result1[id]) . "&StatusVars=1'>delete</a></td></tr>";
				}
					$a .= "<tr><td bgcolor='#FFFFFF' OnClick='javascript:document.location=\"admin.php?password=$password&statusvar=" . base64_encode("_new_") . "&StatusVars=1\"'>";
					$a .=  "<img src='arrow.gif'>&nbsp;<a href='admin.php?password=$password&statusvar=" . base64_encode("_new_") . "&StatusVars=1' class='bigsort'>Add a new status variable </a></td><td>&nbsp;</td></tr>";
				$a .=  "</table></center></fieldset><br><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&EditVars=1' style='cursor:hand'>Back to main variables management page</a></td></tr>";
				$legend = "Edit status variables&nbsp;";
				printbox($a);
				print "</table></body></html>";
				exit;
			}

			$statusvar = base64_decode($statusvar);

			$a =  "<form name='statvars'>";
			$a .= "<input type='hidden' name='password' value='$password'>";
			if ($statusvar=="_new_") {
				$legend = "Add a new status variable&nbsp;";
				$a .= "<table><tr><td>Name</td><td>Color</td></tr>";
				$a .= "<input type='hidden' name='isnew' value='_new_'>";
			} else {
				$legend ="Editing status variable \"$statusvar\"&nbsp;";
				$a .= "<table><tr><td>Name</td><td>Color</td></tr>";
				$sql = "SELECT varname,color,id FROM ".CRM_STATUS_VARS_TABLE." WHERE id='" . $statusvar . "'";
				$result= mcq($sql,$db);
				$result1= mysql_fetch_array($result);
				$add1 = "<br>Warning: If you edit the variable name, the<br>status of all entities carrying this status will<br>be updated to your new variable name!<br><br>";
			}



			$a .= "<tr><td><input type='text' name='varname' value='$result1[varname]'><input type='hidden' name='oldvarname' value='$result1[varname]'></td><td><input type='text' name='varcolor' value='$result1[color]' OnFocus='javascript:popcolorchooser(document.statvars.varname.value)';></td></tr>";
			$a .= "<tr><td colspan=2><input type='hidden' name='StatusVars' value='1'><input type='hidden' name='var_id' value='$result1[id]'><input type='hidden' name='colsubmitted' value='1'>";
			$a .= $add1;
			$a .= "<input type='submit' name='butt' value='Save to database'>&nbsp;<input type='button' name='butt1' value='Cancel' OnClick='javascript:history.back(-1);'></td></tr>";
			printbox($a);
			print "</table></body></html>";
			exit;
}

function priorityVars() {
			global $priorityvar, $colsubmitted, $prio_id, $varcolor, $varname, $oldvarname, $isnew, $deletepriorityvar, $password,$legend, $printbox_size;
			if ($deletepriorityvar) {
						$deletepriorityvar = base64_decode($deletepriorityvar);
						$sql = "DELETE FROM ".CRM_PRIORITY_VARS_TABLE." WHERE id='$deletepriorityvar'";
						mcq($sql,$db);
						uselogger("Priority var $deletepriorityvar deleted","");
			}
			if ($colsubmitted) {
				if ($isnew) {
						$sql = "INSERT INTO ".CRM_PRIORITY_VARS_TABLE."(varname,color) VALUES('$varname','$varcolor')";
						mcq($sql,$db);
						$added=1;
						uselogger("Priority var $varname added","");
				}
				if (!$added) {
					if ($varname!=$oldvarname) {
							$sql = "UPDATE ".CRM_ENTITY_TABLE." SET priority='$varname' WHERE priority='$oldvarname'";
							mcq($sql,$db);
							$add = "All entities with priority '$oldvarname' were updated to priority '$varname'.";
					}
					$sql = "UPDATE ".CRM_PRIORITY_VARS_TABLE." SET varname='$varname',color='$varcolor' WHERE id='$prio_id'";
					//print $sql;
					mcq($sql,$db);
				}
				//print "<tr><td>Saving $varname with color $varcolor. $add</td></tr>";
				uselogger("Saving $varname with color $varcolor. $add","");
			}

			if (!$priorityvar) {
				$sql = "SELECT varname,id,color FROM ".CRM_PRIORITY_VARS_TABLE."";
				$result= mcq($sql,$db);
				//$a =  "<table border='1' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
				$legend = "Edit priority variables&nbsp;";
				$printbox_size = "100%";
				$a =  "Please choose the priority variable you want to edit (or delete)...<br><br><center><table border='1' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
				while ($result1= mysql_fetch_array($result)) {
					$a .= "<tr><td style='cursor:hand' bgcolor='$result1[color]' OnClick='javascript:document.location=\"admin.php?password=$password&priorityvar=" . base64_encode($result1[id]) . "&priorityVars=1\"'>";
					$a .= "<a href='admin.php?password=$password&priorityvar=" . base64_encode($result1[id]) . "&priorityVars=1' class='bigsort'><font color='#000000'>$result1[varname]</font></a></td><td><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&deletepriorityvar=" . base64_encode($result1[id]) . "&priorityVars=1'>delete</a></td></tr>";
				}
					$a .= "<tr><td bgcolor='#FFFFFF' OnClick='javascript:document.location=\"admin.php?priorityvar=" . base64_encode("_new_") . "&priorityVars=1\"'>";
					$a .= "<img src='arrow.gif'>&nbsp;<a href='admin.php?password=$password&priorityvar=" . base64_encode("_new_") . "&priorityVars=1' class='bigsort'>add a new priority variable </a></td><td>&nbsp;</td></tr>";
					$a .= "</table></center></fieldset><br><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&EditVars=1' style='cursor:hand'>Back to main variables management page</a></td></tr>";
					$legend = "Edit priority variables&nbsp;";
					printbox($a);
				print "</table></body></html>";
				exit;
			}

			$priorityvar = base64_decode($priorityvar);

			$a = "<form name='statvars'>";
			$a .= "<input type='hidden' name='password' value='$password'>";
			if ($priorityvar=="_new_") {
				$legend = "Adding new priority variable&nbsp;";
				$a .= "<table><tr><td>Name</td><td>Color</td></tr>";
				$a .= "<input type='hidden' name='isnew' value='_new_'>";
			} else {
				$legend = "Editing priority variable \"$priorityvar\"&nbsp;";
				$a .= "<table><tr><td>Name</td><td>Color</td></tr>";
				$sql = "SELECT varname,color,id FROM ".CRM_PRIORITY_VARS_TABLE." WHERE id='" . $priorityvar . "'";
				$result= mcq($sql,$db);
				$result1= mysql_fetch_array($result);
				$add1 = "<br>Warning: If you edit the variable name, the<br>priority of all entities carrying this priority will<br>be updated to your new variable name!<br><br>";
			}



			$a .= "<tr><td><input type='text' name='varname' value='$result1[varname]'><input type='hidden' name='oldvarname' value='$result1[varname]'></td><td><input type='text' name='varcolor' value='$result1[color]' OnFocus='javascript:popcolorchooser(document.statvars.varname.value)';></td></tr>";
			$a .= "<tr><td colspan=2><input type='hidden' name='priorityVars' value='1'><input type='hidden' name='prio_id' value='$result1[id]'><input type='hidden' name='colsubmitted' value='1'>";
			$a .= $add1;
			$a .= "<input type='submit' name='butt' value='Save to database'>&nbsp;<input type='button' name='butt1' value='Cancel' OnClick='javascript:history.back(-1);'></td></tr>";
			printbox($a);
			print "</table></body></html>";
			exit;
}

/**
 * Handles editing a sysvar
 */
function EditSysVar($id) {
	global $lang, $data, $password, $udated, $setting, $OldVar,$plain,$stdtext;
	if ($udated) {
			print "value $data received for variable $id";
			if ($setting=="EnableEntityJournaling") {
				// Journaling mode was updated. Maybe we have to add this to the journal?
				if ((strtoupper($OldVar)=="YES") && (strtoupper($data)<>"YES")) {
					$sql = "SELECT eid FROM ".CRM_ENTITY_TABLE."";
					$result1 = mcq($sql,$db);
					while ($result= mysql_fetch_array($result1)) {
						journal($result[eid],"[admin] Journaling disabled");
						$jcount++;
					}
				} // end if oldvar was yes

			}


			if ($setting=="STANDARD_TEXT") {
				foreach ($stdtext AS $row) {
					$data .= base64_encode($row) . ",";
				}
				$data = substr($data,0,strlen($data)-1);
				$data = ereg_replace(",,","",$data);
			}



			$sql = "UPDATE ".CRM_SETTINGS_TABLE." SET value='$data' WHERE settingid='$id'";
		    mcq($sql,$db);

			if ($setting=="EnableEntityJournaling") {
				// Journaling mode was updated. Maybe we have to add this to the journal?
				if ((strtoupper($OldVar)<>"YES") && (strtoupper($data)=="YES")) {
					$sql = "SELECT eid FROM ".CRM_ENTITY_TABLE."";
					$result1 = mcq($sql,$db);
					while ($result= mysql_fetch_array($result1)) {
						journal($result[eid],"[admin] Journaling enabled");
						$jcount++;
					}
				} // end if oldvar was yes

			}

			?>
			<SCRIPT LANGUAGE="JavaScript">
			<!--
				document.location='admin.php?password=<?php echo $password;?>&sysval=1';
			//-->
			</SCRIPT>
			<?php

	}
	$sql = "SELECT * FROM ".CRM_SETTINGS_TABLE." WHERE settingid='$id'";
	$result= mcq($sql,$db);
	$result1= mysql_fetch_array($result);

	if ($result1[setting] == "DBVERSION") {
		print "<table><tr><td><font color='#FF0000'>This value cannot be edited.</font>";
		print "<br><img src='arrow.gif'>&nbsp;<a href='javascript:history.back(-1)' class='bigsort'>back</a> <br></td></tr></table>";
		EndHTML();
		exit;
	}
	print "<table border='0' width='100%' bgcolor='#FFFFFF' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>";
	print "<TR><TD COLSPAN=3><hr><font size='+1'>Editing sysvar $id: " . strtoupper($result1[setting]) . "</font></TD></TR>";
	print "<FORM NAME='composeform' METHOD='POST'>";
	print "<TR><TD COLSPAN=3><b>Discription:</b><br><br>" . $result1[discription] . "</TD></TR>";
	print "<TR><TD><br><b>";
	if ($result1['setting']<>"STANDARD_TEXT") {
		print "Value:";
	} else {
		print "Values:";
	}

	print "</b><INPUT TYPE='hidden' NAME='EditSysVar' VALUE='$id'><INPUT TYPE='hidden' NAME='OldVar' VALUE='" . $result1[value] . "'><INPUT TYPE='hidden' NAME='setting' VALUE='$result1[setting]'>";
	if (substr($result1[setting],0,4) == "BODY") {
		if ($plain) {
			print "<TEXTAREA name='data' ROWS='18' COLS='100'>" . $result1[value] . "</TEXTAREA>";
		} else {
			//print "<TEXTAREA name='data' ROWS='18' COLS='100'>" . $result1[value] . "</TEXTAREA>";

				?>
				<script language="Javascript1.2"><!-- // load htmlarea
				_editor_url = "";                     // URL to htmlarea files
				var win_ie_ver = parseFloat(navigator.appVersion.split("MSIE")[1]);
				if (navigator.userAgent.indexOf('Mac')        >= 0) { win_ie_ver = 0; }
				if (navigator.userAgent.indexOf('Windows CE') >= 0) { win_ie_ver = 0; }
				if (navigator.userAgent.indexOf('Opera')      >= 0) { win_ie_ver = 0; }
				if (win_ie_ver >= 5.5) {
				  document.write('<scr' + 'ipt src="' +_editor_url+ 'editor.js"');
				  document.write(' language="Javascript1.2"></scr' + 'ipt>');
				} else { document.write('<scr'+'ipt>function() { return false; }</scr'+'ipt>'); }
				// --></script>
				<?php
				print "<TEXTAREA name='data' ROWS='18' COLS='100'>" . $result1[value] . "</TEXTAREA>";
				?>
				<script language="javascript1.2">
					editor_generate('data');
				</script>
				<?php
		}
		print "<TR><TD COLSPAN=3><input type='hidden' name='password' value='$password'><input type='hidden' name='udated' value='1'><INPUT TYPE='submit' NAME='Send.x' VALUE='" . $lang[save] . "'>&nbsp;&nbsp;<input type='button' name='do' value='$lang[cancel]' Onclick='javascript:history.back(1);'>&nbsp;";
		if (!$plain) {
			print "<input type='button' class='bigsort' OnClick=\"javascript:document.location='admin.php?EditSysVar=$id&plain=1';\" value='Javascript not working?'>";
		}
		print "</TD></TR></form></table></body></html>";
		exit;

	} elseif($result1[setting]=="STANDARD_TEXT") {
		$si = 1;
		if (strlen($GLOBALS['STANDARD_TEXT'])>1) {
				print "<br>";
				$arr = split(",",$GLOBALS['STANDARD_TEXT']);
				foreach ($arr AS $row) {
					print $si . ".&nbsp;<input type=text size=70 name='stdtext[]' value='" . htmlentities2(stripslashes(base64_decode($row))) . "'><br>";
					$si++;
				}
			} else {
				print "<br>";
			}
		print $si . ".&nbsp;<input type=text size=70 name='stdtext[]' value=''><br>";
		$si++;
		print $si . ".&nbsp;<input type=text size=70 name='stdtext[]' value=''><br>";
		$si++;
		print $si . ".&nbsp;<input type=text size=70 name='stdtext[]' value=''><br>";

	} else {
		if ((stristr($result1['setting'],"show") || stristr($result1['setting'],"enable")|| stristr($result1['setting'],"auto") || stristr($result1['setting'],"BLOCK") || stristr($result1['setting'],"force") || stristr($result1['setting'],"letuser") || stristr($result1['setting'],"hidecustomer") || stristr($result1['setting'],"langover")) && !stristr($result1['setting'],"recentedit")  && ($result1['setting']<>"MonthsToShow")) {


			if (strtoupper($result1[value])=="YES") {
				$yes = "SELECTED";
			} elseif (strtoupper($result1[value])=="ADMIN") {
				$admin = "SELECTED";
			} else {
				$no = "SELECTED";
			}

			if ($result1['setting']=="EnableRepositorySwitcher") {
				$option_insert = "<option " . $admin . ">Admin</option>";
			}
			print "</TD><TD><BR><SELECT NAME='data'><OPTION " . $yes . ">Yes</OPTION><OPTION " . $no . ">No</OPTION>" . $option_insert . "</TD></TR>";

		} elseif (stristr($result1['setting'],"dateformat")) {
			if (strtoupper($result1[value])=="DD-MM-YYYY") {
				$yes = "SELECTED";
			} else {
				$no = "SELECTED";
			}
			print "</TD><TD><BR><SELECT NAME='data'><OPTION " . $yes . ">dd-mm-yyyy</OPTION><OPTION " . $no . ">mm-dd-yyyy</OPTION></TD></TR>";

		} elseif (stristr($result1['setting'],"navtype")) {
			if (strtoupper($result1[value])=="TABS") {
				$yes = "SELECTED";
			} else {
				$no = "SELECTED";
			}
			print "</TD><TD><BR><SELECT NAME='data'><OPTION " . $yes . ">TABS</OPTION><OPTION " . $no . ">NOTABS</OPTION></TD></TR>";
		} elseif (stristr($result1['setting'],"managementinter")) {
			if (strtoupper($result1[value])=="ON") {
				$yes = "SELECTED";
			} else {
				$no = "SELECTED";
			}
			print "</TD><TD><BR><SELECT NAME='data'><OPTION " . $yes . ">On</OPTION><OPTION " . $no . ">Off</OPTION></TD></TR>";

		} else {
			print "</TD><TD><BR><INPUT TYPE='text' SIZE=70 NAME='data' VALUE=\"" . $result1[value] . "\"></TD></TR>";
		}
	}
	print "<TR><TD COLSPAN=3><BR><input type='hidden' name='udated' value='1'><input type='hidden' name='password' value='$password'><INPUT TYPE='submit' NAME='bt' VALUE='" . $lang[save] . "'>&nbsp;&nbsp;<input type='button' name='do' value='$lang[cancel]' Onclick='javascript:history.back(1);'></TD></TR>";
	print "</FORM></TABLE>";
	EndHTML();
	exit;
}

function check_reference_in_main_user_table_to_a_limited_account_name($limited_account_name_new) {

	$sql = "SELECT id FROM ".CRM_USERS_TABLE." WHERE name='" . $limited_account_name_new ."'";
	$result= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($result);
	if (!$maxU1[0]) {
		return("error");
	} else {
		return("ok");
	}
}
function fillout($var,$len) {
		while (strlen($var)<$len) {
				$var = $var . " ";
		}
		if ($var=="____0") {
			$var="_____";
		}
	return $var;
}
function nav() {
	global $lang,$logo,$ShowDeletedViewOption,$EnableCustInsert;
?>

<table border="0" width="100%"><tr><td>
<table border="0" width="100%" cellpadding="0" cellspacing="0"><tr><td valign="top">
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[gotomainpage];?>' href='index.php?<?php echo $epoch;?>'><?php echo $lang[main];?></a>
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[addcust];?>' href='edit.php?e=_new_&<?php echo $epoch;?>'><?php echo $lang[add];?></a>
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[viewbrief];?>' href='index.php?ShowEntitiesOpen=1&<?php echo $epoch;?>'><?php echo $lang[entities];?></a>
<!-- <a class='bigsort' title='<?php echo $lang[brieflistdel];?>' href='del.php'><?php echo $lang[delentities];?></a> | -->

&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[vacc];?>' href='customers.php?<?php echo $epoch;?>'><?php echo $lang[customers];?></a>
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[dumpi];?>' href='csv.php?<?php echo $epoch;?>'>CSV</a>
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[phonebook];?>' href='phonebook.php?<?php echo $epoch;?>'><?php echo $lang[phonebookshort];?></a>
&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[sumverb];?>' href='summary.php?<?php echo $epoch;?>'><?php echo $lang[summary];?></a>
<?php
if ($ShowDeletedViewOption=="yes" || $ShowDeletedViewOption=="Yes") {
	print "&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='$lang[delentities]>' href='index.php?ShowEntitiesOpen=1&filter=viewdel&tab=$x'>$lang[delentities]</a>";
}
if ($EnableCustInsert=="yes" || $EnableCustInsert=="Yes") {
	$sql= "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE." WHERE ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_ENTITY_TABLE.".owner='2147483647' AND ".CRM_ENTITY_TABLE.".assignee='2147483647' AND deleted<>'y'";
	$result= mcq($sql,$db);
    $e= mysql_fetch_array($result);

	print "&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='$lang[delentities]>' href='index.php?ShowEntitiesOpen=1&filter=custinsert&tab=$x'>$lang[viewinsertedentities]</a>  ($e[0])";
}

?>

&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='<?php echo $lang[logout];?>' href='index.php?logout=1&<?php echo $epoch;?>'><?php echo $lang[logout];?></a>
&nbsp;&nbsp;&nbsp;&nbsp;
<?php echo $lang[entity];?>:&nbsp;<form name='direct' action='edit.php' method=POST><input type='text' size=3 name='e' OnChange='javascript:document.direct.submit()' value='' OnFocus="javascript:document.direct.e.value=''"></form>&nbsp;
<?php echo $lang[search];?>:
<form name='direct2' action='summary.php' method=POST>
<input type='text' size=15 name='wildsearch' value='<?php echo $wildsearch; ?>' OnChange='javascript:document.direct2.submit()' OnFocus="javascript:document.direct2.wildsearch.value=''">
<input type='hidden' name ='owner' value='all'>
<input type='hidden' name ='assignee' value='all'>
<input type='hidden' name ='".CRM_CUSTOMER_TABLE."' value='all'>
<input type='hidden' name ='duedate' value='all'>
<input type='hidden' name ='status'>
<input type='hidden' name ='prio'>
<input type='hidden' name ='waiting'>


</form>


<a OnClick='javascript:pophelp(16)' class='bigsort' style='cursor: help'><img src='info.gif'></a>

<br>

<?php
$today = date("F j, Y, H:i") . "h.";
//$result[value]=0;
$sql= "SELECT count(*) FROM ".CRM_ENTITY_TABLE." WHERE status='open'";
$result= mcq($sql,$db);
$result= mysql_fetch_array($result);
if ($result[0]) {
    print "$today $lang[thereare] <b>$result[0]</b> $lang[openentities].";
    } else {
    print "$today $lang[noopen]";
}

print "</td></tr></table>";
print "</td></tr></table>";
print "<table width='75%'>";
}

function internav() {
	global $lang, $epoch, $ShowPDWASLink, $LetUserEditOwnProfile;
?>	    <table border=0>
<?php
		if (strtoupper($LetUserEditOwnProfile)=="YES") {
	?>
		<tr><td NOWRAP><img src='arrow.gif'>&nbsp;<a class='bigsort' title='' href='profile.php?<?php echo $epoch;?>'><?php echo $lang['password'];?></a>&nbsp;&nbsp;&nbsp;&nbsp;</td><td NOWRAP><?php echo $lang[username];?>/<?php echo strtolower($lang[password]);?></td></tr>
	<?php
	}
	?>
		<tr><td NOWRAP><img src='arrow.gif'>&nbsp;<a class='bigsort' title='' href='stats.php?<?php echo $epoch;?>'><?php echo $lang[maninfo];?></a>&nbsp;&nbsp;&nbsp;&nbsp;</td><td NOWRAP><?php echo $lang[maninfoverb];?></td></tr>
		<tr><td NOWRAP>
		<img src='arrow.gif'>&nbsp;<a class='bigsort' title='' href='grph.php?<?php echo $epoch;?>'><?php echo $lang[sitestats];?></a></td><td NOWRAP><?php echo $lang[sitestatsverb];?></td></tr>
		<tr><td NOWRAP>
		<img src='arrow.gif'>&nbsp;<a class='bigsort' title='' href='admin.php?<?php echo $epoch;?>'><?php echo $lang[administration];?></a>&nbsp;<img src='lock.png'></td><td NOWRAP><?php echo $lang[administrationverb];?> (alt-a)</td></tr>
		<tr><td NOWRAP>
		<img src='arrow.gif'>&nbsp;<a OnClick='javascript:pophelp("contents")' class='bigsort' style='cursor: help'><?php echo $lang[helpcontents];?></a></td><td NOWRAP><?php echo $lang[helpcontentsverb];?></td></tr>
		<tr><td NOWRAP>
		<?php
			//if (strtoupper($ShowPDWASLink)=="YES") {
				//if (file_exists("CRM-CTT PDWAS Setup.exe")) {
				//		print "<img src='arrow.gif'>&nbsp;<a class='bigsort' title='' href='CRM-CTT PDWAS Setup.exe'>PDWAS Setup</a></td><td NOWRAP>Download PDWAS CRM Client Setup";
				//}
				//if (file_exists("CRM_PDWASmanual.pdf")) {
				//		print "&nbsp;&nbsp;(<a target='_new' class='bigsort' title='' href='CRM_PDWASmanual.pdf'>manual</a>)";
				//}

			//}

		?>
		</td></tr>



		<!-- <tr><td>
		<img src='arrow.gif'>&nbsp;<a OnClick='javascript:pophelp(13)' class='bigsort' style='cursor: hand'>Disclaimer</a></td><td>
		<a OnClick='javascript:pophelp(14)' class='none'><font color='#000000'>S.O.B.</font></a> Disclaimer</td></tr> -->
		</table>

	<?php
}
	function prtsrc($tim) {
	global $search,$lang,$nonavbar,$HideCustomerTab;
	$sql = "SELECT COUNT(*) FROM ".CRM_PHONEBOOK_TABLE."";
	$result= mcq($sql,$db);

	$top= mysql_fetch_array($result);
		 print "<table><tr><td>";
	if (!$tim==1) {

	 print "$lang[pbcont1] $top[0] $lang[pbcont2].</td></tr>";
	}
	print "<tr><td><form name='pb' method='POST' ACTION='phonebook.php'>";
	print "<br><table>";
	if (strtoupper($HideCustomerTab)=="YES" && GetClearanceLevel($GLOBALS[USERID])<>"administrator") {
		print "<tr><td>$lang[customers]:</td><td><input type='checkbox' class='radio' DISABLED name='PBwhere1' value='customers'> <img src='lock.png' style='border:0' title='Disabled by administrator'></td></tr>";
	} else {
		print "<tr><td>$lang[customers]:</td><td><input type='checkbox' class='radio' CHECKED name='PBwhere1' value='customers'></td></tr>";
	}
	print "<tr><td>$lang[phonebook1]:</td><td><input type='checkbox' class='radio' CHECKED name='PBwhere2' value='phonebook'></td></tr></table><br>";
	print "$lang[search]: <input type='text' name='search' OnChange='javascript:document.pb.submit()'> ";

	print "</td>";
	print "<td><center><input type='hidden' name='nonavbar' value='$nonavbar'><input type='hidden' name='zoek' value='Search'></form></td></tr></table><br>";
	if (!$tim==1) {
	 print "<img src='arrow.gif'>&nbsp;<a href='phonebook.php?nonavbar=$nonavbar&add=1' class='bigsort'>$lang[pbaddrec]</a>&nbsp;&nbsp;";
	}
	if (!$nonavbar) {
		print "<img src='arrow.gif'>&nbsp;<a Onclick='javascript:poppb()' style='cursor:hand' class='bigsort'>$lang[openinnewwindow]</a>";
	}
	print "</center><br><br>";
	if ($tim=="0") {
	?>
		<SCRIPT LANGUAGE="JavaScript">
		<!--
			document.pb.search.focus();
		//-->
		</SCRIPT>
		<?php
	}
}
function DspSearchResults($search,$cust_insert) {
	global $nonavbar, $CustomerListColumnsToShow, $lang;
	prtsrc2("0");

	if ($nonavbar) {
		print "<hr>";
	}


		$arr = array();
		// ZOEK ALHIER

		if ($cust_insert) {
			$sql = "SELECT eid FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE 1=0 OR " . $cust_insert;
			$result = mcq($sql,$db);
			while($result1 = mysql_fetch_array($result)) {
				array_push($arr,$result1[eid]);
			}

			$search = chr(27) . " - extra fields only";

		} else {
			qlog("No extra fields searched in this query");
		}

		$sql= "SELECT ".CRM_CUSTOMER_TABLE.".id AS bla FROM ".CRM_CUSTOMER_TABLE." WHERE custname LIKE '%$search%' OR contact LIKE '%$search%' OR contact_title LIKE '%$search%' OR contact_phone LIKE '%$search%' OR contact_email LIKE '%$search%' OR cust_address LIKE '%$search%' OR cust_remarks LIKE '%$search%' OR cust_homepage LIKE '%$search%'  ORDER BY custname";

		$result= mcq($sql,$db);


		while ($pb= mysql_fetch_array($result)) {
			if (!in_array($pd[eid],$arr)) {
						array_push($arr,$pb[bla]);
					}
		}

		if($search) {
			$sql = "SELECT eid FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE type='cust' AND value LIKE '%$search%'";
			$result = mcq($sql,$db);
			while ($pb= mysql_fetch_array($result)) {
				if (!in_array($pb[eid],$arr)) {
					array_push($arr,$pb[eid]);
				}
			}
		}
		$query = "SELECT * FROM ".CRM_CUSTOMER_TABLE." WHERE id='NONEXISTENT' ";

		foreach($arr as $row) {
			$query .= "OR id='" . $row . "' ";
			$num++;
		}

		$query .= " ORDER BY custname";

		$store = base64_encode($query);
		//print $query;
		print "<table border=0 width=100%><tr><td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td><fieldset><legend 						align='left'>$lang[pbresults] '$search' &nbsp;[$lang[customers]]&nbsp;<img src='arrow.gif'>&nbsp;<a 	href='javascript:popExportWindow(\"" . $store . "\");' class='bigsort'>Export</a>&nbsp;</legend>";

		print "<table cellspacing='0' cellpadding='4' width=100% border=1 bordercolor='#F0F0F0'>";

		if ($CustomerListColumnsToShow['cb_custname']) {
			print "<td>" . $lang['customer'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_contact']) {
			print "<td>" . $lang['contact'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_contact_title']) {
			print "<td>" . $lang['contacttitle'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_contact_phone']) {
			print "<td>" . $lang['contactphone'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_contact_email']) {
			print "<td>" . $lang['contactemail'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_cust_address']) {
			print "<td>" . $lang['customeraddress'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_cust_remarks']) {
			print "<td>" . $lang['custremarks'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_cust_homepage']) {
			print "<td>" . $lang['custhomepage'] . "</td>";
		}
		if ($CustomerListColumnsToShow['cb_active']) {
			print "<td>Active</td>";
		}
		$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra customer fields list'";
		$result = mcq($sql,$db);
		$list = mysql_fetch_array($result);
		$list = $list[value];
		$ExtraFieldsList = @explode(",",$list);
		if (sizeof($ExtraFieldsList)>0 && $ExtraFieldsList[0]<>"") {
		for ($x=0;$x<sizeof($ExtraFieldsList);$x++) {
			if ($CustomerListColumnsToShow[$ExtraFieldsList[$x]]) {
				$toshow = $ExtraFieldsList[$x];
				if (stristr($ExtraFieldsList[$x],"TB_")) {
					$toshow = ereg_replace("TB_","",$ExtraFieldsList[$x]);
				}
				if (stristr($ExtraFieldsList[$x],"DD_")) {
					$toshow = ereg_replace("DD_","",$ExtraFieldsList[$x]);
					$tmp = explode("|",$toshow);
					$toshow = $tmp[0];
				}

				print "<td>" . $toshow . "</td>";
			}
		}
		}

		print "<td>" . $lang['add'] . "</td>";
		print "<td>" . $lang['entities'] . "</td>";
		print "</tr>";

		//print "<tr><td>" . $lang[customer] . "</td><td>" . $lang['contact'] . "</td><td>" . $lang['owner'] . "</td><td>" . $lang[add] . "</td><td>Active</td></tr>";

		$result = mcq($query,$db);
		while ($pb= mysql_fetch_array($result)) {
				$a = "<tr onmouseover=\"javascript:style.background='#CCCCCC';\"  onmouseout=\"javascript:style.background='#FFFFFF';\">";
				if ($CustomerListColumnsToShow['cb_custname']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['custname'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_contact']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['contact'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_contact_title']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['contact_title'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_contact_phone']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['contact_phone'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_contact_email']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['contact_email'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_cust_address']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['cust_address'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_cust_remarks']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['cust_remarks'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_cust_homepage']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['cust_homepage'] . "</td>";
				}
				if ($CustomerListColumnsToShow['cb_active']) {
					$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $pb['active'] . "</td>";
				}

				if (sizeof($ExtraFieldsList)>0 && $ExtraFieldsList[0]<>"") {
						for ($x=0;$x<sizeof($ExtraFieldsList);$x++) {
							if ($CustomerListColumnsToShow[$ExtraFieldsList[$x]]) {
								$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='" . $pb[id] . "' AND name='" . $ExtraFieldsList[$x] ."' AND type='cust' LIMIT 1";

								$result33 = mcq($sql,$db);
								$gh = mysql_fetch_array($result33);
								if (stristr($list[$x],"TB_")) {
									$gh[0] = eregi_replace("\n","<BR>",$gh[0]);
								}
								$a .= "<td style='cursor:hand' OnClick='javascript:gobla(" . $pb[id] . ");'>" . $gh[0] . "&nbsp;</td>";

							}
						}
				}

				$a .= "<td><img src='arrow.gif'>&nbsp;<a href='edit.php?e=_new_&tab=22&SetCustTo=" . $pb[id] . "' class='bigsort'>$lang[pbaddrec]</a></td>";
				$a .= "<td><img src='arrow.gif'>&nbsp;<a href='index.php?ShowEntitiesOpen=1&pdfiltercustomer=" . $pb['id'] . "' class='bigsort'>" . $lang['entities'] . "</a></td>";
				$a .= "</tr>";
				print $a;
				unset($a);
				$teller++;

		}

		if ($teller>25) {
			prtsrc2("1");
		}

		if ($teller==0) {
			print "<tr><td>$lang[noresults]</td></tr>";
		} else {
			print "<tr><Td>$teller $lang[resfound]</td></tr>";
		}
		print "</table>";


		print "</fieldset></td></tr></table>";
		$teller=0;

} // end if $search


function prtsrc2($tim) {
	global $search,$lang,$nonavbar,$maxcust;

	if (!$search) $search = "%";
	print "<table width='100%' border=0>";
	if (!$tim==1) {
		print "<tr><td>&nbsp;&nbsp;<fieldset><legend align='left'>$lang[customers]&nbsp;</legend><table><tr><td>$lang[custindb]: $maxcust&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(6)' class='topnav' cursor='click' style='cursor: help'><img src='info.gif'></a></td><td>&nbsp;</td></tr>";
		print "<tr><td><form name='pb' method='GET' ACTION='customers.php'>";
		$std = $search;
		if ($std=="%") $std = "";

		if (!$store) {
			$store = base64_encode("SELECT * FROM ".CRM_CUSTOMER_TABLE." ORDER BY custname");
		}

		print "$lang[search]: <input type='text' name='search' value='" . $std . "' OnChange='javascript:document.pb.submit()'> ";
		 print "<br><br><img src='arrow.gif'>&nbsp;<a href='customers.php?nonavbar=$nonavbar&add=1' class='bigsort'>$lang[addcust]</a><br><img src='arrow.gif'>&nbsp;<a 	href='javascript:popExportWindow(\"" . $store . "\");' class='bigsort'>Export</a><br><img src='arrow.gif'>&nbsp;<a 	href='javascript:showLayer(\"Advanced\");' OnClick='javascript:document.pb.search.value=\"(disabled)\";document.pb.search.disabled=true;' class='bigsort'>More</a>&nbsp;&nbsp;";
		print "<td><center><input type='hidden' name='nonavbar' value='$nonavbar'><input type='hidden' name='zoek' value='Search'></td></tr>";
			print "<tr><td colspan=2><div id='Advanced' style='display: none'><table>";
			$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra customer fields list'";
			$result = mcq($sql,$db);
			$list = mysql_fetch_array($result);
			$list = $list[value];
			$list = explode(",",$list);



			foreach ($list as $item) {

					if (stristr($item,"DD_")) {
						$item_ts = ereg_replace("DD_","",$item);
						$tmp = explode("|",$item_ts);
						$item_ts = $tmp[0];
					} elseif (stristr($item,"TB_")) {
						$item_ts = ereg_replace("TB_","",$item);
					} else {
						$item_ts = $item;
					}

					$outpmenu .= "<tr><td><fieldset><legend>" . $item_ts . "&nbsp;</legend>";
					$outpmenu .= "<select name='" . base64_encode($item) . "'><option value=''>" . $lang['all'] . "</option>";

					$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE name='" . $item . "' AND type='cust'";
					$result2 = mcq($sql,$db);
					$done = array();
					while ($result = mysql_fetch_array($result2)) {
						if (!in_array($result['value'],$done)) {
							$outpmenu .= "<option>" . $result['value'] . "</option>";
							array_push($done, $result['value']);
						}

					}

					$outpmenu .= "</select></td></tr>";

			}

//			$outpmenu .= "<tr><td colspan=4><table>";

				print $outpmenu;
				print "<tr><td><input type='submit'></td></tr>";
				print "</div></table>";
		print "</form></td></tr></table></fieldset><br></td></tr></table>";
		print "</table>";
		?>
		<SCRIPT LANGUAGE="JavaScript">
		<!--
			document.pb.search.focus();
		//-->
		</SCRIPT>
		<?php
	} else {
		//print "<tr><td><form name='pb' method='GET' ACTION='customers.php'>";
		//print "$lang[search]: <input type='text' name='search' value='" . $search . "' OnChange='javascript:document.pb.submit()'></form></td></tr>";
	}

}
function form()
{
   global $sqlcounter,$password,$summary,$entities_owned_by_users,$entities_assigned_to_users,$lang;
   global $sqlcounter,$self_assigned,$didntbelonghere,$elseaction,$entities_per_customer,$overdue_per_assignee;

   print "<table><tr><td>$lang[smtsm]<table><form name=mi method='POST'>";
   print "<tr><td colspan=3><img src='arrow.gif'>&nbsp;<a class='bigsort' href='mansumpdf2.php'>$lang[dlmspdf].</a>&nbsp;&nbsp;</i><br><br></td></tr>";
   if ($summary=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<tr><td><input type='checkbox' name='summary' $tmp> $lang[oqs]</td>";
   if ($entities_owned_by_users=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<td><input type='checkbox' name='entities_owned_by_users' $tmp> $lang[eobu]</td>";
   if ($entities_assigned_to_users=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<tr><td><input type='checkbox' name='entities_assigned_to_users' $tmp> $lang[eatu]</td>";
   if ($self_assigned=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<td><input type='checkbox' name='self_assigned' $tmp> $lang[sae]</td>";
   if ($didntbelonghere=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<tr><td><input type='checkbox' name='didntbelonghere' $tmp> $lang[etdbh]</td>";
   if ($elseaction=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<td><input type='checkbox' name='elseaction' $tmp> $lang[ewfsea]</td>";
   if ($entities_per_customer=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<tr><td><input type='checkbox' name='entities_per_customer' $tmp> $lang[epc]</td>";
   if ($overdue_per_assignee=='on') { $tmp = "CHECKED"; } else { $tmp = ""; }
   print "<td><input type='checkbox' name='overdue_per_assignee' $tmp> $lang[oepa]</td></tr>";


   print "<tr><td><br><input type='hidden' name='password' value='$password'>";
   print "<input type='submit' name='knop' value='Report information'>";
   print "&nbsp;<img src='arrow.gif'>&nbsp;<a href='$PHP_SELF?password=$password' class='bigsort'>clear all</a></td></tr>";
   print "</form></tr></td></table>";
   print "";
} // end func

function summary()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$waiE,$password,$maxEoNc,$lang;
	print "<tr><td colspan=4><fieldset><legend>$lang[oqs]</legend>&nbsp;</legend><table border=0>";
	print "<tr><td colspan=4>$lang[allround]</td></tr>";
	print "<tr><td>$lang[entities]</td><td>$maxE</td></tr>";
	print "<tr><td><i>$lang[ofwhich]</i></td></tr>";

	$sql = "SELECT * FROM ".CRM_STATUS_VARS_TABLE." ORDER BY varname";
	$result= mcq($sql,$db);
    while ($e= mysql_fetch_array($result)) {

			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE status='$e[varname]'";
			$result1= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($result1);

			$bla = $maxU1[0];

			$pc1 = ($maxEo/100); // dit is 1 procent

			$pc2 = ($bla/100); // dit is 1 procent van not [deleted]

			$apc = round($bla/$pc1); // dit is het percentage

			print "<tr><td bgcolor='" . $e['color'] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$e[varname]</td><td width=\"20%\">$bla</td><td width=\"20%\">$apc%</td></tr>";
			$totaal=$totaal+$bla;
	}
	if ($totaal<>$MaxE) {
		$bla = $maxE - $totaal;
		$apc = round($bla/$pc1); // dit is het percentage
		print "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Unknown</td><td width=\"20%\">$bla</td><td width=\"20%\">$apc%</td></tr>";
	}
	$apc = round($delE/$pc1); // dit is het percentage
	print "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$lang[deleted] </td><td>$delE</td><td>n/a</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";


	$apc = round($expE/$pc1); // dit is het percentage
	if ($apc>30) {
		$a1 = "<font color='ff0000'>";
		$a2 = "</font>";
	} else {
		unset($a1);
		unset($a2);
	}


	$sql = "SELECT * FROM ".CRM_PRIORITY_VARS_TABLE." ORDER BY varname";
	$result= mcq($sql,$db);
    while ($e= mysql_fetch_array($result)) {

			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE priority='$e[varname]'";
			$result1= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($result1);

			$bla = $maxU1[0];

			$pc1 = ($maxEo/100); // dit is 1 procent

			$pc2 = ($bla/100); // dit is 1 procent van not [deleted]

			$apc = round($bla/$pc1); // dit is het percentage

			print "<tr><td bgcolor='" . $e['color'] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$e[varname]</td><td width=\"20%\">$bla</td><td width=\"20%\">$apc%</td></tr>";
			$totaal=$totaal+$bla;
	}

	print "<tr><td>&nbsp;</td></tr>";
	print "<tr><td>$lang[edd]</td><td>$expE</td><td>$a1$apc%$a2</td></tr>";

	$apc = round($obsE/$pc1); // dit is het percentage
	if ($apc>30) {
		$a1 = "<font color='ff0000'>";
		$a2 = "</font>";
	} else {
		unset($a1);
		unset($a2);
	}

	print "<tr><td>$lang[dontbelonghere]</td><td>$obsE</td><td>$a1$apc%$a2</td></tr>";
	$apc = round($waiE/$pc1); // dit is het percentage
		if ($apc>30) {
		$a1 = "<font color='ff0000'>";
		$a2 = "</font>";
	} else {
		unset($a1);
		unset($a2);
	}

	print "<tr><td>$lang[ewfsea]</td><td>$waiE</td><td>$a1$apc%$a2</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";
	$weeknumber = date("W");
	$sqlcounter++;
	$sql = "SELECT eid,cdate FROM ".CRM_ENTITY_TABLE."";
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

						$tmaand = substr($t,5,2);
						$tdag = substr($t,8,2);
						$tmp = date ("W", mktime (0,0,0,$tmaand,$tdag,$tjaar));
						if ($weeknumber == $tmp) {
							$thisweek++;
						}
				}
		}
	if (!$thisweek) { $thisweek=0; }
	print "<tr><td>$lang[eatw] ($weeknumber):</td><td>$thisweek</td></tr>";


	$sqlcounter++;
	$sql = "SELECT eid,closedate FROM ".CRM_ENTITY_TABLE." WHERE closedate<>'0000-00-00' AND status='close'";
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

						$tmaand = substr($t,5,2);
						$tdag = substr($t,8,2);
						$tmp = date ("W", mktime (0,0,0,$tmaand,$tdag,$tjaar));
		//				print "<tr><td>Matching $tmp against $weeknumber</td></tr>";
						if ($weeknumber == $tmp) {
							$thisweek2++;
						}
				}
		}
	if (!$thisweek2) { $thisweek2=0; }
	print "<tr><td>Entities deleted this week ($weeknumber):</td><td>$thisweek2</td></tr>";

	$month = date("F");
	$sqlcounter++;
	$sql = "SELECT eid,cdate FROM ".CRM_ENTITY_TABLE."";
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

						$tmaand = substr($t,5,2);
						$tdag = substr($t,8,2);
						$tmp = date ("F", mktime (0,0,0,$tmaand,$tdag,$tjaar));

		//				print $tmp;
						if ($month == $tmp) {
							$thismonth++;
						}
				}
		}
	if (!$thismonth) { $thismonth=0; }
	print "<tr><td>$lang[eatm] ($month):</td><td>$thismonth</td></tr>";
	$month = date("F");
	$sqlcounter++;
	$sql = "SELECT eid,closedate FROM ".CRM_ENTITY_TABLE." WHERE closedate<>'0000-00-00' and status='close'";
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

					$tmaand = substr($t,5,2);
					$tdag = substr($t,8,2);
					$tmp = date ("F", mktime (0,0,0,$tmaand,$tdag,$tjaar));
	//				print "<tr><td>Matching $tmp against $month. Date is $e[closedate] </td></tr>";
	//				print $tmp;
					if ($month == $tmp) {
						$thismonth2++;
					}
				}
		}
	if (!$thismonth2) { $thismonth2=0; }
	print "<tr><td>Entities deleted this month ($month):</td><td>$thismonth2</td></tr>";
	print "<tr><td><img src='arrow.gif'>&nbsp;<a href='$PHP_SELF?password=$password&summonth=1' class='bigsort'>Whole year summary</a></tr>";

	$sqlcounter++;
	$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE cdate<>'0000-00-00' AND closedate<>'0000-00-00' AND deleted='y'";
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$tmaand = substr($t,5,2);
				$tdag = substr($t,8,2);
				$tmp = date ("U", mktime (0,0,0,$tmaand,$tdag,$tjaar));
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$tmaand = substr($t,5,2);
				$tdag = substr($t,8,2);
				$tmp2 = date ("U", mktime (0,0,0,$tmaand,$tdag,$tjaar));
				$avg = $avg + round((($tmp-$tmp2)/86400));
				$avgc++;
	}

	print "<tr><td>&nbsp;</td></tr>";


	//print "<i>$lang[cuaeoay].</i></td></tr>";


	print "<tr><td>$lang[users]</td><td>$maxU</td></tr>";
	print "<tr><td>$lang[customers]</td><td>$maxC</td></tr>";
	print "</td></tr></table></fieldset>";
} // end func

function entities_owned_by_users() {
		global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;
		print "<tr><td colspan=4><fieldset><legend>$lang[eobu]</legend>&nbsp;</legend><table border=0>";
		print "<tr><td colspan=4>$lang[zoilo]</td></tr>";
		print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";
		print "<tr><td><b>$lang[owner]</b></td><td><b>Open<b></td><td><b>$lang[deleted]</b></td><td><b>$lang[total]</b></td><td><b>%</b></td><td>% bar</td></tr>";


		$sqlcounter++;
		$sql = "SELECT id,FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." ORDER BY name";
		$result= mcq($sql,$db);

		while ($id = mysql_fetch_array($result)) {
			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE owner='$id[id]'";
			$pr1 = mcq($sql,$db);
			$pr = mysql_fetch_array($pr1);

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE owner='$id[id]' AND deleted='y'";
			$pr1 = mcq($sql,$db);
			$prD = mysql_fetch_array($pr1);


			$pc1 = ($maxE/100); // dit is 1 procent
			$apc = round($pr[0]/$pc1); // dit is het percentage

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND owner='$id[id]'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$open = $maxU1[0];


			if (!$pr[0]==0) {
			print "<tr><td>$id[FULLNAME]</td><td>$open</td><td>$prD[0]</td><td>$pr[0]</td><td>$apc%</td><td width='100'><img src='pixel.gif' width='$apc' height=10></td></tr>\n";}

	}
	print "</table></fieldset>";
} // end func



function entities_assigned_to_users()
{
   	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;

	print "<tr><td colspan=4><fieldset><legend>$lang[eatu]</legend>&nbsp;</legend><table border=0 width='100%'>";
	print "<tr><td colspan=4>$lang[zailo]</td></tr>";

	print "<tr><td><table width='100%' border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE'>";
	print "<tr><td><b>$lang[assignee]</b></td><td><b>Open<b></td><td><b>$lang[deleted]</b></td><td><b>$lang[total]</b></td><td><b>%</b></td><td>% bar</td></tr>";

	$sqlcounter++;
$sql = "SELECT id,FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." ORDER BY name";
	$result= mcq($sql,$db);

	while ($id = mysql_fetch_array($result)) {
		$sqlcounter++;
$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE assignee='$id[id]'";
		$pr1 = mcq($sql,$db);
		$pr = mysql_fetch_array($pr1);
		$sqlcounter++;
$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE assignee='$id[id]' AND deleted='y'";
		$pr1 = mcq($sql,$db);
		$prD = mysql_fetch_array($pr1);
		$pc1 = ($maxE/100); // dit is 1 procent
		$apc = round($pr[0]/$pc1);


		$sqlcounter++;
$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND assignee='$id[id]'";
		$resul1t= mcq($sql,$db);
		$maxU1 = mysql_fetch_array($resul1t);
		$open = $maxU1[0];


		if (!$pr[0]==0) {
			print "<tr><td>$id[FULLNAME]</td><td>$open</td><td>$prD[0]</td><td>$pr[0]</td><td>$apc%</td><td width='100'><img src='pixel.gif' width='$apc' height=10></td></tr>\n";}

	}
	print "</table></tr></td></table></fieldset>";
} // end func



function self_assigned()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;
	print "<tr><td colspan=4><fieldset><legend>$lang[sae]</legend>&nbsp;</legend><table border=0>";
	print "<tr><td colspan=4>$lang[ombla]</td></tr>";
	print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";
	print "<tr><td><b>$lang[owner] (<b>$lang[andassignee]</b>)</td><td><b>$lang[selfassig]</b></td><td><b>%</b></td></tr>";

	$sqlcounter++;
	$sql = "SELECT DISTINCT owner FROM ".CRM_ENTITY_TABLE." WHERE ".CRM_ENTITY_TABLE.".owner=".CRM_ENTITY_TABLE.".assignee AND deleted<>'y' ORDER BY owner";
	$result= mcq($sql,$db);
		while ($id = mysql_fetch_array($result)) {

			$sqlcounter++;

			$name = GetUserName($id['owner']);

			if (trim($name)=="") {
					$name = $id[owner];
			}
			if ($name=="2147483647") {
					$name = "[unassigned]";
			}

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND owner='$id[owner]'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top1 = $maxU1[0];
			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND owner='$id[owner]' AND ".CRM_ENTITY_TABLE.".owner=".CRM_ENTITY_TABLE.".assignee";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top2 = $maxU1[0];

			$top1pc = $top1 / 100;
			$top2pc = round($top2 / $top1pc);

		print "<tr><td>$name</td><td>$top2 out of $top1</td><td>$top2pc%</td></tr>";
		}
	print "</table>";
	print "$lang[aohnsae]</fieldset>";

} // end func

function overdue_per_assignee()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$cdate,$lang;

	print "<tr><td colspan=4><fieldset><legend>$lang[oepa]</legend>&nbsp;</legend><table border=0>";
	print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";


	print "<tr><td><b>$lang[assignee]</b></td><td><b>Overdue</b></td><td><b>%</b></td></tr>";

	$sqlcounter++;
	$sql = "SELECT DISTINCT assignee FROM ".CRM_ENTITY_TABLE." WHERE sqldate<'$cdate' AND status<>'close' AND deleted<>'y' ORDER BY assignee";
	$result= mcq($sql,$db);
		while ($id = mysql_fetch_array($result)) {

			$name = GetUserName($id['assignee']);

			if ($name=="2147483647") {
					$name = "[unassigned]";
			}

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND status<>'close' AND assignee='$id[assignee]'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top1 = $maxU1[0];
			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND status<>'close' AND assignee='$id[assignee]' AND sqldate < '$cdate'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top2 = $maxU1[0];

			$top1pc = $top1 / 100;
			$top2pc = round($top2 / $top1pc);

		print "<tr><td>$name</td><td>$top2 out of $top1</td><td>$top2pc%</td></tr>";
		}
	print "</table>";
	$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE sqldate<'$cdate' AND status<>'close'";
	$resul1t= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($resul1t);
	$top3 = $maxU1[0];
	$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE status<>'close'";
	$result= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($result);
	$maxNC = $maxU1[0];
		$tmp = $maxNC / 100;
		$prt = round($top3 / $tmp);

	print "<br>$lang[onavarage] $prt% of all entities is overdue.";
	print "Other assignees have no overdue entities.</fieldset>";

} // end func



function didntbelonghere()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;

	print "<tr><td colspan=4><fieldset><legend>$lang[etdbh]</legend>&nbsp;</legend><table border=0>";
	print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";
	print "<tr><td><b>$lang[owner]</td><td><b>$lang[etdbh]</b></td><td><b>%</b></td></tr>";



	$sqlcounter++;
	$sql = "SELECT DISTINCT owner FROM ".CRM_ENTITY_TABLE." WHERE obsolete='y' AND status='open' ORDER BY owner";
	$result= mcq($sql,$db);
		while ($id = mysql_fetch_array($result)) {

			$name = GetUserName($id['owner']);

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE status='open' AND owner='$id[owner]'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top1 = $maxU1[0];
			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE status='open' AND owner='$id[owner]' AND obsolete='y'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top2 = $maxU1[0];

			$top1pc = $top1 / 100;
			$top2pc = round($top2 / $top1pc);

		print "<tr><td>$name</td><td>$top2 out of $top1</td><td>$top2pc%</td></tr>";
		}
	print "</table>";
	$sqlcounter++;
	$sqlcounter++;
	$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE status='open'";
	$result= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($result);
	$maxtmp = $maxU1[0];
	$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE obsolete='y' AND status='open'";
	$resul1t= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($resul1t);
	$top3 = $maxU1[0];

		$tmp = $maxtmp / 100;
		$prt = @round($top3 / $tmp);

	print "$lang[onavarage] $prt% $lang[oaoedbh].</fieldset>";
} // end func



function elseaction()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;
	print "<tr><td colspan=4><fieldset><legend>$lang[ewfsea]</legend>&nbsp;</legend><table border=0>";
	print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";

	print "<tr><td><b>$lang[assignee]</td><td><b>$lang[ewfsea]</b></td><td><b>%</b></td></tr>";

	$sqlcounter++;
	$sql = "SELECT DISTINCT assignee FROM ".CRM_ENTITY_TABLE." WHERE waiting='y' AND status<>'close' ORDER BY assignee";
	$result= mcq($sql,$db);
		while ($id = mysql_fetch_array($result)) {


			$name = GetUserName($id['assignee']);

			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND assignee='$id[assignee]'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top1 = $maxU1[0];
			$sqlcounter++;
			$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND assignee='$id[assignee]' AND waiting='y'";
			$resul1t= mcq($sql,$db);
			$maxU1 = mysql_fetch_array($resul1t);
			$top2 = $maxU1[0];

			$top1pc = $top1 / 100;
			$top2pc = @round($top2 / $top1pc);

		print "<tr><td>$assignee</td><td>$top2 out of $top1</td><td>$top2pc%</td></tr>";
		}
	print "</table>";
	$sqlcounter++;
$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE waiting='y'";
	$resul1t= mcq($sql,$db);
	$maxU1 = mysql_fetch_array($resul1t);
	$top3 = $maxU1[0];

		$tmp = $maxE / 100;
		$prt = round($top3 / $tmp);

	print "$lang[onavarage] $prt% of all entities is waiting for somebody else's action.</fieldset>";
} // end func



function entities_per_customer()
{
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$lang;
	print "<tr><td colspan=4><fieldset><legend>$lang[epc]</legend>&nbsp;</legend><table border=0>";
	print "</table><table border=1' cellspacing='0' cellpadding='2' bordercolor='#CECECE' width='100%'>";
	print "<tr><td><b>$lang[customer]</b></td><td><b>Open<b></td><td><b>$lang[deleted]</b></td><td><b>$lang[total]</b></td><td><b>%</b></td><td>% bar</td></tr>";

	$sqlcounter++;
	$sql = "SELECT id,custname FROM ".CRM_CUSTOMER_TABLE." ORDER BY custname";
	$result= mcq($sql,$db);

	while ($id = mysql_fetch_array($result)) {
		$sqlcounter++;
		$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE CRMcustomer='$id[id]'";
		$pr1 = mcq($sql,$db);
		$pr = mysql_fetch_array($pr1);
		$pc1 = ($maxE/100); // dit is 1 procent
		$apc = round($pr[0]/$pc1);


		$sqlcounter++;
		$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE CRMcustomer='$id[id]' AND deleted='y'";
		$pr1 = mcq($sql,$db);
		$prD = mysql_fetch_array($pr1);
		$sqlcounter++;
		$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND CRMcustomer='$id[id]'";
		$resul1t= mcq($sql,$db);
		$maxU1 = mysql_fetch_array($resul1t);
		$open = $maxU1[0];

		print "<tr><td>$id[custname]</td><td>$open</td><td>$prD[0]</td><td>$pr[0]</td><td>$apc%</td><td width='100'><img src='pixel.gif' width='$apc' height=10></td></tr>\n";

	}
	print "</table></fieldset>";
} // end func


function summonth() {
	global $sqlcounter,$maxU,$maxo,$maxE,$maxEo,$maxEc,$maxEa,$delE,$obsE,$maxC,$expE,$password,$lang;
	$debug = 0;
	print "<tr><td colspan=4><hr></td></tr>";
	print "<tr><td colspan=5>";
	print "</td></tr>";
	$year = date("Y");
	print "<tr><td colspan=4><font size=+1>Entity year summary for $year</font><br><br></td></tr>";
	print "<tr><td colspan=8><table border=1>";
	print "<tr><td><b>Weeknumber</b></td><td><b>Added</b></td><td><b>Closed</b></td></tr>";
	$weeknumber = date("W");
	for ($weeknumber=0;$weeknumber<53;$weeknumber++) {
	$sqlcounter++;
	$sql = "SELECT eid,cdate FROM ".CRM_ENTITY_TABLE."";
	if ($debug) { print $sql; }
	// WHERE status='open'
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {
					$tmaand = substr($t,5,2);
					$tdag = substr($t,8,2);
					$tmp = date ("W", mktime (0,0,0,$tmaand,$tdag,$tjaar));
					if ($weeknumber == $tmp) {
						$thisweek++;
					}
				} else {
//					print "Year error";
				}
		}
	if (!$thisweek) { $thisweek=0; }
	$sqlcounter++;
	//status='close' AND
	$sql = "SELECT eid,closedate FROM ".CRM_ENTITY_TABLE." WHERE closedate<>'0000-00-00' AND status='close'";
	if ($debug) { print $sql; }
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {
					$tmaand = substr($t,5,2);
					$tdag = substr($t,8,2);
					$tmp = date ("W", mktime (0,0,0,$tmaand,$tdag,$tjaar));
	//				print "<tr><td>Matching $tmp against $weeknumber</td></tr>";
					if ($weeknumber == $tmp) {
						$thisweek2++;
					}
				}
		}
	if (!$thisweek2) { $thisweek2=0; }


	if ((!$thisweek==0) || (!$thisweek2==0)) {
		print "<tr><td>$weeknumber</td><td>$thisweek</td><td>$thisweek2</td></tr>";
	}

	unset($thisweek);
	unset($thisweek2);
	}

	print "</table></td></tr>";
	print "<tr><td colspan=8><table border=1>";
	print "<tr><td><b>Month</b></td><td><b>Added</b></td><td><b>Closed</b></td></tr>";

	for ($x=2;$x<14;$x++) {
	$month = date("F", mktime (0,0,0,$x,0,0));
	$sqlcounter++;
	// WHERE status='open'
	$sql = "SELECT eid,cdate FROM ".CRM_ENTITY_TABLE."";
	if ($debug) { print $sql; }
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

					$tmaand = substr($t,5,2);
					$tdag = substr($t,8,2);
					$tmp = date ("F", mktime (0,0,0,$tmaand,$tdag,$tjaar));

	//				print $tmp;
					if ($month == $tmp) {
						$thismonth++;
					}
				}
		}
	if (!$thismonth) { $thismonth=0; }

	$sqlcounter++;
	$sql = "SELECT eid,closedate FROM ".CRM_ENTITY_TABLE." WHERE closedate<>'0000-00-00' AND status='close'";
	if ($debug) { print $sql; }
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$year = date("Y");
				if ($tjaar == $year) {

						$tmaand = substr($t,5,2);
						$tdag = substr($t,8,2);
						$tmp = date ("F", mktime (0,0,0,$tmaand,$tdag,$tjaar));
		//				print "<tr><td>Matching $tmp against $month. Date is $e[closedate] </td></tr>";
		//				print $tmp;
						if ($month == $tmp) {
							$thismonth2++;
						}
				}
		}
	// Yet try to determine the average 'open-time' in this week only

	if (!$thismonth2) { $thismonth2=0; }
	print "<tr><td>$month</td><td>$thismonth</td><td>$thismonth2</td></tr>";
	unset ($thismonth);
	unset ($thismonth2);


	}
	$sqlcounter++;
	$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE cdate<>'0000-00-00' AND closedate<>'0000-00-00' AND status='close'";
	if ($debug) { print $sql; }
	$result= mcq($sql,$db);
        while ($e= mysql_fetch_array($result)) {
				$t = $e[closedate];
				$tjaar = substr($t,0,4);
				$tmaand = substr($t,5,2);
				$tdag = substr($t,8,2);
				$tmp = date ("U", mktime (0,0,0,$tmaand,$tdag,$tjaar));
				$t = $e[cdate];
				$tjaar = substr($t,0,4);
				$tmaand = substr($t,5,2);
				$tdag = substr($t,8,2);
				$tmp2 = date ("U", mktime (0,0,0,$tmaand,$tdag,$tjaar));
				//print "<tr><td>Date is $e[cdate] $tmp2 till $e[closedate] $tmp";
//				print "<br> diff is " . ($tmp-$tmp2) . " which is about " . round((($tmp-$tmp2)/86400)) . " days";
				$avg = $avg + round((($tmp-$tmp2)/86400));
				$avgc++;
//				print "</td></tr>";
	}
	print "</tr></td></table><tr><td colspan=5>&nbsp;</td></tr></";
	$sqlcounter++;
	//status='close' AND
	$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE closedate='0000-00-00' AND status='close'";
	if ($debug) { print $sql; }
	$result= mcq($sql,$db);
	$maxW = mysql_fetch_array($result);
	$maxWc = $maxW[0];

	print "<tr><td colspan=5>Of $avgc entities counted, the overall average 'open-time' was " . @round($avg/$avgc) . " days.<br><i>Counted using <u>all</u> closed entities in the database, over <u>all</u> years. There were $maxWc entities closed before this CRM was logging the closeure date.</i></td></tr>";




}
function getmicrotime(){
    list($usec, $sec) = explode(" ",microtime());
    return ((float)$usec + (float)$sec);
}
function StartPDF() {
	global $pdf;
	$pdf=new PDF();
	$pdf->Open();
	$pdf->AliasNbPages();
	$pdf->AddPage();
	$pdf->SetFont('Times','',12);
	$pdf->SetFont('Arial','',8);
}

function StartPrintPDF() {
	global $pdf;
	$pdf=new PDF_AutoPrint();
	$pdf->Open();
	$pdf->AliasNbPages();
	$pdf->AddPage();
	$pdf->SetFont('Times','',12);
	$pdf->SetFont('Arial','',8);
	$pdf->AutoPrint(false);
}


function toc($pdfa) {
		global $pdf,$shell_status;
		if ($shell_status) {
				print "CreatePDFTOC: Creating TOC of " . sizeof($pdfa) . " entities\n";
				print "|--------------------------------------------------| 100%\n[";
		}
		$pdf->SetFillColor(244,209,137);
		line();
		$pdf->SetFont('Arial','',18);

		$pdf->Cell(0,10, $pdf_title2 . " " . $lang[entsum],0,1,"C");
		line();
		$pdf->Ln(1);

		$pdf->SetFont('Arial','',8);

		$top = sizeof($pdfa);

		for ($op=0;$op<$top;$op++) {
			if (!$pdfa[$op]=="") {
				if ($shell_status) {

					$pc1 = $top/100; // 1% van totaal
					$pc2 = round($op/$pc1);


					if ($pc2 > ($oldpc+1)) {
						$oldpc = $pc2;
						print "#";
					}
				}
				CheckEntityAccess($pdfa[$op]);
				$sql = "SELECT category FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $pdfa[$op] . "'";
				$result = mcq($sql,$db);
				$cat = mysql_fetch_array($result);
				$pdf->Write(5, "- ");

				$id = fillout($pdfa[$op],5);

				$pdf->SetTextColor(0,0,255);
				$$pdfa[$op]=$pdf->AddLink();
				$pdf->Write(5, $id . " : " . $cat[0] ,$op);
				$pdf->Ln(4);
				$pdf->SetTextColor(0);
			}
		}
		if ($shell_status) {
			print "]\n";
		}

		line();
		$pdf->Ln(1);
		$pdf->AddPage();
}
function CreatePDF($pdfa,$file='') {
	global $pdf,$in_line,$shell_status;
	$data = array();

	if ($shell_status) { // if run on command line (generate_total_pdf_summary.php)
				print "CreatePDF: Creating report of " . sizeof($pdfa) . " entities\n";
				print "|--------------------------------------------------| 100%\n[";
	}



	$top = sizeof($pdfa);


	for ($op=0;$op<$top;$op++) {

		if (!$pdfa[$op]=="") {
			if ($shell_status) {

					$pc1 = $top/100; // 1% van totaal
					$pc2 = round($op/$pc1);


					if ($pc2 > ($oldpc+1)) {
						$oldpc = $pc2;
						print "#";
					}




			}
			$pdf->SetLink($op);
			$pdf->AddLink();

			cat_sum($pdfa[$op]);

			$pdf->SetFont('','');
			$pdf->SetFont('Arial','B',8);
			$pdf->Ln(20);

			if ($op<(sizeof($pdfa)-1)) {
				$pdf->AddPage();
			}
		} else {
			if ($shell_status) {
				print "CreatePDF: error " . $op . " is empty.";
			}
		}
	}

	$date = date("F j, Y, H:i") . "h";

	$pdf->Output($file);

	if ($shell_status) {
		print "]\n";
	}
	$GLOBALS['CURFUNC'] = "SumPDF::";
	qlog("PDF Summary generated - quit.");
}

function cat_sum($e) {
		global $a,$data,$pdf,$DateFormat,$NoImageInclude,$in_line,$internal_catsum_counter;
		global $tc,$lang,$pdf_title,$language,$session,$include,$filename_to_disk,$filename_to_disk_to_use;

		// Generates PDF report for 1 entity

		$sql = "SELECT * FROM ".CRM_ENTITY_TABLE." WHERE eid='$e'";
		$result= mcq($sql,$db);
		$ea = mysql_fetch_array($result);

		$owner       = GetUserName($ea['owner']);
		$assignee    = GetUserName($ea['assignee']);
		$customer    = GetCustomerName($ea['CRMcustomer']);
		$Statuscolor = hex2rgb(GetStatusColor($ea[status]));
		$Priocolor   = hex2rgb(GetPriorityColor($ea[priority]));

		if ($ea['closeepoch']=="") {
			$nowepoch = date('U');
			$txt = "Age";
		} else {
			$nowepoch = $ea['closeepoch'];
			$txt = "Duration";
		}
		if ($ea['openepoch']=="") {
				$age = "";
		} else {
			$age_in_seconds = $nowepoch - $ea['openepoch'];

			if ($age_in_seconds>86400) {
				$age = "($txt: " . ceil($age_in_seconds/86400) . " days)";
			} elseif ($age_in_seconds>3600) {
				$age = "($txt: " . ceil($age_in_seconds/3600) . " hours)";
			} elseif ($age_in_seconds>60) {
				$age = "($txt: " . ceil($age_in_seconds/60) . " minutes)";
			} elseif ($age_in_seconds<>$nowepoch) {
				$age = "($txt: " . ceil($age_in_seconds) . " seconds)";
			}
		}
		$t = $ea[tp]; // timestamp last edit
		$tp[jaar] = substr($t,0,4);
		$tp[maand] = substr($t,4,2);
		$tp[dag] = substr($t,6,2);
		$tp[uur] = substr($t,8,2);
		$tp[min] = substr($t,10,2);
		$cdate = explode("-",$ea[cdate]);

		// Add zero's ie. 2-7-2003 must become 02-07-2003

		if (strlen($cdate[0])==1) {
				$cdate[0] = "0" . $cdate[0];
		}
		if (strlen($duedate[1])==1) {
				$cdate[1] = "0" . $cdate[1];
		}

		if (!$NoImageInclude) {

			if (!$include) {
				$subdir = ereg_replace("sumpdf.php","",$_SERVER['SCRIPT_NAME']);
			} else {
				$subdir = ereg_replace("dump_to_disk.php","",$_SERVER['SCRIPT_NAME']);
			}

			if ($getset) {
				$subdir = ereg_replace("edit.php","",$_SERVER['SCRIPT_NAME']);
			}

			if (!$filename_to_disk) {
				$filename_to_disk_to_use = tempnam("","CRM_TMP_BIN_");
			} else {
				$internal_catsum_counter++;
				$filename_to_disk_to_use = $filename_to_disk . $internal_catsum_counter;
			}

			DisplayEntityActivityGraph($e);

			$pdf->Image($filename_to_disk_to_use,150,37,44,'','png','http://' . $_SERVER['SERVER_NAME'] . $subdir . 'edit.php?e=' . $e);

			unlink($filename_to_disk_to_use);
			unset($filename_to_disk_to_use);
		}

		$cdate = TransformDate($cdate[2] . "-" . $cdate[1] . "-" . $cdate[0]);
		$pdf->SetFont('Arial','',12);
	    $pdf->SetFillColor(128,0,0);
	    $pdf->SetTextColor(255);
		$pdf->Cell(0,6,($lang['summary']) . " : " . $ea['category'],1,1,'L',1);
	    $pdf->SetTextColor(0);
		$pdf->SetFont('Arial','',6);
		$pdf->Cell(0,6,"$pdf_title",0,1);
	    line();
		$pdf->SetFont('Arial','',10);
		$pdf->Cell(0,4,"$lang[entity] $e $lang[ownedby] $owner, $lang[assignedto] $assignee.",0,1);
		$pdf->Cell(0,6,"$lang[created] $cdate, $lang[lastupdate] " . TransformDate("$tp[dag]-$tp[maand]-$tp[jaar]") . " $tp[uur]:$tp[min]h.". " " . $age,0,1);
		$pdf->SetFillColor($Statuscolor[0],$Statuscolor[1],$Statuscolor[2]);

		$a1 = "$lang[curstat]: $ea[status]";
		$bla1 = $pdf->GetStringWidth($a1)+6;
		$a2 = "$lang[priority]: $ea[priority]";
		$bla2 = $pdf->GetStringWidth($a2)+6;

		if ($bla1>$bla2) {
			$wdth = $bla1;
		} else {
			$wdth = $bla2;
		}

		$pdf->Cell(1,6,0,0,0,0,0);
		$pdf->Cell($wdth,6,$a1,1,0,1,1);
//		$pdf->Ln(1);
		$pdf->Cell(1,6,0,0,0,0,0);
	    $pdf->SetFillColor(128,0,0);
		$pdf->SetFillColor($Priocolor[0],$Priocolor[1],$Priocolor[2]);
		$pdf->Cell($wdth,6,$a2,1,1,1,1);
		$pdf->SetFillColor(128,0,0);
		$pdf->Cell(0,10,"$lang[customer]: $customer",0,1);
		$pdf->SetFont('Arial','',8);

		line();

		if ($ea[content]=="") {
			$ea[content]="-";
		}

		$n = explode("\n",$ea[content]);

		for ($n1=0;$n1<sizeof($n);$n1++) {
				$nt = wordwrap($n[$n1], 120, "HOPS!", 1);
				$nta = explode("HOPS!",$nt);
				for ($i=0;$i<sizeof($nta);$i++) {
					$pdf->Cell(0,4,trim($nta[$i]),0,1);
				}
			}



		$sql = "SELECT COUNT(*) FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$ea[eid]'";
		$result = mcq($sql,$db);
		$num = mysql_fetch_array($result);
		if ($num[0]>0) {
			line();
			$pdf->SetFont('Arial','',10);
			$pdf->Cell(0,10,"This entity has files attached:",0,1);
			$pdf->SetFont('Arial','',8);
			$data = array();
			$header=array("Creation date",'Size','User','Filename');

			if ($DateFormat=="mm-dd-yyyy") {
				$sql= "SELECT filename,creation_date,filesize,fileid,username,date_format(creation_date, '%m-%d-%Y %H:%i') AS dt FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$ea[eid]' ORDER BY filename";
			} else {
				$sql= "SELECT filename,creation_date,filesize,fileid,username,date_format(creation_date, '%d-%m-%Y %H:%i') AS dt FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$ea[eid]' ORDER BY filename";
			}
			$result7= mcq($sql,$db);
			while ($files= mysql_fetch_array($result7)) {

				$ownert = GetUserNameByName($files[username]);

				$url = "http://" . $_SERVER['SERVER_NAME'] . $subdir . "csv.php?fileid=" . $files['fileid'];
				array_push($data,array($files['dt'],round(($files[filesize]/1024)). "K",$ownert,$url,$files['filename']));
				$ftel++;
				$tel++;
			}
				$pdf->FancyTable4colSinglePDF($header,$data);

		}


			// Extra fields list

		$sql19 = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra fields list'";

		$resultop = mcq($sql19,$db);
		$list = mysql_fetch_array($resultop);
		$list = $list[value];
		$list = @explode(",",$list);

		$sql110 = "SELECT COUNT(*) FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$ea[eid]'";
		$result1 = mcq($sql110,$db);
		$num = mysql_fetch_array($result1);

		if (sizeof($list)>1 && $num[0]>0) {
			$pdf->Ln(6);
			line();
			$pdf->SetFont('Arial','',10);
			$pdf->Cell(0,10,"Custom fields:",0,1);
			$pdf->SetFont('Arial','',8);
			$data = array();
			//$header=array("Field","Value");

			for ($po=0;$po<sizeof($list);$po++) {

					$sql0 = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$ea[eid]' AND deleted<>'y' AND name='$list[$po]' ORDER BY name";
//					print $sql;

					$result8 = mcq($sql0,$db);
					$cust= mysql_fetch_array($result8);
					$val = $cust[value];
					if (strstr($list[$po],"DD_")) {
						$list[$po] = ereg_replace("DD_","",$list[$po]);
						$tmp = explode("|",$list[$po]);
						$list[$po] = $tmp[0];
					}
					if (strstr($list[$po],"TB_")) {
						$list[$po] = ereg_replace("TB_","",$list[$po]);
					}
					//if ($val<>"") {
					//	array_push($data,array($list[$po],$val));
					//}
					// Print out the data
					$pdf->SetFont('Arial','',10);
					$pdf->SetFillColor(0,0,128);
					$pdf->SetTextColor(255);
					$pdf->Cell(0,6,($list[$po]),1,1,'L',1);
					$pdf->SetFont('Arial','',8);
					$pdf->SetFillColor(0,0,0);
					$pdf->SetTextColor(0);
					//Have to convert custom fields to multiline
					$val = $cust[value];

					line();

					if ($val=="") {
						$val="-";
					}

					$n = explode("\n",$val);

					for ($n1=0;$n1<sizeof($n);$n1++) {
						$nt = wordwrap($n[$n1], 120, "HOPS!", 1);
						$nta = explode("HOPS!",$nt);
						for ($i=0;$i<sizeof($nta);$i++) {
							$pdf->Cell(0,4,trim($nta[$i]),0,1);
						}
					}

			}
			//$pdf->FancyTable2col($header,$data);
			unset($header);
			unset($data);
			unset($num);
			unset($list);
		}


		$pdf->Ln(8);

		line();


}
function MainCalendar() {
		global $MainPageCalendar,$MonthsToShow;
		$MainPageCalendar=1;
		print "<tr><td><table border='0'><tr><td><fieldset><legend align='left'>Calendar&nbsp;</legend>";
		include("calendar.php");
		print "</fieldset></td></tr></table>";
}

function TodaysEntities() {
	global $fullname, $lang, $user_id, $alreadyshowed, $date;
	$sql = "SELECT ".CRM_ENTITY_TABLE.".eid AS id, ".CRM_ENTITY_TABLE.".category AS cat,".CRM_LOGIN_USERS_TABLE.".FULLNAME AS name, ".CRM_CUSTOMER_TABLE.".custname AS cust FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE duedate='$date' AND ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".assignee AND ".CRM_ENTITY_TABLE.".deleted='n' ORDER BY ".CRM_CUSTOMER_TABLE.".custname";

	print "<tr><td NOWRAP><fieldset><legend align='left'>$lang[entities]&nbsp;</legend><table border=0 WIDTH=100%>";
	$toprint0 = "<tr><td NOWRAP colspan=2>$lang[entitiestoday]:</td></tr>";

	$result= mcq($sql,$db);
	  while ($today= mysql_fetch_array($result)) {
						$toprint1 .= "<tr><td NOWRAP width='10%'><b>&nbsp;- $today[id]</td><td NOWRAP><a href='edit.php?e=$today[id]' class='bigsort'>$today[cust]</a></td><td NOWRAP><a href='edit.php?e=$today[id]' class='bigsort'>$today[cat] ($lang[assignedto] $today[name])</a></b></td></tr>";
					 }
	  if ($toprint1) {
		  print $toprint0 . $toprint1;

	  }   else {
			print "<tr><td NOWRAP colspan=2>$lang[noentities].</td></tr>";
	  }
	  print "</table></fieldset></td></tr>";
}

function RecentEntities() {
		global $fullname, $lang, $user_id, $alreadyshowed;
		$ShowRecentEditedEntities = 10;
		print "<tr><td NOWRAP><fieldset><legend>$fullname's recent " . strtolower($lang[entities]) . "</legend><table width='100%' border=0>";
		if ($ShowRecentEditedEntities>20) $ShowRecentEditedEntities=20;
		$sql = "SELECT ".CRM_ENTITY_TABLE.".eid AS id, ".CRM_ENTITY_TABLE.".category AS cat,tp,".CRM_LOGIN_USERS_TABLE.".FULLNAME AS name, ".CRM_CUSTOMER_TABLE.".custname AS cust FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE lasteditby='" . $user_id . "' AND deleted <> 'yes' AND ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".assignee AND ".CRM_ENTITY_TABLE.".deleted='n' ORDER BY tp DESC LIMIT " . $ShowRecentEditedEntities;
		$result= mcq($sql,$db);
		while ($recent= mysql_fetch_array($result)) {
			if (!in_array($recent[id],$alreadyshowed)) print "<tr><td NOWRAP width=10%><b>&nbsp;- $recent[id]</td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cust]</a></td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cat] ($lang[assignedto] $recent[name])</a></b></td></tr>";
			$count++;
		}
		if ($count<1) {
				print "<tr><td NOWRAP width='10%'>$lang[noentities]</td></tr>";
		}
		print "</table></fieldset></td></tr>";
}

function AllEntitiesOwned() {
		global $fullname, $lang, $user_id, $alreadyshowed;
		print "<tr><td NOWRAP><fieldset><legend>$fullname's " . strtolower($lang[entities]) . " (" . strtolower($lang[owner]) . ")&nbsp;</legend><table width='100%' border=0>";

		$sql = "SELECT ".CRM_ENTITY_TABLE.".eid AS id, ".CRM_ENTITY_TABLE.".category AS cat,tp,".CRM_LOGIN_USERS_TABLE.".FULLNAME AS name, ".CRM_CUSTOMER_TABLE.".custname AS cust FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE owner='" . $user_id . "' AND deleted <> 'yes' AND ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".assignee AND ".CRM_ENTITY_TABLE.".deleted='n' ORDER BY tp DESC";
		$result= mcq($sql,$db);
		while ($recent= mysql_fetch_array($result)) {
			if (!in_array($recent[id],$alreadyshowed)) print "<tr><td NOWRAP width='10%'><b>&nbsp;- $recent[id]</td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cust]</a></td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cat] ($lang[assignedto] $recent[name])</a></b></td></tr>";
			$count++;
		}
		if ($count<1) {
				print "<tr><td NOWRAP width='10%'>$lang[noresults]</td></tr>";
		}
		print "</table></fieldset></td></tr>";
}

function AllEntitiesAssignee() {
		global $fullname, $lang, $user_id, $alreadyshowed;
		print "<tr><td NOWRAP><fieldset><legend>$fullname's " . strtolower($lang[entities]) . " (" . strtolower($lang[assignee]) . ")&nbsp;</legend><table width='100%' border=0>";

		$sql = "SELECT ".CRM_ENTITY_TABLE.".eid AS id, ".CRM_ENTITY_TABLE.".category AS cat,tp,".CRM_LOGIN_USERS_TABLE.".FULLNAME AS name, ".CRM_CUSTOMER_TABLE.".custname AS cust FROM ".CRM_ENTITY_TABLE.",".CRM_CUSTOMER_TABLE.",".CRM_LOGIN_USERS_TABLE." WHERE assignee='" . $user_id . "' AND deleted <> 'yes' AND ".CRM_CUSTOMER_TABLE.".id=".CRM_ENTITY_TABLE.".CRMcustomer AND ".CRM_LOGIN_USERS_TABLE.".id=".CRM_ENTITY_TABLE.".assignee AND ".CRM_ENTITY_TABLE.".deleted='n' ORDER BY tp DESC";
		$result= mcq($sql,$db);
		while ($recent= mysql_fetch_array($result)) {
			if (!in_array($recent[id],$alreadyshowed)) {
				print "<tr><td NOWRAP width='10%'><b>&nbsp;- $recent[id]</td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cust]</a></td><td NOWRAP><a href='edit.php?e=$recent[id]' class='bigsort'>$recent[cat] ($lang[assignedto] $recent[name])</a></b></td></tr>";
				$count++;
			}
		}
		if ($count<1) {
				print "<tr><td NOWRAP width='10%'>$lang[noresults]</td></tr>";
		}
		print "</table></fieldset></td></tr>";
}
function printheader($menu)
{
		global $title,$logo,$NoMenu,$lang;
		?>
		<html>
		<head>
		<title>C R M management interface - <?php echo $title; ?></title>
		<META HTTP-EQUIV="Expires" CONTENT="0">
		<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		</head>
		<script language="JavaScript">
		<!--

		// Write the correct stylesheet into the document
		if (navigator.appName.indexOf('Microsoft') > -1) {
			// IE stylesheet
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
			} else {
			// NS stylesheet (gheghe, the same :) )
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
		}
		function pophelp(i)	{
						newWindow = window.open('help.php?id=' + i, 'HelpWindow' + i,'width=350,height=300,directories=0,status=0,menuBar=0,scrollBars=1,resizable=1');
		}

		function popupdater(i,id)	{
			newWindow = window.open('management.php?override=1&loguser=' + id + '&NoMenu=1&e=' + i, 'Update' + i,'width=640,height=630,directories=0,status=0,menuBar=0,scrollBars=1,resizable=1');
			}

		function popcalendar()	{
						newWindow = window.open('calendar.php', 'myWindow2','width=500,height=430,directories=0,status=0,menuBar=0,scrollBars=0,resizable=1');
				}

				//-->
		</SCRIPT>
		<body bgcolor="#ffffff" leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" link="#336699" text="#333333" alink="white" vlink="#666666"">

		<table border="0" width="100%"><tr><td>
		<table border="0" width="100%" cellpadding="0" cellspacing="0">
<?php

		 if (!$NoMenu) {
			 ?>
		<tr><td valign="top">
		<fieldset><legend><img src='arrow.gif'>&nbsp;<a class='bigsort' title='Log out' href='index.php?logout=1'><?php echo $lang[logout];?></a>&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='Log out' href='management.php'><?php echo $lang[entities];?></a>&nbsp;</legend><table><tr><td>

		<?php
		$today = date("F j, Y, H:i") . "h.";
		$result[value]=0;

		?>
		</td><td align=right valign='center'>
		<?php

		    print "&nbsp;";

		print "</td></tr>";
	}

//	print "</table>";





} // end func

function makelinks($input) // This functions makes hyperlinks from URL's or emailadresses in text
{
	// first get http:// and etc
	$input = eregi_replace("[^\"](http://[[:alnum:]#?/&=.,-~]*)",
	" <a href=\"\\1\" class=\"bigsort\" target=\"_new\">\\1</a>",
	$input);
	// and at the beginning of a line
	$input = eregi_replace("(^[a-z]*://[[:alnum:]#?/&=.,-~]*)",
	" <a href=\"\\1\" class=\"bigsort\" target=\"_new\">\\1</a>",
	$input);
	// then get the email@hosts
	$input = eregi_replace("(([a-z0-9_]<br>\\-<br>\\.)+@([^[:space:]]*)([[:alnum:]-]))",
	"<a href=\"mailto:\\1\">\\1</a>", $input);
	return($input);
}
function debug() {
		print "<!--Debug:DNGN-->\n";
}


function IsDate($date)
{
    // $date is in format dd-mm-yyyy

	$dates = split("-",$date);

	// bool checkdate ( int month, int day, int year)

	if (checkdate($dates[1],$dates[0],$dates[2])) {
	    return true;
	} else {
		return false;
	}


} // end func
function GetPacksFromProjectPage() {
	global $legend,$password,$printbox_size,$packurl;


	if (!$fd = @fopen("http://crmstage.it-combine.com/crm%20distributed/compose/get_packs.php", "r")) {
		$printbox_size = "100%";
		$legend = "<img src='error.gif'>";
		printbox("Connect to remote site failed. Your <u>server</u> needs to be able to connect to the internet for this function - or maybe the service is unavailable.<br><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='dictedit.php?password=$password&packman=1&tab=80' style='cursor:hand'>back to main language page</a>");
		EndHTML();
		exit;
	} else {

		$listarr = array();
		$urlarr = array();
		$y = 0;
		while ($line=fgets($fd,1000))
		  {
			if (!$check) {
				//crm_language_pack_remote_install // check if response is OK
				if (trim($line)<>"crm_language_pack_remote_install") {
					$printbox_size = "100%";
					$legend = "<img src='error.gif'>";
					printbox("The response was not expected. Please try again later.<br><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='dictedit.php?password=$password&packman=1&tab=80' style='cursor:hand'>back to main language page</a>");
					EndHTML();
					exit;
				} else {
					$check = 1;
				}
			} else {
				$line = trim($line);
				$tmp = split(",",$line);
				$tmp[1] = ereg_replace(".CRM","",$tmp[1]);
				$tmp[1] = ereg_replace("_"," ",$tmp[1]);
//				$tmp[0] = ereg_replace(">","",$tmp[1]);
				$listarr[$y]['url'] = $tmp[0];
				$listarr[$y]['name'] = $tmp[1];
				$y++;
				unset($tmp);
//				print_r($listarr);
			}
		  }
		  fclose ($fd);
	}

	sort($listarr);

	$legend = "Choose pack to install";
	$t = "The following language packs are available at the project page. Click on a pack to install. <br>Please mind; this procedure does not check if a pack is already installed.<br><br>";

	for ($i=0;$i<sizeof($listarr);$i++) {
		$t .= "<img src='arrow.gif'>&nbsp<a href='dictedit.php?password=$password&DLP=1&packurl=" . base64_encode($listarr[$i]['url']) . "' class='bigsort'>" . $listarr[$i]['name'] . "</a><br>";
	}
	$printbox_size = "100%";

	$t .= "<br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='dictedit.php?password=$password&packman=1&tab=80' style='cursor:hand'>back to main language page</a>";

	printbox($t);

}
function viewArray($arr)
{
	echo '<table cellpadding="0" cellspacing="0" border="1">';
	foreach ($arr as $key1 => $elem1) {
		echo '<tr>';
		echo '<td>'.$key1.'&nbsp;</td>';
		if (is_array($elem1)) { extArray($elem1); }
		else { echo '<td>'.$elem1.'&nbsp;</td>'; }
		echo '</tr>';
	}
	echo '</table>';
}

function extArray($arr)
{
	echo '<td>';
	echo '<table cellpadding="0" cellspacing="0" border="1">';
	foreach ($arr as $key => $elem) {
		echo '<tr>';
		echo '<td>'.$key.'&nbsp;</td>';
		if (is_array($elem)) { extArray($elem); }
		else { echo '<td>'.htmlspecialchars($elem).'&nbsp;</td>'; }
		echo '</tr>';
	}
	echo '</table>';
	echo '</td>';
}
function DisplayLoginForm ($err_string){
global $color1 ,$color2,$title,$CRM_VERSION,$admemail,$netscape,$lang,$host,$user,$pass,$database,$table_prefix,$QUERY_STRING;

	// Some temporary files don't get processed and they stay behind, there's nothing to do about that,
	// but this helps. Everytime a logon form is show, a quick check for expired temporary files is
	// performed (expired = older than 120 seconds)

	DeleteExpiredTempFiles();

	// Flush expired sessions (same method)
	DeleteExpiredSessions();

  ?>
  <html>
  <head>
  <title><?php echo $title; ?></title>
   <META HTTP-EQUIV="Expires" CONTENT="0">
  <META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
 	<SCRIPT LANGUAGE="javascript" SRC="cookies.js"></SCRIPT>
	<SCRIPT LANGUAGE="javascript">
	<!--
	if (navigator.appName.indexOf('Microsoft') > -1) {
	// IE stylesheet
	document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
	} else {
	// NS stylesheet (gheghe, the same :) )

	document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
}
	function setUser(){
  	setCookie('namebla',document.login.name.value)

	}
	function clearUser(){
  	setCookie('namebla','')
  	document.login.name.value ='';
	}
	function setPwd(){
			<?php
			$lang[cookiewarning] = ereg_replace("\n","",$lang[cookiewarning]);
			?>
			  alert('<?php echo $lang[cookiewarning];?>')
			  setCookie('passwordbla',document.login.password.value)
	}
	function clearPwd(){
  	setCookie('passwordbla','')
	  document.login.password.value ='';
	}
	function checkCooks(){
   		  namebla = getCookie('namebla')
	  passwordbla = getCookie('passwordbla')
			repos = getCookie('repository')
	mainpagequery = getCookie('mainpagequery')

    if (namebla && namebla != null){
      document.login.name.value = namebla;
    }
    if (passwordbla && passwordbla != null){
      document.login.password.value = passwordbla;
    }
    if (repos && repos != null){
      document.login.repository.value = repos;
    }
	 if (mainpagequery && mainpagequery != null){
      document.login.mainpagequery.value = mainpagequery;
    }

	}
	function pophelp(i)	{
			newWindow = window.open('help.php?noc=EEAC44EC12FJHGDS7697HJHG546GJHK57&id=' + i, 'HelpWindow' + i,'width=350,height=300,directories=0,status=0,menuBar=0,scrollBars=1,resizable=1');
	}

	//-->
	</SCRIPT>

		<body onLoad="checkCooks();document.login.name.focus()" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
		<?php
		$topost = $_SERVER['PHP_SELF'];
		if (!stristr($QUERY_STRING,"logout")) {
			$ins = $QUERY_STRING;
		}
	      print "<form name=login method='post' action='" . $topost . "?" . $ins . "'>"
		?>
	<table><tr><td>&nbsp;</td><td><fieldset><legend>
	<?php
			print "<a href='http://crm.it-combine.com' target='_new' class='topnav'>$CRM_VERSION</a>";
	?>
	</legend><table border="0"><tr><td>&nbsp;</td><td>
	  <table border="0" cellpadding="0" cellspacing="3">

          <tr>
		  <td valign=top><!-- <img src='password.png' border=0> --></td>
            <td nowrap>
			<font size="4"><b><?php echo $title; ?></b></font>

		</td>
          </tr>
          <tr>

          </tr>

		<tr>
            <td nowrap colspan=2>
              <font color="#cc6600">
              <?php echo $err_string; ?> &nbsp;&nbsp;</b><a OnClick='javascript:pophelp(17)' class='topnav' style='cursor: help'><img src='info.gif'></a>
              </font>

			  </td>
          </tr>
          <tr>


            <td width="286" colspan=2><fieldset>
			<legend>Log on&nbsp;</legend><table>
			<tr><td><?php echo $lang[username];?><br>
              <input type="text" name="name" tabindex=1>
            </td>
          </tr>
          <tr>
            <td width="286" colspan=2> <a class='topnav' href="javascript:setUser()" title='<?php echo $lang[saveusername];?>'><font size=-2><?php echo $lang[saveusername];?></font></a><font size=-2> | <a class='topnav' href="javascript:clearUser()" title='<?php echo $lang[clearusername];?>'><font size=-2><?php echo $lang[clearusername];?></font></a> </font>
			</td></tr>
          <tr>
            <td width="286" colspan=2><br><?php echo $lang[password];?><br>
              <input type="password" name="password" tabindex=2>
            </td>
          </tr>
          <tr>
            <td width="286" colspan=2> <a class='topnav' href="javascript:setPwd()" title='<?php echo $lang[savepassword];?>'><font size=-2><?php echo $lang[savepassword];?></font></a><font size=-2> | <a class='topnav' href="javascript:clearPwd()" title='<?php echo $lang[clearpassword];?>'><font size=-2><?php echo $lang[clearpassword];?></font></a> </font>
			</table></fieldset></td></tr>
          <tr>

		<td colspan=2><br>
			<?php

				// Get all possible CRM repository titles from all possible databases
			if (sizeof($pass)>1) {
            print "<img src='reposwhite.jpg'>&nbsp;Repository:<br><select name='repository' tabindex=3>";

				for ($r=0;$r<sizeof($pass);$r++) {

						if ($db = @mysql_connect($host[$r], $user[$r], $pass[$r])) {
							if (@mysql_select_db($database[$r],$db)) {
								$PRFX = $table_prefix[$r];
								// If no TBL_PREFIX is found, it ought to be "CRM"

								if ($PRFX=="") $PRFX="CRM";

								$sql = "SELECT value FROM ".CRM_SESSIONS_TABLE." WHERE setting='title'";
//								$result= @mcq($sql,$db);
								$result = @mysql_query($sql);
								$maxU1 = @mysql_fetch_array($result);
								$title = $maxU1[0];
								if (!$title=="") {
									print "<option value='$r'>$title</option>";
								}
							} else {
								// print "<option value=''>Host: $host[$r] Database: error stage 2</option>";
							}

						} else {
							// print "<option value=''>Host: $host[$r] Database: $database[$r] error stage 1</option>";
						}
					}
					?>
			</select>
				&nbsp;&nbsp;&nbsp;


			<?php
				} else {
					print "<input type='hidden' name='repository'>";
				}
				print "<input type='hidden' name='mainpagequery'>";
			?>
            	<input type="submit" tabindex=4 value="Login" name="submit" OnClick="javascript: setCookie('repository',document.login.repository.value)">
              <input type='hidden' name=thiswasalogin value='1'>
              <input align="right" type="button" tabindex=5 value="Back to Administration Panel" name="back" OnClick="javascript: location.href='../admin_homepage.php'">
			</td>
          </tr>
		  <tr>
			<td></td><td>
			</td>
		  </tr>
        </table>
      </form>

</td></tr></table></fieldset></td></tr></table>
</body>
  </html>
	<?php

  exit;  //Dit zorgt er voor dat de rest niet wordt geprint.
}


function GenerateSecret ($name){
	global $md5str,$lang;
	$exptime = time();
	$md5str = MD5($exptime);
/*
CREATE TABLE ".CRM_SESSIONS_TABLE." (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  temp varchar(100) NOT NULL default '',
  active enum('yes','no') NOT NULL default 'yes',
  exptime varchar(40) NOT NULL default '',
  noexp enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
) TYPE=MyISAM;
*/
	SetCookie("session",$md5str); //Set Cookie
//
	$arg = "INSERT INTO ".CRM_SESSIONS_TABLE."(temp,exptime,name) VALUES('$md5str','$exptime','$name')";
	$row = mcq($arg,$db);

	uselogger("Login $name","");

	$GLOBALS['session_id'] = $md5str;
}

function setnewtime ($actuser, $session){
	SetCookie("session",$session); //Set Cookie
	$exptime = time();
	$arg = "UPDATE ".CRM_SESSIONS_TABLE." SET exptime='$exptime' WHERE temp='$session'";
	$row = mcq($arg,$db);
}

function DeleteExpiredSessions() {
	global $timeout;

	// This function deletes sessions which are too old. It's always ran first.

	if ($timeout>0) {
		$temp = $timeout * 60;
		$currenttime = time();

		$trash = ($currenttime - $temp - 60); // safety - 60 second bonusz

		$sql = "DELETE FROM ".CRM_SESSIONS_TABLE." WHERE exptime < '" . $trash . "'";

		mcq($sql,$db);


	}
}

function AuthenticateUser ($name, $password, $silent){
	global $thiswasalogin, $logon, $title,$lang;
	$arg = "SELECT password, 1 AS auth, active, id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$name' AND password=PASSWORD('$password')";
	$result = mcq($arg,$db);
	$row = mysql_fetch_array($result);

	if ($row[auth]){
		if ($row[active]=="no") {
			uselogger("Disabled account","");
			require_once("language.php");
			DisplayLoginForm("This account is disabled");
		}
		GenerateSecret($name);
		$GLOBALS[USERID] = $row[id];
		$GLOBALS[USERNAME] = $name;
	}
	else {
		uselogger("invalid","");
		if ($silent<>yes){
			require_once("language.php");
			DisplayLoginForm("Invalid username or password. Please try again.");
		}
		else{
			$thiswasalogin=0;
			$logon=yes;
			uselogger("login $username","login $username");
		}
	}
}
function AuthenticateUserByEncryptedPassword ($name, $password, $silent){
	global $thiswasalogin, $logon, $title,$lang;
	$GLOBALS['CURFUNC'] = "AuthenticateUserByEncryptedPassword::";
	$arg = "SELECT password, 1 AS auth, active, id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$name' AND password='$password'";
	$result = mcq($arg,$db);
	$row = mysql_fetch_array($result);

	if ($row[auth]){
		if ($row[active]=="no") {
			uselogger("Disabled account","");
			require_once("language.php");
			DisplayLoginForm("This account is disabled");
			qlog("This account is disabled");
		}
		GenerateSecret($name);
		$GLOBALS[USERID] = $row[id];
		$GLOBALS[USERNAME] = $name;

	}
	else {
		uselogger("invalid","");
		if ($silent<>yes){
			require_once("language.php");
			DisplayLoginForm("Invalid username or password. Please try again.");
			qlog("Invalid userid or password");
		}
		else{
			$thiswasalogin=0;
			$logon=yes;
			uselogger("login $username","login $username");
			qlog("Login: $username");
		}
	}
	$GLOBALS['CURFUNC'] = "";
}
function ActiveUser ($session){
	global $username,$expire,$lang;
	$personresult = mcq("SELECT name, temp, exptime, noexp FROM ".CRM_SESSIONS_TABLE." WHERE temp='$session'",$db);
	$personarray = mysql_fetch_array ($personresult);
	$currenttime = time();
	$settime = $personarray["exptime"]+EXPIRE;
	$todaynum= date("w", $currenttime);
	$expdaynum = date("w", $settime);

	$arg = "SELECT id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$personarray[name]'";
	$result = mcq($arg,$db);
	$row = mysql_fetch_array($result);
	$GLOBALS[USERID] = $row[id];
	$GLOBALS[USERNAME] = $personarray[name];

  if ($todaynum <> $expdaynum && $currenttime > $settime){ //als het de volgende dag is en je tijd is niet okay.
		$arg = "UPDATE ".CRM_SESSIONS_TABLE." SET noexp='no' WHERE temp='$session'";//  volgende dag en tijd verlopen, noexp to no
		$row = mcq($arg,$db);
		uselogger("expire","");
	  SetCookie("session","",time()-500); //unset cookie
    require_once("language.php");
	DisplayLoginForm("You have been inactive too long. Please log in again");
	}
	elseif ($currenttime > $settime && $personarray[noexp]==no){ // als je tijd niet okay is en je mag niet altijd door
		uselogger("expire","");
	  SetCookie("session","",time()-500); //unset cookie
    DisplayLoginForm("Session expired, login ...");
	}
	elseif ($session <> $personarray["temp"]){
		$arg = "UPDATE ".CRM_SESSIONS_TABLE." SET noexp='no' WHERE temp='$session'";//  foute session, noexp to no
		$row = mcq($arg,$db);
		uselogger("session","");
	  SetCookie("session","",time()-500); //unset cookie
    DisplayLoginForm("Your session key is invalid. Please log in again");
	}
	else{
		setnewtime ($personarray["name"], $session);
	}
  return $personarray["name"];
}
function printstepheader($step)
{
	?>

	    <center><table border='1' width='40%' bgcolor='#F2F2F2' cellspacing='0' cellpadding='4' bordercolor='#CECECE'>
		<tr><td colspan=2><?php echo $step;?></td></tr>
		</table></center>
		<br>
	<?php
}
function printeditform() {
	global $lang,$language,$customer,$ForceCategoryPulldown;

	$e = "_new_";
	print "<form ACTION='cust-insert.php' name='EditEntity' method='POST' ENCTYPE='multipart/form-data' id='dashed'>";
			$curid = $e; // tmp save
					print "<input class='txt' type=hidden name='changed' value='0'>";
					if ($e=="_new_") {
					print "<input type='hidden' name='tab' value='800'>";
						$enetjes = $lang[newentity];
					} else {
						$enetjes = $e;
					}

					print "<div id='IsChanged' style='display: none'>";
					print "<table><tr><td><fieldset><font color='#FF0000'>Changed</font></fieldset></td></tr></table>";
					/*
					print "<table><tr><td>";
					print "<fieldset><legend>!&nbsp;</legend>";
					print "&nbsp;<img src='error.gif' title='Values are changed but not yet saved'>&nbsp;";
					print "</fieldset></td></tr></table>";
					*/
					print "</div>";

					print "</table>";

					print "<table width='100%'><tr><td>&nbsp;</td><td><table width='90%'><tr><td align='left'>";
					print "<br><fieldset><legend align='left'><font size=+1>$enetjes: $customer&nbsp;</font></legend>";
					print "<table width='90%'><tr><td align='left'>";
					$enetjes = "";
					print "<input class='txt' type=hidden name='e' value='$e'>";
					print "<input class='txt' type=hidden name='action' value='add'>";



// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=== Here comes the main form  =========================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================
// +=======================================================================================

			print "<input class='txt' type=hidden name='eid' value='$e' $roins>";
			print "<tr><td><table><tr><td>";





			// hier hoer
//			print "<table><tr><td>$lang[priority]</td><td>$lang[status]</td></tr><tr><td>";
			print "</td><td>";
			print "<fieldset><legend align='left'>$lang[priority]&nbsp;</legend><select name='prio' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
			$sql = "SELECT varname,id,color FROM ".CRM_PRIORITY_VARS_TABLE."";
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[priority]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}

			print "</select></fieldset>";

			print "</td><td><fieldset><legend align='left'>$lang[status]&nbsp;</legend><select name=status size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
			$sql = "SELECT varname,id,color FROM ".CRM_STATUS_VARS_TABLE."";
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[status]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}

			print "</select></fieldset></td><td>";
//			print "<br><table>";
//			print "<tr><td>$lang[owner]</td><td>$lang[assignee]</td></tr>";



			// Print customer sub information in a DIV


			if ($e<>"_new_") {

				// Print [customer] sub-info in DIV

//				print "Info on Cust#$ea[".CRM_CUSTOMER_TABLE."]";
				$sql= "SELECT * FROM ".CRM_CUSTOMER_TABLE." WHERE id='$ea[CRMcustomer]'";
				$result= mcq($sql,$db);
				$cust= mysql_fetch_array($result);
				print "<table width=100%><tr><td valign='top'>";
				print "<div style='display:block' id='open$cust[id]'><a style='cursor:hand' class='bigsort' OnClick=\"javascript:showLayer('rest$cust[id]');hideLayer('open$cust[id]');showLayer('close$cust[id]');\" title='Expand'>&nbsp;&nbsp;<img src='pr.gif'></a></div>";


				print "<div style='display:none' id='close$cust[id]'><a style='cursor:hand' class='bigsort' OnClick=\"javascript:hideLayer('rest$cust[id]');showLayer('open$cust[id]');hideLayer('close$cust[id]')\" title='Collapse'>&nbsp;&nbsp;<img src='pl.gif'></a></div>";
				print "</td><td valign=top>";

				print "<div style='display: none' id='rest$cust[id]'>";
				print "<br><fieldset><legend>$lang[customer]</legend><table width='75%'>";
				print "<tr><td>$lang[customer]</td><td>$cust[custname]</td></tr>";
				if ($cust[contact]) print "<tr><td>$lang[contact]</td><td>$cust[contact]</td></tr>";
				if ($cust[contact_title]) print "<tr><td>$lang[contacttitle]</td><td>$cust[contact_title]</td></tr>";
				if ($cust[contact_phone]) print "<tr><td>$lang[contactphone]</td><td>$cust[contact_phone]</td></tr>";
				if ($cust[contact_email]) print "<tr><td>$lang[contactemail]</td><td><a href='mailto:$cust[contact_email]' class='bigsort'>$cust[contact_email]</a></td></tr>";
				if ($cust[cust_address]) print "<tr><td>$lang[customeraddress]</td><td>" . ereg_replace("\n","<BR>",$cust[cust_address]) . "</td></tr>";
				if ($cust[cust_remarks]) print "<tr><td>$lang[custremarks]</td><td>" . ereg_replace("\n","<BR>",$cust[cust_remarks]) . "</td></tr>";


				if ($cust[cust_homepage]) {
				if (!stristr($cust[cust_homepage],"http://")) {
						$cust[cust_homepage] = "http://" . $cust[cust_homepage];
					}
					print "<tr><td>$lang[custhomepage]</td><td><a href='$cust[cust_homepage]' target='_new' class='bigsort'>$cust[cust_homepage]</a></td></tr>";
				}

				$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra customer fields list'";
				$result = mcq($sql,$db);
				$list = mysql_fetch_array($result);
				$list = $list[value];
				$list = @explode(",",$list);

				if (sizeof($list)>0 && $list[0]<>"") {
					for ($x=0;$x<sizeof($list);$x++) {

							$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$ea[CRMcustomer]' AND deleted<>'y' AND name='$list[$x]' AND type='cust' ORDER BY name";

							$result = mcq($sql,$db);
							$cust1= mysql_fetch_array($result);
							$val = $cust1[value];

							if (stristr($list[$x],"DD_")) {
								$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
								$list[$x] = ereg_replace("DD_","",$list[$x]);
								$tmp = explode("|",$list[$x]);
								$list[$x] = $tmp[0];

								for ($t=1;$t<(sizeof($tmp)+0);$t++) {
									if ($val==$tmp[$t]) {
										if ($tmp[$t]) print "<tr><td>" . $tmp[0] . "</td><td>";
										if ($tmp[$t]) print $tmp[$t];
									}

								}
								print "</td></tr>";
							} elseif (stristr($list[$x],"TB_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							$val = ereg_replace("\n","<BR>",$val);
							print "<tr><td>" . ereg_replace("TB_","",$list[$x]) . "</td><td>$val</td></tr>";
							} else {
								$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
								if (!$val=="") print "<tr><td>$list[$x]</td><td>$val</td></tr>";
							}
					}
				}
				print "</table></fieldset>";
				//http://crmstage.it-combine.com/customers.php?editcust=1&custid=16&1069595550
				// customers.php?editcust=1&custid=$ea[CRMcustomer]&nonavbar=1

				print "&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' href='javascript:popcustomereditscreen($ea[CRMcustomer]);'>$lang[edit] " . strtolower($lang[customer]) . " $cust[custname]</a>";
				print "</div><br>";

				print "</td></tr></table>";
			}






//			print "<br>";

//			print "<table><tr><td>$lang[category]</td><td>$lang[duedate]</td></tr>";
			print "</table><table><tr><td><fieldset><legend align='left'>$lang[category]&nbsp;</legend>";

			if (strtoupper($ForceCategoryPulldown)=="YES") {
				print "<select name='cat' class='text' width=50 OnChange=\"javascript:AlertUser('IsChanged');\">";
				$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Category pulldown list'";
				$result = mcq($sql,$db);
				$list = mysql_fetch_array($result);
				$list = $list[value];
				$list = @explode(",",$list);

				if (sizeof($list)>0 && $list[0]<>"") {

					for ($t=0;$t<sizeof($list);$t++) {
						if ($ea[category]==$list[$t]) {
							$roins = "SELECTED";
						} else {
							unset($roins);
						}
						print "<option $roins value='$list[$t]'>$list[$t]</option>";
					}

				}
				print "</select>";
			} else {
				print "<input class='txt' type=text name=cat size=50 value='$ea[category]' $roins OnKeyUp=\"javascript:AlertUser('IsChanged');\">";
			}
			print "</fieldset></td><td><fieldset><legend align='left'>$lang[duedate]&nbsp;</legend><input type='hidden' size='13' name='duedate' value='$ea[duedate]' OnChange=\"javascript:AlertUser('IsChanged');AdjustDateToUSAFormat(document.EditEntity.duedate.value);\">";


			print "<input type='text' size='13' name='displayDate' OnClick=\"javascript:popcalendar();\" value='bla' $roins>";

			?>
				<SCRIPT LANGUAGE="JavaScript">
				<!--
				AdjustDateToUSAFormat(document.EditEntity.duedate.value);

				//-->
				</SCRIPT>
			<?php
			//print "</fieldset></td><td><fieldset><legend align='left'>$lang[duedate]&nbsp;</legend><input type='text' size='13' name='duedate' value='$ea[duedate]' OnFocus=\"javascript:popcalendar();AlertUser('IsChanged');\" $roins>";
			if ($e<>"_new_") {
							print "&nbsp;&nbsp;<img src='arrow.gif'>&nbsp;<a class='bigsort' title='$lang[alarmdatev]' href='javascript:popalarm($e)' $roins>&nbsp;$lang[alarmdate]</a>";
			}
			print "</fieldset></td></tr></table>";
			if ($nonavbar) {
					print "<TEXTAREA $roins rows=13 cols=90 name='content' wrap='virtual' class='txt' OnKeyUp=\"javascript:AlertUser('IsChanged');\">$ea[content]</TEXTAREA><br>";
			} else {
					print "<TEXTAREA $roins rows=13 cols=118 name='content' wrap='virtual' class='txt' OnKeyUp=\"javascript:AlertUser('IsChanged');\">$ea[content]</TEXTAREA><br>";
			}


			print "<table><tr><td><br><fieldset><table>";
				if ($e<>"_new_") {
					if ($ea[deleted]=='y') {
						print "<tr><td><input type='checkbox' class='radio' name=deleted value='y' CHECKED $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[isdeleted]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(12)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a>";
					} else {
						print "<tr><td><input type='checkbox' class='radio' name=deleted value='y' $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[isdeleted]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(12)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a>";
					}
				}
				if ($ea[waiting]=='y') {
						print "<tr><td><input type='checkbox' class='radio' name=waiting value='y' CHECKED $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[iswaiting]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				} else {
						print "<tr><td><input type='checkbox' class='radio' name=waiting value='y' $roins OnChange=\"javascript:AlertUser('IsChanged');\"> $lang[iswaiting]&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";
				}


			print "</table></fieldset></td></tr></table><br>";
			print "<table>";
			$toprint = "<tr><td><fieldset><legend align='left'>$lang[listofatt]&nbsp;</legend><table border=0>";


			$sql= "SELECT filename,creation_date,date_format(creation_date, '%a %M %e, %Y %H:%i') AS dt,filesize,fileid,username FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$curid' ORDER BY filename,creation_date";
			$result= mcq($sql,$db);



			$toprint .= "<tr><td>$lang[filename]</td><td>$lang[filesize]</td><td>$lang[creationdate]</td><td>$lang[owner]</td><td>$lang[deletefile]</td></tr>";




			while ($files= mysql_fetch_array($result)) {
				$sql = "SELECT FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$files[username]'";
				$res1 = mcq($sql,$db);
				$owner = mysql_fetch_array($res1);
				$ownert = $owner[FULLNAME];

				if (stristr("@@@:",$ownert[FULLNAME])) {
					$ownert = "&nbsp;&nbsp;&nbsp;n/a";
				}

				$toprint .= "<tr><td><img src='arrow.gif'>&nbsp;<a href=csv.php?fileid=$files[fileid] class='bigsort'>$files[filename]</a></td><td>";
				$toprint .= round(($files[filesize]/1024)). "K";
				$toprint .= "</td><td>$files[dt]</td><td>$ownert</td><td><input type='checkbox' class='radio' name=deletefile[] value='$files[fileid]' $roins></td></tr>";
				$ftel++;
			}
			if ($ftel) {
				print $toprint . "</fieldset></td></tr></table>";
				}

			print "<tr><td colspan=6><fieldset><legend align='left'>$lang[attachfile]&nbsp;</legend><INPUT TYPE='hidden' name='MAX_FILE_SIZE' value='52428800'><INPUT NAME='userfile' TYPE='file' $roins>&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(9)' class='bigsort' cursor='click' style='cursor: help'><img src='info.gif'></a></fieldset></tr></td>";

			print "</table><br>";

			// Custom fields list

			$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra fields list'";
			$result = mcq($sql,$db);
			$list = mysql_fetch_array($result);
			$list = $list[value];
			$list = @explode(",",$list);

			if (sizeof($list)>0 && $list[0]<>"") {
				print "<table><tr><td>";
				print "<fieldset><legend align='left'>Custom fields&nbsp;</legend>";
				print "<table>";


				for ($x=0;$x<sizeof($list);$x++) {

						$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$enetjes' AND deleted<>'y' AND name='$list[$x]' ORDER BY name";
//						print $sql;
						$result = mcq($sql,$db);
						$cust= mysql_fetch_array($result);
						$val = $cust[value];

						if (stristr($list[$x],"DD_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							$list[$x] = ereg_replace("DD_","",$list[$x]);
							$tmp = explode("|",$list[$x]);
							$list[$x] = $tmp[0];
							print "<tr><td>" . $tmp[0] . "</td><td>";
							print "<select name='" . $orig . "' size='1' $roins OnChange=\"javascript:AlertUser('IsChanged');\">";
							print "<option value=''>-</option>";
							for ($t=1;$t<(sizeof($tmp)+0);$t++) {
								if ($val==$tmp[$t]) {
									$u = "SELECTED";
								} else {
									unset($u);
								}
								print "<option $u>" . $tmp[$t] . "</option>";
							}
							print "</select></td></tr>";
						} elseif (stristr($list[$x],"TB_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
								print "<tr><td>" . ereg_replace("TB_","",$list[$x]) . "</td><td><textarea rows=8 cols=60 wrap='virtual' class='txt' name='$orig' OnKeyUp=\"javascript:AlertUser('IsChanged');\">$val</textarea></td></tr>";
						} else {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							print "<tr><td>$list[$x]</td><td><INPUT TYPE='text' NAME='$orig' size=50 VALUE='$val' $roins OnKeyUp=\"javascript:AlertUser('IsChanged');\"></td></tr>";
						}
				}
			}
			print "</table></td></tr></table>";

			if ($nonavbar) {
				print "<INPUT TYPE='hidden' name='close_on_next_load' value='1'>";
//				$add1 = " OnClick='javascript:window.close()' ";
				}
			if ($nonavbar) {
				if ($e=="_new_") {
					print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[saveclose]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					if (strtoupper($ShowEmailButton) == "YES") {
						print "&nbsp;&nbsp;&nbsp;<input class='txt' OnClick=\"javascript:document.EditEntity.changed.value='0'\" type=submit name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					}
				} else {
					print "<table width='90%'><tr><td><input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name=sb value='$lang[saveclose]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					if (strtoupper($ShowEmailButton) == "YES") {
						print "&nbsp;&nbsp;&nbsp;<input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>&nbsp;&nbsp;&nbsp;";
					}
				}
				print "<input class='txt' type=submit name=sb OnClick=\"javascript:document.EditEntity.changed.value='0'\" value='$lang[cancel]' align='right' OnClick='javascript:window.close();'></td></tr></table>";
			} else {
				print "<table width='90%'><tr><td><input class='txt' type=submit name=sb OnClick=\"javascript:document.EditEntity.changed.value='0'\" value='$lang[save]' $roins>";
				if (strtoupper($ShowEmailButton) == "YES") {
					print "&nbsp;&nbsp;&nbsp;<input class='txt' type=submit OnClick=\"javascript:document.EditEntity.changed.value='0'\" name='notifassignee' value='$lang[save] + e-mail $lang[assignee]' align='right' $roins>";
				}
				print "</td></tr></table>";
			}
			/*
			if ($nonavbar) {
				print "<input class='txt' type=submit name=sb value='$lang[saveclose]'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				print "<input class='txt' type=submit name=sb value='$lang[cancel]' OnClick='javascript:window.close();'></form>";
			} else {
				print "<input class='txt' type=submit name=sb value='$lang[save]'></form>";
			}
			*/
			print "</form>";
}

	function printeditform2() {
	global $lang,$language,$customer,$ForceCategoryPulldown;
			print "<table width=70% border=0><tr><td colspan=5>";
			print "<form name='EditEntity' method=POST ENCTYPE='multipart/form-data' id='dashed'>";
			print "<input class='txt' type=hidden name='e' value='$e'>";
			print "<input class='txt' type=hidden name='action' value='add'>";
			print "<input class='txt' type=hidden name='eid' value='$e'>";
			print "<table border=0><tr><td>$lang[priority]</td><td>$lang[status]";
			print "</td><td rowspan=2><font size='+2'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$customer hoppa@</font></td>";
			print "</tr><tr><td>";
			print "<select name='prio' size='1' $roins>";
			$sql = "SELECT varname,id,color FROM ".CRM_PRIORITY_VARS_TABLE."";
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[priority]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}
			print "</select>";
			print "</td><td><select name=status size='1' $roins>";
			$sql = "SELECT varname,id,color FROM ".CRM_STATUS_VARS_TABLE."";
			$result= mcq($sql,$db);
			while($options = mysql_fetch_array($result)) {
				if (strtoupper(($ea[status]))==strtoupper($options[varname])) { $a="SELECTED"; } else { $a=""; }
				print "<option value='$options[varname]' $a>$options[varname]</option>";
			}

			print "</select></td></tr></table>";


			print "<br>";

			print "<table><tr><td>$lang[category]</td><td>$lang[duedate]";
			print "</td></tr>";
			print "<tr><td>";
			if (strtoupper($ForceCategoryPulldown)=="YES") {
				print "<select name='cat' class='text' width=50>";
				$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Category pulldown list'";
				$result = mcq($sql,$db);
				$list = mysql_fetch_array($result);
				$list = $list[value];
				$list = @explode(",",$list);

				if (sizeof($list)>0 && $list[0]<>"") {

					for ($t=0;$t<sizeof($list);$t++) {
						if ($ea[category]==$list[$t]) {
							$roins = "SELECTED";
						} else {
							unset($roins);
						}
						print "<option $roins value='$list[$t]'>$list[$t]</option>";
					}

				}
				print "</select>";
			} else {
				print "<input class='txt' type=text name=cat size=50 value='$ea[category]' $roins>";
			}


			print "</td><td><input type='text' size='13' name='duedate' value='$ea[duedate]' OnFocus='javascript:popcalendar();'>";
			print "</td></tr></table>";



			print "<TEXTAREA rows=8 cols=80 name='content' wrap='virtual' class='txt'>$ea[content]</TEXTAREA><br>";

			print "<tr><td><input class='bigsort' type=checkbox name=waiting value='y'> <font face='MS Shell Dlg' size='2'>$lang[iswaiting]</font>&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(10)' class='topnav' cursor='click' style='cursor: help'><img src='info.gif'></a></td></tr>";



			print "</table><br>";
			print "<table>";
			$toprint = "<tr><td colspan=6>$lang[listofatt]:</td></tr>";


			$sql= "SELECT filename,creation_date,date_format(creation_date, '%a %M %e, %Y %H:%i') AS dt,filesize,fileid,username FROM ".CRM_BINFILES_TABLE." WHERE koppelid='$e' ORDER BY filename";
			$result= mcq($sql,$db);

			$toprint .= "<tr><td>$lang[filename]</td><td>$lang[filesize]</td><td>$lang[creationdate]</td><td>$lang[owner]</td><td>$lang[deletefile]</td></tr>";

			while ($files= mysql_fetch_array($result)) {
				$sql = "SELECT FULLNAME FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='$files[username]'";
				$res1 = mcq($sql,$db);
				$owner = mysql_fetch_array($res1);
				$ownert = $owner[FULLNAME];

				$toprint .= "<tr><td><a href=csv.php?fileid=$files[fileid] class='topnav'>$files[filename]</a></td><td>";
				$toprint .= round(($files[filesize]/1024)). "K";
				$toprint .= "</td><td>$files[dt]</td><td>$ownert</td><td><input type=checkbox name=deletefile[] value='$files[fileid]'</td></tr>";
				$ftel++;
			}
			if ($ftel) { print $toprint; }

			print "<tr><td colspan=6><br><INPUT TYPE='hidden' name='MAX_FILE_SIZE' value='52428800'><img src='attach.gif'>&nbsp;&nbsp;$lang[attachfile]: <br><INPUT NAME='userfile' TYPE='file'>&nbsp;&nbsp;&nbsp;&nbsp;<a OnClick='javascript:pophelp(9)' class='topnav' cursor='click' style='cursor: help'><img src='info.gif'></a></tr></td>";

			print "</table><br>";

			// Custom fields list

			$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='Extra fields list'";
			$result = mcq($sql,$db);
			$list = mysql_fetch_array($result);
			$list = $list[value];
			$list = @explode(",",$list);

			if (sizeof($list)>0 && $list[0]<>"") {
				print "<table><tr><td>";
				print "<b>Custom fields:</b>";
				print "</td></tr>";

				for ($x=0;$x<sizeof($list);$x++) {

						$sql = "SELECT value FROM ".CRM_CUSTOM_ADDONS_TABLE." WHERE eid='$e' AND deleted<>'y' AND name='$list[$x]' ORDER BY name";
	//					print $sql;
						$result = mcq($sql,$db);
						$cust= mysql_fetch_array($result);
						$val = $cust[value];

						if (stristr($list[$x],"DD_")) {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							$list[$x] = ereg_replace("DD_","",$list[$x]);
							$tmp = explode("|",$list[$x]);
							$list[$x] = $tmp[0];
							print "<tr><td>" . $tmp[0] . "</td><td>";
							print "<select name='" . $orig . "' size='1'>";
							print "<option value=''>-</option>";
							for ($t=1;$t<(sizeof($tmp)+0);$t++) {
								if ($val==$tmp[$t]) {
									$u = "SELECTED";
								} else {
									unset($u);
								}
								print "<option $u>" . $tmp[$t] . "</option>";
							}
							print "</select></td></tr>";
						} else {
							$orig = ereg_replace(" ","SPACEREPLACEPLEASEIGNORE",$list[$x]);
							print "<tr><td>$list[$x]</td><td><INPUT TYPE='text' NAME='$orig' size=50 VALUE='$val'></td></tr>";
						}
				}
			}
			print "</table>";

			if ($nonavbar) {
				print "<INPUT TYPE='hidden' name='close_on_next_load' value='1'>";
//				$add1 = " OnClick='javascript:window.close()' ";
				}
			if ($nonavbar) {
				print "<table width='90%'><tr><td align='right'><input class='txt' type=submit name=sb value='$lang[saveclose]' align='right'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				print "<input class='txt' type=submit name=sb value='$lang[cancel]' align='right' OnClick='javascript:window.close();'></td></tr></table>";
			} else {
				print "<table width='60%'><tr><td align='right'><input class='txt' type=submit name=sb value='$lang[save]'></td></tr></table>";
			}

			print "</form></table>";
}

function PrintFooter() {
		global $CRM_VERSION;
		print "<table><tr><td><a href='http://crm.it-combine.com' class='bigsort'>&copy;&nbsp;CRM-ctt $CRM_VERSION</a></td></tr></table>";
		print "</body></html>";
}


function printheader_cust($menu)
{
		global $title,$logo,$NoMenu,$lang,$name,$language,$tab,$host;
		?>
		<html>
		<head>
		<title>C R M management interface - <?php echo $title; ?></title>
		<META HTTP-EQUIV="Expires" CONTENT="0">
		<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		</head>
		<script language="JavaScript">
		<!--

		// Write the correct stylesheet into the document
		if (navigator.appName.indexOf('Microsoft') > -1) {
			// IE stylesheet
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
			} else {
			// NS stylesheet (gheghe, the same :) )
			document.write('<link href="crm.css" rel="stylesheet" type="text/css">');
		}
		function pophelp(i)	{
						newWindow = window.open('help.php?id=' + i, 'HelpWindow' + i,'width=350,height=300,directories=0,status=0,menuBar=0,scrollBars=1,resizable=1');
		}

		function popupdater(i,id)	{
			newWindow = window.open('management.php?loguser=' + id + '&NoMenu=1&e=' + i, 'Update' + i,'width=640,height=630,directories=0,status=0,menuBar=0,scrollBars=1,resizable=1');
			}

		function popcalendar()	{
						document.EditEntity.duedate.blur();
						newWindow = window.open('calendar.php', 'myWindow2','width=500,height=430,directories=0,status=0,menuBar=0,scrollBars=0,resizable=1');
				}

				//-->
		</SCRIPT>
		<body bgcolor="#ffffff" leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" link="#336699" text="#333333" alink="white" vlink="#666666""><br>
		<table border="0" width="100%"><tr><td bgcolor=''>
		<?php
			$epoch = date("U");
			include("tabs_inc.php");
			$tabbs = array (
			"21"		=>  array(($back_end_url . "cust-insert.php?list=1&tab=21&$epoch") => "$lang[entities]"),
			"22"		=>  array(($back_end_url . "cust-insert.php?a=2&tab=22&$epoch") => "$lang[add]"),
			"23"		=>  array(($back_end_url . "index.php?logout=1&$epoch") => "$lang[logout]"),
			);

			tabs(array("21", "22","23"), $tabbs, "$tab");

		print "</table></td><td>";

		$today = date("F j, Y, H:i") . "h.";
		$result[value]=0;
//		print $title;

/*
		<br><img src='arrow.gif'>&nbsp;<a class='bigsort' title='Log out' href='index.php?logout=1'><?php echo $lang[logout];</a><br>
		<img src='arrow.gif'>&nbsp;<a class='bigsort' title='List' href='cust-insert.php?list=1'><?php echo $lang[entities];</a><br>

		print "<img src='arrow.gif'>&nbsp;<a href='cust-insert.php?a=2' class='bigsort'>$lang[pbaddrec]</a>";
*/
		?>


		<?php
		print "<tr><td>" . $lang[managementheader] . " insert-only " . strtolower($lang[customer]) . "-user '" . $name . "'.";
		print "&nbsp;&nbsp;";
		// Check wheter or not we must now display the language select box
			$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='langoverride'";
			$result= mcq($sql,$db);
			$resarr=mysql_fetch_array($result);

			if ($resarr[0]=="no" || $resarr[0]=="No" || $resarr[0]=="NO") {

				print "$lang[language]&nbsp;:&nbsp;&nbsp;";
				print "<form name='langform' method='POST'>";
				print "<select name='lan' OnChange='javascript:document.langform.submit();'>";
				$sql= "SELECT DISTINCT LANGID FROM ".CRM_LANGUAGES_TABLE."";
					$result= mcq($sql,$db);
					while ($resarr=mysql_fetch_array($result)){
							if ((trim($resarr[LANGID])=="") || ($resarr[LANGID] == "GLOBAL")) {
						// GLOBAL is a global language setting which ought to be ignored
							} else {
								if ($language==$resarr[LANGID]) {
									$ins = "SELECTED";
								} else {
									unset($ins);
								}
								print "<option value='$resarr[LANGID]' $ins>$resarr[LANGID]</option>";
							}
					}
					print "</select><input type=hidden name='name' value='$name'></form></td></tr>";
			} else {
				print "</td></tr>";
			}


		print "</table>";
} // end func
// repository switcher
function ShowRepositorySwitcher($post_to,$post_to_parent="") {
	global $host,$pass,$database,$table_prefix,$user,$swrepos,$switchreposto,$repository_nr,$EnableRepositorySwitcher,$lang,$postto;

	$GLOBALS['CURFUNC'] = "ShowRepositorySwitcher::";

	if (strtoupper($EnableRepositorySwitcher)<>"YES") {
		if (strtoupper($EnableRepositorySwitcher)=="ADMIN" && is_administrator()==true) {
			// access allowed
		} else {
			$no_access= true;
		}
	}

	if ($no_access) {
		// nothing
	} else {



		if (sizeof($host)>1) {

			if ($swrepos) {

				$r = ereg_replace("a-","",$switchreposto);

				$sql = "SELECT password FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $GLOBALS['USERNAME'] . "'";
				$result= mcq($sql,$db);
				$result1= mysql_fetch_array($result);
				$curpassword = $result1[password];

				qlog("Switching this user to repository $r");
				uselogger("Switching this user to repository $r","");

				$db = @mysql_connect($host[$r], $user[$r], $pass[$r]);
						mysql_select_db($database[$r],$db);

				$GLOBALS['TBL_PREFIX'] = $table_prefix[$r];

				qlog("DB Switched to $r (came from $repository_nr) - reloading");
				uselogger("This user switched to this repository from repository $repository_nr","");
				setCookie('repository',$r);
				$GLOBALS['REPOSID'] = $r;
				$repository_nr = $r;
				AuthenticateUserByEncryptedPassword ($GLOBALS['USERNAME'], $curpassword, "1");
				$GLOBALS['CURFUNC'] = "ShowRepositorySwitcher::";
				if ($_GET['req_url']) {
					qlog("Req_URL received");
					$postto = base64_decode($_GET['req_url']);
				}

				if (!$postto) {
					$postto = "index.php";
					qlog("postto var defaulted");
				}
				if ($post_to_parent) {
					?>
					<SCRIPT LANGUAGE="JavaScript">
					<!--
						window.opener.location='<?php echo $postto;?>';
						window.close();
					//-->
					</SCRIPT>
					<?php
				} else {
					?>
					<SCRIPT LANGUAGE="JavaScript">
					<!--
						document.location='<?php echo $postto;?>';
					//-->
					</SCRIPT>
					<?php
				}
			} else {

				if ($post_to_parent) {
	//				window.opener.location

				}

				$count = 0;

				$sql = "SELECT password FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $GLOBALS['USERNAME'] . "'";
				$result= mcq($sql,$db);
				$result1= mysql_fetch_array($result);
				$curpassword = $result1[password];

				$outp = "<img src='reposwhite.jpg'> <form name='switchrepos' method='GET'><input type='hidden' name='swrepos' value='1'><input type='hidden' name='postto' value='" . $post_to . "'><input type='hidden' name='post_to_parent' value='" . $post_to_parent . "'><select name='switchreposto' OnChange='javascript:document.switchrepos.submit();'>";

				if (sizeof($pass)>0) {
						for ($r=0;$r<sizeof($pass);$r++) {
								if ($db = @mysql_connect($host[$r], $user[$r], $pass[$r])) {
									if (@mysql_select_db($database[$r],$db)) {
										$tbl = $table_prefix[$r];
										if ($tbl=="") $tbl="CRM";
										$sql = "SELECT password FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $GLOBALS['USERNAME'] . "'";

										$result = @mysql_query($sql);
										$result1= @mysql_fetch_array($result);
										$foreignpassword = $result1[password];

										if ($curpassword==$foreignpassword) {
											if ($GLOBALS['REPOSNR']==$r) {
												$ins = "SELECTED";
											} else {
												unset($ins);
											}
											$sql = "SELECT id FROM ".CRM_LOGIN_USERS_TABLE." WHERE name='" . $GLOBALS['USERNAME'] . "'";
											$result = mcq($sql,$db);
											$id1 = mysql_fetch_array($result);

											$sql = "SELECT COUNT(*) FROM ".CRM_ENTITY_TABLE." WHERE deleted<>'y' AND assignee='" . $id1[0] . "'";
											$result = mcq($sql,$db);
											$count = mysql_fetch_array($result);

											$sql = "SELECT value FROM ".CRM_SETTINGS_TABLE." WHERE setting='title'";
											$result = mcq($sql,$db);
											$result = mysql_fetch_array($result);
											$outp .= "<option $ins value='a-" . $r . "'>" . $result['value'] . " (" . $GLOBALS['USERNAME'] . ": " . $count[0] . " " . $lang['openentities'] . ")</option>";
											$county++;
										} else {
											//print "<option>denied</option>";
										}
									} else {
										//print "<option>no select</option>";
									}

								} else {
									 //print "<option>host not found</option>";
								}
							}

					$outp .= "</select></form>";

					if ($county>1) {
						print $outp;
					}
				} else {
					print "foutje";
				}
			}
		}
		$GLOBALS['CURFUNC'] = "";
	}
}

function EmailTriggerForOwnerSet($e_id) {
	$sql = "SELECT notify_owner FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $e_id . "'";
	$result = mcq($sql,$db);
	$result = mysql_fetch_array($result);
	if ($result[0] == "y") {
		return(true);
	} else {
		return(false);
	}
}
function EmailTriggerForAssigneeSet($e_id) {
	$sql = "SELECT notify_assignee FROM ".CRM_ENTITY_TABLE." WHERE eid='" . $e_id . "'";
	$result = mcq($sql,$db);
	$result = mysql_fetch_array($result);
	if ($result[0] == "y") {
		return(true);
	} else {
		return(false);
	}
}
function EmailTriggerForCustomerOwnerSet($c_id) {
	$sqlt = "SELECT customer_owner,email_owner_upon_adds FROM ".CRM_CUSTOMER_TABLE." WHERE id='". $c_id . "'";
	$resultt= mcq($sqlt,$db);
	$row= mysql_fetch_array($resultt);

	if ($row['email_owner_upon_adds']=="yes") {
		return(true);
	} else {
		return(false);
	}
}
function htmlentities2($myHTML)
{
   $translation_table = get_html_translation_table( HTML_ENTITIES, ENT_QUOTES);
   $translation_table[chr( 38)] = '&';
   return preg_replace( "/&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,4};)/", "&amp;" , strtr( $myHTML, $translation_table));
}
function ExportUsers() {
	MustBeAdmin();
	$GLOBALS['CURFUNC'] = "ExportUsers::";
	qlog("Exporting users");
	$sql = "SELECT name,password,type,active,exptime,noexp,FULLNAME,EMAIL,CLLEVEL,administrator,LASTFILTER,LASTSORT,RECEIVEDAILYMAIL FROM ".CRM_LOGIN_USERS_TABLE."";
	$result = mcq($sql,$db);
	while ($row = mysql_fetch_array($result)) {
		$outp .= base64_encode($row['name']) . "," . base64_encode($row['password']) . "," . base64_encode($row['type']) . "," . base64_encode($row['FULLNAME']) . "," . base64_encode($row['EMAIL']) . "," . base64_encode($row['CLLEVEL']) . "," . base64_encode($row['administrator']) . "," . base64_encode($row['LASTFILTER']) . "," . base64_encode($row['LASTSORT']) . "," . base64_encode($row['RECEIVEDAILYMAIL']) . "\n";

	}

	$filename = "Exported_users_CRM-CTT_" . urlencode($GLOBALS['title']) . "-" . date("Fj-Y-Hi") . ".crm";

	header("Content-Type: CSV");
	header("Content-Disposition: attachment; filename=$filename" );
	header("Content-Description: CRM Generated Data" );
	header("Window-target: _top");

	print $outp;
}

function ImportUsers() {
	global $legend;
	MustBeAdmin();
	$GLOBALS['CURFUNC'] = "ImportUsers::";
	qlog("Importing users");
	$sarr = array();
	if ($_FILES['userfile']['tmp_name'] && $_FILES['userfile']['name']) {

		$fp=fopen($_FILES['userfile']['tmp_name'] ,"rb");
		$filecontent=fread($fp,filesize($_FILES['userfile']['tmp_name'] ));
		fclose($fp);
//		$filecontent = addslashes($filecontent);
		//print $filecontent;

		$arr = split("\n",$filecontent);

		foreach ($arr AS $line) {
//			name,password,type,FULLNAME,EMAIL,CLLEVEL,administrator,LASTFILTER,LASTSORT,RECEIVEDAILYMAIL
			$element_count=0;
			$account = split(",",$line);

			$sql = "INSERT INTO ".CRM_LOGIN_USERS_TABLE."(name,password,type,FULLNAME,EMAIL,CLLEVEL,administrator,LASTFILTER,LASTSORT,RECEIVEDAILYMAIL) VALUES (";

			foreach ($account AS $element) {
				$sql .= "'" . addslashes(base64_decode($element)) . "',";
				$element_count++;
			}
			$sql .= ")";
			$sql = ereg_replace(",)",")",$sql);
			if ($element_count==10) {
				// 1st element is the account name, and it may not already exist.
				if (GetUserNameByName(base64_decode($account[0]))<>"n/a") {
					$GLOBALS['CURFUNC'] = "ImportUsers::";
					qlog("Error. Account " . base64_decode($account[0]) . " already exists (fullname " . GetUserNameByName(base64_decode($account[0])) . ")");
				} else {
					array_push($sarr,$sql);
				}
			} else {
				$GLOBALS['CURFUNC'] = "ImportUsers::";
				qlog("Ignoring record with $element_count instead of 10 elements");
			}

		}
		$GLOBALS['CURFUNC'] = "ImportUsers::";
		if (sizeof($sarr)==0) {
				qlog("No valid accounts to import found");
				$legend = "<img src='error.gif'>";
				printbox("No valid accounts to import found in this file.<br><br><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&joepie=1' style='cursor:hand'>Back to main administration page</a>");
		} else {
				qlog("Importing " . sizeof($sarr) . " accounts");
				foreach ($sarr AS $query) {
					mcq($query,$db);
				}
				print sizeof($sarr) . " user-accounts imported.";
		}

	} else {
		print "<table><tr><td><fieldset><legend>Import users&nbsp;</legend><table>";
		print "<tr><td>Select file for upload:</td><td><FORM ENCTYPE='multipart/form-data' name='IU' method='POST'><INPUT TYPE='hidden' name='MAX_FILE_SIZE' value='52428800'><INPUT NAME='userfile' TYPE='file'></td></tr><tr><td><INPUT TYPE='submit' value='Upload'></TD></TR><TR><TD COLSPAN=2><img src='arrow.gif'>&nbsp;<a class='bigsort' href='admin.php?password=$password&joepie=1' style='cursor:hand'>Back to main administration page</a></TD></TR></FORM></TD></TR></TABLE>";
	}

}

?>