DROP TABLE IF EXISTS [db_prefix]active_sessions;
CREATE TABLE IF NOT EXISTS [db_prefix]active_sessions (
  id int(11) NOT NULL auto_increment,
  session varchar(32) NOT NULL DEFAULT '0' ,
  ip_address varchar(15) NOT NULL DEFAULT '0' ,
  id_user int(11) DEFAULT '0' ,
  update_date timestamp(14) ,
  PRIMARY KEY (id),
  INDEX session (session)
);


DROP TABLE IF EXISTS [db_prefix]active_sessions_loanoff;
CREATE TABLE IF NOT EXISTS [db_prefix]active_sessions_loanoff (
  id int(11) NOT NULL auto_increment,
  session varchar(32) NOT NULL DEFAULT '0' ,
  ip_address varchar(15) NOT NULL DEFAULT '0' ,
  id_user int(11) DEFAULT '0' ,
  update_date timestamp(14) ,
  PRIMARY KEY (id),
  INDEX session (session)
);


DROP TABLE IF EXISTS [db_prefix]alerts_system;
CREATE TABLE [db_prefix]alerts_system (
  id int(3) NOT NULL auto_increment,
  description varchar(255) NOT NULL default '',
  status enum('0','1') NOT NULL default '0',
  date_last_send datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
);
INSERT INTO [db_prefix]alerts_system VALUES (1, 'Alert from contact us form', '1', '0000-00-00 00:00:00');
INSERT INTO [db_prefix]alerts_system VALUES (2, 'Alert from call back form', '1', '0000-00-00 00:00:00');
INSERT INTO [db_prefix]alerts_system VALUES (3, 'Alert from feedback form', '1', '0000-00-00 00:00:00');
INSERT INTO [db_prefix]alerts_system VALUES (4, 'Alert from pre-qualification letter', '1', '0000-00-00 00:00:00');
INSERT INTO [db_prefix]alerts_system VALUES (5, 'Alert from short application form', '1', '0000-00-00 00:00:00');
INSERT INTO [db_prefix]alerts_system VALUES (6, 'Alert from full application letter', '1', '0000-00-00 00:00:00');


DROP TABLE IF EXISTS [db_prefix]alerts_user;
CREATE TABLE [db_prefix]alerts_user (
  id int(11) NOT NULL auto_increment,
  id_subscribe int(11) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  email varchar(255) default NULL,
  loanof_id int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]billing_unit;
CREATE TABLE IF NOT EXISTS [db_prefix]billing_unit (
  id tinyint(3) NOT NULL auto_increment,
  abbr varchar(10) NOT NULL default '',
  name varchar(100) default NULL,
  fractional_unit tinyint(4) default NULL,
  symbol varchar(10) default NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]billing_unit (id, abbr, name, fractional_unit, symbol) VALUES (1, 'USD', 'American Dollar', 2, '$');
INSERT INTO [db_prefix]billing_unit (id, abbr, name, fractional_unit, symbol) VALUES (2, 'EUR', 'Euro', 2, '&euro;');
INSERT INTO [db_prefix]billing_unit (id, abbr, name, fractional_unit, symbol) VALUES (3, 'GBP', 'Pound Sterling', 2, '&pound;');


DROP TABLE IF EXISTS [db_prefix]borrower;
CREATE TABLE [db_prefix]borrower (
  id int(11) unsigned NOT NULL auto_increment,
  UserEmail varchar(64) default NULL,
  UserPassword varchar(128) default NULL,
  ProviderSidId int(3) unsigned default NULL,
  ContactFirstName varchar(64) default NULL,
  ContactLastName varchar(64) default NULL,
  ContactAddress1 varchar(128) default NULL,
  ContactAddress2 varchar(128) default NULL,
  ContactCity varchar(64) default NULL,
  ContactStateOrProvince varchar(4) default NULL,
  ContactPostalCode int(5) unsigned default NULL,
  ContactHomePhone int(10) unsigned default NULL,
  ContactWorkPhone int(10) unsigned default NULL,
  ContactEmail varchar(255) default NULL,
  HomeOwnerBit enum('1','0') default NULL,
  CreditRatingID enum('1','2','3','4') default NULL,
  PropertyValue int(14) unsigned default NULL,
  PropertyTypeID enum('1','2','3','4','5') default NULL,
  Mortgage1Balance int(11) unsigned default NULL,
  Mortgage1Rate double default NULL,
  RequestedLoanAmountMin int(14) unsigned default NULL,
  RequestedLoanAmountMax int(14) unsigned default NULL,
  RequestedLoanPurposeID enum('4','7','8','9','10','11','12','13','14','15') default NULL,
  ssn varchar(15) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]callback;
CREATE TABLE [db_prefix]callback (
  id int(11) unsigned NOT NULL auto_increment,
  name varchar(70) default NULL,
  phone varchar(50) default NULL,
  phone1 varchar(50) default NULL,
  email varchar(50) default NULL,
  time varchar(255) default NULL,
  message text,
  date date NOT NULL default '0000-00-00',
  status varchar(20) NOT NULL default 'new',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]contactus;
CREATE TABLE [db_prefix]contactus (
  id int(11) unsigned NOT NULL auto_increment,
  name varchar(70) default NULL,
  hphone varchar(50) default NULL,
  dphone varchar(50) default NULL,
  mphone varchar(50) default NULL,
  email varchar(50) default NULL,
  address varchar(255) default NULL,
  message text,
  date date NOT NULL default '0000-00-00',
  status varchar(20) NOT NULL default 'new',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]costs_costs;
CREATE TABLE [db_prefix]costs_costs (
  id int(11) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  interest text,
  property_tax text,
  priority int(11) default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]costs_costs (id, name, interest, property_tax, priority) VALUES (1, 'Co-op', 'As a result of there being no mortgage payment due the first month following your closing; at the closing you must pay simple interest covering the period from the day of the closing through the end of the month.', '', 1);
INSERT INTO [db_prefix]costs_costs (id, name, interest, property_tax, priority) VALUES (2, '1-4 Family & Condo Purchases', 'As a result of there being no mortgage payment due the first month following your closing; at the closing you must pay simple interest covering the period from the day of the closing through the end of the month.', 'A calculation will be done at the closing to determine the amount of money that will need to be initially deposited to your escrow account. The actual amount will depend on the dollar amount and timing of the first tax payment coming due. The bank will need to make certain that there will be sufficient funds on account to make this first payment. Generally speaking, you can expect this amount to range anywhere from 4 to 6 months worth of payments.', 2);
INSERT INTO [db_prefix]costs_costs (id, name, interest, property_tax, priority) VALUES (3, '1-4 Family & Condo Refinances', 'As a result of there being no mortgage payment due the first month following your closing; at the closing you must pay simple interest covering the period from the day of the closing through the end of the month.', 'A calculation will be done at the closing to determine the amount of money that will need to be initially deposited to your escrow account. The actual amount will depend on the dollar amount and timing of the first tax payment coming due. The bank will need to make certain that there will be sufficient funds on account to make this first payment. Generally speaking, you can expect this amount to range anywhere from 4 to 6 months worth of payments. Note that any funds remaining in your escrow account with the previous lender will be refunded directly to you (usually within two weeks of the closing.)', 3);


DROP TABLE IF EXISTS [db_prefix]costs_fees;
CREATE TABLE [db_prefix]costs_fees (
  id int(11) unsigned NOT NULL auto_increment,
  cost_id int(11) unsigned default '0',
  _key varchar(255) default NULL,
  _value text,
  priority int(11) unsigned default NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (1, 1, 'APPRAISAL', '$300 (higher for properties valued over $500,000)', 1);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (6, 1, 'APPLICATION FEE', '$300', 2);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (7, 1, 'CREDIT REPORT', '$15 ', 3);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (8, 2, 'APPRAISAL', '$300 (higher for 2-4 family properties & those valued over $500,000)', 1);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (9, 2, 'APPLICATION FEE', '$300', 2);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (10, 2, 'CREDIT REPORT', '$15', 3);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (11, 3, 'APPRAISAL', '$300 (higher for 2-4 family properties & those valued over $500,000)', 1);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (12, 3, 'APPLICATION FEE', '$300', 2);
INSERT INTO [db_prefix]costs_fees (id, cost_id, _key, _value, priority) VALUES (13, 3, 'CREDIT REPORT', '$15', 3);


DROP TABLE IF EXISTS [db_prefix]costs_tax;
CREATE TABLE [db_prefix]costs_tax (
  id int(11) unsigned NOT NULL auto_increment,
  cost_id int(11) unsigned default '0',
  _key varchar(255) default NULL,
  _value text,
  priority int(11) unsigned default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (1, 1, 'BANK ATTORNEY', '$400-$750 (depending on bank & state)', 1);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (4, 1, 'FLOOD CERT', '$18-$29 (depending on bank)', 2);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (5, 1, 'LIEN/UCC SEARCH', '$250-$300 (depending on bank)', 3);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (6, 1, 'RECORDING FEE', '$20-$75(depending on bank & state)', 4);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (7, 1, 'DOC PREP/UNDERWRITING FEE', '$0-$600 (depending on bank)', 5);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (8, 2, 'BANK ATTORNEY', '$400-$750 (depending on bank & state)', 1);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (9, 2, 'FLOOD CERT', '$18-$29 (depending on bank)', 2);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (11, 2, 'RECORDING FEE', '$60-$287(depending on locale)', 3);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (12, 2, 'TAX SERVICE CHARGE', '$60-$130(depending on bank) ', 4);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (13, 2, 'DOC PREP/UNDERWRITING FEE', '$0-$500 (depending on bank)', 5);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (14, 2, 'NY STATE MORTGAGE TAX', 'NYC - 1.75% of loan amount less $25 (1.875% on loans above $500,000)<br><br>YONKERS - 1.25% of loan amount less $25<br><br>ALL OTHER NY - .75% of loan amount less $25', 6);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (15, 3, 'BANK ATTORNEY', '$400-$750 (depending on bank & state)', 1);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (16, 3, 'FLOOD CERT', '$18-$29 (depending on bank)', 2);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (17, 3, 'RECORDING FEE', '$60-$287(depending on locale)', 3);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (18, 3, 'TAX SERVICE CHARGE', '$60-$130(depending on bank)', 4);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (19, 3, 'DOC PREP/UNDERWRITING FEE', '$0-$500 (depending on bank)', 5);
INSERT INTO [db_prefix]costs_tax (id, cost_id, _key, _value, priority) VALUES (20, 3, 'NY STATE MORTGAGE TAX', 'NYC - 1.75% of loan amount less $25 (1.875% on loans above $500,000)<br><br>YONKERS - 1.25% of loan amount less $25<br><br>ALL OTHER NY - .75% of loan amount less $25', 6);


DROP TABLE IF EXISTS [db_prefix]crmbinfiles;
CREATE TABLE [db_prefix]crmbinfiles (
  fileid bigint(20) NOT NULL auto_increment,
  koppelid bigint(20) NOT NULL default '0',
  content mediumblob NOT NULL,
  filename varchar(200) NOT NULL default '',
  creation_date timestamp NOT NULL default '0000-00-00 00:00:00',
  filesize mediumint(9) NOT NULL default '0',
  filetype varchar(150) NOT NULL default '',
  username varchar(150) NOT NULL default '',
  checked enum('in','out') NOT NULL default 'in',
  checked_out_by int(11) NOT NULL default '0',
  PRIMARY KEY  (fileid),
  KEY fileid (fileid),
  KEY koppelid (koppelid)
);


DROP TABLE IF EXISTS [db_prefix]crmcalendar;
CREATE TABLE [db_prefix]crmcalendar (
  user varchar(20) NOT NULL default '',
  Tijdpostzegel timestamp NOT NULL default '0000-00-00 00:00:00',
  datum date NOT NULL default '0000-00-00',
  basicdate varchar(8) NOT NULL default '',
  calendarid mediumint(5) NOT NULL auto_increment,
  type varchar(10) NOT NULL default '',
  customnum varchar(12) NOT NULL default '',
  emailadress varchar(150) NOT NULL default '',
  eID varchar(5) NOT NULL default '',
  PRIMARY KEY  (calendarid),
  KEY Tijdpostzegel (Tijdpostzegel)
);


DROP TABLE IF EXISTS [db_prefix]crmcustomaddons;
CREATE TABLE [db_prefix]crmcustomaddons (
  id bigint(20) NOT NULL auto_increment,
  eid bigint(20) NOT NULL default '0',
  type varchar(50) NOT NULL default '',
  name longtext NOT NULL,
  value longtext NOT NULL,
  deleted enum('y','n') NOT NULL default 'n',
  usr varchar(50) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY deleted (deleted),
  KEY eid (eid),
  KEY type (type)
);


DROP TABLE IF EXISTS [db_prefix]crmcustomer;
CREATE TABLE [db_prefix]crmcustomer (
  id int(11) NOT NULL auto_increment,
  custname varchar(200) NOT NULL default '',
  contact varchar(240) NOT NULL default '',
  contact_title varchar(240) NOT NULL default '',
  contact_phone varchar(50) NOT NULL default '',
  contact_email varchar(240) NOT NULL default '',
  cust_address longtext NOT NULL,
  cust_remarks longtext NOT NULL,
  cust_homepage varchar(240) NOT NULL default '',
  active enum('yes','no') NOT NULL default 'yes',
  customer_owner int(11) NOT NULL default '0',
  email_owner_upon_adds enum('no','yes') NOT NULL default 'no',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
);


DROP TABLE IF EXISTS [db_prefix]crmejournal;
CREATE TABLE [db_prefix]crmejournal (
  id int(11) NOT NULL auto_increment,
  eid int(11) NOT NULL default '0',
  category varchar(150) NOT NULL default '',
  content longtext NOT NULL,
  status varchar(50) NOT NULL default 'open',
  priority varchar(50) NOT NULL default 'low',
  owner int(11) NOT NULL default '0',
  assignee int(11) NOT NULL default '0',
  CRMcustomer int(11) NOT NULL default '0',
  tp timestamp NOT NULL default '0000-00-00 00:00:00',
  deleted enum('n','y') NOT NULL default 'n',
  duedate varchar(15) NOT NULL default '',
  sqldate date NOT NULL default '0000-00-00',
  obsolete enum('y','n') NOT NULL default 'n',
  cdate date NOT NULL default '0000-00-00',
  waiting enum('n','y') NOT NULL default 'n',
  readonly enum('n','y') NOT NULL default 'n',
  closedate date NOT NULL default '0000-00-00',
  lasteditby bigint(20) NOT NULL default '0',
  createdby bigint(20) NOT NULL default '0',
  notify_assignee enum('n','y') NOT NULL default 'n',
  notify_owner enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
);


DROP TABLE IF EXISTS [db_prefix]crmentity;
CREATE TABLE [db_prefix]crmentity (
  eid int(11) NOT NULL auto_increment,
  category varchar(150) NOT NULL default '',
  content longtext NOT NULL,
  status varchar(50) NOT NULL default 'open',
  priority varchar(50) NOT NULL default 'low',
  owner int(11) NOT NULL default '0',
  assignee int(11) NOT NULL default '0',
  CRMcustomer int(11) NOT NULL default '0',
  tp timestamp NOT NULL default '0000-00-00 00:00:00',
  deleted enum('n','y') NOT NULL default 'n',
  duedate varchar(15) NOT NULL default '',
  sqldate date NOT NULL default '0000-00-00',
  obsolete enum('y','n') NOT NULL default 'n',
  cdate date NOT NULL default '0000-00-00',
  waiting enum('n','y') NOT NULL default 'n',
  readonly enum('n','y') NOT NULL default 'n',
  closedate date NOT NULL default '0000-00-00',
  lasteditby bigint(20) NOT NULL default '0',
  createdby bigint(20) NOT NULL default '0',
  notify_assignee enum('n','y') NOT NULL default 'n',
  notify_owner enum('n','y') NOT NULL default 'n',
  openepoch varchar(30) NOT NULL default '',
  closeepoch varchar(30) NOT NULL default '',
  PRIMARY KEY  (eid),
  UNIQUE KEY id (eid),
  KEY id_2 (eid)
);


DROP TABLE IF EXISTS [db_prefix]crmhelp;
CREATE TABLE [db_prefix]crmhelp (
  helpid bigint(20) NOT NULL auto_increment,
  title varchar(240) NOT NULL default '',
  content longtext NOT NULL,
  PRIMARY KEY  (helpid)
);

INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (1, 'Download query result as CSV export file', 'When checked, the result of your search query will be ''pushed'' as an CSV-export file. <br><br>This means that you will <b>not</b> see the result on screen, but  you''ll jump to the CSV page. On that page you can select wich fields you want to export.<br><br>See also help on <a href=''help.php?id=4'' class=''topnav''>''Exporting data to Excel''</a>');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (2, 'Include entity contents', 'When checked, this function as a result will include the textual content of an entity in the summary. ');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (3, 'Include deleted entities', 'When checked, the query you created by using the pull-down boxes will also be ran over deleted entities in the database.<br><br>Use this function when searching for an enitity not knowing wheter or this entity is still available.<br><br>When found, you can easily undelete an entity by clicking ''Update in new window'' followed by unchecking the ''This is a deleted entity'' checkbox. Do not forget to click ''Save and close'' when you''re done.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (4, 'Exporting data to CSV (Excel)', 'CSV stands for Character Separated Values.<br><br>You can select the fields in the database you want to export. If you are unsure, just check all the boxes. You will now export all data in the database but the binairy files (the attachments).<br><br>By clicking ''Download exportfile'' you will immediately see a download dialog box. Click ''Open'', and, if it appears again, click ''Open'' again.<br><br>If you are looking for an export of an particular part of the database you can use the summary page, and check the ''Download result as CSV file'' option. See also help on <a href=''help.php?id=1'' class=''topnav''>''Download query result as CSV export file''</a>.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (5, 'Adding and modifing owners/assignees', 'You can modify owners/assignees by just clicking the name and altering the text.<br><br>Using the last field you can add owners/assignees, one at the time.<br>If a owner or assignee logs in with a limited account (which have to be created seprately using the same name), the user will only have rights to view the entities assigned to him- or herself, with the only right to add comments to the textual content and the right to attach files.<br><br><b>Important!</b><br>Do not switch users! The CRM works by the number, not the name!');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (6, 'Adding and modifing customers', 'You can modify customers by just clicking the name and altering the text.<br><br>Using the last field you can add customers, one at the time.<br><br><b>Important!</b><br>Do not switch customers! The CRM works by the number, not the name!');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (7, 'Fulltext search through all entities', 'When typing a word, or part of it, in the ''Enitity must contain text''-field, the CRM will search through the database for entities with that exact word in the ''Category'' or the content.<br><br>When you''ve also checked ''Include enitity contents'', the content will be <font color=ff3300><u>red-highlighted</u></font> when your search matched.<br><br>Wildcard searches or logical-operand searches are <b>not</b> supported.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (8, 'Management Information', 'Management Information displays summaries of data gathered from the database. These summaries are mostly statistics.<br><br>Check the summaries you want to see. If you check more boxes, the output will be longer. <br><br>If you check all boxes, remember this slows down the server, so maybe you''ll have to wait a little.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (9, 'Attach a file', 'Using this function you can attach a file to an enitity.<br><br>By clicking ''browse'' you''ll see a file select box. Browse to the file you want to attach. Click ''open'' and the path to the file will appear in the field box.<br><br>After you''ve saved the enitity, the file will be attached.<br><br>You can only attach one file at the time!');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (10, 'This entity is waiting for somebody else''s action', 'By checking this box you let the CRM know that the entity you''re working on is stalled because somebody else has to undertake action first.<br><br>This is mainly for management information purposes. Though; you can also use this as a search option when using the summary page.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (11, 'This entity really doesn''t belong here.', 'By checking this box you let the CRM know that the entity you''re working on really should not be logged in this CRM.<br><br>This is mainly for management information purposes.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (12, 'This is a deleted entity', 'When you check this box, <b>you delete the entire entity although it might not yet be closed.</b><br><br>When the checkbox was already checked an you uncheck it, you <b>undelete</b> the entity.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (13, '<center><b>Disclaimer</b></center>', '<center>(logo?)</center><br><i><b>ALL INFORMATION CONTAINED IN THIS WEBSITE IS CONFIDENTIAL</b><br><br> Although, with respect to documents available from this server, neither the author nor any other involved supplier makes any warranty, express or implied, including the warranties of merchantability and fitness for a particular purpose, or assumes any legal liability or responsibility for the accuracy,  completeness, or usefulness of any information, apparatus, product, or process disclosed, or represents that its use would not infringe privately owned rights. This should be perfectly clear for anybody who uses this website. Don''t agree? Too bad! Be warned!</i><br>');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (14, 'S.O.B.', 'S.O.B. stands for <i>Standard Operational B*llsh*t</i>');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (16, 'Quickmenu to entities', 'You can use the <i>little</i> fieldbox in the header of every page to quickly jump to an entity.<B>You can only enter entity-numbers in this box!</b>When you enter a valid number and press TAB or ENTER you will instantly jump to the edit window of that entity.<br><br>The <i>large</i> fieldbox is the searchbox from the summary page. When you enter a text in this box, the CRM will search all entities for matching records.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (17, 'Logging into the CRM', 'You can only login to this application if a username and a password was provided to you.<br><br>If you should be able to get in, but you cannot, use the e-mail adress as shown on the login page to send an email to the administrator of this site.<br><br>Clicking Save Username will save your used username to your machine using a so-called cookie. By clicking Clear Username the cookie will be deleted. The same goes for the password.');
INSERT INTO [db_prefix]crmhelp (helpid, title, content) VALUES (18, 'Brief entity overview matching query', 'By checking the Brief Overview box the result of you search query will be displayed in the format of the Brief Entity Overview. This may come in handy working with queries with many matches.');


DROP TABLE IF EXISTS [db_prefix]crmjournal;
CREATE TABLE [db_prefix]crmjournal (
  id bigint(20) NOT NULL auto_increment,
  eid bigint(20) NOT NULL default '0',
  timestamp timestamp NOT NULL default '0000-00-00 00:00:00',
  user bigint(20) NOT NULL default '0',
  message longtext NOT NULL,
  type varchar(20) NOT NULL default 'entity',
  PRIMARY KEY  (id),
  KEY eid (eid,user)
);


DROP TABLE IF EXISTS [db_prefix]crmlanguages;
CREATE TABLE [db_prefix]crmlanguages (
  id bigint(20) NOT NULL auto_increment,
  LANGID varchar(15) NOT NULL default '',
  TEXTID varchar(30) NOT NULL default '',
  TEXT varchar(255) NOT NULL default '',
  UNIQUE KEY id (id),
  KEY LANGID (LANGID)
);

INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (1, 'ENGLISH', 'customer', 'Customer');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (2, 'ENGLISH', 'owner', 'Owner');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (3, 'ENGLISH', 'entity', 'Entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (4, 'ENGLISH', 'priority', 'Priority');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (5, 'ENGLISH', 'assignee', 'Assignee');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (6, 'ENGLISH', 'duedate', 'Due date');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (7, 'ENGLISH', 'alarmdate', 'Alarm date');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (8, 'ENGLISH', 'alarmdatev', 'Set an alarm for this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (9, 'ENGLISH', 'category', 'Category');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (10, 'ENGLISH', 'status', 'Status');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (11, 'ENGLISH', 'helpcontents', 'Help contents');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (12, 'ENGLISH', 'tolimited', 'Due to insufficient priviledges you are redirected to the limited interface.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (13, 'ENGLISH', 'briefover', 'Brief entity overview');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (14, 'ENGLISH', 'mightbebetter', 'It might be better to use the summary option!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (15, 'ENGLISH', 'editthis', 'Edit this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (16, 'ENGLISH', 'alarmsettings', 'Alarm settings');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (17, 'ENGLISH', 'closethisentity', 'Close this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (18, 'ENGLISH', 'deletethisentity', 'Delete this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (19, 'ENGLISH', 'downloadpdf', 'Download PDF report of this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (20, 'ENGLISH', 'downloadpdfs', 'Download PDF report');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (21, 'ENGLISH', 'close', 'Close');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (22, 'ENGLISH', 'edit', 'Edit');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (23, 'ENGLISH', 'delete', 'Delete');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (24, 'ENGLISH', 'pdfreport', 'PDF Report');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (25, 'ENGLISH', 'welcome1', 'Welcome to the');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (26, 'ENGLISH', 'intro1', 'This tool is used to log and assign customer questions. At this moment there are');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (27, 'ENGLISH', 'intro2', 'users registered,<br>which have a total of');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (28, 'ENGLISH', 'intro3', 'entities logged, for');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (29, 'ENGLISH', 'intro4', 'customers.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (30, 'ENGLISH', 'welcome', 'Welcome');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (31, 'ENGLISH', 'lastlogon', 'Last logon');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (32, 'ENGLISH', 'entitiestoday', 'Entities due today');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (33, 'ENGLISH', 'noentities', 'There are no entities due for today');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (34, 'ENGLISH', 'gotomainpage', 'Go to main page');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (35, 'ENGLISH', 'main', 'Main');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (36, 'ENGLISH', 'addcusttodb', 'Add a customer request to the database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (37, 'ENGLISH', 'add', 'Add');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (38, 'ENGLISH', 'viewbrief', 'View a brief list of the current entities in the database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (39, 'ENGLISH', 'entities', 'Entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (40, 'ENGLISH', 'brieflistdel', 'View a brief list of the deleted entities in the database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (41, 'ENGLISH', 'delentities', 'Deleted entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (42, 'ENGLISH', 'vacoa', 'View, add or change possible owners and assignees');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (43, 'ENGLISH', 'oa', 'Owners/assignees');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (44, 'ENGLISH', 'vacc', 'View, add or change customers');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (45, 'ENGLISH', 'customers', 'Customers');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (46, 'ENGLISH', 'dumpi', 'Dump a character separated scheme of the database for export purposes');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (47, 'ENGLISH', 'phonebook1', 'Phonebook');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (48, 'ENGLISH', 'phonebookshort', 'PB');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (49, 'ENGLISH', 'sumverb', 'View and print more advanced summaries');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (50, 'ENGLISH', 'summary', 'Summary');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (51, 'ENGLISH', 'logout', 'Logout');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (52, 'ENGLISH', 'maninfo', 'Management information');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (53, 'ENGLISH', 'maninfoverb', 'Statistic reports for management information purposes');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (54, 'ENGLISH', 'sitestats', 'Site statistics');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (55, 'ENGLISH', 'sitestatsverb', 'This website"s statistic information');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (56, 'ENGLISH', 'administration', 'Administration');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (57, 'ENGLISH', 'administrationverb', 'Administrator functions');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (58, 'ENGLISH', 'helpcontentsverb', 'Show content list of available help');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (59, 'ENGLISH', 'dateinvalid', 'The date you entered is invalid. The date value is unset.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (60, 'ENGLISH', 'entrysaved', 'Entry saved under number');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (61, 'ENGLISH', 'wasadded', 'was added.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (62, 'ENGLISH', 'deleting1', 'Deleting');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (63, 'ENGLISH', 'deleting2', 'file(s). Please confirm by clicking the button below.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (64, 'ENGLISH', 'confdel', 'Confirm deletion');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (65, 'ENGLISH', 'deletingentity', 'Deleting entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (66, 'ENGLISH', 'ownedby', 'owned by');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (67, 'ENGLISH', 'assignedto', 'assigned to');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (68, 'ENGLISH', 'curstat', 'Current status');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (69, 'ENGLISH', 'created', 'created');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (70, 'ENGLISH', 'lastupdate', 'last update');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (71, 'ENGLISH', 'deleteerror', 'Since this entity is not yet closed you cannot delete it!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (72, 'ENGLISH', 'confirmdel', 'Click here to delete this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (73, 'ENGLISH', 'search', 'Search');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (74, 'ENGLISH', 'thereare', 'There are');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (75, 'ENGLISH', 'openentities', 'open entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (76, 'ENGLISH', 'noopen', 'There are no open entities.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (77, 'ENGLISH', 'nonexistent', 'You entered a non-existing Entity number!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (78, 'ENGLISH', 'editing', 'Editing');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (79, 'ENGLISH', 'wasclosed', 'This entity was closed');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (80, 'ENGLISH', 'newentity', 'New entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (81, 'ENGLISH', 'isdeleted', 'This is a deleted entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (82, 'ENGLISH', 'iswaiting', 'Waiting for somebody else"s action');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (83, 'ENGLISH', 'doesntbelonghere', 'This entity really doesn"t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (84, 'ENGLISH', 'listofatt', 'List of files currently attached to this entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (85, 'ENGLISH', 'filename', 'Filename');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (86, 'ENGLISH', 'filesize', 'Filesize');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (87, 'ENGLISH', 'creationdate', 'Creation date');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (88, 'ENGLISH', 'deletefile', 'Delete');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (89, 'ENGLISH', 'attachfile', 'Attach file');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (90, 'ENGLISH', 'saveclose', 'Save and close');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (91, 'ENGLISH', 'cancel', 'Cancel');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (92, 'ENGLISH', 'save', 'Save to database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (93, 'ENGLISH', 'noaction', 'Error, no action submitted');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (94, 'ENGLISH', 'zailo', 'zero assigned is left out');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (95, 'ENGLISH', 'name', 'Name');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (96, 'ENGLISH', 'usrwarning', 'If a box is disabled (grey), it means this owner or assignee has his or her own limited login account, and therefore the name may not be changed<br>for the reference between these accounts would then be lost.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (97, 'ENGLISH', 'ownassindb', 'Owners or assignees in database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (98, 'ENGLISH', 'addownass', 'Add a owner/assignee');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (99, 'ENGLISH', 'apply', 'Apply changes');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (100, 'ENGLISH', 'custindb', 'Customers in database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (101, 'ENGLISH', 'addcust', 'Add a customer');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (102, 'ENGLISH', 'selectfields', 'Please select the fields you want to appear in your export');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (103, 'ENGLISH', 'lastupdatedate', 'Last update date');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (104, 'ENGLISH', 'lastupdatetime', 'Last update time');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (105, 'ENGLISH', 'closedate', 'Closure date');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (106, 'ENGLISH', 'waitingcsv', 'Waiting');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (107, 'ENGLISH', 'doesntcsv', 'Doesn''t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (108, 'ENGLISH', 'contents', 'Contents');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (109, 'ENGLISH', 'alreadyselected', '<b>Your query is stored</b>');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (110, 'ENGLISH', 'sep', 'Separation character');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (111, 'ENGLISH', 'scqp', 'Semicolon quoted-printable (;) (recommended)');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (112, 'ENGLISH', 'cqp', 'Colon quoted-printable (:)');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (113, 'ENGLISH', 'kqp', 'Comma quoted-printable (,)');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (114, 'ENGLISH', 'csvwarning', 'When the download-dialog box appears, choose ''open file from current location''.<br> This box may occur again. When it does, click "open" again. This should spawn MS Excel <br>with your exported data.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (115, 'ENGLISH', 'downloadexport', 'Download exportfile');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (116, 'ENGLISH', 'repdownloaded', 'Report downloaded');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (117, 'ENGLISH', 'endofreport', 'End of report. Have an extremely nice day');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (118, 'ENGLISH', 'noresults', 'This query had no results.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (119, 'ENGLISH', 'entitiesfound', 'entities found.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (120, 'ENGLISH', 'pbexport', 'phonebook export');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (121, 'ENGLISH', 'endofpbexport', '<red> -- End of report --');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (122, 'ENGLISH', 'pbexpmade', 'Phonebook export created');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (123, 'ENGLISH', 'wasdeleted', 'was deleted');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (124, 'ENGLISH', 'pbdelconf', 'Are you sure you want to delete this record?');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (125, 'ENGLISH', 'fname', 'First name');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (126, 'ENGLISH', 'lname', 'Last name');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (127, 'ENGLISH', 'tel', 'Telephone');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (128, 'ENGLISH', 'company', 'Company');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (129, 'ENGLISH', 'dep', 'Department');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (130, 'ENGLISH', 'title', 'Title');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (131, 'ENGLISH', 'room', 'Room');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (132, 'ENGLISH', 'deletepb', 'Delete');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (133, 'ENGLISH', 'pbrecadded', 'Your record was added to the phonebook.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (134, 'ENGLISH', 'pbapp', 'Your changes are applied.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (135, 'ENGLISH', 'pbwarning', 'Please fill in at least the last name!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (136, 'ENGLISH', 'addtopb', 'Add to phonebook');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (137, 'ENGLISH', 'pbresults', 'Results for your query');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (138, 'ENGLISH', 'options', 'Options');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (139, 'ENGLISH', 'resfound', 'matches found');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (140, 'ENGLISH', 'pbcont1', 'This phonebook contains');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (141, 'ENGLISH', 'pbcont2', 'entries');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (142, 'ENGLISH', 'pbaddrec', 'add a record');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (143, 'ENGLISH', 'entsum', 'entity summary');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (144, 'ENGLISH', 'showonly', 'Show only');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (145, 'ENGLISH', 'all', 'All');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (146, 'ENGLISH', 'inccont', 'Include entity contents');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (147, 'ENGLISH', 'incldel', 'Include deleted entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (148, 'ENGLISH', 'dlacsv', 'Download result as CSV');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (149, 'ENGLISH', 'briefo', 'Brief overview');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (150, 'ENGLISH', 'mustcontain', 'Entity must contain text');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (151, 'ENGLISH', 'please', 'Please make your choice...');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (152, 'ENGLISH', 'remarks', 'Remarks');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (153, 'ENGLISH', 'hasfilessum', 'This entity has files attached');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (154, 'ENGLISH', 'expired', 'This entities due date is expired!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (155, 'ENGLISH', 'thisiswaiting', 'This entity is waiting for somebody else''s action.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (156, 'ENGLISH', 'thisdoesntbelong', 'This entity really doesn''t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (157, 'ENGLISH', 'clear', 'clear');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (158, 'ENGLISH', 'wrongpwd', 'Wrong password. Please try again or get lost');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (159, 'ENGLISH', 'havetoenterpwd', 'Since your account does not have administrator priviledges you have to enter the administrator password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (160, 'ENGLISH', 'adm', 'Administration');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (161, 'ENGLISH', 'nopwd', 'Since your account has administrator priviledges you were not prompted for a password.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (162, 'ENGLISH', 'imported', 'print "There were $imported records imported."');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (163, 'ENGLISH', 'ignored', 'records were ignored because of an empty name field.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (164, 'ENGLISH', 'impwarning', 'To exclude a record from being imported, empty the firstname-field. Correct faulty records.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (165, 'ENGLISH', 'commawarning', 'Since you chose to import a comma-separated file, be aware that combinations like Last_name,First_name (which are commonly used in MS Outlook) can produce undesireable results.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (166, 'ENGLISH', 'importinpb', 'Import phonebook records');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (167, 'ENGLISH', 'pbimpwarning', 'The CSV data you paste <i>must</i> contain all fields, although they may be empty:');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (168, 'ENGLISH', 'paste', 'Paste your text here ...');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (169, 'ENGLISH', 'pleasechoose', 'Please choose one of the options hereunder:');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (170, 'ENGLISH', 'chgsys', 'Change system values');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (171, 'ENGLISH', 'impphone', 'Import phonebook records');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (172, 'ENGLISH', 'viewfiles', 'View files in database');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (173, 'ENGLISH', 'delallclosed', 'Delete all closed entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (174, 'ENGLISH', 'eahelp', 'Add / edit help topics');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (175, 'ENGLISH', 'physdel', 'Physically delete a deleted entity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (176, 'ENGLISH', 'viewlog', 'View log entries & stats');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (177, 'ENGLISH', 'manacc', 'Manage accounts');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (178, 'ENGLISH', 'isdel', 'has been deleted');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (179, 'ENGLISH', 'delfile', 'Deleting physical file');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (180, 'ENGLISH', 'physdelwarning', 'Please enter the entity ID of the <b>closed and deleted</b> entity you want to <b>physically</b> delete:');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (181, 'ENGLISH', 'confphysdel', 'Please confirm physical deletion by clicking the button below.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (182, 'ENGLISH', 'addhelp', 'Add a help entry:');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (183, 'ENGLISH', 'editaccount', 'Edit an account');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (184, 'ENGLISH', 'addaccount', 'Add an account');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (185, 'ENGLISH', 'password', 'Password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (186, 'ENGLISH', 'addu', 'Add user');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (187, 'ENGLISH', 'btmap', 'back to main administration page');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (188, 'ENGLISH', 'passwarn', 'leave both blank to keep current password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (189, 'ENGLISH', 'limited', 'Limited');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (190, 'ENGLISH', 'normal', 'Normal');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (191, 'ENGLISH', 'adminrights', 'Administrator');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (192, 'ENGLISH', 'yes', 'Yes');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (193, 'ENGLISH', 'no', 'No');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (194, 'ENGLISH', 'ela', 'Editing login account');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (195, 'ENGLISH', 'dta', 'Delete this account');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (196, 'ENGLISH', 'passmatcherror', 'Passwords do not match. Press ''back'' in your browser and re-type password.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (197, 'ENGLISH', 'nimut', 'An error occured!<br><br>This account exists, but it<br>doesn''t refer to any user in the database to which entities could be assigned.<br><br>Check the name (and the case) and try again.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (198, 'ENGLISH', 'uwchala', 'Users which could have a limited account');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (199, 'ENGLISH', 'tawu', 'The account was updated');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (200, 'ENGLISH', 'setting', 'Setting');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (201, 'ENGLISH', 'value', 'Value');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (202, 'ENGLISH', 'discription', 'Description');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (203, 'ENGLISH', 'ocsvifb', 'Or change system values in form below');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (204, 'ENGLISH', 'csvnow', 'Change system values');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (205, 'ENGLISH', 'plzenterpwd', 'Please enter password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (206, 'ENGLISH', 'eor', 'End of report');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (207, 'ENGLISH', 'smtsm', 'Select more to see more...');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (208, 'ENGLISH', 'dlmspdf', 'or click here to download the (more compact) PDF report');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (209, 'ENGLISH', 'sts', 'Summaries to show');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (210, 'ENGLISH', 'oqs', 'Overall quick summary');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (211, 'ENGLISH', 'eobu', 'Entities owned by users');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (212, 'ENGLISH', 'eatu', 'Entities assigned to users');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (213, 'ENGLISH', 'sae', 'Self-assigned entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (214, 'ENGLISH', 'etdbh', 'Entities that don''t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (215, 'ENGLISH', 'ewfsea', 'Entities waiting for somebody else''s action');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (216, 'ENGLISH', 'epc', 'Entities per customer');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (217, 'ENGLISH', 'oepa', 'Overdue entities per assignee');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (218, 'ENGLISH', 'deleted', 'Deleted');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (219, 'ENGLISH', 'total', 'Total');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (220, 'ENGLISH', 'ofwhich', 'of which');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (221, 'ENGLISH', 'allround', 'All values are rounded');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (222, 'ENGLISH', 'atac', 'and thus also closed');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (223, 'ENGLISH', 'edd', 'Expired due dates');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (224, 'ENGLISH', 'dontbelonghere', 'Entities that don''t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (225, 'ENGLISH', 'eatw', 'Entities added this week');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (226, 'ENGLISH', 'ectw', 'Entities closed this week');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (227, 'ENGLISH', 'eatm', 'Entities added this month');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (228, 'ENGLISH', 'ectm', 'Entities closed this month');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (229, 'ENGLISH', 'of', 'Of');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (230, 'ENGLISH', 'tad', 'entities counted, the overall average ''open-time'' from adding a new entity till closing that entity was');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (231, 'ENGLISH', 'cuaeoay', 'Counted using <u>all</u> closed entities in the database, over <u>all</u> years');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (232, 'ENGLISH', 'users', 'Users');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (233, 'ENGLISH', 'customers', 'Customers');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (234, 'ENGLISH', 'zoilo', 'zero owned is left out');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (235, 'ENGLISH', 'ombla', 'Or : maybe entities which aren''t assiged yet or couldn''t be assigned (...)');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (236, 'ENGLISH', 'andassignee', 'and assignee');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (237, 'ENGLISH', 'selfassig', 'Self-assigned');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (238, 'ENGLISH', 'aohnsae', 'Other owners have no self-assigned entities.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (239, 'ENGLISH', 'onavarage', 'On average');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (240, 'ENGLISH', 'oaoedbh', 'of all <b>open</b> entities doesn''t belong here');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (241, 'ENGLISH', 'teaair', 'The entity and all its references were physically deleted');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (242, 'ENGLISH', 'cookiewarning', 'Do not use this function on public computers!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (243, 'ENGLISH', 'username', 'Username');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (244, 'ENGLISH', 'saveusername', 'Remember username');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (245, 'ENGLISH', 'clearusername', 'Forget username');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (246, 'ENGLISH', 'savepassword', 'Remember password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (247, 'ENGLISH', 'clearpassword', 'Forget password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (248, 'ENGLISH', 'signedoff', 'You signed off. Please type your username and password to log in again');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (249, 'ENGLISH', 'signedoffdue1', 'You were signed off due to');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (250, 'ENGLISH', 'signedoffdue2', 'minutes of inactivity');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (251, 'ENGLISH', 'sysmsg', 'The system administrator has left a message for you');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (252, 'ENGLISH', 'pleaseenter', 'Please enter your username and password');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (253, 'ENGLISH', 'language', 'Language');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (254, 'ENGLISH', 'pushpdf', 'Download results as PDF-file');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (255, 'ENGLISH', 'managementheader', 'Welcome to the limited interface. You are logged on as');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (256, 'ENGLISH', 'oefm', 'Open entities for');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (257, 'ENGLISH', 'showresults', 'Report method');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (258, 'ENGLISH', 'verbose', 'Verbose');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (259, 'ENGLISH', 'verbosewithcontents', 'Verbose with contents');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (260, 'ENGLISH', 'briefsum', 'Brief');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (261, 'ENGLISH', 'downloadsumpdf', 'Download summary as PDF-file');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (262, 'ENGLISH', 'downloadsumcsv', 'Download summary in Excel-format');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (263, 'ENGLISH', 'packman', 'Manage language packs');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (264, 'ENGLISH', 'openinnewwindow', 'Open in new window');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (265, 'ENGLISH', 'delcust', 'Delete this customer (<b>no</b> confirmation asked)');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (266, 'ENGLISH', 'nousers1', 'There are no owners / assignees configured. Before you can start using CRM, you must do this. Click on ''Owners/Assignees'' to add possible owners and assignees!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (267, 'ENGLISH', 'custhomepage', 'Homepage');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (268, 'ENGLISH', 'custremarks', 'Remarks');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (269, 'ENGLISH', 'customeraddress', 'Customer address');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (270, 'ENGLISH', 'contactemail', 'Contact e-mail');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (271, 'ENGLISH', 'contactphone', 'Contact phone');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (272, 'ENGLISH', 'contact', 'Contact');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (273, 'ENGLISH', 'contacttitle', 'Contact title');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (274, 'ENGLISH', 'custdelexplain', 'This customer cannot be deleted because there are entities belonging to this customer');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (275, 'ENGLISH', 'editextras', 'Edit extra values');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (276, 'ENGLISH', 'fieldname', 'Field name');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (277, 'ENGLISH', 'iftynmvhpcysa', 'If you think you need more fieldname values here, please contact your CRM system administrator.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (278, 'ENGLISH', 'extrafields', 'Extra fields');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (279, 'ENGLISH', 'uinw', 'Update in new window');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (280, 'ENGLISH', 'nocustomers1', 'There are no customers configured. Before you can start using CRM, you must do this. Click on ''Customers'''' to add at least 1 customer!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (281, 'ENGLISH', 'nousersandnocustomers1', 'There are no customers and no possible Owners/Assignees configured. Before you can start using CRM, you must do this. Click on ''Customers'''' to add at least 1 customer, and next on ''Owners/Assignees'' to add at least 1 possible Owner/Assignee!');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (282, 'ENGLISH', 'managerepositories', 'Manage repositories');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (283, 'ENGLISH', 'viewdelentities', 'View deleted entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (284, 'ENGLISH', 'viewinsertedentities', 'Inserted entities');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (285, 'ENGLISH', 'readonly', 'Read-only to other users');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (286, 'ENGLISH', 'stillchecked1', 'This file is still locked for editing by');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (287, 'ENGLISH', 'stillchecked2', '. Please stop editing this file before trying to check it in.');
INSERT INTO [db_prefix]crmlanguages (id, LANGID, TEXTID, TEXT) VALUES (288, 'ENGLISH', 'saveasnewentity', 'Save as new entity');


DROP TABLE IF EXISTS [db_prefix]crmloginusers;
CREATE TABLE [db_prefix]crmloginusers (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  password varchar(50) default NULL,
  type enum('normal','limited') NOT NULL default 'normal',
  active enum('yes','no') NOT NULL default 'yes',
  exptime varchar(40) NOT NULL default '',
  noexp enum('n','y') NOT NULL default 'n',
  FULLNAME varchar(150) NOT NULL default '',
  EMAIL varchar(150) NOT NULL default '',
  CLLEVEL varchar(50) NOT NULL default 'ro',
  administrator enum('yes','no') NOT NULL default 'no',
  LASTFILTER longtext NOT NULL,
  LASTSORT varchar(50) NOT NULL default '',
  RECEIVEDAILYMAIL enum('No','Yes') NOT NULL default 'No',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
);

INSERT INTO [db_prefix]crmloginusers (id, name, password, type, active, exptime, noexp, FULLNAME, EMAIL, CLLEVEL, administrator, LASTFILTER, LASTSORT, RECEIVEDAILYMAIL) VALUES (1, 'admin', '43e9a4ab75570f5b', 'normal', 'yes', '', 'n', 'Administrator admin', '', 'rw', 'yes', 'a:6:{s:16:"pdfiltercustomer";s:1:"4";s:14:"pdfilterstatus";s:3:"all";s:16:"pdfilterpriority";s:3:"all";s:13:"pdfilterowner";s:3:"all";s:16:"pdfilterassignee";s:3:"all";s:18:"pdfilterextrafield";s:8:"YTowOnt9";}', '', 'No');


DROP TABLE IF EXISTS [db_prefix]crmphonebook;
CREATE TABLE [db_prefix]crmphonebook (
  id mediumint(5) NOT NULL auto_increment,
  Firstname varchar(50) NOT NULL default '',
  Lastname varchar(50) NOT NULL default '',
  Telephone varchar(15) NOT NULL default '',
  Company varchar(50) NOT NULL default '',
  Department varchar(50) NOT NULL default '',
  Title varchar(100) NOT NULL default '',
  Room varchar(60) NOT NULL default '',
  Email varchar(60) NOT NULL default '',
  UNIQUE KEY id (id)
);


DROP TABLE IF EXISTS [db_prefix]crmpriorityvars;
CREATE TABLE [db_prefix]crmpriorityvars (
  id int(11) NOT NULL auto_increment,
  varname varchar(50) NOT NULL default '',
  color varchar(7) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]crmpriorityvars (id, varname, color) VALUES (1, 'Critical', '#FF6666');
INSERT INTO [db_prefix]crmpriorityvars (id, varname, color) VALUES (2, 'High', '#FFFF66');
INSERT INTO [db_prefix]crmpriorityvars (id, varname, color) VALUES (3, 'Medium', '#FFFF99');
INSERT INTO [db_prefix]crmpriorityvars (id, varname, color) VALUES (4, 'Low', '#FFFFCC');


DROP TABLE IF EXISTS [db_prefix]crmsessions;
CREATE TABLE [db_prefix]crmsessions (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  temp varchar(100) NOT NULL default '',
  active enum('yes','no') NOT NULL default 'yes',
  exptime varchar(40) NOT NULL default '',
  noexp enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
);


DROP TABLE IF EXISTS [db_prefix]crmsettings;
CREATE TABLE [db_prefix]crmsettings (
  settingid bigint(20) NOT NULL auto_increment,
  setting varchar(150) NOT NULL default '',
  value longtext NOT NULL,
  datetime timestamp NOT NULL default '0000-00-00 00:00:00',
  discription varchar(250) NOT NULL default '',
  UNIQUE KEY settingid (settingid)
);

INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (1, 'title', 'Mortgage', '2002-05-20 18:43:01', 'Will appear almost anywhere.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (2, 'logo', '*NONE*', '2002-05-20 14:22:03', 'Location of your company logo (small, GIF or JPEG). *NONE* disables the logo.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (4, 'admpassword', '*NONE*', '2002-05-20 16:20:29', 'Administration password, *NONE* disables the authentication at all.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (5, 'mipassword', '*NONE*', '2002-05-20 18:41:55', 'Management Information password, *NONE* disables the authentication at all.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (6, 'managementinterface', 'off', '2002-05-20 21:03:25', 'When set to ''on'', users authenticated as a limited user will only see the restricted managementinterface with very limited priviledges. Opposite to ''on'' is ''off''.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (7, 'admemail', 'support@pilotgroup.net', '2004-10-01 15:05:21', 'The administrators email-addres.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (8, 'cronpassword', '', '2002-05-20 18:06:54', 'The password used by the HTTP-GET crond job (duedate-notify-cron.php)');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (9, 'timeout', '20', '0000-00-00 00:00:00', 'Number of minutes before a user is automatically logged off when there is no activity');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (10, 'Logon message', '', '2004-09-30 19:10:00', 'This message will be displayed when a user logs in.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (11, 'navtype', 'TABS', '2004-09-30 19:10:00', 'Navigation bar type. Use NOTABS for normal navigation, anything else for tabs');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (12, 'langoverride', 'no', '2004-09-30 19:10:00', 'Language override. No to let the user be able to choose his or her own language, yes to disable this feature and thereby force the use of the system-wide language choosen hereunder.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (13, 'Extra fields list', '', '2004-09-30 19:10:00', 'List of extra which can be added to an entity. Take extra care when editing this in a live environment!');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (14, 'EmailNewEntities', '', '2004-09-30 19:10:00', 'The e-mail address to which notifications of added entities should be mailed. Leave empty for no notification.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (15, 'MonthsToShow', '7', '2004-09-30 19:10:00', 'The number of months to show in the various calendar appearances.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (16, 'ShowDeletedViewOption', 'no', '2004-09-30 19:10:00', 'Wheter or not CRM should display a menu tab to view the deleted entities. Options are yes or no.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (17, 'EnableCustInsert', 'no', '2004-09-30 19:10:00', 'Set this to yes to enable the [customer] insert functionality, no to keep customers from logging in even if they have a customer account.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (18, 'SMTPserver', 'localhost', '2004-09-30 19:10:00', 'The hostname or IP-address of your SMTP (outgoing mail) server');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (19, 'BODY_DUEDATE', '<BODY><FONT FACE="MS Shell Dlg" SIZE="2"><B>An alarm date of one of your entities has been reached.</B><BR><BR>This email is concerning entity @ENTITYID@, @CATEGORY@<BR><BR><BR>The history of this entity is printed below.<br>If this email was not intended for you, please contact owner @OWNER@ or assignee @ASSIGNEE@.<BR><BR>History:<BR><BR><TABLE BORDER=1><TR><TD>@CONTENTS@.</TD></TR></TABLE><BR><BR>If you do nothing, you will <I>not</I> be reminded about this entity again.<BR><BR>End of this e-mail.<BR><TABLE><TR><TD>Entity:</TD><TD>@ENTITYID@</TD></TR><TR><TD>Category:</TD><TD>@CATEGORY@</TD></TR><TR><TD>Owner:</TD><TD>@OWNER@</TD></TR><TR><TD>Assignee:</TD><TD>@ASSIGNEE@</TD></TR><TR><TD>Contents:</TD><TD>See attachment</TD></TR><TR><TD>Admin email:</TD><TD>@ADMINEMAIL@</TD></TR><TR><TD>Webhost:</TD><TD>@WEBHOST@</TD></TR><TR><TD>Title:</TD><TD>@TITLE@</TD></TR><TR><TD>Customer:</TD><TD>@CUSTOMER@</TD></TR><TR><TD>Due-date:</TD><TD>@DUEDATE@</TD></TR><TR><TD>Status:</TD><TD>@STATUS@</TD></TR><TR><TD>Priority:</TD><TD>@PRIORITY@</TD></TR></TABLE></FONT></BODY>', '2004-09-30 19:10:00', 'The body of the email which will be sent to an assignee when an alarm date of a certain entity is met. Please read the manual before editing this setting.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (20, 'BODY_ENTITY_ADD', '<BODY><FONT FACE="MS Shell Dlg" SIZE="2"><B>A new entity was added to repository "@TITLE@"</B><BR><BR>This email is concerning a new entity with category "@CATEGORY@"<BR>This entity will be available in your CRM installation at @WEBHOST@ under EID number @ENTITYID@.<BR><BR>If this email was not intended for you, please contact @ADMINEMAIL@<BR><BR><TABLE><TR><TD>Entity:</TD><TD>@ENTITYID@</TD></TR><TR><TD>Category:</TD><TD>@CATEGORY@</TD></TR><TR><TD>Owner:</TD><TD>@OWNER@</TD></TR><TR><TD>Assignee:</TD><TD>@ASSIGNEE@</TD></TR><TR><TD>Contents:</TD><TD>See attachment</TD></TR><TR><TD>Admin email:</TD><TD>@ADMINEMAIL@</TD></TR><TR><TD>Webhost:</TD><TD>@WEBHOST@</TD></TR><TR><TD>Title:</TD><TD>@TITLE@</TD></TR><TR><TD>Customer:</TD><TD>@CUSTOMER@</TD></TR><TR><TD>Due-date:</TD><TD>@DUEDATE@</TD></TR><TR><TD>Status:</TD><TD>@STATUS@</TD></TR><TR><TD>Priority:</TD><TD>@PRIORITY@</TD></TR></TABLE></FONT></BODY>', '2004-09-30 19:10:00', 'The body of the email which will be sent when a new entity is added. Please read the manual before editing this setting.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (21, 'BODY_ENTITY_EDIT', '<BODY><FONT FACE="MS Shell Dlg" SIZE="2"><B>One of your entities in repository "@TITLE@" was updated.</B><BR><BR>This email is concerning your entity with category "@CATEGORY@"<BR>This entity is available in your CRM installation at @WEBHOST@ under EID number @ENTITYID@. <BR><BR>If this email was not intended for you, please contact @ADMINEMAIL@<BR><BR><TABLE><TR><TD>Entity:</TD><TD>@ENTITYID@</TD></TR><TR><TD>Category:</TD><TD>@CATEGORY@</TD></TR><TR><TD>Owner:</TD><TD>@OWNER@</TD></TR><TR><TD>Assignee:</TD><TD>@ASSIGNEE@</TD></TR><TR><TD>Contents:</TD><TD>See attachment</TD></TR><TR><TD>Admin email:</TD><TD>@ADMINEMAIL@</TD></TR><TR><TD>Webhost:</TD><TD>@WEBHOST@</TD></TR><TR><TD>Title:</TD><TD>@TITLE@</TD></TR><TR><TD>Customer:</TD><TD>@CUSTOMER@</TD></TR><TR><TD>Due-date:</TD><TD>@DUEDATE@</TD></TR><TR><TD>Status:</TD><TD>@STATUS@</TD></TR><TR><TD>Priority:</TD><TD>@PRIORITY@</TD></TR></TABLE></FONT></BODY>', '2004-09-30 19:10:00', 'The body of the email which will be sent when an entity is updated. Please read the manual before editing this setting.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (22, 'ShowNumOfAttachments', 'No', '2004-09-30 19:10:00', 'Wether or not to show the number of attached documents in the main entity lists');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (23, 'DBVERSION', '2.4.6', '2004-09-30 19:10:00', 'The current database version');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (24, 'ShowEmailButton', 'Yes', '2004-09-30 19:10:00', 'Yes to show an extra button to send an e-mail to the assignee when an entity is added or edited, no to disable this option.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (25, 'ShowMainPageCalendar', 'Yes', '2004-09-30 19:10:00', 'Yes to show the 3-month calendar on the main page, no to disable this option.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (26, 'Extra customer fields list', '', '2004-09-30 19:10:00', '');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (27, 'Category pulldown list', '', '2004-09-30 19:10:00', '');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (28, 'ForceCategoryPulldown', '', '2004-09-30 19:10:00', 'Yes to show a pulldown list for the category, no to make it a text box.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (29, 'ShowRecentEditedEntities', '7', '2004-09-30 19:10:00', '0 for no recent list, any number under 20 to show the most recent edited entities on the main page.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (30, 'EnableEntityJournaling', 'Yes', '2004-09-30 19:10:00', 'Set this value to Yes if you want entity journaling enabled (a link will be added to the main edit entity page)');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (31, 'AutoCompleteCustomerNames', 'No', '2004-09-30 19:10:00', 'Set this value to Yes if you want a text box wich auto-completes customer names instead of a pull-down menu with all customers.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (32, 'EnableEntityContentsJournaling', 'Yes', '2004-09-30 19:10:00', 'Set this value to Yes if you want a drop-down box in the main entity window to switch to history states of an entity');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (33, 'DontShowPopupWindow', 'No', '2004-09-30 19:10:00', 'No to show the standard javascript popup window in the entity overview, yes to disable it and make editing the entity the default action when clicking on the row.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (34, 'ShowFilterInMainList', 'Yes', '2004-09-30 19:10:00', 'Wether or not to show the filter pulldowns on top of the main entity list');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (35, 'ShowShortKeyLegend', 'Yes', '2004-09-30 19:10:00', 'Wether or not to show the ShortKeys (ALT-1..ALT-9) legend on the tabs');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (36, 'MainListColumnsToShow', 'a:9:{s:2:"id";b:1;s:7:"cb_cust";b:1;s:8:"cb_owner";b:1;s:11:"cb_assignee";b:1;s:9:"cb_status";b:1;s:11:"cb_priority";b:1;s:11:"cb_category";b:1;s:10:"cb_duedate";b:1;s:12:"cb_alarmdate";b:1;}', '2004-09-30 19:10:00', 'non-editable by admin');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (37, 'LetUserSelectOwnListLayout', 'Yes', '2004-09-30 19:10:00', 'Wether or not to let the user select his/her own list layout');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (38, 'BODY_TEMPLATE_CUSTOMER', '<FONT face="MS Shell Dlg"><P><FONT size=2>&gt;&gt; This mail is regarding entity @ENTITYID@ , "@CATEGORY@" in CRM @TITLE@ at @WEBHOST@<BR>-----------------------<BR>Send from CRM-CTT<BR></FONT><A href="http://crm.it-combine.com/"><FONT size=2>http://crm.it-combine.com</FONT></A><BR></P></FONT>', '2004-09-30 19:10:00', 'The template wich is used when sending an e-mail to a customer (editable by user before sending)');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (39, 'ShowPDWASLink', 'No', '2004-09-30 19:10:00', 'Yes to show the PDWAS link in the file list. PDWAS is a CRM-CTT addon which enables you to edit flies and directly save them to CRM-CTT without having to upload the file manually.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (40, 'EnableWebDAVSubsystem', 'No', '2004-09-30 19:10:01', 'Yes to enable the WebDAV subsystem, no to disable it');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (41, 'DateFormat', 'dd-mm-yyyy', '2004-09-30 19:10:01', 'Enter ''mm-dd-yyyy'' here to display dates in US format, anything else to display dates in international format (which is dd-mm-yyyy).');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (42, 'HideCustomerTab', 'no', '2004-09-30 19:10:01', 'Set this value to ''Yes'' if you want the customer tab only to be visible to administrators');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (43, 'CustomerListColumnsToShow', 'a:5:{s:2:"id";b:1;s:11:"cb_custname";b:1;s:10:"cb_contact";b:1;s:16:"cb_contact_phone";b:1;s:9:"cb_active";b:1;}', '2004-09-30 19:10:01', 'The columns to show in the customer list');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (44, 'ShowSaveAsNewEntityButton', 'Yes', '2004-09-30 19:10:01', 'Yes to show the Save As New Entity button, no to hide it.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (45, 'AutoCompleteCategory', 'Yes', '2004-09-30 19:10:01', 'Enter Yes of you would like type-ahead functionality in the category field on the main entity page');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (46, 'AutoInsertDateTime', 'No', '2004-09-30 19:10:01', 'Enter Yes of you would like the date and time information inserted automatically when adding text to an entity.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (47, 'LetUserEditOwnProfile', 'Yes', '2004-09-30 19:10:02', 'Set this option to ''Yes'' to enable user to change their passwords, edit their full name, and select wether or not they want to receive the daily entity overwiew email.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (48, 'EnableRepositorySwitcher', 'Yes', '2004-09-30 19:10:02', 'Set this option to ''Yes'' to enable a user to dynamically switch between repositories in which the same users exist with the same password. ''No'' disables this, ''Admin'' enables it only for admins.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (49, 'BlockAllCSVDownloads', 'No', '2004-09-30 19:10:02', 'Set this value to Yes if you want to block all CSV/Excel downloads for all users except for administrators.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (50, 'STANDARD_TEXT', '', '2004-09-30 19:10:02', 'A list of standard comments which users can automatically insert as a reply in entities. Leave empty for no standard comments.');
INSERT INTO [db_prefix]crmsettings (settingid, setting, value, datetime, discription) VALUES (51, 'CUSTOMER_LIST_TRESHOLD', '150', '2004-09-30 19:10:02', 'The number of customers listed on the main customers page. If this number of customers is exceeded, the list will not appear for bandwith reasons.');


DROP TABLE IF EXISTS [db_prefix]crmstatusvars;
CREATE TABLE [db_prefix]crmstatusvars (
  id int(11) NOT NULL auto_increment,
  varname varchar(50) NOT NULL default '',
  color varchar(7) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]crmstatusvars (id, varname, color) VALUES (1, 'Open', '#66CC66');
INSERT INTO [db_prefix]crmstatusvars (id, varname, color) VALUES (2, 'Closed', '#FF6633');
INSERT INTO [db_prefix]crmstatusvars (id, varname, color) VALUES (3, 'Awaiting closure', '#3399CC');


DROP TABLE IF EXISTS [db_prefix]crmuselog;
CREATE TABLE [db_prefix]crmuselog (
  id bigint(20) NOT NULL auto_increment,
  ip varchar(15) NOT NULL default '',
  url varchar(50) NOT NULL default '',
  useragent varchar(255) NOT NULL default '',
  tijd timestamp NOT NULL default '0000-00-00 00:00:00',
  qs varchar(255) NOT NULL default '',
  user varchar(50) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY tijd (tijd),
  KEY url (url),
  KEY tijd_2 (tijd),
  KEY ip (ip),
  KEY user (user)
);


DROP TABLE IF EXISTS [db_prefix]crmusers;
CREATE TABLE [db_prefix]crmusers (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  password varchar(50) NOT NULL default '',
  unused tinyint(4) NOT NULL default '0',
  email varchar(150) NOT NULL default '',
  brmember enum('n','y') NOT NULL default 'n',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY id_2 (id)
);


DROP TABLE IF EXISTS [db_prefix]crmwebdav_locks;
CREATE TABLE [db_prefix]crmwebdav_locks (
  token varchar(255) NOT NULL default '',
  path varchar(200) NOT NULL default '',
  expires int(11) NOT NULL default '0',
  owner varchar(200) default NULL,
  recursive int(11) default '0',
  writelock int(11) default '0',
  exclusivelock int(11) NOT NULL default '0',
  PRIMARY KEY  (token),
  UNIQUE KEY token (token),
  KEY path (path),
  KEY path_2 (path),
  KEY path_3 (path,token),
  KEY expires (expires)
);


DROP TABLE IF EXISTS [db_prefix]crmwebdav_properties;
CREATE TABLE [db_prefix]crmwebdav_properties (
  path varchar(255) NOT NULL default '',
  name varchar(120) NOT NULL default '',
  ns varchar(120) NOT NULL default 'DAV:',
  value text,
  PRIMARY KEY  (path,name,ns),
  KEY path (path)
);


DROP TABLE IF EXISTS [db_prefix]cust_comments;
CREATE TABLE [db_prefix]cust_comments (
  id int(11) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  text text NOT NULL,
  activ enum('0','1') NOT NULL default '0',
  date date NOT NULL default '0000-00-00',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]cust_comments (id, name, text, activ, date) VALUES (1, 'Westley K.', 'You wee really great! You congratulated me on my purchase and was a part of the whole positive buying experience.', '1', '2006-11-07');
INSERT INTO [db_prefix]cust_comments (id, name, text, activ, date) VALUES (2, 'Shirley Oxby', 'Their guys were very helpful and was very responsive to our needs. They explained things in ways that made us feel important.', '1', '2006-11-09');
INSERT INTO [db_prefix]cust_comments (id, name, text, activ, date) VALUES (3, 'Christina M.', 'I was very pleased with John. He was excellent and seemed truly interested in helping us. We are very pleased and thankful to John and their company.', '1', '2006-11-01');
INSERT INTO [db_prefix]cust_comments (id, name, text, activ, date) VALUES (4, 'Donny & Jolene', 'I just have to say that this was the easiest''s and most stress free way of getting a mortgage. My calls were handled promptly and the whole process was very smooth. Thanks.', '1', '2006-11-14');


DROP TABLE IF EXISTS [db_prefix]fapp_form;
CREATE TABLE [db_prefix]fapp_form (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  id_form int(11) NOT NULL default '0',
  user_name varchar(100) NOT NULL default '',
  type enum('pdf','online') NOT NULL default 'pdf',
  status enum('all','curr','start','closed','finish') NOT NULL default 'all',
  admstatus enum('new','review','closed','declined') NOT NULL default 'new',
  loan_amount varchar(20) NOT NULL default '',
  date_send datetime NOT NULL default '0000-00-00 00:00:00',
  date_closed datetime NOT NULL default '0000-00-00 00:00:00',
  form_name varchar(255) NOT NULL default '',
  country_type enum('usa','uk') NOT NULL default 'usa',
  form_type varchar(20) NOT NULL default '',
  id_loanofficer int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab1;
CREATE TABLE [db_prefix]fapp_tab1 (
  id int(10) unsigned NOT NULL auto_increment,
  agent_name varchar(40) default NULL,
  cb_income_used enum('chb_yes','chb_no') default NULL,
  cb_income_not_used enum('chb_yes','chb_no') default NULL,
  laf_va enum('chb_yes','chb_no') default NULL,
  laf_conv enum('chb_yes','chb_no') default NULL,
  laf_other enum('chb_yes','chb_no') default NULL,
  laf_fha enum('chb_yes','chb_no') default NULL,
  laf_fmha enum('chb_yes','chb_no') default NULL,
  laf_other_explain varchar(25) default NULL,
  loan_amount decimal(10,2) default NULL,
  interest_rate decimal(10,2) default NULL,
  number_of_months int(5) default NULL,
  yearly_taxes decimal(10,2) default NULL,
  yearly_insurance decimal(10,2) default NULL,
  fixed enum('chb_yes','chb_no') default NULL,
  amort_other enum('chb_yes','chb_no') default NULL,
  amort_explain varchar(40) default NULL,
  amort_gpm enum('chb_yes','chb_no') default NULL,
  amort_arm enum('chb_yes','chb_no') default NULL,
  arm_type varchar(40) default NULL,
  proposed_pi decimal(10,2) default NULL,
  proposed_re_taxes decimal(10,2) default NULL,
  proposed_hazard_insurance decimal(10,2) default NULL,
  proposed_total_expenses decimal(10,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab10;
CREATE TABLE [db_prefix]fapp_tab10 (
  id int(10) unsigned NOT NULL auto_increment,
  statement_completed_jointly enum('chb_yes','chb_no') default NULL,
  statement_completed_not_jointly enum('chb_yes','chb_no') default NULL,
  deposit_held_by varchar(45) default NULL,
  deposit_amount decimal(10,2) default NULL,
  bnk1_name varchar(55) default NULL,
  bank_account_number_one varchar(35) default NULL,
  bnk1_street varchar(45) default NULL,
  bank_amount_one decimal(10,2) default NULL,
  bnk1_city varchar(30) default NULL,
  bnk1_state varchar(30) default NULL,
  bnk1_zip varchar(15) default NULL,
  add_bank_record1 enum('chb_yes','chb_no') default NULL,
  add_bank_record1no enum('chb_yes','chb_no') default NULL,
  bnk2_name varchar(55) default NULL,
  bank_account_number_two varchar(35) default NULL,
  bnk2_street varchar(45) default NULL,
  bank_amount_two decimal(10,2) default NULL,
  bnk2_city varchar(30) default NULL,
  bnk2_state varchar(30) default NULL,
  bnk2_zip varchar(15) default NULL,
  add_bank_record2 enum('chb_yes','chb_no') default NULL,
  add_bank_record2no enum('chb_yes','chb_no') default NULL,
  bnk3_name varchar(55) default NULL,
  bank_account_number_three varchar(35) default NULL,
  bnk3_street varchar(45) default NULL,
  bank_amount_three decimal(10,2) default NULL,
  bnk3_city varchar(30) default NULL,
  bnk3_state varchar(30) default NULL,
  bnk3_zip varchar(15) default NULL,
  add_bank_record3 enum('chb_yes','chb_no') default NULL,
  add_bank_record3no enum('chb_yes','chb_no') default NULL,
  bnk4_name varchar(55) default NULL,
  bank_account_number_four varchar(35) default NULL,
  bnk4_street varchar(45) default NULL,
  bank_amount_four decimal(10,2) default NULL,
  bnk4_city varchar(30) default NULL,
  bnk4_state varchar(30) default NULL,
  bnk4_zip varchar(15) default NULL,
  stk1_name varchar(45) default NULL,
  stk1_num varchar(15) default NULL,
  stock_value_one decimal(10,2) default NULL,
  stk2_name varchar(45) default NULL,
  stk2_num varchar(15) default NULL,
  stock_value_two decimal(10,2) default NULL,
  life_ins_face_amount_one decimal(10,2) default NULL,
  life_ins_value_one decimal(10,2) default NULL,
  subtotal_liquid_assets decimal(20,2) default NULL,
  real_estate_owned_value decimal(20,2) default NULL,
  retirement_fund_value decimal(10,2) default NULL,
  business_owned_value decimal(10,2) default NULL,
  auto_one_year varchar(5) default NULL,
  auto_one_make varchar(15) default NULL,
  auto_one_model varchar(15) default NULL,
  auto_one_value decimal(10,2) default NULL,
  auto_two_year varchar(5) default NULL,
  auto_two_make varchar(15) default NULL,
  auto_two_model varchar(15) default NULL,
  auto_two_value decimal(10,2) default NULL,
  auto_three_year varchar(5) default NULL,
  auto_three_make varchar(15) default NULL,
  auto_three_model varchar(15) default NULL,
  auto_three_value decimal(10,2) default NULL,
  total_auto_value decimal(20,2) default NULL,
  other_assets_description_one varchar(45) default NULL,
  other_assets_value_one decimal(10,2) default NULL,
  other_assets_description_two varchar(45) default NULL,
  other_assets_value_two decimal(10,2) default NULL,
  other_assets_description_three varchar(45) default NULL,
  other_assets_value_three decimal(10,2) default NULL,
  total_other_assets decimal(20,2) default NULL,
  total_all_assets decimal(20,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab11;
CREATE TABLE [db_prefix]fapp_tab11 (
  id int(10) unsigned NOT NULL auto_increment,
  liab1_rental_prop enum('chb_yes','chb_no') default NULL,
  liab1_subj_prop enum('chb_yes','chb_no') default NULL,
  liab1_type varchar(20) default NULL,
  liab1_name varchar(55) default NULL,
  liab1_street varchar(30) default NULL,
  liab1_city varchar(30) default NULL,
  liab1_state varchar(30) default NULL,
  liab1_zip varchar(20) default NULL,
  monthly_pymt_one decimal(20,2) default NULL,
  unpaid_balance_one decimal(20,2) default NULL,
  liability_acct_number_one varchar(40) default NULL,
  months_left_to_pay_one varchar(6) default NULL,
  pay_off_one enum('chb_yes','chb_no') default NULL,
  add_liab_record1 enum('chb_yes','chb_no') default NULL,
  add_liab_record1no enum('chb_yes','chb_no') default NULL,
  liab2_rental_prop enum('chb_yes','chb_no') default NULL,
  liab2_subj_prop enum('chb_yes','chb_no') default NULL,
  liab2_type varchar(20) default NULL,
  liab2_name varchar(55) default NULL,
  liab2_street varchar(30) default NULL,
  liab2_city varchar(30) default NULL,
  liab2_state varchar(30) default NULL,
  liab2_zip varchar(20) default NULL,
  monthly_pymt_two decimal(20,2) default NULL,
  unpaid_balance_two decimal(20,2) default NULL,
  liability_acct_number_two varchar(40) default NULL,
  months_left_to_pay_two varchar(6) default NULL,
  pay_off_two enum('chb_yes','chb_no') default NULL,
  add_liab_record2 enum('chb_yes','chb_no') default NULL,
  add_liab_record2no enum('chb_yes','chb_no') default NULL,
  liab3_rental_prop enum('chb_yes','chb_no') default NULL,
  liab3_subj_prop enum('chb_yes','chb_no') default NULL,
  liab3_type varchar(20) default NULL,
  liab3_name varchar(55) default NULL,
  liab3_street varchar(30) default NULL,
  liab3_city varchar(30) default NULL,
  liab3_state varchar(30) default NULL,
  liab3_zip varchar(20) default NULL,
  monthly_pymt_three decimal(20,2) default NULL,
  unpaid_balance_three decimal(20,2) default NULL,
  liability_acct_number_three varchar(40) default NULL,
  months_left_to_pay_three varchar(6) default NULL,
  pay_off_three enum('chb_yes','chb_no') default NULL,
  add_liab_record3 enum('chb_yes','chb_no') default NULL,
  add_liab_record3no enum('chb_yes','chb_no') default NULL,
  liab4_rental_prop enum('chb_yes','chb_no') default NULL,
  liab4_subj_prop enum('chb_yes','chb_no') default NULL,
  liab4_type varchar(20) default NULL,
  liab4_name varchar(55) default NULL,
  liab4_street varchar(30) default NULL,
  liab4_city varchar(30) default NULL,
  liab4_state varchar(30) default NULL,
  liab4_zip varchar(20) default NULL,
  monthly_pymt_four decimal(20,2) default NULL,
  unpaid_balance_four decimal(20,2) default NULL,
  liability_acct_number_four varchar(40) default NULL,
  months_left_to_pay_four varchar(6) default NULL,
  pay_off_four enum('chb_yes','chb_no') default NULL,
  add_liab_record4 enum('chb_yes','chb_no') default NULL,
  add_liab_record4no enum('chb_yes','chb_no') default NULL,
  liab5_rental_prop enum('chb_yes','chb_no') default NULL,
  liab5_subj_prop enum('chb_yes','chb_no') default NULL,
  liab5_type varchar(20) default NULL,
  liab5_name varchar(55) default NULL,
  liab5_street varchar(30) default NULL,
  liab5_city varchar(30) default NULL,
  liab5_state varchar(30) default NULL,
  liab5_zip varchar(20) default NULL,
  monthly_pymt_five decimal(20,2) default NULL,
  unpaid_balance_five decimal(20,2) default NULL,
  liability_acct_number_five varchar(40) default NULL,
  months_left_to_pay_five varchar(6) default NULL,
  pay_off_five enum('chb_yes','chb_no') default NULL,
  add_liab_record5 enum('chb_yes','chb_no') default NULL,
  add_liab_record5no enum('chb_yes','chb_no') default NULL,
  liab6_rental_prop enum('chb_yes','chb_no') default NULL,
  liab6_subj_prop enum('chb_yes','chb_no') default NULL,
  liab6_type varchar(20) default NULL,
  liab6_name varchar(55) default NULL,
  liab6_street varchar(30) default NULL,
  liab6_city varchar(30) default NULL,
  liab6_state varchar(30) default NULL,
  liab6_zip varchar(20) default NULL,
  monthly_pymt_six decimal(20,2) default NULL,
  unpaid_balance_six decimal(20,2) default NULL,
  liability_acct_number_six varchar(40) default NULL,
  months_left_to_pay_six varchar(6) default NULL,
  pay_off_six enum('chb_yes','chb_no') default NULL,
  add_liab_record6 enum('chb_yes','chb_no') default NULL,
  add_liab_record6no enum('chb_yes','chb_no') default NULL,
  liab7_rental_prop enum('chb_yes','chb_no') default NULL,
  liab7_subj_prop enum('chb_yes','chb_no') default NULL,
  liab7_type varchar(20) default NULL,
  liab7_name varchar(55) default NULL,
  liab7_street varchar(30) default NULL,
  liab7_city varchar(30) default NULL,
  liab7_state varchar(30) default NULL,
  liab7_zip varchar(20) default NULL,
  monthly_pymt_seven decimal(20,2) default NULL,
  unpaid_balance_seven decimal(20,2) default NULL,
  liability_acct_number_seven varchar(40) default NULL,
  months_left_to_pay_seven varchar(6) default NULL,
  pay_off_seven enum('chb_yes','chb_no') default NULL,
  other_pymts_owed_to varchar(60) default NULL,
  other_monthly_pymt decimal(10,2) default NULL,
  job_related_expense varchar(60) default NULL,
  job_related_monthly_pymt decimal(10,2) default NULL,
  liabilities_total_monthly_pymts decimal(20,2) default NULL,
  total_liabilities decimal(20,2) default NULL,
  total_net_worth decimal(20,2) default NULL,
  alt_personal_name_one varchar(60) default NULL,
  alt_creditor_name_one varchar(60) default NULL,
  alt_acct_number_one varchar(40) default NULL,
  alt_personal_name_two varchar(60) default NULL,
  alt_creditor_name_two varchar(60) default NULL,
  alt_acct_number_two varchar(40) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab12;
CREATE TABLE [db_prefix]fapp_tab12 (
  id int(10) unsigned NOT NULL auto_increment,
  details_purchase_price decimal(10,2) default NULL,
  details_improvements_value decimal(10,2) default NULL,
  details_land_only_value decimal(10,2) default NULL,
  details_refinance_amount decimal(10,2) default NULL,
  details_estimated_prepaids decimal(10,2) default NULL,
  details_estimated_closing_costs decimal(10,2) default NULL,
  details_pmi_mip_funding_fee decimal(10,2) default NULL,
  details_discount_price decimal(10,2) default NULL,
  details_total_costs decimal(10,2) default NULL,
  details_subordinate_financing_amount decimal(10,2) default NULL,
  details_seller_paid_closing_costs decimal(10,2) default NULL,
  details_explain_other_costs varchar(100) default NULL,
  details_other_costs decimal(10,2) default NULL,
  details_loan_amount_no_mi decimal(10,2) default NULL,
  details_pmi_mip_funding_fee_financed decimal(10,2) default NULL,
  details_loan_amount_m_plus_n decimal(10,2) default NULL,
  details_cash_from_to_borrower decimal(10,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab13;
CREATE TABLE [db_prefix]fapp_tab13 (
  id int(10) unsigned NOT NULL auto_increment,
  ba_yes enum('chb_yes','chb_no') default NULL,
  ba_no enum('chb_yes','chb_no') default NULL,
  cba_yes enum('chb_yes','chb_no') default NULL,
  cba_no enum('chb_yes','chb_no') default NULL,
  bb_yes enum('chb_yes','chb_no') default NULL,
  bb_no enum('chb_yes','chb_no') default NULL,
  cbb_yes enum('chb_yes','chb_no') default NULL,
  cbb_no enum('chb_yes','chb_no') default NULL,
  bc_yes enum('chb_yes','chb_no') default NULL,
  bc_no enum('chb_yes','chb_no') default NULL,
  cbc_yes enum('chb_yes','chb_no') default NULL,
  cbc_no enum('chb_yes','chb_no') default NULL,
  bd_yes enum('chb_yes','chb_no') default NULL,
  bd_no enum('chb_yes','chb_no') default NULL,
  cbd_yes enum('chb_yes','chb_no') default NULL,
  cbd_no enum('chb_yes','chb_no') default NULL,
  be_yes enum('chb_yes','chb_no') default NULL,
  be_no enum('chb_yes','chb_no') default NULL,
  cbe_yes enum('chb_yes','chb_no') default NULL,
  cbe_no enum('chb_yes','chb_no') default NULL,
  bf_yes enum('chb_yes','chb_no') default NULL,
  bf_no enum('chb_yes','chb_no') default NULL,
  cbf_yes enum('chb_yes','chb_no') default NULL,
  cbf_no enum('chb_yes','chb_no') default NULL,
  bg_yes enum('chb_yes','chb_no') default NULL,
  bg_no enum('chb_yes','chb_no') default NULL,
  cbg_yes enum('chb_yes','chb_no') default NULL,
  cbg_no enum('chb_yes','chb_no') default NULL,
  bh_yes enum('chb_yes','chb_no') default NULL,
  bh_no enum('chb_yes','chb_no') default NULL,
  cbh_yes enum('chb_yes','chb_no') default NULL,
  cbh_no enum('chb_yes','chb_no') default NULL,
  bi_yes enum('chb_yes','chb_no') default NULL,
  bi_no enum('chb_yes','chb_no') default NULL,
  cbi_yes enum('chb_yes','chb_no') default NULL,
  cbi_no enum('chb_yes','chb_no') default NULL,
  bj_yes enum('chb_yes','chb_no') default NULL,
  bj_no enum('chb_yes','chb_no') default NULL,
  cbj_yes enum('chb_yes','chb_no') default NULL,
  cbj_no enum('chb_yes','chb_no') default NULL,
  bk_yes enum('chb_yes','chb_no') default NULL,
  bk_no enum('chb_yes','chb_no') default NULL,
  cbk_yes enum('chb_yes','chb_no') default NULL,
  cbk_no enum('chb_yes','chb_no') default NULL,
  bl_yes enum('chb_yes','chb_no') default NULL,
  bl_no enum('chb_yes','chb_no') default NULL,
  cbl_yes enum('chb_yes','chb_no') default NULL,
  cbl_no enum('chb_yes','chb_no') default NULL,
  bm_yes enum('chb_yes','chb_no') default NULL,
  bm_no enum('chb_yes','chb_no') default NULL,
  cbm_yes enum('chb_yes','chb_no') default NULL,
  cbm_no enum('chb_yes','chb_no') default NULL,
  b_ownership_property_type char(2) default NULL,
  cb_ownership_property_type char(2) default NULL,
  b_ownership_title_held char(2) default NULL,
  cb_ownership_title_held char(2) default NULL,
  declarations_explanation text,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab14;
CREATE TABLE [db_prefix]fapp_tab14 (
  id int(10) unsigned NOT NULL auto_increment,
  b_private enum('chb_yes','chb_no') default NULL,
  cb_private enum('chb_yes','chb_no') default NULL,
  b_hisp enum('chb_yes','chb_no') default NULL,
  b_not_hisp enum('chb_yes','chb_no') default NULL,
  cb_hisp enum('chb_yes','chb_no') default NULL,
  cb_not_hisp enum('chb_yes','chb_no') default NULL,
  b_amer_indian enum('chb_yes','chb_no') default NULL,
  cb_amer_indian enum('chb_yes','chb_no') default NULL,
  b_api enum('chb_yes','chb_no') default NULL,
  cb_api enum('chb_yes','chb_no') default NULL,
  b_aa enum('chb_yes','chb_no') default NULL,
  cb_aa enum('chb_yes','chb_no') default NULL,
  b_hawaiian enum('chb_yes','chb_no') default NULL,
  cb_hawaiian enum('chb_yes','chb_no') default NULL,
  b_white enum('chb_yes','chb_no') default NULL,
  cb_white enum('chb_yes','chb_no') default NULL,
  b_male enum('chb_yes','chb_no') default NULL,
  b_female enum('chb_yes','chb_no') default NULL,
  cb_male enum('chb_yes','chb_no') default NULL,
  cb_female enum('chb_yes','chb_no') default NULL,
  ff_interview enum('chb_yes','chb_no') default NULL,
  mail_interview enum('chb_yes','chb_no') default NULL,
  phone_interview enum('chb_yes','chb_no') default NULL,
  internet_interview enum('chb_yes','chb_no') default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab2;
CREATE TABLE [db_prefix]fapp_tab2 (
  id int(10) unsigned NOT NULL auto_increment,
  subj_prop_street varchar(70) default NULL,
  subj_prop_city varchar(35) default NULL,
  subj_prop_state varchar(30) default NULL,
  subj_prop_zip varchar(15) default NULL,
  subj_prop_apn varchar(90) default NULL,
  num_units varchar(8) default NULL,
  year_built varchar(8) default NULL,
  purch enum('chb_yes','chb_no') default NULL,
  constr enum('chb_yes','chb_no') default NULL,
  purp_other enum('chb_yes','chb_no') default NULL,
  purp_refi enum('chb_yes','chb_no') default NULL,
  const_perm enum('chb_yes','chb_no') default NULL,
  purp_explain varchar(40) default NULL,
  prime_res enum('chb_yes','chb_no') default NULL,
  second_res enum('chb_yes','chb_no') default NULL,
  invest enum('chb_yes','chb_no') default NULL,
  const_yr varchar(8) default NULL,
  const_cost decimal(10,2) default NULL,
  const_liens decimal(10,2) default NULL,
  const_value_lot decimal(10,2) default NULL,
  const_cost_improve decimal(10,2) default NULL,
  const_total_value decimal(10,2) default NULL,
  refi_yr varchar(8) default NULL,
  refi_cost decimal(10,2) default NULL,
  refi_exist_liens decimal(10,2) default NULL,
  purpose_of_refi varchar(30) default NULL,
  improve_made enum('chb_yes','chb_no') default NULL,
  improve_to_be_made enum('chb_yes','chb_no') default NULL,
  improve_cost decimal(10,2) default NULL,
  improvements_description varchar(45) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab3;
CREATE TABLE [db_prefix]fapp_tab3 (
  id int(10) unsigned NOT NULL auto_increment,
  title_held_in varchar(70) default NULL,
  title_held_manner varchar(70) default NULL,
  source_down_pymt varchar(50) default NULL,
  fee_simple enum('chb_yes','chb_no') default NULL,
  leasehold enum('chb_yes','chb_no') default NULL,
  dpyes enum('chb_yes','chb_no') default NULL,
  dpno enum('chb_yes','chb_no') default NULL,
  leasehold_date varchar(50) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab4;
CREATE TABLE [db_prefix]fapp_tab4 (
  id int(10) unsigned NOT NULL auto_increment,
  b_first_name varchar(30) default NULL,
  b_mi_name varchar(8) default NULL,
  b_last_name varchar(35) default NULL,
  b_soc_sec varchar(25) default NULL,
  b_phone varchar(30) default NULL,
  b_age varchar(20) default NULL,
  b_school varchar(4) default NULL,
  b_married enum('chb_yes','chb_no') default NULL,
  b_separated enum('chb_yes','chb_no') default NULL,
  b_unmarried enum('chb_yes','chb_no') default NULL,
  b_depend int(4) default NULL,
  b_dep_ages varchar(25) default NULL,
  copy enum('chb_yes','chb_no') default NULL,
  b_res_street varchar(40) default NULL,
  b_own_home enum('chb_yes','chb_no') default NULL,
  b_rent_home enum('chb_yes','chb_no') default NULL,
  b_res_city varchar(30) default NULL,
  b_res_state varchar(30) default NULL,
  b_res_zip varchar(20) default NULL,
  b_yrs_at_res varchar(8) default NULL,
  add_res_record1 enum('chb_yes','chb_no') default NULL,
  add_res_record1no enum('chb_yes','chb_no') default NULL,
  b_former_street varchar(40) default NULL,
  b_former_city varchar(30) default NULL,
  b_former_state varchar(30) default NULL,
  b_former_zip varchar(20) default NULL,
  add_res_record2 enum('chb_yes','chb_no') default NULL,
  add_res_record2no enum('chb_yes','chb_no') default NULL,
  b_2former_street varchar(40) default NULL,
  b_2former_own enum('chb_yes','chb_no') default NULL,
  b_2former_rent enum('chb_yes','chb_no') default NULL,
  b_2former_city varchar(30) default NULL,
  b_2former_state varchar(30) default NULL,
  b_2former_zip varchar(20) default NULL,
  b_2former_yrs varchar(8) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab5;
CREATE TABLE [db_prefix]fapp_tab5 (
  id int(10) unsigned NOT NULL auto_increment,
  copy2 enum('chb_yes','chb_no') default NULL,
  cb_first_name varchar(30) default NULL,
  cb_mi_name varchar(8) default NULL,
  cb_last_name varchar(35) default NULL,
  cb_soc_sec varchar(30) default NULL,
  cb_phone varchar(30) default NULL,
  cb_age varchar(20) default NULL,
  cb_school varchar(4) default NULL,
  cb_married enum('chb_yes','chb_no') default NULL,
  cb_separated enum('chb_yes','chb_no') default NULL,
  cb_unmarried enum('chb_yes','chb_no') default NULL,
  cb_depend int(4) default NULL,
  cb_dep_ages varchar(25) default NULL,
  cb_res_street varchar(40) default NULL,
  cb_own_home enum('chb_yes','chb_no') default NULL,
  cb_rent_home enum('chb_yes','chb_no') default NULL,
  cb_res_city varchar(30) default NULL,
  cb_res_state varchar(30) default NULL,
  cb_res_zip varchar(15) default NULL,
  cb_yrs_at_res varchar(8) default NULL,
  add_cbres_record1 enum('chb_yes','chb_no') default NULL,
  add_cbres_record1no enum('chb_yes','chb_no') default NULL,
  cb_former_street varchar(40) default NULL,
  cb_former_city varchar(30) default NULL,
  cb_former_state varchar(30) default NULL,
  cb_former_zip varchar(15) default NULL,
  add_cbres_record2 enum('chb_yes','chb_no') default NULL,
  add_cbres_record2no enum('chb_yes','chb_no') default NULL,
  cb_2former_street varchar(40) default NULL,
  cb_2former_own enum('chb_yes','chb_no') default NULL,
  cb_2former_rent enum('chb_yes','chb_no') default NULL,
  cb_2former_city varchar(30) default NULL,
  cb_2former_state varchar(30) default NULL,
  cb_2former_zip varchar(15) default NULL,
  cb_2former_yrs varchar(8) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab6;
CREATE TABLE [db_prefix]fapp_tab6 (
  id int(10) unsigned NOT NULL auto_increment,
  b_employer_name varchar(60) default NULL,
  cb_employer_name varchar(60) default NULL,
  b_employer_street varchar(60) default NULL,
  cb_employer_street varchar(60) default NULL,
  b_employer_city varchar(30) default NULL,
  b_employer_state varchar(30) default NULL,
  b_employer_zip varchar(15) default NULL,
  cb_employer_city varchar(30) default NULL,
  cb_employer_state varchar(30) default NULL,
  cb_employer_zip varchar(15) default NULL,
  b_employer_phone varchar(30) default NULL,
  cb_employer_phone varchar(30) default NULL,
  b_employer_position varchar(30) default NULL,
  cb_employer_position varchar(30) default NULL,
  b_employer_bus_type varchar(30) default NULL,
  cb_employer_bus_type varchar(30) default NULL,
  b_self_employed enum('chb_yes','chb_no') default NULL,
  b_not_self_employed enum('chb_yes','chb_no') default NULL,
  cb_self_employed enum('chb_yes','chb_no') default NULL,
  cb_not_self_employed enum('chb_yes','chb_no') default NULL,
  b_yrs_on_job varchar(8) default NULL,
  cb_yrs_on_job varchar(8) default NULL,
  b_yrs_in_prof varchar(8) default NULL,
  cb_yrs_in_prof varchar(8) default NULL,
  add_employed_record1 enum('chb_yes','chb_no') default NULL,
  add_employed_record1no enum('chb_yes','chb_no') default NULL,
  b_employer2_name varchar(60) default NULL,
  cb_employer2_name varchar(60) default NULL,
  b_employer2_street varchar(60) default NULL,
  cb_employer2_street varchar(60) default NULL,
  b_employer2_city varchar(30) default NULL,
  b_employer2_state varchar(30) default NULL,
  b_employer2_zip varchar(15) default NULL,
  cb_employer2_city varchar(30) default NULL,
  cb_employer2_state varchar(30) default NULL,
  cb_employer2_zip varchar(15) default NULL,
  b_employer2_phone varchar(30) default NULL,
  cb_employer2_phone varchar(30) default NULL,
  b_employer2_position varchar(30) default NULL,
  cb_employer2_position varchar(30) default NULL,
  b_employer2_bus_type varchar(30) default NULL,
  cb_employer2_bus_type varchar(30) default NULL,
  b_self_employer2 enum('chb_yes','chb_no') default NULL,
  b_other_not_self_employed enum('chb_yes','chb_no') default NULL,
  cb_self_employer2 enum('chb_yes','chb_no') default NULL,
  cb_other_not_self_employed enum('chb_yes','chb_no') default NULL,
  b_dates_from varchar(50) default NULL,
  b_dates_to varchar(15) default NULL,
  cb_dates_from varchar(15) default NULL,
  cb_dates_to varchar(15) default NULL,
  b_employer2_income varchar(15) default NULL,
  cb_employer2_income varchar(15) default NULL,
  add_employed_record2 enum('chb_yes','chb_no') default NULL,
  add_employed_record2no enum('chb_yes','chb_no') default NULL,
  b_employer3_name varchar(55) default NULL,
  cb_employer3_name varchar(55) default NULL,
  b_employer3_street varchar(55) default NULL,
  cb_employer3_street varchar(55) default NULL,
  b_employer3_city varchar(30) default NULL,
  b_employer3_state varchar(30) default NULL,
  b_employer3_zip varchar(15) default NULL,
  cb_employer3_city varchar(30) default NULL,
  cb_employer3_state varchar(30) default NULL,
  cb_employer3_zip varchar(15) default NULL,
  b_employer3_phone varchar(30) default NULL,
  cb_employer3_phone varchar(30) default NULL,
  b_employer3_position varchar(30) default NULL,
  cb_employer3_position varchar(30) default NULL,
  b_employer3_bus_type varchar(30) default NULL,
  cb_employer3_bus_type varchar(30) default NULL,
  b_self_employer3 enum('chb_yes','chb_no') default NULL,
  b_other_not_self_employed3 enum('chb_yes','chb_no') default NULL,
  cb_self_employer3 enum('chb_yes','chb_no') default NULL,
  cb_other_not_self_employed3 enum('chb_yes','chb_no') default NULL,
  b_dates3_from varchar(15) default NULL,
  b_dates3_to varchar(15) default NULL,
  cb_dates3_from varchar(15) default NULL,
  cb_dates3_to varchar(15) default NULL,
  b_employer3_income varchar(15) default NULL,
  cb_employer3_income varchar(15) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab7;
CREATE TABLE [db_prefix]fapp_tab7 (
  id int(10) unsigned NOT NULL auto_increment,
  b_base_income decimal(10,2) default NULL,
  cb_base_income decimal(10,2) default NULL,
  b_overtime_income decimal(10,2) default NULL,
  cb_overtime_income decimal(10,2) default NULL,
  b_bonus_income decimal(10,2) default NULL,
  cb_bonus_income decimal(10,2) default NULL,
  b_commission_income decimal(10,2) default NULL,
  cb_commission_income decimal(10,2) default NULL,
  b_dividend_income decimal(10,2) default NULL,
  cb_dividend_income decimal(10,2) default NULL,
  b_rental_income decimal(10,2) default NULL,
  cb_rental_income decimal(10,2) default NULL,
  b_other_income decimal(10,2) default NULL,
  cb_other_income decimal(10,2) default NULL,
  b_total_income decimal(10,2) default NULL,
  cb_total_income decimal(10,2) default NULL,
  total_household_income decimal(10,2) default NULL,
  total_base_income decimal(10,2) default NULL,
  total_overtime_income decimal(10,2) default NULL,
  total_bonus_income decimal(10,2) default NULL,
  total_commission_income decimal(10,2) default NULL,
  total_dividend_income decimal(10,2) default NULL,
  total_rental_income decimal(10,2) default NULL,
  total_other_income decimal(10,2) default NULL,
  b_explain_one enum('chb_yes','chb_no') default NULL,
  cb_explain_one enum('chb_yes','chb_no') default NULL,
  explanation_one varchar(55) default NULL,
  explanation_one_income decimal(10,2) default NULL,
  b_explain_two enum('chb_yes','chb_no') default NULL,
  cb_explain_two enum('chb_yes','chb_no') default NULL,
  explanation_two varchar(55) default NULL,
  explanation_two_income decimal(10,2) default NULL,
  b_explain_three enum('chb_yes','chb_no') default NULL,
  cb_explain_three enum('chb_yes','chb_no') default NULL,
  explanation_three varchar(55) default NULL,
  explanation_three_income decimal(10,2) default NULL,
  b_explain_four enum('chb_yes','chb_no') default NULL,
  cb_explain_four enum('chb_yes','chb_no') default NULL,
  explanation_four varchar(55) default NULL,
  explanation_four_income decimal(10,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab8;
CREATE TABLE [db_prefix]fapp_tab8 (
  id int(10) unsigned NOT NULL auto_increment,
  housing_expense_rent decimal(10,2) default NULL,
  current_pi decimal(10,2) default NULL,
  proposed_pi decimal(10,2) default NULL,
  current_other_financing decimal(10,2) default NULL,
  proposed_other_financing decimal(10,2) default NULL,
  current_hazard_insurance decimal(10,2) default NULL,
  proposed_hazard_insurance decimal(10,2) default NULL,
  current_re_taxes decimal(10,2) default NULL,
  proposed_re_taxes decimal(10,2) default NULL,
  current_mi decimal(10,2) default NULL,
  proposed_mi decimal(10,2) default NULL,
  current_hoa_dues decimal(10,2) default NULL,
  proposed_hoa_dues decimal(10,2) default NULL,
  current_other_expenses decimal(10,2) default NULL,
  proposed_other_expenses decimal(10,2) default NULL,
  current_total_expenses decimal(10,2) default NULL,
  proposed_total_expenses decimal(10,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]fapp_tab9;
CREATE TABLE [db_prefix]fapp_tab9 (
  id int(10) unsigned NOT NULL auto_increment,
  reo1_present_res enum('chb_yes','chb_no') default NULL,
  reo1_subj_prop enum('chb_yes','chb_no') default NULL,
  reo1_street varchar(55) default NULL,
  reo1_city varchar(55) default NULL,
  reo1_status char(2) default NULL,
  reo1_type varchar(4) default NULL,
  prop_one_market_value decimal(10,2) default NULL,
  prop_one_mort_lien_value decimal(10,2) default NULL,
  prop_one_mort_pymt decimal(10,2) default NULL,
  prop_one_other_expense decimal(10,2) default NULL,
  prop_one_gross_rental_income decimal(10,2) default NULL,
  prop_one_net_rental_income decimal(10,2) default NULL,
  add_prop_record1 enum('chb_yes','chb_no') default NULL,
  add_prop_record1no enum('chb_yes','chb_no') default NULL,
  reo2_present_res enum('chb_yes','chb_no') default NULL,
  reo2_subj_prop enum('chb_yes','chb_no') default NULL,
  reo2_street varchar(55) default NULL,
  reo2_city varchar(55) default NULL,
  reo2_status char(2) default NULL,
  reo2_type varchar(4) default NULL,
  prop_two_market_value decimal(10,2) default NULL,
  prop_two_mort_lien_value decimal(10,2) default NULL,
  prop_two_mort_pymt decimal(10,2) default NULL,
  prop_two_other_expense decimal(10,2) default NULL,
  prop_two_gross_rental_income decimal(10,2) default NULL,
  prop_two_net_rental_income decimal(10,2) default NULL,
  add_prop_record2 enum('chb_yes','chb_no') default NULL,
  add_prop_record2no enum('chb_yes','chb_no') default NULL,
  reo3_present_res enum('chb_yes','chb_no') default NULL,
  reo3_subj_prop enum('chb_yes','chb_no') default NULL,
  reo3_street varchar(55) default NULL,
  reo3_city varchar(55) default NULL,
  reo3_status char(2) default NULL,
  reo3_type varchar(4) default NULL,
  prop_three_market_value decimal(10,2) default NULL,
  prop_three_mort_lien_value decimal(10,2) default NULL,
  prop_three_mort_pymt decimal(10,2) default NULL,
  prop_three_other_expense decimal(10,2) default NULL,
  prop_three_gross_rental_income decimal(10,2) default NULL,
  prop_three_net_rental_income decimal(10,2) default NULL,
  total_prop_market_value decimal(20,2) default NULL,
  total_prop_mort_lien_value decimal(20,2) default NULL,
  total_prop_gross_rental_income decimal(20,2) default NULL,
  effective_gross_rent_vacancy_factor decimal(20,2) default NULL,
  total_prop_mort_pymts decimal(20,2) default NULL,
  total_prop_other_expense decimal(20,2) default NULL,
  total_prop_net_rental_income decimal(20,2) default NULL,
  effective_net_rental_income decimal(20,2) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]feedbacks;
CREATE TABLE [db_prefix]feedbacks (
  id int(11) unsigned NOT NULL auto_increment,
  text text,
  date datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_buy_to_let1;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_buy_to_let1 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  relatedperson enum('yes','no') NOT NULL default 'yes',
  propertyuse enum('yes','no') NOT NULL default 'yes',
  propertyvalue int(11) NOT NULL default '0',
  loanamount int(11) NOT NULL default '0',
  duration smallint(3) NOT NULL default '0',
  applicants_type enum('1','2') NOT NULL default '1',
  repaymenttype varchar(50) NOT NULL default '',
  pioamount int(11) NOT NULL default '0',
  pramount int(11) NOT NULL default '0',
  region int(11) NOT NULL default '0',
  housetype varchar(50) NOT NULL default '',
  tenure varchar(50) NOT NULL default '',
  unexlease smallint(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_buy_to_let2;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_buy_to_let2 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  sex1 enum('male','female') NOT NULL default 'male',
  sex2 enum('male','female') NOT NULL default 'male',
  bithday1 date NOT NULL default '0000-00-00',
  bithday2 date NOT NULL default '0000-00-00',
  ukperm1 enum('yes','no') NOT NULL default 'yes',
  ukperm2 enum('yes','no') NOT NULL default 'yes',
  smok1 enum('yes','no') NOT NULL default 'yes',
  smok2 enum('yes','no') NOT NULL default 'yes',
  employment1 varchar(20) NOT NULL default '',
  employment2 varchar(20) NOT NULL default '',
  income_entry1 int(11) NOT NULL default '0',
  income_entry2 int(11) NOT NULL default '0',
  bonus_entry1 int(11) NOT NULL default '0',
  bonus_entry2 int(11) NOT NULL default '0',
  yearsselfemployed1 int(3) NOT NULL default '0',
  yearsselfemployed2 int(3) NOT NULL default '0',
  seeyear1_1 int(11) NOT NULL default '0',
  seeyear1_2 int(11) NOT NULL default '0',
  seeyear1_3 int(11) NOT NULL default '0',
  seeyear2_1 int(11) NOT NULL default '0',
  seeyear2_2 int(11) NOT NULL default '0',
  seeyear2_3 int(11) NOT NULL default '0',
  accounts1 enum('yes','no') NOT NULL default 'yes',
  accounts2 enum('yes','no') NOT NULL default 'yes',
  hourlyrate1 int(11) NOT NULL default '0',
  hourlyrate2 int(11) NOT NULL default '0',
  contractmonths1 int(11) NOT NULL default '0',
  contractmonths2 int(11) NOT NULL default '0',
  contractfinish1 int(11) NOT NULL default '0',
  contractfinish2 int(11) NOT NULL default '0',
  creditcardrepayments1 int(11) NOT NULL default '0',
  creditcardrepayments2 int(11) NOT NULL default '0',
  loanrepayments1 int(11) NOT NULL default '0',
  loanrepayments2 int(11) NOT NULL default '0',
  childrepayments1 int(11) NOT NULL default '0',
  childrepayments2 int(11) NOT NULL default '0',
  selfcertification1 enum('yes','no') NOT NULL default 'yes',
  selfcertification2 enum('yes','no') NOT NULL default 'yes',
  creditproblems1 enum('yes','no') NOT NULL default 'yes',
  creditproblems2 enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_buy_to_let3;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_buy_to_let3 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  id_rate varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_buy_to_let4;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_buy_to_let4 (
  id int(10)  NOT NULL auto_increment,
  id_user int(10) NOT NULL default '0',
  btlowner varchar(50) NOT NULL default '',
  btlloancover enum('yes','no') NOT NULL default 'yes',
  btltenancy varchar(50) NOT NULL default '',
  rentalincome int(10) NOT NULL default '0',
  existingmortgage enum('NotApp','yes','no') NOT NULL default 'NotApp',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_first1;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_first1 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  propertyvalue int(11) NOT NULL default '0',
  loanamount int(11) NOT NULL default '0',
  duration smallint(3) NOT NULL default '0',
  applicants_type enum('1','2') NOT NULL default '1',
  repaymenttype varchar(50) NOT NULL default '',
  pioamount int(11) NOT NULL default '0',
  pramount int(11) NOT NULL default '0',
  region int(11) NOT NULL default '0',
  housetype varchar(50) NOT NULL default '',
  tenure varchar(50) NOT NULL default '',
  unexlease smallint(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_first2;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_first2 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  sex1 enum('male','female') NOT NULL default 'male',
  sex2 enum('male','female') NOT NULL default 'male',
  bithday1 date NOT NULL default '0000-00-00',
  bithday2 date NOT NULL default '0000-00-00',
  ukperm1 enum('yes','no') NOT NULL default 'yes',
  ukperm2 enum('yes','no') NOT NULL default 'yes',
  smok1 enum('yes','no') NOT NULL default 'yes',
  smok2 enum('yes','no') NOT NULL default 'yes',
  employment1 varchar(20) NOT NULL default '',
  employment2 varchar(20) NOT NULL default '',
  income_entry1 int(11) NOT NULL default '0',
  income_entry2 int(11) NOT NULL default '0',
  bonus_entry1 int(11) NOT NULL default '0',
  bonus_entry2 int(11) NOT NULL default '0',
  yearsselfemployed1 int(3) NOT NULL default '0',
  yearsselfemployed2 int(3) NOT NULL default '0',
  seeyear1_1 int(11) NOT NULL default '0',
  seeyear1_2 int(11) NOT NULL default '0',
  seeyear1_3 int(11) NOT NULL default '0',
  seeyear2_1 int(11) NOT NULL default '0',
  seeyear2_2 int(11) NOT NULL default '0',
  seeyear2_3 int(11) NOT NULL default '0',
  accounts1 enum('yes','no') NOT NULL default 'yes',
  accounts2 enum('yes','no') NOT NULL default 'yes',
  hourlyrate1 int(11) NOT NULL default '0',
  hourlyrate2 int(11) NOT NULL default '0',
  contractmonths1 int(11) NOT NULL default '0',
  contractmonths2 int(11) NOT NULL default '0',
  contractfinish1 int(11) NOT NULL default '0',
  contractfinish2 int(11) NOT NULL default '0',
  creditcardrepayments1 int(11) NOT NULL default '0',
  creditcardrepayments2 int(11) NOT NULL default '0',
  loanrepayments1 int(11) NOT NULL default '0',
  loanrepayments2 int(11) NOT NULL default '0',
  childrepayments1 int(11) NOT NULL default '0',
  childrepayments2 int(11) NOT NULL default '0',
  selfcertification1 enum('yes','no') NOT NULL default 'yes',
  selfcertification2 enum('yes','no') NOT NULL default 'yes',
  creditproblems1 enum('yes','no') NOT NULL default 'yes',
  creditproblems2 enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_first3;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_first3 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  id_rate varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_mhome1;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_mhome1 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  propertyvalue int(11) NOT NULL default '0',
  loanamount int(11) NOT NULL default '0',
  duration smallint(3) NOT NULL default '0',
  applicants_type enum('1','2') NOT NULL default '1',
  repaymenttype varchar(50) NOT NULL default '',
  pioamount int(11) NOT NULL default '0',
  pramount int(11) NOT NULL default '0',
  region int(11) NOT NULL default '0',
  housetype varchar(50) NOT NULL default '',
  tenure varchar(50) NOT NULL default '',
  unexlease smallint(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_mhome2;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_mhome2 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  sex1 enum('male','female') NOT NULL default 'male',
  sex2 enum('male','female') NOT NULL default 'male',
  bithday1 date NOT NULL default '0000-00-00',
  bithday2 date NOT NULL default '0000-00-00',
  ukperm1 enum('yes','no') NOT NULL default 'yes',
  ukperm2 enum('yes','no') NOT NULL default 'yes',
  smok1 enum('yes','no') NOT NULL default 'yes',
  smok2 enum('yes','no') NOT NULL default 'yes',
  employment1 varchar(20) NOT NULL default '',
  employment2 varchar(20) NOT NULL default '',
  income_entry1 int(11) NOT NULL default '0',
  income_entry2 int(11) NOT NULL default '0',
  bonus_entry1 int(11) NOT NULL default '0',
  bonus_entry2 int(11) NOT NULL default '0',
  yearsselfemployed1 int(3) NOT NULL default '0',
  yearsselfemployed2 int(3) NOT NULL default '0',
  seeyear1_1 int(11) NOT NULL default '0',
  seeyear1_2 int(11) NOT NULL default '0',
  seeyear1_3 int(11) NOT NULL default '0',
  seeyear2_1 int(11) NOT NULL default '0',
  seeyear2_2 int(11) NOT NULL default '0',
  seeyear2_3 int(11) NOT NULL default '0',
  accounts1 enum('yes','no') NOT NULL default 'yes',
  accounts2 enum('yes','no') NOT NULL default 'yes',
  hourlyrate1 int(11) NOT NULL default '0',
  hourlyrate2 int(11) NOT NULL default '0',
  contractmonths1 int(11) NOT NULL default '0',
  contractmonths2 int(11) NOT NULL default '0',
  contractfinish1 int(11) NOT NULL default '0',
  contractfinish2 int(11) NOT NULL default '0',
  creditcardrepayments1 int(11) NOT NULL default '0',
  creditcardrepayments2 int(11) NOT NULL default '0',
  loanrepayments1 int(11) NOT NULL default '0',
  loanrepayments2 int(11) NOT NULL default '0',
  childrepayments1 int(11) NOT NULL default '0',
  childrepayments2 int(11) NOT NULL default '0',
  selfcertification1 enum('yes','no') NOT NULL default 'yes',
  selfcertification2 enum('yes','no') NOT NULL default 'yes',
  creditproblems1 enum('yes','no') NOT NULL default 'yes',
  creditproblems2 enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_mhome3;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_mhome3 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  id_rate varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_remortgage1;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_remortgage1 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  reasonremortgage varchar(50) NOT NULL default '',
  propertyvalue int(11) NOT NULL default '0',
  loanamount int(11) NOT NULL default '0',
  duration smallint(3) NOT NULL default '0',
  applicants_type enum('1','2') NOT NULL default '1',
  repaymenttype varchar(50) NOT NULL default '',
  pioamount int(11) NOT NULL default '0',
  pramount int(11) NOT NULL default '0',
  region int(11) NOT NULL default '0',
  housetype varchar(50) NOT NULL default '',
  tenure varchar(50) NOT NULL default '',
  unexlease smallint(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_remortgage2;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_remortgage2 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  sex1 enum('male','female') NOT NULL default 'male',
  sex2 enum('male','female') NOT NULL default 'male',
  bithday1 date NOT NULL default '0000-00-00',
  bithday2 date NOT NULL default '0000-00-00',
  ukperm1 enum('yes','no') NOT NULL default 'yes',
  ukperm2 enum('yes','no') NOT NULL default 'yes',
  smok1 enum('yes','no') NOT NULL default 'yes',
  smok2 enum('yes','no') NOT NULL default 'yes',
  employment1 varchar(20) NOT NULL default '',
  employment2 varchar(20) NOT NULL default '',
  income_entry1 int(11) NOT NULL default '0',
  income_entry2 int(11) NOT NULL default '0',
  bonus_entry1 int(11) NOT NULL default '0',
  bonus_entry2 int(11) NOT NULL default '0',
  yearsselfemployed1 int(3) NOT NULL default '0',
  yearsselfemployed2 int(3) NOT NULL default '0',
  seeyear1_1 int(11) NOT NULL default '0',
  seeyear1_2 int(11) NOT NULL default '0',
  seeyear1_3 int(11) NOT NULL default '0',
  seeyear2_1 int(11) NOT NULL default '0',
  seeyear2_2 int(11) NOT NULL default '0',
  seeyear2_3 int(11) NOT NULL default '0',
  accounts1 enum('yes','no') NOT NULL default 'yes',
  accounts2 enum('yes','no') NOT NULL default 'yes',
  hourlyrate1 int(11) NOT NULL default '0',
  hourlyrate2 int(11) NOT NULL default '0',
  contractmonths1 int(11) NOT NULL default '0',
  contractmonths2 int(11) NOT NULL default '0',
  contractfinish1 int(11) NOT NULL default '0',
  contractfinish2 int(11) NOT NULL default '0',
  creditcardrepayments1 int(11) NOT NULL default '0',
  creditcardrepayments2 int(11) NOT NULL default '0',
  loanrepayments1 int(11) NOT NULL default '0',
  loanrepayments2 int(11) NOT NULL default '0',
  childrepayments1 int(11) NOT NULL default '0',
  childrepayments2 int(11) NOT NULL default '0',
  selfcertification1 enum('yes','no') NOT NULL default 'yes',
  selfcertification2 enum('yes','no') NOT NULL default 'yes',
  creditproblems1 enum('yes','no') NOT NULL default 'yes',
  creditproblems2 enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]form_uk_remortgage3;
CREATE TABLE IF NOT EXISTS [db_prefix]form_uk_remortgage3 (
  id int(11) NOT NULL auto_increment,
  id_user int(11) NOT NULL default '0',
  id_rate varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]forms;
CREATE TABLE IF NOT EXISTS [db_prefix]forms (
  id int(11) NOT NULL auto_increment,
  id_location int(11) NOT NULL default '0',
  name blob NOT NULL,
  alias varchar(255) NOT NULL default '',
  path varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (1, 1, 'Full Application Form', 'full', 'fapp_form.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (2, 1, 'Refinance Form', 'refinance', 'short_form.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (3, 1, 'Prequalify Form', 'prequalify', 'prequalify.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (4, 2, 'First time buyer', 'FIRST', 'firsttimebuyer_fapp_uk.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (5, 2, 'Move mortgage home quote', 'MHOME', 'move_home_fapp_uk.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (6, 2, 'Remortgage quote', 'REMORTGAGE', 'remortgage_fapp_uk.php');
INSERT INTO [db_prefix]forms (id, id_location, name, alias, path) VALUES (7, 2, 'Buy to let mortgage quote', 'BUY_TO_LET', 'buy_to_let_mortgage_fapp_uk.php');


DROP TABLE IF EXISTS [db_prefix]language;
CREATE TABLE [db_prefix]language (
  id int(3) NOT NULL auto_increment,
  code varchar(10) default NULL,
  name varchar(25) default NULL,
  id_location int(11) NOT NULL default '1',
  visible enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]language (id, code, name, id_location, visible) VALUES (1, 'EN', 'english', 1, '1');
INSERT INTO [db_prefix]language (id, code, name, id_location, visible) VALUES (2, 'UK', 'english_uk', 2, '1');

DROP TABLE IF EXISTS [db_prefix]leftmenu_table;
CREATE TABLE [db_prefix]leftmenu_table (
  id int(11) NOT NULL auto_increment,
  page_id varchar(50) NOT NULL default '',
  menu int(2) NOT NULL default '0',
  `order` int(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (1, 3, 1, 1);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (2, 42, 1, 2);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (3, 85, 1, 3);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (4, 41, 1, 4);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (5, 41, 2, 1);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (6, 42, 2, 2);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (7, 31, 2, 3);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (8, 85, 2, 4);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (9, 86, 2, 5);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (10, 87, 2, 6);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (11, 6, 2, 7);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (12, 1, 2, 8);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (13, 3, 2, 9);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (14, 41, 3, 1);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (15, 42, 3, 2);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (16, 86, 3, 3);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (17, 31, 3, 5);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (18, 85, 3, 6);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (19, 1, 3, 7);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (20, 3, 3, 8);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (21, 88, 3, 9);
INSERT INTO [db_prefix]leftmenu_table (id, page_id, menu, `order`) VALUES (22, 90, 1, 5);


DROP TABLE IF EXISTS [db_prefix]loan_officer;
CREATE TABLE [db_prefix]loan_officer (
  id int(11) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  email varchar(255) default NULL,
  login varchar(255) default NULL,
  pass varchar(255) default NULL,
  status enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]location;
CREATE TABLE IF NOT EXISTS [db_prefix]location (
  id int(11) NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  visible enum('0','1') NOT NULL default '0',
  alias varchar(20) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]location (id, name, visible, alias) VALUES (1, 'USA', '0', 'usa');
INSERT INTO [db_prefix]location (id, name, visible, alias) VALUES (2, 'UK', '1', 'uk');


DROP TABLE IF EXISTS [db_prefix]mortgage_rate_feed;
CREATE TABLE [db_prefix]mortgage_rate_feed (
  id int(4) NOT NULL auto_increment,
  link text,
  max_news tinyint(3) NOT NULL default '5',
  status enum('0','1') NOT NULL default '1',
  date_update datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id),
  KEY id (id)
);

INSERT INTO [db_prefix]mortgage_rate_feed (id, link, max_news, status, date_update) VALUES (1, 'http://rss.news.yahoo.com/rss/world', 0, '1', '2005-12-19 09:29:37');


DROP TABLE IF EXISTS [db_prefix]mortgage_rates;
CREATE TABLE [db_prefix]mortgage_rates (
  id int(11) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  priority int(11) unsigned default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]mortgage_rates (id, name, priority) VALUES (1, '30 Year Fixed to $333,700', 1);
INSERT INTO [db_prefix]mortgage_rates (id, name, priority) VALUES (2, '30 Year Fixed over $333,700', 2);
INSERT INTO [db_prefix]mortgage_rates (id, name, priority) VALUES (3, ' 3/1 ARM', 3);
INSERT INTO [db_prefix]mortgage_rates (id, name, priority) VALUES (4, '5/1 ARM', 4);
INSERT INTO [db_prefix]mortgage_rates (id, name, priority) VALUES (5, 'FlexPay ARM', 5);


DROP TABLE IF EXISTS [db_prefix]mortgage_rates_changed;
CREATE TABLE [db_prefix]mortgage_rates_changed (
  time date default NULL
);

INSERT INTO [db_prefix]mortgage_rates_changed (time) VALUES ('2008-02-12');


DROP TABLE IF EXISTS [db_prefix]mortgage_subrates;
CREATE TABLE [db_prefix]mortgage_subrates (
  id int(11) unsigned NOT NULL auto_increment,
  rate decimal(10,3) default NULL,
  points decimal(10,3) default NULL,
  apr decimal(10,3) default NULL,
  rid int(11) unsigned default NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]mortgage_subrates (id, rate, points, apr, rid) VALUES (1, 5.375, 1.250, 5.611, 1);
INSERT INTO [db_prefix]mortgage_subrates (id, rate, points, apr, rid) VALUES (2, 5.625, 1.000, 5.815, 2);
INSERT INTO [db_prefix]mortgage_subrates (id, rate, points, apr, rid) VALUES (3, 4.375, 0.250, 4.213, 3);
INSERT INTO [db_prefix]mortgage_subrates (id, rate, points, apr, rid) VALUES (4, 4.625, 0.250, 4.357, 4);
INSERT INTO [db_prefix]mortgage_subrates (id, rate, points, apr, rid) VALUES (5, 1.250, 3.125, 3.671, 5);



DROP TABLE IF EXISTS [db_prefix]news;
CREATE TABLE [db_prefix]news (
  id int(11) unsigned NOT NULL auto_increment,
  date datetime NOT NULL default '0000-00-00 00:00:00',
  body text,
  status enum('0','1') NOT NULL default '0',
  image_path varchar(255) default NULL,
  subject varchar(255) NOT NULL default '',
  date_ts varchar(255) default NULL,
  channel_name varchar(255) NOT NULL default '',
  channel_link varchar(255) NOT NULL default '',
  news_link varchar(255) NOT NULL default '',
  id_channel int(3) NOT NULL default '0',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]news (id, date, body, status, image_path, subject, date_ts, channel_name, channel_link, news_link, id_channel) VALUES (18, '2006-12-28 12:00:00', 'A lawsuit has been filed by Netbank Inc. against the former head of sales at Meritage Mortgage Corp. The Meritage unit was shut down in November. Netbank wants the executive to repay his 2006 salary and bonuses.', '1', '', 'Netbank Sues former Executive', '1167253200', 'MortgageDaily.com - Mortgage News Headlines', 'http://www.mortgagedaily.com?spcode=rss', 'http://www.mortgagedaily.com/LawsuitNetbank122706.asp?spcode=rss', 3);
INSERT INTO [db_prefix]news (id, date, body, status, image_path, subject, date_ts, channel_name, channel_link, news_link, id_channel) VALUES (19, '2006-12-28 12:00:00', 'The annual number of home equity lines of credit closed decreased, according to a study from the Consumer Bankers Association. The study was reportedly based on the responses of 46 lenders. Bookings for new home equity accounts decreased nearly 5 percent for the year ending June 30, 2006, the report said.', '1', '', 'Heloc Production Drops', '1167253200', 'MortgageDaily.com - Mortgage News Headlines', 'http://www.mortgagedaily.com?spcode=rss', 'http://www.mortgagedaily.com/homeequitystudy122706.asp?spcode=rss', 3);
INSERT INTO [db_prefix]news (id, date, body, status, image_path, subject, date_ts, channel_name, channel_link, news_link, id_channel) VALUES (20, '2006-12-28 12:00:00', 'The Department of Housing and Urban Development released its Tier Ranking Scores of Tier One lender servicers for the fiscal year ending Sept. 30, 2006. The scores are reportedly used to determine which servicers are best utilizing Hud''s loss mitigation tools. Of the four lenders with volume of 100,000 loans that ranked Tier One, Chase Home Finance Llc had the highest workout ratio.', '1', '', 'Best Hud Mitigators', '1167253200', 'MortgageDaily.com - Mortgage News Headlines', 'http://www.mortgagedaily.com?spcode=rss', 'http://www.mortgagedaily.com/BestHudServicers122706.asp?spcode=rss', 3);


DROP TABLE IF EXISTS [db_prefix]news_feeds;
CREATE TABLE [db_prefix]news_feeds (
  id int(4) NOT NULL auto_increment,
  link text,
  max_news tinyint(3) NOT NULL default '5',
  status enum('0','1') NOT NULL default '1',
  date_update datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id),
  KEY id (id)
);

INSERT INTO [db_prefix]news_feeds (id, link, max_news, status, date_update) VALUES (3, 'http://MortgageDaily.com/rss.xml', 3, '1', '2006-12-28 11:45:41');


DROP TABLE IF EXISTS [db_prefix]page_content;
CREATE TABLE [db_prefix]page_content (
  id int(11) NOT NULL auto_increment,
  id_page int(11) NOT NULL default '0',
  id_lang int(11) NOT NULL default '0',
  page_name varchar(255) NOT NULL default '',
  content text NOT NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (1, 3, 1, 'About Us', '<font class="maintext">We has built a strong reputation as an outstanding mortgage brokerage firm serving the lending needs of real estate professionals, builders and individual homebuyers throughout New Jersey and Maine.<br />\r\n<br />\r\nAnd, now it&quot;s our pleasure to offer all of our exceptional mortgage services online. Through our company you not only have access to the best loans available in the marketplace, but you can review loan alternatives, and even apply for your loan, at your convenience, online - 24 hours a day.<br />\r\n<br />\r\nOur company goal is to search the mortgage market to find you the most competitive deal, one that matches your needs and circumstances. You can<br />\r\n<br />\r\nThank you for visiting our web site. We look forward to putting our mortgage service to work for you! </font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (2, 4, 1, 'In the press', '<TABLE border=0>\r\n<TR class=maintext vAlign=top>\r\n<TD><B>\r\n<H2 class="caption2">Budget 2006 winners and losers</H2></B>How is your pocket affected?<BR><BR>In the table below we have attempted to breakdown the impact of Budget 2006 on typical families and income groups - although it cannot measure the effect of "sin taxes" on cigarettes and beer, and the green taxes on heavily polluting vehicles.<BR><BR>The tax calculations have been provided by KPMG LLP (UK). They summarise the Budget 2006 proposals and other tax changes, which may be amended significantly before enactment. The table is intended to provide a general guide to the subject matter and should not be regarded as a basis for ascertaining liability to tax or determining investment strategy in specific circumstances.<BR><BR>Although endeavours have been made to provide accurate and timely information, there can be no guarantee that such information is accurate as of the date it is received or that it will continue to be accurate in the future. No one should act upon such information without appropriate independent professional advice after a thorough examination of the particular situation.<BR><BR>\r\n<H4>Levels and bases of, and reliefs from, taxation are subject to change.</H4>\r\n<DIV align=right>www.seemoney.co.uk</DIV></TD></TR>\r\n<TR>\r\n<TD>\r\n<HR class="dot_line">\r\n</TD></TR>\r\n<TR class=maintext vAlign=top>\r\n<TD><B>ING sells Deutsche Hypothekenbank</B><BR><BR><I>The Netherlands / Germany - Aug 2006</I><BR><BR>The Dutch bancassurance group ING announced on 10 August 2006 that it had sold its 83.7% stake in the German mortgage lender Deutsche Hypothekenbank.</TD></TR>\r\n</TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (3, 6, 1, 'FAQ', '<TABLE width=555 border=0>\r\n              <TBODY>\r\n              <TR class=maintext  valign="top">\r\n                <TD><FONT class="menui_header"><B>What is a \r\n                  mortgage?</B></FONT><BR><BR>A mortgage is a loan taken out \r\n                  from a mortgage lender to pay for a property. The loan is \r\n                  divided into capital, i.e. the amount of money you borrow to \r\n                  purchase the property, and a mortgage interest rate, i.e. the \r\n                  amount the lender charges for lending you the money.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Who is a \r\n                  mortgage broker?</B></FONT><BR><BR>That is a mortgage broker \r\n                  qualified to give you advice on buying a mortgage. Many \r\n                  operate as part of a one or two man band operation, or are \r\n                  tied to estate agent. Some mortgage brokers work from home and \r\n                  rely on referrals from intermediaries such as accountants and \r\n                  solicitors for business, while others work online, using the \r\n                  Internet to generate business.<BR><BR>There are around 10,000 \r\n                  mortgage products on the market, so it'' a very good idea to \r\n                  consult a mortgage broker for help in finding the right \r\n                  product. They will be able to tell you about the best deals \r\n                  currently available, including some that are exclusive to \r\n                  advisers. They will also be able to offer advice about how to \r\n                  repay your mortgage, home insurance and other financial \r\n                  matters.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>How much \r\n                  mortgage can I get</B></FONT><BR><BR>The amount of money \r\n                  depends on the amount you can comfortably afford to repay each \r\n                  month. It will also depend on the mortgage lender you choose \r\n                  as each has its own guidelines. Some mortgage lenders may only \r\n                  lend you a multiple of three times your income while others \r\n                  may stretch to four, five or even six times.<BR><BR>If you are \r\n                  buying as a couple the mortgage calculation multiples will be \r\n                  different. Some mortgage lenders will lend you two and a half \r\n                  times both annual incomes while others will offer three to \r\n                  three and a half times the greater income plus one times the \r\n                  second income.<BR><BR>Somehow the major factor getting your \r\n                  mortgage is determined by the amount you earn. Lenders \r\n                  generally apply multiples to your income to calculate your \r\n                  maximum loan. Lenders may be prepared to offer high mortgage \r\n                  multiples if you are putting down a large deposit: because you \r\n                  are committing more of your money to the property it \r\n                  represents stronger security, and they may therefore be \r\n                  prepared to lend you more.<BR><BR>Your credit history is also \r\n                  important in determining which lenders will be prepared to \r\n                  lend to you, or whether they will offer you their most \r\n                  favorable rates. If you have consistently met your payments \r\n                  under current and previous credit agreements you will be \r\n                  entitled to the more competitive mortgages on the market. If, \r\n                  however, you have failed to keep up your payments, the \r\n                  mortgage rates available are likely to reflect \r\n                  this.<BR><BR>Finally, the third important factor in \r\n                  determining a lender''s decision is the property itself; the \r\n                  value and general condition of the property will always need \r\n                  to be assessed to ensure that it represents adequate security. \r\n                  Also some lenders have criteria which may rule out certain \r\n                  property types.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>How do I prove \r\n                  my income?</B></FONT><BR><BR>If you are employed, the mortgage \r\n                  lender will request written evidence from your employer such \r\n                  as pay slips or other documents proving that you are working \r\n                  and get the salary.<BR><BR>If you are self-employed you may \r\n                  need to show a mortgage company three years'' audited accounts \r\n                  or a letter of confirmation from an accountant if you have not \r\n                  been in business long enough to prove that you can afford the \r\n                  mortgage repayments.<BR><BR>Many mortgage companies have a \r\n                  variety of criteria, some willing to be more flexible than \r\n                  others. It is a good idea to speak to an independent mortgage \r\n                  broker for getting an impartial advice.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Mortgage \r\n                  repayment options…</B></FONT><BR><BR>There are three types of \r\n                  mortgage repayment options to consider when you are choosing \r\n                  your mortgage:<BR><BR>Capital repayment mortgages allow you to \r\n                  repay the loan throughout the term. Your monthly payment is \r\n                  made up of both interest and capital repayment so that at the \r\n                  end of the term the whole mortgage is repaid. The advantage of \r\n                  this repayment method is that, as long as you make all your \r\n                  payments, the mortgage is guaranteed to be repaid by the end \r\n                  of the term.<BR><BR>If, on the other hand, you opt for \r\n                  interest only mortgage payment, your monthly payment will be \r\n                  made up solely of interest, so that your borrowing will remain \r\n                  the same throughout the term. At the end of the mortgage term, \r\n                  assuming you have not made any lump sum repayments, you will \r\n                  still owe the same amount that you borrowed in the first \r\n                  place. In this scenario it is your responsibility to ensure \r\n                  that either a suitable repayment vehicle (such as an endowment \r\n                  or pension plan) is in place, or that the loan is repaid by \r\n                  means of lump sum repayments or sale of the property. So, \r\n                  while this option does mean lower monthly payments, it also \r\n                  places added responsibility on you, and potentially greater \r\n                  risk.<BR><BR>The final option, so-called �?part and part’, is \r\n                  to combine the two methods so that you pay interest only on \r\n                  part of the loan and capital repayment on the rest. This might \r\n                  be suitable if you have, for example, an endowment that is not \r\n                  likely to cover the whole of your debt at the end of the term, \r\n                  or where you have increased your borrowing and want the \r\n                  certainty that the additional borrowing will be repaid by the \r\n                  end of the mortgage term.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Advantages and \r\n                  disadvantages of different mortgage \r\n                  products…</B></FONT><BR><BR>Different mortgage products have \r\n                  specific advantages and disadvantages; your choice of mortgage \r\n                  will depend on your specific situation and your attitude to \r\n                  both risk and cost.<BR><BR>If your priority is security then \r\n                  the logical decision may be to fix your mortgage rate, so that \r\n                  your payments will stay the same for an initial period, so \r\n                  that during the initial period your payments can drop but not \r\n                  increase. The main disadvantage of most fixed and capped rates \r\n                  is that if you choose to switch to another mortgage lender, \r\n                  and often if you choose to pay your mortgage off early, you \r\n                  may have to pay large early repayment charge; if you wish to \r\n                  keep your options open, and safeguard future flexibility, this \r\n                  can be a major factor in deciding not to choose fixed or \r\n                  capped mortgage payment.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Early repayment \r\n                  charges...</B></FONT><BR><BR>In many cases lenders will \r\n                  protect their interests by attaching early repayment charges \r\n                  to the initial period of a mortgage, either in line with an \r\n                  initial fixed or discounted rate, for example, or beyond the \r\n                  initial rate (known as overhang): these may be charged in a \r\n                  number of different situations. The lender would almost always \r\n                  set an early repayment charge if you change to a different \r\n                  lender within the early repayment period set within the \r\n                  mortgage offer. They might also charge you if you move house \r\n                  or pay the mortgage off in full.<BR><BR>It is of the greatest \r\n                  importance to consider what the early repayment charges may be \r\n                  when deciding which mortgage product suits your situation: if \r\n                  you need to keep your options open with regard to moving \r\n                  house, or shopping around for better deals, then a product \r\n                  with no early repayment charges would be advantageous. On the \r\n                  other hand, if you have no plans to change lender in the \r\n                  immediate future, and wish, for example, to fix your monthly \r\n                  payment, then an early repayment charge may not matter to you \r\n                  at all.<BR><BR>Early repayment charges are generally worked \r\n                  out as a percentage of the outstanding balance, and will vary \r\n                  widely from lender to lender. One of our responsibilities is \r\n                  to ensure that you are fully aware of all penalties that you \r\n                  may be charged before you make any final decision as to what \r\n                  product best suits your needs.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Do I need a \r\n                  deposit for a mortgage?</B></FONT><BR><BR>Not necessarily, as \r\n                  some mortgage companies try to be as helpful as they can \r\n                  particularly to first time buyers. Generally speaking however, \r\n                  it does make life easier if you can find a deposit and the \r\n                  more you can put down the better, as you will be able to enjoy \r\n                  a cheaper and better interest rate.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>To whom will \r\n                  most lenders give mortgages?</B></FONT><BR><BR>You must be \r\n                  over 18 to have a mortgage and most lenders generally \r\n                  recommend the mortgage term does not extend beyond your \r\n                  retirement age. You will not be discriminated against because \r\n                  of your colour, race, ethnic or national origin, your sex or \r\n                  if you are disabled. However, you will need to have the right \r\n                  to reside and work in the UK for at least the duration of the \r\n                  mortgage.<BR><BR>Up to four people can be joined in an \r\n                  application. At least one applicant is required to have an \r\n                  acceptable form of income and all should have a good credit \r\n                  history. Your application will be subject to a credit check \r\n                  and you will need to prove your income.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>How long can \r\n                  the term of the mortgage be?</B></FONT><BR><BR>The usual term \r\n                  is 25 years but your loan can be for any term from five to 30 \r\n                  years. It should ideally end on or before your normal \r\n                  retirement age.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Higher Lending \r\n                  Charges...</B></FONT><BR><BR>Some lenders charge a one off \r\n                  insurance premium, known as the higher lending charge, to \r\n                  cover themselves in any case of high risk lending, which is \r\n                  generally (but not always) defined as lending above 90% of the \r\n                  property value. This insurance does not benefit the borrower \r\n                  in any way, but covers the lender if, in the event of \r\n                  repossession, there is a shortfall in repayment of the \r\n                  outstanding debt. Were this situation to arise, the insurance \r\n                  company that provided the policy will often pursue the \r\n                  borrower for the equivalent of the money claimed by the \r\n                  lender.<BR><BR>The one off premium is usually added to the \r\n                  loan, rather than being paid upfront at the outset, and the \r\n                  borrower will therefore also be paying interest on this \r\n                  additional borrowing for the life of the mortgage, unless it \r\n                  is paid off with a lump sum or regular \r\n                  overpayments.<BR><BR>More and more deals are now being offered \r\n                  without an early repayment charge; in our experience many \r\n                  people (particularly first time buyers) are needlessly paying \r\n                  it. Occasionally, however, a situation could arise where the \r\n                  advantages of a particular deal outweigh the disadvantage of \r\n                  having to pay the premium. In this case we would clearly \r\n                  include the fee, along with all other fees, in our \r\n                  illustrations, and its significance would be explained to you \r\n                  in full at the outset.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>What is the \r\n                  valuation?</B></FONT><BR><BR>The mortgage valuation is solely \r\n                  for the purposes of a mortgage lender to satisfy itself \r\n                  property provides sufficient security for company to lend on \r\n                  it. The mortgage valuation does not give any indication \r\n                  whether the property is worth what you are paying, nor does it \r\n                  provide a comprehensive list of any repairs \r\nrequired.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>What is a \r\n                  valuation fee?</B></FONT><BR><BR>Lenders need expert guidance \r\n                  on what the property in question is worth as security for them \r\n                  to lend on it. They instruct a value to assess the property \r\n                  for this purpose.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Portable \r\n                  mortgages...</B></FONT><BR><BR>If you decide to move home it \r\n                  is important to know from the outset whether you have early \r\n                  repayment charges as lenders will only charge penalties if you \r\n                  change lender, or reduce the loan size, and not (with portable \r\n                  mortgages) if you are actually moving to a new home. This can \r\n                  be an important factor to take into consideration if, for \r\n                  example, you are considering whether or not to go for a long \r\n                  term fixed rate: you may not be sure whether you wish to move \r\n                  or not during the initial fixed period, but as long as you \r\n                  have a portable mortgage you will be keeping this option \r\n                  open.<BR><BR>Portability can still be an advantage even when \r\n                  your mortgage product has no redemption penalties at all. For \r\n                  example, you could have secured a particularly favorable deal \r\n                  originally and the market could subsequently have changed, \r\n                  leaving no comparable deals: it would obviously make sense in \r\n                  this situation to keep the product that you have, rather than \r\n                  switching when you move house.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>What happens if \r\n                  I can''t afford to make my monthly mortgage \r\n                  payments?</B></FONT><BR><BR>Always call your lender straight \r\n                  away. They will do all they can to help you overcome your \r\n                  difficulties and work with you to find a solution. With your \r\n                  co-operation they can develop a plan for dealing with your \r\n                  financial difficulties and clearing any arrears.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Must I clear my \r\n                  mortgage by a certain age?</B></FONT><BR><BR>Mortgages are \r\n                  usually designed to be repaid no later than the borrower''s \r\n                  normal retirement age, usually 65 for employed people (male \r\n                  and female) and 70 for self-employed. Most mortgage companies \r\n                  will consider a longer term providing the borrower has enough \r\n                  income after retirement.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>What happens if \r\n                  I lose my job?</B></FONT><BR><BR>If you lose your job and \r\n                  cannot make your mortgage payments your house could be at \r\n                  risk. It is strongly recommended you take out a mortgage \r\n                  accident sickness and redundancy policy in connection with \r\n                  your mortgage, which will pay your loan repayments for up 12 \r\n                  months, while you get back on your feet.<BR></TD></TR>\r\n              <TR class=maintext vAlign=top>\r\n                <TD><BR><FONT class="menui_header"><B>Is it safe to \r\n                  transmit my mortgage application over the \r\n                  Internet?</B></FONT><BR><BR>Security of your personal \r\n                  information is a prime concern to all mortgage lenders and \r\n                  intermediaries. Online mortgage application forms enable you \r\n                  to enter your application details and transmit them \r\n                  electronically to the lenders in a secure environment. Lenders \r\n                  use the most up-to-date security techniques to ensure the \r\n                  details of your online mortgage application are received \r\n                  securely.<BR></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (4, 7, 1, 'Useful links', '<table border="0" width="555px">\r\n<tr class="maintext" valign="top">\r\n      <td><a  class="mainlink" href="http://www.cml.org.uk/cml/home">Council of Mortgage Lenders</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">The Council of Mortgage Lenders is the trade association for the mortgage lending industry, and our members account for around 98% of UK residential mortgage lending.</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.mfgonline.co.uk/">Mortgage Finance Gazette</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">One of the most popular UK online magazines for brokers and lenders</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.ft.com/home/europe">Financial times</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Financial news for UK and Asia</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.uknetguide.co.uk/Finance/Mortgages/">UkNetGuide</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Unlike Search engines Uk Net Guide is complied by human begins. They bring together all resources you need to find what youРІР‚в„ўre looking for</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.hud.gov/buying/">Homes and Communities</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Useful tips and articles on homebuying, owing and selling</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n</table>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (5, 8, 1, 'Buying home tips', '<TABLE width=555 border=0>\r\n<TBODY>\r\n<TR class=maintext vAlign=top>\r\n<TD>Buying a home is one of the most important things most important thing most people will ever make. For sure, homeownership has great benefits. But it also comes with certain responsibilities.<BR><BR>Be confident, if you are ready for homeownership. Take a look at your current situation and determine if: \r\n<ul class=new>\r\n<li class=new>you have a suitable credit history that shows you are ready for homeownership \r\n<li class=new>you have continuing and reliable source of income prior to applying for the loan \r\n<li class=new>you have money for down payment and closing costs </LI></UL><BR>Once you''ve narrowed down the area where you''d like to live, spend as much time as you can driving around the neighborhoods looking for homes for sale. You''ll not only see what''s being offered, you''ll get to know the neighborhood even better.<BR><BR>Moving home can be quite stressful. There are a number of things to think about when moving and it can often be a lot of hard work. Planning is essential and it is recommended that you start your preparation eight weeks in advance. Use the following checklist to help you keep track of your move:<BR><BR>Eight weeks \r\n<ul class=new>\r\n<li class=new>Start a file for records or receipts that may be needed later for your taxes. \r\n<li class=new>Get estimates for moving companies and/or truck rental. Check for availability and ask about insurance. Don''t forget your car if it requires shipment. \r\n<li class=new>Obtain a reference from your current landlord. \r\n<li class=new>Investigate schools and childcare facilities of your new locality. </LI></UL>Seven weeks \r\n<ul class=new>\r\n<li class=new>Give your new address to your health professionals. Get relevant referrals. \r\n<li class=new>Investigate moving needs for any pets and arrange a check-up for them. </LI></UL>Six weeks \r\n<ul class=new>\r\n<li class=new>Decide what to take, what to store and what to give to charity. \r\n<li class=new>Cancel, transfer, or sell club memberships. \r\n<li class=new>Investigate car insurance premiums for your new area. \r\n<li class=new>Investigate storage options if required, and collect boxes for packing. </LI></UL>Five weeks \r\n<ul class=new>\r\n<li class=new>Give notice to your current landlord or agent. \r\n<li class=new>Organise a garage sale. Place your ad in The Age or The Sydney Morning Herald. Or sell your items at www.ebay.com.au. Contact charities for pick-up of donated items. </LI></UL>Four weeks \r\n<ul class=new>\r\n<li class=new>Party time! Organise a BBQ to use up perishables. \r\n<li class=new>Arrange transfer of school records. \r\n<li class=new>Decide how pets will be moved. \r\n<li class=new>Notify businesses, clubs, organisations and friends. Remember e-mail contacts. \r\n<li class=new>Start packing! Label boxes every box. Plan to carry irreplaceable items. </LI></UL>Three weeks \r\n<ul class=new>\r\n<li class=new>Organise new homes for your plants if need be. \r\n<li class=new>Pre-book utility connections if required. \r\n<li class=new>Give a forwarding address to old employer, lawyer, accountant, etc. \r\n<li class=new>Service your car, especially if you are driving to your new home. \r\n<li class=new>Get hotel reservations if travelling a long way or if your new home is not ready. </LI></UL>Two weeks \r\n<ul class=new>\r\n<li class=new>If you''re moving into or out of a high rise, reserve an elevator with the body corporate. \r\n<li class=new>Get a babysitter for young children on moving day so you can focus on the move. \r\n<li class=new>Close or transfer bank accounts, and get travellers cheques if needed. Empty any safety deposit boxes. Ensure you have cash for the moving day. \r\n<li class=new>Arrange to forward your mail to your new address. Cancel Post Office Box accounts. \r\n<li class=new>Notify insurance and credit card companies of your move. </LI></UL>One week \r\n<ul class=new>\r\n<li class=new>Arrange for house cleaning after you move. \r\n<li class=new>Make charity donations as planned previously. \r\n<li class=new>Back up computer files before dissembling and packing your system. \r\n<li class=new>Contact utilities to cancel or transfer accounts after your moving date, and confirm utilities will be on at your new place before you arrive. \r\n<li class=new>De-frost &amp; clean your refrigerator and freezer; clean your stove. \r\n<li class=new>Confirm your travel plans (flights, hotels, rental cars, etc). Arrange rental truck if needed. </LI></UL>Moving day \r\n<ul class=new>\r\n<li class=new>If moving yourself, pick up rental truck. Load heavy items first \r\n<li class=new>If employing removalist, confirm your new address with the moving company. \r\n<li class=new>Do a final check of cupboards, drawers, etc. \r\n<li class=new>Turn off lights, appliances and hot water system. Lock doors and windows. Leave keys with your old landlord if applicable. </LI></UL>ASAP \r\n<ul class=new>\r\n<li class=new>Update car rego and driver''s licence. </LI></UL></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (6, 9, 1, 'How to get a better Mortgage', '<table>\r\n      <tr class="maintext" valign="top">\r\n      <td>You are  looking for a better mortgage? Why not talk to our company? Our team of independent mortgage advisors are on hand to give friendly and clear advice on all the different types of mortgages available.<br><br>\r\n      Choosing the mortgage that is best suited to your special needs has never been more difficult. Banks, Trust and Insurance companies are continually inventing new mortgage products to capture your attention, and hopefully your business. In addition, ensuring that you get the best possible rate and product depends on aggressively shopping the mortgage marketplace. As an recognized mortgage professional company, we I will also look at the rest of your debt obligations and determine if they can be restuctured to lower your interest costs.<br><br>\r\n      Our representatives will be able to tell you everything you need to know about the best Europe mortgages at the moment and give you advice about how to repay your mortgage, any insurance you might need as a homeowner and other financial matters. Once they have given you an idea of the amount you can borrow you can start looking for a property.\r\n      </td>\r\n      </tr>\r\n</table>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (7, 10, 1, 'Switching lenders', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>If your are unhappy with your current \r\n                  lender and think you are paying too much, why not to contact \r\n                  out team?We are always on hand to give friendly and clear \r\n                  advice when you need it.<BR>Are you thinking about \r\n                  remortgaging? Just call us at<BR>0000000000000 \r\n            </TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (8, 11, 1, 'The procedure', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>To \r\n                  help you understand the mortgage procedure we have collected \r\n                  all our experience and published it here.<BR>Please read this \r\n                  carefully and contact us with any questions.<BR><BR><B>Step \r\n                  One: Initial Contact</B><BR><BR>Initial contact is first and \r\n                  very important step. On this meeting our representatives will \r\n                  take a few basic details from you and allocate a dedicated \r\n                  mortgage adviser to you. You''ll get all important data on \r\n                  mortgage, we''ll view your current situation and will be able \r\n                  to give you professional advice. Here, on this meeting, you''ll \r\n                  be advised a personal consultant, who''ll be responsible for \r\n                  your mortgage and who''ll be able to answer all your questions \r\n                  and assist you there.<BR>Be sure that you''ll leave your first \r\n                  meeting feeling more informed regarding the choices available \r\n                  to you.<BR><BR><B>Step Two: After the meeting</B><BR><BR>Your \r\n                  broker will research the entire mortgage market (over 18,000 \r\n                  products) for you and using the information from the initial \r\n                  meeting will recommend a handful of products (usually two to \r\n                  five) that are most suitable for your individual \r\n                  circumstances. We''ll then arrange a mortgage agreement in \r\n                  principle (AIP).<BR><BR>We''ll continue to research the market \r\n                  and keep you updated on a weekly basis with any changes and \r\n                  information on lenders and interest rates. A case manager will \r\n                  oversee all the paperwork and will act as source of contact, \r\n                  should your adviser be unavailable, answering any questions \r\n                  that you may have and assisting your adviser in obtaining your \r\n                  mortgage offer in the shortest time possible.<BR><BR><B>Step \r\n                  Three: Mortgage decision</B><BR><BR>Once you have decided on a \r\n                  mortgage we will process your application, advise you if any \r\n                  additional information is required and then check the formal \r\n                  offer once it is returned from the lender.<BR><BR>Now you''ll \r\n                  be ready for mortgage and you''ll have all important \r\n                  information about \r\n        lending.<BR><BR></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (9, 12, 1, 'Loans for non-residents', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>Our services are available for \r\n                  both European and non-European customers.<BR><BR>Mortgage \r\n                  Company can help non-resident investors to enjoy the \r\n                  advantages of owning European residential property through our \r\n                  finance arrangements with highly respected lenders. The home \r\n                  loans for non-residents program is only available for purchase \r\n                  of residential property by borrowers who do not ordinarily \r\n                  reside or pay taxes in Europe i.e non-European residents \r\n                  earning their income overseas.<BR>You, as an applicant must \r\n                  have permanent full time employment and good credit \r\n                  history.<BR>Just make us a call and learn more \r\n                  :<BR>000000000000<BR><BR></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (10, 13, 1, 'Fixed Rates', '<FONT class=subheader>30 Year Fixed Rate Program</FONT><BR><BR><FONT class=maintext>30 year fixed mortgage is a type of mortgage loan that is repaid by the borrower making 360 equal monthly payments over a period of 30 years. Since the borrower''s payments are ''fixed'', the borrower can expect to make the same monthly payment for the entire term of the loan. A 30 year mortgage loan is the most widely accepted program used to finance a residential purchase, and is available for conventional, jumbo, FHA and VA loans. </FONT><BR><BR><FONT class=subheader>15 Year Fixed Rate Program</FONT><BR><BR><FONT class=maintext>A 15 year fixed mortgage is a type of mortgage loan that is repaid by the borrower making 180 equal monthly payments over a period of 15 years. Since the borrower''s payments are ''fixed'', the borrower can expect to make the same monthly payment for the entire term of the loan. A 15 year mortgage loan is the most widely accepted program used to finance a residential purchase, and is available for conventional, jumbo, FHA and VA loans. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (18, 22, 1, 'Call back form', '<font class="maintext">\r\nDear %FULLNAME%, <br>Thank you for contacting our Team.<br>Your details have been accepted, and we''ll contact you shortly.<br><br>%SIGN%\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (11, 14, 1, 'Variable rate mortgage', '<font class="maintext">\r\nThe Variable-Rate Mortgage is offered at the prime rate less 0.25%1 and is adjusted every month. That way, you enjoy a discount on the lowest possible rate on the market! The variable payment is adjusted monthly in relation to interest rate movements and in keeping with the remaining amortization. This option minimise the amount of the payment.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (12, 15, 1, 'Capped rate mortgage', '<FONT \r\n            class=maintext>This is a mortgage that is guaranteed not to rise above \r\n            a specific rate (the ''cap'') within a set period. Unless this is \r\n            combined with another rate, such as a Discount or Tracker, the \r\n            Lender''s SVR will be charged if it is lower than the capped rate; if \r\n            it rises above this ceiling the rate charged will remain at the \r\n            capped level. There are often early repayment charges applicable if \r\n            the loan is repaid within the capped period. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (13, 16, 1, 'Remortgage rates', '<FONT \r\n            class=maintext>For many people, their home is their biggest investment \r\n            and source of savings. When they need to borrow money for major \r\n            expenses, or to pay off accumulated debts, they can use their home \r\n            value to borrow money.<BR><BR>Pay off your credit cards<BR>If you \r\n            have credit card or other consumer loans, it is often less expensive \r\n            to consolidate these expensive loans with your \r\n            mortgage.<BR><BR>Credit card interest rates are usually much higher \r\n            than mortgage interest rates. And, the interest on your mortgage is \r\n            tax deductible, while the interest on your credit card is \r\n            not.<BR><BR>If you have enough home equity, you may be able to pay \r\n            off your pricey credit card debts and save money.<BR><BR>Refinance \r\n            vs. home equity loan<BR>Generally, there are two ways to use your \r\n            home equity to borrow money. You can either refinance with a new \r\n            mortgage that is larger than your remaining balance (a cash-out \r\n            refinance) or get a home equity loan.<BR><BR>A cash-out refinance is \r\n            generally cheaper, but a home equity loan will usually let you \r\n            borrow more. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (14, 17, 1, 'Self Certification', '<FONT \r\n            class=maintext>This is a mortgage where a borrower states their income \r\n            and signs a confirmation of their ability to repay a loan, without \r\n            having to provide evidence such as accounts, payslips or bank \r\n            statements. Consequently, S/C rates are often higher than standard \r\n            Full Status mortgages. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (15, 19, 1, 'Buy-to-let mortgages', '<FONT \r\n            class=maintext>Whether you are buying your first buy-to-let property \r\n            or you are a portfolio investor there is some financial information \r\n            you need to know about:<BR><BR>\r\n            <OL type=1>\r\n              <LI>What choices of mortgage interest rates and products are \r\n              available\r\n              <LI>What is the maximum available loan\r\n              <LI>An illustration of costs and monthly payments\r\n              <LI>An analysis of returns from your investment \r\n            properties</LI></OL>Our buy-to-let quotation system will give you \r\n            all of this and more FREE OF CHARGE while you are online. <BR><BR>We \r\n            only select and recommend those buy-to-let lenders whose products \r\n            are competitive and whose service standards match those we \r\n            constantly strive to achieve. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (16, 20, 1, 'Commercial mortgages', '<font class="maintext">\r\nWe offer commercial loan programs to suit nearly every borrower and property type. Successful commercial real estate financing is dependent upon the availability of competitive funding. My commercial loan programs are fast financial solutions for commercial property owners and investors.<br>Property Types<br><br><ul><li>Multi-Family<br>Traditional, multi-family residential complexes located in both city and suburban markets.</li><li>Mixed-Use<br>Properties that integrate and combine residential with different uses, including retail and office spaces.</li><li>Office<br>Traditional office or office type properties.</li><li>Retail<br>Properties with a mix of tenants that meet the convenience needs of neighborhood residents, including video stores, grocery, and financial services companies.</li><li>Light Industrial<br>Single- or multi-tenanted spaces used for warehouse, manufacturing, distribution, or research and development. We offer loans from $250,000 to $3 million in Fixed Rate programs with 25 and 30 year amortization. Adjustable rate programs are available with a 3-year below market start rate. Our loans have competitive rates and quick decision times.</li><ul>\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (17, 18, 1, 'Cashback mortgages', '<font class="maintext">\r\nThis is a mortgage in which the Lender refunds a sum of money, either as a percentage of the loan or a flat figure, to the borrower upon completion. With this type of offer the borrower will typically be tied to the Lender''s SVR by early repayment charges necessitating repayment of the cashback if the loan is repaid within a set period.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (19, 21, 1, 'Contact us', '<font class="maintext">\r\nDear %FULLNAME%, <br>Thank you for contacting our Team.<br>Your details have been accepted, and we''ll contact you shortly.<br><br>%SIGN% \r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (20, 23, 1, 'Leave a comment', 'Thank you. Your message was sent to administrator.<br><br>%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (21, 29, 1, 'Arm''s', '<font class="maintext">\r\n1, 3, 5, 7, 10 Year Adjustable Rate Loan Programs<br><br>\r\nAn Adjustable Rate Mortgage (ARM) is a mortgage loan that is most widely known for its low starting interest rate (when compared to the 30 & 15 year mortgage loans). This ''low'' introductory rate is used to calculate the mortgage payment for a specified period of time. Once this introductory period is over, the interest rate is adjusted periodically based on a preselected index. The most commonly used index is the yield on the one-year Treasury Bill. The new interest rate is determined by adding this index to a set margin (which is determined by the lender). Although there are a variety of adjustable rate mortgage programs available, the most common program is the One Year Adjustable Mortgage (one Year ARM). The interest rate on the one year ARM is adjusted once each Year, for 30 years. APR''s on variable rate loans are subject to increase but may decrease from year-to-year, the borrower should be prepared to handle an increase in his/her monthly payment (should the index rate increase).\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (22, 30, 1, 'Jumbo', '<font class="maintext">\r\nA jumbo mortgage is a mortgage loan which is larger than the limits set by Fannie Mae and Freddie Mac ($322,700 as of 1/1/2003). Since these two agencies will not purchase these types of loans, they usually carry a higher interest rate (to enhance their value and marketability to investors).\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (23, 31, 1, 'Rate Watch', 'Welcome to Rate Watch!<br><br>\r\nWe''d like to offer you an easy way to stay informed about trends in loan rates without having to track them actively either on the Internet or with multiple phone calls to your broker! Now you can easily track our mortgage rates to help you determine when you should lock in an interest rate or refinance. <br><br>Simply join Rate Watch: it''s free.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (24, 32, 1, 'Bad Credit Ok', '<font class="maintext">\r\nYour credit report may be full of dings, compounded with a history of foreclosure and bankruptcy, but you may still get a loan for home purchase, refinance, or even cash out of your current home. It doesn''t matter whether you have charge-offs, collections, or tax liens on your credit report, as long as you can meet the specific guidelines for loan approval by a multitude of lenders specialized in the credit-damaged borrower.<br><br>\r\nThe lending industry uses categories to asses the credit risk of any particular borrower. If the property checks out and you have sufficient income, impeccable credit and the required down payment you are considered an ''A'' borrower. An ''A'' borrower can walk into almost any lender and get a mortgage loan. A borrower can fall short in one of these areas and still be considered an ''A'' borrower, as long as the other areas can compensate for the weakness. For example, a borrower that exceeds the required monthly debt-to-income ratios (28% housing debt and 36% combined debt) could offer a large down payment. Many lenders will also excuse modest credit ''blemishes'' if a reasonable explanation is provided (i.e. job transition, medical problems). Being 30-60 days late on one credit card payment is a typical blemish that could be accepted by a lender.<br><br>\r\nBut what about those that have more serious marks against their credit. Depending on how tarnished your credit history has been, lenders will typically place borrowers into the following credit categories, which are qualified by time frames:<br><br><br>\r\nA-minus credit:<br>\r\nAcceptable blemishes within the last two years: Charge-offs, or collection accounts, of minor amounts (e.g. less than $500 in all) are acceptable. Medical bills, including hospitalization and clinic visits, are usually disregarded by the lender. As for payment habits, the borrower can have no more than two 30 days late payments, or one 60 days late payment on revolving or installment credit.<br><br>\r\nB credit:<br>\r\nAcceptable blemishes within the last 18 months: Up to four 30 days late , or up to two 60 late days payments are allowed on revolving and installment debt. If the credit ding is an isolated incident, a 90 days late payment is allowed within the last 12 months. Charge-offs, or collection accounts, which are isolated, insignificant, and less than $1,000 in all, are acceptable. However, outstanding collection accounts less than four years old must be paid. Bankruptcy or foreclosure that had been discharged or settled previous to the 18 month time frame is allowed.<br><br>\r\nC credit:<br>\r\nAcceptable blemishes within the last 12 months: No more than six 30 days late payments, three 60 days late payments, or two 90 days late payments are allowed on revolving or installment credit. Open collections accounts and charge-offs may not exceed $4,000 and must be paid in full. Bankruptcy or foreclosure that had been discharged or settled prior to the last 12 months is acceptable.<br><br>\r\nD credit:<br>\r\nA sporadic disregard for timely payment or credit standing categories the borrower in this class. Open collections accounts, charge-offs, and judgements must be paid through loan proceeds. The borrower who had filed bankruptcy and had been discharged prior to the last six months is acceptable, as much as the ex-homeowner who had his previous home foreclosed and settled prior to the last six months. However, mortgage payments cannot be longer than 90 days past due.<br><br>\r\nThe above are general industry guidelines to make lending judgement on the borrower''s loan application. There are no hard-and-fast rules of separating the borrower on the border line between one credit category and another. Also, there are compromising variations between one lender to the next depending on the degree of subjectivity involved in underwriting and how much each lender wants to commit their funds.<br><br>\r\nDown payment requirements are being reduced<br>\r\nTypical lenders in the market of credit-damaged borrowers usually lend only up to 80% of the appraised value of the home, so the borrower often has to have 20% equity or come up with a 20% down payment for a purchase. Extensive shopping may uncover a company that will lend a greater percentage.<br><br>\r\nWhat about income? A-minus and B-credit borrowers are often allowed to allocate 50% of their income to pay for combined monthly debt (compared to the standard 36% guideline used for A credit borrowers), while the bottom rung of the credit ladder can be stretched to 60%. As for proof of income, some lenders do have "Stated Income" programs which do not require tax returns, W-2s, or pay stubs, but may require up to 6-month bank statements to verify income activity.<br><br>\r\nDepending on the extent of the blemishes, borrowers with less-than-perfect credit histories can expect to pay higher than market interest rates for their home loan. But if getting into a home or refinancing out of a bind is one''s goal, there are plenty of lenders out there among whom the homebuyer or borrower can shop around to get the appropriate financing. If you are having trouble finding a lender that caters to borrowers with less than perfect credit, you might want to consult with a mortgage broker. Since brokers typically deal with a multitude of lenders, they might know of lenders that make such loans.</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (25, 33, 1, 'Refinancing', '<font class="maintext">\r\nFor many people, their home is their biggest investment and source of savings. When they need to borrow money for major expenses, or to pay off accumulated debts, they can use their home value to borrow money.<br><br>\r\nPay off your credit cards<br>\r\nIf you have credit card or other consumer loans, it is often less expensive to consolidate these expensive loans with your mortgage.<br><br>\r\nCredit card interest rates are usually much higher than mortgage interest rates. And, the interest on your mortgage is tax deductible, while the interest on your credit card is not.<br><br>\r\nIf you have enough home equity, you may be able to pay off your pricey credit card debts and save money.<br><br>\r\nRefinance vs. home equity loan<br>\r\nGenerally, there are two ways to use your home equity to borrow money. You can either refinance with a new mortgage that is larger than your remaining balance (a cash-out refinance) or get a home equity loan.<br><br>\r\nA cash-out refinance is generally cheaper, but a home equity loan will usually let you borrow more.</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (26, 34, 1, '125% Ltv', '<font class="maintext">\r\nThis popular loan program is a great way to reduce your monthly payments by allowing you to consolidate those high rate credit cards and installment loans. Cashing-out equity for home improvement or for an investment opportunity may be another reason for selecting this type of loan program.<br><br>\r\n\r\nExample of how you may benefit from our 125% LTV loan program<br><br>\r\n\r\n...Before Refinance:<br>\r\nHome Value: 200,000<br>\r\nCredit Card Debt: 75,000<br>\r\nRate: 6.85%<br>\r\nTerm: 30 Years<br>\r\nMortgage Payoff: 150,000<br>\r\nMonthly Mortgage Payment: 982.00<br>\r\nMonthly Debt Payment: 1,250<br><br>\r\n\r\n...After Refinance:<br>\r\nNew Loan: 237,000<br>\r\nNew Rate: 7.25%<br>\r\nNew Payment: 1,616.76<br>\r\nOld Payment: 982.00 + 1,250 = 2,232.00<br>\r\nMonthly Payment Savings = $615.24<br>\r\nYearly Savings: 7,382.88<br>\r\n3-Year Savings: 22,148.64<br>\r\n5-Year Savings: 36,914.40<br><br>\r\n\r\n* Payments based on 30 Year Amortization, 100% ltv, 1st lien position, 7.25% rate, 7.35% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guide lines\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (27, 35, 1, '100-102% Ltv', '<font class="maintext">\r\nLooking for a 100% financing on your new home mortgage? We have several lenders who can offer you this excellent type of loan program. Some even allow up to 6% seller concessions to pay your closing costs! If you are looking for max LTV, submit your loan application today and pre-qualify by tomorrow!\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (28, 36, 1, 'Interest Only', '<font class="maintext">\r\nThis type of loan program is for those who would like to significantly lower their mortgage payments by allowing you to pay only the interest on the loan. This type of loan is great for debt consolidation up to 100% LTV.<br><br>\r\n\r\nExample of how you may benefit from an Interest Only Loan Program<br><br>\r\n\r\n...Before Refinance:<br>\r\nMortgage Balance: 225,000<br>\r\nRate: 7.5%<br>\r\nTerm: 30 Year<br>\r\nMonthly Mortgage Payment: 1,573.23<br><br>\r\n\r\n...After Refinance:<br>\r\nNew Loan: 225,000<br>\r\nNew Rate: 3.75%<br>\r\nNew Payment: 703.00<br>\r\nOld Payment: 1,573.23<br>\r\nMonthly Payment Savings: 870.23<br>\r\nYearly Savings: 10,442.76<br>\r\n3-Year Savings: 31,328.28<br>\r\n5-Year Savings: 52,213.80<br><br>\r\n\r\n* Payments based on 30 Year Amortization, 80% ltv, 1st lien position, 3.75% rate, 3.85% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guide lines<br>\r\nHome Equity Line (HELOC)<br><br>\r\n\r\nThis type of program is very popular for those looking to do home improvements and who are not interested in tapping into all of their home''s equity at one time. With this type of program you can draw on your equity at your leisure making this an excellent loan program that you control. A "HELOC" is usually setup on an interest only payment and is fixed to either the LIBOR or Prime index and can be used for at least 10 years before principal payments are required.<br><br>\r\n\r\nExample of How and Interest Only HELOC Payment is Calculated:<br><br>\r\n\r\nRate + Index x Remaining HELOC Balance/divided by 12 Months = Mo. Payment<br><br>\r\n\r\n4.25 + 1.00 x 35,000 /12 Mo. = $125.00<br><br><br>\r\n     \r\n    \r\n* Payments based on 30 Year Amortization, 80% LTV, 1st lien position, 5.25% rate, 5.35% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guidelines\r\n\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (29, 37, 1, 'Home Equity', '<font class="maintext">\r\nA home equity line is a form of revolving credit in which your home serves as collateral. Because the home is likely to be a consumer''s largest asset, many homeowners use their credit lines only for major items such as education, home improvements, or medical bills and not for day-to-day expenses.<br><br>\r\nWith a home equity line, you will be approved for a specific amount of credit-your credit limit-meaning the maximum amount you can borrow at any one time while you have the plan.<br><br>\r\nMany lenders set the credit limit on a home equity line by taking a percentage (say, 75 percent) of the appraised value of the home and subtracting the balance owed on the existing mortgage. For example:<br><br>\r\n\r\n<center>\r\n<table width="70%" bgcolor="#E6E6E6" cellspacing=1>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Appraisal of home</td><td width="50%" class="maintext">$100,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Percentage</td><td width="50%" class="maintext">x75%</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Percentage of appraised value</td><td width="50%" class="maintext">$75,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Less mortgage debt</td><td width="50%" class="maintext">-$40,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Potential credit line</td><td width="50%" class="maintext">$35,000</td></tr>\r\n</table>\r\n</center><br>\r\nIn determining your actual credit line, the lender also will consider your ability to repay, by looking at your income, debts, and other financial obligations, as well as your credit history.<br><br>\r\nHome equity plans often set a fixed time during which you can borrow money, such as 10 years. When this period is up, the plan may allow you to renew the credit line. But in a plan that does not allow renewals, you will not be able to borrow additional money once the time has expired. Some plans may call for payment in full of any outstanding balance. Others may permit you to repay over a fixed time, for example 10 years.<br><br>\r\nOnce approved for the home equity plan, usually you will be able to borrow up to your credit limit whenever you want. Typically, you will be able to draw on your line by using special checks.<br><br>\r\nUnder some plans, borrowers can use a credit card or other means to borrow money and make purchases using the line. However, there may be limitations on how you use the line. Some plans may require you to borrow a minimum amount each time you draw on the line (for example, $300) and to keep a minimum amount outstanding. Some lenders also may require that you take an initial advance when you first set up the line.<br><br>\r\n\r\n\r\n<font class="subheader">Costs to Obtain a Home Equity Line</font><br><br>\r\n<font class="maintext">\r\nMany of the costs in setting up a home equity line of credit are similar to those you pay when you buy a home. For example:<br>\r\n\r\n<ul>\r\n <li>A fee for a property appraisal, which estimates the value of your home.</li>\r\n <li>An application fee, which may not be refundable if you are turned down for credit.</li>\r\n <li>Up-front charges, such as one or more points (one point equals one percent of the credit limit).</li>\r\n <li>Other closing costs, which include fees for attorneys, title search, mortgage preparation and filing, property and title insurance, as well as taxes.</li>\r\n <li>Certain fees during the plan. For example, some plans impose yearly membership or maintenance fees.</li>\r\n <li>You also may be charged a transaction fee every time you draw on the credit line.</li>\r\n</ul><br>\r\n\r\n<font class="subheader">Comparing a line of credit and a traditional second mortgage loan</font><br><br>\r\n<font class="maintext">\r\nIf you are thinking about a home equity line of credit you also might want to consider a more traditional second mortgage loan. This type of loan provides you with a fixed amount of money repayable over a fixed period. Usually the payment schedule calls for equal payments that will pay off the entire loan within that time. You might consider a traditional second mortgage loan instead of a home equity line if, for example, you need a set amount for a specific purpose, such as an addition to your home.<br><br>\r\nIn deciding which type of loan best suits your needs, consider the costs under the two alternatives. Look at the APR and other charges. You cannot, however, simply compare the APR for a traditional mortgage loan with the APR for a home equity line because the APRs are figured differently.<br>\r\n\r\n<ul>\r\n <li>The APR for a traditional mortgage takes into account the interest rate charged plus points and other finance charges..</li>\r\n <li>The APR for a home equity line is based on the periodic interest rate alone. It does not include points or other charges.</li>\r\n</ul>    \r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (30, 38, 1, 'No Doc - Limited', '<font class="maintext">\r\nOur No-Doc/Limited Doc Loan programs offer self-employed business owners an easy way to qualify for a mortgage. We have several lenders who offer very competitive No-Doc/Limited Doc programs with excellent rates and flexible terms for those who have the credit score to qualify.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (31, 39, 1, 'Stated Income', '<font class="maintext">\r\nOur "stated" income program is a loan program offered by many of our lenders. This program is great for self-employed borrowers and allows you to "State" your income without the need for verification. Our stated income program allows a borrower to meet the "Debt-To-Income" ratio required by our lenders.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (32, 40, 1, 'Construction', '<font class="maintext">\r\nWhether you''re planning to build your dream home or just thinking about it, we can help. We can answer your questions, and guide you through the loan process. We''ll be with you every step of the way from framing your front door to turning the key. At Family Home Lending, we''re home construction lending experts. We can answer your questions and your builder''s questions so your project keeps moving smoothly from groundbreaking to housewarming. Our Construction-to-Permanent Loan is based on ordering an appraisal based on the future value of the home.  That''s right I said future appraised value of you home.  We can lend 90% of the future appraised value of a primary home, and 80% of the future appraised value  for a spec home.  The construction loans is based on the actual cost which can include the purchase of the land.<br><br>\r\n\r\nWe can offer new construction loans on the following property types:<br><br>\r\n\r\n<ul style="font-weight: bold">\r\n  <li>Primary Homes</li>\r\n  <li>Second Homes</li>\r\n  <li>Modular Homes</li>\r\n  <li>Spec. Homes for Builders</li>\r\n  <li>Complete Rehabilitation</li>\r\n</ul>\r\nThis means with one application, you get all the financing you need in two easy processes your construction and permanent loan. All fees and points will be built into both mortgages.  Based on the project if it has enough value we can finance your land and wrap your closing cost into your construction loan up front.  Below you will find the list of items you will need to get your construction loan started.<br><br>\r\n\r\n<ul style="font-weight: bold">\r\n  <li>Plans and Specifications</li>\r\n  <li>Plot Plan</li>\r\n  <li>Proof of a Land contract or a Deed</li>\r\n  <li>Proof the Land is build able from your local Building Inspector</li>\r\n  <li>Title Commitment</li>\r\n  <li>Homeowners Insurance</li>\r\n  <li>Line item list of all cost to build your project</li>\r\n</ul>\r\nTerms of the construction loan are for 3 or 6 month periods. This loan program offers interest only (up to 5 draws) 30-year amortization.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (33, 24, 1, 'Sent application/credit report', 'Dear, %FULLNAME% Thank you for filling the application form.\r\n\r\nWeРІР‚в„ўll review it shortly and will let you know the results as soon as possible. \r\n\r\n%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (34, 41, 1, 'Apply Online', 'Applying for a loan or getting more information is easy. We offer you several convenient and secure options to get started.<br><br>\r\n\r\n1. Get pre-qualification letter <br>\r\n2. Fill out our Short Application Form. This process will take 2-4 minutes. I will contact you once I receive your application.<br>\r\n3. Fill out our Long Application Form. This process will take 2-4 minutes. I will contact you once I receive your application. (We will need this form completed eventually.)<br>\r\n4. We use the most cutting edge technology available to close loans quickly, at a low cost. By combining the use of the Internet along with advanced processing software and automated underwriting systems.  We have taken the mystery out of approving and closing a home loan.  This means that you can now get a loan faster, at a lower cost, with less paperwork and less stress!<br>\r\n\r\n5. Have one of our Loan Officers contact you<br> 6. Please mail me a loan application.<br> 7. Download the application material now and mail or fax it to me. \r\n<br><br>\r\n\r\nDocuments Required<br><br>\r\n\r\n<ul>1.  <u>Purchase/Refinance Loans</u><br><br><ul>Instructions for completing loan application<br><br>1.  Complete and sign 3 or 4 page residential loan application Form 1003 and attached loan info sheet, credit authorization and fair lending notice. Page 4 of the application is a continuation page in case you need additional space for your assets or liabilities. If you make a mistake while filling out the application cross it out, and make a change. Do NOT use white out.<br>2.  If you are salaried: provide two years W-2 and one month of paystubs OR if you are self-employed: provide two years tax returns and a YTD profit and loss statement.<br>3.  If you own rental property, please provide rental agreements and two years tax returns.<br>4.  If you wish to speed up the approval process, please also provide three months bank statements for each bank, stock and mutual fund account.<br>5.  Provide recent copies of any stock brokerage or IRA/401K accounts that you may have.<br>6.  If you are requesting a cash out refinance please provide a letter explaining what you plan to do with the proceeds.<br>7.  Provide copy of divorce decree if applicable.<br>8.  If you are NOT a US citizen provide us with a copy of your green card (front & back), or if you are NOT a permanent resident provide us with your H-1 or L-1 visa.<br><br></ul>2.  <u>Credit Lines/Home Equity Loans</u><br><br><ul>Instructions for completing loan application<br><br>1.  Complete and sign 3 or 4 page residential loan application Form 1003 and attached loan info sheet, credit authorization and fair lending notice. Page 4 of the application is a continuation page in case you need additional space for your assets or liabilities. If you make a mistake while filling out the application cross it out, and make a change. Do NOT use white out.<br>2.  If you are salaried: provide two years W-2 and one month of paystubs OR if you are self-employed: provide two years tax returns and a YTD profit and loss statement.<br>3.  If you own rental property, please provide rental agreements and two years tax returns.<br>4.  Please provide a copy of the note on your 1st mortgage. This will normally be found in your closing loan documents.<br>5.  Please provide a signed letter explaining what you plan to do with the proceeds.<br>6.  Provide copy of divorce decree if applicable.<br>7.  If you are NOT a US citizen provide us with a copy of your green card (front & back), or if you are NOT a permanent resident provide us with your H-1 or L-1 visa.</ul></ul>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (35, 26, 1, 'Login page', 'Before filling an application form please register here.<br>Your details will not be passed to other companies or used for marketing purposes.Once you register, you''ll get more access to site features, and will help you in the mortgage process understanding.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (36, 25, 1, 'Registration page', 'Register in this form to receive information on your Loan Status modification.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (37, 27, 1, 'Borrower homepage', 'Dear, %FULLNAME%<br><br>It''s always nice to meet you here.<br>On your own panel, you can complete your own information, continue filling your allocation, view your results and communicate directly with your borrower.<br><br>%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (38, 28, 1, 'Saved changes confirmation', 'Dear,  %FULLNAME%<br>\r\nThe changes you have made here were successfully saved.<br><br>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (40, 42, 1, 'Mortgage Rates', '<font class="maintext">\r\nWe will provide you a low cost home, refinance, construction or commercial loan. Enjoy a fast, hassle-free, no-nonsense service from a company that cares, with years of experience, and the determination to get what you want! We can show you in detail how we can save you and your family a fortune on your mortgage loan with our low interest rates. After the initial application is taken, we automate everything through loan submission followed by closing.<br><br>Our focus is to reaffirm this companies history of providing outstanding service to our customers. We encourage our staff to develop strong relationships with our customers. As these relationships develop, we understand our customer''s needs. As we understand these needs, we provide the services they require with the quality that meets the borrowers appropriate financial and loan requirements at competitive prices. Through good planning, our customers'' expectations should be met with timely delivery of the expected interest rate and loan and sufficient after-market service, making only those promises that we can keep. Every person in this organization needs to conduct business in a manner which is courteous and polite.<br><br>America truly is the land of opportunity. We will provide the expertise, with a lifetime of support, which hopefully upon qualifying will enable every American as well as Foreign Nationals to realize and fulfill the American dream.<br><br><br>Rates, points, and products are subject to change at any time without notice.\r\n<br></font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (41, 43, 1, 'Understanding The Loan Application Process', '<font class="maintext">\r\n<font color="#BD827B" class="headers" size="4" face="Verdana, Arial, Helvetica, sans-serif"><b>Introduction</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Buying a home may be the most exciting, confusing and stressful financial transaction you ever undertake. Even if you have done it several times you can still find the process complicated and intimidating, particularly when it comes to getting a mortgage loan. Countless loan documents, unfamiliar terminology and uncertainty serve to temper the joy of buying a new home. As soon as the sales contract is signed, obtaining the financing for the purchase becomes paramount for all but a very few buyers. If you understand the steps required to qualify for a mortgage loan, however, much of the stress can be avoided. The following explanation of the loan application process is intended to help you through the complexities of obtaining a mortgage loan.</span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Loan Application Interview</b></font></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Once you have selected a lender, the next step will probably be a meeting with a loan officer or other lender representative, whose job is to begin the collection of information the lender needs to approve the loan. They will explain the types of mortgage e loans available to you, the interest rates and fees for each type and the qualification requirements. During the meeting, the loan officer will fill out, or assist you in filling out, the loan application form. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">By this time you should have a good idea of the general interest rates and fees being charged in the area. The total cost of a mortgage loan consists of the interest rate on the loan, origination fees, discount points, and miscellaneous other charges. One point is equal to one percent of the amount of the loan and is usually collected at the loan closing, or settlement. The interest rate affects the amount of the monthly payment, while points affect the amount of cash you must have at closing. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Most lenders will offer a range of interest rate/point combinations to meet the borrower needs. In general, the higher the interest rate, the lower the points. For example, if the current market provides for an 8.5 percent interest rate with 2 points, a nine percent rate may be offered at no points. If you are a first-time home buyer, the larger monthly payments on the 9 percent loan may be easier to handle than the 2 points that will require additional cash at settlement. If you are a corporate transferee, however, your company''s relocation policy may pay all or part of origination costs and the lower rate will have more appeal. The loan officer is prepared to explain all of your options to you. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When discussing the terms of the loan, make sure you understand how and when the rate and fees on the loan are going to be set. Most lenders will quote a rate and fee at the time the application is taken and then will guarantee, or "lock" the rate quote for a specified length of time. A rate lock protects you from rising interest rates while the loan is being processed, but it also typically commits you to close the loan at the rate and the fee even if rates decline prior to closing. Lock periods may run from 10 to 60 days, with longer periods available in some cases at an additional fee. The lock period must be long enough to get you through the estimated closing date. A 30-day lock affords you no protection if closing is at least 60 days away. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You may have the option to let the rate "float," getting the final rate and fees set nearer the settlement date. If you believe rates are declining and are willing to run the risk that interest rates could rise during the processing of your loan, you may select this alternative. Before you take a floating rate, make sure that the rise in interest rates will not create a problem for you because you have insufficient income to cover the higher mortgage payments. In either case, make sure you understand exactly the terms of the lock-in agreement.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Completing The Loan Application Form</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The loan application form asks for information on the property you are buying, terms of the purchase contract and the employment and financial history of all loan applicants, including your spouse and/or other co-borrowers. The lender will verify or not to make the loan, so it is very important to make sure that it is complete and accurate. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You can complete the loan application process much more easily and accurately if you prepare for it ahead of time. A great deal of detail will be asked about your personal finances, including bank account numbers and balances, current loan amounts and payments, and credit card account numbers. You will want to be thorough and precise in your answers, so it will be to your benefit to assemble this kind of information before the meeting with the loan officer. The following is a summary of the major kinds of information required on the loan application, the documents that may be needed and the questions that you should be prepared to answer.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">Details of Purchase Contract and the Property</span></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Because the property is security for the loan, the lender will have an appraisal made of the property, and you need to have the following information available: </span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A complete copy of the sales contract, including any addendum''s, signed by all parties, showing the full names of the sellers and buyers as they will appear on the new deed, the amount of earnest money deposit and who is responsible for closing costs, origination fees, etc.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the house is to be built, or is still under construction, a set of plans and specifications.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The complete mailing address of the property, its age and its full legal description.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Name, address and telephone number of the real estate agent and/or the seller of the property who will assist the appraiser in obtaining access to the property. \r\n                            </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">All of this information should be in the purchase contract. If not, consult the Realtor or the seller. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Personal Information</span></font></b> </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The loan officer will want the social security numbers of you and your spouse (or other co-borrowers), age, number of years of schooling, your marital status, number and ages of dependents and your current address and telephone number. If you have lived at your current address less than 2 years, be prepared to furnish former addresses for up to seven years. You will also be asked to detail your current housing expenses, including rent or mortgage payments, real estate taxes and insurance (your mortgage payment may include tax and insurance funds). You will need the name and address of your landlord(s) or mortgage lender(s) for the past two years. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Employment History and Sources of Income</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your ability to make the regular payments on the mortgage and to afford the costs associated with owning a home are primary considerations is the lender''s loan approval process and should be your primary concern. Required information includes:</span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At least two years employment history with employer''s name and address, your job title or position, length of time on the job, salary, bonuses, commissions and average overtime pay.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Recent paycheck stubs and Federal W-2 forms for two years (some lenders may require full Federal tax returns).</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Records of dividends and interest received from investments.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are self-employed, full tax returns and financial statements for 2 years, plus a profit and loss statement for the current year to date.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">A written explanation if there are gaps in your employment record, because of circumstances such as illness or layoffs, or for any other reason</span>. </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The loan officer will have you sign a Verification of Employment (VOE) form. This will be sent to your employer to verify your employment and earnings. One will be sent to previous employers if you have been on the job less than two years. Many lenders now use a general authorization form which allows them to verify employment and other financial information on the application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are relying on income from other sources, such as rental property, social security or disability payments, child support, etc., you must provide adequate proof of the source. Appropriate documents could include canceled checks, copies of leases, certification of benefits, divorce decrees and similar evidence. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">Personal Assets</span></span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A detailed listing of your personal assets is required on the loan application form. You will need to have the following information available to complete the form: </span></font></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">All bank accounts, both checking and savings, and money market accounts, with the name and address of the institution, name(s) on the accounts, account numbers and current account balances.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Recent bank statements for at least two months.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Current market value of stocks, bonds, CDs and other investments.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Vested interest in all retirement funds.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Face amount and cash value of life insurance policies in force.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Make, model, year and value of automobiles owned.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Address and market value of all real estate owned along with the amount of rents collected, the mortgage on the property and the monthly mortgage payments (a profit and loss statement will be required for investment properties).</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Value of other personal property such as furniture. </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">As with the Verification of Employment, the loan officer will have you sign Verifications of Deposit (VOD) for each of the institutions (or a general authorization) where you have savings or checking accounts. Differences between the account balances reported by the institution and the balance you give for the loan application have to be reconciled, so be sure you have your correct current balances. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender will look for the source of funds with which you will make the down payment and pay closing costs and fees. Gifts from a relative, church, municipality or non-profit organization may sometimes be used, but must be verified in writing. If you are providing less than 5 percent of the sales price, the donor must be a relative and must provide a letter stating the donor''s relationship to you, the amount of the gift and the fact that no repayment is expected. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Personal Indebtedness</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will be asked to itemize all of your current bills, loans and other debts, including current balances and monthly payments. Debts include automobile loans, credit cards such as Visa, Mastercard and other retail store accounts, finance company, bank a nd credit union loans and existing mortgages, including home equity loans. You should be able to give the account or loan number, the monthly payment, the number of payments remaining and the outstanding balance. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information you provide on the loan application will later be verified by a credit report ordered by the lender. Like employment and deposit information, differences between your figures and those on the credit report will raise questions and may delay the approval of your loan. It is to your advantage to take time to get your data right prior to filling out the loan application. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have had credit problems, you should inform the lender. Lenders recognize that unemployment, illness, marital problems or other financial difficulties can temporarily impair your credit rating. Provide a written explanation of the circumstances regarding the problem to be included with the loan application. The lender must consider such a written explanation as part of the underwriting analysis. If the problem has been corrected and your payments have been made on time for a year or more, your credit will probably be judged as satisfactory. Chronic late payments, judgments or loan defaults, however, severely damage your credit standing and may prevent you from obtaining the financing you need to complete the purchase. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have been through bankruptcy or foreclosure proceedings within the past seven years, be prepared to give full details and copies of applicable documents regarding them. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will also be asked to explain the details if you are obligated to pay alimony, child support or separate maintenance. Such obligations are treated like debt payments by most lenders and will be part of the underwriting analysis. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Additional Information</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will be asked to sign a section of the loan application form which contains your certification that the information you have provided is correct to the best of your knowledge; your promise to advise the lender of any material changes in the information on; and your consent to (1) verification of the application data, (2) submission of account history to credit reporting agencies, and (3) transfer of the loan or loan servicing to successors to the original lender. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The last part of the application form requests information on the race and gender of the applicants. The Federal Government uses this data to monitor lenders'' compliance with fair housing and equal credit opportunity laws. Providing this information is strictly voluntary on your part and has no effect on your loan application. The lender, however, is required by federal law to request the information. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Because of the particular circumstances surrounding a loan application, the lender may require additional information or documentation regarding you or the property after the application has been submitted for approval. Loan officers make every effort to collect all data at the outset, but cannot foresee every eventuality. Requests for additional information are not necessarily bad omens and your primary concern should be in responding promptly with the information. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At the time the application is taken, you will probably be asked to pay for the credit report and appraisal fees. depending upon the locality and the type of the loan, these fees will generally run up to $500. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Based on the information collected in taking the application, the loan officer may be able to pre-qualify you for the loan requested, but cannot approve the loan. That is done by the lender''s underwriters after all documents and information have been recieved and verified.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>After The Loan Application - What Next?</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">After the loan application has been completed, it will be turned over to the lender''s loan processing department and then to the underwriter, where the decision to approve or reject the loan will be made. Loan processors send out the Verifications of Employment and Deposit and order the credit report, property appraisal and other documents. The time it takes to receive these documents affects the length of time required for approval of the loan. If you are transferring from out of the local community, it may take longer to receive the credit and employment information. Processing times vary from one lender to another, but the loan officer should be able to give an idea of the processing time for your application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Within three business days after completing the application, the lender must provide you with a <b>Good Faith Estimate</b> of the anticipated closing costs. It will show costs associated with the loan settlement, such as origination fees, mortgage insurance, title insurance, escrow reserves and hazard insurance. </span> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Within the same three days you will also receive a <b>Truth-in-Lending Disclosure</b> statement. This statement shows, among other things, the estimated monthly payment. The total cost of all finance charges on your loan is also shown, stated as an <b>Annual Percentage Rate (APR)</b>. The APR represents the dollar amount of finance charges you pay either up front or over the life of the loan, converted to an annual interest rate. Since the APR includes origination fees and other charges as well as interest on the mortgage loan, the APR is usually higher than the interest rate on the loan. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">After the lender has approved the loan, you will usually receive a commitment letter which sets out the terms of the loan and the length of time for which those terms are offered. If the loan does not close within the specified commitment period, the terms are subject to change. You usually must accept the commitment by returning a signed copy to the lender within five to ten days and may have to pay part or all of the origination fees at this time. The commitment may contain conditions that you will still have to satisfy, so you should read it carefully. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In cases where closing is scheduled soon after approval, the lender may give you verbal approval instead of a commitment letter. This is not unusual, but make sure you understand the terms of the approval. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Once the commitment letter or approval has been received, you are assured the financing you need to complete the purchase of your home and you need to turn your attention to completing the details required for settlement.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Reducing The Anxiety of Waiting</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">For many home buyers, the period of time between the submission of the loan application and receipt of the commitment letter is one of uncertainty and concern. Requests for additional information, unexpected delays and lack of communication all serve to increase the tension. There are a number of things that both you and the lender can do to reduce the stress. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Keep in mind that the lender wants to make the loan. Loan underwriters are looking for ways to approve loans, not reject them. If you have come to the interview with the loan officer fully prepared and have provided good documentation, you have done a great deal to assure prompt processing of your application and approval of your loan. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You and the lender need to make sure that lines of communication are kept open. Your contact person may be the loan officer, but often it might be someone in the lender''s loan processing department who can tell you the status of your application. Remember, however, that it may take several weeks to process the application and frequent inquiries from you prior to that time will not speed things up. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You should be accessible if the lender needs additional information or documents during processing. If you are from out of town, use your real estate agent as a contact if necessary. Quick response to lender requests helps keep the process on schedule. In order to protect both you and the lender, mortgage loans require much more paperwork and legal documentation than an automobile or other installment loan, and lenders do not ask for more than is absolutely necessary. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Obtaining a mortgage loan need not be an ordeal that dampens the thrill of acquiring a new home. If you understand the lending process and are prepared to do your part, it simply becomes a key step in owning a home.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></p>\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (42, 44, 1, 'How To Shop For A Mortgage', ' With dozens of competing lenders and mortgages to choose from, you may think that today''s home loan market is terribly confusing. It really isn''t though if you know the basic facts about financing a house. That''s what this brochure is designed to give you. Let''s start with the questions that are probably uppermost in your mind.</font></span></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Large A Mortgage Can I Get?</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">That depends upon your income and the cost of your new house. Lenders use certain guidelines to determine the mortgage amount that they will lend any one homebuyer. The two guidelines used are housing expenses and long term debt. Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For <b>Federal Housing Administration (FHA)</b> loans, this figure is not t o exceed 29 percent of the homebuyer''s gross monthly income. With loan guaranteed by the <b>Department of Veteran''s Affairs (VA)</b>, lenders measure prospective homebuyers with &quot;Residual Income,&quot; or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower.</font></span></p>\r\n                  <ul>\r\n                    <li> \r\n                      <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><span class="headers"><font size="4"><span class="headers">FHA Loans</span></font></span><br>\r\n                        </strong></span><span class="bodytext"><span class="bodytext">Housing expenses = 29% of gross monthly income </span><br><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income</span></span></font></span></span></p>\r\n                    </li>\r\n                    <li><span class="headers"><span class="headers"><font size="4"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong>VA Loans</strong></span></font></span></span></font></span></span><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><br>\r\n                      </strong></span><span class="bodytext"><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income<br>Residual Income = Varies by location and family size <br></span><br>\r\n                      </span> </font></span></span></li>\r\n                    <li> \r\n                      <p><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><font size="4" class="headers">Conventional Loans</font><br>\r\n                        </strong></span><span class="bodytext"><span class="bodytext">Housing Expenses = 25% - 28% of gross monthly income </span><br><span class="bodytext">Housing Expenses Plus Long-Term Debt = 33% - 36% of gross monthly income </span></span></font></span></span></p>\r\n                    </li>\r\n                  </ul>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. VA and FHA mortgage lenders define long- term debt as monthly income. Your lender will work out these figures for you when you sit down to discuss the mortgage you want.</font></span></span></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Types Of Loans Are Available</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although you may see many different types advertised, they all belong to just two families: those mortgages that carry fixed interest rates, and those whose rates change during the course of the loan on a periodic schedule mutually agreed upon by you and your lender. This page does, however, discuss some new loans who are really "cousins" to each family-convertible mortgages.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Fixed Rate Mortgages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You are probably familiar with a fixed-rate mortgage. Your parents more than likely had one, as did their patent before them. The major advantage of fixed rate mortgages is that they present predictable housing costs for the life of the loan. Some fixed-rate mortgages you will probably hear about are:</span></font></span></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">30-year fixed-rate mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">15-year fixed-rate mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Bi-weekly mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">"Convertible" mortgages</span></font></li>\r\n                  </ul>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When people thought of a mortgage 10 to 50 years ago, they thought of a 30-year fixed-rate mortgage. This traditional favorite is not the only choice nowadays because volatile financial times created a whole new range of selections. However, the 30-year fixed-rate mortgage may still be the best mortgage for your circumstances. It offers the lowest monthly payments of fixed-rate loans, while providing for a never- changing monthly payment schedule. Some lenders offers 25,20, and even 40-year term mortgages as well. But remember, the longer the term of the loan, the more total interest you will pay.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The 15-year fixed-rate mortgage allows homeowners to own their homes free and clear in half the time and for less than half the total interest costs of the traditional 30-year loan. The loan''s term is shortened by the 10 percent to 15 percent higher monthly payments. Some homebuyers prefer this mortgage because it allows them to own their home before their children start college. Others prefer it because they will own their home free and clear before retirement and probable declines in income.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The major disadvantages or the 15-year fixed-rate mortgage are the sometimes higher monthly payments. But if saving on total interest costs and cutting the to free and clear ownership are important to you, the 15-year fixed-rate mortgage is a good option. The bi-weekly mortgage shortens the loan term to 18 to 19 years by requiring a payment for half the monthly amount every two weeks. The bi-weekly payments increase the annual amount paid by about 8 percent and in effect pay 13 monthly payments(26 bi-weekly payments) per year. The shortened loan term decreases the total interest costs substantially. The interest costs for the bi-weekly mortgage are decreased even further, however, by the application of each payment to the principal upon which the interest is calculated every 14 days. By nibbling away at the principal faster, the homeowner saves additional interest. Remember, however, that you trade lower total interest costs for fewer mortgage interest deductions on your federal income tax. Your ability to qualify for this type of loan is based on a 30-year term, and most lenders who offer this mortgage will allow the homebuyer to convert to a more traditional 30-year loan without penalty. Availability is limited on this mortgage, but it can be worth looking for.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some newer mortgages afford homebuyers some the best qualities of the fixed-rate and adjustable rate mortgages. One new type of loan, often called a <b>Two-Step, Super Seven</b>, or <b>Premier Mortgage</b>, gives homeowners the predictability of a fixed- rate and adjustable rate mortgage for a certain time, most often seven or 10 years, and then the interest rate is adjusted to fit market conditions at that time. The main advantage associated with this type of loan is that homebuyers often get a slightly lower than market rate to begin with. The main disadvantage is that they may see their interest rate go up by as much as six percentage points at the end of the seven-year period. The lender may also reserve the option to call the loan due with 30 days notice at that time, making this loan similar to a balloon mortgage in some cases.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Lenders offer this type of loan in part because research indicates that many homebuyers remain in the home for seven to 10 years before moving. For this type of homebuyer, the Two-Step or Super Seven loan present an excellent way of getting a fixed- rate loan at a better than market price for a fixed-rate loan at a better than market price for a fixed period of time.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another type of mortgage that is becoming popular is called a <b>Lender Buydown</b>, where the homebuyer gets an initially discounted rate and gradually increases to an agreed-upon fixed rate over a matter of three years. For example: When the market rate is 10 percent, the fixed rate for the mortgage is set at about 10.5 percent, but the homebuyer makes monthly payments based on a first year rate of 8.5 percent. The second year the rate goes up to 9.5 percent, and for the third year through the remaining life of the loan, the rate is calculated at 10.5 percent. A second type of lender buy-down, called a <b>Compressed Buydown</b>, works the same way, but with the interest rate changing every six months instead of on a yearly basis.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Lender Buydown gives consumers the advantage of lower initial monthly payments for the first two years of the loan when extra money may be needed for furnishings and, secondly, the advantage of knowing that, although the interest rate does change during the first three years of the loan, the interest is fixed from the third year on.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Convertible mortgages offer today''s homebuyer the option to change the loan''s interest rate after some period of time or some specified movement in interest rates.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Convertible fixed-rate mortgages are often referred to as the <b>Reduction Option Loan (ROLE)</b> or, in some locations, the <b>Reducing Interest Loan (RIL), or Mortgage (RIM)</b>. This new type of loan offers homeowners the option of getting a loan that , under the right conditions, can be adjusted to a lower interest rate with a payment of $100 or $200 or so and a small loan amount-based fee, sometimes as little as one-fourth of a percentage point. These conditions usually are a prescribed movement in rates-typically two percent below the initial- during a set time limit-between months 13 and 59, for example.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On a 30-year fixed-rate mortgage with a reduction option, the homebuyer pays an extra one-fourth to three-eighths of a percentage point in the interest rate on the mortgage plus a quarter to three-eighths of 1 percent of the loan amount (points) at the time of closing. This allows the homeowners to adjust the interest rate on the loan without having to go through a refinancing, which could cost up to 5 percent or 6 percent of the loan amount, if the rates are right during the prescribed time limit.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On an $80,000 loan, this means that you could reduce the interest rate on your loan from, say, 10.5 percent to 8.5 percent, and take advantage of the low rates for the rest of the loan term for $150 instead of up to $4,800 , if the rates dropped to that point during your "window of opportunity" - months 13 through 59. Some homeowners may find the ROL a good "insurance policy" against the high costs of refinancing. Others may want the flexibility that refinancing offers - namely the ability to draw on built-up equity- that is not available with ROLs. The decision is up to you.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertible Adjustable Rate Mortgages (ARMs)</b> are another new loan product on today''s market. It worked like any other ARM, but it offers homeowners a distinct advantage-it allows them to turn their ARM into a fixed-rate mortgage after a set period (usually during the second through fifth years of the loan).</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A new product developed by the <b>Federal National Mortgage Association (Fannie Mae)</b>, which buys mortgages from lenders, allows the homeowner to convert an ARM to either a 15 or 30 year fixed-rate mortgage for a fee of 1 percent of the original loan plus $250 , as compared to the 3 percent to 6 percent costs of refinancing. Say, for instance, that you got your convertible ARM at an initial interest rate of 10.0 percent, and after a year or so, rates had dropped to 8.0 percent. For the smaller conversion fee, you could adjust your mortgage to either a 15 or 30 year fixed-rate loan at a new rate that would be about one-half percent higher than the going market rate, or 8.5 percent. There are other variations on this loan available from lenders across the country. Homebuyers who want the low initial rate of an ARM, and the option and peace of mind of a fixed mortgage should rates drop, can now have it both ways.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Adjustable Rate Mortgages (ARMs) have become on of the most popular and effective tools for helping some prospective homebuyers achieve their dream of homeownership. Developed during a time of high interest rates that kept many people out of the housing market, the ARM offers lower initial rates by sharing the future risk of higher rates between borrower and lender.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">ARMs can be an excellent choice of financing under certain conditions, such as rising income expectations, high interest rates, and short-term homeownership. But because payments and interest rates can increase, either steadily or irregularly, homebuyers considering this kind of mortgage need to have the income to keep up with all possible rate and/or payment changes. Each ARM has four basic components:</span></font></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Initial interest rate</b>, which is typically one to three percentage points lower than that of most fixed-rate mortgages. Lower interest rates also make ARMs somewhat easier to qualify for. The initial interest rate is tied to certain economic indicators that dictate in part what the monthly payments will be.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustment interval</b>, at the time between changes in the interest rate and/or monthly payment will be.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Index</b>, against which lenders measure the difference between what they are making on their investment in the mortgage and what they could be making on other types of investments. The most popular index is based on the rate of return on a one- year Treasury bill (also called T-bill).</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Margin</b>, or the additional amount the lender adds to the index to establish the adjusted interest rate on an ARM. The margin is usually 1.5 percent to 2.5 percent. </span></font></li>\r\n                  </ul>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to the four basic components, an ARM usually contains certain consumer safeguards such as interest rate caps, which limit the amount that the interest rate applied to the payments may move. This prevents the amount of interest the consumer pays from rising higher than perhaps the homeowner can afford. For instance, a typical ARM would have a two percentage point cap over the life of the loan. That means that a loan with an initial interest rate of 9.75 percent would be able to go no higher than 14.75 percent over the life of the loan, and it would be able to move no more than two percentage points per year.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another safeguard found on some ARMs are monthly payment caps that limit the amount homeowners need to increase their payments at adjustment time. Monthly payment caps can, however, sometimes prevent the monthly payments from increasing enough to keep up with the rise in the interest rate, causing negative amortization-resulting in higher or more payments for the homeowner later on.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Other options you should ask about when shopping for an ARM are:</span></font></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Assumability</b>, or whether you may transfer the mortgage to a new homebuyer, usually with the same terms if the new homebuyer qualifies for the loan. ARMs are almost always assumable.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertibility</b> allows the borrower to change an ARM to a fixed-rate mortgage, usually at the end of some predetermined period, locking in a lower interest rate.</span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A relative newcomer in the mortgage market is a <b>Reverse Annuity Mortgage (RAM).</b> For older Americans, especially retirees living on fixed incomes, the equity in their paid-for or almost-paid-for home represents a large but liquid asset. The RAM i s designed to help supplement those homeowners'' income.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender who will issue a RAM appraises the property and makes the loan based on a percentage of its current value. The homeowner retains ownership, and the property secures the loan. The lender then pays an annuity to the borrower, usually on a monthly basis, up to an amount equal to the equity they have in the home.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of such a loan for older Americans is that of receiving a monthly tax-free income. Under one plan, this income is available for life or until the house is sold at the homeowner moves. The schedule of payments depends on the value of the home and the ages of the owners. There are risks involved, however. If the homeowner wants to move and buy a new house, there may not be enough equity in the home to permit such  a plan. Or the lender may consider only the current market value of the home rather than any future appreciation when deciding on the monthly payments.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Federal Housing Administration (FHA) and the Veterans Administration (VA) offer a wide range of mortgage choices that may appeal to you. These include 30 and 15 year fixed- rate mortgages, as well as ARMs. Insured by these government agencies, the loans feature low or no down payment terms and are often assumable by future purchasers. VA loans are restricted to individuals qualified by military service or other entitlements, but FHA - insured loans are open to all qualified home purchasers. Note that there are limits to handle moderate-priced homes anywhere in the country. Talk to your lender about FHA/VA possibilities.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">This type of financing became popular when interest rates went to very high levels in the early 1980s. Seller-assisted creative financing usually means the seller of the home helps with the financing by underwriting all or part of the loan.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of this type of arrangement is that the mortgage usually carries a lower interest rate with lower monthly payments. The disadvantage is that the previous homeowner, not an institution, may hold the deed of trust. If the loan terms call for certain payment schedules, the buyer may have to seek new financing. Many homebuyers in recent years have found "creative financing" deals to be fraught with problems and useful only as short-term alternatives to mortgages from traditional lenders.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One type of mortgage you are apt to run into with seller financing is the balloon payment mortgage. <b>Balloons</b>, as they are known, are usually offered as short-term fixed-rate loans. The balloon payment mortgage gets its name from the payment schedule, which involves smaller payments for a certain period of time and one large payment for the entire amount of the outstanding principal. They have terms of 3, 5, and sometimes 15 years, though payments are usually calculated as though it were a 30 year loan. Sometimes a balloon will be offered as a second mortgage where you also assume the homeowner''s first mortgage . The major disadvantage with a balloon payment loan is that it may be difficult to save up the money to make the final large payment (often the entire amount of the principal) while paying interest on the loan. Some lenders guarantee refinancing, though the interest rate is usually adjusted when the principal comes due. If you cannot refinance, you may have to the property if you cannot meet the large payment. Balloons are an advantage if you plan on living in an appreciating house for a short period of time and want to pay less while you live there.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are several ways. First, talk with your real estate agent or broker. Real estate professionals are normally in the best position to learn about financing opportunities in the marketplace. Lenders regularly call agents to alert them to financing packages. And, of course, agents are highly motivated to obtain financing for their buyers. Without a suitable loan, the sale can''t proceed, and agents won''t get their sales commission on the house.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Second, look for rate surveys published by your local newspaper. Many American papers now include brief tables on interest rates and mortgage availability in their real estate or business section. They can help guide you to sources you have not thought about.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Third, look in the Yellow Pages under "Mortgages," and shop for quotes by telephone. Call five to 10 different lenders for rates and terms on fixed and adjustable loans.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Finally, if your area is covered by one of the many commercial <b>computerized mortgage shopping services</b>, give it a try. You may find, however, that the computer services have only a selection of local lenders on their listings.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One important method is by bearing in mind that mortgage packages consist of more than interest rates. They consist of a quoted rate, plus discount points (pre-paid interest assessed by the lender at settlement, or the meeting when the property legally changes hands) and other fees, plus a full range of terms including adjustable versus fixed-rates, low down payment versus high down payment, the presence or absence of prepayment penalties, and many other features noted earlier in this brochure.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One way to evaluate rates, however, is by examining the <b>Annual Percentage Rate (APR)</b>. The APR can help you compare different types of mortgages. It indicates the &quot;effective rate of interest&quot; paid per year. The figure includes discount points and other charges and spreads them out over the life of the loan. While the APR provides you with a common point for comparison, look at the whole product before deciding which mortgage to get. Pick the one with the rate, payment schedule and other terms t hat suit your situation best.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <blockquote> \r\n                    <dl> \r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Acceleration Clause</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you miss a monthly payment, an acceleration clause allows the lender to speed up the rate at which your loan comes due or even to demand immediate payment of the entire outstanding balance of the loan.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Assumability</span></font></b></font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Assuming a mortgage is simply taking the loan over from the holder (seller) and becoming liable for the repayment.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Buydown</span></font></b></font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The buydown mortgage is one where the seller and/or the home builder subsidizes the mortgage by lowering the interest rate during the first few years of the loan. While the lower initial payment and interest rate make this kind of loan easier to qualify, the payments may increase when the subsidy expires.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Closing Costs/Settlement Costs/Escrow</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Closing costs ate the costs associated with settlement, the meeting where the buyer and seller (or their agents) sit down to fill out the papers and make the exchanges that allow the property to legally change hands. Closing costs include appraisal fees, title search and insurance, survey, tax adjustments, deed recording fees, credit report and points, among others.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Due-on Sale Clause</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">A clause or provision in a mortgage or deed of trust that allows the lender to demand immediate payment of the balance of the mortgage at the time of sale.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Negative Amortization</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This occurs when your monthly payments are not large enough to pay all the interest due on the loan. This unpaid interest is added to unpaid balance of the loan. The danger of negative amortization is that the homebuyer could end up owing more than the original amount of the loan.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Private Mortgage Insurance</span></font></b> </font></span></dt>\r\n                      <dd><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment-as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are usually required to carry private mortgage insurance. </span> </font></span> \r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance will require additional premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 house with a 10 percent down payment, this would mean an initial premium payment of $338 to $675 and an extra $15 to $20 a month. </span></font></p>\r\n                      </dd>\r\n                    </dl>\r\n                  </blockquote>\r\n                  <p> \r\n                  <table class="bodytext" cellspacing="0" cellpadding="4" bgcolor="#CCCC99" align="center" border="0">\r\n                    <center>\r\n                      <tr bgcolor="#FFCFCE"> \r\n                        <td width="102" align="left" valign="top"><div align="left" class="bodytext">Comparison on a</font></div></td>\r\n                        <td align=left class="bodytext" width="50" valign="top">30 Year</font></td>\r\n                        <td align=left class="bodytext" width="64" valign="top">15-Year</font></td>\r\n                        <td align=left class="bodytext" width="65" valign="top">Bi-Weekly</font></td>\r\n                        <td align=left class="bodytext" width="69" valign="top">ARM</font></td>\r\n                      </tr>\r\n                      <tr bgcolor="#FFCFCE" > \r\n                        <td width="102" height="12" align="left" valign="top"><div align="left" class="bodytext">$75,000 Mortgage</font></div></td>\r\n                        <td align=left width="50" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                        <td align=left width="64" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                        <td align=left width="65" height="12" class="bodytext" valign="top">Mortgage </font></td>\r\n                        <td align=left width="69" height="12" class="bodytext" valign="top"><span class="lighttabletext">at 7.5%</span></font></td>\r\n                      </tr>\r\n                      <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="16%" class="bodytext" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">w/5% cap*</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Monthly Payment</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$806</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658(329 X 2)</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$524</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,481</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,398</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,434</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$5,602</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,336</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,606</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,061</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,188</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage Balance</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,583</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,726</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,476</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,309</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$73,052</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$64,372</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$69,817</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,400</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost/Life</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$161,942</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$70,062</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$104,331</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$132,566</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left width="102" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Difference from</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $91,880</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $57,611</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $29,376</font></td>\r\n                            </tr>\r\n                    </center>\r\n                  </table>\r\n                  <p align="left"></p>\r\n                  <div align="left" class="bodytext"> \r\n                    <blockquote><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">* The interest on the ARM used in this example increased 2 percent in the second year (payment = $629), and decreased 1 percent in the third year (payment = $577 for Years 3 through 30). This is a hypothetical situation. Not all ARMs will behave in this manner; some will increase (or decrease) more slowly, some more rapidly. In each case, the monthly payments, interest costs, and the amount you save will differ. For more information about tailoring an ARM to fit your particular circumstances, talk to your lender.</span></font></blockquote>\r\n                    <p><span class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Back to Tools</font></a></span></p>                  </div>\r\n                  <h1 class="headers"></h1>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (43, 45, 1, 'A Consumer''s Guide To Mortgage Lock-Ins', '                          When you''re looking for a mortgage, you''re likely to shop among lenders for the most favorable interest rate, and the lowest points and other up-front charges. When you find the most favorable terms and the lender that you want, you''ll apply to that lender. But when you get to settlement, will you actually receive the terms you applied or bargained for? Or will you find that the rate has changed - and that your costs have gone up? Lock-ins on rates and points might offer you a way to ensure that what you shop for is what you get. This page explains what these arrangements mean. </span></font></span></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#aboutlocks">All About Rate Lock-Ins</font></a></span></font></span></span></span></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#whatisalock">What Is A Rate Lock-in? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#inwriting">Will Your Lock-In Be In Writing? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#charged">Will You Be Charged For A Lock-In? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#options">Setting The Mortgage Term</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#valid">How Long Are Lock-Ins Valid? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#expires">When The Lock-In Period Expires </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#speedup">Speeding Up The Loan Approval</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#askabout">Ask About Lock-Ins</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#complaints">Complaints About Lock-Ins</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#stateagencies">State Agencies</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#federalagencies">Federal Agencies</a></span></font></span></span></font></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="aboutlocks" class="headers"><font color="#BD827B" size="4" class="headers"><span class="headers"><b>All About Rate Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">In most cases, the terms you are quoted when you shop among lenders only represent the terms available to borrowers settling their loan agreement at the time of the quote. The quoted terms may not be the terms available to you at settlement weeks or even months later; therefore, you could not rely on the terms quoted to you when shopping for a loan useless a lender is willing to offer a lock-in.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="whatisalock" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>What Is A Rate Lock-in? </b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">A lock-in, also called a rate-lock or rate commitemnt, is a lender''s promise to hold a certain interest rate and points for you, usually for a specified period of time, while your loan application is processed. (Points are additional charges imposed by the lender that are usually pre-paid by the consumer at settlement but can sometimes be financed by adding them to the mortgage amount. One point equals 1 percent of the loan amount.) Depending upon the lender, you may be able to lock in the interest rate and n umber of points that you will be charged when you file your application, during processing of the loan, when the loan is approved, or later. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">A lock-in that is given when you apply for a loan may be useful because it''s likely to take your lender several weeks or longer to prepare, document, and evaluate your loan application. During that time, the cost of your mortgage may change. But if your interest rate and points are locked in, you should be protected against increases while your application is processed. This protection could affect whether you can afford the mortgage. However, a locked-in rate could also prevent you from taking advantage of price decreases, unless your lender is willing to lock in a lower rate that becomes available during this period. It is important to recognize that a lock-in is not the same as a loan commitemnt, although some loan commitemnts may contain a lock-in. A loan commitemnt is the lender''s promise to make you a loan in a specific amount at some future time. Generally, you will receive the lender''s commitemnt only after your loan application has been approved. This commitemnt usually will state the loan terms that have been approved (including loan amount), how long the commitemnt is valid, and the lender''s conditions for making the loan such as receipt of a satisfactory title insurance policy protecting the lender.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="inwriting" class="headers"><font color="#BD827B"><span class="headers"><font size="4"><span class="headers"><b>Will Your Lock-In Be In Writing? </b></span></font></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Some lenders have pre-printed forms that set out the exact terms of the lock-in agreement. Others may only make an oral lock-in on the telephone or at the time of application. Oral agreements can be very difficult to prove in the event of a dispute. Some lenders'' lock-in forms may contain crucial information that is difficult to understand or that is in fine print. For example, some lock-in agreements may become void through some unrelated action such as a change in the maximum rate for Veterans Administration-guaranteed loans. Thus, it is wise to obtain a blank copy of a lender''s lock-in form to read carefully before you apply for a loan. If possible, show the lock-in form to a lawyer or real estate professional. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">It is wise to obtain written, rather than verbal, lock-in agreements to make sure that you fully understand how your lender''s lock-ins and loan commitemnts work and to have a tangible record of your arrangements with the lender. This record may be useful in the event of a dispute.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="charged" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Will You Be Charged For A Lock-In? </b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Lenders may charge you a fee for locking in the rate of interest and number of points for your mortgage. Some lenders may charge you a fee up-front, and may not refund it if you withdraw your application, if your credit is denied, or if you do not close the loan. Others might charge the fee at settlement. The fee might be a flat fee, a percentage of the mortgage amount, or a fraction of a percentage point added to the rate you lock-in. The amount of the fee and how it is charged will vary among lenders and may depend on the length of the lock-in period.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="options" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>What Options Are Available For Setting The Mortgage Term? \r\n                          </b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Lenders may offer options in establishing the interest rate and points that you will be charged, such as: </span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Locked-in interest rate/locked-in points</b><br>Under this option, the lender lets you lock in both the interest rate and points quoted to you. This option may be considered to be a true lock-in because your mortgage terms should not increase above the interest rate and points that you''ve agreed upon even if market conditions change.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Locked-in interest rate/floating points</b><br>Under this option, the lender lets you lock in the interest rate, while permitting or requiring the points to rise and fall (float) with changes in market conditions. If market interest rates drop during the lock- in period, the points may also fall. If they rise, the points may increase. Even if you float your points, your lender may allow you to lock in the points at some time before settlement at whatever level is then current. (For instance, say you''ve locked in a 10.5 percent interest rate, but not the 3 points that went with that rate. A month later, the market interest rate remains the same, but the points the lender charges for that rate have dropped to 2.5. With your lender''s agreement, you could then lock in the lower 2.5 points.) If you float your points and market interest rates increase by the time of settlement, the lender may charge a greater number of points for a loan at the rate you''ve locked in. In this case, the benefit you might have has by locking in your rate may be lost because you''ll have to pay more in up-front costs.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Floating interest rate/floating points</b><br>Under this option, the lender lets you lock in the interest rate and the points at some time after application but before settlement. If you think that rates will remain level or even go down, you may want to wait on locking in a particular rate and points. If rates go up, you should expect to be charged the higher rate. Because practices vary, you may want to ask your lender whether there are other options available to you.</span></font></span></span></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="valid" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>How Long Are Lock-Ins Valid? </b></span></font></a></font></span></span></h3>\r\n \r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Usually the lender will promise to hold a certain interest rate and number of points for a given number of days, and to get these terms you must settle on the loan within that time period. Lock-ins of 30-60 days are common. But some lenders may offer a lock-in for only a short period of time (for example, seven days after your loan is approved) while some others might offer longer lock-ins (up to 120 days). Lenders that charge a lock-in fee may charge a higher fee for the longer lock-in period. Usually, the longer the period, the greater the fee.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="expires" class="headers"><font color="#BD827B" size="4" class="headers"><b>What Happens If The Lock-In Period Expires?</b> </font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">If you don''t settle within the lock-in period, you might lose the interest rate and the number of points you had locked-in. This could happen if there are delays in processing whether they are caused by you, others involved in the settlement process, or the lender. For example, your loan approval could be delayed if the lender has to wait for any documents from you or from others such as employers, appraisers, termite inspectors, builders, and individuals selling the home. On occasion, lenders are themselves the cause of processing delays, particularly when loan demand is heavy. This sometimes happens when interest rates fall suddenly. If your lock-in expires, most lenders will offer the loan based on the higher of the prevailing interest rate and points, or your locked in rate. If market conditions have caused interest rates to rise, most lenders will charge you more for your loan. One reason why some lenders may be unable to offer the lock-in rate after the period expires is that they can no longer sell the loan to investors at the lock-in rate. (When lenders lock in loan terms for borrowers, they often have an agreement with investors to buy these loans based on the lock-in terms. That agreement may expire around the same time that the lock-in expires and the lender may be unable to afford to offer the same terms if market rates have increased.) Lenders who intend to keep the loans they make may have more flexibility in those cases where settlement is not reached before the lock-in expires.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="speedup" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>How Can You Speed Up The Approval Of The Loan</b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">While the lender has the greatest role in how fast your loan application is processed, there are certain things you can do to speed up its approval. Try to find out what documentation the lender will require from you. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Much of the information required by your lender can be brought with you when you apply for a loan. This may help to get your application moving more quickly through the process. When you first meet with your lender, be sure to bring the following documents. </span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The purchase contract for the house (if you don''t have the contract, check with your real estate agent or the seller).</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Your bank account numbers, the address of your bank branch and your latest bank statement, plus pay stubs , W-2 forms, or other proof of employment and salary, to help the lender check your finances.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you are self-employed, balance sheets, tax returns for two to three previous years, and other information about your business.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Information about debts, including loan and credit card account numbers and the names and addresses of your creditors.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Evidence of your mortgage or rental payments, such as cancelled checks.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Certificate of Eligibility from the Veterans Administration if you want a VA-guaranteed loan. Your lender may be able to help you obtain this. </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Be sure to respond promptly to your lender''s request for information while your loan is being processed. It is also a good idea to call the lender and real estate agent from time to time. By calling occasionally, you can check on the status of your application, and offer to help contact others such as employers who may need to provide documents and other information for your loan. It is also helpful to keep notes on your contacts with the lender so that you will have a record of your conversations.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="askabout" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Ask About Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">When you''re ready to settle on your loan, you''ll want to get the loan terms that you''ve locked in. To increase that likelihood, it is important to learn as much as you can about what the lender is promising you before you apply for a loan. Ask for the following information when shopping for a loan: </font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4"><span class="headers">Lock-Ins and Fees</span></font> </font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Does the lender offer a lock-in of the interest rate and points?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">When will the lender let you lock in the interest rate and points? When you apply? When the loan is approved?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Will the lock-in be in writing? If the lock-in is not in writing, you will have no record of the lender''s agreement with you in case of a dispute.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">How long will the lock-in last (30, 60, 90, 120 or more days)?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Does the lender charge a fee to lock-in your interest rate? Does the fee increase for longer lock-in periods? If so, how much?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you have locked in a rate, and the lender''s rate drops, can you lock-in at the lower rate? Does the lender charge you an additional fee to lock in the lower rate?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Can you float your interest rate and points for now, and lock them in later? </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Loan Processing Time</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">How long does the lender expect to take to process your loan?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">What has been the lender''s average time for processing loans recently?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Has the lender''s loan volume increased? Heavy volume might increase the lender''s average processing time. </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Expiration of Lock-ins</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">What rate will be charged if the lock-in expires before settlement-the rate in effect when the lock-in expires?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you don''t settle within the lock-in period, will the lender refund some or all of your application or lock-in fees if you decide to cancel the loan application?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If your lock-in expires and you want to get another lock-in at the rate in effect at the time of the expiration will the lender charge an additional fee for the second lock-in?</span></font></span></span></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="complaints" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Complaints About Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Knowing what to look for puts you in a better position to decide whether, when, and how long to lock-in mortgage terms and, by helping to keep the loan process moving, you can lessen the chance that your lock-in will run out before settlement. But what i f your lock-in does lapse? If you believe that the lapse was due to delays caused by the lender or someone else involved in the loan process, you should try first to reach a mutually satisfactory agreement with the lender, if that effort fails, consider writing to the appropriate state or federal regulatory agency. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Some lender actions, such as offering lock-in terms which are impossible to fulfill, failing to process you loan diligently, or causing your lock-in to expire are improper and may even be illegal. In addition, because you may have contractual rights under your lock-in or loan commitemnt, you may want to consult with an attorney. Be aware, though, that complaints may not be resolved as quickly as may be necessary for a home purchase. Depending upon their authority under applicable state or federal law, regulatory agencies may either attempt to help you resolve your complaint directly or record your complaint and recommend other action.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="stateagencies" class="headers"><font color="#BD827B"><span class="headers"><font size="4"><span class="headers"><b>State Agencies</b></span></font></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">State consumer protection officers, banking authorities, and offices of the attorney general can be contacted regarding complaints against many lenders doing business in the state. (Some states have enacted legislation to specifically address complaints about mortgage lock-ins.)</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="federalagencies" class="headers"><font color="#BD827B" size="4" class="headers"><b>Federal Agencies</b></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">In addition, some lenders are directly supervised by federal regulatory agencies, as shown in the list that follows: \r\n                          </font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Mortgage Companies</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="browntext">Division of Credit Practices<br>Bureau of Consumer Protection<br>Federal Trade Commission<br>601 Pennsylvania Avenue, N.W. <br>Washington, D.C. 20580<br>(202) 326-3224</span></span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federally Insured Savings and Loan Institutions an Federally Chartered Savings Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Community Investment<br>Federal Home Loan Bank Board<br>1700 G Street, N.W. <br>Washington, D.C. 20552<br>(202) 377-6000</span></font></span></span></li>\r\n                        </ul>\r\n                        <p>&nbsp;</p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">State Member Banks of the Federal Reserve System</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Division of Consumer and Community Affairs<br>Board of Governors of the Federal Reserve System<br>20th and Constitution Avenue, N.W. <br>Washington, D.C. 20551<br>(202) 452-3946</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">National Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Consumer Activities Division<br>Office of the Comptroller of the Currency<br>490 L''Enfant Plaza, S.W. <br>Washington, D.C. 20219<br>(202) 447-1600</font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federally Insured Non-Member State-Chartered Banks and Savings Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Consumer Programs<br>Federal Deposit Insurance Corporation<br>550 Seventeenth Street, N.W. <br>Washington, D.C. 20429<br>(800) 424-5488<br>(202) 898-3536</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federal Credit Unions</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Credit Union Administration<br>1776 G Street, N.W. <br>Washington, D.C. 20456<br>(202) 357-1065</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The Federal Reserve Board and the Federal Home Loan Bank Board have prepared this information on mortgage lock-ins in response to a request from the House Committee on Banking, Finance and Urban Affairs and in consultation with many other agencies and trade and consumer groups. It is designed to help consumers understand an important aspect of home financing. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">We believe a fully informed consumer is in the best position to make a sound financial choice. This page will provide useful basic information about obtaining the terms of credit you really want. It cannot provide all the answers you will need, but we believe it is a good starting point. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The information presented on this page was prepared in consultation with the following organizations:</span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">American Bankers Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">American Institute of Real Estate Appraisers</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Comptroller of the Currency</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Consumer Federation of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Credit Union National Association, Inc. </span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Deposit Insurance Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Home Loan Mortgage Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal National Mortgage Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal National Mortgage Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Reserve Board''s Consumer Advisory Council</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Trade Commission</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Independent Bankers Association of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Bankers Association of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Insurance Companies of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Federal Credit Unions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Home Builders</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Realtors</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Council of Savings Institutions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Credit Union Administration</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Special Adviser to the President for Consumer Affairs</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Society of Real Estate Appraisers</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The Consumer Bankers Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">U.S. Department of Housing and Urban Development</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">U.S. League of Savings Institutions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Veterans Administration</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext"><font size="2">Back to Tools</font></span></font></a></font></span></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (44, 46, 1, 'PMI''s Lowering Your Down Payment', '                  <h3 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers">How To Buy the Home You Want</font></h3>\r\n                  <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2" class="bodytext">Mortgage insurance (MI) allows you to choose from a wider price range of homes. How? Lenders are generally willing to accept a lower down payment than the standard 20% if the lender obtains mortgage insurance on your loan through a mortgage insurance company. \r\n                    </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You can not only get the home you deserve, but you can conserve your savings and increase your income tax deductions, just by putting less money down. </span></font></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Buy More Home</font></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">You can afford more home and maximize your investment if your lender obtains MI for your loan.</font></span></p>\r\n                  <table border="0" width="89%"  cellspacing="0" cellpadding="2">\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font size="2"></font></td>\r\n                      <td width="19%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"> \r\n                        Without MI </span></font></td>\r\n                      <td width="18%" colspan="2" class="headln"> \r\n                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"> \r\n                          With MI</span> </font></div>\r\n                      </td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Down Payment</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">20%</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">10%</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">5%</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Your Available Savings </span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Maximum Home Price </span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$50,000</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$200,000</span></font></td>\r\n                    </tr>\r\n                  </table><br>\r\n                  <span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bighead"><span class="bodytext">Financing a home with a low down payment loan may be the best way to afford a home in high-priced markets.</span></span></font></span></font></span> \r\n                  <h3 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers">Conserve Your Savings</font></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lower the down payment, the more you retain for home furnishings, other investments, future emergencies, or even college tuition</font></span></p>\r\n                  <table border="0" width="89%" cellspacing="0" cellpadding="2">\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif"></font></td>\r\n                      <td width="23%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"> \r\n                        Without MI</span></font></td>\r\n                      <td class="headln" colspan="2"> \r\n                        <div align="center"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"> \r\n                          With MI</span></font></div>\r\n                      </td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Home Price</span></font></td>\r\n                      <td width="23%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="19%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Down Payment </span></font></td>\r\n                      <td width="23%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">20%</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">10%</span></font></td>\r\n                      <td width="19%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">5%</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Cash Down Payment </span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$5,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Savings</span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="18%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Savings Retained</span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$0</span></font></td>\r\n                      <td width="18%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$15,000</span></font></td>\r\n                    </tr>\r\n                  </table>\r\n                  <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Even if you have less than $20,000 saved, you can still afford to buy a $100,000 home with a lower down payment option if your lender obtains MI on your qualified loan from a mortgage insurance company.</font></span></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Increase Your Tax Write-off</font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">A larger loan amount will have higher interest payments and could result in higher tax deductions. </span></font></span></font></span></p>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage interest is one of the few remaining consumer debt items that you can deduct.</span></font></span></font></span></p>\r\n                  <p class="browntext"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Back to Tools</span></span></font></a> </p>\r\n                  <p>&nbsp;</p>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (45, 47, 1, 'If Your Mortgage Loan Application Is Rejected', '                  The joys and anticipation of owning a new home are sometimes crushed when the application for mortgage financing is turned down by the lender. If your loan request has been denied, you should understand why the loan was denied and what steps you can take to correct the problem or make sure that it does not happen again in the future. The following information helps you understand the most common reasons for loan denials and corrective measures you can take, and it describes some alternatives that exist especially for low and moderate income home buyers. </span> \r\n                  </font> <br><br><br>\r\n                  <font class="maintext_bold">Possible Causes For Rejection And Your Alternatives</font>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Appraised Value Too Low</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One of the factors considered by the lender is the ratio of the loan amount to the sale price or the appraised value of the property, whichever is lower. If the appraisal on the property is substantially lower than the purchase price, the loan-to-value ratio, or LTV, may be higher than the lender will, or can legally, approve. If you have applied for a maximum loan amount, 90 to 95 percent of the purchase price a low appraisal may make your requested loan too large. Your alternatives in this situation will depend upon the reasons for the low valuation. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the purchase price is simply higher than the prevailing prices being paid in the general area, you can try to renegotiate the price with the seller down to a level more in line with the market and one which the lender would accept in order to approve your loan. If this is not possible, your only other solution is probably accepting a lower loan amount, assuming you have sufficient funds to cover the additional down payment. </span> </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Inadequate Funds</font></b></font></p>\r\n                  <blockquote> \r\n                    <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Based on the financial information and the Verification of Deposit, the lender may have determined that you do not have enough cash to make a down payment and cover closing costs. Usually, these funds may not come from borrowing, but a gift from a relative can be used as long as no repayment of the money is expected. Other solutions include getting the seller to take back a second mortgage which would reduce the down payment requirement (assuming you can still qualify with the additional loan payments), or getting the seller to pay some of the closing costs, such as the origination fees. Finally, you could correct this problem by simply waiting, providing you institute a savings program in the meanwhile. \r\n                      </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Insufficient Income</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In assessing your ability to repay the requested loan, lenders look at the amount of your monthly income in relation to your proposed mortgage payments and to all of your monthly debt and installment loan payments. Generally speaking, your mortgage payment should not be more than 28 percent of your monthly gross income, and your total debt, including mortgage payments and other installment payments, should not be more then 36 percent. The percentages are slightly higher for FHA loans. These ratios are only guidelines, but if yours are substantially higher, say 35 percent and 42 percent, they are well beyond industry norms and can cause denial of the loan. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Sometimes, particularly if your credit card record is very good, if you can show that you are already carrying that much housing expense through rent or mortgage payments, you may be able to convince the lender to reconsider. This is an example of why full and accurate disclosure on the loan application works in your favor, even though it may not be obvious at the time. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If your personal circumstances have changed since the submission of the loan application let the lender know. An impending salary increase or bonus or new employment, for you or your co-borrower, may improve the financial picture presented on the application. These changes, of course, will need to be documented and verified before the lender will reconsider the loan request. </span></font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Too Many Debts</font></b></font></p>\r\n                  <blockquote> \r\n                    <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In some cases, it is not only the amount of debt owed by an  applicant that prevents qualifying for the loan. Extensive use of numerous credit cards and revolving accounts with evidence of increasing account balances that are close to the card issuers'' debt limits may be enough to kill the application. The primary solution to this problem is to pay off some of the accounts to bring down outstanding obligations, as well as the number of creditors. </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Unsatisfactory Credit History</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="browntext"><span class="bodytext">Nothing can be more damaging to your loan request than a history of poor debt repayment practices. If the credit report shows frequent late charges, past due accounts, judgments or bankruptcy, chances for approval of the loan are slim. Lenders may stretch their guidelines on debt ratios or income requirements, but have little tolerance for a bad credit record. Even low loan-to-value ratios and debt ratios cannot offset an unsatisfactory credit history. </span></span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="browntext">If your loan is turned down because of a poor credit report, you may request a free copy of the report from the credit report company, which will be identified in a notice from the lender. Examine the credit report carefully to see if it is up to date and accurate. The credit bureau must correct any errors in the report. If there are unsettled disputes over certain accounts, it must also include your side of the argument in the report. Even if the name on the report seems to be you, make sure all of the accounts and references apply to you. Many people have the same name and improper recording of data occurs. </span></span></font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="browntext">If the adverse items on the report occurred because of illness, marital problems, job layoff or other temporary circumstances and were confined to a particular period of time, you should have provided the lender with a written explanation at the time the loan application was taken or at some other point in the process. If you didn''t do it then, do it now. Assuming there has been sufficient time since the problems occurred for you to regain financial stability and demonstrate prompt payment of your obligations, there is a good chance the lender will reconsider the loan request. Many lenders look for one year''s clean payment record to offset past credit problems. If the credit report is accurate and you have a questionable credit history, you need to start repaying outstanding balances on time in order to re-establish an acceptable record. It may take time, but there is no alternative when this problem stands between you and owning a home.</span></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Alternatives For Low And Moderate Income Homebuyers</font></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Many lenders participate in housing programs designed for low and moderate income home buyers who would not qualify for home loans under standard lending requirements. These programs are sponsored by both governmental and private organizations. If you have a good credit history, or have not established a credit history at all, they may provide a source of financing for your home purchase. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Primary sources of special, low income housing programs include state and local housing finance agencies, non-profit housing assistance groups, the Department and Housing and Urban Development (HUD) and secondary mortgage market operations such as the Federal National Mortgage Association (<b>Fannie Mae</b>) and the Federal Home Loan Mortgage Corporation (<b>Freddie Mac</b>). Your lender should be able to tell you how to contact local offices of organizations which work directly with borrowers or you can usually find them in the phone book in the blue government listings under <b>Housing</b>. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Assistance for low and moderate income home buyers is not only based on direct subsidies but also on relaxation of standard loan approval requirements. For instance, many low income families spend a greater percentage of their income groups. If you can show that you have consistently handled such higher payments and have a good credit record, the lender might approve the loan based on higher debt ratios. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some potential home buyers have trouble getting a loan approved because they have not established a credit record. There is nothing adverse on the credit report but there is no record of prompt repayment of loans or charge accounts. If this is your situation, you may be able to qualify based on what is called a "non-traditional credit history." Using this approach the lender will depend on utility companies, past and present landlords and other sources which can verify that you have met a regular payment obligation in a timely, consistent manner. If you think such an approach might help you and the lender has not mentioned it, suggest it to the lender.</span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">A Rejection Is Not Your Last Chance</font></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The fact that a lender has rejected your loan application does not mean that you are denied home ownership forever. As has been discussed earlier, there are positive steps you can take to correct the problem. Some problems may be resolved very quickly while others may take longer, but you can turn around most problem situations. Take the time to determine exactly why your loan request was denied and then take steps to eliminate the cause of rejection. </span></font></p>\r\n                  <p align="left"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Return to Tools</font></a></font></p>\r\n                  <h1 class="headers"></h1>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (46, 48, 1, 'Cloasing Your Mortgage Loan', '                  Once your application for a mortgage loan has been approved and you have received a commitment letter from the lender, the final step before you can call the house your own is the closing, or settlement, of the purchase transaction and mortgage loan. Even though you have signed purchase agreement and your loan request has been approved, you have no rights to the property, including access, until the legal title to the property is transferred to you and loan is closed. You should have a good understanding of what is involved in the closing process, because there are a number of things that you can do to make sure that it goes smoothly and on time. </font></span></font></span> \r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At closing, you will sign the mortgage loan documents, the seller will execute the deed to the property, funds will be collected and disbursed and the closing agent will record the necessary instruments to give you legal ownership of the property. Settle meant of a mortgage loan is a legal process, so specific procedures and requirements will vary according to state and local laws, but a general description of closing practices can help you through the process.</span></font></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Between Commitment and Closing</b></font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">As soon as you receive firm approval from the lender who is making your mortgage loan, you should confirm the actual date of loan closing. An estimated closing date was probably specified in the sale contract, but a firm date needs to be set by you, the seller of the property and your lender. You want to make sure that settlement will take place before your loan commitment expires and before any rate lock agreement (guaranteed terms of the loan) expires. The settlement date also has to allow adequate time to assemble all of the required documentation. If repairs or maintenance on the property are a part of the lender''s commitment, there must be time to complete them. The real estate agents involved in the sale transaction and the lender are often the best people to coordinate the closing arrangements. Most lenders require at last 3 to 5 days advance notice of the closing date in order to prepare the loan documents and get them to the closing agent. </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are standard documents and exhibits that are commonly required for a loan closing, regardless of jurisdiction. Some of these will be your responsibility and others will be the responsibility of the seller. The following documents are typically required for closing.</span></font></span></font></p>\r\n                  <ul>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headln"><span class="headln"><span class="headers">Title Insurance Policy</span></span></span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Every lender will require title insurance. The company issuing the title insurance policy will have researched legal records to make sure that you are receiving clear title, or ownership, to the property. Their title search has established that the seller of the property is the legal owner, and that there are no claims, or liens, against the property. The title company offers both a lender''s policy and an owner''s policy. You will have to pay for a lender''s policy and it is advisable for you to have an owner''s policy as well. For a small additional premium, it will protect you up to the full value of the property if fraud, a lien or faulty title is discovered after closing. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Homeowner''s Insurance</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lender will require you to have homeowners insurance on the property at least in the amount of the replacement cost of the property. You should make sure the policy covers the value of the property and contents in the event they are destroyed by fire or storm. You must pay for the policy and have it at closing. You are free to select the insurance carrier, but the lender will require the company to meet rating standards and be rated by a recognized insurance rating agency. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Termite Inspection and Certification</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In many areas of the country, the property must be inspected for termites and the inspection is required in the purchase contract. In some parts of the country, this may be called a "wood infestation" report. The report is required on all FHA and VA loans as well as many conventional loans. \r\n                      </font></span> </li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Survey or Plot Plan</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender may require a survey of the property, showing the property boundaries, the location of the improvements, any easements for utilities or street right-of-way and any encroachments on the boundaries by fences or buildings. Encroachments can be minor, such as a fence, or may be serious and have to be corrected before closing. In some areas, an addendum to the title policy eliminates the need for a survey. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Water and Sewer Certification</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the property is not served by public water and sewer facilities, you will need local government certification of the private water source and sanitary sewer facility. Properties with well and septic water sources are usually governed by county codes and standards. </font><font size="1" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"> \r\n                      </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Flood Insurance</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the lender or the appraiser determines that the property is located within a defined flood plain, you will want, and the lender will require, a flood insurance policy. The policy must remain in force for the life of the loan. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><span class="headers">Certificate of Occupancy or Building Code Compliance Letter</span></span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If your home is new construction, you will have to have a Certificate of Occupancy, usually from the city or county, before you can close the loan and move in. The builder will obtain the certificate from the appropriate authority. Many local governments require an inspection when a home is sold to see if the property conforms to local building codes. Code violations may require repairs or replacement of structural or mechanical elements. The responsibility for ordering the inspection and paying for any required repairs should be spelled out in the purchase contract.</font> </span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Other Documentation</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Additional documentation required for closing will be set out in the commitment letter from the lender and will depend upon terms of the sale, peculiarities of the property and local ordinances and custom. Examples would include private road maintenance agreements if the street in front of your property is not maintained by a municipality or proof of sale of your previous home if that was a condition of approval of your loan. </font></span></li>\r\n                  </ul>\r\n                  <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Within 24 hours prior to the actual closing, your and your real estate agent should make a final inspection of the property to make sure any required repairs have been completed, all property described in the sale contract, such as kitchen appliances, carpeting and draperies are present and that no recent fire or storm damage has occurred. In most cases, the lender will make a similar inspection before closing.</font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Loan Closing</b></font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The actual loan closing procedure, including who conducts the closing and who is present, depends upon local law and custom and lender practices. Some states require that you be represented by an attorney, others do not. Even if it is not required by law, you may want to have an attorney, review the closing documents. </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some lenders will close the loan in their offices, some will use title or escrow companies and some will send their instructions and documents to their attorney or yours to conduct the closing. As soon as you receive your commitment letter from the lender, you should determine who is responsible for closing arrangements. \r\n                    </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The actual closing is conducted by a closing agent who may be an employee of the lender or the title company, or it may be an attorney representing you or the lender. The lender and seller, or their representatives, and the real estate agents may or may not be at the actual closing. It is not unusual for the parties to the transaction to complete their roles without ever meeting face to face. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The closing agent will have received instructions from the lender on how the loan is to be documented and the funds disbursed, and will have collected all of the necessary exhibits from you, the seller and the lender. The closing agent will make sure that all necessary papers are signed and recorded and  that funds are properly disbursed and accounted for when the closing is completed. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You typically need to come to the closing with a certified check for the closing costs, including the balance of the down payment. You can get the exact figure a day or two prior to the closing from lender or the closing agent. You should also bring the homeowners insurance policy and proof of payment if it has not been delivered earlier. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">For the most part, your role at closing is to review and sign the numerous documents associated with a mortgage loan. The closing agent should explain the nature and purpose of each one and give you and/or your attorney an opportunity to check them before signing. A brief description of the major documents may help you understand their purpose and significance.</span></font></span></font></p>\r\n                  <dl> \r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Settlement Statement - HUD-1 For</b></font></strong></dt>\r\n                    <dd><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">This form is required by Federal law and is prepared by the closing agent. It provides the details of the sale transaction including the sale price, amount of financing, loan fees and charges, proration of real estate taxes, amounts due to and from buyer and seller and funds due to third parties such as the selling real estate agent. It must be signed by both buyer and seller and becomes a part of the lender''s permanent loan file.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some of your charges on the HUD-1 may have already been paid, such as credit report and appraisal fees. They will be noted as P.O.C. (paid outside the closing). You will usually be charged interest on the loan from the date of settlement until the first day of the next month and your first payment will be due on the first day of the month and your first will be due on the first of the following month. Make sure you know exactly when your first and subsequent payments are due and what the penalties are for being late.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If your loan is greater than 80 percent of the value of the property, you will probably have to pay for mortgage insurance that protects the lender in case you default. One year''s premium will usually run between .5 percent to .75 percent of the loan amount.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to your monthly payments on the loan, most lenders will require you to maintain an "escrow", or "impound,"account for real estate taxes and insurance. Current law permits a lender to collect 1/6th (2 months) of the estimated annual real estate taxes and insurance payments at closing. Additionally, real estate taxes for the current year will be pro-rated between you and the seller and paid at closing. After closing, you will remit 1/12 of the annual amount with each monthly payment. Tax and insurance bills should be sent to the lender who will pay them out of the escrow funds collected.</span></font></span></font></span></dd>\r\n                  </dl>\r\n                  <dl> \r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Truth-in-Lending Statement</b></font></strong></dt>\r\n                    <dd class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">This form is also required by Federal law. You were given an initial TIL shortly after you completed the loan application. If no changes have taken place since that time, the lender need not provide one at closing. If, however there are significant charges, you must receive a corrected TIL no later than settlement.</font></span></span></font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>The Mortgage Note</b></font></strong></dt>\r\n                    <dd class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The mortgage note is legal evidence of your indebtedness and your formal promise to repay the debt. It sets out the amount and terms of the loan and also recites the penalties and steps the lender can take if you fail your payments on time.</font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><font color="#BD827B"><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Mortgage or Deed of Trust</b></font></strong></font></dt>\r\n                    <dd class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This is the "security instrument" which gives the lender a claim against your house if you fail to live up to the terms of the mortgage note. It recites the legal rights and obligations of both you and the lender and gives the lender the right to take the property by foreclosure if you default on the loan. The mortgage or deed of trust will be recorded, providing public notice of the lender''s claim (lien) on the property.</font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Miscellaneous Documents</b></font></strong></dt>\r\n                    <dd><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">There will be a number of documents or affidavits that you will be asked to sign at closing. Some are lender requirements (e.g. a statement that you intend to occupy the properties your primary residence), or are required by state or Federal law. These instruments should not be taken lightly. Some provide for criminal penalties for false information, and some may give the lender the right to call your loan, which means the entire loan amount becomes immediately due and payable. When everything has been signed and the closing agent is satisfied that all of the instructions for closing have been complied with in full, you become the owner and are given the keys to the property. </font></span></font></span></dd>\r\n                  </dl>\r\n                  <p><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n                  <h1 class="headers"></h1>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (47, 49, 1, 'Transferring A Loan Between Lenders', '<h3 class="headers"><font color="#BD827B" size="3" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Does Transfer of Servicing Mean?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">When you take out a mortgage with a mortgage company or a bank, there is always a possibility that the lender \r\nwill <b>sell</b> or <b>transfer</b> the servicing of your loan to another institution. <b>Servicing</b> means \r\nthe collection of payments and management of operational procedures related to mortgages. When servicing is sold, \r\nit means that another lender will be taking your payments, handling your escrow accounts, paying your insurance \r\nand taxes and answering your questions. This may happen right after you close the loan or several years later. \r\n                          </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The practice of <b>selling</b> or <b>transferring</b> the servicing of your loan is legal and is very common in \r\nthe mortgage industry. When the servicing is sold, it is usually packaged in a bundle with other loans. Some \r\nmortgage companies only originate loans and sell or transfer the servicing immediately. It is more cost-effective \r\nfor these companies to do this because servicing is not a part of their business. It is not uncommon to \r\nget your mortgage from a neighborhood lender and have it transferred to an institution in another state. It \r\nis also possible for your mortgage servicing to be transferred more than once during the life of your loan.</span></font></span></font></p>\r\n                        <blockquote> \r\n                          <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><b class="bodytext">Whether or not your servicing is sold has nothing to do with the quality of your loan or your payment history. \r\nIt has, in fact, nothing whatever to do with you personally.</b></font></span></font></p>\r\n                        </blockquote>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Does It Affect Your Loan?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The company that holds your loan makes the decision to transfer servicing to another institution. The company does not \r\nhave to ask your permission to transfer the servicing, but it does have to inform you of the transfer. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The transfer of servicing should not affect you or your mortgage adversely. The original terms and conditions \r\nof your mortgage will stay the same. Your interest rate and duration of your loan will not change on fixed rate \r\nloans. Your payment should stay the same or on the same schedule except in cases where changes in taxes or insurance \r\nrequirements increase or decrease the escrow amount. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have an adjustable rate mortgage (ARM), the original conditions of the mortgage contract stay in effect and \r\nthe rate will change according to the adjustment periods (i.e. every six months, annually, every three years, \r\netc). This information is contained in your contract, but you are welcome to verify the information with your \r\nnew servicer. If your original lender agreed to let you refinance to a fixed-rate mortgage within a certain \r\ntime-frame, you should ask whether this agreement would be honored by the new lender.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>When Will You Be Notified?</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">if available), the new servicer''s address, and instructions for making your next payment.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>An Important Consumer Safeguard</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is very important that you receive both letters. If you receive only a letter from the new servicer, be \r\nsure to call your original servicer to verify that your loan actually has been transferred. It is extremely \r\nimportant that you keep your servicer informed of your current mailing address, so that you will receive all relevant correspondence.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Where Do You Pay Your Next Payment?</font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">If you have received both letters or have verified the transfer of your mortgage with your old servicer, be \r\nsure to send all payments from that point on to your new servicer. If you send the payment to the old servicer, \r\nyou run the risk of the payment not getting to the correct lender in time, paying a late charge or of having the \r\npayment being lost. It is your responsibility to send the payment to the new servicer once you are informed of the transfer. </font></span></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The <b>welcome</b> letter from your new servicer will often inform you if you will be receiving new payment coupons. \r\nBut if your payment is due before the coupons arrive, write your loan number on the check and send it to the \r\naddress provided in the welcome letter. If you have coupons from your previous servicer, you may include this with your payment. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will want to read the <b>welcome</b> letter carefully \r\nfor payment instructions. Your payment date will not change, since it is determined in your original mortgage \r\ndocuments. If your mortgage is paid through electronic funds transfer or automatic draft each month, you will \r\nneed to cancel that arrangement and fill out new forms for the payment to be sent to the servicer. Since this \r\noften takes time, you may need to send a check yourself for a payment until your electronic funds transfer is \r\nchanged over. This is something that you will need to take care of. The new servicer cannot take the payment \r\nfrom your savings or checking account without your signature.\r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you accidentally send your payment to your old servicer, the company will usually forward the first payment to \r\nnew servicer, but they will not continue to do this. By not sending your payment to the correct office, you \r\nrisk your payment being lost. There are some cases where the old servicer no longer exists due to a merger or \r\ntake over. In that case, the payment may be returned to you by the postal service after several weeks, which \r\nmay cause a late charge to be assessed to your account. \r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">It is always best to follow the payment instructions received in the <b>welcome</b> letter or ask your new servicer \r\nabout alternate payment locations.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Happens To Your Escrow Account?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is your old servicer''s responsibility to inform the insurance company and your tax authority of the change \r\nin servicer. A follow-up call from you the insurance company or tax authority can help ensure that the tax \r\nor insurance bill is not sent to the wrong servicer. You should be able to find their number on your original \r\ninsurance documents. When you call the insurance company or tax authority, make sure they have your current address \r\nand phone number in case they need to contact you. </font></span></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">If your escrow account is interest-bearing, all interest due should be credited to your account by the old servicer \r\nbefore the transfer takes place. Your old servicer is responsible for handling these items prior to the transfer. \r\n                          </span></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some time after your servicing is transferred, your new lender will make an analysis of your escrow. During the analysis, \r\nthe lender reviews your escrow amount and determines if it is adequate to cover the fees for your insurance, \r\ntaxes and any other premiums paid through escrow. If the amount is found to be insufficient, the lender may \r\nask you to increase your regular monthly payment. If it is your new servicer''s policy to review escrow accounts \r\nas soon as the servicing is transferred your payment may change immediately, you should receive an explanation regarding any changes.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What About Insurance Policies And Taxes?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">If you receive a notice that either your insurance or taxes are due, call your new servicer and make sure that company \r\nhas on file that funds have been escrowed for the premium. If the new company has not received a copy of that bill, \r\nit will probably direct you to send in the bill for payment. If you have a question after the transfer has \r\ntaken place, you should contact your new servicer, even if your old servicer was the one that collected the \r\nfunds for your insurance or tax payment. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some mortgage companies offer to escrow life or disability insurance (insurance that would pay off the mortgage \r\nin case of death , or make payments in case disability). In these policies, the lender who originally made your \r\nloan is named as the beneficiary. If you have these policies, your old servicer should inform you of what \r\neffect the transfer of servicing will have on this insurance coverage and what action you may need to take to maintain coverage. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On flood and hazard insurance, it is the responsibility of the old servicer to provide the insurance agent or \r\ncompany with a notice of transfer. The beneficiary may be able to be transferred from one company to the other, \r\nbut it is wise to make sure this occurs. You should make sure to transfer the beneficiary to ensure that, \r\nin case of a claim, the check is written and sent to appropriate servicer.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who Sends You Your End Of The Year Tax Statement?</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Make sure that you find out which lender will be reporting your interest paid for income tax purposes. Sometimes, \r\nboth lenders will report on the time that they had the loan. Quite often, the new lender will compile the information \r\nand send you one tax statement at the end of the year that covers the entire year. You should find out about \r\nthis at the time of the transfer so that you know if you should look for one statement or two at the end of the year.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Do You Have More Questions?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Usually your old servicer will make sure everything is taken care of prior to the transfer, but is in your best interest \r\nto check on all details. It is best to ask questions at the time of the transfer to make sure everything \r\nis handled before your old servicing company purges your records from its files. It is much more difficult \r\nto get information from an institution that has not handled your loan for the last six months. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have questions regarding you specific transfer, it is always best to contact your new servicer in writing. \r\nAt times of mortgage transfers, most companies are flooded with phone calls so you may get faster and clearer information through the mail.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Consumer Checklist</b></font></h3>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext">Always keep your servicer informed of any changes in your address and phone number. Provide this information \r\nin writing and forward it to the address indicated in your <b>welcome</b> letter. This address is usually \r\ndifferent from the one that you would send payments</span>.</span></font></span></font></span></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When your servicing is transferred, make sure you receive both a <b>goodbye</b> letter and a <b>welcome</b> \r\nletter. If you don''t receive both letters, call your old servicer to verify the transfer.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When you receive the letters, read them carefully making note of the new servicer''s name, address, phone number, \r\ncontact name and payment information.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When making your payments after your servicing has been transferred, follow the instructions in the <b>welcome</b>letter.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Make sure that your insurance companies (homeowners, flood/hazard, life/disability) and your tax authority have been notified of the transfer.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Find out which company will be reporting on your interest paid for income tax purposes.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Ask questions at the time of the transfer. If there is a problem, it is easier to handle it as soon as it \r\narises. If you have questions after the transfer is completed, contact your new servicer. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" class="bodytext">Back to Tools</font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (48, 50, 1, 'How To Save Half On Interest Costs', '                    Save $100,000 on mortgage interest costs! Sound impossible? Not really. An old-time mortgage that is once again proving popular allows homebuyers to so just that. It is the 15-year fixed-rate mortgage that lets homebuyers own their homes free and clear in 15 years. And, while the monthly payments are somewhat higher than a 30- year loan, the interest rate on the 15-year mortgage is usually a little lower, and importantly:</font></span></p>\r\n                  <ul>\r\n                    <li> \r\n                      <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><b>The homebuyer pays less than half the total interest cost of the traditional 30-year mortgage. The purpose of this page is to help prospective homebuyers explore the 15-year fixed-rate mortgage - a new option for saving on total mortgage interest costs.</b></span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who It''s For</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The 15-year fixed-rate mortgage has proved popular with two very different groups of homebuyers. First, it enables young homebuyers with sufficient income to meet the higher monthly payments to pay off the house before their children start college. They own more of their home faster with this kind of mortgage. Other homebuyers, who are more established in their careers, have higher incomes and whose desire is to own their homes before they retire, may also prefer this mortgage. The 15-year fixed-rate mortgage gives them additional financing options using the house''s equity. For example, they can easily take out a second mortgage if they want to make use of the equity in their home. But you need not fall into either category to appreciate the savings the 15-year fixed-rate mortgage affords homebuyers. Let''s take a closer look at some of the pros and cons of this type of mortgage and what savings you  may expect.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Advantages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">The 15-year fixed-rate mortgage offers the qualified consumer five big advantages.</font></span></font></span></p>\r\n                  <ol>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">You own your home in half the time it would take with a traditional mortgage.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"></span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">You save more than half the amount of interest of a 30-year mortgage. On a $75,000 mortgage at 9.5 percent, you save more than $95,000.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Lenders usually offer this mortgage at a slightly lower interest rate than with 30-year loans--typically 0.5 percent to 1.0 percent lower. It is this lower interest rate added to the shorter loan life that realizes the savings for 15-year fixed-rate borrowers.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><b>Fixed-rate</b>means exactly that - no matter where mortgage interest rates go, the payments for this mortgage stay the same from the first to the last. This helps many borrowers plan their budgets with more certainty. They know that their monthly payments will not increase (or decrease) and throw their financial planning off.</span></font></span></font></li>\r\n                  </ol>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" class="headers" face="Verdana, Arial, Helvetica, sans-serif"><b>Disadvantages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">The disadvantages associated with a 15-year rate mortgage are really the qualifiers that will tell consumers if this is the mortgage for them.</font></span></font></span></p>\r\n                  <ol>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">The monthly payments for this type of loan are higher than those for a 30-year mortgage, roughly 10 percent to 15 percent higher per month.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Because borrowers pay less total interest on the 15-year fixed-rate mortgage, they lose the maximum mortgage interest tax deduction.</span></font></span></font></li>\r\n                  </ol>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" class="headers" face="Verdana, Arial, Helvetica, sans-serif"><b>Compare Them Yourself</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">At right is a comparison of a $75,000 mortgage with terms of 15 and 30 years. We used a 15-year mortgage at a half percent lower rate, which is typical in today''s market. As you can see, the 15-year mortgage saves more than $95,000 over the traditional 30-year loan.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font class="headers"><b>Want To Know More?</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">For more information about 15-year fixed-rate mortgages, or to find out if you qualify, talk to your mortgage lender. He or she will be able to help you select the mortgage that is best for you.</font></span></font></span></p>\r\n                  <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"> \r\n                    30-year at 15-year at 10 percent 9.5 percent Monthly Payment (Principal and Interest) $ 658 $ 738 First Year Interest Cost 7,481 7,023 Mortgage Balance 74,583 72,625 Fourth Year Interest Cost 7,336 6,244 Mortgage Balance 73,052 63,991 Total Interest Cost Over the Life of the Loan $ 161,942 $ 65,970 Difference From 30-year Total - $ 95,972 </span> </font></span></font> \r\n                  <p></p>\r\n                  <p><span class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (49, 51, 1, 'When Your Debt Exceeds Your Home Value', '                  <ul>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>What is a short pay off?</font></b> </span></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Imagine your home is worth $200,000, but you owe $220,000 on it. If you were to sell it in the open market at $200,000, you might net $184,000, or $36,000 less than what you need to pay off the loan. A short pay off is where your lender will forgive a portion or all of the short amount.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">What lender would just write off that type of money?</font></span></span></font></b> \r\n                      <br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Just about all of them will, with justification. Justification might mean a substantial loss of income that would prevent you from paying on the mortgage, therefore being forced in a position to sell the home. Attempting to sell short so you can upgrade to a larger property is not justification. In addition, lack of cash reserves will also serve as justification. Don''t expect to place your home on the market at 75% of market value and expect your lender to jump on any offers.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><font size="3"><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif"><span class="headln"><span class="headers">How will this affect my credit?</span></span></span></font></b></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Depending on how you negotiate the transaction, it could go on your credit report as, "settled," or, "paid,"or "short payoff". It depends on the lender and how well you can negotiate.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Are some lenders harder to deal with than others? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Yes. If you have a Freddie Mac loan, Freddie Mac will probably want you to contribute to the short sale, get your agent to reduce brokerage fees, and get the buyer to take the property with the termites. Some lenders will just ignore you.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">What will my lender require from me in order to consider participating in a short sale? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext"><br>\r\n                      </span></font></span></font></span> \r\n                      <ol>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your past 2 years tax returns </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Letter of hardship </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Complete loan application </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Preliminary title report </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Listing contract </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Copy of MLS </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A marketing plan for your home </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A broker price opinion (like an appraisal). </span></font></span></font></span></li>\r\n                      </ol>\r\n                      <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When you have an offer, all of the above should be enclosed with the offer (except for the marketing plan) plus the purchase agreement, and a good faith estimate as to what the lender will net after the close of escrow. </span></font></span></font></span></p>\r\n                    </li>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Why should I list with an agent? It seems if I can save the brokerage fee that the lender would net more and be more inclined to accept any offers that come in. </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">You are correct. If you''re loan is current, you may be able to get a qualified buyer yourself. If your loan is delinquent, or in default, you don''t have time to play around getting your home sold. You need as much exposure as possible.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><span class="headln"><span class="headers">What happens if my lender say''s "No," and I''m in foreclosure?</span></font></span></span></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">This is one situation where "No," means, "Maybe, you just haven''t convinced me that participating in a short sale is to my benefit." Keep hammering your lender, and do not take your home off the market until your lender agrees to a sales price and the prospective buyer has formal loan approval.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Should I try to hide any assets in order for the lender to consider participating? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Most assets are traceable, except for personal collections (guns, coins, etc.). If you own another property, it will show up on your credit report. Your lender may back track to your original loan application to see if there are any other assets. No, don''t hide assets. If your lender discovers you''re not dealing honestly, they''ll never co-operate. </font></span></li>\r\n    </ul><ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Can any real estate agent or attorney handle a short sale?</span></font></span></font> \r\n                      </b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">A lot will say they can. There''s no real way to tell if they can. If your home goes into foreclosure, you''ll get flooded with a ton of mail. There''s a good bet that most of the mail is from people who have helped out previously in these situations. One way to tell is if the person you''re dealing with will ask you for the information outlined <a class="mainlink" href="#above">above</a>. They''ll know these are the requirements.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Question: I believe that in California, the loan is secured by the property, so the bank cannot go after your assets to make you pay the remaining balance of the loan. The bank will try and guilt you into doing so, ignore them. If they refused, threaten to foreclose and be ready for the bank to do so. At that point, they will usually negotiate. I''m sure this info won''t be added to the real estate criter''s FAQ.</span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Actually, this is a good example of a misnomer in the foreclosure arena so this &quot;real estate criter&quot; is going to add it to the FAQ. There are no deficiency rights in California for <b>Purchase Money Loans</b>. This is the loan you obtained in order to purchase the property. Once you refinance the property, take out an equity line of credit, obtain a consumer loan that is secured by the property, this rule no longer applies. The lender has the right to go after you in a deficiency judgement, even if a senior lien holder takes the property back and a junior loses his security instrument.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">How can I assure a non-purchase money lender won''t go after me after the short sale? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">When any lender agrees to a short pay, they are relinquishing their right to pursue the borrower in the future</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Are there any tax ramifications? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Yes. According to IRS Section 108 a-e, there are debt/income interpretations that may come into play. The IRS may view the deficiency on a non-purchase money loan as income and demand you to pay taxes on that amount. If the short pay transaction resulted in a net loss of $20,000 to the lender, your tax liability could be around $6,350.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">So why would I want to do a short sale only to owe the IRS money? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font size="2"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">To limit your tax liability. In some cases (not Citicorp, Fannie Mae, or Freddie Mac) the senior lien holder will allow for some funds to be allocated to the juniors. If you allow the property to go into foreclosure, and the juniors lose 100% of their money, you can get taxed on the full amount. You should really contact a CPA concerning this part of the Tax Code.</font></font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><font size="3" class="headln" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B"><span class="headers">I have an FHA loan. They won''t do a short pay. Any suggestions? \r\n                      </span></span></font></b></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Any feedback from other states would be appreciated. There are certain regions where FHA will not participate in short sales. One region is the state of California. If you are in foreclosure on an FHA loan in California, you may want to approach HUD to see if they will consider a lower interest rate, or some type of repayment schedule until you get back on your feet. </span></font></span></li>\r\n                  </ul>\r\n                  <p><a class="mainlink" href="tools.php" class="bodytext"><span class="bighead"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Back to Tools</span></font></span></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (50, 52, 1, 'What Happens After You Apply For A Mortgage?', '                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Scientists who study and measure human behavior find that buying a home is one of the most stressful experiences of our lives. Contributing significantly to this anxiety is waiting for the mortgage to be approved. Much of the homebuyers'' unease results from not knowing what is going on. You know credit checks and verifications of employment are taking place-but what makes the difference between getting or not getting that loan, and how long does it take? This page can dispel at least some of that anxiety by detailing the steps the lender takes in making the loan decision-process called "underwriting." Listed below are the topics addressed on this page.</font></span></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#goodrisk">Are You a Good Risk?</font></a></span></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#initialinterview">The Initial Interview</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#safeguards">Consumer Safeguards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#sufficientincome">Is Your Income Sufficient?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#incomerequired">Income Requirements</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#income/expense">Income/Expense Standards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#debt">Debt</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#goodcredit">Is Your Credit Good?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#creditinfo">Credit Information Safeguards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#downpay">Can You Make The Down Payment?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#worthprice">Is The House Worth The Price?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#doigetloan">Do I Get The Loan?</a></span></font></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="goodrisk" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Are You a Good Risk?</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"><span class="bodytext">Just as wise stock market investors carefully research the companies in which they plan to buy stock, careful mortgage lenders investigate the financial background of each loan applicant. In lending the prospective homebuyer the money to buy the home, the lender assumes a long-term risk. The assumption is that the borrower is going to eventually repay the loan and in the meantime make the loan payments on time. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Once all the information is collected and eligibility is established, the lender decides whether to extend the homebuyer credit. In other words, lenders analyze the risk of lending (making the investment), and match it to an appropriate interest rate and loan term. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are no established, industry-wide standards for underwriting, though most lenders follow standards set by government-related agencies, private mortgage insurers, private mortgage investors or institutional investors. The vast majority of mortgage lenders attempt to approve a loan application if at all prudently possible, but to approve a loan that will become delinquent serves no one''s best interest. The burden falls on the lender to establish that an applicant is qualified.</span></font><font size="2"><span class="bodytext"></span></font></span></p>\r\n                        <h3><a class="mainlink" name="initialinterview" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>The Initial Interview</b></font></a></h3>\r\n                        <p><span class="bodytext"><span class="story"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">The process usually begins with an interview where the prospective borrowers and a representative of the lender sit down to discuss the potential loan. Increasingly, however, lenders are not requiring a face-to-face meeting and accept a completed application by mail. Many lenders today will even qualify you for a loan before you begin to shop for a home. Many lenders advertise this service in the local newspaper, but any lender can provide it. Knowing approximately how much money you are qualified to borrow can save you time and prevent disappointment when you are looking at houses. </font></span></span></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">When going to see a lender for an initial interview, you should take:</span></span></font></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Purchase contract for the house if you have one.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Certificate of Eligibility from the Veterans Administration (VA) if you want a VA loan. (Note: If you do not have one, the lender will obtain the information for you from your service records.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Bank account numbers and the address of your bank branch. This will save the lender time in checking your credit.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Credit card bills for the past several billing periods.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Pay stubs, W2 forms or other proof of employment and salary.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">If you are self-employed, you should be able to present balance sheets, tax returns and other information about your business. </span></span></font></li>\r\n                        </ul>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">The important document that gets the whole process rolling is the loan application. It asks in-depth questions concerning you, your income, assets and liabilities, your credit, and your legal history, as well as a description of the property you wish to buy. The lender will verify the information you provide on the application before making the decision whether to extend the loan. </span></span></font></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Applicants usually will know after the initial interview if they are qualified for the type and size of loan they want. Lenders try to let the borrower know as quickly as possible if they really are not qualified for the size of loan that they request.</span></span></font></p>\r\n                        <h3><a class="mainlink" name="safeguards" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Consumer Safeguards</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The initial interview sets in motion some important consumer safeguards. The Truth-in-Lending disclosure requirements provide the applicant with an estimated yearly cost for the loan - the <b>Annual Percentage Rate (APR)</b>. The other important disclosure that follows from the <b>Real Estate Settlement Procedures Act (RESPA)</b>, a federal law. This requires lenders to provide homebuyers with information on known and estimated closing costs. \r\n                          </span></font></span></font></span></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext">The initial interview also starts a clock that will allow applicants to know whether or not they have been approved in about 30 to 60 days from the submission of a completed application. If the loan is denied, the lender must disclose the specific reason (s) for the rejection.</span></span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="sufficientincome" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Is Your Income Sufficient?</b></font></a></h3>\r\n                        <p class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2">Following the initial interview, or loan application, the first step the lender takes is to verify your employment or income. This is done by mailing employment and income forms to current and past employers, and it will help the lender determine how much debt you can successfully take on.</font></p>\r\n                        <h3><a class="mainlink" name="incomerequired" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Income Requirements</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2">A general rule is that you can qualify for a loan of up to twice the family''s income (i.e. a family with income of $30,000 a year usually can qualify for a mortgage of up to $60,000). Often, the amount you earn may not be as important as how you earn it. Bonuses and commissions can vary greatly from year to year, and lenders are reluctant to depend on them if they make up a large percentage of your income. There are similar problems when a large portion of your salary is based on overtime pay, and you rely on it to qualify for the loan. In the case of bonuses and commissions, the lender will want to verify your bonus and commission status back two or three years to get a better idea of what you earn from those sources on average. In the case of overtime, the lender will establish whether the work is expected to continue and whether or not the amount of overtime income is reasonable for the extra work. After establishing these points, the mortgage lender will make a decision as to how much to allow for these additional sources of income.</font> </span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you are self-employed, you should plan on producing a balance sheet, profit and loss statements and copies of your federal income tax returns for the past two or three years. Tax returns may also be required to verify other income claims, such as when income from securities is a major source for mortgage payments.</font></span></font></p>\r\n<h3><a class="mainlink" name="income/expense" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Income/Expense Standards</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2"><span class="bodytext">Your lender will work out these figures for you when you sit down to discuss the mortgage you want. </span></font></span></p>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext"><span class="bodytext"><span class="bodytext">Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For Federal Housing Administration (FHA) loans, this figure is not to exceed 29 percent of the homebuyer''s gross monthly income. With loans guaranteed by the Department of Veteran''s Affairs (VA), lenders measure prospective homebuyers with <b>Residual Income</b>, or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower. </span></span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"></span></font></span></span></font></span></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="headers"><b>FHA Loans</b> </span> </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">Housing Expenses = 29% gross monthly income</span></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">Housing Expenses plus Long-Term Debt = 41% gross monthly income</span></span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="debt" class="headers"><font color="#BD827B"><span class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Debt</b></span></font></span></font></a></h3>\r\n                        <p class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. FHA-insured mortgage lenders define long-term debt as monthly expenses extending 12 months or more into the future, and look for these expenses plus housing expenses not to exceed 41 percent of the homeowner''s gross monthly income.</font></p>\r\n                        <h3><span class="headers"><a class="mainlink" name="goodcredit"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Is Your Credit Good?</b></span></font></a></span></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Before extending credit, lenders will want to examine the risk of not getting the money back. To do this lenders will look at four crucial aspects of your credit history when you apply for a mortgage:</font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><b><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">History of past credit</span></span></span></font></b><span class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"> \r\n                             - what were the size and terms of past loans?</font></span></span></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext"><span class="bodytext">Type of Credit</span></span></b><span class="bodytext"><span class="bodytext"> \r\n                             - have you obtained real estate, auto, personal or other installment loans in the past?</span></span></span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">Lapses in employment or debt repayment</span></b><span class="bodytext">\r\n                           - are active accounts current , and is there any recent bankruptcy or judgment?</span></span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b></b>\r\n                           - how many unexplained lapses are there, and for how long? </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">From the information uncovered by these four questions, lenders can develop a fair idea of just how you will handle your responsibilities once you have signed the contract for repaying the loan. However, lenders cannot examine everything when putting together a credit history. They have two extremely important limitations on credit information gathering.</font></span></font></p>\r\n                        <h3><a class="mainlink" name="creditinfo" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Credit Information Safeguards</b></span></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">The first limitation is the Fair Credit Reporting Act, which was designed to ensure fair and accurate consumer credit reporting. The Fair Credit Reporting Act stipulates that lenders must certify the purpose for which the information is sought and use it for no other purpose. The Act also prohibits reports based on subjective information from neighbors and others concerning character, general reputation and other personal aspects. Certain other credit information, such as bankruptcy more than seven years before, is also prohibited unless the principal involved in the action was $50,000 or more. </font></span></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">The second consumer safeguard limiting the credit information lenders can use to make a mortgage decision is the Equal Credit Opportunity Act (<b>ECOA</b>). ECOA prohibits discrimination in lending based on race, color, national origin, sex, marital status, age (provided the applicant may legally contract), and the fact that all or part of the applicant''s income comes from a public assistance program. </font> </span></font></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">Lender''s are also prohibited by law from asking:</font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">questions concerning the applicant''s spouse, unless</span></b> \r\n                            </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the spouse will be contractually liable, </font></span></font></li>\r\n                              <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">the spouse''s income will be used to qualify, </span></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the applicants live in a community property state, or </font></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the applicant will use child support, alimony or separate maintenance payments from a spouse or former spouse to qualify. </font></span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">questions concerning future parenting plans.</span></b></span></font><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"> \r\n                            (although the lender may ask the ages and current number of children the applicant has)</font></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="downpay" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Can You Make The Down Payment?</b></font></a></h3>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext"><span class="bodytext">Lenders expect homebuyers to have enough money available to make the down payment of between 10 and 20 percent of the asking price for the house-though FHA and VA loans require smaller down payment (0 to 5 percent) and to pay their share of the closing costs (3 percent to 6 percent of the loan amount). If, however, you cannot come up with a 20 percent down payment, a lender can make you a loan for as little as 5 percent down. He will, however, require you to carry private mortgage insurance for conventional (not FHA or VA loans), for which you will pay a premium for the first year and an additional monthly fee in subsequent years.</font></span></p> \r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Sources on which prospective homebuyers may draw for the down payment and the closing costs include savings, stocks/bonds, Individual Retirement Accounts (IRAs), pension funds, real state holdings, life insurance policies, mutual funds or employee savings plans. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Homebuyers may also rely on another source of funding for the down payment-a gift, or money given by a parent or other relative that need not be repaid. a person may give another person up to $10,000 per year without either party being taxed. A married couple, therefore, could give a child or spouse as much as $40,000 for a down payment tax-free. Remember, however, that if you use gift money for a down payment, you will need to present a letter so stating and signed by both the giver(s) and the receiver( s) to your lender. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage lenders send a form to the homebuyer''s savings institution(s) to verify the amount available for purchasing the house, as well as the amount of outstanding loans with that institution.</font></span></font></p>\r\n                        <h3><a class="mainlink" name="worthprice" class="headers" target="#BD827B"><font color="#BD827B"><span class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Is The House Worth The Price?</b></span></font></span></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Mortgage lenders also examine the real estate being purchased to make sure that, in case of foreclosure, the lender has a salable property. The property''s acceptability is established by an independent appraisal. </font> \r\n                          </span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The appraiser looks not only at what the home is worth today, but how the neighborhood''s dynamics will affect the property value in the future. The three main points the appraiser checks are:</font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><b><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Physical security of the property.</span></font></b> </span> \r\n                            </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">age, structural soundness, landscaping, etc. </span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b class="bodytext">Location.</b> \r\n                            </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">The kind of neighborhood, surrounding houses, access to transportation, commercial development nearby, etc</span>. </span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Local government''s plans for the area.</b> </span></font></span></font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">how zoning and taxes will affect the property in the years to come.</span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="doigetloan" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Do I Get The Loan?</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender has made all the checks. Your income, credit, assets, property and all necessary documentation have been scrutinized. Now comes the big decision. </font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the lender''s decision is to extend the credit, you will be notified, usually through a commitment letter. The mortgage lender can approve the homebuyer for the entire amount asked for, or a lesser amount based on the borrower''s qualifications. The commitment terms relating to interest rate and/or discount points may be firm at the time of commitment or conditioned on the market rate at the time of closing. If the decision is not to extend the credit, the lender has 30 days from the acceptance of the completed application to notify the prospective homebuyer. This notification must also include the reason(s) for the rejection. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the loan is eligible for government insurance or guaranty, written agreements stating so are issued. These can be either an FHA or Firm Commitment or VA Certificate of Commitment. Conventional loans (not FHA or VA) receive an application for private mortgage insurance if the down payment is less than 20 percent of the purchase price. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">By now you should feel a bit more at ease about what happens after you apply for a mortgage. If you have a good credit rating, it will speak for itself. Also, it is up to the lender to prevent homebuyers from over-extending themselves to the point of losing their homes. Prudent underwriters should prevent this from occurring. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Certainly there will always be some anxiety associated with applying for a mortgage, but if you understand the process, waiting for approval will be far less worrisome.</font></span></font></p>\r\n                        <p><a class="mainlink" href="tools.php"class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (51, 53, 1, 'How Much Can You Qualifi For - Self Test', '                          Imagine you have just completed a search that included hundreds of hours of looking at the exteriors and interiors of houses. You have sized up siding, reviewed roofing and perused the petunias. And finally, you have found the house of your dreams. Now imagine that this house of your dreams costs much more than you can afford. </font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you are house hunting and have not done an important piece of homework, you could be in for this kind of heartbreak. The first thing you need to know when shopping for a home is how much you can spend. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A general rule is that you can purchase a house valued at twice your annual income, but this does not take into account your debts, a large down payment, or other factors which can add to or detract from the amount you can afford. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The purpose of this page is to help give you a more specific idea of what priced house you can afford. It will address what you are worth and what you owe on a regular basis (your assets and liabilities) and what costs you would most likely encounter once you bought your new house. In general, you will be examining the same things a lender looks at when deciding how large a mortgage you can afford. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Completing the worksheet inside this brochure should save time while shopping for a home because it will narrow your choices based on costs. When you finally do talk with lenders, you will have some answers for many of their questions, speeding up your loan''s processing. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">It should be noted, however, that today many lenders will qualify you in advance for a mortgage, even before you begin to shop for a home. Many lenders advertise this service in the local newspaper, but contact any lender to see if this is possible.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Down Payment</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Private Mortgage Insurance</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment - as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are required to carry <b>Private Mortgage Insurance</b>. Private mortgage will require an initial premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 mortgage with a 10 percent down payment, this would mean a premium of $338 to $675 for the first year and an extra $15 to $20 a month in subsequent years</font><font size="2">.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are Your Assets?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The first thing you have to examine when deciding how much you can spend on your new home is how much you are worth, taking into account your income, savings, investments and other holdings such as Individual Retirement Accounts (IRAs) or Keogh plans, the cash value of your life insurance, pensions or corporate savings plans, and equity in real estate. Lenders will need this information before deciding to extend you the loan. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Often, the amount you earn may not be as important as how you earn it. Bonuses and commissions can vary greatly from year to year, and lenders are reluctant to depend on them if they make up a large part of your income. There are similar problems when a large portion of your salary is based on overtime pay, and you rely on it to qualify for the loan. To get a realistic view of what your income level actually is, average your income (including bonuses, commissions and overtime) for the past two or three years. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">As a last resort, pensions and corporate thrift plans can provide another source of down payment money. Most plans or policies give you the option of either withdrawing your money with no repayment or borrowing against the cash value. Though it is not the best policy for most homebuyers to borrow from these sources in addition to borrowing mortgage money, they can often get rates substantially lower than those on many other kinds of loans. Remember - if you borrow against the cash value of your life insurance or employee thrift plan, you will be making principal and interest payments for these separate from your mortgage. You should estimate these payments under installment loans on the worksheet inside. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">While turning your savings, investments and other holdings into cash (making them "liquid"), remember that you will probably have to pay tax on most of it. One source of tax-free money often overlooked is a gift, or money given by a parent or other relative that need not be repaid. A person may give another person up to $10,000 per year without either party being taxed. Your parents, for example, could give you and your spouse up to $40,000 tax free.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Liabilities</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Your liabilities are those expenses for which you are responsible each month. These include outstanding loans, such as student, auto, personal and so on, as well as credit card balances. When calculating your liabilities, use the entire balance for your credit cards, as if you had to pay them off entirely this month. That way, you give yourself some breathing room should you run up an unusually high balance during your mortgage term. \r\n                          </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You should estimate these payments under liabilities on the worksheet.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Emergency Funds</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is always wise to put a little money away "for a rainy day" - especially when you are paying off a mortgage. If something arises such as unexpected medical costs or substantial auto repairs, you would want to be able to pay those expenses without jeopardizing your ability to meet your mortgage payments. Most financial experts suggest that you always have six months income on hand in case of emergency.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Annual Income</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">When calculating your annual income, remember to take into account all sources. You may, for example, get dividends from investments, alimony or child support payments. Calculate your annual income on the following page.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Annual Expenses</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This list should get you started, but you may have special expenses that are not listed here. Remember that when you buy your house you will no longer have to pay rent, and your utilities costs will change. You can use this money for your mortgage payments or other operating costs associated with your new home.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Costs of Homeownership</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Of the costs of homeownership, the ones listed on the next page are the most important. Homeowners insurance premiums usually run about $300 to $500 per year, and property taxes and maintenance costs will vary, of course, depending on the size, age and condition of your new house. Estimates for the costs of utilities, maintenance and improvements can be obtained from Realtors, local utility companies and others. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some homebuyers will also have an additional cost of homeownership if they are buying into a condominium or a co-op. Condo and co-op fees are additional amount usually paid monthly on top of the mortgage payments. Some homeowners will also incur a home owners association fee for their block or neighborhood. These fees vary greatly from location to location.</span></font></span></font></p>\r\n                        <p><a class="mainlink" href="tools.php" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (52, 54, 1, 'Why Mortgage Escrow Accounts?', '                          Mortgage escrow accounts have been in the news lately and seem to be greatly misunderstood by many consumers. The original idea behind mortgage escrow accounts was to protect the interests of homeowners and they have been serving that purpose for more than 50 years.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Why Mortgage Escrows?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage escrow accounts came into being more than 50 years ago. In the 1930''s, many Americans were losing their homes in foreclosures because of late tax payments. To help ease the burden on homeowners who had to come up with large, lump sum payments at tax time, lenders agreed to take on the responsibility by collecting smaller monthly sums from homeowners along with their mortgage payment. In 1934, the government mandated that lenders manage escrows on all FHA insured mortgages. This then became the standard practice for all mortgages.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage escrow accounts ensure that homeowners'' property taxes, fire and hazard insurance premiums, mortgage insurance premiums and other escrow items are paid in a timely fashion. They are a guarantee that there is always enough money to pay these bills when they are due so that the homeowner avoids the risk of lapsed insurance coverage or delinquent taxes.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who''s Protecting The Homeowner?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Escrowing is governed by the Real Estate Settlement Procedures Act of 1974 (<b>RESPA</b>), administered by the U.S. Department of Housing and Urban Development (<b>HUD</b>). Lenders must manage their escrow accounts in compliance with this federal law and with the interpretations set out by HUD. </span></font></span></font></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition, the 1990 Housing Bill recently signed into law by the President, requires lenders to issue itemized statements of escrow accounts to borrowers on an annual basis. While many lenders are already providing homeowners with regular statements of their escrow accounts, the new law should ensure that every lender follows this practice.</span></font></span></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who Should You Talk To?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Escrowing as practiced by the nation''s lenders protects both the borrower and the lender. Borrowers who have questions or concerns about their escrow accounts should talk to their lenders immediately. Consumers who know the purpose of escrows and are aware of the benefits they provide are the best insurance against misunderstandings between borrowers and lenders or misleading information from any source.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Escrows Do For Homebuyers</b></font></span></span></h3>\r\n                        <ol>\r\n                          <li><font size="4"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Guarantee that bills are paid on time.</span></font></span></span></font><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><br>\r\n                            <span class="bodytext"><font size="2" class="bodytext">The most obvious advantage of escrows is that they automatically budget the borrower''s tax and insurance responsibilities over the course of a year. Homeowners do not have to worry about coming up with several large, lump sum payments, each with different due dates, throughout the year. If there is ever a fire in the home, or if the basement floods causing damage, the homeowner is assured that the home is protected by up-to-date insurance</font>.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><font size="4" class="headers">Unexpected increases are taken care of</font></span><b><br>\r\n                            </b><span class="bodytext"><font size="2"><span class="bodytext">Because of escrows, homeowners also do not need to worry about calculating unexpected increases in their taxes or insurance premiums. It is the responsibility of the lender to allow for possible increases in these payments. \r\n                            </span></font></span> </font> </span> </span> \r\n                            <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Even when there are not enough funds in a mortgage escrow account to meet increased tax or insurance payments, the lender typically covers the bill without charging interest to the borrower. It is very common for lenders to pay taxes and insurance premiums when they are due even though all the money for these bills has not yet been collected from the homeowner. It is estimated that in 1989 alone, lenders advanced more than $600 million to homeowners who then avoided the penalties and risks of not paying their taxes and insurance on time.</span></font></span></span></font></span></p>\r\n                          </li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><font size="4"><span class="headers"><span class="headers">Mortgages have lower rates and down payments because of escrows.</span></span></font><br>\r\n                            <span class="bodytext"><font size="2" class="bodytext">Escrows protect the interests of investors in home mortgage loans. By making home mortgages more attractive and secure as investments, escrowing has led to a healthier mortgage market. As a result, loans with better terms and lower down payments are available to homebuyers.</font></span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><font size="4"><span class="headers">Local governments save money.</span></font><br>\r\n                            <span class="bodytext"><font size="2"><span class="bighead"><span class="bodytext">Escrow accounts also benefit local governments by providing a more efficient, less expensive means of tax collection. Rather than working with millions of homeowners, municipalities need only collect from a few hundred lenders.</span></span></font></span></font></span></span></li>\r\n                        </ol>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Does The Lender Come Up With My Payment?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The law is very specific in setting limits on the amount that the lender may collect. the lender may require a monthly payment of 1/12 of the total amount of estimated taxes, insurance premiums and other charges reasonably anticipated to be paid. Plus, the lender may collect an additional balance of not more than 1/6 of the estimated annual payments. If the lender determines there will be or is a deficiency in the escrow accounts, the law permits the lender to require additional monthly deposits to avoid or eliminate the deficiency.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Happens When My Loan Is Transferred?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">When the servicing of your loan transferred to another lender, the new lender takes on the responsibility of managing your escrow account. At that time, the new lender may examine your escrow account to make sure that the funds being collected are sufficient to cover all payments that are to be made. If the new lender feels that the amount collected must be adjusted, you will be notified of the change in your monthly payment.For more information, contact the Mortgage Bankers Association of America, Consumer Affairs Division, 1125 15th Street, N.W., Washington, D.C. 20005</span></font></span></span></span></font></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext" size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></span></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (53, 55, 1, 'Mortgage Insurance - Frequently Asked Questions', '                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="bodytext"><span class="headers"><span class="headers"><span class="headln"><span class="headers"><span class="bodytext"><span class="headers"><span class="bighead"><span class="bighead"><span class="bodytext"><span class="contactmenu"><span class="footer"><span class="headers"><span class="headln"><span class="headln"><span class="mainpage"><span class="menulinks"><span class="headln"><font color="#000000"><span class="headers">I have lived in my home for 5 years and am in the process of selling it. I had to buy PMI insurance because I did not have 20% down. Am I entitled to any type of refund once I sell the house?</span></font></span></font></span></font></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Entitlement to a refund and the amount would depend on the mortgage insurance plan type and the refundable or non-refundable/limited option chosen at origination. Your best bet is to ask your lender directly, as there are many different mortgage insurance plans and combinations. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B"><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers">I think banks are being very greedy in demanding a secured loan plus PMI and still wanting a perfect credit rating for 7 years. My husband and I are trying to buy a home. We have a good credit rating, but not perfect credit for 7 whole years. If you guarantee the loan, what is their problem in granting it?</span></font></span></span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage insurance does not guarantee the loan, it only insures a designated portion (commonly only 12-30%) of the loan against default. The combinations of loan characteristics (credit, collateral, MI, etc.) are established as requirements by investors. Loans usually end up in mortgage backed securities. The mortgage securities may be purchased by investors, for example to go into Individual Retirement Accounts (IRA''s), 401K plans, etc. The investment funds for IRAs, 401Ks, etc., have risk and return requirements which ultimately dictate the loan characteristics. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">If mortgage insurance is cancelled, are any pre-paid premium amounts refunded (particularly if they were originally paid by adding them to the loan amount)?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If all the mortgage insurance was financed at the time of origination and is canceled prior to it''s maturity you may be entitled to a refund if the refundable option was chosen at time of origination. However, if the no refund/limited option was chosen no refund is due. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">If a borrower currently has an FHA loan w/MI, after the LTV has reached 80% or less can the MI be cancelled?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is best to refer back your lender for specific information on FHA loans. PMI Mortgage Insurance Co. does not insure FHA loans and therefore can not respond regarding FHA policies.</font></span></p>\r\n                        <h3><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Can you give an example of how the mortgage insurance escrows get applied to the payment?</span></font></span></font></b> \r\n                          </font></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender collects monies on escrow and remits to PMI when the premium is due. Typically, on an annual premium plan, the lender collects 14 months premium at closing. Twelve months of the premium is paid to PMI as the initial premium. The remaining two months is used to start the escrow account. The lender then collects 1/12 of the renewal every month thereafter. It is hard to give a general rule on a monthly premium plan. The plan was developed in 1994 and lenders have developed unique escrowing procedures. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Premise: Mortgage insurance covers the lender for the difference between the loan amount and 80% value of the property. So for a borrower who puts 10% down, in effect mortgage insurance covers the 10% difference. What are approximate rates in premium say per $1000 dollars? Does credit history have a bearing on the premium? Can the borrower negotiate the premium?</font></span></font></b> </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI actually covers the lender for a percentage they designate. The percent of coverage is usually driven by the investor''s (often, Fannie Mae or Freddie Mac) requirements. Therefore, the approximate premium per $1000 varies based on the required coverage. The premium is fixed based on plan type (loan to value, loan type, loan term, etc.) and not related to individual borrower characteristics. Therefore, the premium is not negotiable. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Are mortgage lenders supposed to provide borrowers with information on the conditions when they can cancel mortgage insurance? Are these conditions supposed to be in the loan documentation? If the borrower pays mortgage insurance monthly, and his equity goes up, should his premiums go down? Is the mortgage lender supposed to notify the borrower when he reaches 20% equity? Which states have laws on this subject? Can the borrower choose the mortgage insurance company or does the lender do that?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Because of the wide variation in lender, investor and state requirements, it is necessary to consult your lender on these questions. Keep in mind when considering mortgage insurance issues that the lender is the insured, not the borrower. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="3" class="headers">Would mortgage insurance be of use to lenders to help approve loans for higher risk (i.e. self employed) individuals?</span></font></b> \r\n                          </font></span></font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI does insure loans made by lenders to self employed borrowers. However, it is unlikely that our coverage would have any effect on the lender''s ability to offer such loans. Generally, mortgage insurance is required due to low down payment and associated risk and not related to borrower credit characteristics or history. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Does mortgage insurance apply for investor properties?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI only insures loans on owner occupied residential properties (1 to 4 units).</font></span></p>\r\n                        <h3><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">What is private mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage insurance is a type of insurance that helps protect lenders against losses due to foreclosure. This protection is provided by private mortgage insurance companies, such as PMI Mortgage Insurance Co., and allows lenders to accept lower down payments than would normally be allowed. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage insurance also enables lenders to grant loans that would otherwise be considered too risky to be purchased by third party investors like the Federal National Mortgage Association (FNMA) and the Federal Home Loan Mortgage Corporation (FHLMC). The ability to sell loans to these investors is critical to maintaining mortgage market liquidity, which in turn, allows lenders to continue originating new loans. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Is private mortgage insurance different from other kinds of insurance associated with mortgages?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance protects the lender in the event of borrower default and subsequent foreclosure on the home. FHA and VA insurance also protect the lender against borrower default under a government program rather than through the private enterprise system.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Credit insurance, sometimes called mortgage insurance, is life insurance coverage that pays off the mortgage in the event a borrower dies, becomes disabled, or incurs loss of health or income. Fire, liability, and theft insurance cover the homeowner from losses according to the terms and conditions of their respective insurance policies. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">How small can my down payment be?</span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Private mortgage insurance makes it possible for a homebuyer to obtain a mortgage with a down payment as low as 5% and for low-to-moderate income homebuyers as low as 3%. Such mortgages are popular today because potential homebuyers are not able to accumulate the 20% down payment that is generally required by lenders if a loan is not insured. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Who pays for mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lender does, although they will generally pass that cost on to the borrower. Typically, a portion of the mortgage insurance premium is paid up front at closing, and the rest is paid as part of the monthly mortgage payment. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">What are the payment options for mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance can be paid on either an annual, monthly or single premium plan. Premiums are based on the amount and terms of the mortgage and will vary according to loan-to- value ratio, type of loan, and amount of coverage required by the lender. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Under an <i>annual plan</i>, an initial one year premium is collected up front at closing, with monthly payments collected along with the mortgage payment each month thereafter. <i>Monthly plans</i> allow a borrower to pay the lender only 1 or 2 months worth of premium at closing, and then on a monthly basis along with the regular mortgage payment. Under a <i>single premium plan</i>, the entire premium covering several years is paid in a lump sum at closing. Typically, homebuyers choose to add the amount of the lender''s mortgage insurance premium to the loan amount. By doing this, homebuyers can reduce their closing costs and increase their interest deduction. PMI Mortgage Insurance Co. offers a single premium plan called Super Single. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Below are examples of how a variety of PMI Mortgage Insurance Co. premium plans could effect your mortgage payments: \r\n                          </span></font></span></p>\r\n                        <table border="0" width="75%" cellspacing="0" cellpadding="2">\r\n                          <tr> \r\n                            <td class="headers">&nbsp;</td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Annual Plan</font></td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Monthly Premium</font></td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Super Single (Financed)</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext">Loan Amount(*)</span></font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Cash for MI at closing</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$750</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$56</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Financed Premium</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$3,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Total Mortgage Amountv</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Monthly P&I (**)</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">MI Renewal</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$43</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$56</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext" height="6">&nbsp;</td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">P&I plus monthly</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,360</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,373</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,343</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="tableheader">&nbsp;</td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">(*)Loan amount of $150,000; 10% down payment; 30 year fixed rate loan at 10% interest.</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">(**)P&I stands for monthly Principal and Interest on the mortgage.</font></td>\r\n                          </tr>\r\n                        </table>\r\n                        <pre>&nbsp;              </pre>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers"><span class="headers">Can mortgage insurance coverage be cancelled?</span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage insurance is maintained at the option of the current owner of the mortgage. In many cases, the lender will allow cancellation of mortgage insurance when the loan is paid down to 80% of the original property value. However, the degree of equity in the home is not the only factor that a lender may take into consideration. Note that the law in certain states requires that mortgage insurance be cancelled under some circumstances. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">How does private mortgage insurance differ from FHA insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although the insurance protection concept is similar, there are differences between private mortgage insurance and FHA. FHA insurance is a government-administered mortgage insurance program that does have certain restrictions. FHA has maximum regional loan limits that are lower than those with private mortgage insurance. FHA may be more expensive, takes longer to receive approval, and has fewer payment plan options. FHA insurance lasts for the life of the loan, unlike private mortgage insurance which is cancelable in most circumstances. FHA is a good choice for some borrowers with credit history problems that might need special assistance.</font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (54, 56, 1, 'How to Shop For A Mortgage', '                          With dozens of competing lenders and mortgages to choose from, you may think that today''s home loan market is terribly confusing. It really isn''t though if you know the basic facts about financing a house. That''s what this brochure is designed to give you. Let''s start with the questions that are probably uppermost in your mind.</font></span></p>\r\n                        <h3 class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4" color="#BD827B" class="headers"><b>How Large a Mortgage Can I get? </b></font></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">That depends upon your income and the cost of your new house. Lenders use certain guidelines to determine the mortgage amount that they will lend any one homebuyer. The two guidelines used are housing expenses and long term debt. Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For <b>Federal Housing Administration (FHA)</b> loans, this figure is not t o exceed 29 percent of the homebuyer''s gross monthly income. With loan guaranteed by the <b>Department of Veteran''s Affairs (VA)</b>, lenders measure prospective homebuyers with &quot;Residual Income,&quot; or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower</span>.</font></span></font></span></p>\r\n                        <ul>\r\n                          <li> \r\n                            <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers">\r\n                            FHA Loa</span></span></font></span></span></strong><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers"><strong>n</strong></span><span class="bodytext"><span class="bodytext"><span class="headers"><strong>s</strong></span></span></span></span></font></span></span><strong><br>\r\n                              </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing expenses = 29% of gross monthly income </span><br>\r\n                              <span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income</span></font></span></span></font></span></p>\r\n                          </li>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><font size="4" class="headers">\r\n                          VA Loans</font><br>\r\n                            </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income<br>Residual Income = Varies by location and family size \r\n                            </span></font><span class="bodytext"><br>\r\n                            </span></span><br>\r\n                            </span> </font></span></li>\r\n                          <li> \r\n                            <p><span class="headers"><span class="headers"><font size="4"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong class="headers">\r\n                            Conventional Loans</strong></span></font></span></font></span></span><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><br>\r\n                              </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing Expenses = 25% - 28% of gross monthly income </span><br>\r\n                              <span class="bodytext">Housing Expenses Plus Long-Term Debt = 33% - 36% of gross monthly income  </span></font></span></span></font></span></p>\r\n                          </li>\r\n                        </ul>\r\n                        <p class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. VA and FHA mortgage lenders define long- term debt as monthly income. Your lender will work out these figures for you when you sit down to discuss the mortgage you want.</font></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b class="headers">What Types Of Loans Are Available</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although you may see many different types advertised, they all belong to just two families: those mortgages that carry fixed interest rates, and those whose rates change during the course of the loan on a periodic schedule mutually agreed upon by you and your lender. This page does, however, discuss some new loans who are really "cousins" to each family-convertible mortgages.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Fixed Rate Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">You are probably familiar with a fixed-rate mortgage. Your parents more than likely had one, as did their patent before them. The major advantage of fixed rate mortgages is that they present predictable housing costs for the life of the loan. Some fixed-rate mortgages you will probably hear about are:</font></span></font></span></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">30-year fixed-rate mortgages </span></span></font></span></span></font></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">15-year fixed-rate mortgages </span></font></span></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Bi-weekly mortgages </span></font></span></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">"Convertible" mortgages </span></font></span></span></font></span></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">When people thought of a mortgage 10 to 50 years ago, they thought of a 30-year fixed-rate mortgage. This traditional favorite is not the only choice nowadays because volatile financial times created a whole new range of selections. However, the 30-year fixed-rate mortgage may still be the best mortgage for your circumstances. It offers the lowest monthly payments of fixed-rate loans, while providing for a never- changing monthly payment schedule. Some lenders offers 25,20, and even 40-year term mortgages as well. But remember, the longer the term of the loan, the more total interest you will pay. </span></span></span></font></span></span></font></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The 15-year fixed-rate mortgage allows homeowners to own their homes free and clear in half the time and for less than half the total interest costs of the traditional 30-year loan. The loan''s term is shortened by the 10 percent to 15 percent higher monthly payments. Some homebuyers prefer this mortgage because it allows them to own their home before their children start college. Others prefer it because they will own their home free and clear before retirement and probable declines in income. </span></font></span></span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The major disadvantages or the 15-year fixed-rate mortgage are the sometimes higher monthly payments. But if saving on total interest costs and cutting the to free and clear ownership are important to you, the 15-year fixed-rate mortgage is a good option. The bi-weekly mortgage shortens the loan term to 18 to 19 years by requiring a payment for half the monthly amount every two weeks. The bi-weekly payments increase the annual amount paid by about 8 percent and in effect pay 13 monthly payments(26 bi-weekly payments) per year. The shortened loan term decreases the total interest costs substantially. The interest costs for the bi-weekly mortgage are decreased even further, however, by the application of each payment to the principal upon which the interest is calculated every 14 days. By nibbling away at the principal faster, the homeowner saves additional interest. Remember, however, that you trade lower total interest costs for fewer mortgage interest deductions on your federal income tax. Your ability to qualify for this type of loan is based on a 30-year term, and most lenders who offer this mortgage will allow the homebuyer to convert to a more traditional 30-year loan without penalty. Availability is limited on this mortgage, but it can be worth looking for.</span></font></span></span></font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Mortgages That Change</b></font></span></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">Some newer mortgages afford homebuyers some the best qualities of the fixed-rate and adjustable rate mortgages. One new type of loan, often called a <b>Two-Step, Super Seven</b>, or <b>Premier Mortgage</b>, gives homeowners the predictability of a fixed- rate and adjustable rate mortgage for a certain time, most often seven or 10 years, and then the interest rate is adjusted to fit market conditions at that time. The main advantage associated with this type of loan is that homebuyers often get a slightly lower than market rate to begin with. The main disadvantage is that they may see their interest rate go up by as much as six percentage points at the end of the seven-year period. The lender may also reserve the option to call the loan due with 30 days notice at that time, making this loan similar to a balloon mortgage in some cases. </font></span></span></font></span></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Lenders offer this type of loan in part because research indicates that many homebuyers remain in the home for seven to 10 years before moving. For this type of homebuyer, the Two-Step or Super Seven loan present an excellent way of getting a fixed- rate loan at a better than market price for a fixed-rate loan at a better than market price for a fixed period of time. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Another type of mortgage that is becoming popular is called a <b>Lender Buydown</b>, where the homebuyer gets an initially discounted rate and gradually increases to an agreed-upon fixed rate over a matter of three years. For example: When the market rate is 10 percent, the fixed rate for the mortgage is set at about 10.5 percent, but the homebuyer makes monthly payments based on a first year rate of 8.5 percent. The second year the rate goes up to 9.5 percent, and for the third year through the remaining life of the loan, the rate is calculated at 10.5 percent. A second type of lender buy-down, called a <b>Compressed Buydown</b>, works the same way, but with the interest rate changing every six months instead of on a yearly basis. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">The Lender Buydown gives consumers the advantage of lower initial monthly payments for the first two years of the loan when extra money may be needed for furnishings and, secondly, the advantage of knowing that, although the interest rate does change during the first three years of the loan, the interest is fixed from the third year on. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Convertible mortgages offer today''s homebuyer the option to change the loan''s interest rate after some period of time or some specified movement in interest rates. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Convertible fixed-rate mortgages are often referred to as the <b>Reduction Option Loan (ROLE)</b> or, in some locations, the <b>Reducing Interest Loan (RIL), or Mortgage (RIM)</b>. This new type of loan offers homeowners the option of getting a loan that , under the right conditions, can be adjusted to a lower interest rate with a payment of $100 or $200 or so and a small loan amount-based fee, sometimes as little as one-fourth of a percentage point. These conditions usually are a prescribed movement in rates-typically two percent below the initial- during a set time limit-between months 13 and 59, for example. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">On a 30-year fixed-rate mortgage with a reduction option, the homebuyer pays an extra one-fourth to three-eighths of a percentage point in the interest rate on the mortgage plus a quarter to three-eighths of 1 percent of the loan amount (points) at the time of closing. This allows the homeowners to adjust the interest rate on the loan without having to go through a refinancing, which could cost up to 5 percent or 6 percent of the loan amount, if the rates are right during the prescribed time limit. \r\n                          </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">On an $80,000 loan, this means that you could reduce the interest rate on your loan from, say, 10.5 percent to 8.5 percent, and take advantage of the low rates for the rest of the loan term for $150 instead of up to $4,800 , if the rates dropped to that point during your "window of opportunity" - months 13 through 59. Some homeowners may find the ROL a good "insurance policy" against the high costs of refinancing. Others may want the flexibility that refinancing offers - namely the ability to draw on built-up equity- that is not available with ROLs. The decision is up to you. \r\n                          </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><b>Convertible Adjustable Rate Mortgages (ARMs)</b> are another new loan product on today''s market. It worked like any other ARM, but it offers homeowners a distinct advantage-it allows them to turn their ARM into a fixed-rate mortgage after a set period (usually during the second through fifth years of the loan). </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">A new product developed by the <b>Federal National Mortgage Association (Fannie Mae)</b>, which buys mortgages from lenders, allows the homeowner to convert an ARM to either a 15 or 30 year fixed-rate mortgage for a fee of 1 percent of the original loan plus $250 , as compared to the 3 percent to 6 percent costs of refinancing. Say, for instance, that you got your convertible ARM at an initial interest rate of 10.0 percent, and after a year or so, rates had dropped to 8.0 percent. For the smaller conversion fee, you could adjust your mortgage to either a 15 or 30 year fixed-rate loan at a new rate that would be about one-half percent higher than the going market rate, or 8.5 percent. There are other variations on this loan available from lenders across the country. Homebuyers who want the low initial rate of an ARM, and the option and peace of mind of a fixed mortgage should rates drop, can now have it both ways.</span></span></font></span></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Adjustable Rate Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Adjustable Rate Mortgages (ARMs) have become on of the most popular and effective tools for helping some prospective homebuyers achieve their dream of homeownership. Developed during a time of high interest rates that kept many people out of the housing market, the ARM offers lower initial rates by sharing the future risk of higher rates between borrower and lender. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">ARMs can be an excellent choice of financing under certain conditions, such as rising income expectations, high interest rates, and short-term homeownership. But because payments and interest rates can increase, either steadily or irregularly, homebuyers considering this kind of mortgage need to have the income to keep up with all possible rate and/or payment changes. Each ARM has four basic components: </span></font></span></span></font></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Initial interest rate</b>, which is typically one to three percentage points lower than that of most fixed-rate mortgages. Lower interest rates also make ARMs somewhat easier to qualify for. The initial interest rate is tied to certain economic indicators that dictate in part what the monthly payments will be.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustment interval</b>, at the time between changes in the interest rate and/or monthly payment will be.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Index</b>, against which lenders measure the difference between what they are making on their investment in the mortgage and what they could be making on other types of investments. The most popular index is based on the rate of return on a one- year Treasury bill (also called T-bill).</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Margin</b>, or the additional amount the lender adds to the index to establish the adjusted interest rate on an ARM. The margin is usually 1.5 percent to 2.5 percent. \r\n                            </span></font></span></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to the four basic components, an ARM usually contains certain consumer safeguards such as interest rate caps, which limit the amount that the interest rate applied to the payments may move. This prevents the amount of interest the consumer pays from rising higher than perhaps the homeowner can afford. For instance, a typical ARM would have a two percentage point cap over the life of the loan. That means that a loan with an initial interest rate of 9.75 percent would be able to go no higher than 14.75 percent over the life of the loan, and it would be able to move no more than two percentage points per year. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another safeguard found on some ARMs are monthly payment caps that limit the amount homeowners need to increase their payments at adjustment time. Monthly payment caps can, however, sometimes prevent the monthly payments from increasing enough to keep up with the rise in the interest rate, causing negative amortization-resulting in higher or more payments for the homeowner later on. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Other options you should ask about when shopping for an ARM are:</span></font></span></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Assumability</b>, or whether you may transfer the mortgage to a new homebuyer, usually with the same terms if the new homebuyer qualifies for the loan. ARMs are almost always assumable.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertibility</b> allows the borrower to change an ARM to a fixed-rate mortgage, usually at the end of some predetermined period, locking in a lower interest rate.</span></font></span></span></font></li>\r\n                        </ul>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>An Option For Older Homeowners</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">A relative newcomer in the mortgage market is a <b>Reverse Annuity Mortgage (RAM).</b> For older Americans, especially retirees living on fixed incomes, the equity in their paid-for or almost-paid-for home represents a large but liquid asset. The RAM i s designed to help supplement those homeowners'' income. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender who will issue a RAM appraises the property and makes the loan based on a percentage of its current value. The homeowner retains ownership, and the property secures the loan. The lender then pays an annuity to the borrower, usually on a monthly basis, up to an amount equal to the equity they have in the home. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of such a loan for older Americans is that of receiving a monthly tax-free income. Under one plan, this income is available for life or until the house is sold at the homeowner moves. The schedule of payments depends on the value of the home and the ages of the owners. There are risks involved, however. If the homeowner wants to move and buy a new house, there may not be enough equity in the home to permit such a plan. Or the lender may consider only the current market value of the home rather than any future appreciation when deciding on the monthly payments.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>FHA/VA Mortgages</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The Federal Housing Administration (FHA) and the Veterans Administration (VA) offer a wide range of mortgage choices that may appeal to you. These include 30 and 15 year fixed- rate mortgages, as well as ARMs. Insured by these government agencies, the loans feature low or no down payment terms and are often assumable by future purchasers. VA loans are restricted to individuals qualified by military service or other entitlements, but FHA - insured loans are open to all qualified home purchasers. Note that there are limits to handle moderate-priced homes anywhere in the country. Talk to your lender about FHA/VA possibilities.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Creative Financing or Seller-Assisted Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">This type of financing became popular when interest rates went to very high levels in the early 1980s. Seller-assisted creative financing usually means the seller of the home helps with the financing by underwriting all or part of the loan. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of this type of arrangement is that the mortgage usually carries a lower interest rate with lower monthly payments. The disadvantage is that the previous homeowner, not an institution, may hold the deed of trust. If the loan terms call for certain payment schedules, the buyer may have to seek new financing. Many homebuyers in recent years have found "creative financing" deals to be fraught with problems and useful only as short-term alternatives to mortgages from traditional lenders. \r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One type of mortgage you are apt to run into with seller financing is the balloon payment mortgage. <b>Balloons</b>, as they are known, are usually offered as short-term fixed-rate loans. The balloon payment mortgage gets its name from the payment schedule, which involves smaller payments for a certain period of time and one large payment for the entire amount of the outstanding principal. They have terms of 3, 5, and sometimes 15 years, though payments are usually calculated as though it were a 30 year loan. Sometimes a balloon will be offered as a second mortgage where you also assume the homeowner''s first mortgage . The major disadvantage with a balloon payment loan is that it may be difficult to save up the money to make the final large payment (often the entire amount of the principal) while paying interest on the loan. Some lenders guarantee refinancing, though the interest rate is usually adjusted when the principal comes due. If you cannot refinance, you may have to the property if you cannot meet the large payment. Balloons are an advantage if you plan on living in an appreciating house for a short period of time and want to pay less while you live there.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Do You Shop Most Effectively For A Mortgage?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">There are several ways. First, talk with your real estate agent or broker. Real estate professionals are normally in the best position to learn about financing opportunities in the marketplace. Lenders regularly call agents to alert them to financing packages. And, of course, agents are highly motivated to obtain financing for their buyers. Without a suitable loan, the sale can''t proceed, and agents won''t get their sales commission on the house. \r\n                          </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Second, look for rate surveys published by your local newspaper. Many American papers now include brief tables on interest rates and mortgage availability in their real estate or business section. They can help guide you to sources you have not thought about. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Third, look in the Yellow Pages under "Mortgages," and shop for quotes by telephone. Call five to 10 different lenders for rates and terms on fixed and adjustable loans. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Finally, if your area is covered by one of the many commercial <b>computerized mortgage shopping services</b>, give it a try. You may find, however, that the computer services have only a selection of local lenders on their listings.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Do We Evaluate Different Loans?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">One important method is by bearing in mind that mortgage packages consist of more than interest rates. They consist of a quoted rate, plus discount points (pre-paid interest assessed by the lender at settlement, or the meeting when the property legally changes hands) and other fees, plus a full range of terms including adjustable versus fixed-rates, low down payment versus high down payment, the presence or absence of prepayment penalties, and many other features noted earlier in this brochure. \r\n                          </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One way to evaluate rates, however, is by examining the <b>Annual Percentage Rate (APR)</b>. The APR can help you compare different types of mortgages. It indicates the &quot;effective rate of interest&quot; paid per year. The figure includes discount points and other charges and spreads them out over the life of the loan. While the APR provides you with a common point for comparison, look at the whole product before deciding which mortgage to get. Pick the one with the rate, payment schedule and other terms t hat suit your situation best.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Terms You Should Know</b></font></span></span></h3>\r\n                        <blockquote> \r\n                          <dl> \r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Acceleration Clause</font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you miss a monthly payment, an acceleration clause allows the lender to speed up the rate at which your loan comes due or even to demand immediate payment of the entire outstanding balance of the loan.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Assumability</span></font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Assuming a mortgage is simply taking the loan over from the holder (seller) and becoming liable for the repayment.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Buydown</font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The buydown mortgage is one where the seller and/or the home builder subsidizes the mortgage by lowering the interest rate during the first few years of the loan. While the lower initial payment and interest rate make this kind of loan easier to qualify, the payments may increase when the subsidy expires.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Closing Costs/Settlement Costs/Escrow</span></font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Closing costs ate the costs associated with settlement, the meeting where the buyer and seller (or their agents) sit down to fill out the papers and make the exchanges that allow the property to legally change hands. Closing costs include appraisal fees, title search and insurance, survey, tax adjustments, deed recording fees, credit report and points, among others.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Due-on Sale Clause</span></font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">A clause or provision in a mortgage or deed of trust that allows the lender to demand immediate payment of the balance of the mortgage at the time of sale.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Negative Amortization</span></font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This occurs when your monthly payments are not large enough to pay all the interest due on the loan. This unpaid interest is added to unpaid balance of the loan. The danger of negative amortization is that the homebuyer could end up owing more than the original amount of the loan.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Private Mortgage Insurance</font></b> </font></span></span></dt>\r\n                            <dd><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment-as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are usually required to carry private mortgage insurance. </font></span> \r\n                              </font> </span> </span> \r\n                              <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance will require additional premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 house with a 10 percent down payment, this would mean an initial premium payment of $338 to $675 and an extra $15 to $20 a month. </span></font></span></span></font></p>\r\n                            </dd>\r\n                          </dl>\r\n                        </blockquote>\r\n                        <p> \r\n                        <table class="bodytext" cellspacing="1" cellpadding="4" bgcolor="#FFFFFF" bordercolor="#CCCCCC" border="0" width="100%">\r\n                          <center>\r\n                            <tr bgcolor="#FFCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"> \r\n                                <font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Comparison on a</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top">30 CCC Year</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top">15-Year</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top">Bi-Weekly</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top">ARM</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFCCCC" > \r\n                              <td width="27%" height="12" align="left" valign="top" class="bodytext">$75,000 Mortgage</font></td>\r\n                              <td align=left width="16%" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                              <td align=left width="18%" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                              <td align=left width="20%" height="12" class="bodytext" valign="top">Mortgage</font></td>\r\n                              <td align=left width="19%" height="12" class="bodytext" valign="top">at 7.5%</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="16%" class="bodytext" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">w/5% cap*</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$806</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658(329 X 2)</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$524</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,481</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,398</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,434</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$5,602</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,336</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,606</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,061</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,188</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage Balance</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,583</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,726</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,476</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,309</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$73,052</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$64,372</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$69,817</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,400</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost/Life</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$161,942</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$70,062</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$104,331</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$132,566</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left width="102" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Difference from 30 Year Fixed Rate</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $91,880</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $57,611</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $29,376</font></td>\r\n                            </tr>\r\n                          </center>\r\n                        </table>\r\n                        <div align="left" class="bodytext"> \r\n                          <blockquote><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">* The interest on the ARM used in this example increased 2 percent in the second year (payment = $629), and decreased 1 percent in the third year (payment = $577 for Years 3 through 30). This is a hypothetical situation. Not all ARMs will behave in this manner; some will increase (or decrease) more slowly, some more rapidly. In each case, the monthly payments, interest costs, and the amount you save will differ. For more information about tailoring an ARM to fit your particular circumstances, talk to your lender. </font></span></span></font></span></span></blockquote>\r\n<p><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (55, 57, 1, 'Veterans Administration Loan Program', '<ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#intro">Introduction</span></font></a></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#beprepared">Be Prepared For Homeownership</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#planunexpected">Planning For The Unexpected</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#deliquent">If Your Mortgage Becomes Delinquent</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#default">What To Do When You Default On Your Mortgage</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#workout">Mortgage Loan Workout Plans</a></span></font></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="intro" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Introduction</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Acquiring your first home, or a larger one to meet growing family needs, usually focuses all of your attention on accumulating the down payment and qualifying for the financing on the property you have selected. There is a sense of relief when the loan is finally closed and you have settled in the house. It will not take long, however, before you will have to face the financial responsibilities that home ownership imposes. </font></span></p>\r\n                        <p><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">If you are a first-time home buyer, many of the problems that you simply turned over to the landlord (or your parents) are now yours to fix and pay for. If you have moved from a small house into a larger one, you may find the expenses of maintaining the property have grown along with its size. In either case, careful planning and budgeting are essential in order to guard against financial problems in the future. </span></font></span></span></font></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your home is a major investment and you have a great deal to lose if you default on your mortgage payments or fail to maintain the property. Planning for unexpected situations as well as the routine costs of owning a home can help you avoid foreclosure o r bankruptcy when emergencies arise.</span></font></span></font></span></p>\r\n                        <h3><a class="mainlink" name="beprepared" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Be Prepared For Homeownership</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The expenses of owning a home go beyond the monthly mortgage and utility payments, and can create financial difficulties, particularly for first-time home buyers who have minimal cash reserves. Mechanical failures in the plumbing, electrical and heating systems seem to occur at the worst possible times, but have to be repaired. If you have purchased an older home, complete replacement of water heaters, furnaces or kitchen appliances may be needed. You should have drawn up a budget before beginning your search for a home, making allowances for such expenditures. If you did not, it is time that you begin to accumulate adequate reserves to deal with such emergencies. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In a newer property, your immediate expenses may be confined to landscaping, interior decoration and furnishings. Under normal conditions, mechanical items and appliances will be under warranty for six months to a year and will not require major expenditures, but may need minor repairs. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In an older property, replacement of major items can be very expensive. You should have determined the age of the furnace, hot water heater, air conditioning system, kitchen appliances and the roof. Your home inspector''s report probably noted the ages o f these major items. If they are older then half their expected useful life, you will need to plan for the costs of the replacement. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Set up a budget and plan for both regular maintenance and major repairs. Establish an emergency fund for repairs and appliance replacement. Know what sources of financing are open to you when a major item such as the roof or heating system has to be rep laced. These are things that can cost thousands of dollars and you may have to finance them through a home equity loan, a second mortgage or an installment loan. Determine which kind of loan you are likely to qualify for, the pros and cons of the alternatives and have a plan for dealing with a major expense. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your budget should also include a reserve for making your mortgage payments in the event of illness or loss of income in the future.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="planunexpected" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><span class="headers"><span class="headers"><span class="headers"><span class="headers"><b>Planning For The Unexpected</b></span></span></span></span></span></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">While over-obligating yourself or unexpected repair bills may jeopardize your ability to keep up your house payments, the primary causes of foreclosure and bankruptcy are unanticipated personal crisis. More homeowners lose their homes because of illness, loss of employment or marital problems than all other reasons combined. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">None of us factor these things into our plans for the future, but you should know about some of your alternatives if you find yourself in such a position. It is much easier to look at alternatives and plan an effective course of action before you are in t rouble and in a state of anxiety and stress. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Sometimes you can see the trouble coming before financial problems begin. An advance notice of a layoff means the family income will be severely cut back or eliminated in the near future. A major medical operation or property repair bill may be more than you can afford to repay, even with a short term loan. You have to address the situation as soon as possible or risk losing your home. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There can be a number of local sources that can help you get over the hump. Churches and civic groups may have assistance programs or may know what is available. Non-profit organizations, particularly housing assistance groups or counseling agencies, ma y manage special assistance programs. State and local housing agencies are also places to inquire to help.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="deliquent" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>If Your Mortgage Becomes Delinquent</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The day of the month on which your mortgage payment is due, usually the first day of the month, is set out in the mortgage note. Your payment is considered late of the lender receives it after the due date, and the lender usually will charge a late payment fee when the money is not received within 15 days of the due date (the timing and amount of late charges may vary from lender to lender). Payments made, including any late charges assessed, before the next payment due date will be accepted by the lender, but if you owe two or more mortgage payments, your home is in serious jeopardy. Unless specific arrangements are made with your lender, you must remit all payments and late charges before the money will be accepted and the loan considered current. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When three or more mortgage loan payments are due and unpaid, the loan may be given to the lender''s attorney and foreclosure proceedings initiated. The entire balance of the loan may be due and payable immediately. In addition to the loan payments due, you are liable for legal fees incurred by the lender. At this point, you are in serious danger of losing your home.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="default" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What To Do When You Default On Your Mortgage</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">No lender wants to foreclose on a mortgage. Foreclosure costs them more money than they can make back from the foreclosure sale. Therefore, lenders do not foreclose in order to make money, but only reluctantly as a way of limiting losses on a defaulted loan. This is why, if you get behind on your mortgage payments, your lender will work with you to devise a practical plan to cure the default and bring the loan current. In order to do so, however, you must stay in communication with your lender and be honest in evaluating your financial situation. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The willingness of the lender to work with you to get past your current problems will depend heavily on your past payment record. If it shows consistently timely payments and no serious defaults, you will find the lender much more receptive than if you have a record of unexplained chronic late payments. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are falling behind in your payments, or know that you are likely to in the immediate future, there are some steps that you should take before talking with the lender about alternative payment arrangements. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">First, you need to prepare a monthly list of your income and expenses, using realistic figures based on your current financial situation. You will also need to put together a complete financial disclosure package, showing your assets and liabilities, including all debts and monthly payments and when they are due. Pay stubs, unemployment check stubs or other proof of current income should be in the package, along with two years'' tax returns. Get an estimate of the value of your property. You can usually get a local real estate broker to give you an idea of the current market value, free of charge. Finally, prepare a written explanation of your situation for the lender and offer any plan or suggestion you may have on how you can bring the loan current.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="workout" class="headers"><font color="#BD827B"><span class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b class="headers">Mortgage Loan Workout Plans</b></span></font></span></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bighead"><font size="2"><b><span class="bodytext">A loan workout plan is an agreement between you and your lender that sets out the steps to be taken to cure the delinquency and prevent loss of your home. It may be written or oral and will have specific deadlines which you must meet in order to avoid foreclosure. Therefore, it must be based on very realistic estimates of your ability to meet the plan schedule. </span></span></b></font> \r\n                          </span></font></span></p>\r\n                        <p><span class="bighead"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The nature of the workout plan will depend upon the seriousness of the default, whether your financial problems are short-term or your payment ability has been impaired for the foreseeable future, your prospects for obtaining funds to cure the default and the current value of your property. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the default is caused by a very temporary condition and is likely to be cured within 30 to 60 days, the lender may consider granting you <b>temporary indulgence</b>. Some examples of cases where this approach would be considered are where the house ha s been sold but the sale has not settled or where an insurance settlement is pending. It is usually possible to determine a date certain for curing the default. The lender will want documented evidence, such as the sale contract, before granting indulgence. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have suffered a temporary loss of income but can demonstrate that it has returned to previous levels, you may structure a <b>repayment plan</b> to bring the loan current. This type of workout arrangement requires your normal mortgage payments be made as scheduled, plus an additional amount that will cure the delinquency in no more than 12 to 24 months. In some cases the additional amount may be a lump sum due at a specific date in the future. Repayment plans are probably the most frequently used type of workout agreement. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In some circumstances, it may be impossible for you to make any payments at all for some period of time. If you have had a good record with the lender, a "forbearance plan" will allow you to suspend payments or make reduced payments for a specified length of time. The forbearance plan will be in writing, have a definite term and spell out the method of ending the delinquency. In most cases the length of the plan will not exceed 18 months and will stipulate commencement of foreclosure action if you default on the agreement. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Any workout agreement is a last-ditch effort by you and your lender to avoid foreclosure and keep you in your home. It is not a substitute for good budgeting and financial planning on your part and will probably not be available if your payment record has not been consistently good up to the present time. Lenders will work closely with good borrowers who are having a period of real emergency and hardship, but are not inclined to cooperate with those who demonstrate little financial discipline. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></font></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (56, 58, 1, 'Veterans Administration Loan Program', '<b>Why A VA Loan?</font></b></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The more you know about our home loan program, the more you will realize how little "red tape" there really is in getting a VA loan. These loans are often made without any downpayment at all, and frequently offer lower interest rates than ordinarily available with other kinds of loans. Aside from the veteran''s certificate of eligibility and the VA-assigned appraisal, the application process is not much different than any other type of mortgage loan. And if the lender is approved for automatic processing, as more and more lenders are now, a buyer''s loan can be processed and closed by the lender without waiting for VA''s approval of the credit application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Additionally, if the lender is approved under VA''s Lender Appraisal Processing Program (LAPP), the lender may review the appraisal completed by a VA-assigned appraiser and close the loan on the basis of that review. The LAPP process can further speed the time to loan closing.</span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>VA Pamphlet 26-91-1<br>August 1993<br>VA Home Loans</b></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b><span class="bodytext">For more information</span></b><span class="bodytext">:</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Veteran''s Administration Oakland office has a listing of VA-owned properties in Northern California and Northern Nevada. </span></font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></p>\r\n                        <p class="headers">&nbsp;</p>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (57, 59, 1, 'A Consumer''s Guide To Refinancing Your Mortgage', '                          If you are a homeowner who was lucky enough to buy when mortgage rates were low, you may have no interest in refinancing your present loan. But perhaps you bought your home when rates were higher. Or perhaps you have an adjustable rate loan and would like to obtain different terms. </font></span></font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Should you refinance? This brochure will answer some questions that may help you decide. If you do refinance, the process will remind you of what you went through in obtaining the original mortgage. That''s because, in reality, refinancing a mortgage is simply taking out a new mortgage. You will encounter many of the same procedures-and the same types of costs-the second time around.</span></span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Would Refinancing Be Worth It?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Refinancing can be worth while, but it does not make good financial sense for everyone. A general rule is that refinancing becomes worth your while if the current interest rate on your mortgage is at least two percentage points higher than the prevailing market rate. this figure is generally accepted as the safe margin when balancing the costs of refinancing a mortgage against the savings. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are other considerations, too, such as how long you plan to stay in the house. Most sources say that it takes at least three years to realize fully the savings from a lower interest rate, given the costs of the refinancing. (Depending on your loan amount and the particular circumstances, however, you might choose to refinance a loan that is only 1.5 percentage points higher then the current rate. You may even find you could recoup the refinancing costs in a shorter time.) </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Refinancing can be a good idea for homeowners who:</span></font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to get out of a high interest rate loan to take advantage of lower rates. This is a good idea only if you intend to stay in the house long enough to make the additional fees worthwhile.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Have an adjustable rate mortgage (ARM) and want a fixed-rate loan to have the certainty of knowing exactly what the mortgage payment will be for the life of the loan.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to convert to an ARM with a lower interest rate or more protective features (such as a better rate and payment caps) than the ARM they currently have.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to build up equity more quickly by converting to a loan with a shorter term.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to draw on the equity built up in their house to get cash for a major purchase or for their children''s education. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you decide that a refinancing is not worth the costs, ask your lender whether you may be able to obtain all or some of the new terms you want by agreeing to a modification of your existing loan instead of a refinancing.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Should You Refinance Your ARM?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In deciding whether to refinance an ARM you should consider these questions:</font></span></font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Is the next interest rate adjustment on your existing loan likely to increase your monthly payments substantially? Will the new interest rate be two or three percentage points higher than the prevailing rates being offered for either fixed-rate loans or other ARMs?</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the current mortgage sets a cap on your monthly payments, are those payments large enough to pay off your loan by the end of the original term? Will refinancing a new ARM or a fixed-rate enable you to pay your loan in full by the end of the term?</span></font></span></font></li>\r\n                        </ul>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are The Costs of Refinancing?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The fees described below are the charges that you most likely to encounter in a refinancing.</font></span></font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Application Fees</b><br>\r\n                            This charge imposed by your lender covers the initial costs of processing you loan request and checking your credit report.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Search and Title Insurance</b><br>\r\n                            This charge will cover the cost of examining the public record to confirm ownership of the real estate. It also covers the cost of a policy, usually issued by a title insurance company, that insures the policy holder in a specific amount for any loss caused by discrepancies in the title to the property. Be sure to ask the company carrying the present policy if it can re-issue your policy at a re-issue rate. You could save up to 70 percent of what it would cost you for a new policy.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Lender''s Attorney''s Review Fees</b><br>\r\n                            The lender will usually charge you for fees paid to the lawyer or company that conducts the closing for the lender. Settlements are conducted by lending institutions, title insurance companies, escrow companies, real estate brokers, and attorneys for the buyer and seller. In most situations, the person conducting the settlement is providing a service to the lender. You may want to retain your own attorney to represent you at all stages of the transaction, including settlement.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Loan Origination Fees and Discount Points</b><br>\r\n                             The origination fee is charged for the lender''s work in evaluating and preparing your mortgage loan. Discount points are prepaid finance charges imposed by the lender at closing to increase the lender''s yield beyond the stated interest rate on the mortgage note. One point equals one percent of the loan amount. For example, one point on a $75,000 loan would be $750. In some cases, the points you pay can be financed by adding them to the loan amount. The total number of points a lender charges will depend on market conditions and the interest rate to be charged.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Appraisal Fee</b><br>\r\n                            This fee pays for an appraisal which is a supportable and defensible estimate or opinion of the value of the property.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Prepayment Penalty</b><br>\r\n                           A prepayment penalty on your present mortgage could be the greatest determent to refinancing. The practice of charging money for an early pay-off of the existing mortgage loan varies be state, type of lender, and type of loan. Prepayment penalties are forbidden on various loan including loan from federally chartered credit unions, FHA and VA loans, and some other home-purchase loans. The mortgage documents for your existing loan will state if there is a penalty for prepayment. In some loans, you may be charged interest for the full month in which your prepay your loan.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Miscellaneous</b><br>\r\n                            Depending on the type of loan you have and other factors, another major expense you might face is the fee for a VA loan guarantee, FHA mortgage insurance, or private mortgage insurance. There are a few other closing costs in addition to these. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In conclusion, a homeowner should plan on paying an average of 3 to 6 percent of the outstanding principal in refinancing costs, plus any prepayment penalties and the costs of paying off any second mortgages that may exist. One way of saving on some of these costs is to check first with the lender who holds your current mortgage. The lender may be willing to waive some of them, especially if the work relating to the mortgage closing is still current. This could include the fees for the title search, surveys, inspections, and so on. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information contained in this brochure is intended to help you ask the right questions when considering refinancing your loan. It is not a replacement for professional advice. Talk with mortgage lenders, real estate agents, attorneys, and other advisors about lending practices, mortgage instruments, and your own interests before you commit to any specific loan.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Refinancing Savings On A $100,000 Loan</b></font></h3>\r\n                        <table border="0" width="380" cellspacing="1" cellpadding="6">\r\n                          <tr valign="top"> \r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Your Present Mortgage Rate</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Current Monthly Payment</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Monthly Payment Savings at 8.0%</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Monthly Annual Savings at 8.0%</span></font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">14.0%</font></td>\r\n                            <td ><font class="maintext">$1,185</font></td>\r\n                            <td ><font class="maintext">$451</font></td>\r\n                            <td ><font class="maintext">$5,412</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">13.5%</font></td>\r\n                            <td ><font class="maintext">$1,145</font></td>\r\n                            <td ><font class="maintext">$411</font></td>\r\n                            <td ><font class="maintext">$4,932</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">13.0%</font></td>\r\n                            <td ><font class="maintext">$1,106</font></td>\r\n                            <td ><font class="maintext">$372</font></td>\r\n                            <td ><font class="maintext">$4,464</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">12.5%</font></td>\r\n                            <td ><font class="maintext">12.5%</font></td>\r\n                            <td ><font class="maintext">$333</font></td>\r\n                            <td ><font class="maintext">$3,996</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">12.0%</font></td>\r\n                            <td ><font class="maintext">$1,029</font></td>\r\n                            <td ><font class="maintext">$295</font></td>\r\n                            <td ><font class="maintext">$3,540</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">11.5%</font></td>\r\n                            <td ><font class="maintext">$990</font></td>\r\n                            <td ><font class="maintext">$256</font></td>\r\n                            <td ><font class="maintext">$3,072</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">11.0%</font></td>\r\n                            <td ><font class="maintext">$952</font></td>\r\n                            <td ><font class="maintext">$218</font></td>\r\n                            <td ><font class="maintext">$2,616</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">10.5%</font></td>\r\n                            <td ><font class="maintext">$915</font></td>\r\n                            <td ><font class="maintext">$181</font></td>\r\n                            <td ><font class="maintext">$2,172</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">10.0%</font></td>\r\n                            <td ><font class="maintext">$878</font></td>\r\n                            <td ><font class="maintext">$144</font></td>\r\n                            <td ><font class="maintext">$1,728</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">9.5%</font></td>\r\n                            <td ><font class="maintext">$841</font></td>\r\n                            <td ><font class="maintext">$107</font></td>\r\n                            <td ><font class="maintext">$1,284</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">9.0%</font></td>\r\n                            <td ><font class="maintext">$805</font></td>\r\n                            <td ><font class="maintext">$71</font></td>\r\n                            <td ><font class="maintext">$852</font></td>\r\n                          </tr>\r\n                        </table>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bighead"><span class="bodytext"><font size="2" class="bodytext">\r\n                         </font></span></span></font></span></span></p>\r\n                        <p><a class="mainlink" href="tools.php" class="bodytext">Back to Tools</font></a> \r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (58, 60, 1, 'Deducting Your Mortgage Interest Under the Tax Code', '                          One of the best justifications for owning a home, at least for financial reasons, is the tax savings that result from deducting mortgage interest. The deduction for mortgage interest stands as one of the few remaining tax deductions for the typical middle class taxpayer. Despite the changes to the tax code over the past several years and the repeal and limitation of many non-housing itemized deductions, mortgage interest is still deductible. On first and second mortgages and home equity lines of credit (with some limitations) for first and second homes, your mortgage interest deduction is still a good financial incentive to buy a home.</font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#deduct">Your Mortgage Interest Deductions</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#twokindsdebt">Two Kinds of Debt</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#refinancing">Refinancing Your Mortgage</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#secondmort">Second Mortgages</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#homeequity">Home Equity Lines of Credit</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#typevaries">Loan Type Varies Interest Deduction</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#taxbenefits">The Tax Benefits of Selling Your Home</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#refinance">What Are The Costs of Refinancing?</a></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="deduct" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Your Mortgage Interest Deductions</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">Under the current tax code, mortgage interest on first and second homes is generally deductible as long as these loans total less than $1.1 million, making homeownership one of the best ways to trim your tax bill. The examples below illustrate how the mortgage income tax deduction affects the after-tax homeownership. </span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Listed below are the topics covered in this document. </span></font></span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeowner Profile</b><br>Gross Income - $35,500<br>House Price/Mortgage Size - $115,000 - $23,000 down = $92,000<br>Loan Type - 30-year Fixed-Rate mortgage at 10%<br>Property Tax - 1.23% of home value ($1,415)<br>Filing Status - Files jointly/four exemptions<br>\r\n                            </span></font></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">According to the tax code, this homeowner''s deductions for mortgage interest and property taxes would be evaluated at a 15 percent marginal tax rate. Non-housing itemized deductions (i.e., state and local taxes, non-mortgage interest and so on) is estimated at $2,000 and the standard deduction is $5,450. Under the current tax system, the homeowner saves $1,071 because of the mortgage interest deduction. You can figure what your own costs and savings will be by substituting your own tax figures for those on the chart. </span></font></span></font></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Example of the impact of the Mortgage Income Tax Deduction on Annual Homeownership Costs:</b> </span> </font> \r\n                            </span> </font> </span> \r\n                            <ul>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Before-Tax Homeownership Costs</b><br>Mortgage Interest=$9,177<br>Property Taxes=1,415<br><b>Total of Before-Tax Homeownership Costs=10,592</b><br>\r\n                                </span></font></span></font></span></li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Itemized Deductions</b> </span> </font> </span> </font> \r\n                                </span> \r\n                                <ul>\r\n                                  <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeownership Deductions</b><br>Mortgage Interest= $9,177<br>Property Taxes=1,415<br>Non-homeownership Deductions= 2,000<br><b>Total= 12,592</b> </span></font></span></font></span></li>\r\n                                  <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Standard Deductions=5,450</b></span></font></span></font></span></li>\r\n                                </ul>\r\n                              </li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><strong>Total Itemized Deductions=$7,142</strong><br><b>Multiply Total Itemized Deductions by Marginal Tax Rate to get Homeownership Tax Savings:</b><br>\r\n                                <span class="bodytext"><span class="bodytext">$7,142 \r\n                                x .15 = <font class="bodytext">$1,071</font> </span></span></span></font></span></font></span></li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>After Tax Homeownership Costs = Homeownership Tax - Before Tax Savings:</b><br>\r\n                                $10,592 - 1,071 = $9,521</span></font></span></font></span></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><span class="headers"><span class="headers"><a class="mainlink" name="twokindsdebt"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Two Kinds of Debt</font></b></span></font></a></span></span></h3>\r\n                        <p><font size="3"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2" class="bodytext">Under the current tax system, there are two different kinds if debt. Money you borrow to buy, build or substantially improve your residence is called "acquisition indebtedness." Money you borrow against the equity in your home, or money you take out when you refinance your home for any reason except home improvement, is called "equity indebtedness." </font></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">When you borrowed the money is also important. Home loans taken out before October 14, 1987, are exempted from the new rules. You may fully deduct interest paid on these loans, regardless of their size or what you used them for. Any refinanced debt you incurred before October 14, 1987, is rolled into your total acquisition indebtedness. On loans made on or after October 14, 1987, you can deduct mortgage interest paid on acquisition indebtedness up to a total of 1.0 million. This means you could buy a home for $250,000, a beach home for $200,000, and add a family room to your first house for another $100,000, and still have $450,000 to spend on these homes for further improvements before you reached your limit for interest deductibility. The $1. 0 million is not cumulative. As you pay off a loan, you would add that amount to your total purchasing or improving up to two residences. \r\n                          </span></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font class="bodytext">Your equity indebtedness limit is $100,000. That means that you can borrow up to $100,000 of the equity in your home and use it for whatever you want. This is a change from the pre-1986 tax rule that limited your equity borrowing beyond the purchase price to certain qualified expenses, such as home improvements, medical and education expenses.</font></span></span></font></span></font></p>\r\n                        <h3><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><a class="mainlink" name="refinancing" class="headers"><font size="4" class="headers" color="#BD827B"><b>Refinancing Your Mortgage</b></font></a></font></span></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Interest rate have declined recently, and many homeowners have taken advantage of this drop by refinancing their mortgages. In the past, refinancing your mortgage has proved to be an excellent opportunity both to lower your interest rate and monthly payment and take equity out of your home. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">When refinancing your mortgage, you will probably pay 3 percent to 6 percent of the loan amount in closing costs-for surveys, legal fees and paperwork fees. Many of these closing costs are deductible, but not necessarily in the year that you refinance. I f you are considering refinancing your mortgage under the current tax rules, however, there are a couple of things to bear in mind. If you refinanced before October 14,1987, for a longer term than was remaining on the pre-October 14 loan, you may only de duct the interest paid on the mortgage for the term that was remaining on the old loan. So if you refinanced a loan with 15 years remaining for a 30-year loan with lower payments, you can only deduct the mortgage interest paid on the new loan for 15 year s. The one exception is if you had a balloon mortgage payment come due after October 13,1987 and you refinanced it to a loan of not more than 30 years; you get the deductibility for the full term of the longer loan. Any refinanced debt you incurred before October 14,1987, is rolled into your total acquisition indebtedness. \r\n                          </font></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">In the past many homeowners have refinanced mortgages on their appreciating properties to draw on their equity to buy a new car or take a vacation. Under the new tax system, homeowners will no longer have unlimited mortgage interest deductions when drawing on equity. Any equity debt incurred is subject to a limit of the amount of on equity. Any equity debt incurred is subject to a limit of the amount of the existing debt plus $100,000. Say, for instance, that you bought your house 10 years ago and have seen the property grow in value from $70,000 to $230,000. If you refinance your mortgage (on which you now owe $50,000), you may only deduct the interest paid on the total of your acquisition indebtedness in the property ($50,000) plus $100,000. You will be able to deduct the interest paid on $150,000.</font></span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="secondmort" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Second Mortgages</b></font></span></font></a></h3>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">A second mortgage allows the homeowner to cash in on some of the equity that has built up in the home over time. Some lenders call a second mortgage a "junior lien." Getting a second mortgage is very much like taking out your first mortgage (i.e. you w ill be required to pay closing costs of 3 percent to 6 percent of the loan value). </font></p>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">You may deduct the interest paid on second mortgages made on or after October 13,1987, up to the $100,000 limit had already been reached when the first mortgage was taken out. The amount of second mortgages made before that date is part of your acquisition indebtedness total figure. This means that if you had $50,000 left on your first mortgage as of that date, and had taken out a $25,000 second mortgage on the property prior to October 14,1987, you would have an acquisition indebtedness of $75,000.</font></p>\r\n                        <h3><a class="mainlink" name="homeequity" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="headln"><span class="headers"><b>Home Equity Lines of Credit</b></font></span></span></span></font></a></h3>\r\n                        <p><font size="1" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">While the 1986 tax reform called for consumer interest deducibility to be phased out by 1991, interest deductions on equity indebtedness now are limited only by the $100,000 cap. This means that interest paid on home equity lines of credit - loans secure d by your principal or second home - is still deductible. </span></font></span></font></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">Where the traditional second mortgage gives the homeowner money in one lump sum the home equity line of credit allows homeowners to use the equity in their home like a giant credit card. The lender allows the homeowner to borrow at will against the equity in the home, and charges interest only on the portion of the equity borrowed against. Therefore, your interest deductions for a home equity line of credit depend on whether you borrow against the equity during that year.</font></span></font></span></p>\r\n                        <h3><a class="mainlink" name="typevaries" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Loan Type Varies Interest Deduction</b></font></span></font></a></h3>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">As we''ve said, the mortgage interest tax deduction is one of the best financial reasons to buy a home. You may be wondering, however, what total interest charges are like on the typical home loan. In the chart, you can compare a 30-year fixed-rate loan with 15-year and bi-weekly mortgages for the same amount. As you can see, the amount of interest you pay over the life of your loan depends on what kind of mortgage you determine is best for you.  \r\n                          </font></p>\r\n                        <p align="center"><font size="3"><b class="headers">$75,000 MORTGAGE</font></b></font></p>\r\n                        <div align="center"> \r\n                          <table border="0" width="75%" bgcolor="#FFFFFF">\r\n                            <tr bgcolor="#FFFFFF"> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font size="2"></font></td>\r\n                              <td class="bodytext" valign="top" width="26%">30 Year Fixed RateAt 10%</font></td>\r\n                              <td class="bodytext" valign="top" width="23%">15 Year Fixed Rate At 10%</font></td>\r\n                              <td class="bodytext" valign="top" width="25%">Bi-Weekly Mortgage At 10%</font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Monthly Payment</span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$658</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$806</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$658<br>($329 X 2)</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Interest Cost First Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,481</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,398</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,434</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Fourth Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,336</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$6,606</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,061</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Balance First Year</span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$74,583</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$72,726</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$74,476</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Fourth Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$73,052</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$64,732</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$69,817</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Interest Cost/Life </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$161,942</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$70,062</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$104,331</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Difference from 30-year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"></span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">-$91,880</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">-$57,611</span></font></td>\r\n                            </tr>\r\n                          </table>\r\n                          <br>\r\n                          <span class="bodytext"> </span></div>\r\n                        <h3><span class="headers"><a class="mainlink" name="taxbenefits"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b><span class="bighead"><span class="headers">The Tax Benefits of Selling Your Home</span></span></b></font></a></span><a class="mainlink" name="taxbenefits"></a></h3>\r\n                        <p><font size="3"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">The IRS allows a Capital Gains Exclusion of either $250K or $500K (single or married) on the sale of primary residences. There is no life-time cap on this exclusion.  Every 2 years of residence during a 5 year period, you can sell your home and pocket the gain, up to the exclusion, and start over.  In other words, assuming that your only residence is your home, every 2 years you can sell your home, pocket the gain and do it again!</span></font></span></font></span></font></p>\r\n                        <h1 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>You should consider these questions </b></font></h1>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Is the next interest rate adjustment on your existing loan likely to increase your monthly payments substantially? Will the new interest rate be two or three percentage points higher than the prevailing rates being offered for either fixed-rate loans or other ARMs?</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the current mortgage sets a cap on your monthly payments, are those payments large enough to pay off your loan by the end of the original term? Will refinancing a new ARM or a fixed-rate enable you to pay your loan in full by the end of the term?</span></font></span></font></span></li>\r\n                        </ul>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are The Costs of Refinancing?</b></font><a class="mainlink" name="refinance"></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">The fees described below are the charges that you most likely to encounter in a refinancing.</span></font></span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Application Fees</b><br>This charge imposed by your lender covers the initial costs of processing you loan request and checking your credit report.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Search and Title Insurance</b><br>This charge will cover the cost of examining the public record to confirm ownership of the real estate. It also covers the cost of a policy, usually issued by a title insurance company, that insures the policy holder in a specific amount for any loss caused by discrepancies in the title to the property. Be sure to ask the company carrying the present policy if it can re-issue your policy at a re-issue rate. You could save up to 70 percent of what it would cost you for a new policy.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Lender''s Attorney''s Review Fees</b><br>The lender will usually charge you for fees paid to the lawyer or company that conducts the closing for the lender. Settlements are conducted by lending institutions, title insurance companies, escrow companies, real estate brokers, and attorneys for the buyer and seller. In most situations, the person conducting the settlement is providing a service to the lender. You may want to retain your own attorney to represent you at all stages of the transaction, including settlement.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Loan Origination Fees and Discount Points</b><br>The origination fee is charged for the lender''s work in evaluating and preparing your mortgage loan. Discount points are prepaid finance charges imposed by the lender at closing to increase the lender''s yield beyond the stated interest rate on the mortgage note. One point equals one percent of the loan amount. For example, one point on a $75,000 loan would be $750. In some cases, the points you pay can be financed by adding them to the loan amount. The total number of points a lender charges will depend on market conditions and the interest rate to be charged.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Appraisal Fee</b><br>This fee pays for an appraisal which is a supportable and defensible estimate or opinion of the value of the property.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Prepayment Penalty</b><br>A prepayment penalty on your present mortgage could be the greatest determent to refinancing. The practice of charging money for an early pay-off of the existing mortgage loan varies be state, type of lender, and type of loan. Prepayment penalties are forbidden on various loan including loan from federally chartered credit unions, FHA and VA loans, and some other home-purchase loans. The mortgage documents for your existing loan will state if there is a penalty for prepayment. In some loans, you may be charged interest for the full month in which your prepay your loan.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Miscellaneous</b><br>Depending on the type of loan you have and other factors, another major expense you might face is the fee for a VA loan guarantee, FHA mortgage insurance, or private mortgage insurance. There are a few other closing costs in addition to these. </span></font></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In conclusion, a homeowner should plan on paying an average of 3 to 6 percent of the outstanding principal in refinancing costs, plus any prepayment penalties and the costs of paying off any second mortgages that may exist. One way of saving on some of these costs is to check first with the lender who holds your current mortgage. The lender may be willing to waive some of them, especially if the work relating to the mortgage closing is still current. This could include the fees for the title search, surveys, inspections, and so on. </span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information contained in this brochure is intended to help you ask the right questions when considering refinancing your loan. It is not a replacement for professional advice. Talk with mortgage lenders, real estate agents, attorneys, and other advisors about lending practices, mortgage instruments, and your own interests before you commit to any specific loan.</span></font></span></font></span></p>\r\n                        <p class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bighead"><span class="bodytext">Back to Tools</font></span></span></font></a> \r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (59, 61, 1, 'List of Publications', '                    Below is a list of publications and the places from which they can be ordered. One of the ways that we could upgrade this service with more funding is to make these publications available on line so that all you have to do is click on the publication you want and it can be downloaded right away. The Homebuyer''s Fair would like to thank Cornell University for providing these materials.</font></span></font></p>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" class="headers" size="4"><b>Needs Assessment</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><b>A House for You:</b></span><b><span class="bodytext"> Learn at Home.</span></b><span class="bodytext"> Packet. Cooperative Extension Service University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583-0804, 402-472-6319.</span></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Home of Your Own.</b><span class="bodytext">Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Before You Buy A Home</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349.</span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Best Buyer Guidebook - Coldwell Banker Takes the Mystery Out of Finding and Financing a Home.</b><span class="bodytext"> Pamphlet. Coldwell Banker Real Estate, Sears Tower, Chicago, Illinois 60684; 312-875-5188. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Condos, Co-ops and PUDs.</b><span class="bodytext">Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>House Planning Handbook.</b><span class="bodytext">Booklet. Midwest Plan Service Iowa State University Cooperative Extension Service, Extension Agricultural Engineer, 170 LeBaron Hall, Ames, Iowa 50011; 515-295-8520.</span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Life-Cycle Housing: Evaluate Before Buying, Building.</b><span class="bodytext">Fact Sheet. North Carolina Cooperative Extension Service, P.O. Box 7605, 210 Ricks Hall, Raleigh, North Carolina 27695-7605; 919-515-2770. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Wise Home Buying. </b><span class="bodytext">Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Housing Choice - Renting or Buying.</b><span class="bodytext">Booklet. University of California Cooperative Extension, 139 Highlander Hall, Riverside, CA 92521.</span></span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Finance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>20 Questions to Ask Before Choosing a Mortgage</b><span class="bodytext"> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Consumer''s Guide to Mortgage Closings.</b><span class="bodytext">Brochure. Federal Reserve Board; Federal Home Loan Bank Board, Division of Consumer and Community Affairs, Washington, DC 20551; 202-452-3946. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Consumer''s Guide to Mortgage Lock-Ins.</b><span class="bodytext"> Brochure. Federal Reserve Board; Federal Home Loan Bank Board, Division of Consumer and Community Affairs, Washington, DC 20551; 202-452-3946. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Quick Guide To Home Loan Choices.</b><span class="bodytext"> Fact Sheet. Marjorie Jensen, Department of Community Planning, University of Rhode Island, Rodman Hall, Kingston, Rhode Island 02881-0804; 401-792-2248. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Affordable Housing - The Cooperative Solution.</b><span class="bodytext">Fact Sheet by Ann Hoyt, John Merrill and Susan Hobert. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Affordability Guidelines For Home Buyers.</b><span class="bodytext"> Fact Sheet. Marjorie Jensen, Department of Community Planning, University of Rhode Island, Rodman Hall, Kingston, Rhode Island 02881-0804; 401-792- 2248. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Alternative Documentation Brochure.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414- 347-6721. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Basics of Sound Underwriting</b><span class="bodytext">Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Buying A Home? How Will You Finance It?</b><span class="bodytext">Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Buying A Home Is Your Best Investment.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Costs.</b><span class="bodytext"> Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Documents You Will Sign.</b><span class="bodytext">Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Handbook on Adjustable Rate Mortgages.</b><span class="bodytext">Brochure. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Family Financial Consultant Handbook.</b><span class="bodytext">Handbook. Laurie Boyce, 433 Lowell, 610 Langden St., Madison, Wisconsin 53706. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial Aspects of Home Ownership.</b><span class="bodytext"> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial Management Extension Consultant Program.</b><span class="bodytext">Program developed for the Minnesota FmHA. University of Minnesota, Minnesota Extension Service, McNeal Hall, 1985 Buford Avenue, St. Paul, MN St. Paul, Minnesota 55108, 612/624-3780. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financing The Home.</b><span class="bodytext"> Booklet by Joseph L. Wysocki. Building Research Council, College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Focus: A Closer Look At ARM Pricing.</b><span class="bodytext"> Booklet. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837 </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Getting Out Of Debt: A Self-Help Guide</b>. <span class="bodytext">Clemson University Cooperative Extension Service, Bulletin Room, 83 Poole Agricultural Center, Clemson University, Clemson, South Carolina 29634-0312; 803-656-3261. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Guide to Single Family Home Mortgage Insurance.</b><span class="bodytext">Brochure. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410-3000; HUD User Line: 800-245-2691.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Helping You Buy The Home You Want.</b><span class="bodytext">Fact Sheet. Private Mortgage Insurance Company, 601 Montgomery Street, San Francisco, California 94111; 800-288-1970</span> \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeowner''s Insurance - How Much Do I Need?</b><span class="bodytext">Booklet. Clemson University Cooperative Extension Service, Bulletin Room, 83 Poole Agricultural Center, Clemson University, Clemson, South Carolina 29634-0312; 803-656-3261. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Equity Loans: A Wise Choice If<span class="bodytext"> . . .</span></b><span class="bodytext"> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Mortgages: Understanding the Process and Your Right to Fair Lending.</b><span class="bodytext"> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Housing Costs -- Buying and Closing.</b><span class="bodytext"> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082</span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>How Mortgage Insurance Works.</b><span class="bodytext"> Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Individual Housing Accounts: An Opportunity for First-Time Home Buyers.</b><span class="bodytext">Fact Sheet (Hawaii-specific). Hawaii Cooperative Extension Service, CTAHR at Manoa, 3050 Maile Way, Gilmore Hall, 203A, Honolulu, Hawaii 96822; 808-956-8397. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Insuring Your Home.</b><span class="bodytext"> Fact Sheet by Joseph Wysocki. Building Research Council, College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Living Resourcefully With Reduced Income.</b><span class="bodytext">Booklet. Minnesota Extension Service, University of Minnesota, McNeal Hall, 1985 Buford Avenue, St. Paul, MN St. Paul Minnesota 55108, 612/624-3780. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Loan Application Checklist.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Preserving Home Ownership -- MGIC''s Loan Workout Program.</b><span class="bodytext"> Book and Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Management Calendar.</b><span class="bodytext">Workbook, Teacher Handbook, Activity Book. Purdue University Cooperative Extension Service, 218A Mathews Hall, West Lafayette, Indiana 47907; 317-494-8356. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Mechanics: Buying A House.</b><span class="bodytext">Fact Sheet. Iowa State University Cooperative Extension Service, 170 LeBaron Hall, Ames Iowa 50011; 515-295-8520. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Matters.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Money Guide.</b><span class="bodytext">Booklet. Federal Trade Commission, Division of Credit Practices and the Office of Consumer and Business Education, Correspondence Branch, Washington, DC 20580; 202-326-2222. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Options For Home Buyers.</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Negotiating For Your Home.</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Private Mortgage Insurance: Questions and Answers.</b><span class="bodytext">Brochure. Private Mortgage Insurance Company, 601 Montgomery Street, San Francisco, California 94111; 800-288-1970. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Refinancing Your Home.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Refinancing Your Home: Questions and Answers.</b><span class="bodytext">Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Scoring For Credit.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Settlement Costs and You.</b><span class="bodytext">Brochure. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410- 3000; HUD User Line: 800-245-2691</span> \r\n                      </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Insurance: What Is It And Why Get It.</b><span class="bodytext">Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span>></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Topics Series H.O.M.E.:</b> </span> </font> </span> </font> \r\n                      <ul>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Housing Costs: How Much Can You Afford.</b><span class="bodytext">(322-TOP-59);</span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Basics.</b><span class="bodytext">(322-TOP-60); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Choices.</b><span class="bodytext"> (322-TOP-61); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustable Rate Mortgages.</b><span class="bodytext">(322-TOP-62); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Government Sponsored Mortgages: FHA, FmHA, VA and SONYMA.</b><span class="bodytext"> (322-TOP-63); </span> </span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Ways To Save On Your Mortgage.</b><span class="bodytext">(322-TOP-64); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Costs.</b><span class="bodytext">(322-TOP-65); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Choosing A Mortgage Work Sheet.</b>(322-TOP-66). <span class="bodytext">Cornell University Cooperative Extension, Publications Distribution, Cornell Business and Technology Park - Building 7 and 8, Thornwood Drive, Ithaca, New York 14850; 607-255-2080</span></span></font></span></font></li>\r\n                      </ul>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Underwriting Self-Employed Borrowers.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What Happens After You Apply For A Mortgage.</b> Brochure. Mortgage Bankers Association of America, 1125 15th Street NW, 7th Floor, Washington, DC 20005; 202-861-6583. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What You Can Do To Prevent Foreclosure Of Your Home.</b> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What You Should Know About ARMs.</b> Brochure. Mortgage Bankers Association of America, 1125 15th Street NW, 7th Floor, Washington, DC 20005; 202-861-6583. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Fixed-Rate Pricing Alternatives.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Home Purchase Contract.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Physical</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Basic House Inspection.</b> Fact Sheet. Cornell University Cooperative Extension, Publications Distribution, Cornell Business and Technology Park - Building 7 and 8, Thornwood Drive, Ithaca, New York 14850; 607-255-2080. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer Checklist.</b> Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Inspection: Taking a Closer Look.</b> Video. Texas Agricultural Extension Service, Texas A&amp;M University, 201 Special Services Building, College Station, Texas 77843; 409-845-1146. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Site Selection.</b> Pamphlet. Community Resource Development, Ohio State University Cooperative Extension Service, Extension Publications, Room 385, Kottman Hall, 2021 Coffey Road, Columbus, Ohio 43210-1044. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Inspecting A House Before You Buy.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>The Energy Wise Home Buyer.</b> Book (HUD PDR-412(2)). US Department of Housing and Urban Development, Thomas P. O''Neill Federal Building, 10 Causeway Street, Boston, Massachusetts 02222, Attention Supply Clerk. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Questions About Condominiums.</b> Book (HUD-365-H(7)). US Department of Housing and Urban Development, Thomas P. O''Neill Federal Building, 10 Causeway Street, Boston, Massachusetts 02222, Attention Supply Clerk.</span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Professional Assistance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Choosing Home-Buying Professionals.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial and Legal Aspects of Buying a Home.</b> Fact Sheet University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583- 0804, 402-472-6319. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Real Estate Brokers.</b> Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Maintenance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Citizen''s Guide To Radon.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002.</span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Asbestos In Your Home.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Biological Pollutants In Your Home.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Energy Efficient Homes Deserve Higher Mortgages.</b> Article by Jeanne Mackin. Consumer News Service, Cornell Cooperative Extension, 1156 Comstock Hall, Ithaca, New York 14853. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Inspection Guide.</b> Booklet No. B3412 by John Merrill. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homebuyer''s Guide To Environmental Hazards.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homebuyer''s Safety and Convenience Checklist.</b> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homewise: The Home Owner''s Information Seminar (1992).</b> Provides an outline for a two-part workshop for homeowners on the basics of home maintenance. Delmar Melton, Director, Westside Home Buyer''s Clinic, 414-933-2300. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Maintenance Correspondence Course.</b> Workbook. Arkansas Cooperative Extension Service, P.O. Box 392, 2201 Brookwood Drive, Little Rock, Arkansas; 501-671-2099. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Protecting Your Housing Investment.</b> Booklet. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410-3000; HUD User Line: 800-245-2691. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Radon: What Is It And What Can You Do About It?</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Simple Home Repairs Inside.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your New Home And How To Take Care Of It.</b> National Association of Home Builders'' Bookstore, 15th and M St. NW, Washington, D.C. 20005</span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Being A Good Neighbor</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>&quot;A House for You&quot; : Learn at Home Packet</b>. Cooperative Extension Service University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583-0804, 402-472-6319. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Investing In Your Community.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>General Interest</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><b><span class="bodytext">Blueprint For Home Organization.</span></b><span class="bodytext"> Brochure. Rubbermaid Inc. Home Products Division, 1147 Akron Road, Wooster, Ohio 44691-6000; 216-264-6464. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Building Research Council.</b> Multiple Publications. Building Research Council. College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Information Center.</b> Multiple publications. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Education Resources.</b> Multiple publications. National Institute for Consumer Education, 207 Rackham Building, Eastern Michigan University, Ypsilanti, MI 48197; Consumer Credit Education Hotline: 800-336-6423 or 313-487-2292. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Builder Bookstore.</b> Multiple general interest books and brochures. National Association of Home Builders, 15th and M Streets NW, Washington, DC 20005; 800-368-5242 or 800-223-2665. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Guide for Older Homes.</b> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Vocabulary.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Youth Activity Guide.</b> Booklet. Greenville Housing Authority, Resident Services, P.O. Box 10047, Greenville, South Carolina 29603; 803-240-3086. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buying The First Time Around.</b> Booklet by John Merrill. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buying and Selling.</b> Article. William E. Murphy, Associate Extension Professor, 128 Ag. Eng. Bldg., University of Kentucky, Lexington, Kentucky 40546-0276, 606/257-3000 ext. 120. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Inside and Out: A Guide To Purchasing Property at Auction.</b> Fact Sheets. New York City Housing Program, Brooklyn Housing Resource Center, Cornell Cooperative Extension, 444 Hopkinson Avenue, Brooklyn, New York 11212; 718-385-0233. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Manufactured Housing for Young Consumers.</b> Teaching Folder. Michigan State University Cooperative Extension Service, 204 Human Ecology Building, East Lansing, Michigan 48824; 517-355-7687.\r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>&quot;Owning a Dream.&quot;</b> Video. Homeowners Marketing Services, P.O. Box9200, Hollywood, Florida 33084; 305-983-0350. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Rutgers University Cooperative Extension Video Lending Library.</b> Rutgers Cooperative Extension of Sussex County, 330 Route 206 South, Newton, New Jersey 07860; 201-579-0985. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>The User Friendly Home.</b> Booklet. University of Nevada Cooperative Extension Service, Reno, NV 89557-0131. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Home, Your Choice.</b> Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. \r\n                      </span></font></span></font></li>\r\n                  </ul>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></font></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (60, 62, 1, 'Privacy policy', '<P><FONT class=maintext>Our Privacy Policy sets out our code of practice for the gathering, storing and sharing of our customers'' personal information. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>The data protecting act </FONT></P>\r\n<P><FONT class=maintext>The Data Protection Act puts obligations on users of personal information and lays down principles for its use. One principle states that information has to be processed fairly and lawfully. This means that you''re entitled to know how we intend to use any information you provide, or that we may obtain from other sources eg. credit reference agencies or your employer. You can then decide whether you want us to have that information. To provide the highest level of customer service we need accurate customer information. You can help by informing us whenever your circumstances change, either by phone, post or while you are logged into your plan on our website. Organisations must lodge a notification with the Information Commissioner, describing the purposes for which they process personal information. The details are publicly available from the Commissioner''s Office at: </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>What are cookies?</FONT></P>\r\n<P><FONT class=maintext>A ''cookie'' is a small piece of information which a website places into your browser and can retrieve later. It cannot be read by any website other than that which placed the cookie. We use cookies for several reasons. For example, we can store your preferences for certain kinds of information, or keep track of your progress through our site. Intelligent Finance uses Microsoft Active Service Pages which need cookies to operate properly. It is important that your browser is set to accept cookies, otherwise you will only be able to access our marketing site. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>How to set your browser to accept or disable cookies? </FONT></P>\r\n<P><FONT class=maintext>The way in which you can set your browser to accept or disable cookies varies slightly according to exactly what browser (and operating system) you are currently using. Below are full instructions for changing your browser settings to accept or disable cookies. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>How do we use your personal information? </FONT></P>\r\n<P><FONT class=maintext>Our main use of your personal information is to look after your plan or to provide the specific service you require. If you apply to us for insurance we will pass your details to the insurer. If you make a claim, any information you give to us or to the insurer may be put on to a register of claims and shared with other insurers to prevent fraudulent claims. A list of the participants is available from the insurer. Occasionally, we may contact you by letter, telephone, email or otherwise to inform you about other products and services which may interest you. We try to limit our customer contact programme to acceptable levels, but if you wish to exercise your right to opt out, simply call us on 0845 609 4343 or write to our Head of Regulatory Risk at the following address: Remember that by opting out of receiving marketing information you''ll not be told of any offers or new products and services which may benefit you. For example, you may not hear about a new savings or mortgage product that offers you a better rate or saves you money. Unless you have given us your consent, we''ll not provide information about you to companies outside our group to use for their own marketing purposes. We disclose information about our customers only with their consent, or if we are required to do so by law. Sometimes we need to give information to our agents and subcontractors so that they can provide a particular service for us. Sometimes these companies may be located abroad in countries that don''t have data protection laws. In these circumstances we always ensure that the information is safe and secure. Your information may also be shared by other members of our group to keep their records up to date and administer your relationship with them. Occasionally, the Banking Code Standards Board who monitor compliance with the Banking Code, audit a sample of our customer records to assess our compliance with the Code. Whenever this happens, strict confidentiality conditions are always imposed. Under the Data Protection Act you''ve the right to have access to information we hold about you on our records. The act allows us to charge a fee of Ј10 for this service. If anything is inaccurate or incorrect, please let us know and we will correct it. If you don''t want to receive unsolicited mail from other companies, you can prevent this by registering with the Mailing Preference Service. In addition the Telephone and Fax Preference Services enable you to object to receiving unsolicited marketing phone calls or faxes from other companies. To register, simply telephone the appropriate number below: </FONT></P>\r\n<P><FONT class=maintext>Credit referencing </FONT></P>\r\n<P><FONT class=maintext>If you apply for an Intelligent Finance credit based product, we''ll perform a search with a credit reference agency. The agency will keep a record of the search. After you open a credit based product, we will provide the agency with regular information about how you use it. Other lenders may use this to make decisions on future applications for credit. It may also be used for tracing debtors and to prevent fraud. When opening jars and plans we may search public records such as the Electoral Roll that are available from Credit Reference Agencies to help us verify your identity. Occasionally we search credit reference and fraud prevention agency files as well as our own internal group records to manage your account and take credit decisions such as whether to offer credit or continue to extend existing credit. These searches are not seen or used by lenders to assess your ability to obtain credit. ''Associations'' linking your financial records may be created on credit reference agency records when you apply for jars or plans in joint names. Your financial records, and those of anyone financially associated with you, may be considered in any future applications you make. This association will continue until one of you successfully files a ''disassociation'' at the credit reference agencies. You''ve the right to apply to the credit reference agencies for a copy of your credit file. You can write to them at any time, enclosing a non-returnable fee of Ј2.00. Please give your name, address, postcode, date of birth and any other address you''ve lived at in the last six years to help them find your information. If there''s anything incorrect on your credit file, you''ve the right to ask the agency to add a Notice of Correction. We use Equifax plc, whilst other members of the HBOS Group also use Experian Limited. A third credit reference agency (Call Credit) has recently started up in the UK. Their addresses are as follows: </FONT></P>\r\n<P><FONT class=maintext>Crime prevention and detection </FONT></P>\r\n<P><FONT class=maintext>Our systems protect customers and ourselves against fraud and other crime. Customer information can be used to prevent crime and trace those responsible. We may check your details with fraud prevention agencies. If you give us false or misleading information and we suspect fraud, we will record this. We and other organisations may use and search these records to help us: make decisions about credit and related services for you and members of your household make decisions on household, life and other insurance proposals and insurance claims for you and members of your household trace debtors, recover debt, prevent fraud and to manage your accounts or insurance policies check your identity to prevent money laundering unless you provide us with other satisfactory proof of identity If you want to receive details of those fraud prevention agencies from whom we obtain and with whom we record information about you, contact us on 0845 609 4343. You have a legal right to these details. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>Email </FONT></P>\r\n<P><FONT class=maintext>If you email us, or give us your email address, we''ll keep a record of it. We may use it to contact you occasionally about our products and services - unless you ask us not to do so. We''ll not give your email address to any unauthorised third parties. When emailing us, always use the email facility on our website to make sure that the content of your email is secure. If you send us email in other ways, remember that it will be ''unsecure'' and could be intercepted. If you do send us ''unsecure'' email, please keep any confidential information in it to a minimum. We''ll do the same when we reply. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>Telephone calls </FONT></P>\r\n<P><FONT class=maintext>We may record telephone conversations to offer you additional security, resolve complaints and improve our service standards. Conversations may also be monitored for staff training purposes. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>Responsibility for customer confidentiality </FONT></P>\r\n<P><FONT class=maintext>All our employees are personally responsible for maintaining customer confidentiality. We provide training and education to all our staff to remind them about their obligations. Our policies and procedures are regularly audited and reviewed. </FONT></P>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (61, 63, 1, 'Electronic Disclosure', 'Electronic Disclosures Authorization<br>\r\nBy applying for a loan online, you agree to accept all applicable disclosures associated with this transaction in an electronic form, including disclosures required by the truth in Lending Act,  Real Estate Settlement Procedures Act and Equal Credit Opportunity Act. Paper copies will be provided for certain real estate related transactions after your loan application is received.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (113, 8, 2, 'Buying home tips', '<TABLE width=555 border=0>\r\n<TBODY>\r\n<TR class=maintext vAlign=top>\r\n<TD>Buying a home is one of the most important things most important thing most people will ever make. For sure, homeownership has great benefits. But it also comes with certain responsibilities.<BR><BR>Be confident, if you are ready for homeownership. Take a look at your current situation and determine if: \r\n<ul class=new>\r\n<li class=new>you have a suitable credit history that shows you are ready for homeownership \r\n<li class=new>you have continuing and reliable source of income prior to applying for the loan \r\n<li class=new>you have money for down payment and closing costs </LI></UL><BR>Once you''ve narrowed down the area where you''d like to live, spend as much time as you can driving around the neighborhoods looking for homes for sale. You''ll not only see what''s being offered, you''ll get to know the neighborhood even better.<BR><BR>Moving home can be quite stressful. There are a number of things to think about when moving and it can often be a lot of hard work. Planning is essential and it is recommended that you start your preparation eight weeks in advance. Use the following checklist to help you keep track of your move:<BR><BR>Eight weeks \r\n<ul class=new>\r\n<li class=new>Start a file for records or receipts that may be needed later for your taxes. \r\n<li class=new>Get estimates for moving companies and/or truck rental. Check for availability and ask about insurance. Don''t forget your car if it requires shipment. \r\n<li class=new>Obtain a reference from your current landlord. \r\n<li class=new>Investigate schools and childcare facilities of your new locality. </LI></UL>Seven weeks \r\n<ul class=new>\r\n<li class=new>Give your new address to your health professionals. Get relevant referrals. \r\n<li class=new>Investigate moving needs for any pets and arrange a check-up for them. </LI></UL>Six weeks \r\n<ul class=new>\r\n<li class=new>Decide what to take, what to store and what to give to charity. \r\n<li class=new>Cancel, transfer, or sell club memberships. \r\n<li class=new>Investigate car insurance premiums for your new area. \r\n<li class=new>Investigate storage options if required, and collect boxes for packing. </LI></UL>Five weeks \r\n<ul class=new>\r\n<li class=new>Give notice to your current landlord or agent. \r\n<li class=new>Organise a garage sale. Place your ad in The Age or The Sydney Morning Herald. Or sell your items at www.ebay.com.au. Contact charities for pick-up of donated items. </LI></UL>Four weeks \r\n<ul class=new>\r\n<li class=new>Party time! Organise a BBQ to use up perishables. \r\n<li class=new>Arrange transfer of school records. \r\n<li class=new>Decide how pets will be moved. \r\n<li class=new>Notify businesses, clubs, organisations and friends. Remember e-mail contacts. \r\n<li class=new>Start packing! Label boxes every box. Plan to carry irreplaceable items. </LI></UL>Three weeks \r\n<ul class=new>\r\n<li class=new>Organise new homes for your plants if need be. \r\n<li class=new>Pre-book utility connections if required. \r\n<li class=new>Give a forwarding address to old employer, lawyer, accountant, etc. \r\n<li class=new>Service your car, especially if you are driving to your new home. \r\n<li class=new>Get hotel reservations if travelling a long way or if your new home is not ready. </LI></UL>Two weeks \r\n<ul class=new>\r\n<li class=new>If you''re moving into or out of a high rise, reserve an elevator with the body corporate. \r\n<li class=new>Get a babysitter for young children on moving day so you can focus on the move. \r\n<li class=new>Close or transfer bank accounts, and get travellers cheques if needed. Empty any safety deposit boxes. Ensure you have cash for the moving day. \r\n<li class=new>Arrange to forward your mail to your new address. Cancel Post Office Box accounts. \r\n<li class=new>Notify insurance and credit card companies of your move. </LI></UL>One week \r\n<ul class=new>\r\n<li class=new>Arrange for house cleaning after you move. \r\n<li class=new>Make charity donations as planned previously. \r\n<li class=new>Back up computer files before dissembling and packing your system. \r\n<li class=new>Contact utilities to cancel or transfer accounts after your moving date, and confirm utilities will be on at your new place before you arrive. \r\n<li class=new>De-frost &amp; clean your refrigerator and freezer; clean your stove. \r\n<li class=new>Confirm your travel plans (flights, hotels, rental cars, etc). Arrange rental truck if needed. </LI></UL>Moving day \r\n<ul class=new>\r\n<li class=new>If moving yourself, pick up rental truck. Load heavy items first \r\n<li class=new>If employing removalist, confirm your new address with the moving company. \r\n<li class=new>Do a final check of cupboards, drawers, etc. \r\n<li class=new>Turn off lights, appliances and hot water system. Lock doors and windows. Leave keys with your old landlord if applicable. </LI></UL>ASAP \r\n<ul class=new>\r\n<li class=new>Update car rego and driver''s licence. </LI></UL></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (112, 7, 2, 'Useful links', '<table border="0" width="555px">\r\n<tr class="maintext" valign="top">\r\n      <td><a  class="mainlink" href="http://www.cml.org.uk/cml/home">Council of Mortgage Lenders</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">The Council of Mortgage Lenders is the trade association for the mortgage lending industry, and our members account for around 98% of UK residential mortgage lending.</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.mfgonline.co.uk/">Mortgage Finance Gazette</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">One of the most popular UK online magazines for brokers and lenders</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.ft.com/home/europe">Financial times</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Financial news for UK and Asia</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.uknetguide.co.uk/Finance/Mortgages/">UkNetGuide</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Unlike Search engines Uk Net Guide is complied by human begins. They bring together all resources you need to find what youРІР‚в„ўre looking for</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n              <tr class="maintext" valign="top">\r\n      <td><a class="mainlink" href="http://www.hud.gov/buying/">Homes and Communities</a></td>\r\n      </tr>\r\n      <tr>\r\n      <td class="maintext">Useful tips and articles on homebuying, owing and selling</td>\r\n      </tr>\r\n      <tr><td  colspan="5">&nbsp;</td> </tr>\r\n</table>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (110, 4, 2, 'In the press', '<TABLE border=0>\r\n<TR class=maintext vAlign=top>\r\n<TD><B>\r\n<H2 class="caption2">Budget 2006 winners and losers</H2></B>How is your pocket affected?<BR><BR>In the table below we have attempted to breakdown the impact of Budget 2006 on typical families and income groups - although it cannot measure the effect of "sin taxes" on cigarettes and beer, and the green taxes on heavily polluting vehicles.<BR><BR>The tax calculations have been provided by KPMG LLP (UK). They summarise the Budget 2006 proposals and other tax changes, which may be amended significantly before enactment. The table is intended to provide a general guide to the subject matter and should not be regarded as a basis for ascertaining liability to tax or determining investment strategy in specific circumstances.<BR><BR>Although endeavours have been made to provide accurate and timely information, there can be no guarantee that such information is accurate as of the date it is received or that it will continue to be accurate in the future. No one should act upon such information without appropriate independent professional advice after a thorough examination of the particular situation.<BR><BR>\r\n<H4>Levels and bases of, and reliefs from, taxation are subject to change.</H4>\r\n<DIV align=right>www.seemoney.co.uk</DIV></TD></TR>\r\n<TR>\r\n<TD>\r\n<HR class="dot_line">\r\n</TD></TR>\r\n<TR class=maintext vAlign=top>\r\n<TD><B>ING sells Deutsche Hypothekenbank</B><BR><BR><I>The Netherlands / Germany - Aug 2006</I><BR><BR>The Dutch bancassurance group ING announced on 10 August 2006 that it had sold its 83.7% stake in the German mortgage lender Deutsche Hypothekenbank.</TD></TR>\r\n</TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (111, 6, 2, 'FAQ', '<table width="100%" border="0">\r\n    <tbody>\r\n        <tr valign="top" class="maintext">\r\n            <td valign="top"><font class="menui_header"><strong>What is a mortgage?</strong></font><br />\r\n            A mortgage is a loan taken out from a mortgage lender to pay for a property. The loan is                    divided into capital, i.e. the amount of money you borrow to purchase the property, and a mortgage interest rate, i.e. the                    amount the lender charges for lending you the money.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><font class="menui_header"><strong>Who is a mortgage broker?</strong></font><br />\r\n            That is a mortgage broker qualified to give you advice on buying a mortgage. Many operate as part of a one or two man band operation, or are tied to estate agent. Some mortgage brokers work from home and rely on referrals from intermediaries such as accountants and solicitors for business, while others work online, using the Internet to generate business.<br />\r\n            There are around 10,000 mortgage products on the market, so it'' a very good idea to consult a mortgage broker for help in finding the right product. They will be able to tell you about the best deals currently available, including some that are exclusive to advisers. They will also be able to offer advice about how to repay your mortgage, home insurance and other financial matters.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><font class="menui_header"><strong>How much mortgage can I get</strong></font><br />\r\n            The amount of money depends on the amount you can comfortably afford to repay each month. It will also depend on the mortgage lender you choose as each has its own guidelines. Some mortgage lenders may only lend you a multiple of three times your income while others may stretch to four, five or even six times.<br />\r\n            <br />\r\n            If you are buying as a couple the mortgage calculation multiples will be different. Some mortgage lenders will lend you two and a half times both annual incomes while others will offer three to three and a half times the greater income plus one times the second income.<br />\r\n            Somehow the major factor getting your mortgage is determined by the amount you earn. Lenders generally apply multiples to your income to calculate your maximum loan. Lenders may be prepared to offer high mortgage multiples if you are putting down a large deposit: because you are committing more of your money to the property it represents stronger security, and they may therefore be prepared to lend you more.<br />\r\n            Your credit history is also important in determining which lenders will be prepared to lend to you, or whether they will offer you their most favorable rates. If you have consistently met your payments under current and previous credit agreements you will be entitled to the more competitive mortgages on the market. If, however, you have failed to keep up your payments, the mortgage rates available are likely to reflect this.<br />\r\n            Finally, the third important factor in determining a lender''s decision is the property itself; the value and general condition of the property will always need to be assessed to ensure that it represents adequate security. Also some lenders have criteria which may rule out certain property types.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>How do I prove                    my income?</strong></font><br />\r\n            <br />\r\n            If you are employed, the mortgage                    lender will request written evidence from your employer such                    as pay slips or other documents proving that you are working                    and get the salary.<br />\r\n            <br />\r\n            If you are self-employed you may                    need to show a mortgage company three years'' audited accounts                    or a letter of confirmation from an accountant if you have not                    been in business long enough to prove that you can afford the                    mortgage repayments.<br />\r\n            <br />\r\n            Many mortgage companies have a                    variety of criteria, some willing to be more flexible than                    others. It is a good idea to speak to an independent mortgage                    broker for getting an impartial advice.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Mortgage                    repayment options</strong></font><br />\r\n            There are three types of                    mortgage repayment options to consider when you are choosing                    your mortgage:<br />\r\n            Capital repayment mortgages allow you to                    repay the loan throughout the term. Your monthly payment is                    made up of both interest and capital repayment so that at the                    end of the term the whole mortgage is repaid. The advantage of                    this repayment method is that, as long as you make all your                    payments, the mortgage is guaranteed to be repaid by the end                    of the term.<br />\r\n            <br />\r\n            If, on the other hand, you opt for                    interest only mortgage payment, your monthly payment will be                    made up solely of interest, so that your borrowing will remain                    the same throughout the term. At the end of the mortgage term,                    assuming you have not made any lump sum repayments, you will                    still owe the same amount that you borrowed in the first                    place. In this scenario it is your responsibility to ensure                    that either a suitable repayment vehicle (such as an endowment                    or pension plan) is in place, or that the loan is repaid by                    means of lump sum repayments or sale of the property. So,                    while this option does mean lower monthly payments, it also                    places added responsibility on you, and potentially greater                    risk.<br />\r\n            <br />\r\n            The final option, so-called &quot;part and part&quot;, is                    to combine the two methods so that you pay interest only on                    part of the loan and capital repayment on the rest. This might                    be suitable if you have, for example, an endowment that is not                    likely to cover the whole of your debt at the end of the term,                    or where you have increased your borrowing and want the                    certainty that the additional borrowing will be repaid by the                    end of the mortgage term.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Advantages and                    disadvantages of different mortgage                    products</strong></font><br />\r\n            <br />\r\n            Different mortgage products have                    specific advantages and disadvantages; your choice of mortgage                    will depend on your specific situation and your attitude to                    both risk and cost.<br />\r\n            <br />\r\n            If your priority is security then                    the logical decision may be to fix your mortgage rate, so that                    your payments will stay the same for an initial period, so                    that during the initial period your payments can drop but not                    increase. The main disadvantage of most fixed and capped rates                    is that if you choose to switch to another mortgage lender,                    and often if you choose to pay your mortgage off early, you                    may have to pay large early repayment charge; if you wish to                    keep your options open, and safeguard future flexibility, this                    can be a major factor in deciding not to choose fixed or                    capped mortgage payment.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Early repayment                    charges...</strong></font><br />\r\n            <br />\r\n            In many cases lenders will                    protect their interests by attaching early repayment charges                    to the initial period of a mortgage, either in line with an                    initial fixed or discounted rate, for example, or beyond the                    initial rate (known as overhang): these may be charged in a                    number of different situations. The lender would almost always                    set an early repayment charge if you change to a different                    lender within the early repayment period set within the                    mortgage offer. They might also charge you if you move house                    or pay the mortgage off in full.<br />\r\n            <br />\r\n            It is of the greatest                    importance to consider what the early repayment charges may be                    when deciding which mortgage product suits your situation: if                    you need to keep your options open with regard to moving                    house, or shopping around for better deals, then a product                    with no early repayment charges would be advantageous. On the                    other hand, if you have no plans to change lender in the                    immediate future, and wish, for example, to fix your monthly                    payment, then an early repayment charge may not matter to you                    at all.<br />\r\n            <br />\r\n            Early repayment charges are generally worked                    out as a percentage of the outstanding balance, and will vary                    widely from lender to lender. One of our responsibilities is                    to ensure that you are fully aware of all penalties that you                    may be charged before you make any final decision as to what                    product best suits your needs.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Do I need a                    deposit for a mortgage?</strong></font><br />\r\n            <br />\r\n            Not necessarily, as                    some mortgage companies try to be as helpful as they can                    particularly to first time buyers. Generally speaking however,                    it does make life easier if you can find a deposit and the                    more you can put down the better, as you will be able to enjoy                    a cheaper and better interest rate.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>To whom will                    most lenders give mortgages?</strong></font><br />\r\n            <br />\r\n            You must be                    over 18 to have a mortgage and most lenders generally                    recommend the mortgage term does not extend beyond your                    retirement age. You will not be discriminated against because                    of your colour, race, ethnic or national origin, your sex or                    if you are disabled. However, you will need to have the right                    to reside and work in the UK for at least the duration of the                    mortgage.<br />\r\n            <br />\r\n            Up to four people can be joined in an                    application. At least one applicant is required to have an                    acceptable form of income and all should have a good credit                    history. Your application will be subject to a credit check                    and you will need to prove your income.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>How long can                    the term of the mortgage be?</strong></font><br />\r\n            <br />\r\n            The usual term                    is 25 years but your loan can be for any term from five to 30                    years. It should ideally end on or before your normal                    retirement age.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Higher Lending                    Charges...</strong></font><br />\r\n            <br />\r\n            Some lenders charge a one off                    insurance premium, known as the higher lending charge, to                    cover themselves in any case of high risk lending, which is                    generally (but not always) defined as lending above 90% of the                    property value. This insurance does not benefit the borrower                    in any way, but covers the lender if, in the event of                    repossession, there is a shortfall in repayment of the                    outstanding debt. Were this situation to arise, the insurance                    company that provided the policy will often pursue the                    borrower for the equivalent of the money claimed by the                    lender.<br />\r\n            <br />\r\n            The one off premium is usually added to the                    loan, rather than being paid upfront at the outset, and the                    borrower will therefore also be paying interest on this                    additional borrowing for the life of the mortgage, unless it                    is paid off with a lump sum or regular                    overpayments.<br />\r\n            <br />\r\n            More and more deals are now being offered                    without an early repayment charge; in our experience many                    people (particularly first time buyers) are needlessly paying                    it. Occasionally, however, a situation could arise where the                    advantages of a particular deal outweigh the disadvantage of                    having to pay the premium. In this case we would clearly                    include the fee, along with all other fees, in our                    illustrations, and its significance would be explained to you                    in full at the outset.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>What is the                    valuation?</strong></font><br />\r\n            <br />\r\n            The mortgage valuation is solely                    for the purposes of a mortgage lender to satisfy itself                    property provides sufficient security for company to lend on                    it. The mortgage valuation does not give any indication                    whether the property is worth what you are paying, nor does it                    provide a comprehensive list of any repairs  required.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>What is a                    valuation fee?</strong></font><br />\r\n            <br />\r\n            Lenders need expert guidance                    on what the property in question is worth as security for them                    to lend on it. They instruct a value to assess the property                    for this purpose.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Portable                    mortgages...</strong></font><br />\r\n            <br />\r\n            If you decide to move home it                    is important to know from the outset whether you have early                    repayment charges as lenders will only charge penalties if you                    change lender, or reduce the loan size, and not (with portable                    mortgages) if you are actually moving to a new home. This can                    be an important factor to take into consideration if, for                    example, you are considering whether or not to go for a long                    term fixed rate: you may not be sure whether you wish to move                    or not during the initial fixed period, but as long as you                    have a portable mortgage you will be keeping this option                    open.<br />\r\n            <br />\r\n            Portability can still be an advantage even when                    your mortgage product has no redemption penalties at all. For                    example, you could have secured a particularly favorable deal                    originally and the market could subsequently have changed,                    leaving no comparable deals: it would obviously make sense in                    this situation to keep the product that you have, rather than                    switching when you move house.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>What happens if                    I can''t afford to make my monthly mortgage                    payments?</strong></font><br />\r\n            <br />\r\n            Always call your lender straight                    away. They will do all they can to help you overcome your                    difficulties and work with you to find a solution. With your                    co-operation they can develop a plan for dealing with your                    financial difficulties and clearing any arrears.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Must I clear my                    mortgage by a certain age?</strong></font><br />\r\n            <br />\r\n            Mortgages are                    usually designed to be repaid no later than the borrower''s                    normal retirement age, usually 65 for employed people (male                    and female) and 70 for self-employed. Most mortgage companies                    will consider a longer term providing the borrower has enough                    income after retirement.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>What happens if                    I lose my job?</strong></font><br />\r\n            <br />\r\n            If you lose your job and                    cannot make your mortgage payments your house could be at                    risk. It is strongly recommended you take out a mortgage                    accident sickness and redundancy policy in connection with                    your mortgage, which will pay your loan repayments for up 12                    months, while you get back on your feet.<br />\r\n            </td>\r\n        </tr>\r\n        <tr valign="top" class="maintext">\r\n            <td><br />\r\n            <font class="menui_header"><strong>Is it safe to                    transmit my mortgage application over the                    Internet?</strong></font><br />\r\n            <br />\r\n            Security of your personal                    information is a prime concern to all mortgage lenders and                    intermediaries. Online mortgage application forms enable you                    to enter your application details and transmit them                    electronically to the lenders in a secure environment. Lenders                    use the most up-to-date security techniques to ensure the                    details of your online mortgage application are received                    securely.<br />\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (109, 3, 2, 'About Us', '<font class="maintext">We has built a strong reputation as an outstanding mortgage brokerage firm serving the lending needs of real estate professionals, builders and individual homebuyers throughout New Jersey and Maine.<br />\r\n<br />\r\nAnd, now it&quot;s our pleasure to offer all of our exceptional mortgage services online. Through our company you not only have access to the best loans available in the marketplace, but you can review loan alternatives, and even apply for your loan, at your convenience, online - 24 hours a day.<br />\r\n<br />\r\nOur company goal is to search the mortgage market to find you the most competitive deal, one that matches your needs and circumstances. You can<br />\r\n<br />\r\nThank you for visiting our web site. We look forward to putting our mortgage service to work for you! </font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (114, 9, 2, 'How to get a better Mortgage', '<table>\r\n      <tr class="maintext" valign="top">\r\n      <td>You are  looking for a better mortgage? Why not talk to our company? Our team of independent mortgage advisors are on hand to give friendly and clear advice on all the different types of mortgages available.<br><br>\r\n      Choosing the mortgage that is best suited to your special needs has never been more difficult. Banks, Trust and Insurance companies are continually inventing new mortgage products to capture your attention, and hopefully your business. In addition, ensuring that you get the best possible rate and product depends on aggressively shopping the mortgage marketplace. As an recognized mortgage professional company, we I will also look at the rest of your debt obligations and determine if they can be restuctured to lower your interest costs.<br><br>\r\n      Our representatives will be able to tell you everything you need to know about the best Europe mortgages at the moment and give you advice about how to repay your mortgage, any insurance you might need as a homeowner and other financial matters. Once they have given you an idea of the amount you can borrow you can start looking for a property.\r\n      </td>\r\n      </tr>\r\n</table>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (115, 10, 2, 'Switching lenders', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>If your are unhappy with your current \r\n                  lender and think you are paying too much, why not to contact \r\n                  out team?We are always on hand to give friendly and clear \r\n                  advice when you need it.<BR>Are you thinking about \r\n                  remortgaging? Just call us at<BR>0000000000000 \r\n            </TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (116, 11, 2, 'The procedure', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>To \r\n                  help you understand the mortgage procedure we have collected \r\n                  all our experience and published it here.<BR>Please read this \r\n                  carefully and contact us with any questions.<BR><BR><B>Step \r\n                  One: Initial Contact</B><BR><BR>Initial contact is first and \r\n                  very important step. On this meeting our representatives will \r\n                  take a few basic details from you and allocate a dedicated \r\n                  mortgage adviser to you. You''ll get all important data on \r\n                  mortgage, we''ll view your current situation and will be able \r\n                  to give you professional advice. Here, on this meeting, you''ll \r\n                  be advised a personal consultant, who''ll be responsible for \r\n                  your mortgage and who''ll be able to answer all your questions \r\n                  and assist you there.<BR>Be sure that you''ll leave your first \r\n                  meeting feeling more informed regarding the choices available \r\n                  to you.<BR><BR><B>Step Two: After the meeting</B><BR><BR>Your \r\n                  broker will research the entire mortgage market (over 18,000 \r\n                  products) for you and using the information from the initial \r\n                  meeting will recommend a handful of products (usually two to \r\n                  five) that are most suitable for your individual \r\n                  circumstances. We''ll then arrange a mortgage agreement in \r\n                  principle (AIP).<BR><BR>We''ll continue to research the market \r\n                  and keep you updated on a weekly basis with any changes and \r\n                  information on lenders and interest rates. A case manager will \r\n                  oversee all the paperwork and will act as source of contact, \r\n                  should your adviser be unavailable, answering any questions \r\n                  that you may have and assisting your adviser in obtaining your \r\n                  mortgage offer in the shortest time possible.<BR><BR><B>Step \r\n                  Three: Mortgage decision</B><BR><BR>Once you have decided on a \r\n                  mortgage we will process your application, advise you if any \r\n                  additional information is required and then check the formal \r\n                  offer once it is returned from the lender.<BR><BR>Now you''ll \r\n                  be ready for mortgage and you''ll have all important \r\n                  information about \r\n        lending.<BR><BR></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (117, 12, 2, 'Loans for non-residents', '<TABLE>\r\n              <TBODY>\r\n              <TR class=maintext vAlign=top>\r\n                <TD>Our services are available for \r\n                  both European and non-European customers.<BR><BR>Mortgage \r\n                  Company can help non-resident investors to enjoy the \r\n                  advantages of owning European residential property through our \r\n                  finance arrangements with highly respected lenders. The home \r\n                  loans for non-residents program is only available for purchase \r\n                  of residential property by borrowers who do not ordinarily \r\n                  reside or pay taxes in Europe i.e non-European residents \r\n                  earning their income overseas.<BR>You, as an applicant must \r\n                  have permanent full time employment and good credit \r\n                  history.<BR>Just make us a call and learn more \r\n                  :<BR>000000000000<BR><BR></TD></TR></TBODY></TABLE>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (118, 13, 2, 'Fixed Rates', '<FONT class=subheader>30 Year Fixed Rate Program</FONT><BR><BR><FONT class=maintext>30 year fixed mortgage is a type of mortgage loan that is repaid by the borrower making 360 equal monthly payments over a period of 30 years. Since the borrower''s payments are ''fixed'', the borrower can expect to make the same monthly payment for the entire term of the loan. A 30 year mortgage loan is the most widely accepted program used to finance a residential purchase, and is available for conventional, jumbo, FHA and VA loans. </FONT><BR><BR><FONT class=subheader>15 Year Fixed Rate Program</FONT><BR><BR><FONT class=maintext>A 15 year fixed mortgage is a type of mortgage loan that is repaid by the borrower making 180 equal monthly payments over a period of 15 years. Since the borrower''s payments are ''fixed'', the borrower can expect to make the same monthly payment for the entire term of the loan. A 15 year mortgage loan is the most widely accepted program used to finance a residential purchase, and is available for conventional, jumbo, FHA and VA loans. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (119, 22, 2, 'Call back form', '<font class="maintext">\r\nDear %FULLNAME%, <br>Thank you for contacting our Team.<br>Your details have been accepted, and we''ll contact you shortly.<br><br>%SIGN%\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (120, 14, 2, 'Variable rate mortgage', '<font class="maintext">\r\nThe Variable-Rate Mortgage is offered at the prime rate less 0.25%1 and is adjusted every month. That way, you enjoy a discount on the lowest possible rate on the market! The variable payment is adjusted monthly in relation to interest rate movements and in keeping with the remaining amortization. This option minimise the amount of the payment.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (121, 15, 2, 'Capped rate mortgage', '<FONT \r\n            class=maintext>This is a mortgage that is guaranteed not to rise above \r\n            a specific rate (the ''cap'') within a set period. Unless this is \r\n            combined with another rate, such as a Discount or Tracker, the \r\n            Lender''s SVR will be charged if it is lower than the capped rate; if \r\n            it rises above this ceiling the rate charged will remain at the \r\n            capped level. There are often early repayment charges applicable if \r\n            the loan is repaid within the capped period. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (122, 16, 2, 'Remortgage rates', '<FONT \r\n            class=maintext>For many people, their home is their biggest investment \r\n            and source of savings. When they need to borrow money for major \r\n            expenses, or to pay off accumulated debts, they can use their home \r\n            value to borrow money.<BR><BR>Pay off your credit cards<BR>If you \r\n            have credit card or other consumer loans, it is often less expensive \r\n            to consolidate these expensive loans with your \r\n            mortgage.<BR><BR>Credit card interest rates are usually much higher \r\n            than mortgage interest rates. And, the interest on your mortgage is \r\n            tax deductible, while the interest on your credit card is \r\n            not.<BR><BR>If you have enough home equity, you may be able to pay \r\n            off your pricey credit card debts and save money.<BR><BR>Refinance \r\n            vs. home equity loan<BR>Generally, there are two ways to use your \r\n            home equity to borrow money. You can either refinance with a new \r\n            mortgage that is larger than your remaining balance (a cash-out \r\n            refinance) or get a home equity loan.<BR><BR>A cash-out refinance is \r\n            generally cheaper, but a home equity loan will usually let you \r\n            borrow more. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (123, 17, 2, 'Self Certification', '<FONT \r\n            class=maintext>This is a mortgage where a borrower states their income \r\n            and signs a confirmation of their ability to repay a loan, without \r\n            having to provide evidence such as accounts, payslips or bank \r\n            statements. Consequently, S/C rates are often higher than standard \r\n            Full Status mortgages. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (124, 19, 2, 'Buy-to-let mortgages', '<FONT \r\n            class=maintext>Whether you are buying your first buy-to-let property \r\n            or you are a portfolio investor there is some financial information \r\n            you need to know about:<BR><BR>\r\n            <OL type=1>\r\n              <LI>What choices of mortgage interest rates and products are \r\n              available\r\n              <LI>What is the maximum available loan\r\n              <LI>An illustration of costs and monthly payments\r\n              <LI>An analysis of returns from your investment \r\n            properties</LI></OL>Our buy-to-let quotation system will give you \r\n            all of this and more FREE OF CHARGE while you are online. <BR><BR>We \r\n            only select and recommend those buy-to-let lenders whose products \r\n            are competitive and whose service standards match those we \r\n            constantly strive to achieve. </FONT>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (125, 20, 2, 'Commercial mortgages', '<font class="maintext">\r\nWe offer commercial loan programs to suit nearly every borrower and property type. Successful commercial real estate financing is dependent upon the availability of competitive funding. My commercial loan programs are fast financial solutions for commercial property owners and investors.<br>Property Types<br><br><ul><li>Multi-Family<br>Traditional, multi-family residential complexes located in both city and suburban markets.</li><li>Mixed-Use<br>Properties that integrate and combine residential with different uses, including retail and office spaces.</li><li>Office<br>Traditional office or office type properties.</li><li>Retail<br>Properties with a mix of tenants that meet the convenience needs of neighborhood residents, including video stores, grocery, and financial services companies.</li><li>Light Industrial<br>Single- or multi-tenanted spaces used for warehouse, manufacturing, distribution, or research and development. We offer loans from $250,000 to $3 million in Fixed Rate programs with 25 and 30 year amortization. Adjustable rate programs are available with a 3-year below market start rate. Our loans have competitive rates and quick decision times.</li><ul>\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (126, 18, 2, 'Cashback mortgages', '<font class="maintext">\r\nThis is a mortgage in which the Lender refunds a sum of money, either as a percentage of the loan or a flat figure, to the borrower upon completion. With this type of offer the borrower will typically be tied to the Lender''s SVR by early repayment charges necessitating repayment of the cashback if the loan is repaid within a set period.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (127, 21, 2, 'Contact us', '<font class="maintext">\r\nDear %FULLNAME%, <br>Thank you for contacting our Team.<br>Your details have been accepted, and we''ll contact you shortly.<br><br>%SIGN% \r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (128, 23, 2, 'Leave a comment', 'Thank you. Your message was sent to administrator.<br><br>%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (129, 29, 2, 'Arm''s', '<font class="maintext">\r\n1, 3, 5, 7, 10 Year Adjustable Rate Loan Programs<br><br>\r\nAn Adjustable Rate Mortgage (ARM) is a mortgage loan that is most widely known for its low starting interest rate (when compared to the 30 & 15 year mortgage loans). This ''low'' introductory rate is used to calculate the mortgage payment for a specified period of time. Once this introductory period is over, the interest rate is adjusted periodically based on a preselected index. The most commonly used index is the yield on the one-year Treasury Bill. The new interest rate is determined by adding this index to a set margin (which is determined by the lender). Although there are a variety of adjustable rate mortgage programs available, the most common program is the One Year Adjustable Mortgage (one Year ARM). The interest rate on the one year ARM is adjusted once each Year, for 30 years. APR''s on variable rate loans are subject to increase but may decrease from year-to-year, the borrower should be prepared to handle an increase in his/her monthly payment (should the index rate increase).\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (130, 30, 2, 'Jumbo', '<font class="maintext">\r\nA jumbo mortgage is a mortgage loan which is larger than the limits set by Fannie Mae and Freddie Mac ($322,700 as of 1/1/2003). Since these two agencies will not purchase these types of loans, they usually carry a higher interest rate (to enhance their value and marketability to investors).\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (131, 31, 2, 'Rate Watch', 'Welcome to Rate Watch!<br><br>\r\nWe''d like to offer you an easy way to stay informed about trends in loan rates without having to track them actively either on the Internet or with multiple phone calls to your broker! Now you can easily track our mortgage rates to help you determine when you should lock in an interest rate or refinance. <br><br>Simply join Rate Watch: it''s free.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (132, 32, 2, 'Bad Credit Ok', '<font class="maintext">\r\nYour credit report may be full of dings, compounded with a history of foreclosure and bankruptcy, but you may still get a loan for home purchase, refinance, or even cash out of your current home. It doesn''t matter whether you have charge-offs, collections, or tax liens on your credit report, as long as you can meet the specific guidelines for loan approval by a multitude of lenders specialized in the credit-damaged borrower.<br><br>\r\nThe lending industry uses categories to asses the credit risk of any particular borrower. If the property checks out and you have sufficient income, impeccable credit and the required down payment you are considered an ''A'' borrower. An ''A'' borrower can walk into almost any lender and get a mortgage loan. A borrower can fall short in one of these areas and still be considered an ''A'' borrower, as long as the other areas can compensate for the weakness. For example, a borrower that exceeds the required monthly debt-to-income ratios (28% housing debt and 36% combined debt) could offer a large down payment. Many lenders will also excuse modest credit ''blemishes'' if a reasonable explanation is provided (i.e. job transition, medical problems). Being 30-60 days late on one credit card payment is a typical blemish that could be accepted by a lender.<br><br>\r\nBut what about those that have more serious marks against their credit. Depending on how tarnished your credit history has been, lenders will typically place borrowers into the following credit categories, which are qualified by time frames:<br><br><br>\r\nA-minus credit:<br>\r\nAcceptable blemishes within the last two years: Charge-offs, or collection accounts, of minor amounts (e.g. less than $500 in all) are acceptable. Medical bills, including hospitalization and clinic visits, are usually disregarded by the lender. As for payment habits, the borrower can have no more than two 30 days late payments, or one 60 days late payment on revolving or installment credit.<br><br>\r\nB credit:<br>\r\nAcceptable blemishes within the last 18 months: Up to four 30 days late , or up to two 60 late days payments are allowed on revolving and installment debt. If the credit ding is an isolated incident, a 90 days late payment is allowed within the last 12 months. Charge-offs, or collection accounts, which are isolated, insignificant, and less than $1,000 in all, are acceptable. However, outstanding collection accounts less than four years old must be paid. Bankruptcy or foreclosure that had been discharged or settled previous to the 18 month time frame is allowed.<br><br>\r\nC credit:<br>\r\nAcceptable blemishes within the last 12 months: No more than six 30 days late payments, three 60 days late payments, or two 90 days late payments are allowed on revolving or installment credit. Open collections accounts and charge-offs may not exceed $4,000 and must be paid in full. Bankruptcy or foreclosure that had been discharged or settled prior to the last 12 months is acceptable.<br><br>\r\nD credit:<br>\r\nA sporadic disregard for timely payment or credit standing categories the borrower in this class. Open collections accounts, charge-offs, and judgements must be paid through loan proceeds. The borrower who had filed bankruptcy and had been discharged prior to the last six months is acceptable, as much as the ex-homeowner who had his previous home foreclosed and settled prior to the last six months. However, mortgage payments cannot be longer than 90 days past due.<br><br>\r\nThe above are general industry guidelines to make lending judgement on the borrower''s loan application. There are no hard-and-fast rules of separating the borrower on the border line between one credit category and another. Also, there are compromising variations between one lender to the next depending on the degree of subjectivity involved in underwriting and how much each lender wants to commit their funds.<br><br>\r\nDown payment requirements are being reduced<br>\r\nTypical lenders in the market of credit-damaged borrowers usually lend only up to 80% of the appraised value of the home, so the borrower often has to have 20% equity or come up with a 20% down payment for a purchase. Extensive shopping may uncover a company that will lend a greater percentage.<br><br>\r\nWhat about income? A-minus and B-credit borrowers are often allowed to allocate 50% of their income to pay for combined monthly debt (compared to the standard 36% guideline used for A credit borrowers), while the bottom rung of the credit ladder can be stretched to 60%. As for proof of income, some lenders do have "Stated Income" programs which do not require tax returns, W-2s, or pay stubs, but may require up to 6-month bank statements to verify income activity.<br><br>\r\nDepending on the extent of the blemishes, borrowers with less-than-perfect credit histories can expect to pay higher than market interest rates for their home loan. But if getting into a home or refinancing out of a bind is one''s goal, there are plenty of lenders out there among whom the homebuyer or borrower can shop around to get the appropriate financing. If you are having trouble finding a lender that caters to borrowers with less than perfect credit, you might want to consult with a mortgage broker. Since brokers typically deal with a multitude of lenders, they might know of lenders that make such loans.</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (133, 33, 2, 'Refinancing', '<font class="maintext">\r\nFor many people, their home is their biggest investment and source of savings. When they need to borrow money for major expenses, or to pay off accumulated debts, they can use their home value to borrow money.<br><br>\r\nPay off your credit cards<br>\r\nIf you have credit card or other consumer loans, it is often less expensive to consolidate these expensive loans with your mortgage.<br><br>\r\nCredit card interest rates are usually much higher than mortgage interest rates. And, the interest on your mortgage is tax deductible, while the interest on your credit card is not.<br><br>\r\nIf you have enough home equity, you may be able to pay off your pricey credit card debts and save money.<br><br>\r\nRefinance vs. home equity loan<br>\r\nGenerally, there are two ways to use your home equity to borrow money. You can either refinance with a new mortgage that is larger than your remaining balance (a cash-out refinance) or get a home equity loan.<br><br>\r\nA cash-out refinance is generally cheaper, but a home equity loan will usually let you borrow more.</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (134, 34, 2, '125% Ltv', '<font class="maintext">\r\nThis popular loan program is a great way to reduce your monthly payments by allowing you to consolidate those high rate credit cards and installment loans. Cashing-out equity for home improvement or for an investment opportunity may be another reason for selecting this type of loan program.<br><br>\r\n\r\nExample of how you may benefit from our 125% LTV loan program<br><br>\r\n\r\n...Before Refinance:<br>\r\nHome Value: 200,000<br>\r\nCredit Card Debt: 75,000<br>\r\nRate: 6.85%<br>\r\nTerm: 30 Years<br>\r\nMortgage Payoff: 150,000<br>\r\nMonthly Mortgage Payment: 982.00<br>\r\nMonthly Debt Payment: 1,250<br><br>\r\n\r\n...After Refinance:<br>\r\nNew Loan: 237,000<br>\r\nNew Rate: 7.25%<br>\r\nNew Payment: 1,616.76<br>\r\nOld Payment: 982.00 + 1,250 = 2,232.00<br>\r\nMonthly Payment Savings = $615.24<br>\r\nYearly Savings: 7,382.88<br>\r\n3-Year Savings: 22,148.64<br>\r\n5-Year Savings: 36,914.40<br><br>\r\n\r\n* Payments based on 30 Year Amortization, 100% ltv, 1st lien position, 7.25% rate, 7.35% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guide lines\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (135, 35, 2, '100-102% Ltv', '<font class="maintext">\r\nLooking for a 100% financing on your new home mortgage? We have several lenders who can offer you this excellent type of loan program. Some even allow up to 6% seller concessions to pay your closing costs! If you are looking for max LTV, submit your loan application today and pre-qualify by tomorrow!\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (136, 36, 2, 'Interest Only', '<font class="maintext">\r\nThis type of loan program is for those who would like to significantly lower their mortgage payments by allowing you to pay only the interest on the loan. This type of loan is great for debt consolidation up to 100% LTV.<br><br>\r\n\r\nExample of how you may benefit from an Interest Only Loan Program<br><br>\r\n\r\n...Before Refinance:<br>\r\nMortgage Balance: 225,000<br>\r\nRate: 7.5%<br>\r\nTerm: 30 Year<br>\r\nMonthly Mortgage Payment: 1,573.23<br><br>\r\n\r\n...After Refinance:<br>\r\nNew Loan: 225,000<br>\r\nNew Rate: 3.75%<br>\r\nNew Payment: 703.00<br>\r\nOld Payment: 1,573.23<br>\r\nMonthly Payment Savings: 870.23<br>\r\nYearly Savings: 10,442.76<br>\r\n3-Year Savings: 31,328.28<br>\r\n5-Year Savings: 52,213.80<br><br>\r\n\r\n* Payments based on 30 Year Amortization, 80% ltv, 1st lien position, 3.75% rate, 3.85% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guide lines<br>\r\nHome Equity Line (HELOC)<br><br>\r\n\r\nThis type of program is very popular for those looking to do home improvements and who are not interested in tapping into all of their home''s equity at one time. With this type of program you can draw on your equity at your leisure making this an excellent loan program that you control. A "HELOC" is usually setup on an interest only payment and is fixed to either the LIBOR or Prime index and can be used for at least 10 years before principal payments are required.<br><br>\r\n\r\nExample of How and Interest Only HELOC Payment is Calculated:<br><br>\r\n\r\nRate + Index x Remaining HELOC Balance/divided by 12 Months = Mo. Payment<br><br>\r\n\r\n4.25 + 1.00 x 35,000 /12 Mo. = $125.00<br><br><br>\r\n     \r\n    \r\n* Payments based on 30 Year Amortization, 80% LTV, 1st lien position, 5.25% rate, 5.35% APR.<br><br>\r\n\r\nAPR may vary depending on term and amount.<br>\r\nRates are subject to change.<br>\r\nLoan application subject to credit and underwriting guidelines\r\n\r\n\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (137, 37, 2, 'Home Equity', '<font class="maintext">\r\nA home equity line is a form of revolving credit in which your home serves as collateral. Because the home is likely to be a consumer''s largest asset, many homeowners use their credit lines only for major items such as education, home improvements, or medical bills and not for day-to-day expenses.<br><br>\r\nWith a home equity line, you will be approved for a specific amount of credit-your credit limit-meaning the maximum amount you can borrow at any one time while you have the plan.<br><br>\r\nMany lenders set the credit limit on a home equity line by taking a percentage (say, 75 percent) of the appraised value of the home and subtracting the balance owed on the existing mortgage. For example:<br><br>\r\n\r\n<center>\r\n<table width="70%" bgcolor="#E6E6E6" cellspacing=1>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Appraisal of home</td><td width="50%" class="maintext">$100,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Percentage</td><td width="50%" class="maintext">x75%</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Percentage of appraised value</td><td width="50%" class="maintext">$75,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Less mortgage debt</td><td width="50%" class="maintext">-$40,000</td></tr>\r\n<tr bgcolor="#FFFFFF"><td width="50%" class="maintext">Potential credit line</td><td width="50%" class="maintext">$35,000</td></tr>\r\n</table>\r\n</center><br>\r\nIn determining your actual credit line, the lender also will consider your ability to repay, by looking at your income, debts, and other financial obligations, as well as your credit history.<br><br>\r\nHome equity plans often set a fixed time during which you can borrow money, such as 10 years. When this period is up, the plan may allow you to renew the credit line. But in a plan that does not allow renewals, you will not be able to borrow additional money once the time has expired. Some plans may call for payment in full of any outstanding balance. Others may permit you to repay over a fixed time, for example 10 years.<br><br>\r\nOnce approved for the home equity plan, usually you will be able to borrow up to your credit limit whenever you want. Typically, you will be able to draw on your line by using special checks.<br><br>\r\nUnder some plans, borrowers can use a credit card or other means to borrow money and make purchases using the line. However, there may be limitations on how you use the line. Some plans may require you to borrow a minimum amount each time you draw on the line (for example, $300) and to keep a minimum amount outstanding. Some lenders also may require that you take an initial advance when you first set up the line.<br><br>\r\n\r\n\r\n<font class="subheader">Costs to Obtain a Home Equity Line</font><br><br>\r\n<font class="maintext">\r\nMany of the costs in setting up a home equity line of credit are similar to those you pay when you buy a home. For example:<br>\r\n\r\n<ul>\r\n <li>A fee for a property appraisal, which estimates the value of your home.</li>\r\n <li>An application fee, which may not be refundable if you are turned down for credit.</li>\r\n <li>Up-front charges, such as one or more points (one point equals one percent of the credit limit).</li>\r\n <li>Other closing costs, which include fees for attorneys, title search, mortgage preparation and filing, property and title insurance, as well as taxes.</li>\r\n <li>Certain fees during the plan. For example, some plans impose yearly membership or maintenance fees.</li>\r\n <li>You also may be charged a transaction fee every time you draw on the credit line.</li>\r\n</ul><br>\r\n\r\n<font class="subheader">Comparing a line of credit and a traditional second mortgage loan</font><br><br>\r\n<font class="maintext">\r\nIf you are thinking about a home equity line of credit you also might want to consider a more traditional second mortgage loan. This type of loan provides you with a fixed amount of money repayable over a fixed period. Usually the payment schedule calls for equal payments that will pay off the entire loan within that time. You might consider a traditional second mortgage loan instead of a home equity line if, for example, you need a set amount for a specific purpose, such as an addition to your home.<br><br>\r\nIn deciding which type of loan best suits your needs, consider the costs under the two alternatives. Look at the APR and other charges. You cannot, however, simply compare the APR for a traditional mortgage loan with the APR for a home equity line because the APRs are figured differently.<br>\r\n\r\n<ul>\r\n <li>The APR for a traditional mortgage takes into account the interest rate charged plus points and other finance charges..</li>\r\n <li>The APR for a home equity line is based on the periodic interest rate alone. It does not include points or other charges.</li>\r\n</ul>    \r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (138, 38, 2, 'No Doc - Limited', '<font class="maintext">\r\nOur No-Doc/Limited Doc Loan programs offer self-employed business owners an easy way to qualify for a mortgage. We have several lenders who offer very competitive No-Doc/Limited Doc programs with excellent rates and flexible terms for those who have the credit score to qualify.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (139, 39, 2, 'Stated Income', '<font class="maintext">\r\nOur "stated" income program is a loan program offered by many of our lenders. This program is great for self-employed borrowers and allows you to "State" your income without the need for verification. Our stated income program allows a borrower to meet the "Debt-To-Income" ratio required by our lenders.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (140, 40, 2, 'Construction', '<font class="maintext">\r\nWhether you''re planning to build your dream home or just thinking about it, we can help. We can answer your questions, and guide you through the loan process. We''ll be with you every step of the way from framing your front door to turning the key. At Family Home Lending, we''re home construction lending experts. We can answer your questions and your builder''s questions so your project keeps moving smoothly from groundbreaking to housewarming. Our Construction-to-Permanent Loan is based on ordering an appraisal based on the future value of the home.  That''s right I said future appraised value of you home.  We can lend 90% of the future appraised value of a primary home, and 80% of the future appraised value  for a spec home.  The construction loans is based on the actual cost which can include the purchase of the land.<br><br>\r\n\r\nWe can offer new construction loans on the following property types:<br><br>\r\n\r\n<ul style="font-weight: bold">\r\n  <li>Primary Homes</li>\r\n  <li>Second Homes</li>\r\n  <li>Modular Homes</li>\r\n  <li>Spec. Homes for Builders</li>\r\n  <li>Complete Rehabilitation</li>\r\n</ul>\r\nThis means with one application, you get all the financing you need in two easy processes your construction and permanent loan. All fees and points will be built into both mortgages.  Based on the project if it has enough value we can finance your land and wrap your closing cost into your construction loan up front.  Below you will find the list of items you will need to get your construction loan started.<br><br>\r\n\r\n<ul style="font-weight: bold">\r\n  <li>Plans and Specifications</li>\r\n  <li>Plot Plan</li>\r\n  <li>Proof of a Land contract or a Deed</li>\r\n  <li>Proof the Land is build able from your local Building Inspector</li>\r\n  <li>Title Commitment</li>\r\n  <li>Homeowners Insurance</li>\r\n  <li>Line item list of all cost to build your project</li>\r\n</ul>\r\nTerms of the construction loan are for 3 or 6 month periods. This loan program offers interest only (up to 5 draws) 30-year amortization.\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (141, 24, 2, 'Sent application/credit report', 'Dear, %FULLNAME% Thank you for filling the application form.\r\n\r\nWeРІР‚в„ўll review it shortly and will let you know the results as soon as possible. \r\n\r\n%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (142, 41, 2, 'Apply Online', 'Applying for a loan or getting more information is easy. We offer you several convenient and secure options to get started.<br><br>\r\n\r\n1. Get pre-qualification letter <br>\r\n2. Fill out our Short Application Form. This process will take 2-4 minutes. I will contact you once I receive your application.<br>\r\n3. Fill out our Long Application Form. This process will take 2-4 minutes. I will contact you once I receive your application. (We will need this form completed eventually.)<br>\r\n4. We use the most cutting edge technology available to close loans quickly, at a low cost. By combining the use of the Internet along with advanced processing software and automated underwriting systems.  We have taken the mystery out of approving and closing a home loan.  This means that you can now get a loan faster, at a lower cost, with less paperwork and less stress!<br>\r\n\r\n5. Have one of our Loan Officers contact you<br> 6. Please mail me a loan application.<br> 7. Download the application material now and mail or fax it to me. \r\n<br><br>\r\n\r\nDocuments Required<br><br>\r\n\r\n<ul>1.  <u>Purchase/Refinance Loans</u><br><br><ul>Instructions for completing loan application<br><br>1.  Complete and sign 3 or 4 page residential loan application Form 1003 and attached loan info sheet, credit authorization and fair lending notice. Page 4 of the application is a continuation page in case you need additional space for your assets or liabilities. If you make a mistake while filling out the application cross it out, and make a change. Do NOT use white out.<br>2.  If you are salaried: provide two years W-2 and one month of paystubs OR if you are self-employed: provide two years tax returns and a YTD profit and loss statement.<br>3.  If you own rental property, please provide rental agreements and two years tax returns.<br>4.  If you wish to speed up the approval process, please also provide three months bank statements for each bank, stock and mutual fund account.<br>5.  Provide recent copies of any stock brokerage or IRA/401K accounts that you may have.<br>6.  If you are requesting a cash out refinance please provide a letter explaining what you plan to do with the proceeds.<br>7.  Provide copy of divorce decree if applicable.<br>8.  If you are NOT a US citizen provide us with a copy of your green card (front & back), or if you are NOT a permanent resident provide us with your H-1 or L-1 visa.<br><br></ul>2.  <u>Credit Lines/Home Equity Loans</u><br><br><ul>Instructions for completing loan application<br><br>1.  Complete and sign 3 or 4 page residential loan application Form 1003 and attached loan info sheet, credit authorization and fair lending notice. Page 4 of the application is a continuation page in case you need additional space for your assets or liabilities. If you make a mistake while filling out the application cross it out, and make a change. Do NOT use white out.<br>2.  If you are salaried: provide two years W-2 and one month of paystubs OR if you are self-employed: provide two years tax returns and a YTD profit and loss statement.<br>3.  If you own rental property, please provide rental agreements and two years tax returns.<br>4.  Please provide a copy of the note on your 1st mortgage. This will normally be found in your closing loan documents.<br>5.  Please provide a signed letter explaining what you plan to do with the proceeds.<br>6.  Provide copy of divorce decree if applicable.<br>7.  If you are NOT a US citizen provide us with a copy of your green card (front & back), or if you are NOT a permanent resident provide us with your H-1 or L-1 visa.</ul></ul>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (143, 26, 2, 'Login page', 'Before filling an application form please register here.<br>Your details will not be passed to other companies or used for marketing purposes.Once you register, you''ll get more access to site features, and will help you in the mortgage process understanding.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (144, 25, 2, 'Registration page', 'Register in this form to receive information on your Loan Status modification.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (145, 27, 2, 'Borrower homepage', 'Dear, %FULLNAME%<br><br>It''s always nice to meet you here.<br>On your own panel, you can complete your own information, continue filling your allocation, view your results and communicate directly with your borrower.<br><br>%SIGN%');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (146, 28, 2, 'Saved changes confirmation', 'Dear,  %FULLNAME%<br>\r\nThe changes you have made here were successfully saved.<br><br>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (147, 42, 2, 'Mortgage Rates', '<font class="maintext">\r\nWe will provide you a low cost home, refinance, construction or commercial loan. Enjoy a fast, hassle-free, no-nonsense service from a company that cares, with years of experience, and the determination to get what you want! We can show you in detail how we can save you and your family a fortune on your mortgage loan with our low interest rates. After the initial application is taken, we automate everything through loan submission followed by closing.<br><br>Our focus is to reaffirm this companies history of providing outstanding service to our customers. We encourage our staff to develop strong relationships with our customers. As these relationships develop, we understand our customer''s needs. As we understand these needs, we provide the services they require with the quality that meets the borrowers appropriate financial and loan requirements at competitive prices. Through good planning, our customers'' expectations should be met with timely delivery of the expected interest rate and loan and sufficient after-market service, making only those promises that we can keep. Every person in this organization needs to conduct business in a manner which is courteous and polite.<br><br>America truly is the land of opportunity. We will provide the expertise, with a lifetime of support, which hopefully upon qualifying will enable every American as well as Foreign Nationals to realize and fulfill the American dream.<br><br><br>Rates, points, and products are subject to change at any time without notice.\r\n<br></font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (148, 43, 2, 'Understanding The Loan Application Process', '<font class="maintext">\r\n<font color="#BD827B" class="headers" size="4" face="Verdana, Arial, Helvetica, sans-serif"><b>Introduction</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Buying a home may be the most exciting, confusing and stressful financial transaction you ever undertake. Even if you have done it several times you can still find the process complicated and intimidating, particularly when it comes to getting a mortgage loan. Countless loan documents, unfamiliar terminology and uncertainty serve to temper the joy of buying a new home. As soon as the sales contract is signed, obtaining the financing for the purchase becomes paramount for all but a very few buyers. If you understand the steps required to qualify for a mortgage loan, however, much of the stress can be avoided. The following explanation of the loan application process is intended to help you through the complexities of obtaining a mortgage loan.</span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Loan Application Interview</b></font></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Once you have selected a lender, the next step will probably be a meeting with a loan officer or other lender representative, whose job is to begin the collection of information the lender needs to approve the loan. They will explain the types of mortgage e loans available to you, the interest rates and fees for each type and the qualification requirements. During the meeting, the loan officer will fill out, or assist you in filling out, the loan application form. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">By this time you should have a good idea of the general interest rates and fees being charged in the area. The total cost of a mortgage loan consists of the interest rate on the loan, origination fees, discount points, and miscellaneous other charges. One point is equal to one percent of the amount of the loan and is usually collected at the loan closing, or settlement. The interest rate affects the amount of the monthly payment, while points affect the amount of cash you must have at closing. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Most lenders will offer a range of interest rate/point combinations to meet the borrower needs. In general, the higher the interest rate, the lower the points. For example, if the current market provides for an 8.5 percent interest rate with 2 points, a nine percent rate may be offered at no points. If you are a first-time home buyer, the larger monthly payments on the 9 percent loan may be easier to handle than the 2 points that will require additional cash at settlement. If you are a corporate transferee, however, your company''s relocation policy may pay all or part of origination costs and the lower rate will have more appeal. The loan officer is prepared to explain all of your options to you. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When discussing the terms of the loan, make sure you understand how and when the rate and fees on the loan are going to be set. Most lenders will quote a rate and fee at the time the application is taken and then will guarantee, or "lock" the rate quote for a specified length of time. A rate lock protects you from rising interest rates while the loan is being processed, but it also typically commits you to close the loan at the rate and the fee even if rates decline prior to closing. Lock periods may run from 10 to 60 days, with longer periods available in some cases at an additional fee. The lock period must be long enough to get you through the estimated closing date. A 30-day lock affords you no protection if closing is at least 60 days away. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You may have the option to let the rate "float," getting the final rate and fees set nearer the settlement date. If you believe rates are declining and are willing to run the risk that interest rates could rise during the processing of your loan, you may select this alternative. Before you take a floating rate, make sure that the rise in interest rates will not create a problem for you because you have insufficient income to cover the higher mortgage payments. In either case, make sure you understand exactly the terms of the lock-in agreement.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Completing The Loan Application Form</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The loan application form asks for information on the property you are buying, terms of the purchase contract and the employment and financial history of all loan applicants, including your spouse and/or other co-borrowers. The lender will verify or not to make the loan, so it is very important to make sure that it is complete and accurate. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You can complete the loan application process much more easily and accurately if you prepare for it ahead of time. A great deal of detail will be asked about your personal finances, including bank account numbers and balances, current loan amounts and payments, and credit card account numbers. You will want to be thorough and precise in your answers, so it will be to your benefit to assemble this kind of information before the meeting with the loan officer. The following is a summary of the major kinds of information required on the loan application, the documents that may be needed and the questions that you should be prepared to answer.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">Details of Purchase Contract and the Property</span></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Because the property is security for the loan, the lender will have an appraisal made of the property, and you need to have the following information available: </span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A complete copy of the sales contract, including any addendum''s, signed by all parties, showing the full names of the sellers and buyers as they will appear on the new deed, the amount of earnest money deposit and who is responsible for closing costs, origination fees, etc.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the house is to be built, or is still under construction, a set of plans and specifications.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The complete mailing address of the property, its age and its full legal description.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Name, address and telephone number of the real estate agent and/or the seller of the property who will assist the appraiser in obtaining access to the property. \r\n                            </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">All of this information should be in the purchase contract. If not, consult the Realtor or the seller. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Personal Information</span></font></b> </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The loan officer will want the social security numbers of you and your spouse (or other co-borrowers), age, number of years of schooling, your marital status, number and ages of dependents and your current address and telephone number. If you have lived at your current address less than 2 years, be prepared to furnish former addresses for up to seven years. You will also be asked to detail your current housing expenses, including rent or mortgage payments, real estate taxes and insurance (your mortgage payment may include tax and insurance funds). You will need the name and address of your landlord(s) or mortgage lender(s) for the past two years. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Employment History and Sources of Income</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your ability to make the regular payments on the mortgage and to afford the costs associated with owning a home are primary considerations is the lender''s loan approval process and should be your primary concern. Required information includes:</span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At least two years employment history with employer''s name and address, your job title or position, length of time on the job, salary, bonuses, commissions and average overtime pay.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Recent paycheck stubs and Federal W-2 forms for two years (some lenders may require full Federal tax returns).</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Records of dividends and interest received from investments.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are self-employed, full tax returns and financial statements for 2 years, plus a profit and loss statement for the current year to date.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">A written explanation if there are gaps in your employment record, because of circumstances such as illness or layoffs, or for any other reason</span>. </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The loan officer will have you sign a Verification of Employment (VOE) form. This will be sent to your employer to verify your employment and earnings. One will be sent to previous employers if you have been on the job less than two years. Many lenders now use a general authorization form which allows them to verify employment and other financial information on the application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are relying on income from other sources, such as rental property, social security or disability payments, child support, etc., you must provide adequate proof of the source. Appropriate documents could include canceled checks, copies of leases, certification of benefits, divorce decrees and similar evidence. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">Personal Assets</span></span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A detailed listing of your personal assets is required on the loan application form. You will need to have the following information available to complete the form: </span></font></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">All bank accounts, both checking and savings, and money market accounts, with the name and address of the institution, name(s) on the accounts, account numbers and current account balances.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Recent bank statements for at least two months.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Current market value of stocks, bonds, CDs and other investments.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Vested interest in all retirement funds.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Face amount and cash value of life insurance policies in force.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Make, model, year and value of automobiles owned.</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Address and market value of all real estate owned along with the amount of rents collected, the mortgage on the property and the monthly mortgage payments (a profit and loss statement will be required for investment properties).</span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Value of other personal property such as furniture. </span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">As with the Verification of Employment, the loan officer will have you sign Verifications of Deposit (VOD) for each of the institutions (or a general authorization) where you have savings or checking accounts. Differences between the account balances reported by the institution and the balance you give for the loan application have to be reconciled, so be sure you have your correct current balances. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender will look for the source of funds with which you will make the down payment and pay closing costs and fees. Gifts from a relative, church, municipality or non-profit organization may sometimes be used, but must be verified in writing. If you are providing less than 5 percent of the sales price, the donor must be a relative and must provide a letter stating the donor''s relationship to you, the amount of the gift and the fact that no repayment is expected. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Personal Indebtedness</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will be asked to itemize all of your current bills, loans and other debts, including current balances and monthly payments. Debts include automobile loans, credit cards such as Visa, Mastercard and other retail store accounts, finance company, bank a nd credit union loans and existing mortgages, including home equity loans. You should be able to give the account or loan number, the monthly payment, the number of payments remaining and the outstanding balance. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information you provide on the loan application will later be verified by a credit report ordered by the lender. Like employment and deposit information, differences between your figures and those on the credit report will raise questions and may delay the approval of your loan. It is to your advantage to take time to get your data right prior to filling out the loan application. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have had credit problems, you should inform the lender. Lenders recognize that unemployment, illness, marital problems or other financial difficulties can temporarily impair your credit rating. Provide a written explanation of the circumstances regarding the problem to be included with the loan application. The lender must consider such a written explanation as part of the underwriting analysis. If the problem has been corrected and your payments have been made on time for a year or more, your credit will probably be judged as satisfactory. Chronic late payments, judgments or loan defaults, however, severely damage your credit standing and may prevent you from obtaining the financing you need to complete the purchase. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have been through bankruptcy or foreclosure proceedings within the past seven years, be prepared to give full details and copies of applicable documents regarding them. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will also be asked to explain the details if you are obligated to pay alimony, child support or separate maintenance. Such obligations are treated like debt payments by most lenders and will be part of the underwriting analysis. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Additional Information</span></font></b> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will be asked to sign a section of the loan application form which contains your certification that the information you have provided is correct to the best of your knowledge; your promise to advise the lender of any material changes in the information on; and your consent to (1) verification of the application data, (2) submission of account history to credit reporting agencies, and (3) transfer of the loan or loan servicing to successors to the original lender. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The last part of the application form requests information on the race and gender of the applicants. The Federal Government uses this data to monitor lenders'' compliance with fair housing and equal credit opportunity laws. Providing this information is strictly voluntary on your part and has no effect on your loan application. The lender, however, is required by federal law to request the information. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Because of the particular circumstances surrounding a loan application, the lender may require additional information or documentation regarding you or the property after the application has been submitted for approval. Loan officers make every effort to collect all data at the outset, but cannot foresee every eventuality. Requests for additional information are not necessarily bad omens and your primary concern should be in responding promptly with the information. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At the time the application is taken, you will probably be asked to pay for the credit report and appraisal fees. depending upon the locality and the type of the loan, these fees will generally run up to $500. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Based on the information collected in taking the application, the loan officer may be able to pre-qualify you for the loan requested, but cannot approve the loan. That is done by the lender''s underwriters after all documents and information have been recieved and verified.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>After The Loan Application - What Next?</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">After the loan application has been completed, it will be turned over to the lender''s loan processing department and then to the underwriter, where the decision to approve or reject the loan will be made. Loan processors send out the Verifications of Employment and Deposit and order the credit report, property appraisal and other documents. The time it takes to receive these documents affects the length of time required for approval of the loan. If you are transferring from out of the local community, it may take longer to receive the credit and employment information. Processing times vary from one lender to another, but the loan officer should be able to give an idea of the processing time for your application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Within three business days after completing the application, the lender must provide you with a <b>Good Faith Estimate</b> of the anticipated closing costs. It will show costs associated with the loan settlement, such as origination fees, mortgage insurance, title insurance, escrow reserves and hazard insurance. </span> </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Within the same three days you will also receive a <b>Truth-in-Lending Disclosure</b> statement. This statement shows, among other things, the estimated monthly payment. The total cost of all finance charges on your loan is also shown, stated as an <b>Annual Percentage Rate (APR)</b>. The APR represents the dollar amount of finance charges you pay either up front or over the life of the loan, converted to an annual interest rate. Since the APR includes origination fees and other charges as well as interest on the mortgage loan, the APR is usually higher than the interest rate on the loan. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">After the lender has approved the loan, you will usually receive a commitment letter which sets out the terms of the loan and the length of time for which those terms are offered. If the loan does not close within the specified commitment period, the terms are subject to change. You usually must accept the commitment by returning a signed copy to the lender within five to ten days and may have to pay part or all of the origination fees at this time. The commitment may contain conditions that you will still have to satisfy, so you should read it carefully. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In cases where closing is scheduled soon after approval, the lender may give you verbal approval instead of a commitment letter. This is not unusual, but make sure you understand the terms of the approval. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Once the commitment letter or approval has been received, you are assured the financing you need to complete the purchase of your home and you need to turn your attention to completing the details required for settlement.</span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Reducing The Anxiety of Waiting</b></font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">For many home buyers, the period of time between the submission of the loan application and receipt of the commitment letter is one of uncertainty and concern. Requests for additional information, unexpected delays and lack of communication all serve to increase the tension. There are a number of things that both you and the lender can do to reduce the stress. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Keep in mind that the lender wants to make the loan. Loan underwriters are looking for ways to approve loans, not reject them. If you have come to the interview with the loan officer fully prepared and have provided good documentation, you have done a great deal to assure prompt processing of your application and approval of your loan. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You and the lender need to make sure that lines of communication are kept open. Your contact person may be the loan officer, but often it might be someone in the lender''s loan processing department who can tell you the status of your application. Remember, however, that it may take several weeks to process the application and frequent inquiries from you prior to that time will not speed things up. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You should be accessible if the lender needs additional information or documents during processing. If you are from out of town, use your real estate agent as a contact if necessary. Quick response to lender requests helps keep the process on schedule. In order to protect both you and the lender, mortgage loans require much more paperwork and legal documentation than an automobile or other installment loan, and lenders do not ask for more than is absolutely necessary. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Obtaining a mortgage loan need not be an ordeal that dampens the thrill of acquiring a new home. If you understand the lending process and are prepared to do your part, it simply becomes a key step in owning a home.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></p>\r\n</font>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (149, 44, 2, 'How To Shop For A Mortgage', ' With dozens of competing lenders and mortgages to choose from, you may think that today''s home loan market is terribly confusing. It really isn''t though if you know the basic facts about financing a house. That''s what this brochure is designed to give you. Let''s start with the questions that are probably uppermost in your mind.</font></span></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Large A Mortgage Can I Get?</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">That depends upon your income and the cost of your new house. Lenders use certain guidelines to determine the mortgage amount that they will lend any one homebuyer. The two guidelines used are housing expenses and long term debt. Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For <b>Federal Housing Administration (FHA)</b> loans, this figure is not t o exceed 29 percent of the homebuyer''s gross monthly income. With loan guaranteed by the <b>Department of Veteran''s Affairs (VA)</b>, lenders measure prospective homebuyers with &quot;Residual Income,&quot; or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower.</font></span></p>\r\n                  <ul>\r\n                    <li> \r\n                      <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><span class="headers"><font size="4"><span class="headers">FHA Loans</span></font></span><br>\r\n                        </strong></span><span class="bodytext"><span class="bodytext">Housing expenses = 29% of gross monthly income </span><br><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income</span></span></font></span></span></p>\r\n                    </li>\r\n                    <li><span class="headers"><span class="headers"><font size="4"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong>VA Loans</strong></span></font></span></span></font></span></span><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><br>\r\n                      </strong></span><span class="bodytext"><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income<br>Residual Income = Varies by location and family size <br></span><br>\r\n                      </span> </font></span></span></li>\r\n                    <li> \r\n                      <p><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><font size="4" class="headers">Conventional Loans</font><br>\r\n                        </strong></span><span class="bodytext"><span class="bodytext">Housing Expenses = 25% - 28% of gross monthly income </span><br><span class="bodytext">Housing Expenses Plus Long-Term Debt = 33% - 36% of gross monthly income </span></span></font></span></span></p>\r\n                    </li>\r\n                  </ul>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. VA and FHA mortgage lenders define long- term debt as monthly income. Your lender will work out these figures for you when you sit down to discuss the mortgage you want.</font></span></span></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Types Of Loans Are Available</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although you may see many different types advertised, they all belong to just two families: those mortgages that carry fixed interest rates, and those whose rates change during the course of the loan on a periodic schedule mutually agreed upon by you and your lender. This page does, however, discuss some new loans who are really "cousins" to each family-convertible mortgages.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Fixed Rate Mortgages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You are probably familiar with a fixed-rate mortgage. Your parents more than likely had one, as did their patent before them. The major advantage of fixed rate mortgages is that they present predictable housing costs for the life of the loan. Some fixed-rate mortgages you will probably hear about are:</span></font></span></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">30-year fixed-rate mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">15-year fixed-rate mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Bi-weekly mortgages</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">"Convertible" mortgages</span></font></li>\r\n                  </ul>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When people thought of a mortgage 10 to 50 years ago, they thought of a 30-year fixed-rate mortgage. This traditional favorite is not the only choice nowadays because volatile financial times created a whole new range of selections. However, the 30-year fixed-rate mortgage may still be the best mortgage for your circumstances. It offers the lowest monthly payments of fixed-rate loans, while providing for a never- changing monthly payment schedule. Some lenders offers 25,20, and even 40-year term mortgages as well. But remember, the longer the term of the loan, the more total interest you will pay.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The 15-year fixed-rate mortgage allows homeowners to own their homes free and clear in half the time and for less than half the total interest costs of the traditional 30-year loan. The loan''s term is shortened by the 10 percent to 15 percent higher monthly payments. Some homebuyers prefer this mortgage because it allows them to own their home before their children start college. Others prefer it because they will own their home free and clear before retirement and probable declines in income.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The major disadvantages or the 15-year fixed-rate mortgage are the sometimes higher monthly payments. But if saving on total interest costs and cutting the to free and clear ownership are important to you, the 15-year fixed-rate mortgage is a good option. The bi-weekly mortgage shortens the loan term to 18 to 19 years by requiring a payment for half the monthly amount every two weeks. The bi-weekly payments increase the annual amount paid by about 8 percent and in effect pay 13 monthly payments(26 bi-weekly payments) per year. The shortened loan term decreases the total interest costs substantially. The interest costs for the bi-weekly mortgage are decreased even further, however, by the application of each payment to the principal upon which the interest is calculated every 14 days. By nibbling away at the principal faster, the homeowner saves additional interest. Remember, however, that you trade lower total interest costs for fewer mortgage interest deductions on your federal income tax. Your ability to qualify for this type of loan is based on a 30-year term, and most lenders who offer this mortgage will allow the homebuyer to convert to a more traditional 30-year loan without penalty. Availability is limited on this mortgage, but it can be worth looking for.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some newer mortgages afford homebuyers some the best qualities of the fixed-rate and adjustable rate mortgages. One new type of loan, often called a <b>Two-Step, Super Seven</b>, or <b>Premier Mortgage</b>, gives homeowners the predictability of a fixed- rate and adjustable rate mortgage for a certain time, most often seven or 10 years, and then the interest rate is adjusted to fit market conditions at that time. The main advantage associated with this type of loan is that homebuyers often get a slightly lower than market rate to begin with. The main disadvantage is that they may see their interest rate go up by as much as six percentage points at the end of the seven-year period. The lender may also reserve the option to call the loan due with 30 days notice at that time, making this loan similar to a balloon mortgage in some cases.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Lenders offer this type of loan in part because research indicates that many homebuyers remain in the home for seven to 10 years before moving. For this type of homebuyer, the Two-Step or Super Seven loan present an excellent way of getting a fixed- rate loan at a better than market price for a fixed-rate loan at a better than market price for a fixed period of time.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another type of mortgage that is becoming popular is called a <b>Lender Buydown</b>, where the homebuyer gets an initially discounted rate and gradually increases to an agreed-upon fixed rate over a matter of three years. For example: When the market rate is 10 percent, the fixed rate for the mortgage is set at about 10.5 percent, but the homebuyer makes monthly payments based on a first year rate of 8.5 percent. The second year the rate goes up to 9.5 percent, and for the third year through the remaining life of the loan, the rate is calculated at 10.5 percent. A second type of lender buy-down, called a <b>Compressed Buydown</b>, works the same way, but with the interest rate changing every six months instead of on a yearly basis.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Lender Buydown gives consumers the advantage of lower initial monthly payments for the first two years of the loan when extra money may be needed for furnishings and, secondly, the advantage of knowing that, although the interest rate does change during the first three years of the loan, the interest is fixed from the third year on.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Convertible mortgages offer today''s homebuyer the option to change the loan''s interest rate after some period of time or some specified movement in interest rates.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Convertible fixed-rate mortgages are often referred to as the <b>Reduction Option Loan (ROLE)</b> or, in some locations, the <b>Reducing Interest Loan (RIL), or Mortgage (RIM)</b>. This new type of loan offers homeowners the option of getting a loan that , under the right conditions, can be adjusted to a lower interest rate with a payment of $100 or $200 or so and a small loan amount-based fee, sometimes as little as one-fourth of a percentage point. These conditions usually are a prescribed movement in rates-typically two percent below the initial- during a set time limit-between months 13 and 59, for example.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On a 30-year fixed-rate mortgage with a reduction option, the homebuyer pays an extra one-fourth to three-eighths of a percentage point in the interest rate on the mortgage plus a quarter to three-eighths of 1 percent of the loan amount (points) at the time of closing. This allows the homeowners to adjust the interest rate on the loan without having to go through a refinancing, which could cost up to 5 percent or 6 percent of the loan amount, if the rates are right during the prescribed time limit.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On an $80,000 loan, this means that you could reduce the interest rate on your loan from, say, 10.5 percent to 8.5 percent, and take advantage of the low rates for the rest of the loan term for $150 instead of up to $4,800 , if the rates dropped to that point during your "window of opportunity" - months 13 through 59. Some homeowners may find the ROL a good "insurance policy" against the high costs of refinancing. Others may want the flexibility that refinancing offers - namely the ability to draw on built-up equity- that is not available with ROLs. The decision is up to you.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertible Adjustable Rate Mortgages (ARMs)</b> are another new loan product on today''s market. It worked like any other ARM, but it offers homeowners a distinct advantage-it allows them to turn their ARM into a fixed-rate mortgage after a set period (usually during the second through fifth years of the loan).</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A new product developed by the <b>Federal National Mortgage Association (Fannie Mae)</b>, which buys mortgages from lenders, allows the homeowner to convert an ARM to either a 15 or 30 year fixed-rate mortgage for a fee of 1 percent of the original loan plus $250 , as compared to the 3 percent to 6 percent costs of refinancing. Say, for instance, that you got your convertible ARM at an initial interest rate of 10.0 percent, and after a year or so, rates had dropped to 8.0 percent. For the smaller conversion fee, you could adjust your mortgage to either a 15 or 30 year fixed-rate loan at a new rate that would be about one-half percent higher than the going market rate, or 8.5 percent. There are other variations on this loan available from lenders across the country. Homebuyers who want the low initial rate of an ARM, and the option and peace of mind of a fixed mortgage should rates drop, can now have it both ways.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Adjustable Rate Mortgages (ARMs) have become on of the most popular and effective tools for helping some prospective homebuyers achieve their dream of homeownership. Developed during a time of high interest rates that kept many people out of the housing market, the ARM offers lower initial rates by sharing the future risk of higher rates between borrower and lender.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">ARMs can be an excellent choice of financing under certain conditions, such as rising income expectations, high interest rates, and short-term homeownership. But because payments and interest rates can increase, either steadily or irregularly, homebuyers considering this kind of mortgage need to have the income to keep up with all possible rate and/or payment changes. Each ARM has four basic components:</span></font></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Initial interest rate</b>, which is typically one to three percentage points lower than that of most fixed-rate mortgages. Lower interest rates also make ARMs somewhat easier to qualify for. The initial interest rate is tied to certain economic indicators that dictate in part what the monthly payments will be.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustment interval</b>, at the time between changes in the interest rate and/or monthly payment will be.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Index</b>, against which lenders measure the difference between what they are making on their investment in the mortgage and what they could be making on other types of investments. The most popular index is based on the rate of return on a one- year Treasury bill (also called T-bill).</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Margin</b>, or the additional amount the lender adds to the index to establish the adjusted interest rate on an ARM. The margin is usually 1.5 percent to 2.5 percent. </span></font></li>\r\n                  </ul>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to the four basic components, an ARM usually contains certain consumer safeguards such as interest rate caps, which limit the amount that the interest rate applied to the payments may move. This prevents the amount of interest the consumer pays from rising higher than perhaps the homeowner can afford. For instance, a typical ARM would have a two percentage point cap over the life of the loan. That means that a loan with an initial interest rate of 9.75 percent would be able to go no higher than 14.75 percent over the life of the loan, and it would be able to move no more than two percentage points per year.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another safeguard found on some ARMs are monthly payment caps that limit the amount homeowners need to increase their payments at adjustment time. Monthly payment caps can, however, sometimes prevent the monthly payments from increasing enough to keep up with the rise in the interest rate, causing negative amortization-resulting in higher or more payments for the homeowner later on.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Other options you should ask about when shopping for an ARM are:</span></font></p>\r\n                  <ul>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Assumability</b>, or whether you may transfer the mortgage to a new homebuyer, usually with the same terms if the new homebuyer qualifies for the loan. ARMs are almost always assumable.</span></font></li>\r\n                    <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertibility</b> allows the borrower to change an ARM to a fixed-rate mortgage, usually at the end of some predetermined period, locking in a lower interest rate.</span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A relative newcomer in the mortgage market is a <b>Reverse Annuity Mortgage (RAM).</b> For older Americans, especially retirees living on fixed incomes, the equity in their paid-for or almost-paid-for home represents a large but liquid asset. The RAM i s designed to help supplement those homeowners'' income.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender who will issue a RAM appraises the property and makes the loan based on a percentage of its current value. The homeowner retains ownership, and the property secures the loan. The lender then pays an annuity to the borrower, usually on a monthly basis, up to an amount equal to the equity they have in the home.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of such a loan for older Americans is that of receiving a monthly tax-free income. Under one plan, this income is available for life or until the house is sold at the homeowner moves. The schedule of payments depends on the value of the home and the ages of the owners. There are risks involved, however. If the homeowner wants to move and buy a new house, there may not be enough equity in the home to permit such  a plan. Or the lender may consider only the current market value of the home rather than any future appreciation when deciding on the monthly payments.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Federal Housing Administration (FHA) and the Veterans Administration (VA) offer a wide range of mortgage choices that may appeal to you. These include 30 and 15 year fixed- rate mortgages, as well as ARMs. Insured by these government agencies, the loans feature low or no down payment terms and are often assumable by future purchasers. VA loans are restricted to individuals qualified by military service or other entitlements, but FHA - insured loans are open to all qualified home purchasers. Note that there are limits to handle moderate-priced homes anywhere in the country. Talk to your lender about FHA/VA possibilities.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">This type of financing became popular when interest rates went to very high levels in the early 1980s. Seller-assisted creative financing usually means the seller of the home helps with the financing by underwriting all or part of the loan.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of this type of arrangement is that the mortgage usually carries a lower interest rate with lower monthly payments. The disadvantage is that the previous homeowner, not an institution, may hold the deed of trust. If the loan terms call for certain payment schedules, the buyer may have to seek new financing. Many homebuyers in recent years have found "creative financing" deals to be fraught with problems and useful only as short-term alternatives to mortgages from traditional lenders.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One type of mortgage you are apt to run into with seller financing is the balloon payment mortgage. <b>Balloons</b>, as they are known, are usually offered as short-term fixed-rate loans. The balloon payment mortgage gets its name from the payment schedule, which involves smaller payments for a certain period of time and one large payment for the entire amount of the outstanding principal. They have terms of 3, 5, and sometimes 15 years, though payments are usually calculated as though it were a 30 year loan. Sometimes a balloon will be offered as a second mortgage where you also assume the homeowner''s first mortgage . The major disadvantage with a balloon payment loan is that it may be difficult to save up the money to make the final large payment (often the entire amount of the principal) while paying interest on the loan. Some lenders guarantee refinancing, though the interest rate is usually adjusted when the principal comes due. If you cannot refinance, you may have to the property if you cannot meet the large payment. Balloons are an advantage if you plan on living in an appreciating house for a short period of time and want to pay less while you live there.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are several ways. First, talk with your real estate agent or broker. Real estate professionals are normally in the best position to learn about financing opportunities in the marketplace. Lenders regularly call agents to alert them to financing packages. And, of course, agents are highly motivated to obtain financing for their buyers. Without a suitable loan, the sale can''t proceed, and agents won''t get their sales commission on the house.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Second, look for rate surveys published by your local newspaper. Many American papers now include brief tables on interest rates and mortgage availability in their real estate or business section. They can help guide you to sources you have not thought about.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Third, look in the Yellow Pages under "Mortgages," and shop for quotes by telephone. Call five to 10 different lenders for rates and terms on fixed and adjustable loans.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Finally, if your area is covered by one of the many commercial <b>computerized mortgage shopping services</b>, give it a try. You may find, however, that the computer services have only a selection of local lenders on their listings.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One important method is by bearing in mind that mortgage packages consist of more than interest rates. They consist of a quoted rate, plus discount points (pre-paid interest assessed by the lender at settlement, or the meeting when the property legally changes hands) and other fees, plus a full range of terms including adjustable versus fixed-rates, low down payment versus high down payment, the presence or absence of prepayment penalties, and many other features noted earlier in this brochure.</span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One way to evaluate rates, however, is by examining the <b>Annual Percentage Rate (APR)</b>. The APR can help you compare different types of mortgages. It indicates the &quot;effective rate of interest&quot; paid per year. The figure includes discount points and other charges and spreads them out over the life of the loan. While the APR provides you with a common point for comparison, look at the whole product before deciding which mortgage to get. Pick the one with the rate, payment schedule and other terms t hat suit your situation best.</span></font></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></h3>\r\n                  <blockquote> \r\n                    <dl> \r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Acceleration Clause</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you miss a monthly payment, an acceleration clause allows the lender to speed up the rate at which your loan comes due or even to demand immediate payment of the entire outstanding balance of the loan.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Assumability</span></font></b></font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Assuming a mortgage is simply taking the loan over from the holder (seller) and becoming liable for the repayment.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Buydown</span></font></b></font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The buydown mortgage is one where the seller and/or the home builder subsidizes the mortgage by lowering the interest rate during the first few years of the loan. While the lower initial payment and interest rate make this kind of loan easier to qualify, the payments may increase when the subsidy expires.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Closing Costs/Settlement Costs/Escrow</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Closing costs ate the costs associated with settlement, the meeting where the buyer and seller (or their agents) sit down to fill out the papers and make the exchanges that allow the property to legally change hands. Closing costs include appraisal fees, title search and insurance, survey, tax adjustments, deed recording fees, credit report and points, among others.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Due-on Sale Clause</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">A clause or provision in a mortgage or deed of trust that allows the lender to demand immediate payment of the balance of the mortgage at the time of sale.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Negative Amortization</span></font></b> </font></span></dt>\r\n                      <dd class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This occurs when your monthly payments are not large enough to pay all the interest due on the loan. This unpaid interest is added to unpaid balance of the loan. The danger of negative amortization is that the homebuyer could end up owing more than the original amount of the loan.</font></span></dd>\r\n                      <dt><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Private Mortgage Insurance</span></font></b> </font></span></dt>\r\n                      <dd><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment-as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are usually required to carry private mortgage insurance. </span> </font></span> \r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance will require additional premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 house with a 10 percent down payment, this would mean an initial premium payment of $338 to $675 and an extra $15 to $20 a month. </span></font></p>\r\n                      </dd>\r\n                    </dl>\r\n                  </blockquote>\r\n                  <p> \r\n                  <table class="bodytext" cellspacing="0" cellpadding="4" bgcolor="#CCCC99" align="center" border="0">\r\n                    <center>\r\n                      <tr bgcolor="#FFCFCE"> \r\n                        <td width="102" align="left" valign="top"><div align="left" class="bodytext">Comparison on a</font></div></td>\r\n                        <td align=left class="bodytext" width="50" valign="top">30 Year</font></td>\r\n                        <td align=left class="bodytext" width="64" valign="top">15-Year</font></td>\r\n                        <td align=left class="bodytext" width="65" valign="top">Bi-Weekly</font></td>\r\n                        <td align=left class="bodytext" width="69" valign="top">ARM</font></td>\r\n                      </tr>\r\n                      <tr bgcolor="#FFCFCE" > \r\n                        <td width="102" height="12" align="left" valign="top"><div align="left" class="bodytext">$75,000 Mortgage</font></div></td>\r\n                        <td align=left width="50" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                        <td align=left width="64" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                        <td align=left width="65" height="12" class="bodytext" valign="top">Mortgage </font></td>\r\n                        <td align=left width="69" height="12" class="bodytext" valign="top"><span class="lighttabletext">at 7.5%</span></font></td>\r\n                      </tr>\r\n                      <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="16%" class="bodytext" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">w/5% cap*</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Monthly Payment</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$806</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658(329 X 2)</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$524</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,481</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,398</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,434</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$5,602</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,336</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,606</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,061</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,188</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage Balance</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,583</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,726</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,476</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,309</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$73,052</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$64,372</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$69,817</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,400</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost/Life</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$161,942</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$70,062</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$104,331</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$132,566</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left width="102" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Difference from</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $91,880</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $57,611</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $29,376</font></td>\r\n                            </tr>\r\n                    </center>\r\n                  </table>\r\n                  <p align="left"></p>\r\n                  <div align="left" class="bodytext"> \r\n                    <blockquote><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">* The interest on the ARM used in this example increased 2 percent in the second year (payment = $629), and decreased 1 percent in the third year (payment = $577 for Years 3 through 30). This is a hypothetical situation. Not all ARMs will behave in this manner; some will increase (or decrease) more slowly, some more rapidly. In each case, the monthly payments, interest costs, and the amount you save will differ. For more information about tailoring an ARM to fit your particular circumstances, talk to your lender.</span></font></blockquote>\r\n                    <p><span class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Back to Tools</font></a></span></p>                  </div>\r\n                  <h1 class="headers"></h1>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (150, 45, 2, 'A Consumer''s Guide To Mortgage Lock-Ins', '                          When you''re looking for a mortgage, you''re likely to shop among lenders for the most favorable interest rate, and the lowest points and other up-front charges. When you find the most favorable terms and the lender that you want, you''ll apply to that lender. But when you get to settlement, will you actually receive the terms you applied or bargained for? Or will you find that the rate has changed - and that your costs have gone up? Lock-ins on rates and points might offer you a way to ensure that what you shop for is what you get. This page explains what these arrangements mean. </span></font></span></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#aboutlocks">All About Rate Lock-Ins</font></a></span></font></span></span></span></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#whatisalock">What Is A Rate Lock-in? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#inwriting">Will Your Lock-In Be In Writing? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#charged">Will You Be Charged For A Lock-In? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#options">Setting The Mortgage Term</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#valid">How Long Are Lock-Ins Valid? </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#expires">When The Lock-In Period Expires </a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#speedup">Speeding Up The Loan Approval</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#askabout">Ask About Lock-Ins</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#complaints">Complaints About Lock-Ins</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#stateagencies">State Agencies</a></span></font></span></span></font></li>\r\n                          <li><font size="1"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#federalagencies">Federal Agencies</a></span></font></span></span></font></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="aboutlocks" class="headers"><font color="#BD827B" size="4" class="headers"><span class="headers"><b>All About Rate Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">In most cases, the terms you are quoted when you shop among lenders only represent the terms available to borrowers settling their loan agreement at the time of the quote. The quoted terms may not be the terms available to you at settlement weeks or even months later; therefore, you could not rely on the terms quoted to you when shopping for a loan useless a lender is willing to offer a lock-in.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="whatisalock" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>What Is A Rate Lock-in? </b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">A lock-in, also called a rate-lock or rate commitemnt, is a lender''s promise to hold a certain interest rate and points for you, usually for a specified period of time, while your loan application is processed. (Points are additional charges imposed by the lender that are usually pre-paid by the consumer at settlement but can sometimes be financed by adding them to the mortgage amount. One point equals 1 percent of the loan amount.) Depending upon the lender, you may be able to lock in the interest rate and n umber of points that you will be charged when you file your application, during processing of the loan, when the loan is approved, or later. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">A lock-in that is given when you apply for a loan may be useful because it''s likely to take your lender several weeks or longer to prepare, document, and evaluate your loan application. During that time, the cost of your mortgage may change. But if your interest rate and points are locked in, you should be protected against increases while your application is processed. This protection could affect whether you can afford the mortgage. However, a locked-in rate could also prevent you from taking advantage of price decreases, unless your lender is willing to lock in a lower rate that becomes available during this period. It is important to recognize that a lock-in is not the same as a loan commitemnt, although some loan commitemnts may contain a lock-in. A loan commitemnt is the lender''s promise to make you a loan in a specific amount at some future time. Generally, you will receive the lender''s commitemnt only after your loan application has been approved. This commitemnt usually will state the loan terms that have been approved (including loan amount), how long the commitemnt is valid, and the lender''s conditions for making the loan such as receipt of a satisfactory title insurance policy protecting the lender.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="inwriting" class="headers"><font color="#BD827B"><span class="headers"><font size="4"><span class="headers"><b>Will Your Lock-In Be In Writing? </b></span></font></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Some lenders have pre-printed forms that set out the exact terms of the lock-in agreement. Others may only make an oral lock-in on the telephone or at the time of application. Oral agreements can be very difficult to prove in the event of a dispute. Some lenders'' lock-in forms may contain crucial information that is difficult to understand or that is in fine print. For example, some lock-in agreements may become void through some unrelated action such as a change in the maximum rate for Veterans Administration-guaranteed loans. Thus, it is wise to obtain a blank copy of a lender''s lock-in form to read carefully before you apply for a loan. If possible, show the lock-in form to a lawyer or real estate professional. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">It is wise to obtain written, rather than verbal, lock-in agreements to make sure that you fully understand how your lender''s lock-ins and loan commitemnts work and to have a tangible record of your arrangements with the lender. This record may be useful in the event of a dispute.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="charged" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Will You Be Charged For A Lock-In? </b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Lenders may charge you a fee for locking in the rate of interest and number of points for your mortgage. Some lenders may charge you a fee up-front, and may not refund it if you withdraw your application, if your credit is denied, or if you do not close the loan. Others might charge the fee at settlement. The fee might be a flat fee, a percentage of the mortgage amount, or a fraction of a percentage point added to the rate you lock-in. The amount of the fee and how it is charged will vary among lenders and may depend on the length of the lock-in period.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="options" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>What Options Are Available For Setting The Mortgage Term? \r\n                          </b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Lenders may offer options in establishing the interest rate and points that you will be charged, such as: </span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Locked-in interest rate/locked-in points</b><br>Under this option, the lender lets you lock in both the interest rate and points quoted to you. This option may be considered to be a true lock-in because your mortgage terms should not increase above the interest rate and points that you''ve agreed upon even if market conditions change.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Locked-in interest rate/floating points</b><br>Under this option, the lender lets you lock in the interest rate, while permitting or requiring the points to rise and fall (float) with changes in market conditions. If market interest rates drop during the lock- in period, the points may also fall. If they rise, the points may increase. Even if you float your points, your lender may allow you to lock in the points at some time before settlement at whatever level is then current. (For instance, say you''ve locked in a 10.5 percent interest rate, but not the 3 points that went with that rate. A month later, the market interest rate remains the same, but the points the lender charges for that rate have dropped to 2.5. With your lender''s agreement, you could then lock in the lower 2.5 points.) If you float your points and market interest rates increase by the time of settlement, the lender may charge a greater number of points for a loan at the rate you''ve locked in. In this case, the benefit you might have has by locking in your rate may be lost because you''ll have to pay more in up-front costs.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b>Floating interest rate/floating points</b><br>Under this option, the lender lets you lock in the interest rate and the points at some time after application but before settlement. If you think that rates will remain level or even go down, you may want to wait on locking in a particular rate and points. If rates go up, you should expect to be charged the higher rate. Because practices vary, you may want to ask your lender whether there are other options available to you.</span></font></span></span></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="valid" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>How Long Are Lock-Ins Valid? </b></span></font></a></font></span></span></h3>\r\n \r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Usually the lender will promise to hold a certain interest rate and number of points for a given number of days, and to get these terms you must settle on the loan within that time period. Lock-ins of 30-60 days are common. But some lenders may offer a lock-in for only a short period of time (for example, seven days after your loan is approved) while some others might offer longer lock-ins (up to 120 days). Lenders that charge a lock-in fee may charge a higher fee for the longer lock-in period. Usually, the longer the period, the greater the fee.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="expires" class="headers"><font color="#BD827B" size="4" class="headers"><b>What Happens If The Lock-In Period Expires?</b> </font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">If you don''t settle within the lock-in period, you might lose the interest rate and the number of points you had locked-in. This could happen if there are delays in processing whether they are caused by you, others involved in the settlement process, or the lender. For example, your loan approval could be delayed if the lender has to wait for any documents from you or from others such as employers, appraisers, termite inspectors, builders, and individuals selling the home. On occasion, lenders are themselves the cause of processing delays, particularly when loan demand is heavy. This sometimes happens when interest rates fall suddenly. If your lock-in expires, most lenders will offer the loan based on the higher of the prevailing interest rate and points, or your locked in rate. If market conditions have caused interest rates to rise, most lenders will charge you more for your loan. One reason why some lenders may be unable to offer the lock-in rate after the period expires is that they can no longer sell the loan to investors at the lock-in rate. (When lenders lock in loan terms for borrowers, they often have an agreement with investors to buy these loans based on the lock-in terms. That agreement may expire around the same time that the lock-in expires and the lender may be unable to afford to offer the same terms if market rates have increased.) Lenders who intend to keep the loans they make may have more flexibility in those cases where settlement is not reached before the lock-in expires.</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="speedup" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>How Can You Speed Up The Approval Of The Loan</b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">While the lender has the greatest role in how fast your loan application is processed, there are certain things you can do to speed up its approval. Try to find out what documentation the lender will require from you. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Much of the information required by your lender can be brought with you when you apply for a loan. This may help to get your application moving more quickly through the process. When you first meet with your lender, be sure to bring the following documents. </span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The purchase contract for the house (if you don''t have the contract, check with your real estate agent or the seller).</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Your bank account numbers, the address of your bank branch and your latest bank statement, plus pay stubs , W-2 forms, or other proof of employment and salary, to help the lender check your finances.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you are self-employed, balance sheets, tax returns for two to three previous years, and other information about your business.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Information about debts, including loan and credit card account numbers and the names and addresses of your creditors.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Evidence of your mortgage or rental payments, such as cancelled checks.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Certificate of Eligibility from the Veterans Administration if you want a VA-guaranteed loan. Your lender may be able to help you obtain this. </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Be sure to respond promptly to your lender''s request for information while your loan is being processed. It is also a good idea to call the lender and real estate agent from time to time. By calling occasionally, you can check on the status of your application, and offer to help contact others such as employers who may need to provide documents and other information for your loan. It is also helpful to keep notes on your contacts with the lender so that you will have a record of your conversations.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="askabout" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Ask About Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">When you''re ready to settle on your loan, you''ll want to get the loan terms that you''ve locked in. To increase that likelihood, it is important to learn as much as you can about what the lender is promising you before you apply for a loan. Ask for the following information when shopping for a loan: </font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4"><span class="headers">Lock-Ins and Fees</span></font> </font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Does the lender offer a lock-in of the interest rate and points?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">When will the lender let you lock in the interest rate and points? When you apply? When the loan is approved?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Will the lock-in be in writing? If the lock-in is not in writing, you will have no record of the lender''s agreement with you in case of a dispute.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">How long will the lock-in last (30, 60, 90, 120 or more days)?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Does the lender charge a fee to lock-in your interest rate? Does the fee increase for longer lock-in periods? If so, how much?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you have locked in a rate, and the lender''s rate drops, can you lock-in at the lower rate? Does the lender charge you an additional fee to lock in the lower rate?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Can you float your interest rate and points for now, and lock them in later? </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Loan Processing Time</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">How long does the lender expect to take to process your loan?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">What has been the lender''s average time for processing loans recently?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Has the lender''s loan volume increased? Heavy volume might increase the lender''s average processing time. </span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Expiration of Lock-ins</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">What rate will be charged if the lock-in expires before settlement-the rate in effect when the lock-in expires?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If you don''t settle within the lock-in period, will the lender refund some or all of your application or lock-in fees if you decide to cancel the loan application?</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">If your lock-in expires and you want to get another lock-in at the rate in effect at the time of the expiration will the lender charge an additional fee for the second lock-in?</span></font></span></span></li>\r\n                        </ul>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="complaints" class="headers"><font color="#BD827B" size="4"><span class="headers"><b>Complaints About Lock-Ins</b></span></font></a></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Knowing what to look for puts you in a better position to decide whether, when, and how long to lock-in mortgage terms and, by helping to keep the loan process moving, you can lessen the chance that your lock-in will run out before settlement. But what i f your lock-in does lapse? If you believe that the lapse was due to delays caused by the lender or someone else involved in the loan process, you should try first to reach a mutually satisfactory agreement with the lender, if that effort fails, consider writing to the appropriate state or federal regulatory agency. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Some lender actions, such as offering lock-in terms which are impossible to fulfill, failing to process you loan diligently, or causing your lock-in to expire are improper and may even be illegal. In addition, because you may have contractual rights under your lock-in or loan commitemnt, you may want to consult with an attorney. Be aware, though, that complaints may not be resolved as quickly as may be necessary for a home purchase. Depending upon their authority under applicable state or federal law, regulatory agencies may either attempt to help you resolve your complaint directly or record your complaint and recommend other action.</span></font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="stateagencies" class="headers"><font color="#BD827B"><span class="headers"><font size="4"><span class="headers"><b>State Agencies</b></span></font></span></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">State consumer protection officers, banking authorities, and offices of the attorney general can be contacted regarding complaints against many lenders doing business in the state. (Some states have enacted legislation to specifically address complaints about mortgage lock-ins.)</font></span></span></p>\r\n                        <h3><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" name="federalagencies" class="headers"><font color="#BD827B" size="4" class="headers"><b>Federal Agencies</b></font></a></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">In addition, some lenders are directly supervised by federal regulatory agencies, as shown in the list that follows: \r\n                          </font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Mortgage Companies</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="browntext">Division of Credit Practices<br>Bureau of Consumer Protection<br>Federal Trade Commission<br>601 Pennsylvania Avenue, N.W. <br>Washington, D.C. 20580<br>(202) 326-3224</span></span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federally Insured Savings and Loan Institutions an Federally Chartered Savings Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Community Investment<br>Federal Home Loan Bank Board<br>1700 G Street, N.W. <br>Washington, D.C. 20552<br>(202) 377-6000</span></font></span></span></li>\r\n                        </ul>\r\n                        <p>&nbsp;</p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">State Member Banks of the Federal Reserve System</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Division of Consumer and Community Affairs<br>Board of Governors of the Federal Reserve System<br>20th and Constitution Avenue, N.W. <br>Washington, D.C. 20551<br>(202) 452-3946</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">National Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Consumer Activities Division<br>Office of the Comptroller of the Currency<br>490 L''Enfant Plaza, S.W. <br>Washington, D.C. 20219<br>(202) 447-1600</font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federally Insured Non-Member State-Chartered Banks and Savings Banks</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Consumer Programs<br>Federal Deposit Insurance Corporation<br>550 Seventeenth Street, N.W. <br>Washington, D.C. 20429<br>(800) 424-5488<br>(202) 898-3536</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><font size="4" class="headers">Federal Credit Unions</font></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Credit Union Administration<br>1776 G Street, N.W. <br>Washington, D.C. 20456<br>(202) 357-1065</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The Federal Reserve Board and the Federal Home Loan Bank Board have prepared this information on mortgage lock-ins in response to a request from the House Committee on Banking, Finance and Urban Affairs and in consultation with many other agencies and trade and consumer groups. It is designed to help consumers understand an important aspect of home financing. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">We believe a fully informed consumer is in the best position to make a sound financial choice. This page will provide useful basic information about obtaining the terms of credit you really want. It cannot provide all the answers you will need, but we believe it is a good starting point. </span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The information presented on this page was prepared in consultation with the following organizations:</span></font></span></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">American Bankers Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">American Institute of Real Estate Appraisers</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Comptroller of the Currency</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Consumer Federation of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Credit Union National Association, Inc. </span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Deposit Insurance Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Home Loan Mortgage Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal National Mortgage Corporation</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal National Mortgage Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Reserve Board''s Consumer Advisory Council</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Federal Trade Commission</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Independent Bankers Association of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Bankers Association of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Insurance Companies of America</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Federal Credit Unions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Home Builders</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Association of Realtors</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Council of Savings Institutions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">National Credit Union Administration</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Office of Special Adviser to the President for Consumer Affairs</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Society of Real Estate Appraisers</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">The Consumer Bankers Association</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">U.S. Department of Housing and Urban Development</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">U.S. League of Savings Institutions</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Veterans Administration</span></font></span></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext"><font size="2">Back to Tools</font></span></font></a></font></span></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (151, 46, 2, 'PMI''s Lowering Your Down Payment', '                  <h3 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers">How To Buy the Home You Want</font></h3>\r\n                  <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2" class="bodytext">Mortgage insurance (MI) allows you to choose from a wider price range of homes. How? Lenders are generally willing to accept a lower down payment than the standard 20% if the lender obtains mortgage insurance on your loan through a mortgage insurance company. \r\n                    </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You can not only get the home you deserve, but you can conserve your savings and increase your income tax deductions, just by putting less money down. </span></font></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Buy More Home</font></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">You can afford more home and maximize your investment if your lender obtains MI for your loan.</font></span></p>\r\n                  <table border="0" width="89%"  cellspacing="0" cellpadding="2">\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font size="2"></font></td>\r\n                      <td width="19%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"> \r\n                        Without MI </span></font></td>\r\n                      <td width="18%" colspan="2" class="headln"> \r\n                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"> \r\n                          With MI</span> </font></div>\r\n                      </td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Down Payment</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">20%</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">10%</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="maintext">5%</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Your Available Savings </span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$10,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="44%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Maximum Home Price </span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$50,000</span></font></td>\r\n                      <td width="18%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="19%" ><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$200,000</span></font></td>\r\n                    </tr>\r\n                  </table><br>\r\n                  <span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bighead"><span class="bodytext">Financing a home with a low down payment loan may be the best way to afford a home in high-priced markets.</span></span></font></span></font></span> \r\n                  <h3 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers">Conserve Your Savings</font></h3>\r\n                  <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lower the down payment, the more you retain for home furnishings, other investments, future emergencies, or even college tuition</font></span></p>\r\n                  <table border="0" width="89%" cellspacing="0" cellpadding="2">\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font face="Verdana, Arial, Helvetica, sans-serif"></font></td>\r\n                      <td width="23%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"> \r\n                        Without MI</span></font></td>\r\n                      <td class="headln" colspan="2"> \r\n                        <div align="center"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"> \r\n                          With MI</span></font></div>\r\n                      </td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Home Price</span></font></td>\r\n                      <td width="23%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                      <td width="19%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$100,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Down Payment </span></font></td>\r\n                      <td width="23%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">20%</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">10%</span></font></td>\r\n                      <td width="19%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">5%</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Cash Down Payment </span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="18%"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$5,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Savings</span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="18%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$20,000</span></font></td>\r\n                    </tr>\r\n                    <tr> \r\n                      <td width="40%" class="headln"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Savings Retained</span></font></td>\r\n                      <td width="23%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$0</span></font></td>\r\n                      <td width="18%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$10,000</span></font></td>\r\n                      <td width="19%" ><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">$15,000</span></font></td>\r\n                    </tr>\r\n                  </table>\r\n                  <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Even if you have less than $20,000 saved, you can still afford to buy a $100,000 home with a lower down payment option if your lender obtains MI on your qualified loan from a mortgage insurance company.</font></span></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Increase Your Tax Write-off</font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">A larger loan amount will have higher interest payments and could result in higher tax deductions. </span></font></span></font></span></p>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage interest is one of the few remaining consumer debt items that you can deduct.</span></font></span></font></span></p>\r\n                  <p class="browntext"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Back to Tools</span></span></font></a> </p>\r\n                  <p>&nbsp;</p>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (152, 47, 2, 'If Your Mortgage Loan Application Is Rejected', '                  The joys and anticipation of owning a new home are sometimes crushed when the application for mortgage financing is turned down by the lender. If your loan request has been denied, you should understand why the loan was denied and what steps you can take to correct the problem or make sure that it does not happen again in the future. The following information helps you understand the most common reasons for loan denials and corrective measures you can take, and it describes some alternatives that exist especially for low and moderate income home buyers. </span> \r\n                  </font> <br><br><br>\r\n                  <font class="maintext_bold">Possible Causes For Rejection And Your Alternatives</font>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Appraised Value Too Low</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One of the factors considered by the lender is the ratio of the loan amount to the sale price or the appraised value of the property, whichever is lower. If the appraisal on the property is substantially lower than the purchase price, the loan-to-value ratio, or LTV, may be higher than the lender will, or can legally, approve. If you have applied for a maximum loan amount, 90 to 95 percent of the purchase price a low appraisal may make your requested loan too large. Your alternatives in this situation will depend upon the reasons for the low valuation. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the purchase price is simply higher than the prevailing prices being paid in the general area, you can try to renegotiate the price with the seller down to a level more in line with the market and one which the lender would accept in order to approve your loan. If this is not possible, your only other solution is probably accepting a lower loan amount, assuming you have sufficient funds to cover the additional down payment. </span> </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Inadequate Funds</font></b></font></p>\r\n                  <blockquote> \r\n                    <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Based on the financial information and the Verification of Deposit, the lender may have determined that you do not have enough cash to make a down payment and cover closing costs. Usually, these funds may not come from borrowing, but a gift from a relative can be used as long as no repayment of the money is expected. Other solutions include getting the seller to take back a second mortgage which would reduce the down payment requirement (assuming you can still qualify with the additional loan payments), or getting the seller to pay some of the closing costs, such as the origination fees. Finally, you could correct this problem by simply waiting, providing you institute a savings program in the meanwhile. \r\n                      </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Insufficient Income</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In assessing your ability to repay the requested loan, lenders look at the amount of your monthly income in relation to your proposed mortgage payments and to all of your monthly debt and installment loan payments. Generally speaking, your mortgage payment should not be more than 28 percent of your monthly gross income, and your total debt, including mortgage payments and other installment payments, should not be more then 36 percent. The percentages are slightly higher for FHA loans. These ratios are only guidelines, but if yours are substantially higher, say 35 percent and 42 percent, they are well beyond industry norms and can cause denial of the loan. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Sometimes, particularly if your credit card record is very good, if you can show that you are already carrying that much housing expense through rent or mortgage payments, you may be able to convince the lender to reconsider. This is an example of why full and accurate disclosure on the loan application works in your favor, even though it may not be obvious at the time. </span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If your personal circumstances have changed since the submission of the loan application let the lender know. An impending salary increase or bonus or new employment, for you or your co-borrower, may improve the financial picture presented on the application. These changes, of course, will need to be documented and verified before the lender will reconsider the loan request. </span></font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Too Many Debts</font></b></font></p>\r\n                  <blockquote> \r\n                    <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In some cases, it is not only the amount of debt owed by an  applicant that prevents qualifying for the loan. Extensive use of numerous credit cards and revolving accounts with evidence of increasing account balances that are close to the card issuers'' debt limits may be enough to kill the application. The primary solution to this problem is to pay off some of the accounts to bring down outstanding obligations, as well as the number of creditors. </font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4" class="headers">Unsatisfactory Credit History</font></b></font></p>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="browntext"><span class="bodytext">Nothing can be more damaging to your loan request than a history of poor debt repayment practices. If the credit report shows frequent late charges, past due accounts, judgments or bankruptcy, chances for approval of the loan are slim. Lenders may stretch their guidelines on debt ratios or income requirements, but have little tolerance for a bad credit record. Even low loan-to-value ratios and debt ratios cannot offset an unsatisfactory credit history. </span></span></font></p>\r\n                  </blockquote>\r\n                  <blockquote> \r\n                    <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="browntext">If your loan is turned down because of a poor credit report, you may request a free copy of the report from the credit report company, which will be identified in a notice from the lender. Examine the credit report carefully to see if it is up to date and accurate. The credit bureau must correct any errors in the report. If there are unsettled disputes over certain accounts, it must also include your side of the argument in the report. Even if the name on the report seems to be you, make sure all of the accounts and references apply to you. Many people have the same name and improper recording of data occurs. </span></span></font></p>\r\n                  </blockquote>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="browntext">If the adverse items on the report occurred because of illness, marital problems, job layoff or other temporary circumstances and were confined to a particular period of time, you should have provided the lender with a written explanation at the time the loan application was taken or at some other point in the process. If you didn''t do it then, do it now. Assuming there has been sufficient time since the problems occurred for you to regain financial stability and demonstrate prompt payment of your obligations, there is a good chance the lender will reconsider the loan request. Many lenders look for one year''s clean payment record to offset past credit problems. If the credit report is accurate and you have a questionable credit history, you need to start repaying outstanding balances on time in order to re-establish an acceptable record. It may take time, but there is no alternative when this problem stands between you and owning a home.</span></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Alternatives For Low And Moderate Income Homebuyers</font></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Many lenders participate in housing programs designed for low and moderate income home buyers who would not qualify for home loans under standard lending requirements. These programs are sponsored by both governmental and private organizations. If you have a good credit history, or have not established a credit history at all, they may provide a source of financing for your home purchase. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Primary sources of special, low income housing programs include state and local housing finance agencies, non-profit housing assistance groups, the Department and Housing and Urban Development (HUD) and secondary mortgage market operations such as the Federal National Mortgage Association (<b>Fannie Mae</b>) and the Federal Home Loan Mortgage Corporation (<b>Freddie Mac</b>). Your lender should be able to tell you how to contact local offices of organizations which work directly with borrowers or you can usually find them in the phone book in the blue government listings under <b>Housing</b>. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Assistance for low and moderate income home buyers is not only based on direct subsidies but also on relaxation of standard loan approval requirements. For instance, many low income families spend a greater percentage of their income groups. If you can show that you have consistently handled such higher payments and have a good credit record, the lender might approve the loan based on higher debt ratios. </span></font></p>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some potential home buyers have trouble getting a loan approved because they have not established a credit record. There is nothing adverse on the credit report but there is no record of prompt repayment of loans or charge accounts. If this is your situation, you may be able to qualify based on what is called a "non-traditional credit history." Using this approach the lender will depend on utility companies, past and present landlords and other sources which can verify that you have met a regular payment obligation in a timely, consistent manner. If you think such an approach might help you and the lender has not mentioned it, suggest it to the lender.</span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">A Rejection Is Not Your Last Chance</font></h3>\r\n                  <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The fact that a lender has rejected your loan application does not mean that you are denied home ownership forever. As has been discussed earlier, there are positive steps you can take to correct the problem. Some problems may be resolved very quickly while others may take longer, but you can turn around most problem situations. Take the time to determine exactly why your loan request was denied and then take steps to eliminate the cause of rejection. </span></font></p>\r\n                  <p align="left"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Return to Tools</font></a></font></p>\r\n                  <h1 class="headers"></h1>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (153, 48, 2, 'Cloasing Your Mortgage Loan', '                  Once your application for a mortgage loan has been approved and you have received a commitment letter from the lender, the final step before you can call the house your own is the closing, or settlement, of the purchase transaction and mortgage loan. Even though you have signed purchase agreement and your loan request has been approved, you have no rights to the property, including access, until the legal title to the property is transferred to you and loan is closed. You should have a good understanding of what is involved in the closing process, because there are a number of things that you can do to make sure that it goes smoothly and on time. </font></span></font></span> \r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">At closing, you will sign the mortgage loan documents, the seller will execute the deed to the property, funds will be collected and disbursed and the closing agent will record the necessary instruments to give you legal ownership of the property. Settle meant of a mortgage loan is a legal process, so specific procedures and requirements will vary according to state and local laws, but a general description of closing practices can help you through the process.</span></font></span></font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Between Commitment and Closing</b></font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">As soon as you receive firm approval from the lender who is making your mortgage loan, you should confirm the actual date of loan closing. An estimated closing date was probably specified in the sale contract, but a firm date needs to be set by you, the seller of the property and your lender. You want to make sure that settlement will take place before your loan commitment expires and before any rate lock agreement (guaranteed terms of the loan) expires. The settlement date also has to allow adequate time to assemble all of the required documentation. If repairs or maintenance on the property are a part of the lender''s commitment, there must be time to complete them. The real estate agents involved in the sale transaction and the lender are often the best people to coordinate the closing arrangements. Most lenders require at last 3 to 5 days advance notice of the closing date in order to prepare the loan documents and get them to the closing agent. </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are standard documents and exhibits that are commonly required for a loan closing, regardless of jurisdiction. Some of these will be your responsibility and others will be the responsibility of the seller. The following documents are typically required for closing.</span></font></span></font></p>\r\n                  <ul>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headln"><span class="headln"><span class="headers">Title Insurance Policy</span></span></span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Every lender will require title insurance. The company issuing the title insurance policy will have researched legal records to make sure that you are receiving clear title, or ownership, to the property. Their title search has established that the seller of the property is the legal owner, and that there are no claims, or liens, against the property. The title company offers both a lender''s policy and an owner''s policy. You will have to pay for a lender''s policy and it is advisable for you to have an owner''s policy as well. For a small additional premium, it will protect you up to the full value of the property if fraud, a lien or faulty title is discovered after closing. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Homeowner''s Insurance</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lender will require you to have homeowners insurance on the property at least in the amount of the replacement cost of the property. You should make sure the policy covers the value of the property and contents in the event they are destroyed by fire or storm. You must pay for the policy and have it at closing. You are free to select the insurance carrier, but the lender will require the company to meet rating standards and be rated by a recognized insurance rating agency. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Termite Inspection and Certification</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In many areas of the country, the property must be inspected for termites and the inspection is required in the purchase contract. In some parts of the country, this may be called a "wood infestation" report. The report is required on all FHA and VA loans as well as many conventional loans. \r\n                      </font></span> </li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Survey or Plot Plan</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender may require a survey of the property, showing the property boundaries, the location of the improvements, any easements for utilities or street right-of-way and any encroachments on the boundaries by fences or buildings. Encroachments can be minor, such as a fence, or may be serious and have to be corrected before closing. In some areas, an addendum to the title policy eliminates the need for a survey. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Water and Sewer Certification</span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the property is not served by public water and sewer facilities, you will need local government certification of the private water source and sanitary sewer facility. Properties with well and septic water sources are usually governed by county codes and standards. </font><font size="1" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"> \r\n                      </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Flood Insurance</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the lender or the appraiser determines that the property is located within a defined flood plain, you will want, and the lender will require, a flood insurance policy. The policy must remain in force for the life of the loan. </font></span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><span class="headers">Certificate of Occupancy or Building Code Compliance Letter</span></span></font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If your home is new construction, you will have to have a Certificate of Occupancy, usually from the city or county, before you can close the loan and move in. The builder will obtain the certificate from the appropriate authority. Many local governments require an inspection when a home is sold to see if the property conforms to local building codes. Code violations may require repairs or replacement of structural or mechanical elements. The responsibility for ordering the inspection and paying for any required repairs should be spelled out in the purchase contract.</font> </span></li>\r\n                    <li><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Other Documentation</font><br>\r\n                      <span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Additional documentation required for closing will be set out in the commitment letter from the lender and will depend upon terms of the sale, peculiarities of the property and local ordinances and custom. Examples would include private road maintenance agreements if the street in front of your property is not maintained by a municipality or proof of sale of your previous home if that was a condition of approval of your loan. </font></span></li>\r\n                  </ul>\r\n                  <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Within 24 hours prior to the actual closing, your and your real estate agent should make a final inspection of the property to make sure any required repairs have been completed, all property described in the sale contract, such as kitchen appliances, carpeting and draperies are present and that no recent fire or storm damage has occurred. In most cases, the lender will make a similar inspection before closing.</font></p>\r\n                  <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Loan Closing</b></font></h3>\r\n                  <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The actual loan closing procedure, including who conducts the closing and who is present, depends upon local law and custom and lender practices. Some states require that you be represented by an attorney, others do not. Even if it is not required by law, you may want to have an attorney, review the closing documents. </font></span></font></span></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some lenders will close the loan in their offices, some will use title or escrow companies and some will send their instructions and documents to their attorney or yours to conduct the closing. As soon as you receive your commitment letter from the lender, you should determine who is responsible for closing arrangements. \r\n                    </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The actual closing is conducted by a closing agent who may be an employee of the lender or the title company, or it may be an attorney representing you or the lender. The lender and seller, or their representatives, and the real estate agents may or may not be at the actual closing. It is not unusual for the parties to the transaction to complete their roles without ever meeting face to face. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The closing agent will have received instructions from the lender on how the loan is to be documented and the funds disbursed, and will have collected all of the necessary exhibits from you, the seller and the lender. The closing agent will make sure that all necessary papers are signed and recorded and  that funds are properly disbursed and accounted for when the closing is completed. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You typically need to come to the closing with a certified check for the closing costs, including the balance of the down payment. You can get the exact figure a day or two prior to the closing from lender or the closing agent. You should also bring the homeowners insurance policy and proof of payment if it has not been delivered earlier. </span></font></span></font></p>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">For the most part, your role at closing is to review and sign the numerous documents associated with a mortgage loan. The closing agent should explain the nature and purpose of each one and give you and/or your attorney an opportunity to check them before signing. A brief description of the major documents may help you understand their purpose and significance.</span></font></span></font></p>\r\n                  <dl> \r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Settlement Statement - HUD-1 For</b></font></strong></dt>\r\n                    <dd><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">This form is required by Federal law and is prepared by the closing agent. It provides the details of the sale transaction including the sale price, amount of financing, loan fees and charges, proration of real estate taxes, amounts due to and from buyer and seller and funds due to third parties such as the selling real estate agent. It must be signed by both buyer and seller and becomes a part of the lender''s permanent loan file.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some of your charges on the HUD-1 may have already been paid, such as credit report and appraisal fees. They will be noted as P.O.C. (paid outside the closing). You will usually be charged interest on the loan from the date of settlement until the first day of the next month and your first payment will be due on the first day of the month and your first will be due on the first of the following month. Make sure you know exactly when your first and subsequent payments are due and what the penalties are for being late.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If your loan is greater than 80 percent of the value of the property, you will probably have to pay for mortgage insurance that protects the lender in case you default. One year''s premium will usually run between .5 percent to .75 percent of the loan amount.</span></font></span></font></span></dd>\r\n                    <dt><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><br>\r\n                      </span></font></span></font></span></dt>\r\n                    <dd><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to your monthly payments on the loan, most lenders will require you to maintain an "escrow", or "impound,"account for real estate taxes and insurance. Current law permits a lender to collect 1/6th (2 months) of the estimated annual real estate taxes and insurance payments at closing. Additionally, real estate taxes for the current year will be pro-rated between you and the seller and paid at closing. After closing, you will remit 1/12 of the annual amount with each monthly payment. Tax and insurance bills should be sent to the lender who will pay them out of the escrow funds collected.</span></font></span></font></span></dd>\r\n                  </dl>\r\n                  <dl> \r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Truth-in-Lending Statement</b></font></strong></dt>\r\n                    <dd class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">This form is also required by Federal law. You were given an initial TIL shortly after you completed the loan application. If no changes have taken place since that time, the lender need not provide one at closing. If, however there are significant charges, you must receive a corrected TIL no later than settlement.</font></span></span></font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>The Mortgage Note</b></font></strong></dt>\r\n                    <dd class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The mortgage note is legal evidence of your indebtedness and your formal promise to repay the debt. It sets out the amount and terms of the loan and also recites the penalties and steps the lender can take if you fail your payments on time.</font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><font color="#BD827B"><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Mortgage or Deed of Trust</b></font></strong></font></dt>\r\n                    <dd class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This is the "security instrument" which gives the lender a claim against your house if you fail to live up to the terms of the mortgage note. It recites the legal rights and obligations of both you and the lender and gives the lender the right to take the property by foreclosure if you default on the loan. The mortgage or deed of trust will be recorded, providing public notice of the lender''s claim (lien) on the property.</font></dd>\r\n                    <dt>&nbsp;</dt>\r\n                    <dt><strong class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers" color="#BD827B"><b>Miscellaneous Documents</b></font></strong></dt>\r\n                    <dd><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">There will be a number of documents or affidavits that you will be asked to sign at closing. Some are lender requirements (e.g. a statement that you intend to occupy the properties your primary residence), or are required by state or Federal law. These instruments should not be taken lightly. Some provide for criminal penalties for false information, and some may give the lender the right to call your loan, which means the entire loan amount becomes immediately due and payable. When everything has been signed and the closing agent is satisfied that all of the instructions for closing have been complied with in full, you become the owner and are given the keys to the property. </font></span></font></span></dd>\r\n                  </dl>\r\n                  <p><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n                  <h1 class="headers"></h1>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (154, 49, 2, 'Transferring A Loan Between Lenders', '<h3 class="headers"><font color="#BD827B" size="3" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Does Transfer of Servicing Mean?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">When you take out a mortgage with a mortgage company or a bank, there is always a possibility that the lender \r\nwill <b>sell</b> or <b>transfer</b> the servicing of your loan to another institution. <b>Servicing</b> means \r\nthe collection of payments and management of operational procedures related to mortgages. When servicing is sold, \r\nit means that another lender will be taking your payments, handling your escrow accounts, paying your insurance \r\nand taxes and answering your questions. This may happen right after you close the loan or several years later. \r\n                          </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The practice of <b>selling</b> or <b>transferring</b> the servicing of your loan is legal and is very common in \r\nthe mortgage industry. When the servicing is sold, it is usually packaged in a bundle with other loans. Some \r\nmortgage companies only originate loans and sell or transfer the servicing immediately. It is more cost-effective \r\nfor these companies to do this because servicing is not a part of their business. It is not uncommon to \r\nget your mortgage from a neighborhood lender and have it transferred to an institution in another state. It \r\nis also possible for your mortgage servicing to be transferred more than once during the life of your loan.</span></font></span></font></p>\r\n                        <blockquote> \r\n                          <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><b class="bodytext">Whether or not your servicing is sold has nothing to do with the quality of your loan or your payment history. \r\nIt has, in fact, nothing whatever to do with you personally.</b></font></span></font></p>\r\n                        </blockquote>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Does It Affect Your Loan?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The company that holds your loan makes the decision to transfer servicing to another institution. The company does not \r\nhave to ask your permission to transfer the servicing, but it does have to inform you of the transfer. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The transfer of servicing should not affect you or your mortgage adversely. The original terms and conditions \r\nof your mortgage will stay the same. Your interest rate and duration of your loan will not change on fixed rate \r\nloans. Your payment should stay the same or on the same schedule except in cases where changes in taxes or insurance \r\nrequirements increase or decrease the escrow amount. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have an adjustable rate mortgage (ARM), the original conditions of the mortgage contract stay in effect and \r\nthe rate will change according to the adjustment periods (i.e. every six months, annually, every three years, \r\netc). This information is contained in your contract, but you are welcome to verify the information with your \r\nnew servicer. If your original lender agreed to let you refinance to a fixed-rate mortgage within a certain \r\ntime-frame, you should ask whether this agreement would be honored by the new lender.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>When Will You Be Notified?</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">if available), the new servicer''s address, and instructions for making your next payment.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>An Important Consumer Safeguard</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is very important that you receive both letters. If you receive only a letter from the new servicer, be \r\nsure to call your original servicer to verify that your loan actually has been transferred. It is extremely \r\nimportant that you keep your servicer informed of your current mailing address, so that you will receive all relevant correspondence.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers">Where Do You Pay Your Next Payment?</font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">If you have received both letters or have verified the transfer of your mortgage with your old servicer, be \r\nsure to send all payments from that point on to your new servicer. If you send the payment to the old servicer, \r\nyou run the risk of the payment not getting to the correct lender in time, paying a late charge or of having the \r\npayment being lost. It is your responsibility to send the payment to the new servicer once you are informed of the transfer. </font></span></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The <b>welcome</b> letter from your new servicer will often inform you if you will be receiving new payment coupons. \r\nBut if your payment is due before the coupons arrive, write your loan number on the check and send it to the \r\naddress provided in the welcome letter. If you have coupons from your previous servicer, you may include this with your payment. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You will want to read the <b>welcome</b> letter carefully \r\nfor payment instructions. Your payment date will not change, since it is determined in your original mortgage \r\ndocuments. If your mortgage is paid through electronic funds transfer or automatic draft each month, you will \r\nneed to cancel that arrangement and fill out new forms for the payment to be sent to the servicer. Since this \r\noften takes time, you may need to send a check yourself for a payment until your electronic funds transfer is \r\nchanged over. This is something that you will need to take care of. The new servicer cannot take the payment \r\nfrom your savings or checking account without your signature.\r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you accidentally send your payment to your old servicer, the company will usually forward the first payment to \r\nnew servicer, but they will not continue to do this. By not sending your payment to the correct office, you \r\nrisk your payment being lost. There are some cases where the old servicer no longer exists due to a merger or \r\ntake over. In that case, the payment may be returned to you by the postal service after several weeks, which \r\nmay cause a late charge to be assessed to your account. \r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">It is always best to follow the payment instructions received in the <b>welcome</b> letter or ask your new servicer \r\nabout alternate payment locations.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Happens To Your Escrow Account?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is your old servicer''s responsibility to inform the insurance company and your tax authority of the change \r\nin servicer. A follow-up call from you the insurance company or tax authority can help ensure that the tax \r\nor insurance bill is not sent to the wrong servicer. You should be able to find their number on your original \r\ninsurance documents. When you call the insurance company or tax authority, make sure they have your current address \r\nand phone number in case they need to contact you. </font></span></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">If your escrow account is interest-bearing, all interest due should be credited to your account by the old servicer \r\nbefore the transfer takes place. Your old servicer is responsible for handling these items prior to the transfer. \r\n                          </span></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some time after your servicing is transferred, your new lender will make an analysis of your escrow. During the analysis, \r\nthe lender reviews your escrow amount and determines if it is adequate to cover the fees for your insurance, \r\ntaxes and any other premiums paid through escrow. If the amount is found to be insufficient, the lender may \r\nask you to increase your regular monthly payment. If it is your new servicer''s policy to review escrow accounts \r\nas soon as the servicing is transferred your payment may change immediately, you should receive an explanation regarding any changes.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What About Insurance Policies And Taxes?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">If you receive a notice that either your insurance or taxes are due, call your new servicer and make sure that company \r\nhas on file that funds have been escrowed for the premium. If the new company has not received a copy of that bill, \r\nit will probably direct you to send in the bill for payment. If you have a question after the transfer has \r\ntaken place, you should contact your new servicer, even if your old servicer was the one that collected the \r\nfunds for your insurance or tax payment. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some mortgage companies offer to escrow life or disability insurance (insurance that would pay off the mortgage \r\nin case of death , or make payments in case disability). In these policies, the lender who originally made your \r\nloan is named as the beneficiary. If you have these policies, your old servicer should inform you of what \r\neffect the transfer of servicing will have on this insurance coverage and what action you may need to take to maintain coverage. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">On flood and hazard insurance, it is the responsibility of the old servicer to provide the insurance agent or \r\ncompany with a notice of transfer. The beneficiary may be able to be transferred from one company to the other, \r\nbut it is wise to make sure this occurs. You should make sure to transfer the beneficiary to ensure that, \r\nin case of a claim, the check is written and sent to appropriate servicer.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who Sends You Your End Of The Year Tax Statement?</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Make sure that you find out which lender will be reporting your interest paid for income tax purposes. Sometimes, \r\nboth lenders will report on the time that they had the loan. Quite often, the new lender will compile the information \r\nand send you one tax statement at the end of the year that covers the entire year. You should find out about \r\nthis at the time of the transfer so that you know if you should look for one statement or two at the end of the year.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Do You Have More Questions?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Usually your old servicer will make sure everything is taken care of prior to the transfer, but is in your best interest \r\nto check on all details. It is best to ask questions at the time of the transfer to make sure everything \r\nis handled before your old servicing company purges your records from its files. It is much more difficult \r\nto get information from an institution that has not handled your loan for the last six months. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have questions regarding you specific transfer, it is always best to contact your new servicer in writing. \r\nAt times of mortgage transfers, most companies are flooded with phone calls so you may get faster and clearer information through the mail.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Consumer Checklist</b></font></h3>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext">Always keep your servicer informed of any changes in your address and phone number. Provide this information \r\nin writing and forward it to the address indicated in your <b>welcome</b> letter. This address is usually \r\ndifferent from the one that you would send payments</span>.</span></font></span></font></span></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When your servicing is transferred, make sure you receive both a <b>goodbye</b> letter and a <b>welcome</b> \r\nletter. If you don''t receive both letters, call your old servicer to verify the transfer.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When you receive the letters, read them carefully making note of the new servicer''s name, address, phone number, \r\ncontact name and payment information.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When making your payments after your servicing has been transferred, follow the instructions in the <b>welcome</b>letter.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Make sure that your insurance companies (homeowners, flood/hazard, life/disability) and your tax authority have been notified of the transfer.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Find out which company will be reporting on your interest paid for income tax purposes.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Ask questions at the time of the transfer. If there is a problem, it is easier to handle it as soon as it \r\narises. If you have questions after the transfer is completed, contact your new servicer. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="2" class="bodytext">Back to Tools</font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (155, 50, 2, 'How To Save Half On Interest Costs', '                    Save $100,000 on mortgage interest costs! Sound impossible? Not really. An old-time mortgage that is once again proving popular allows homebuyers to so just that. It is the 15-year fixed-rate mortgage that lets homebuyers own their homes free and clear in 15 years. And, while the monthly payments are somewhat higher than a 30- year loan, the interest rate on the 15-year mortgage is usually a little lower, and importantly:</font></span></p>\r\n                  <ul>\r\n                    <li> \r\n                      <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><b>The homebuyer pays less than half the total interest cost of the traditional 30-year mortgage. The purpose of this page is to help prospective homebuyers explore the 15-year fixed-rate mortgage - a new option for saving on total mortgage interest costs.</b></span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who It''s For</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The 15-year fixed-rate mortgage has proved popular with two very different groups of homebuyers. First, it enables young homebuyers with sufficient income to meet the higher monthly payments to pay off the house before their children start college. They own more of their home faster with this kind of mortgage. Other homebuyers, who are more established in their careers, have higher incomes and whose desire is to own their homes before they retire, may also prefer this mortgage. The 15-year fixed-rate mortgage gives them additional financing options using the house''s equity. For example, they can easily take out a second mortgage if they want to make use of the equity in their home. But you need not fall into either category to appreciate the savings the 15-year fixed-rate mortgage affords homebuyers. Let''s take a closer look at some of the pros and cons of this type of mortgage and what savings you  may expect.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Advantages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">The 15-year fixed-rate mortgage offers the qualified consumer five big advantages.</font></span></font></span></p>\r\n                  <ol>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">You own your home in half the time it would take with a traditional mortgage.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"></span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">You save more than half the amount of interest of a 30-year mortgage. On a $75,000 mortgage at 9.5 percent, you save more than $95,000.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Lenders usually offer this mortgage at a slightly lower interest rate than with 30-year loans--typically 0.5 percent to 1.0 percent lower. It is this lower interest rate added to the shorter loan life that realizes the savings for 15-year fixed-rate borrowers.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><b>Fixed-rate</b>means exactly that - no matter where mortgage interest rates go, the payments for this mortgage stay the same from the first to the last. This helps many borrowers plan their budgets with more certainty. They know that their monthly payments will not increase (or decrease) and throw their financial planning off.</span></font></span></font></li>\r\n                  </ol>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" class="headers" face="Verdana, Arial, Helvetica, sans-serif"><b>Disadvantages</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">The disadvantages associated with a 15-year rate mortgage are really the qualifiers that will tell consumers if this is the mortgage for them.</font></span></font></span></p>\r\n                  <ol>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">The monthly payments for this type of loan are higher than those for a 30-year mortgage, roughly 10 percent to 15 percent higher per month.</span></font></span></font></li>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Because borrowers pay less total interest on the 15-year fixed-rate mortgage, they lose the maximum mortgage interest tax deduction.</span></font></span></font></li>\r\n                  </ol>\r\n                  <h3 class="headers"><span class="bodytext"><font color="#BD827B" size="4" class="headers" face="Verdana, Arial, Helvetica, sans-serif"><b>Compare Them Yourself</b></font></span></h3>\r\n                  <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">At right is a comparison of a $75,000 mortgage with terms of 15 and 30 years. We used a 15-year mortgage at a half percent lower rate, which is typical in today''s market. As you can see, the 15-year mortgage saves more than $95,000 over the traditional 30-year loan.</font></span></p>\r\n                  <h3 class="headers"><span class="bodytext"><font class="headers"><b>Want To Know More?</b></font></span></h3>\r\n                  <p><span class="bodytext"><font size="2"><span class="bodytext">For more information about 15-year fixed-rate mortgages, or to find out if you qualify, talk to your mortgage lender. He or she will be able to help you select the mortgage that is best for you.</font></span></font></span></p>\r\n                  <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"> \r\n                    30-year at 15-year at 10 percent 9.5 percent Monthly Payment (Principal and Interest) $ 658 $ 738 First Year Interest Cost 7,481 7,023 Mortgage Balance 74,583 72,625 Fourth Year Interest Cost 7,336 6,244 Mortgage Balance 73,052 63,991 Total Interest Cost Over the Life of the Loan $ 161,942 $ 65,970 Difference From 30-year Total - $ 95,972 </span> </font></span></font> \r\n                  <p></p>\r\n                  <p><span class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (156, 51, 2, 'When Your Debt Exceeds Your Home Value', '                  <ul>\r\n                    <li><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>What is a short pay off?</font></b> </span></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Imagine your home is worth $200,000, but you owe $220,000 on it. If you were to sell it in the open market at $200,000, you might net $184,000, or $36,000 less than what you need to pay off the loan. A short pay off is where your lender will forgive a portion or all of the short amount.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">What lender would just write off that type of money?</font></span></span></font></b> \r\n                      <br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Just about all of them will, with justification. Justification might mean a substantial loss of income that would prevent you from paying on the mortgage, therefore being forced in a position to sell the home. Attempting to sell short so you can upgrade to a larger property is not justification. In addition, lack of cash reserves will also serve as justification. Don''t expect to place your home on the market at 75% of market value and expect your lender to jump on any offers.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><font size="3"><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif"><span class="headln"><span class="headers">How will this affect my credit?</span></span></span></font></b></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Depending on how you negotiate the transaction, it could go on your credit report as, "settled," or, "paid,"or "short payoff". It depends on the lender and how well you can negotiate.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Are some lenders harder to deal with than others? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Yes. If you have a Freddie Mac loan, Freddie Mac will probably want you to contribute to the short sale, get your agent to reduce brokerage fees, and get the buyer to take the property with the termites. Some lenders will just ignore you.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">What will my lender require from me in order to consider participating in a short sale? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext"><br>\r\n                      </span></font></span></font></span> \r\n                      <ol>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your past 2 years tax returns </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Letter of hardship </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Complete loan application </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Preliminary title report </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Listing contract </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Copy of MLS </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A marketing plan for your home </span></font></span></font></span></li>\r\n                        <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A broker price opinion (like an appraisal). </span></font></span></font></span></li>\r\n                      </ol>\r\n                      <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When you have an offer, all of the above should be enclosed with the offer (except for the marketing plan) plus the purchase agreement, and a good faith estimate as to what the lender will net after the close of escrow. </span></font></span></font></span></p>\r\n                    </li>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Why should I list with an agent? It seems if I can save the brokerage fee that the lender would net more and be more inclined to accept any offers that come in. </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">You are correct. If you''re loan is current, you may be able to get a qualified buyer yourself. If your loan is delinquent, or in default, you don''t have time to play around getting your home sold. You need as much exposure as possible.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><span class="headln"><span class="headers">What happens if my lender say''s "No," and I''m in foreclosure?</span></font></span></span></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">This is one situation where "No," means, "Maybe, you just haven''t convinced me that participating in a short sale is to my benefit." Keep hammering your lender, and do not take your home off the market until your lender agrees to a sales price and the prospective buyer has formal loan approval.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Should I try to hide any assets in order for the lender to consider participating? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Most assets are traceable, except for personal collections (guns, coins, etc.). If you own another property, it will show up on your credit report. Your lender may back track to your original loan application to see if there are any other assets. No, don''t hide assets. If your lender discovers you''re not dealing honestly, they''ll never co-operate. </font></span></li>\r\n    </ul><ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Can any real estate agent or attorney handle a short sale?</span></font></span></font> \r\n                      </b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">A lot will say they can. There''s no real way to tell if they can. If your home goes into foreclosure, you''ll get flooded with a ton of mail. There''s a good bet that most of the mail is from people who have helped out previously in these situations. One way to tell is if the person you''re dealing with will ask you for the information outlined <a class="mainlink" href="#above">above</a>. They''ll know these are the requirements.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">Question: I believe that in California, the loan is secured by the property, so the bank cannot go after your assets to make you pay the remaining balance of the loan. The bank will try and guilt you into doing so, ignore them. If they refused, threaten to foreclose and be ready for the bank to do so. At that point, they will usually negotiate. I''m sure this info won''t be added to the real estate criter''s FAQ.</span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Actually, this is a good example of a misnomer in the foreclosure arena so this &quot;real estate criter&quot; is going to add it to the FAQ. There are no deficiency rights in California for <b>Purchase Money Loans</b>. This is the loan you obtained in order to purchase the property. Once you refinance the property, take out an equity line of credit, obtain a consumer loan that is secured by the property, this rule no longer applies. The lender has the right to go after you in a deficiency judgement, even if a senior lien holder takes the property back and a junior loses his security instrument.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">How can I assure a non-purchase money lender won''t go after me after the short sale? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">When any lender agrees to a short pay, they are relinquishing their right to pursue the borrower in the future</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Are there any tax ramifications? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Yes. According to IRS Section 108 a-e, there are debt/income interpretations that may come into play. The IRS may view the deficiency on a non-purchase money loan as income and demand you to pay taxes on that amount. If the short pay transaction resulted in a net loss of $20,000 to the lender, your tax liability could be around $6,350.</font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><b class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers">So why would I want to do a short sale only to owe the IRS money? </span></font></span></font></b><br>\r\n                      <span class="bodytext"><font size="2"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">To limit your tax liability. In some cases (not Citicorp, Fannie Mae, or Freddie Mac) the senior lien holder will allow for some funds to be allocated to the juniors. If you allow the property to go into foreclosure, and the juniors lose 100% of their money, you can get taxed on the full amount. You should really contact a CPA concerning this part of the Tax Code.</font></font></span></li>\r\n                  </ul>\r\n                  <ul>\r\n                    <li><font size="3" class="headln" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B"><span class="headers">I have an FHA loan. They won''t do a short pay. Any suggestions? \r\n                      </span></span></font></b></font><br>\r\n                      <span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Any feedback from other states would be appreciated. There are certain regions where FHA will not participate in short sales. One region is the state of California. If you are in foreclosure on an FHA loan in California, you may want to approach HUD to see if they will consider a lower interest rate, or some type of repayment schedule until you get back on your feet. </span></font></span></li>\r\n                  </ul>\r\n                  <p><a class="mainlink" href="tools.php" class="bodytext"><span class="bighead"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Back to Tools</span></font></span></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (157, 52, 2, 'What Happens After You Apply For A Mortgage?', '                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Scientists who study and measure human behavior find that buying a home is one of the most stressful experiences of our lives. Contributing significantly to this anxiety is waiting for the mortgage to be approved. Much of the homebuyers'' unease results from not knowing what is going on. You know credit checks and verifications of employment are taking place-but what makes the difference between getting or not getting that loan, and how long does it take? This page can dispel at least some of that anxiety by detailing the steps the lender takes in making the loan decision-process called "underwriting." Listed below are the topics addressed on this page.</font></span></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#goodrisk">Are You a Good Risk?</font></a></span></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#initialinterview">The Initial Interview</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#safeguards">Consumer Safeguards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#sufficientincome">Is Your Income Sufficient?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#incomerequired">Income Requirements</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#income/expense">Income/Expense Standards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#debt">Debt</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#goodcredit">Is Your Credit Good?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#creditinfo">Credit Information Safeguards</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#downpay">Can You Make The Down Payment?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#worthprice">Is The House Worth The Price?</a></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><a class="mainlink" href="#doigetloan">Do I Get The Loan?</a></span></font></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="goodrisk" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Are You a Good Risk?</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"><span class="bodytext">Just as wise stock market investors carefully research the companies in which they plan to buy stock, careful mortgage lenders investigate the financial background of each loan applicant. In lending the prospective homebuyer the money to buy the home, the lender assumes a long-term risk. The assumption is that the borrower is going to eventually repay the loan and in the meantime make the loan payments on time. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Once all the information is collected and eligibility is established, the lender decides whether to extend the homebuyer credit. In other words, lenders analyze the risk of lending (making the investment), and match it to an appropriate interest rate and loan term. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are no established, industry-wide standards for underwriting, though most lenders follow standards set by government-related agencies, private mortgage insurers, private mortgage investors or institutional investors. The vast majority of mortgage lenders attempt to approve a loan application if at all prudently possible, but to approve a loan that will become delinquent serves no one''s best interest. The burden falls on the lender to establish that an applicant is qualified.</span></font><font size="2"><span class="bodytext"></span></font></span></p>\r\n                        <h3><a class="mainlink" name="initialinterview" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>The Initial Interview</b></font></a></h3>\r\n                        <p><span class="bodytext"><span class="story"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">The process usually begins with an interview where the prospective borrowers and a representative of the lender sit down to discuss the potential loan. Increasingly, however, lenders are not requiring a face-to-face meeting and accept a completed application by mail. Many lenders today will even qualify you for a loan before you begin to shop for a home. Many lenders advertise this service in the local newspaper, but any lender can provide it. Knowing approximately how much money you are qualified to borrow can save you time and prevent disappointment when you are looking at houses. </font></span></span></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">When going to see a lender for an initial interview, you should take:</span></span></font></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Purchase contract for the house if you have one.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Certificate of Eligibility from the Veterans Administration (VA) if you want a VA loan. (Note: If you do not have one, the lender will obtain the information for you from your service records.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Bank account numbers and the address of your bank branch. This will save the lender time in checking your credit.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Credit card bills for the past several billing periods.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Pay stubs, W2 forms or other proof of employment and salary.</span></span></font></li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">If you are self-employed, you should be able to present balance sheets, tax returns and other information about your business. </span></span></font></li>\r\n                        </ul>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">The important document that gets the whole process rolling is the loan application. It asks in-depth questions concerning you, your income, assets and liabilities, your credit, and your legal history, as well as a description of the property you wish to buy. The lender will verify the information you provide on the application before making the decision whether to extend the loan. </span></span></font></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="story"><span class="bodytext">Applicants usually will know after the initial interview if they are qualified for the type and size of loan they want. Lenders try to let the borrower know as quickly as possible if they really are not qualified for the size of loan that they request.</span></span></font></p>\r\n                        <h3><a class="mainlink" name="safeguards" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Consumer Safeguards</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The initial interview sets in motion some important consumer safeguards. The Truth-in-Lending disclosure requirements provide the applicant with an estimated yearly cost for the loan - the <b>Annual Percentage Rate (APR)</b>. The other important disclosure that follows from the <b>Real Estate Settlement Procedures Act (RESPA)</b>, a federal law. This requires lenders to provide homebuyers with information on known and estimated closing costs. \r\n                          </span></font></span></font></span></p>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext">The initial interview also starts a clock that will allow applicants to know whether or not they have been approved in about 30 to 60 days from the submission of a completed application. If the loan is denied, the lender must disclose the specific reason (s) for the rejection.</span></span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="sufficientincome" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Is Your Income Sufficient?</b></font></a></h3>\r\n                        <p class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2">Following the initial interview, or loan application, the first step the lender takes is to verify your employment or income. This is done by mailing employment and income forms to current and past employers, and it will help the lender determine how much debt you can successfully take on.</font></p>\r\n                        <h3><a class="mainlink" name="incomerequired" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Income Requirements</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2">A general rule is that you can qualify for a loan of up to twice the family''s income (i.e. a family with income of $30,000 a year usually can qualify for a mortgage of up to $60,000). Often, the amount you earn may not be as important as how you earn it. Bonuses and commissions can vary greatly from year to year, and lenders are reluctant to depend on them if they make up a large percentage of your income. There are similar problems when a large portion of your salary is based on overtime pay, and you rely on it to qualify for the loan. In the case of bonuses and commissions, the lender will want to verify your bonus and commission status back two or three years to get a better idea of what you earn from those sources on average. In the case of overtime, the lender will establish whether the work is expected to continue and whether or not the amount of overtime income is reasonable for the extra work. After establishing these points, the mortgage lender will make a decision as to how much to allow for these additional sources of income.</font> </span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you are self-employed, you should plan on producing a balance sheet, profit and loss statements and copies of your federal income tax returns for the past two or three years. Tax returns may also be required to verify other income claims, such as when income from securities is a major source for mortgage payments.</font></span></font></p>\r\n<h3><a class="mainlink" name="income/expense" class="headers"><font color="#BD827B" class="headers" face="Verdana, Arial, Helvetica, sans-serif" size="4"><b>Income/Expense Standards</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext" size="2"><span class="bodytext">Your lender will work out these figures for you when you sit down to discuss the mortgage you want. </span></font></span></p>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext"><span class="bodytext"><span class="bodytext">Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For Federal Housing Administration (FHA) loans, this figure is not to exceed 29 percent of the homebuyer''s gross monthly income. With loans guaranteed by the Department of Veteran''s Affairs (VA), lenders measure prospective homebuyers with <b>Residual Income</b>, or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower. </span></span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"></span></font></span></span></font></span></p>\r\n                        <ul>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="headers"><b>FHA Loans</b> </span> </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">Housing Expenses = 29% gross monthly income</span></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">Housing Expenses plus Long-Term Debt = 41% gross monthly income</span></span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="debt" class="headers"><font color="#BD827B"><span class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Debt</b></span></font></span></font></a></h3>\r\n                        <p class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. FHA-insured mortgage lenders define long-term debt as monthly expenses extending 12 months or more into the future, and look for these expenses plus housing expenses not to exceed 41 percent of the homeowner''s gross monthly income.</font></p>\r\n                        <h3><span class="headers"><a class="mainlink" name="goodcredit"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Is Your Credit Good?</b></span></font></a></span></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Before extending credit, lenders will want to examine the risk of not getting the money back. To do this lenders will look at four crucial aspects of your credit history when you apply for a mortgage:</font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><b><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">History of past credit</span></span></span></font></b><span class="bodytext"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"> \r\n                             - what were the size and terms of past loans?</font></span></span></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext"><span class="bodytext">Type of Credit</span></span></b><span class="bodytext"><span class="bodytext"> \r\n                             - have you obtained real estate, auto, personal or other installment loans in the past?</span></span></span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">Lapses in employment or debt repayment</span></b><span class="bodytext">\r\n                           - are active accounts current , and is there any recent bankruptcy or judgment?</span></span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b></b>\r\n                           - how many unexplained lapses are there, and for how long? </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">From the information uncovered by these four questions, lenders can develop a fair idea of just how you will handle your responsibilities once you have signed the contract for repaying the loan. However, lenders cannot examine everything when putting together a credit history. They have two extremely important limitations on credit information gathering.</font></span></font></p>\r\n                        <h3><a class="mainlink" name="creditinfo" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Credit Information Safeguards</b></span></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">The first limitation is the Fair Credit Reporting Act, which was designed to ensure fair and accurate consumer credit reporting. The Fair Credit Reporting Act stipulates that lenders must certify the purpose for which the information is sought and use it for no other purpose. The Act also prohibits reports based on subjective information from neighbors and others concerning character, general reputation and other personal aspects. Certain other credit information, such as bankruptcy more than seven years before, is also prohibited unless the principal involved in the action was $50,000 or more. </font></span></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">The second consumer safeguard limiting the credit information lenders can use to make a mortgage decision is the Equal Credit Opportunity Act (<b>ECOA</b>). ECOA prohibits discrimination in lending based on race, color, national origin, sex, marital status, age (provided the applicant may legally contract), and the fact that all or part of the applicant''s income comes from a public assistance program. </font> </span></font></p>\r\n                        <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">Lender''s are also prohibited by law from asking:</font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">questions concerning the applicant''s spouse, unless</span></b> \r\n                            </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the spouse will be contractually liable, </font></span></font></li>\r\n                              <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">the spouse''s income will be used to qualify, </span></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the applicants live in a community property state, or </font></span></font></li>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><font class="bodytext">the applicant will use child support, alimony or separate maintenance payments from a spouse or former spouse to qualify. </font></span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b><span class="bodytext">questions concerning future parenting plans.</span></b></span></font><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"> \r\n                            (although the lender may ask the ages and current number of children the applicant has)</font></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="downpay" class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Can You Make The Down Payment?</b></font></a></h3>\r\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext"><span class="bodytext">Lenders expect homebuyers to have enough money available to make the down payment of between 10 and 20 percent of the asking price for the house-though FHA and VA loans require smaller down payment (0 to 5 percent) and to pay their share of the closing costs (3 percent to 6 percent of the loan amount). If, however, you cannot come up with a 20 percent down payment, a lender can make you a loan for as little as 5 percent down. He will, however, require you to carry private mortgage insurance for conventional (not FHA or VA loans), for which you will pay a premium for the first year and an additional monthly fee in subsequent years.</font></span></p> \r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Sources on which prospective homebuyers may draw for the down payment and the closing costs include savings, stocks/bonds, Individual Retirement Accounts (IRAs), pension funds, real state holdings, life insurance policies, mutual funds or employee savings plans. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Homebuyers may also rely on another source of funding for the down payment-a gift, or money given by a parent or other relative that need not be repaid. a person may give another person up to $10,000 per year without either party being taxed. A married couple, therefore, could give a child or spouse as much as $40,000 for a down payment tax-free. Remember, however, that if you use gift money for a down payment, you will need to present a letter so stating and signed by both the giver(s) and the receiver( s) to your lender. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage lenders send a form to the homebuyer''s savings institution(s) to verify the amount available for purchasing the house, as well as the amount of outstanding loans with that institution.</font></span></font></p>\r\n                        <h3><a class="mainlink" name="worthprice" class="headers" target="#BD827B"><font color="#BD827B"><span class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4"><span class="headers"><b>Is The House Worth The Price?</b></span></font></span></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" class="bodytext">Mortgage lenders also examine the real estate being purchased to make sure that, in case of foreclosure, the lender has a salable property. The property''s acceptability is established by an independent appraisal. </font> \r\n                          </span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The appraiser looks not only at what the home is worth today, but how the neighborhood''s dynamics will affect the property value in the future. The three main points the appraiser checks are:</font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><b><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Physical security of the property.</span></font></b> </span> \r\n                            </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">age, structural soundness, landscaping, etc. </span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><b class="bodytext">Location.</b> \r\n                            </span> </font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"><span class="bodytext">The kind of neighborhood, surrounding houses, access to transportation, commercial development nearby, etc</span>. </span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Local government''s plans for the area.</b> </span></font></span></font> \r\n                            <ul>\r\n                              <li><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">how zoning and taxes will affect the property in the years to come.</span></font></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="doigetloan" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Do I Get The Loan?</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender has made all the checks. Your income, credit, assets, property and all necessary documentation have been scrutinized. Now comes the big decision. </font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the lender''s decision is to extend the credit, you will be notified, usually through a commitment letter. The mortgage lender can approve the homebuyer for the entire amount asked for, or a lesser amount based on the borrower''s qualifications. The commitment terms relating to interest rate and/or discount points may be firm at the time of commitment or conditioned on the market rate at the time of closing. If the decision is not to extend the credit, the lender has 30 days from the acceptance of the completed application to notify the prospective homebuyer. This notification must also include the reason(s) for the rejection. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If the loan is eligible for government insurance or guaranty, written agreements stating so are issued. These can be either an FHA or Firm Commitment or VA Certificate of Commitment. Conventional loans (not FHA or VA) receive an application for private mortgage insurance if the down payment is less than 20 percent of the purchase price. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">By now you should feel a bit more at ease about what happens after you apply for a mortgage. If you have a good credit rating, it will speak for itself. Also, it is up to the lender to prevent homebuyers from over-extending themselves to the point of losing their homes. Prudent underwriters should prevent this from occurring. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Certainly there will always be some anxiety associated with applying for a mortgage, but if you understand the process, waiting for approval will be far less worrisome.</font></span></font></p>\r\n                        <p><a class="mainlink" href="tools.php"class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (158, 53, 2, 'How Much Can You Qualifi For - Self Test', '                          Imagine you have just completed a search that included hundreds of hours of looking at the exteriors and interiors of houses. You have sized up siding, reviewed roofing and perused the petunias. And finally, you have found the house of your dreams. Now imagine that this house of your dreams costs much more than you can afford. </font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you are house hunting and have not done an important piece of homework, you could be in for this kind of heartbreak. The first thing you need to know when shopping for a home is how much you can spend. </font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">A general rule is that you can purchase a house valued at twice your annual income, but this does not take into account your debts, a large down payment, or other factors which can add to or detract from the amount you can afford. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The purpose of this page is to help give you a more specific idea of what priced house you can afford. It will address what you are worth and what you owe on a regular basis (your assets and liabilities) and what costs you would most likely encounter once you bought your new house. In general, you will be examining the same things a lender looks at when deciding how large a mortgage you can afford. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Completing the worksheet inside this brochure should save time while shopping for a home because it will narrow your choices based on costs. When you finally do talk with lenders, you will have some answers for many of their questions, speeding up your loan''s processing. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">It should be noted, however, that today many lenders will qualify you in advance for a mortgage, even before you begin to shop for a home. Many lenders advertise this service in the local newspaper, but contact any lender to see if this is possible.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Down Payment</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Private Mortgage Insurance</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment - as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are required to carry <b>Private Mortgage Insurance</b>. Private mortgage will require an initial premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 mortgage with a 10 percent down payment, this would mean a premium of $338 to $675 for the first year and an extra $15 to $20 a month in subsequent years</font><font size="2">.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are Your Assets?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The first thing you have to examine when deciding how much you can spend on your new home is how much you are worth, taking into account your income, savings, investments and other holdings such as Individual Retirement Accounts (IRAs) or Keogh plans, the cash value of your life insurance, pensions or corporate savings plans, and equity in real estate. Lenders will need this information before deciding to extend you the loan. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Often, the amount you earn may not be as important as how you earn it. Bonuses and commissions can vary greatly from year to year, and lenders are reluctant to depend on them if they make up a large part of your income. There are similar problems when a large portion of your salary is based on overtime pay, and you rely on it to qualify for the loan. To get a realistic view of what your income level actually is, average your income (including bonuses, commissions and overtime) for the past two or three years. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">As a last resort, pensions and corporate thrift plans can provide another source of down payment money. Most plans or policies give you the option of either withdrawing your money with no repayment or borrowing against the cash value. Though it is not the best policy for most homebuyers to borrow from these sources in addition to borrowing mortgage money, they can often get rates substantially lower than those on many other kinds of loans. Remember - if you borrow against the cash value of your life insurance or employee thrift plan, you will be making principal and interest payments for these separate from your mortgage. You should estimate these payments under installment loans on the worksheet inside. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">While turning your savings, investments and other holdings into cash (making them "liquid"), remember that you will probably have to pay tax on most of it. One source of tax-free money often overlooked is a gift, or money given by a parent or other relative that need not be repaid. A person may give another person up to $10,000 per year without either party being taxed. Your parents, for example, could give you and your spouse up to $40,000 tax free.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Liabilities</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Your liabilities are those expenses for which you are responsible each month. These include outstanding loans, such as student, auto, personal and so on, as well as credit card balances. When calculating your liabilities, use the entire balance for your credit cards, as if you had to pay them off entirely this month. That way, you give yourself some breathing room should you run up an unusually high balance during your mortgage term. \r\n                          </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">You should estimate these payments under liabilities on the worksheet.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Emergency Funds</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is always wise to put a little money away "for a rainy day" - especially when you are paying off a mortgage. If something arises such as unexpected medical costs or substantial auto repairs, you would want to be able to pay those expenses without jeopardizing your ability to meet your mortgage payments. Most financial experts suggest that you always have six months income on hand in case of emergency.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Annual Income</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">When calculating your annual income, remember to take into account all sources. You may, for example, get dividends from investments, alimony or child support payments. Calculate your annual income on the following page.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Annual Expenses</b></font></h3>\r\n                        <p class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This list should get you started, but you may have special expenses that are not listed here. Remember that when you buy your house you will no longer have to pay rent, and your utilities costs will change. You can use this money for your mortgage payments or other operating costs associated with your new home.</font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>The Costs of Homeownership</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Of the costs of homeownership, the ones listed on the next page are the most important. Homeowners insurance premiums usually run about $300 to $500 per year, and property taxes and maintenance costs will vary, of course, depending on the size, age and condition of your new house. Estimates for the costs of utilities, maintenance and improvements can be obtained from Realtors, local utility companies and others. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Some homebuyers will also have an additional cost of homeownership if they are buying into a condominium or a co-op. Condo and co-op fees are additional amount usually paid monthly on top of the mortgage payments. Some homeowners will also incur a home owners association fee for their block or neighborhood. These fees vary greatly from location to location.</span></font></span></font></p>\r\n                        <p><a class="mainlink" href="tools.php" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (159, 54, 2, 'Why Mortgage Escrow Accounts?', '                          Mortgage escrow accounts have been in the news lately and seem to be greatly misunderstood by many consumers. The original idea behind mortgage escrow accounts was to protect the interests of homeowners and they have been serving that purpose for more than 50 years.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Why Mortgage Escrows?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage escrow accounts came into being more than 50 years ago. In the 1930''s, many Americans were losing their homes in foreclosures because of late tax payments. To help ease the burden on homeowners who had to come up with large, lump sum payments at tax time, lenders agreed to take on the responsibility by collecting smaller monthly sums from homeowners along with their mortgage payment. In 1934, the government mandated that lenders manage escrows on all FHA insured mortgages. This then became the standard practice for all mortgages.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b></b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage escrow accounts ensure that homeowners'' property taxes, fire and hazard insurance premiums, mortgage insurance premiums and other escrow items are paid in a timely fashion. They are a guarantee that there is always enough money to pay these bills when they are due so that the homeowner avoids the risk of lapsed insurance coverage or delinquent taxes.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who''s Protecting The Homeowner?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Escrowing is governed by the Real Estate Settlement Procedures Act of 1974 (<b>RESPA</b>), administered by the U.S. Department of Housing and Urban Development (<b>HUD</b>). Lenders must manage their escrow accounts in compliance with this federal law and with the interpretations set out by HUD. </span></font></span></font></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition, the 1990 Housing Bill recently signed into law by the President, requires lenders to issue itemized statements of escrow accounts to borrowers on an annual basis. While many lenders are already providing homeowners with regular statements of their escrow accounts, the new law should ensure that every lender follows this practice.</span></font></span></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Who Should You Talk To?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Escrowing as practiced by the nation''s lenders protects both the borrower and the lender. Borrowers who have questions or concerns about their escrow accounts should talk to their lenders immediately. Consumers who know the purpose of escrows and are aware of the benefits they provide are the best insurance against misunderstandings between borrowers and lenders or misleading information from any source.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Escrows Do For Homebuyers</b></font></span></span></h3>\r\n                        <ol>\r\n                          <li><font size="4"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers">Guarantee that bills are paid on time.</span></font></span></span></font><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><br>\r\n                            <span class="bodytext"><font size="2" class="bodytext">The most obvious advantage of escrows is that they automatically budget the borrower''s tax and insurance responsibilities over the course of a year. Homeowners do not have to worry about coming up with several large, lump sum payments, each with different due dates, throughout the year. If there is ever a fire in the home, or if the basement floods causing damage, the homeowner is assured that the home is protected by up-to-date insurance</font>.</span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><font size="4" class="headers">Unexpected increases are taken care of</font></span><b><br>\r\n                            </b><span class="bodytext"><font size="2"><span class="bodytext">Because of escrows, homeowners also do not need to worry about calculating unexpected increases in their taxes or insurance premiums. It is the responsibility of the lender to allow for possible increases in these payments. \r\n                            </span></font></span> </font> </span> </span> \r\n                            <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Even when there are not enough funds in a mortgage escrow account to meet increased tax or insurance payments, the lender typically covers the bill without charging interest to the borrower. It is very common for lenders to pay taxes and insurance premiums when they are due even though all the money for these bills has not yet been collected from the homeowner. It is estimated that in 1989 alone, lenders advanced more than $600 million to homeowners who then avoided the penalties and risks of not paying their taxes and insurance on time.</span></font></span></span></font></span></p>\r\n                          </li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><font size="4"><span class="headers"><span class="headers">Mortgages have lower rates and down payments because of escrows.</span></span></font><br>\r\n                            <span class="bodytext"><font size="2" class="bodytext">Escrows protect the interests of investors in home mortgage loans. By making home mortgages more attractive and secure as investments, escrowing has led to a healthier mortgage market. As a result, loans with better terms and lower down payments are available to homebuyers.</font></span></font></span></span></li>\r\n                          <li><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><font size="4"><span class="headers">Local governments save money.</span></font><br>\r\n                            <span class="bodytext"><font size="2"><span class="bighead"><span class="bodytext">Escrow accounts also benefit local governments by providing a more efficient, less expensive means of tax collection. Rather than working with millions of homeowners, municipalities need only collect from a few hundred lenders.</span></span></font></span></font></span></span></li>\r\n                        </ol>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Does The Lender Come Up With My Payment?</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The law is very specific in setting limits on the amount that the lender may collect. the lender may require a monthly payment of 1/12 of the total amount of estimated taxes, insurance premiums and other charges reasonably anticipated to be paid. Plus, the lender may collect an additional balance of not more than 1/6 of the estimated annual payments. If the lender determines there will be or is a deficiency in the escrow accounts, the law permits the lender to require additional monthly deposits to avoid or eliminate the deficiency.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Happens When My Loan Is Transferred?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">When the servicing of your loan transferred to another lender, the new lender takes on the responsibility of managing your escrow account. At that time, the new lender may examine your escrow account to make sure that the funds being collected are sufficient to cover all payments that are to be made. If the new lender feels that the amount collected must be adjusted, you will be notified of the change in your monthly payment.For more information, contact the Mortgage Bankers Association of America, Consumer Affairs Division, 1125 15th Street, N.W., Washington, D.C. 20005</span></font></span></span></span></font></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext" size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></span></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (160, 55, 2, 'Mortgage Insurance - Frequently Asked Questions', '                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="bodytext"><span class="headers"><span class="headers"><span class="headln"><span class="headers"><span class="bodytext"><span class="headers"><span class="bighead"><span class="bighead"><span class="bodytext"><span class="contactmenu"><span class="footer"><span class="headers"><span class="headln"><span class="headln"><span class="mainpage"><span class="menulinks"><span class="headln"><font color="#000000"><span class="headers">I have lived in my home for 5 years and am in the process of selling it. I had to buy PMI insurance because I did not have 20% down. Am I entitled to any type of refund once I sell the house?</span></font></span></font></span></font></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Entitlement to a refund and the amount would depend on the mortgage insurance plan type and the refundable or non-refundable/limited option chosen at origination. Your best bet is to ask your lender directly, as there are many different mortgage insurance plans and combinations. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B"><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers">I think banks are being very greedy in demanding a secured loan plus PMI and still wanting a perfect credit rating for 7 years. My husband and I are trying to buy a home. We have a good credit rating, but not perfect credit for 7 whole years. If you guarantee the loan, what is their problem in granting it?</span></font></span></span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage insurance does not guarantee the loan, it only insures a designated portion (commonly only 12-30%) of the loan against default. The combinations of loan characteristics (credit, collateral, MI, etc.) are established as requirements by investors. Loans usually end up in mortgage backed securities. The mortgage securities may be purchased by investors, for example to go into Individual Retirement Accounts (IRA''s), 401K plans, etc. The investment funds for IRAs, 401Ks, etc., have risk and return requirements which ultimately dictate the loan characteristics. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">If mortgage insurance is cancelled, are any pre-paid premium amounts refunded (particularly if they were originally paid by adding them to the loan amount)?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If all the mortgage insurance was financed at the time of origination and is canceled prior to it''s maturity you may be entitled to a refund if the refundable option was chosen at time of origination. However, if the no refund/limited option was chosen no refund is due. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">If a borrower currently has an FHA loan w/MI, after the LTV has reached 80% or less can the MI be cancelled?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">It is best to refer back your lender for specific information on FHA loans. PMI Mortgage Insurance Co. does not insure FHA loans and therefore can not respond regarding FHA policies.</font></span></p>\r\n                        <h3><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Can you give an example of how the mortgage insurance escrows get applied to the payment?</span></font></span></font></b> \r\n                          </font></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Your lender collects monies on escrow and remits to PMI when the premium is due. Typically, on an annual premium plan, the lender collects 14 months premium at closing. Twelve months of the premium is paid to PMI as the initial premium. The remaining two months is used to start the escrow account. The lender then collects 1/12 of the renewal every month thereafter. It is hard to give a general rule on a monthly premium plan. The plan was developed in 1994 and lenders have developed unique escrowing procedures. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Premise: Mortgage insurance covers the lender for the difference between the loan amount and 80% value of the property. So for a borrower who puts 10% down, in effect mortgage insurance covers the 10% difference. What are approximate rates in premium say per $1000 dollars? Does credit history have a bearing on the premium? Can the borrower negotiate the premium?</font></span></font></b> </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI actually covers the lender for a percentage they designate. The percent of coverage is usually driven by the investor''s (often, Fannie Mae or Freddie Mac) requirements. Therefore, the approximate premium per $1000 varies based on the required coverage. The premium is fixed based on plan type (loan to value, loan type, loan term, etc.) and not related to individual borrower characteristics. Therefore, the premium is not negotiable. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Are mortgage lenders supposed to provide borrowers with information on the conditions when they can cancel mortgage insurance? Are these conditions supposed to be in the loan documentation? If the borrower pays mortgage insurance monthly, and his equity goes up, should his premiums go down? Is the mortgage lender supposed to notify the borrower when he reaches 20% equity? Which states have laws on this subject? Can the borrower choose the mortgage insurance company or does the lender do that?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Because of the wide variation in lender, investor and state requirements, it is necessary to consult your lender on these questions. Keep in mind when considering mortgage insurance issues that the lender is the insured, not the borrower. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="3" class="headers">Would mortgage insurance be of use to lenders to help approve loans for higher risk (i.e. self employed) individuals?</span></font></b> \r\n                          </font></span></font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI does insure loans made by lenders to self employed borrowers. However, it is unlikely that our coverage would have any effect on the lender''s ability to offer such loans. Generally, mortgage insurance is required due to low down payment and associated risk and not related to borrower credit characteristics or history. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Does mortgage insurance apply for investor properties?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">PMI only insures loans on owner occupied residential properties (1 to 4 units).</font></span></p>\r\n                        <h3><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">What is private mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage insurance is a type of insurance that helps protect lenders against losses due to foreclosure. This protection is provided by private mortgage insurance companies, such as PMI Mortgage Insurance Co., and allows lenders to accept lower down payments than would normally be allowed. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Mortgage insurance also enables lenders to grant loans that would otherwise be considered too risky to be purchased by third party investors like the Federal National Mortgage Association (FNMA) and the Federal Home Loan Mortgage Corporation (FHLMC). The ability to sell loans to these investors is critical to maintaining mortgage market liquidity, which in turn, allows lenders to continue originating new loans. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Is private mortgage insurance different from other kinds of insurance associated with mortgages?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance protects the lender in the event of borrower default and subsequent foreclosure on the home. FHA and VA insurance also protect the lender against borrower default under a government program rather than through the private enterprise system.</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Credit insurance, sometimes called mortgage insurance, is life insurance coverage that pays off the mortgage in the event a borrower dies, becomes disabled, or incurs loss of health or income. Fire, liability, and theft insurance cover the homeowner from losses according to the terms and conditions of their respective insurance policies. \r\n                          </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headln"><span class="headers">How small can my down payment be?</span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Private mortgage insurance makes it possible for a homebuyer to obtain a mortgage with a down payment as low as 5% and for low-to-moderate income homebuyers as low as 3%. Such mortgages are popular today because potential homebuyers are not able to accumulate the 20% down payment that is generally required by lenders if a loan is not insured. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">Who pays for mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The lender does, although they will generally pass that cost on to the borrower. Typically, a portion of the mortgage insurance premium is paid up front at closing, and the rest is paid as part of the monthly mortgage payment. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">What are the payment options for mortgage insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance can be paid on either an annual, monthly or single premium plan. Premiums are based on the amount and terms of the mortgage and will vary according to loan-to- value ratio, type of loan, and amount of coverage required by the lender. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Under an <i>annual plan</i>, an initial one year premium is collected up front at closing, with monthly payments collected along with the mortgage payment each month thereafter. <i>Monthly plans</i> allow a borrower to pay the lender only 1 or 2 months worth of premium at closing, and then on a monthly basis along with the regular mortgage payment. Under a <i>single premium plan</i>, the entire premium covering several years is paid in a lump sum at closing. Typically, homebuyers choose to add the amount of the lender''s mortgage insurance premium to the loan amount. By doing this, homebuyers can reduce their closing costs and increase their interest deduction. PMI Mortgage Insurance Co. offers a single premium plan called Super Single. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Below are examples of how a variety of PMI Mortgage Insurance Co. premium plans could effect your mortgage payments: \r\n                          </span></font></span></p>\r\n                        <table border="0" width="75%" cellspacing="0" cellpadding="2">\r\n                          <tr> \r\n                            <td class="headers">&nbsp;</td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Annual Plan</font></td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Monthly Premium</font></td>\r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Super Single (Financed)</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext">Loan Amount(*)</span></font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Cash for MI at closing</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$750</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$56</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Financed Premium</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$3,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Total Mortgage Amountv</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$150,000</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">Monthly P&I (**)</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,317</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">MI Renewal</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$43</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$56</font></td>\r\n                            <td class="bodytext" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$0</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext" height="6">&nbsp;</td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">P&I plus monthly</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,360</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,373</font></td>\r\n                            <td class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">$1,343</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="tableheader">&nbsp;</td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">(*)Loan amount of $150,000; 10% down payment; 30 year fixed rate loan at 10% interest.</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td colspan="4" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" class="bodytext">(**)P&I stands for monthly Principal and Interest on the mortgage.</font></td>\r\n                          </tr>\r\n                        </table>\r\n                        <pre>&nbsp;              </pre>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers"><span class="headers">Can mortgage insurance coverage be cancelled?</span></font></span></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage insurance is maintained at the option of the current owner of the mortgage. In many cases, the lender will allow cancellation of mortgage insurance when the loan is paid down to 80% of the original property value. However, the degree of equity in the home is not the only factor that a lender may take into consideration. Note that the law in certain states requires that mortgage insurance be cancelled under some circumstances. </font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font color="#BD827B" size="4"><span class="headers">How does private mortgage insurance differ from FHA insurance?</span></font></span></font></b> \r\n                          </font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although the insurance protection concept is similar, there are differences between private mortgage insurance and FHA. FHA insurance is a government-administered mortgage insurance program that does have certain restrictions. FHA has maximum regional loan limits that are lower than those with private mortgage insurance. FHA may be more expensive, takes longer to receive approval, and has fewer payment plan options. FHA insurance lasts for the life of the loan, unlike private mortgage insurance which is cancelable in most circumstances. FHA is a good choice for some borrowers with credit history problems that might need special assistance.</font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (161, 56, 2, 'How to Shop For A Mortgage', '                          With dozens of competing lenders and mortgages to choose from, you may think that today''s home loan market is terribly confusing. It really isn''t though if you know the basic facts about financing a house. That''s what this brochure is designed to give you. Let''s start with the questions that are probably uppermost in your mind.</font></span></p>\r\n                        <h3 class="headers"><font face="Verdana, Arial, Helvetica, sans-serif" size="4" color="#BD827B" class="headers"><b>How Large a Mortgage Can I get? </b></font></h3>\r\n                        <p class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">That depends upon your income and the cost of your new house. Lenders use certain guidelines to determine the mortgage amount that they will lend any one homebuyer. The two guidelines used are housing expenses and long term debt. Lenders generally say that housing expenses (including mortgage payments, insurance, taxes and special assessments) should not exceed 25 percent to 28 percent of the homeowner''s gross monthly income. For <b>Federal Housing Administration (FHA)</b> loans, this figure is not t o exceed 29 percent of the homebuyer''s gross monthly income. With loan guaranteed by the <b>Department of Veteran''s Affairs (VA)</b>, lenders measure prospective homebuyers with &quot;Residual Income,&quot; or the monthly income minus expenses. The remainder is then measured against geographical and family size data to qualify the borrower</span>.</font></span></font></span></p>\r\n                        <ul>\r\n                          <li> \r\n                            <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers">\r\n                            FHA Loa</span></span></font></span></span></strong><span class="headers"><span class="headers"><font size="4"><span class="headers"><span class="headers"><strong>n</strong></span><span class="bodytext"><span class="bodytext"><span class="headers"><strong>s</strong></span></span></span></span></font></span></span><strong><br>\r\n                              </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing expenses = 29% of gross monthly income </span><br>\r\n                              <span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income</span></font></span></span></font></span></p>\r\n                          </li>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><font size="4" class="headers">\r\n                          VA Loans</font><br>\r\n                            </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing Expenses Plus Long-Term Debt = 41% of gross monthly income<br>Residual Income = Varies by location and family size \r\n                            </span></font><span class="bodytext"><br>\r\n                            </span></span><br>\r\n                            </span> </font></span></li>\r\n                          <li> \r\n                            <p><span class="headers"><span class="headers"><font size="4"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong class="headers">\r\n                            Conventional Loans</strong></span></font></span></font></span></span><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><strong><br>\r\n                              </strong></span><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">Housing Expenses = 25% - 28% of gross monthly income </span><br>\r\n                              <span class="bodytext">Housing Expenses Plus Long-Term Debt = 33% - 36% of gross monthly income  </span></font></span></span></font></span></p>\r\n                          </li>\r\n                        </ul>\r\n                        <p class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Lenders usually define long-term debt as monthly expenses extending more than 10 months into the future. These expenses should not exceed 33 percent to 36 percent of the homeowner''s gross monthly income. VA and FHA mortgage lenders define long- term debt as monthly income. Your lender will work out these figures for you when you sit down to discuss the mortgage you want.</font></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b class="headers">What Types Of Loans Are Available</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Although you may see many different types advertised, they all belong to just two families: those mortgages that carry fixed interest rates, and those whose rates change during the course of the loan on a periodic schedule mutually agreed upon by you and your lender. This page does, however, discuss some new loans who are really "cousins" to each family-convertible mortgages.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Fixed Rate Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">You are probably familiar with a fixed-rate mortgage. Your parents more than likely had one, as did their patent before them. The major advantage of fixed rate mortgages is that they present predictable housing costs for the life of the loan. Some fixed-rate mortgages you will probably hear about are:</font></span></font></span></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">30-year fixed-rate mortgages </span></span></font></span></span></font></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">15-year fixed-rate mortgages </span></font></span></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Bi-weekly mortgages </span></font></span></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">"Convertible" mortgages </span></font></span></span></font></span></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><span class="bodytext">When people thought of a mortgage 10 to 50 years ago, they thought of a 30-year fixed-rate mortgage. This traditional favorite is not the only choice nowadays because volatile financial times created a whole new range of selections. However, the 30-year fixed-rate mortgage may still be the best mortgage for your circumstances. It offers the lowest monthly payments of fixed-rate loans, while providing for a never- changing monthly payment schedule. Some lenders offers 25,20, and even 40-year term mortgages as well. But remember, the longer the term of the loan, the more total interest you will pay. </span></span></span></font></span></span></font></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The 15-year fixed-rate mortgage allows homeowners to own their homes free and clear in half the time and for less than half the total interest costs of the traditional 30-year loan. The loan''s term is shortened by the 10 percent to 15 percent higher monthly payments. Some homebuyers prefer this mortgage because it allows them to own their home before their children start college. Others prefer it because they will own their home free and clear before retirement and probable declines in income. </span></font></span></span></font></span></span></p>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The major disadvantages or the 15-year fixed-rate mortgage are the sometimes higher monthly payments. But if saving on total interest costs and cutting the to free and clear ownership are important to you, the 15-year fixed-rate mortgage is a good option. The bi-weekly mortgage shortens the loan term to 18 to 19 years by requiring a payment for half the monthly amount every two weeks. The bi-weekly payments increase the annual amount paid by about 8 percent and in effect pay 13 monthly payments(26 bi-weekly payments) per year. The shortened loan term decreases the total interest costs substantially. The interest costs for the bi-weekly mortgage are decreased even further, however, by the application of each payment to the principal upon which the interest is calculated every 14 days. By nibbling away at the principal faster, the homeowner saves additional interest. Remember, however, that you trade lower total interest costs for fewer mortgage interest deductions on your federal income tax. Your ability to qualify for this type of loan is based on a 30-year term, and most lenders who offer this mortgage will allow the homebuyer to convert to a more traditional 30-year loan without penalty. Availability is limited on this mortgage, but it can be worth looking for.</span></font></span></span></font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Mortgages That Change</b></font></span></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">Some newer mortgages afford homebuyers some the best qualities of the fixed-rate and adjustable rate mortgages. One new type of loan, often called a <b>Two-Step, Super Seven</b>, or <b>Premier Mortgage</b>, gives homeowners the predictability of a fixed- rate and adjustable rate mortgage for a certain time, most often seven or 10 years, and then the interest rate is adjusted to fit market conditions at that time. The main advantage associated with this type of loan is that homebuyers often get a slightly lower than market rate to begin with. The main disadvantage is that they may see their interest rate go up by as much as six percentage points at the end of the seven-year period. The lender may also reserve the option to call the loan due with 30 days notice at that time, making this loan similar to a balloon mortgage in some cases. </font></span></span></font></span></span></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Lenders offer this type of loan in part because research indicates that many homebuyers remain in the home for seven to 10 years before moving. For this type of homebuyer, the Two-Step or Super Seven loan present an excellent way of getting a fixed- rate loan at a better than market price for a fixed-rate loan at a better than market price for a fixed period of time. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Another type of mortgage that is becoming popular is called a <b>Lender Buydown</b>, where the homebuyer gets an initially discounted rate and gradually increases to an agreed-upon fixed rate over a matter of three years. For example: When the market rate is 10 percent, the fixed rate for the mortgage is set at about 10.5 percent, but the homebuyer makes monthly payments based on a first year rate of 8.5 percent. The second year the rate goes up to 9.5 percent, and for the third year through the remaining life of the loan, the rate is calculated at 10.5 percent. A second type of lender buy-down, called a <b>Compressed Buydown</b>, works the same way, but with the interest rate changing every six months instead of on a yearly basis. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">The Lender Buydown gives consumers the advantage of lower initial monthly payments for the first two years of the loan when extra money may be needed for furnishings and, secondly, the advantage of knowing that, although the interest rate does change during the first three years of the loan, the interest is fixed from the third year on. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Convertible mortgages offer today''s homebuyer the option to change the loan''s interest rate after some period of time or some specified movement in interest rates. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Convertible fixed-rate mortgages are often referred to as the <b>Reduction Option Loan (ROLE)</b> or, in some locations, the <b>Reducing Interest Loan (RIL), or Mortgage (RIM)</b>. This new type of loan offers homeowners the option of getting a loan that , under the right conditions, can be adjusted to a lower interest rate with a payment of $100 or $200 or so and a small loan amount-based fee, sometimes as little as one-fourth of a percentage point. These conditions usually are a prescribed movement in rates-typically two percent below the initial- during a set time limit-between months 13 and 59, for example. </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">On a 30-year fixed-rate mortgage with a reduction option, the homebuyer pays an extra one-fourth to three-eighths of a percentage point in the interest rate on the mortgage plus a quarter to three-eighths of 1 percent of the loan amount (points) at the time of closing. This allows the homeowners to adjust the interest rate on the loan without having to go through a refinancing, which could cost up to 5 percent or 6 percent of the loan amount, if the rates are right during the prescribed time limit. \r\n                          </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">On an $80,000 loan, this means that you could reduce the interest rate on your loan from, say, 10.5 percent to 8.5 percent, and take advantage of the low rates for the rest of the loan term for $150 instead of up to $4,800 , if the rates dropped to that point during your "window of opportunity" - months 13 through 59. Some homeowners may find the ROL a good "insurance policy" against the high costs of refinancing. Others may want the flexibility that refinancing offers - namely the ability to draw on built-up equity- that is not available with ROLs. The decision is up to you. \r\n                          </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><b>Convertible Adjustable Rate Mortgages (ARMs)</b> are another new loan product on today''s market. It worked like any other ARM, but it offers homeowners a distinct advantage-it allows them to turn their ARM into a fixed-rate mortgage after a set period (usually during the second through fifth years of the loan). </span></span></font></span></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">A new product developed by the <b>Federal National Mortgage Association (Fannie Mae)</b>, which buys mortgages from lenders, allows the homeowner to convert an ARM to either a 15 or 30 year fixed-rate mortgage for a fee of 1 percent of the original loan plus $250 , as compared to the 3 percent to 6 percent costs of refinancing. Say, for instance, that you got your convertible ARM at an initial interest rate of 10.0 percent, and after a year or so, rates had dropped to 8.0 percent. For the smaller conversion fee, you could adjust your mortgage to either a 15 or 30 year fixed-rate loan at a new rate that would be about one-half percent higher than the going market rate, or 8.5 percent. There are other variations on this loan available from lenders across the country. Homebuyers who want the low initial rate of an ARM, and the option and peace of mind of a fixed mortgage should rates drop, can now have it both ways.</span></span></font></span></span></font></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Adjustable Rate Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Adjustable Rate Mortgages (ARMs) have become on of the most popular and effective tools for helping some prospective homebuyers achieve their dream of homeownership. Developed during a time of high interest rates that kept many people out of the housing market, the ARM offers lower initial rates by sharing the future risk of higher rates between borrower and lender. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">ARMs can be an excellent choice of financing under certain conditions, such as rising income expectations, high interest rates, and short-term homeownership. But because payments and interest rates can increase, either steadily or irregularly, homebuyers considering this kind of mortgage need to have the income to keep up with all possible rate and/or payment changes. Each ARM has four basic components: </span></font></span></span></font></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Initial interest rate</b>, which is typically one to three percentage points lower than that of most fixed-rate mortgages. Lower interest rates also make ARMs somewhat easier to qualify for. The initial interest rate is tied to certain economic indicators that dictate in part what the monthly payments will be.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustment interval</b>, at the time between changes in the interest rate and/or monthly payment will be.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Index</b>, against which lenders measure the difference between what they are making on their investment in the mortgage and what they could be making on other types of investments. The most popular index is based on the rate of return on a one- year Treasury bill (also called T-bill).</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Margin</b>, or the additional amount the lender adds to the index to establish the adjusted interest rate on an ARM. The margin is usually 1.5 percent to 2.5 percent. \r\n                            </span></font></span></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In addition to the four basic components, an ARM usually contains certain consumer safeguards such as interest rate caps, which limit the amount that the interest rate applied to the payments may move. This prevents the amount of interest the consumer pays from rising higher than perhaps the homeowner can afford. For instance, a typical ARM would have a two percentage point cap over the life of the loan. That means that a loan with an initial interest rate of 9.75 percent would be able to go no higher than 14.75 percent over the life of the loan, and it would be able to move no more than two percentage points per year. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Another safeguard found on some ARMs are monthly payment caps that limit the amount homeowners need to increase their payments at adjustment time. Monthly payment caps can, however, sometimes prevent the monthly payments from increasing enough to keep up with the rise in the interest rate, causing negative amortization-resulting in higher or more payments for the homeowner later on. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Other options you should ask about when shopping for an ARM are:</span></font></span></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Assumability</b>, or whether you may transfer the mortgage to a new homebuyer, usually with the same terms if the new homebuyer qualifies for the loan. ARMs are almost always assumable.</span></font></span></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Convertibility</b> allows the borrower to change an ARM to a fixed-rate mortgage, usually at the end of some predetermined period, locking in a lower interest rate.</span></font></span></span></font></li>\r\n                        </ul>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>An Option For Older Homeowners</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">A relative newcomer in the mortgage market is a <b>Reverse Annuity Mortgage (RAM).</b> For older Americans, especially retirees living on fixed incomes, the equity in their paid-for or almost-paid-for home represents a large but liquid asset. The RAM i s designed to help supplement those homeowners'' income. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The lender who will issue a RAM appraises the property and makes the loan based on a percentage of its current value. The homeowner retains ownership, and the property secures the loan. The lender then pays an annuity to the borrower, usually on a monthly basis, up to an amount equal to the equity they have in the home. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of such a loan for older Americans is that of receiving a monthly tax-free income. Under one plan, this income is available for life or until the house is sold at the homeowner moves. The schedule of payments depends on the value of the home and the ages of the owners. There are risks involved, however. If the homeowner wants to move and buy a new house, there may not be enough equity in the home to permit such a plan. Or the lender may consider only the current market value of the home rather than any future appreciation when deciding on the monthly payments.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>FHA/VA Mortgages</b></font></span></span></h3>\r\n                        <p class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The Federal Housing Administration (FHA) and the Veterans Administration (VA) offer a wide range of mortgage choices that may appeal to you. These include 30 and 15 year fixed- rate mortgages, as well as ARMs. Insured by these government agencies, the loans feature low or no down payment terms and are often assumable by future purchasers. VA loans are restricted to individuals qualified by military service or other entitlements, but FHA - insured loans are open to all qualified home purchasers. Note that there are limits to handle moderate-priced homes anywhere in the country. Talk to your lender about FHA/VA possibilities.</font></span></span></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Creative Financing or Seller-Assisted Mortgages</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">This type of financing became popular when interest rates went to very high levels in the early 1980s. Seller-assisted creative financing usually means the seller of the home helps with the financing by underwriting all or part of the loan. </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The advantage of this type of arrangement is that the mortgage usually carries a lower interest rate with lower monthly payments. The disadvantage is that the previous homeowner, not an institution, may hold the deed of trust. If the loan terms call for certain payment schedules, the buyer may have to seek new financing. Many homebuyers in recent years have found "creative financing" deals to be fraught with problems and useful only as short-term alternatives to mortgages from traditional lenders. \r\n                          </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One type of mortgage you are apt to run into with seller financing is the balloon payment mortgage. <b>Balloons</b>, as they are known, are usually offered as short-term fixed-rate loans. The balloon payment mortgage gets its name from the payment schedule, which involves smaller payments for a certain period of time and one large payment for the entire amount of the outstanding principal. They have terms of 3, 5, and sometimes 15 years, though payments are usually calculated as though it were a 30 year loan. Sometimes a balloon will be offered as a second mortgage where you also assume the homeowner''s first mortgage . The major disadvantage with a balloon payment loan is that it may be difficult to save up the money to make the final large payment (often the entire amount of the principal) while paying interest on the loan. Some lenders guarantee refinancing, though the interest rate is usually adjusted when the principal comes due. If you cannot refinance, you may have to the property if you cannot meet the large payment. Balloons are an advantage if you plan on living in an appreciating house for a short period of time and want to pay less while you live there.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Do You Shop Most Effectively For A Mortgage?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">There are several ways. First, talk with your real estate agent or broker. Real estate professionals are normally in the best position to learn about financing opportunities in the marketplace. Lenders regularly call agents to alert them to financing packages. And, of course, agents are highly motivated to obtain financing for their buyers. Without a suitable loan, the sale can''t proceed, and agents won''t get their sales commission on the house. \r\n                          </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Second, look for rate surveys published by your local newspaper. Many American papers now include brief tables on interest rates and mortgage availability in their real estate or business section. They can help guide you to sources you have not thought about. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Third, look in the Yellow Pages under "Mortgages," and shop for quotes by telephone. Call five to 10 different lenders for rates and terms on fixed and adjustable loans. </span></font></span></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Finally, if your area is covered by one of the many commercial <b>computerized mortgage shopping services</b>, give it a try. You may find, however, that the computer services have only a selection of local lenders on their listings.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>How Do We Evaluate Different Loans?</b></font></span></span></h3>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">One important method is by bearing in mind that mortgage packages consist of more than interest rates. They consist of a quoted rate, plus discount points (pre-paid interest assessed by the lender at settlement, or the meeting when the property legally changes hands) and other fees, plus a full range of terms including adjustable versus fixed-rates, low down payment versus high down payment, the presence or absence of prepayment penalties, and many other features noted earlier in this brochure. \r\n                          </font></span></font></span></span></p>\r\n                        <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">One way to evaluate rates, however, is by examining the <b>Annual Percentage Rate (APR)</b>. The APR can help you compare different types of mortgages. It indicates the &quot;effective rate of interest&quot; paid per year. The figure includes discount points and other charges and spreads them out over the life of the loan. While the APR provides you with a common point for comparison, look at the whole product before deciding which mortgage to get. Pick the one with the rate, payment schedule and other terms t hat suit your situation best.</span></font></span></span></font></p>\r\n                        <h3 class="headers"><span class="bodytext"><span class="bodytext"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Terms You Should Know</b></font></span></span></h3>\r\n                        <blockquote> \r\n                          <dl> \r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Acceleration Clause</font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">If you miss a monthly payment, an acceleration clause allows the lender to speed up the rate at which your loan comes due or even to demand immediate payment of the entire outstanding balance of the loan.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Assumability</span></font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Assuming a mortgage is simply taking the loan over from the holder (seller) and becoming liable for the repayment.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Buydown</font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">The buydown mortgage is one where the seller and/or the home builder subsidizes the mortgage by lowering the interest rate during the first few years of the loan. While the lower initial payment and interest rate make this kind of loan easier to qualify, the payments may increase when the subsidy expires.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Closing Costs/Settlement Costs/Escrow</span></font></b> \r\n                              </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Closing costs ate the costs associated with settlement, the meeting where the buyer and seller (or their agents) sit down to fill out the papers and make the exchanges that allow the property to legally change hands. Closing costs include appraisal fees, title search and insurance, survey, tax adjustments, deed recording fees, credit report and points, among others.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Due-on Sale Clause</span></font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">A clause or provision in a mortgage or deed of trust that allows the lender to demand immediate payment of the balance of the mortgage at the time of sale.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4"><span class="headers">Negative Amortization</span></font></b> </font></span></span></dt>\r\n                            <dd class="bodytext"><span class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">This occurs when your monthly payments are not large enough to pay all the interest due on the loan. This unpaid interest is added to unpaid balance of the loan. The danger of negative amortization is that the homebuyer could end up owing more than the original amount of the loan.</font></span></span></dd>\r\n                            <dt><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><b class="headers"><font size="4" class="headers">Private Mortgage Insurance</font></b> </font></span></span></dt>\r\n                            <dd><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">In the event that you do not have a 20 percent down payment, lenders will allow a smaller down payment-as low as 5 percent in some cases. With the smaller down payment loans, however, borrowers are usually required to carry private mortgage insurance. </font></span> \r\n                              </font> </span> </span> \r\n                              <p><font size="2"><span class="bodytext"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Private mortgage insurance will require additional premium payment of 0.5 percent to 1.0 percent of your mortgage amount plus an additional monthly fee depending on your loan''s structure. On a $75,000 house with a 10 percent down payment, this would mean an initial premium payment of $338 to $675 and an extra $15 to $20 a month. </span></font></span></span></font></p>\r\n                            </dd>\r\n                          </dl>\r\n                        </blockquote>\r\n                        <p> \r\n                        <table class="bodytext" cellspacing="1" cellpadding="4" bgcolor="#FFFFFF" bordercolor="#CCCCCC" border="0" width="100%">\r\n                          <center>\r\n                            <tr bgcolor="#FFCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"> \r\n                                <font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Comparison on a</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top">30 CCC Year</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top">15-Year</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top">Bi-Weekly</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top">ARM</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFCCCC" > \r\n                              <td width="27%" height="12" align="left" valign="top" class="bodytext">$75,000 Mortgage</font></td>\r\n                              <td align=left width="16%" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                              <td align=left width="18%" height="12" class="bodytext" valign="top">Fixed-Rate</font></td>\r\n                              <td align=left width="20%" height="12" class="bodytext" valign="top">Mortgage</font></td>\r\n                              <td align=left width="19%" height="12" class="bodytext" valign="top">at 7.5%</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td width="27%" align="left" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="16%" class="bodytext" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">at 10%</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">w/5% cap*</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">First Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$806</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$658(329 X 2)</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$524</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,481</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,398</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,434</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$5,602</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,336</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,606</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$7,061</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$6,188</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Mortgage Balance</font></td>\r\n                              <td class="bodytext" width="16%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="18%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="20%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td class="bodytext" width="19%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,583</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,726</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,476</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$74,309</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left class="bodytext" width="27%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Fourth Year</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$73,052</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$64,372</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$69,817</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$72,400</font></td>\r\n                            </tr>\r\n                            <tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td class="bodytext" width="27%" align="left" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Interest Cost/Life</font></td>\r\n                              <td align=left class="bodytext" width="16%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$161,942</font></td>\r\n                              <td align=left class="bodytext" width="18%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$70,062</font></td>\r\n                              <td align=left class="bodytext" width="20%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$104,331</font></td>\r\n                              <td align=left class="bodytext" width="19%" valign="top"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">$132,566</font></td>\r\n                            </tr>\r\n                            <tr class="tableheader" bgcolor="#FFFFFF" bordercolor="#CCCCCC"> \r\n                              <td align=left width="102" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Difference from 30 Year Fixed Rate</font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext"></font></td>\r\n                              <td align=left width="18%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $91,880</font></td>\r\n                              <td align=left width="20%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $57,611</font></td>\r\n                              <td align=left width="19%" valign="top" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">- $29,376</font></td>\r\n                            </tr>\r\n                          </center>\r\n                        </table>\r\n                        <div align="left" class="bodytext"> \r\n                          <blockquote><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2" class="bodytext">* The interest on the ARM used in this example increased 2 percent in the second year (payment = $629), and decreased 1 percent in the third year (payment = $577 for Years 3 through 30). This is a hypothetical situation. Not all ARMs will behave in this manner; some will increase (or decrease) more slowly, some more rapidly. In each case, the monthly payments, interest costs, and the amount you save will differ. For more information about tailoring an ARM to fit your particular circumstances, talk to your lender. </font></span></span></font></span></span></blockquote>\r\n<p><a class="mainlink" href="tools.php" class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Back to Tools</font></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (162, 57, 2, 'Veterans Administration Loan Program', '<ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#intro">Introduction</span></font></a></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#beprepared">Be Prepared For Homeownership</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#planunexpected">Planning For The Unexpected</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#deliquent">If Your Mortgage Becomes Delinquent</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#default">What To Do When You Default On Your Mortgage</a></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><a class="mainlink" href="#workout">Mortgage Loan Workout Plans</a></span></font></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="intro" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Introduction</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif" class="bodytext">Acquiring your first home, or a larger one to meet growing family needs, usually focuses all of your attention on accumulating the down payment and qualifying for the financing on the property you have selected. There is a sense of relief when the loan is finally closed and you have settled in the house. It will not take long, however, before you will have to face the financial responsibilities that home ownership imposes. </font></span></p>\r\n                        <p><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font size="2"><span class="bodytext">If you are a first-time home buyer, many of the problems that you simply turned over to the landlord (or your parents) are now yours to fix and pay for. If you have moved from a small house into a larger one, you may find the expenses of maintaining the property have grown along with its size. In either case, careful planning and budgeting are essential in order to guard against financial problems in the future. </span></font></span></span></font></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your home is a major investment and you have a great deal to lose if you default on your mortgage payments or fail to maintain the property. Planning for unexpected situations as well as the routine costs of owning a home can help you avoid foreclosure o r bankruptcy when emergencies arise.</span></font></span></font></span></p>\r\n                        <h3><a class="mainlink" name="beprepared" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Be Prepared For Homeownership</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The expenses of owning a home go beyond the monthly mortgage and utility payments, and can create financial difficulties, particularly for first-time home buyers who have minimal cash reserves. Mechanical failures in the plumbing, electrical and heating systems seem to occur at the worst possible times, but have to be repaired. If you have purchased an older home, complete replacement of water heaters, furnaces or kitchen appliances may be needed. You should have drawn up a budget before beginning your search for a home, making allowances for such expenditures. If you did not, it is time that you begin to accumulate adequate reserves to deal with such emergencies. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In a newer property, your immediate expenses may be confined to landscaping, interior decoration and furnishings. Under normal conditions, mechanical items and appliances will be under warranty for six months to a year and will not require major expenditures, but may need minor repairs. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In an older property, replacement of major items can be very expensive. You should have determined the age of the furnace, hot water heater, air conditioning system, kitchen appliances and the roof. Your home inspector''s report probably noted the ages o f these major items. If they are older then half their expected useful life, you will need to plan for the costs of the replacement. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Set up a budget and plan for both regular maintenance and major repairs. Establish an emergency fund for repairs and appliance replacement. Know what sources of financing are open to you when a major item such as the roof or heating system has to be rep laced. These are things that can cost thousands of dollars and you may have to finance them through a home equity loan, a second mortgage or an installment loan. Determine which kind of loan you are likely to qualify for, the pros and cons of the alternatives and have a plan for dealing with a major expense. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Your budget should also include a reserve for making your mortgage payments in the event of illness or loss of income in the future.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="planunexpected" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><span class="headers"><span class="headers"><span class="headers"><span class="headers"><b>Planning For The Unexpected</b></span></span></span></span></span></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">While over-obligating yourself or unexpected repair bills may jeopardize your ability to keep up your house payments, the primary causes of foreclosure and bankruptcy are unanticipated personal crisis. More homeowners lose their homes because of illness, loss of employment or marital problems than all other reasons combined. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">None of us factor these things into our plans for the future, but you should know about some of your alternatives if you find yourself in such a position. It is much easier to look at alternatives and plan an effective course of action before you are in t rouble and in a state of anxiety and stress. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Sometimes you can see the trouble coming before financial problems begin. An advance notice of a layoff means the family income will be severely cut back or eliminated in the near future. A major medical operation or property repair bill may be more than you can afford to repay, even with a short term loan. You have to address the situation as soon as possible or risk losing your home. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There can be a number of local sources that can help you get over the hump. Churches and civic groups may have assistance programs or may know what is available. Non-profit organizations, particularly housing assistance groups or counseling agencies, ma y manage special assistance programs. State and local housing agencies are also places to inquire to help.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="deliquent" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>If Your Mortgage Becomes Delinquent</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The day of the month on which your mortgage payment is due, usually the first day of the month, is set out in the mortgage note. Your payment is considered late of the lender receives it after the due date, and the lender usually will charge a late payment fee when the money is not received within 15 days of the due date (the timing and amount of late charges may vary from lender to lender). Payments made, including any late charges assessed, before the next payment due date will be accepted by the lender, but if you owe two or more mortgage payments, your home is in serious jeopardy. Unless specific arrangements are made with your lender, you must remit all payments and late charges before the money will be accepted and the loan considered current. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">When three or more mortgage loan payments are due and unpaid, the loan may be given to the lender''s attorney and foreclosure proceedings initiated. The entire balance of the loan may be due and payable immediately. In addition to the loan payments due, you are liable for legal fees incurred by the lender. At this point, you are in serious danger of losing your home.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="default" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What To Do When You Default On Your Mortgage</b></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">No lender wants to foreclose on a mortgage. Foreclosure costs them more money than they can make back from the foreclosure sale. Therefore, lenders do not foreclose in order to make money, but only reluctantly as a way of limiting losses on a defaulted loan. This is why, if you get behind on your mortgage payments, your lender will work with you to devise a practical plan to cure the default and bring the loan current. In order to do so, however, you must stay in communication with your lender and be honest in evaluating your financial situation. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The willingness of the lender to work with you to get past your current problems will depend heavily on your past payment record. If it shows consistently timely payments and no serious defaults, you will find the lender much more receptive than if you have a record of unexplained chronic late payments. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you are falling behind in your payments, or know that you are likely to in the immediate future, there are some steps that you should take before talking with the lender about alternative payment arrangements. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">First, you need to prepare a monthly list of your income and expenses, using realistic figures based on your current financial situation. You will also need to put together a complete financial disclosure package, showing your assets and liabilities, including all debts and monthly payments and when they are due. Pay stubs, unemployment check stubs or other proof of current income should be in the package, along with two years'' tax returns. Get an estimate of the value of your property. You can usually get a local real estate broker to give you an idea of the current market value, free of charge. Finally, prepare a written explanation of your situation for the lender and offer any plan or suggestion you may have on how you can bring the loan current.</span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="workout" class="headers"><font color="#BD827B"><span class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b class="headers">Mortgage Loan Workout Plans</b></span></font></span></font></a></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bighead"><font size="2"><b><span class="bodytext">A loan workout plan is an agreement between you and your lender that sets out the steps to be taken to cure the delinquency and prevent loss of your home. It may be written or oral and will have specific deadlines which you must meet in order to avoid foreclosure. Therefore, it must be based on very realistic estimates of your ability to meet the plan schedule. </span></span></b></font> \r\n                          </span></font></span></p>\r\n                        <p><span class="bighead"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">The nature of the workout plan will depend upon the seriousness of the default, whether your financial problems are short-term or your payment ability has been impaired for the foreseeable future, your prospects for obtaining funds to cure the default and the current value of your property. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the default is caused by a very temporary condition and is likely to be cured within 30 to 60 days, the lender may consider granting you <b>temporary indulgence</b>. Some examples of cases where this approach would be considered are where the house ha s been sold but the sale has not settled or where an insurance settlement is pending. It is usually possible to determine a date certain for curing the default. The lender will want documented evidence, such as the sale contract, before granting indulgence. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you have suffered a temporary loss of income but can demonstrate that it has returned to previous levels, you may structure a <b>repayment plan</b> to bring the loan current. This type of workout arrangement requires your normal mortgage payments be made as scheduled, plus an additional amount that will cure the delinquency in no more than 12 to 24 months. In some cases the additional amount may be a lump sum due at a specific date in the future. Repayment plans are probably the most frequently used type of workout agreement. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In some circumstances, it may be impossible for you to make any payments at all for some period of time. If you have had a good record with the lender, a "forbearance plan" will allow you to suspend payments or make reduced payments for a specified length of time. The forbearance plan will be in writing, have a definite term and spell out the method of ending the delinquency. In most cases the length of the plan will not exceed 18 months and will stipulate commencement of foreclosure action if you default on the agreement. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Any workout agreement is a last-ditch effort by you and your lender to avoid foreclosure and keep you in your home. It is not a substitute for good budgeting and financial planning on your part and will probably not be available if your payment record has not been consistently good up to the present time. Lenders will work closely with good borrowers who are having a period of real emergency and hardship, but are not inclined to cooperate with those who demonstrate little financial discipline. \r\n                          </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bighead"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></font></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (163, 58, 2, 'Veterans Administration Loan Program', '<b>Why A VA Loan?</font></b></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The more you know about our home loan program, the more you will realize how little "red tape" there really is in getting a VA loan. These loans are often made without any downpayment at all, and frequently offer lower interest rates than ordinarily available with other kinds of loans. Aside from the veteran''s certificate of eligibility and the VA-assigned appraisal, the application process is not much different than any other type of mortgage loan. And if the lender is approved for automatic processing, as more and more lenders are now, a buyer''s loan can be processed and closed by the lender without waiting for VA''s approval of the credit application. </span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Additionally, if the lender is approved under VA''s Lender Appraisal Processing Program (LAPP), the lender may review the appraisal completed by a VA-assigned appraiser and close the loan on the basis of that review. The LAPP process can further speed the time to loan closing.</span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>VA Pamphlet 26-91-1<br>August 1993<br>VA Home Loans</b></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><b><span class="bodytext">For more information</span></b><span class="bodytext">:</span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The Veteran''s Administration Oakland office has a listing of VA-owned properties in Northern California and Northern Nevada. </span></font></span></p>\r\n                        <p class="bodytext"><span class="bodytext"><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font class="bodytext">Back to Tools</font></a></font></span></p>\r\n                        <p class="headers">&nbsp;</p>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (164, 59, 2, 'A Consumer''s Guide To Refinancing Your Mortgage', '                          If you are a homeowner who was lucky enough to buy when mortgage rates were low, you may have no interest in refinancing your present loan. But perhaps you bought your home when rates were higher. Or perhaps you have an adjustable rate loan and would like to obtain different terms. </font></span></font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">Should you refinance? This brochure will answer some questions that may help you decide. If you do refinance, the process will remind you of what you went through in obtaining the original mortgage. That''s because, in reality, refinancing a mortgage is simply taking out a new mortgage. You will encounter many of the same procedures-and the same types of costs-the second time around.</span></span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Would Refinancing Be Worth It?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Refinancing can be worth while, but it does not make good financial sense for everyone. A general rule is that refinancing becomes worth your while if the current interest rate on your mortgage is at least two percentage points higher than the prevailing market rate. this figure is generally accepted as the safe margin when balancing the costs of refinancing a mortgage against the savings. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">There are other considerations, too, such as how long you plan to stay in the house. Most sources say that it takes at least three years to realize fully the savings from a lower interest rate, given the costs of the refinancing. (Depending on your loan amount and the particular circumstances, however, you might choose to refinance a loan that is only 1.5 percentage points higher then the current rate. You may even find you could recoup the refinancing costs in a shorter time.) </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Refinancing can be a good idea for homeowners who:</span></font></span></font></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to get out of a high interest rate loan to take advantage of lower rates. This is a good idea only if you intend to stay in the house long enough to make the additional fees worthwhile.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Have an adjustable rate mortgage (ARM) and want a fixed-rate loan to have the certainty of knowing exactly what the mortgage payment will be for the life of the loan.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to convert to an ARM with a lower interest rate or more protective features (such as a better rate and payment caps) than the ARM they currently have.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to build up equity more quickly by converting to a loan with a shorter term.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Want to draw on the equity built up in their house to get cash for a major purchase or for their children''s education. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If you decide that a refinancing is not worth the costs, ask your lender whether you may be able to obtain all or some of the new terms you want by agreeing to a modification of your existing loan instead of a refinancing.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Should You Refinance Your ARM?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In deciding whether to refinance an ARM you should consider these questions:</font></span></font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Is the next interest rate adjustment on your existing loan likely to increase your monthly payments substantially? Will the new interest rate be two or three percentage points higher than the prevailing rates being offered for either fixed-rate loans or other ARMs?</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the current mortgage sets a cap on your monthly payments, are those payments large enough to pay off your loan by the end of the original term? Will refinancing a new ARM or a fixed-rate enable you to pay your loan in full by the end of the term?</span></font></span></font></li>\r\n                        </ul>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are The Costs of Refinancing?</b></font></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The fees described below are the charges that you most likely to encounter in a refinancing.</font></span></font></span></p>\r\n                        <ul>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Application Fees</b><br>\r\n                            This charge imposed by your lender covers the initial costs of processing you loan request and checking your credit report.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Search and Title Insurance</b><br>\r\n                            This charge will cover the cost of examining the public record to confirm ownership of the real estate. It also covers the cost of a policy, usually issued by a title insurance company, that insures the policy holder in a specific amount for any loss caused by discrepancies in the title to the property. Be sure to ask the company carrying the present policy if it can re-issue your policy at a re-issue rate. You could save up to 70 percent of what it would cost you for a new policy.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Lender''s Attorney''s Review Fees</b><br>\r\n                            The lender will usually charge you for fees paid to the lawyer or company that conducts the closing for the lender. Settlements are conducted by lending institutions, title insurance companies, escrow companies, real estate brokers, and attorneys for the buyer and seller. In most situations, the person conducting the settlement is providing a service to the lender. You may want to retain your own attorney to represent you at all stages of the transaction, including settlement.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Loan Origination Fees and Discount Points</b><br>\r\n                             The origination fee is charged for the lender''s work in evaluating and preparing your mortgage loan. Discount points are prepaid finance charges imposed by the lender at closing to increase the lender''s yield beyond the stated interest rate on the mortgage note. One point equals one percent of the loan amount. For example, one point on a $75,000 loan would be $750. In some cases, the points you pay can be financed by adding them to the loan amount. The total number of points a lender charges will depend on market conditions and the interest rate to be charged.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Appraisal Fee</b><br>\r\n                            This fee pays for an appraisal which is a supportable and defensible estimate or opinion of the value of the property.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Prepayment Penalty</b><br>\r\n                           A prepayment penalty on your present mortgage could be the greatest determent to refinancing. The practice of charging money for an early pay-off of the existing mortgage loan varies be state, type of lender, and type of loan. Prepayment penalties are forbidden on various loan including loan from federally chartered credit unions, FHA and VA loans, and some other home-purchase loans. The mortgage documents for your existing loan will state if there is a penalty for prepayment. In some loans, you may be charged interest for the full month in which your prepay your loan.</span></font></span></font></li>\r\n                          <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Miscellaneous</b><br>\r\n                            Depending on the type of loan you have and other factors, another major expense you might face is the fee for a VA loan guarantee, FHA mortgage insurance, or private mortgage insurance. There are a few other closing costs in addition to these. </span></font></span></font></li>\r\n                        </ul>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In conclusion, a homeowner should plan on paying an average of 3 to 6 percent of the outstanding principal in refinancing costs, plus any prepayment penalties and the costs of paying off any second mortgages that may exist. One way of saving on some of these costs is to check first with the lender who holds your current mortgage. The lender may be willing to waive some of them, especially if the work relating to the mortgage closing is still current. This could include the fees for the title search, surveys, inspections, and so on. </span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information contained in this brochure is intended to help you ask the right questions when considering refinancing your loan. It is not a replacement for professional advice. Talk with mortgage lenders, real estate agents, attorneys, and other advisors about lending practices, mortgage instruments, and your own interests before you commit to any specific loan.</span></font></span></font></p>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Refinancing Savings On A $100,000 Loan</b></font></h3>\r\n                        <table border="0" width="380" cellspacing="1" cellpadding="6">\r\n                          <tr valign="top"> \r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Your Present Mortgage Rate</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Current Monthly Payment</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Monthly Payment Savings at 8.0%</span></font></td>\r\n                            <td class="headln"><font class="maintext"><span class="tableheader">Monthly Annual Savings at 8.0%</span></font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">14.0%</font></td>\r\n                            <td ><font class="maintext">$1,185</font></td>\r\n                            <td ><font class="maintext">$451</font></td>\r\n                            <td ><font class="maintext">$5,412</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">13.5%</font></td>\r\n                            <td ><font class="maintext">$1,145</font></td>\r\n                            <td ><font class="maintext">$411</font></td>\r\n                            <td ><font class="maintext">$4,932</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">13.0%</font></td>\r\n                            <td ><font class="maintext">$1,106</font></td>\r\n                            <td ><font class="maintext">$372</font></td>\r\n                            <td ><font class="maintext">$4,464</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">12.5%</font></td>\r\n                            <td ><font class="maintext">12.5%</font></td>\r\n                            <td ><font class="maintext">$333</font></td>\r\n                            <td ><font class="maintext">$3,996</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">12.0%</font></td>\r\n                            <td ><font class="maintext">$1,029</font></td>\r\n                            <td ><font class="maintext">$295</font></td>\r\n                            <td ><font class="maintext">$3,540</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">11.5%</font></td>\r\n                            <td ><font class="maintext">$990</font></td>\r\n                            <td ><font class="maintext">$256</font></td>\r\n                            <td ><font class="maintext">$3,072</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">11.0%</font></td>\r\n                            <td ><font class="maintext">$952</font></td>\r\n                            <td ><font class="maintext">$218</font></td>\r\n                            <td ><font class="maintext">$2,616</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">10.5%</font></td>\r\n                            <td ><font class="maintext">$915</font></td>\r\n                            <td ><font class="maintext">$181</font></td>\r\n                            <td ><font class="maintext">$2,172</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">10.0%</font></td>\r\n                            <td ><font class="maintext">$878</font></td>\r\n                            <td ><font class="maintext">$144</font></td>\r\n                            <td ><font class="maintext">$1,728</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">9.5%</font></td>\r\n                            <td ><font class="maintext">$841</font></td>\r\n                            <td ><font class="maintext">$107</font></td>\r\n                            <td ><font class="maintext">$1,284</font></td>\r\n                          </tr>\r\n                          <tr> \r\n                            <td ><font class="maintext">9.0%</font></td>\r\n                            <td ><font class="maintext">$805</font></td>\r\n                            <td ><font class="maintext">$71</font></td>\r\n                            <td ><font class="maintext">$852</font></td>\r\n                          </tr>\r\n                        </table>\r\n                        <p><span class="bodytext"><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bighead"><span class="bodytext"><font size="2" class="bodytext">\r\n                         </font></span></span></font></span></span></p>\r\n                        <p><a class="mainlink" href="tools.php" class="bodytext">Back to Tools</font></a> \r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (165, 60, 2, 'Deducting Your Mortgage Interest Under the Tax Code', '                          One of the best justifications for owning a home, at least for financial reasons, is the tax savings that result from deducting mortgage interest. The deduction for mortgage interest stands as one of the few remaining tax deductions for the typical middle class taxpayer. Despite the changes to the tax code over the past several years and the repeal and limitation of many non-housing itemized deductions, mortgage interest is still deductible. On first and second mortgages and home equity lines of credit (with some limitations) for first and second homes, your mortgage interest deduction is still a good financial incentive to buy a home.</font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#deduct">Your Mortgage Interest Deductions</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#twokindsdebt">Two Kinds of Debt</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#refinancing">Refinancing Your Mortgage</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#secondmort">Second Mortgages</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#homeequity">Home Equity Lines of Credit</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#typevaries">Loan Type Varies Interest Deduction</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#taxbenefits">The Tax Benefits of Selling Your Home</a></span></li>\r\n                          <li><span class="bodytext"><a class="mainlink" href="#refinance">What Are The Costs of Refinancing?</a></span></li>\r\n                        </ul>\r\n                        <h3><a class="mainlink" name="deduct" class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>Your Mortgage Interest Deductions</b></font></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">Under the current tax code, mortgage interest on first and second homes is generally deductible as long as these loans total less than $1.1 million, making homeownership one of the best ways to trim your tax bill. The examples below illustrate how the mortgage income tax deduction affects the after-tax homeownership. </span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">Listed below are the topics covered in this document. </span></font></span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeowner Profile</b><br>Gross Income - $35,500<br>House Price/Mortgage Size - $115,000 - $23,000 down = $92,000<br>Loan Type - 30-year Fixed-Rate mortgage at 10%<br>Property Tax - 1.23% of home value ($1,415)<br>Filing Status - Files jointly/four exemptions<br>\r\n                            </span></font></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">According to the tax code, this homeowner''s deductions for mortgage interest and property taxes would be evaluated at a 15 percent marginal tax rate. Non-housing itemized deductions (i.e., state and local taxes, non-mortgage interest and so on) is estimated at $2,000 and the standard deduction is $5,450. Under the current tax system, the homeowner saves $1,071 because of the mortgage interest deduction. You can figure what your own costs and savings will be by substituting your own tax figures for those on the chart. </span></font></span></font></span></p>\r\n                        <p></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Example of the impact of the Mortgage Income Tax Deduction on Annual Homeownership Costs:</b> </span> </font> \r\n                            </span> </font> </span> \r\n                            <ul>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Before-Tax Homeownership Costs</b><br>Mortgage Interest=$9,177<br>Property Taxes=1,415<br><b>Total of Before-Tax Homeownership Costs=10,592</b><br>\r\n                                </span></font></span></font></span></li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Itemized Deductions</b> </span> </font> </span> </font> \r\n                                </span> \r\n                                <ul>\r\n                                  <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeownership Deductions</b><br>Mortgage Interest= $9,177<br>Property Taxes=1,415<br>Non-homeownership Deductions= 2,000<br><b>Total= 12,592</b> </span></font></span></font></span></li>\r\n                                  <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Standard Deductions=5,450</b></span></font></span></font></span></li>\r\n                                </ul>\r\n                              </li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><strong>Total Itemized Deductions=$7,142</strong><br><b>Multiply Total Itemized Deductions by Marginal Tax Rate to get Homeownership Tax Savings:</b><br>\r\n                                <span class="bodytext"><span class="bodytext">$7,142 \r\n                                x .15 = <font class="bodytext">$1,071</font> </span></span></span></font></span></font></span></li>\r\n                              <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>After Tax Homeownership Costs = Homeownership Tax - Before Tax Savings:</b><br>\r\n                                $10,592 - 1,071 = $9,521</span></font></span></font></span></li>\r\n                            </ul>\r\n                          </li>\r\n                        </ul>\r\n                        <h3><span class="headers"><span class="headers"><a class="mainlink" name="twokindsdebt"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Two Kinds of Debt</font></b></span></font></a></span></span></h3>\r\n                        <p><font size="3"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2" class="bodytext">Under the current tax system, there are two different kinds if debt. Money you borrow to buy, build or substantially improve your residence is called "acquisition indebtedness." Money you borrow against the equity in your home, or money you take out when you refinance your home for any reason except home improvement, is called "equity indebtedness." </font></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext">When you borrowed the money is also important. Home loans taken out before October 14, 1987, are exempted from the new rules. You may fully deduct interest paid on these loans, regardless of their size or what you used them for. Any refinanced debt you incurred before October 14, 1987, is rolled into your total acquisition indebtedness. On loans made on or after October 14, 1987, you can deduct mortgage interest paid on acquisition indebtedness up to a total of 1.0 million. This means you could buy a home for $250,000, a beach home for $200,000, and add a family room to your first house for another $100,000, and still have $450,000 to spend on these homes for further improvements before you reached your limit for interest deductibility. The $1. 0 million is not cumulative. As you pay off a loan, you would add that amount to your total purchasing or improving up to two residences. \r\n                          </span></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><font class="bodytext">Your equity indebtedness limit is $100,000. That means that you can borrow up to $100,000 of the equity in your home and use it for whatever you want. This is a change from the pre-1986 tax rule that limited your equity borrowing beyond the purchase price to certain qualified expenses, such as home improvements, medical and education expenses.</font></span></span></font></span></font></p>\r\n                        <h3><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><a class="mainlink" name="refinancing" class="headers"><font size="4" class="headers" color="#BD827B"><b>Refinancing Your Mortgage</b></font></a></font></span></h3>\r\n                        <p><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2" class="bodytext">Interest rate have declined recently, and many homeowners have taken advantage of this drop by refinancing their mortgages. In the past, refinancing your mortgage has proved to be an excellent opportunity both to lower your interest rate and monthly payment and take equity out of your home. </font></span></font></span></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">When refinancing your mortgage, you will probably pay 3 percent to 6 percent of the loan amount in closing costs-for surveys, legal fees and paperwork fees. Many of these closing costs are deductible, but not necessarily in the year that you refinance. I f you are considering refinancing your mortgage under the current tax rules, however, there are a couple of things to bear in mind. If you refinanced before October 14,1987, for a longer term than was remaining on the pre-October 14 loan, you may only de duct the interest paid on the mortgage for the term that was remaining on the old loan. So if you refinanced a loan with 15 years remaining for a 30-year loan with lower payments, you can only deduct the mortgage interest paid on the new loan for 15 year s. The one exception is if you had a balloon mortgage payment come due after October 13,1987 and you refinanced it to a loan of not more than 30 years; you get the deductibility for the full term of the longer loan. Any refinanced debt you incurred before October 14,1987, is rolled into your total acquisition indebtedness. \r\n                          </font></span></font></span></font></p>\r\n                        <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font class="bodytext">In the past many homeowners have refinanced mortgages on their appreciating properties to draw on their equity to buy a new car or take a vacation. Under the new tax system, homeowners will no longer have unlimited mortgage interest deductions when drawing on equity. Any equity debt incurred is subject to a limit of the amount of on equity. Any equity debt incurred is subject to a limit of the amount of the existing debt plus $100,000. Say, for instance, that you bought your house 10 years ago and have seen the property grow in value from $70,000 to $230,000. If you refinance your mortgage (on which you now owe $50,000), you may only deduct the interest paid on the total of your acquisition indebtedness in the property ($50,000) plus $100,000. You will be able to deduct the interest paid on $150,000.</font></span></font></span></font></p>\r\n                        <h3><a class="mainlink" name="secondmort" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Second Mortgages</b></font></span></font></a></h3>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">A second mortgage allows the homeowner to cash in on some of the equity that has built up in the home over time. Some lenders call a second mortgage a "junior lien." Getting a second mortgage is very much like taking out your first mortgage (i.e. you w ill be required to pay closing costs of 3 percent to 6 percent of the loan value). </font></p>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">You may deduct the interest paid on second mortgages made on or after October 13,1987, up to the $100,000 limit had already been reached when the first mortgage was taken out. The amount of second mortgages made before that date is part of your acquisition indebtedness total figure. This means that if you had $50,000 left on your first mortgage as of that date, and had taken out a $25,000 second mortgage on the property prior to October 14,1987, you would have an acquisition indebtedness of $75,000.</font></p>\r\n                        <h3><a class="mainlink" name="homeequity" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="headln"><span class="headers"><b>Home Equity Lines of Credit</b></font></span></span></span></font></a></h3>\r\n                        <p><font size="1" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">While the 1986 tax reform called for consumer interest deducibility to be phased out by 1991, interest deductions on equity indebtedness now are limited only by the $100,000 cap. This means that interest paid on home equity lines of credit - loans secure d by your principal or second home - is still deductible. </span></font></span></font></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">Where the traditional second mortgage gives the homeowner money in one lump sum the home equity line of credit allows homeowners to use the equity in their home like a giant credit card. The lender allows the homeowner to borrow at will against the equity in the home, and charges interest only on the portion of the equity borrowed against. Therefore, your interest deductions for a home equity line of credit depend on whether you borrow against the equity during that year.</font></span></font></span></p>\r\n                        <h3><a class="mainlink" name="typevaries" class="headers"><font size="4" face="Verdana, Arial, Helvetica, sans-serif"><span class="headers"><b>Loan Type Varies Interest Deduction</b></font></span></font></a></h3>\r\n                        <p><font size="2" class="bodytext" face="Verdana, Arial, Helvetica, sans-serif">As we''ve said, the mortgage interest tax deduction is one of the best financial reasons to buy a home. You may be wondering, however, what total interest charges are like on the typical home loan. In the chart, you can compare a 30-year fixed-rate loan with 15-year and bi-weekly mortgages for the same amount. As you can see, the amount of interest you pay over the life of your loan depends on what kind of mortgage you determine is best for you.  \r\n                          </font></p>\r\n                        <p align="center"><font size="3"><b class="headers">$75,000 MORTGAGE</font></b></font></p>\r\n                        <div align="center"> \r\n                          <table border="0" width="75%" bgcolor="#FFFFFF">\r\n                            <tr bgcolor="#FFFFFF"> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font size="2"></font></td>\r\n                              <td class="bodytext" valign="top" width="26%">30 Year Fixed RateAt 10%</font></td>\r\n                              <td class="bodytext" valign="top" width="23%">15 Year Fixed Rate At 10%</font></td>\r\n                              <td class="bodytext" valign="top" width="25%">Bi-Weekly Mortgage At 10%</font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Monthly Payment</span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$658</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$806</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$658<br>($329 X 2)</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Interest Cost First Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,481</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,398</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,434</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Fourth Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,336</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$6,606</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$7,061</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Mortgage Balance First Year</span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$74,583</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$72,726</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$74,476</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Fourth Year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$73,052</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$64,732</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$69,817</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Interest Cost/Life </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$161,942</span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$70,062</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">$104,331</span></font></td>\r\n                            </tr>\r\n                            <tr> \r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">Difference from 30-year </span></font></td>\r\n                              <td valign="top" width="26%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext"></span></font></td>\r\n                              <td valign="top" width="23%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">-$91,880</span></font></td>\r\n                              <td valign="top" width="25%" bgcolor="#FFFFFF" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><span class="bodytext">-$57,611</span></font></td>\r\n                            </tr>\r\n                          </table>\r\n                          <br>\r\n                          <span class="bodytext"> </span></div>\r\n                        <h3><span class="headers"><a class="mainlink" name="taxbenefits"><font size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b><span class="bighead"><span class="headers">The Tax Benefits of Selling Your Home</span></span></b></font></a></span><a class="mainlink" name="taxbenefits"></a></h3>\r\n                        <p><font size="3"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">The IRS allows a Capital Gains Exclusion of either $250K or $500K (single or married) on the sale of primary residences. There is no life-time cap on this exclusion.  Every 2 years of residence during a 5 year period, you can sell your home and pocket the gain, up to the exclusion, and start over.  In other words, assuming that your only residence is your home, every 2 years you can sell your home, pocket the gain and do it again!</span></font></span></font></span></font></p>\r\n                        <h1 class="headers"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>You should consider these questions </b></font></h1>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><font size="2"><span class="bodytext">Is the next interest rate adjustment on your existing loan likely to increase your monthly payments substantially? Will the new interest rate be two or three percentage points higher than the prevailing rates being offered for either fixed-rate loans or other ARMs?</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">If the current mortgage sets a cap on your monthly payments, are those payments large enough to pay off your loan by the end of the original term? Will refinancing a new ARM or a fixed-rate enable you to pay your loan in full by the end of the term?</span></font></span></font></span></li>\r\n                        </ul>\r\n                        <h3 class="headers"><font color="#BD827B" size="4" face="Verdana, Arial, Helvetica, sans-serif" class="headers"><b>What Are The Costs of Refinancing?</b></font><a class="mainlink" name="refinance"></a></h3>\r\n                        <p><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bodytext"><font size="2"><span class="bodytext">The fees described below are the charges that you most likely to encounter in a refinancing.</span></font></span></font></span></p>\r\n                        <ul>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Application Fees</b><br>This charge imposed by your lender covers the initial costs of processing you loan request and checking your credit report.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Search and Title Insurance</b><br>This charge will cover the cost of examining the public record to confirm ownership of the real estate. It also covers the cost of a policy, usually issued by a title insurance company, that insures the policy holder in a specific amount for any loss caused by discrepancies in the title to the property. Be sure to ask the company carrying the present policy if it can re-issue your policy at a re-issue rate. You could save up to 70 percent of what it would cost you for a new policy.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Lender''s Attorney''s Review Fees</b><br>The lender will usually charge you for fees paid to the lawyer or company that conducts the closing for the lender. Settlements are conducted by lending institutions, title insurance companies, escrow companies, real estate brokers, and attorneys for the buyer and seller. In most situations, the person conducting the settlement is providing a service to the lender. You may want to retain your own attorney to represent you at all stages of the transaction, including settlement.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Loan Origination Fees and Discount Points</b><br>The origination fee is charged for the lender''s work in evaluating and preparing your mortgage loan. Discount points are prepaid finance charges imposed by the lender at closing to increase the lender''s yield beyond the stated interest rate on the mortgage note. One point equals one percent of the loan amount. For example, one point on a $75,000 loan would be $750. In some cases, the points you pay can be financed by adding them to the loan amount. The total number of points a lender charges will depend on market conditions and the interest rate to be charged.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Appraisal Fee</b><br>This fee pays for an appraisal which is a supportable and defensible estimate or opinion of the value of the property.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Prepayment Penalty</b><br>A prepayment penalty on your present mortgage could be the greatest determent to refinancing. The practice of charging money for an early pay-off of the existing mortgage loan varies be state, type of lender, and type of loan. Prepayment penalties are forbidden on various loan including loan from federally chartered credit unions, FHA and VA loans, and some other home-purchase loans. The mortgage documents for your existing loan will state if there is a penalty for prepayment. In some loans, you may be charged interest for the full month in which your prepay your loan.</span></font></span></font></span></li>\r\n                          <li><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Miscellaneous</b><br>Depending on the type of loan you have and other factors, another major expense you might face is the fee for a VA loan guarantee, FHA mortgage insurance, or private mortgage insurance. There are a few other closing costs in addition to these. </span></font></span></font></span></li>\r\n                        </ul>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">In conclusion, a homeowner should plan on paying an average of 3 to 6 percent of the outstanding principal in refinancing costs, plus any prepayment penalties and the costs of paying off any second mortgages that may exist. One way of saving on some of these costs is to check first with the lender who holds your current mortgage. The lender may be willing to waive some of them, especially if the work relating to the mortgage closing is still current. This could include the fees for the title search, surveys, inspections, and so on. </span></font></span></font></span></p>\r\n                        <p><span class="bodytext"><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext">The information contained in this brochure is intended to help you ask the right questions when considering refinancing your loan. It is not a replacement for professional advice. Talk with mortgage lenders, real estate agents, attorneys, and other advisors about lending practices, mortgage instruments, and your own interests before you commit to any specific loan.</span></font></span></font></span></p>\r\n                        <p class="bodytext"><a class="mainlink" href="tools.php" class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><span class="bighead"><span class="bodytext">Back to Tools</font></span></span></font></a> \r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (166, 61, 2, 'List of Publications', '                    Below is a list of publications and the places from which they can be ordered. One of the ways that we could upgrade this service with more funding is to make these publications available on line so that all you have to do is click on the publication you want and it can be downloaded right away. The Homebuyer''s Fair would like to thank Cornell University for providing these materials.</font></span></font></p>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" class="headers" size="4"><b>Needs Assessment</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><span class="bodytext"><b>A House for You:</b></span><b><span class="bodytext"> Learn at Home.</span></b><span class="bodytext"> Packet. Cooperative Extension Service University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583-0804, 402-472-6319.</span></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Home of Your Own.</b><span class="bodytext">Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Before You Buy A Home</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349.</span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Best Buyer Guidebook - Coldwell Banker Takes the Mystery Out of Finding and Financing a Home.</b><span class="bodytext"> Pamphlet. Coldwell Banker Real Estate, Sears Tower, Chicago, Illinois 60684; 312-875-5188. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Condos, Co-ops and PUDs.</b><span class="bodytext">Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>House Planning Handbook.</b><span class="bodytext">Booklet. Midwest Plan Service Iowa State University Cooperative Extension Service, Extension Agricultural Engineer, 170 LeBaron Hall, Ames, Iowa 50011; 515-295-8520.</span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Life-Cycle Housing: Evaluate Before Buying, Building.</b><span class="bodytext">Fact Sheet. North Carolina Cooperative Extension Service, P.O. Box 7605, 210 Ricks Hall, Raleigh, North Carolina 27695-7605; 919-515-2770. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Wise Home Buying. </b><span class="bodytext">Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Housing Choice - Renting or Buying.</b><span class="bodytext">Booklet. University of California Cooperative Extension, 139 Highlander Hall, Riverside, CA 92521.</span></span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Finance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>20 Questions to Ask Before Choosing a Mortgage</b><span class="bodytext"> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Consumer''s Guide to Mortgage Closings.</b><span class="bodytext">Brochure. Federal Reserve Board; Federal Home Loan Bank Board, Division of Consumer and Community Affairs, Washington, DC 20551; 202-452-3946. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Consumer''s Guide to Mortgage Lock-Ins.</b><span class="bodytext"> Brochure. Federal Reserve Board; Federal Home Loan Bank Board, Division of Consumer and Community Affairs, Washington, DC 20551; 202-452-3946. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Quick Guide To Home Loan Choices.</b><span class="bodytext"> Fact Sheet. Marjorie Jensen, Department of Community Planning, University of Rhode Island, Rodman Hall, Kingston, Rhode Island 02881-0804; 401-792-2248. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Affordable Housing - The Cooperative Solution.</b><span class="bodytext">Fact Sheet by Ann Hoyt, John Merrill and Susan Hobert. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Affordability Guidelines For Home Buyers.</b><span class="bodytext"> Fact Sheet. Marjorie Jensen, Department of Community Planning, University of Rhode Island, Rodman Hall, Kingston, Rhode Island 02881-0804; 401-792- 2248. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Alternative Documentation Brochure.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414- 347-6721. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Basics of Sound Underwriting</b><span class="bodytext">Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Buying A Home? How Will You Finance It?</b><span class="bodytext">Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Buying A Home Is Your Best Investment.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Costs.</b><span class="bodytext"> Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Documents You Will Sign.</b><span class="bodytext">Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Handbook on Adjustable Rate Mortgages.</b><span class="bodytext">Brochure. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Family Financial Consultant Handbook.</b><span class="bodytext">Handbook. Laurie Boyce, 433 Lowell, 610 Langden St., Madison, Wisconsin 53706. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial Aspects of Home Ownership.</b><span class="bodytext"> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial Management Extension Consultant Program.</b><span class="bodytext">Program developed for the Minnesota FmHA. University of Minnesota, Minnesota Extension Service, McNeal Hall, 1985 Buford Avenue, St. Paul, MN St. Paul, Minnesota 55108, 612/624-3780. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financing The Home.</b><span class="bodytext"> Booklet by Joseph L. Wysocki. Building Research Council, College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Focus: A Closer Look At ARM Pricing.</b><span class="bodytext"> Booklet. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837 </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Getting Out Of Debt: A Self-Help Guide</b>. <span class="bodytext">Clemson University Cooperative Extension Service, Bulletin Room, 83 Poole Agricultural Center, Clemson University, Clemson, South Carolina 29634-0312; 803-656-3261. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Guide to Single Family Home Mortgage Insurance.</b><span class="bodytext">Brochure. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410-3000; HUD User Line: 800-245-2691.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Helping You Buy The Home You Want.</b><span class="bodytext">Fact Sheet. Private Mortgage Insurance Company, 601 Montgomery Street, San Francisco, California 94111; 800-288-1970</span> \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homeowner''s Insurance - How Much Do I Need?</b><span class="bodytext">Booklet. Clemson University Cooperative Extension Service, Bulletin Room, 83 Poole Agricultural Center, Clemson University, Clemson, South Carolina 29634-0312; 803-656-3261. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Equity Loans: A Wise Choice If<span class="bodytext"> . . .</span></b><span class="bodytext"> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Mortgages: Understanding the Process and Your Right to Fair Lending.</b><span class="bodytext"> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Housing Costs -- Buying and Closing.</b><span class="bodytext"> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082</span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>How Mortgage Insurance Works.</b><span class="bodytext"> Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Individual Housing Accounts: An Opportunity for First-Time Home Buyers.</b><span class="bodytext">Fact Sheet (Hawaii-specific). Hawaii Cooperative Extension Service, CTAHR at Manoa, 3050 Maile Way, Gilmore Hall, 203A, Honolulu, Hawaii 96822; 808-956-8397. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Insuring Your Home.</b><span class="bodytext"> Fact Sheet by Joseph Wysocki. Building Research Council, College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Living Resourcefully With Reduced Income.</b><span class="bodytext">Booklet. Minnesota Extension Service, University of Minnesota, McNeal Hall, 1985 Buford Avenue, St. Paul, MN St. Paul Minnesota 55108, 612/624-3780. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Loan Application Checklist.</b><span class="bodytext">Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span> </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Preserving Home Ownership -- MGIC''s Loan Workout Program.</b><span class="bodytext"> Book and Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Management Calendar.</b><span class="bodytext">Workbook, Teacher Handbook, Activity Book. Purdue University Cooperative Extension Service, 218A Mathews Hall, West Lafayette, Indiana 47907; 317-494-8356. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Mechanics: Buying A House.</b><span class="bodytext">Fact Sheet. Iowa State University Cooperative Extension Service, 170 LeBaron Hall, Ames Iowa 50011; 515-295-8520. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Money Matters.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240.</span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Money Guide.</b><span class="bodytext">Booklet. Federal Trade Commission, Division of Credit Practices and the Office of Consumer and Business Education, Correspondence Branch, Washington, DC 20580; 202-326-2222. </span> </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Options For Home Buyers.</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Negotiating For Your Home.</b><span class="bodytext">Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Private Mortgage Insurance: Questions and Answers.</b><span class="bodytext">Brochure. Private Mortgage Insurance Company, 601 Montgomery Street, San Francisco, California 94111; 800-288-1970. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Refinancing Your Home.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Refinancing Your Home: Questions and Answers.</b><span class="bodytext">Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Scoring For Credit.</b><span class="bodytext">Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. </span></span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Settlement Costs and You.</b><span class="bodytext">Brochure. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410- 3000; HUD User Line: 800-245-2691</span> \r\n                      </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Title Insurance: What Is It And Why Get It.</b><span class="bodytext">Fact Sheet. Community Development Legal Assistance Center, 99 Hudson Street, New York, New York 10013; 212-219-1800. </span>></span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Topics Series H.O.M.E.:</b> </span> </font> </span> </font> \r\n                      <ul>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Housing Costs: How Much Can You Afford.</b><span class="bodytext">(322-TOP-59);</span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Basics.</b><span class="bodytext">(322-TOP-60); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Mortgage Choices.</b><span class="bodytext"> (322-TOP-61); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Adjustable Rate Mortgages.</b><span class="bodytext">(322-TOP-62); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Government Sponsored Mortgages: FHA, FmHA, VA and SONYMA.</b><span class="bodytext"> (322-TOP-63); </span> </span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Ways To Save On Your Mortgage.</b><span class="bodytext">(322-TOP-64); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Closing Costs.</b><span class="bodytext">(322-TOP-65); </span></span></font></span></font></li>\r\n                        <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Choosing A Mortgage Work Sheet.</b>(322-TOP-66). <span class="bodytext">Cornell University Cooperative Extension, Publications Distribution, Cornell Business and Technology Park - Building 7 and 8, Thornwood Drive, Ithaca, New York 14850; 607-255-2080</span></span></font></span></font></li>\r\n                      </ul>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Underwriting Self-Employed Borrowers.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What Happens After You Apply For A Mortgage.</b> Brochure. Mortgage Bankers Association of America, 1125 15th Street NW, 7th Floor, Washington, DC 20005; 202-861-6583. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What You Can Do To Prevent Foreclosure Of Your Home.</b> Fact sheet. Louisiana State University Agricultural Center, Knapp Hall, P.O. Box 25100, Baton Rouge, Louisiana 70894-5100; 504-388-1425. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>What You Should Know About ARMs.</b> Brochure. Mortgage Bankers Association of America, 1125 15th Street NW, 7th Floor, Washington, DC 20005; 202-861-6583. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Fixed-Rate Pricing Alternatives.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Home Purchase Contract.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Physical</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Basic House Inspection.</b> Fact Sheet. Cornell University Cooperative Extension, Publications Distribution, Cornell Business and Technology Park - Building 7 and 8, Thornwood Drive, Ithaca, New York 14850; 607-255-2080. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer Checklist.</b> Brochure. Mortgage Guaranty Insurance Corporation, Marketing Department P.O. Box 488, MGIC Plaza, 250 East Kilbourn Avenue, Milwaukee, Wisconsin 53202, 414-347-6721. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Inspection: Taking a Closer Look.</b> Video. Texas Agricultural Extension Service, Texas A&amp;M University, 201 Special Services Building, College Station, Texas 77843; 409-845-1146. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Site Selection.</b> Pamphlet. Community Resource Development, Ohio State University Cooperative Extension Service, Extension Publications, Room 385, Kottman Hall, 2021 Coffey Road, Columbus, Ohio 43210-1044. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Inspecting A House Before You Buy.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>The Energy Wise Home Buyer.</b> Book (HUD PDR-412(2)). US Department of Housing and Urban Development, Thomas P. O''Neill Federal Building, 10 Causeway Street, Boston, Massachusetts 02222, Attention Supply Clerk. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Questions About Condominiums.</b> Book (HUD-365-H(7)). US Department of Housing and Urban Development, Thomas P. O''Neill Federal Building, 10 Causeway Street, Boston, Massachusetts 02222, Attention Supply Clerk.</span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Professional Assistance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Choosing Home-Buying Professionals.</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Ec Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Financial and Legal Aspects of Buying a Home.</b> Fact Sheet University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583- 0804, 402-472-6319. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Real Estate Brokers.</b> Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Maintenance</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>A Citizen''s Guide To Radon.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002.</span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Asbestos In Your Home.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Biological Pollutants In Your Home.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Energy Efficient Homes Deserve Higher Mortgages.</b> Article by Jeanne Mackin. Consumer News Service, Cornell Cooperative Extension, 1156 Comstock Hall, Ithaca, New York 14853. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Inspection Guide.</b> Booklet No. B3412 by John Merrill. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homebuyer''s Guide To Environmental Hazards.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homebuyer''s Safety and Convenience Checklist.</b> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Homewise: The Home Owner''s Information Seminar (1992).</b> Provides an outline for a two-part workshop for homeowners on the basics of home maintenance. Delmar Melton, Director, Westside Home Buyer''s Clinic, 414-933-2300. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Maintenance Correspondence Course.</b> Workbook. Arkansas Cooperative Extension Service, P.O. Box 392, 2201 Brookwood Drive, Little Rock, Arkansas; 501-671-2099. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Protecting Your Housing Investment.</b> Booklet. U.S. Department of Housing and Urban Development, 7th and D Street SW, Washington, DC 20410-3000; HUD User Line: 800-245-2691. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Radon: What Is It And What Can You Do About It?</b> Fact Sheet. Rutgers Cooperative Extension, Cook College, Home Extension House, P.O. Box 231, New Brunswick, New Jersey 08903; 908-932-9349. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Simple Home Repairs Inside.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your New Home And How To Take Care Of It.</b> National Association of Home Builders'' Bookstore, 15th and M St. NW, Washington, D.C. 20005</span></font></span></font></p>\r\n                    </li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>Being A Good Neighbor</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>&quot;A House for You&quot; : Learn at Home Packet</b>. Cooperative Extension Service University of Nebraska, Room 205 TCD, Lincoln, Nebraska, 68583-0804, 402-472-6319. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Investing In Your Community.</b> Book. Fannie Mae, Customer Education Group, 3900 Wisconsin Avenue N.W., Washington, DC 20016-2899; 202-752-2837.</span></font></span></font></li>\r\n                  </ul>\r\n                  <h3 class="headers"><font size="2"><span class="bodytext"><font color="#BD827B" face="Verdana, Arial, Helvetica, sans-serif" size="4" class="headers"><b>General Interest</b></font></span></font></h3>\r\n                  <ul>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><b><span class="bodytext">Blueprint For Home Organization.</span></b><span class="bodytext"> Brochure. Rubbermaid Inc. Home Products Division, 1147 Akron Road, Wooster, Ohio 44691-6000; 216-264-6464. </span></font></span></font></li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Building Research Council.</b> Multiple Publications. Building Research Council. College of Fine and Applied Arts, University of Illinois at Urbana-Champaign, One East Saint Mary''s Road, Champaign, Illinois 61820; 800-336-0616. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Information Center.</b> Multiple publications. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Consumer Education Resources.</b> Multiple publications. National Institute for Consumer Education, 207 Rackham Building, Eastern Michigan University, Ypsilanti, MI 48197; Consumer Credit Education Hotline: 800-336-6423 or 313-487-2292. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Builder Bookstore.</b> Multiple general interest books and brochures. National Association of Home Builders, 15th and M Streets NW, Washington, DC 20005; 800-368-5242 or 800-223-2665. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Guide for Older Homes.</b> Fact Sheet. Mississippi State University Cooperative Extension Service, P.O. Box 5446, Mississippi State, Mississippi 39762; 601-325-3082. \r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Vocabulary.</b> Booklet. Consumer Information Center, U.S. General Services Administration, P.O. Box 100, Pueblo, Colorado 81002. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buyer''s Youth Activity Guide.</b> Booklet. Greenville Housing Authority, Resident Services, P.O. Box 10047, Greenville, South Carolina 29603; 803-240-3086. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buying The First Time Around.</b> Booklet by John Merrill. University of Wisconsin Extension Service, Agricultural Bulletins, Room 245, 30 North Murray Street, Madison, Wisconsin 53715; 608-262-3346. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Home Buying and Selling.</b> Article. William E. Murphy, Associate Extension Professor, 128 Ag. Eng. Bldg., University of Kentucky, Lexington, Kentucky 40546-0276, 606/257-3000 ext. 120. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Inside and Out: A Guide To Purchasing Property at Auction.</b> Fact Sheets. New York City Housing Program, Brooklyn Housing Resource Center, Cornell Cooperative Extension, 444 Hopkinson Avenue, Brooklyn, New York 11212; 718-385-0233. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Manufactured Housing for Young Consumers.</b> Teaching Folder. Michigan State University Cooperative Extension Service, 204 Human Ecology Building, East Lansing, Michigan 48824; 517-355-7687.\r\n                      </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>&quot;Owning a Dream.&quot;</b> Video. Homeowners Marketing Services, P.O. Box9200, Hollywood, Florida 33084; 305-983-0350. \r\n                        </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Rutgers University Cooperative Extension Video Lending Library.</b> Rutgers Cooperative Extension of Sussex County, 330 Route 206 South, Newton, New Jersey 07860; 201-579-0985. </span></font></span></font></li>\r\n                    <li> \r\n                      <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>The User Friendly Home.</b> Booklet. University of Nevada Cooperative Extension Service, Reno, NV 89557-0131. </span></font></span></font></p>\r\n                    </li>\r\n                    <li><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><span class="bodytext"><b>Your Home, Your Choice.</b> Booklet. Federal Trade Commission, Thomas P. O''Neill Federal Building, 10 Causeway Street, Room 1184, Boston, Massachusetts 02222-1073; 617-565-7240. \r\n                      </span></font></span></font></li>\r\n                  </ul>\r\n                  <p><font size="2"><span class="bodytext"><font face="Verdana, Arial, Helvetica, sans-serif"><a class="mainlink" href="tools.php" class="bodytext"><font size="1"><span class="bodytext">Back to Tools</font></span></font></a></font></span></font></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (167, 62, 2, 'Privacy policy', '<P><FONT class=maintext>Our Privacy Policy sets out our code of practice for the gathering, storing and sharing of our customers'' personal information. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>The data protecting act </FONT></P>\r\n<P><FONT class=maintext>The Data Protection Act puts obligations on users of personal information and lays down principles for its use. One principle states that information has to be processed fairly and lawfully. This means that you''re entitled to know how we intend to use any information you provide, or that we may obtain from other sources eg. credit reference agencies or your employer. You can then decide whether you want us to have that information. To provide the highest level of customer service we need accurate customer information. You can help by informing us whenever your circumstances change, either by phone, post or while you are logged into your plan on our website. Organisations must lodge a notification with the Information Commissioner, describing the purposes for which they process personal information. The details are publicly available from the Commissioner''s Office at: </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>What are cookies?</FONT></P>\r\n<P><FONT class=maintext>A ''cookie'' is a small piece of information which a website places into your browser and can retrieve later. It cannot be read by any website other than that which placed the cookie. We use cookies for several reasons. For example, we can store your preferences for certain kinds of information, or keep track of your progress through our site. Intelligent Finance uses Microsoft Active Service Pages which need cookies to operate properly. It is important that your browser is set to accept cookies, otherwise you will only be able to access our marketing site. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>How to set your browser to accept or disable cookies? </FONT></P>\r\n<P><FONT class=maintext>The way in which you can set your browser to accept or disable cookies varies slightly according to exactly what browser (and operating system) you are currently using. Below are full instructions for changing your browser settings to accept or disable cookies. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>How do we use your personal information? </FONT></P>\r\n<P><FONT class=maintext>Our main use of your personal information is to look after your plan or to provide the specific service you require. If you apply to us for insurance we will pass your details to the insurer. If you make a claim, any information you give to us or to the insurer may be put on to a register of claims and shared with other insurers to prevent fraudulent claims. A list of the participants is available from the insurer. Occasionally, we may contact you by letter, telephone, email or otherwise to inform you about other products and services which may interest you. We try to limit our customer contact programme to acceptable levels, but if you wish to exercise your right to opt out, simply call us on 0845 609 4343 or write to our Head of Regulatory Risk at the following address: Remember that by opting out of receiving marketing information you''ll not be told of any offers or new products and services which may benefit you. For example, you may not hear about a new savings or mortgage product that offers you a better rate or saves you money. Unless you have given us your consent, we''ll not provide information about you to companies outside our group to use for their own marketing purposes. We disclose information about our customers only with their consent, or if we are required to do so by law. Sometimes we need to give information to our agents and subcontractors so that they can provide a particular service for us. Sometimes these companies may be located abroad in countries that don''t have data protection laws. In these circumstances we always ensure that the information is safe and secure. Your information may also be shared by other members of our group to keep their records up to date and administer your relationship with them. Occasionally, the Banking Code Standards Board who monitor compliance with the Banking Code, audit a sample of our customer records to assess our compliance with the Code. Whenever this happens, strict confidentiality conditions are always imposed. Under the Data Protection Act you''ve the right to have access to information we hold about you on our records. The act allows us to charge a fee of Ј10 for this service. If anything is inaccurate or incorrect, please let us know and we will correct it. If you don''t want to receive unsolicited mail from other companies, you can prevent this by registering with the Mailing Preference Service. In addition the Telephone and Fax Preference Services enable you to object to receiving unsolicited marketing phone calls or faxes from other companies. To register, simply telephone the appropriate number below: </FONT></P>\r\n<P><FONT class=maintext>Credit referencing </FONT></P>\r\n<P><FONT class=maintext>If you apply for an Intelligent Finance credit based product, we''ll perform a search with a credit reference agency. The agency will keep a record of the search. After you open a credit based product, we will provide the agency with regular information about how you use it. Other lenders may use this to make decisions on future applications for credit. It may also be used for tracing debtors and to prevent fraud. When opening jars and plans we may search public records such as the Electoral Roll that are available from Credit Reference Agencies to help us verify your identity. Occasionally we search credit reference and fraud prevention agency files as well as our own internal group records to manage your account and take credit decisions such as whether to offer credit or continue to extend existing credit. These searches are not seen or used by lenders to assess your ability to obtain credit. ''Associations'' linking your financial records may be created on credit reference agency records when you apply for jars or plans in joint names. Your financial records, and those of anyone financially associated with you, may be considered in any future applications you make. This association will continue until one of you successfully files a ''disassociation'' at the credit reference agencies. You''ve the right to apply to the credit reference agencies for a copy of your credit file. You can write to them at any time, enclosing a non-returnable fee of Ј2.00. Please give your name, address, postcode, date of birth and any other address you''ve lived at in the last six years to help them find your information. If there''s anything incorrect on your credit file, you''ve the right to ask the agency to add a Notice of Correction. We use Equifax plc, whilst other members of the HBOS Group also use Experian Limited. A third credit reference agency (Call Credit) has recently started up in the UK. Their addresses are as follows: </FONT></P>\r\n<P><FONT class=maintext>Crime prevention and detection </FONT></P>\r\n<P><FONT class=maintext>Our systems protect customers and ourselves against fraud and other crime. Customer information can be used to prevent crime and trace those responsible. We may check your details with fraud prevention agencies. If you give us false or misleading information and we suspect fraud, we will record this. We and other organisations may use and search these records to help us: make decisions about credit and related services for you and members of your household make decisions on household, life and other insurance proposals and insurance claims for you and members of your household trace debtors, recover debt, prevent fraud and to manage your accounts or insurance policies check your identity to prevent money laundering unless you provide us with other satisfactory proof of identity If you want to receive details of those fraud prevention agencies from whom we obtain and with whom we record information about you, contact us on 0845 609 4343. You have a legal right to these details. </FONT></P>\r\n<P>&nbsp;</P>\r\n<P><FONT class=maintext>Email </FONT></P>\r\n<P><FONT class=maintext>If you email us, or give us your email address, we''ll keep a record of it. We may use it to contact you occasionally about our products and services - unless you ask us not to do so. We''ll not give your email address to any unauthorised third parties. When emailing us, always use the email facility on our website to make sure that the content of your email is secure. If you send us email in other ways, remember that it will be ''unsecure'' and could be intercepted. If you do send us ''unsecure'' email, please keep any confidential information in it to a minimum. We''ll do the same when we reply. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>Telephone calls </FONT></P>\r\n<P><FONT class=maintext>We may record telephone conversations to offer you additional security, resolve complaints and improve our service standards. Conversations may also be monitored for staff training purposes. </FONT></P>\r\n<P><FONT class=maintext></FONT>&nbsp;</P>\r\n<P><FONT class=maintext>Responsibility for customer confidentiality </FONT></P>\r\n<P><FONT class=maintext>All our employees are personally responsible for maintaining customer confidentiality. We provide training and education to all our staff to remind them about their obligations. Our policies and procedures are regularly audited and reviewed. </FONT></P>');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (168, 63, 2, 'Electronic Disclosure', 'Electronic Disclosures Authorization<br>\r\nBy applying for a loan online, you agree to accept all applicable disclosures associated with this transaction in an electronic form, including disclosures required by the truth in Lending Act,  Real Estate Settlement Procedures Act and Equal Credit Opportunity Act. Paper copies will be provided for certain real estate related transactions after your loan application is received.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (169, 108, 1, 'Mortgage Term Glossary', '<b><font class="maintext"><a class="mainlink" href="glossary.php#A">A</a>  |  <a class="mainlink" href="glossary.php#B">B</a> | <a class="mainlink" href="glossary.php#C">C</a> | <a class="mainlink" href="glossary.php#D">D</a> | <a class="mainlink" href="glossary.php#E">E</a> | <a class="mainlink" href="glossary.php#F">F</a> | <a class="mainlink" href="glossary.php#G">G</a> | <a class="mainlink" href="glossary.php#H">H</a> | <a class="mainlink" href="glossary.php#I">I</a> | <a class="mainlink" href="glossary.php#J">J</a> | K | <a class="mainlink" href="glossary.php#L">L</a> | <a class="mainlink" href="glossary.php#M">M</a> | <a class="mainlink" href="glossary.php#N">N</a> | <a class="mainlink" href="glossary.php#O">O</a> | <a class="mainlink" href="glossary.php#P">P</a> | Q | <a class="mainlink" href="glossary.php#R">R</a> | <a class="mainlink" href="glossary.php#S">S</a> | <a class="mainlink" href="glossary.php#T">T</a> | <a class="mainlink" href="glossary.php#U">U</a> | <a class="mainlink" href="glossary.php#V">V</a> | <a class="mainlink" href="glossary.php#W">W</a> | X | Y | Z</font></b><br>\r\n\r\n<p><b><span class="golossary">Acceleration</span></b><br>\r\n<span class="golossary_def" >The right of the mortgagee (lender) to demand the immediate repayment of the mortgage loan balance upon the default of the mortgagor (borrower), or by using the right vested in the Due-on-Sale Clause.</span></p>\r\n\r\n<p ><b><span class="golossary">Adjustable rate mortgage (ARM)</span></b><br>\r\n<span class="golossary_def">Is a mortgage in which the interest rate is adjusted periodically based on a preselected index. Also sometimes known as the re-negotiable rate mortgage, the variable rate mortgage or the Canadian rollover mortgage.</span></p>\r\n\r\n<p ><b><span class="golossary">Adjustment interval</span></b><br>\r\n<span class="golossary_def">On an adjustable rate mortgage, the time between changes in the interest rate and/or monthly payment, typically\r\none, three or five years, depending on the index.</span></p>\r\n\r\n<p ><b><span class="golossary">Amortization</span></b><br>\r\n<span class="golossary_def">Means loan payment by equal periodic payment calculated to pay off the debt at the end of a fixed period, including accrued interest on the outstanding balance.</span></p>\r\n\r\n<p ><b><span class="golossary">Annual percentage rate (A.P.R.)</span></b><br>\r\n<span class="golossary_def">Is a interest rate reflecting the cost of a mortgage as a yearly rate. This rate is likely to be higher than the stated note rate or advertised rate on the mortgage, because it takes into account point and other credit cost. The APR allows home buyers to compare different types of mortgages based on the annual cost for each loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Appraisal</span></b><br>\r\n<span class="golossary_def">An estimate of the value of property, made by a qualified professional called an &quot;appraiser&quot;.</span></p>\r\n\r\n<p ><b><span class="golossary">Assessment</span></b><br>\r\n<span class="golossary_def">A local tax levied against a property for a specific purpose, such as a sewer or street lights.</span></p>\r\n\r\n<p ><b><span class="golossary">Assumption</span></b><br>\r\n<span class="golossary_def">The agreement between buyer and seller where the buyer takes over the payments on an existing mortgage from the seller. Assuming a loan can usually save the buyer money since this is an existing mortgage debt, unlike a new mortgage where closing cost and new, probably higher, market-rate interest charges will apply. </span><a name=B></a></p>\r\n\r\n<p ><b><span class="golossary">Balloon (payment) mortgage</span></b><br>\r\n<span class="golossary_def">Usually a short-term fixed-rate loan which involves small payments for a certain period of time and one large payment for the remaining amount of the principal at a time specified in the contract.</span></p>\r\n\r\n<p ><b><span class="golossary">Blanket Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage covering at least two pieces of real estate as security for the same mortgage.</span></p>\r\n\r\n<p ><b><span class="golossary">Borrower (Mortgagor)</span></b><br>\r\n<span class="golossary_def">One who applies for and receives a loan in the form of a mortgage with the intention of repaying the loan in full.</span></p>\r\n\r\n<p ><b><span class="golossary">Broker</span></b><br>\r\n<span class="golossary_def">An individual in the business of assisting in arranging funding or negotiating contracts for a client buy who does not loan the money himself. Brokers usually charge a fee or receive a commission for their services.</span></p>\r\n\r\n<p ><b><span class="golossary">Buy-down</span></b><br>\r\n<span class="golossary_def">When the lender and/or the home builder subsidized the mortgage by lowering the interest rate during the first few years of the loan. While the payments are initially low, they will increase when the subsidy expires. </span><a name=C></a></p>\r\n\r\n<p ><b><span class="golossary">Cash Flow</span></b><br>\r\n<span class="golossary_def">The amount of cash derived over a certain period of time from an income-producing property. The cash flow should be large enough to pay the expenses of the income producing property (mortgage payment, maintenance, utilities, etc).</span></p>\r\n\r\n<p ><b><span class="golossary">Caps (interest)</span></b><br>\r\n<span class="golossary_def">Consumer safeguards which limit the amount the interest rate on an adjustable rate mortgage may change per year and/or the life of the loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Caps (payment)</span></b><br>\r\n<span class="golossary_def">Consumer safeguards which limit the amount monthly payments on an adjustable rate mortgage may change.</span></p>\r\n\r\n<p ><b><span class="golossary">Certificate of Eligibility</span></b><br>\r\n<span class="golossary_def">The document given to qualified veterans which entitles them to VA guaranteed loans for homes, business, and mobile homes. Certificates of eligibility may be obtained by sending DD-214 (Separation Paper) to the local VA office with VA form 1880 (request for Certificate of Eligibility).</span></p>\r\n\r\n<p ><b><span class="golossary">Certificate of Reasonable Value (CRV)</span></b><br>\r\n<span class="golossary_def">An appraisal issued by the Veterans Administration showing the property''s current market value</span></p>\r\n\r\n<p ><b><span class="golossary">Certificate of veteran status</span></b><br>\r\n<span class="golossary_def">The document given to veterans\r\nor reservists who have served 90 days of continuous active duty (including\r\ntraining time) It may be obtained by sending DD 214 to the local VA office with\r\nform 26-8261a (request for certificate of veteran status). This document\r\nenables veterans to obtain lower down payments on certain FHA insured loans.</span></p>\r\n\r\n<p ><b><span class="golossary">Closing</span></b><br>\r\n<span class="golossary_def">The meeting between the buyer,\r\nseller and lender or their agents where the property and funds legally change\r\nhands. Also called settlement. Closing costs usually include an origination\r\nfee, discount points, appraisal fee, title search and insurance, survey, taxes,\r\ndeed recording fee, credit report charge and other costs assessed at\r\nsettlement. The cost of closing usually are about 3 percent to 6 percent of the\r\nmortgage amount.</span></p>\r\n\r\n<p ><b><span class="golossary">Commitment</span></b><br>\r\n<span class="golossary_def">A promise by a lender to make a\r\nloan on specific terms or conditions to a borrower or builder. A promise by an\r\ninvestor to purchase mortgages from a lender with specific terms or conditions.\r\nAn agreement, often in writing, between a lender and a borrower to loan money\r\nat a future date subject to the completion of paper work or compliance with\r\nstated conditions.</span></p>\r\n\r\n<p ><b><span class="golossary">Construction loan</span></b><br>\r\n<span class="golossary_def">A short term interim loan to\r\npay for the construction of buildings or homes. These are usually designed to\r\nprovide periodic disbursements to the builder as he progresses.</span></p>\r\n\r\n<p ><b><span class="golossary">Contract sale or deed:</span></b><br>\r\n<span class="golossary_def">A contract between purchaser\r\nand a seller of real estate to convey title after certain conditions have been\r\nmet. It is a form of installment sale.</span></p>\r\n\r\n<p ><b><span class="golossary">Conventional loan</span></b><br>\r\n<span class="golossary_def">A mortgage not insured by FHA\r\nor guaranteed by the VA.</span></p>\r\n\r\n<p ><b><span class="golossary">Credit Report</span></b><br>\r\n<span class="golossary_def">A report documenting the credit\r\nhistory and current status of a borrower''s credit standing. </span><a name=D></a></p>\r\n\r\n<p ><b><span class="golossary">Debt-to-Income Ratio</span></b><br>\r\n<span class="golossary_def">The ratio, expressed as a\r\npercentage, which results when a borrower''s monthly payment obligation on\r\nlong-term debts is divided by his or her gross monthly income. See housing\r\nexpenses-to-income ratio.</span></p>\r\n\r\n<p ><b><span class="golossary">Deed of trust</span></b><br>\r\n<span class="golossary_def">In many states, this document\r\nis used in place of a mortgage to secure the payment of a note.</span></p>\r\n\r\n<p ><b><span class="golossary">Default</span></b><br>\r\n<span class="golossary_def">Failure to meet legal\r\nobligations in a contract, specifically, failure to make the monthly payments\r\non a mortgage.</span></p>\r\n\r\n<p ><b><span class="golossary">Deferred interest</span></b><br>\r\n<span class="golossary_def">When a mortgage is written with\r\na monthly payment that is less than required to satisfy the note rate, the unpaid\r\ninterest is deferred by adding it to the loan balance. See<em><span\r\nstyle=''font-family:Verdana;''> negative amortization. </span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Delinquency</span></b><br>\r\n<span class="golossary_def">Failure to make payments on\r\ntime. This can lead to foreclosure.</span></p>\r\n\r\n<p ><b><span class="golossary">Department of Veterans Affairs (VA)</span></b><br>\r\n<span class="golossary_def">An independent agency of the\r\nfederal government which guarantees long-term, low-or no-down payment mortgages\r\nto eligible veterans.</span></p>\r\n\r\n<p ><b><span class="golossary">Discount Point</span></b><br>\r\n<span class="golossary_def">See <em><span style=''font-family:Verdana;''>point.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Down Payment</span></b><br>\r\n<span class="golossary">Money paid to make up the\r\ndifference between the purchase price and the golossary_def amount.</span></p>\r\n\r\n<p ><b><span class="golossary">Due-on-Sale-Clause</span></b><br>\r\n<span class="golossary_def">A provision in a mortgage or\r\ndeed of trust that allows the lender to demand immediate payment of the balance\r\nof the mortgage if the mortgage holder sells the home.</span><a name=E></a></p>\r\n\r\n<p ><b><span class="golossary">Earnest Money</span></b><br>\r\n<span class="golossary_def">Money given by a buyer to a\r\nseller as part of the purchase price to bind a transaction or assure payment.</span></p>\r\n\r\n<p ><b><span class="golossary">Entitlement</span></b><br>\r\n<span class="golossary_def">The VA home loan benefit is\r\ncalled entitlement. Entitlement for a VA guaranteed home loan. This is also\r\nknown as eligibility.</span></p>\r\n\r\n<p ><b><span class="golossary">Equal Credit </span></b><br><st1:place><b><span  class="golossary">Opportunity</span></b><br></st1:place><b><span class="golossary"> Act\r\n(ECOA)</span></b><br>\r\n\r\n<span class="golossary_def">Is a federal law that requires\r\nlenders and other creditors to make credit equally available without\r\ndiscrimination based on race, color, religion, national origin, age, sex,\r\nmarital status or receipt of income from public assistance programs.</span></p>\r\n\r\n<p ><b><span class="golossary">Equity</span></b><br>\r\n<span class="golossary_def">The difference between the fair\r\nmarket value and current indebtedness, also referred to as the owner''s\r\ninterest. The value an owner has in real estate over and above the obligation\r\nagainst the property.</span></p>\r\n\r\n<p ><b><span class="golossary">Escrow</span></b><br>\r\n<span class="golossary_def">An account held by the lender\r\ninto which the home buyer pays money for tax or insurance payments. Also\r\nearnest deposits held pending loan closing.</span><a name=F></a></p>\r\n\r\n<p ><b><span class="golossary">Fannie Mae</span></b><br>\r\n<span class="golossary">see<em><span style=''font-family:Verdana;''> Federal National Mortgage Association</span></em>.</span></p>\r\n\r\n<p ><b><span class="golossary">Farmers Home Administration (FmHA)</span></b><br>\r\n<span class="golossary_def">Provides financing to farmers\r\nand other qualified borrowers who are unable to obtain loans elsewhere.</span></p>\r\n\r\n<p ><b><span class="golossary">Federal Home Loan Bank Board (FHLBB)</span></b><br>\r\n<span class="golossary_def">The former name for the\r\nregulatory and supervisory agency for federally chartered savings institutions.\r\nAgency is now called the<em><span style=''font-family:Verdana;mso-bidi-font-family:Arial''> Office of Thrift Supervision</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Federal Home Loan Mortgage Corporation (FHLMC) also\r\ncalled &quot;Freddie Mac&quot;</span></b><br>\r\n<span class="golossary_def">Is a quasi-governmental agency\r\nthat purchases conventional mortgage from insured depository institutions and\r\nHUD-approved mortgage bankers.</span></p>\r\n\r\n<p ><b><span class="golossary">Federal Housing Administration (FHA)</span></b><br> \r\n<span class="golossary_def">A division of the Department of\r\nHousing and Urban Development. Its main activity is the insuring of residential\r\nmortgage loans made by private lenders. FHA also sets standards for\r\nunderwriting mortgages.</span></p>\r\n\r\n<p ><b><span class="golossary">Federal National Mortgage Association (FNMA) also\r\nknow as &quot;Fannie Mae&quot;</span></b><br>\r\n<span class="golossary_def">A tax-paying corporation\r\ncreated by Congress that purchases and sells conventional residential mortgages\r\nas well as those insured by FHA or guaranteed by VA. This institution, which\r\nprovides funds for one in seven mortgages, makes mortgage money more available\r\nand more affordable.</span></p>\r\n\r\n<p ><b><span class="golossary">FHA loan</span></b><br>\r\n<span class="golossary_def">A loan insured by the Federal\r\nHousing Administration open to all qualified home purchasers. While there are\r\nlimits to the size of FHA loans ($155,250 as of </span><st1:date Year="1996"\r\nDay="1" Month="1"><span style=''font-size:7.5pt;font-family:Verdana;mso-bidi-font-family: Arial''>1/1/96</span></st1:date><span class="golossary">), they are generous enough to handle\r\nmoderately-priced homes almost anywhere in the country.</span></p>\r\n\r\n<p ><b><span class="golossary">FHA mortgage insurance</span></b><br>\r\n<span class="golossary_def">Requires a fee (up to 2.25\r\npercent of the loan amount) paid at closing to insure the loan with FHA. In\r\naddition, FHA mortgage insurance requires an annual fee of up to 0.5 percent of\r\nthe current loan amount, paid in monthly installments. The lower the down\r\npayment, the more years the fee must be paid.</span></p>\r\n\r\n<p ><b><span class="golossary">FHLMC</span></b><br>\r\n<span class="golossary_def">The Federal Home Loan Mortgage\r\nCorporation provides a secondary market for savings and loans by purchasing\r\ntheir conventional loans. Also known as &quot;Freddie Mac.&quot;</span></p>\r\n\r\n<p ><b><span class="golossary">Firm Commitment</span></b><br>\r\n<span class="golossary_def">A promise by FHA to insure a\r\nmortgage loan for a specified property and borrower. A promise from a lender to\r\nmake a mortgage loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Fixed Rate Mortgage</span></b><br>\r\n<span class="golossary_def">The mortgage interest rate will\r\nremain the same on these mortgages throughout the term of the mortgage for the\r\noriginal borrower.</span></p>\r\n\r\n<p ><b><span class="golossary">FNMA</span></b><br>\r\n<span class="golossary_def">The Federal National Mortgage\r\nAssociation is a secondary mortgage institution which is the largest single\r\nholder of home mortgages in the </span><span class="golossary">United\r\n  States</span><span class="golossary">. FNMA buys VA, FHA, and\r\nconventional mortgages from primary lenders. Also known as &quot;Fannie\r\nMae.&quot;</span></p>\r\n\r\n<p ><b><span class="golossary">Foreclosure</span></b><br>\r\n<span class="golossary_def">A legal process by which the\r\nlender or the seller forces a sale of a mortgaged property because the borrower\r\nhas not met the terms of the mortgage. Also known as a repossession of\r\nproperty.</span></p>\r\n\r\n<p ><b><span class="golossary">Freddie Mac</span></b><br>\r\n<span class="golossary_def">See <em><span style=''font-family:Verdana;''>Federal Home Loan Mortgage Corporation. </span></em></span><a\r\nname=G></a></p>\r\n\r\n<p ><b><span class="golossary">Ginnie Mae</span></b><br>\r\n<span class="golossary_def">See <em><span style=''font-family:Verdana;''>Government National Mortgage Association.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Government National Mortgage Association (GNMA)</span></b><br>\r\n\r\n<p ><b><span class="golossary_def">&nbsp;</span></b><br>\r\n\r\n<p ><b><span class="golossary">Graduated Payment Mortgage (GPM)</span></b><br>\r\n<span class="golossary_def">A type of flexible-payment\r\nmortgage where the payments increase for a specified period of time and then\r\nlevel off. This type of mortgage has negative amortization built into it.</span></p>\r\n\r\n<p ><b><span class="golossary">Guaranty</span></b><br>\r\n<span class="golossary_def">A promise by one party to pay a\r\ndebt or perform an obligation contracted by another if the original party fails\r\nto pay or perform according to a contract.</span><a name=H></a></p>\r\n\r\n<p ><b><span class="golossary">Hazard Insurance</span></b><br>\r\n<span class="golossary_def">A form of insurance in which\r\nthe insurance company protects the insured from specified losses, such as fire,\r\nwindstorm and the like.</span></p>\r\n\r\n<p ><b><span class="golossary">Housing Expenses-to-Income Ratio</span></b><br>\r\n<span class="golossary_def">The ratio, expressed as a\r\npercentage, which results when a borrower''s housing expenses are divided by\r\nhis/her gross monthly income. See debt-to-income ratio.</span><a name=I></a></p>\r\n\r\n<p ><b><span class="golossary">Impound</span></b><br>\r\n<span class="golossary_def">That portion of a borrower''s\r\nmonthly payments held by the lender or servicer to pay for taxes, hazard\r\ninsurance, mortgage insurance, lease payments, and other items as they become\r\ndue. Also known as reserves.</span></p>\r\n\r\n<p ><b><span class="golossary">Index</span></b><br>\r\n<span class="golossary_def">A published interest rate\r\nagainst which lenders measure the difference between the current interest rate\r\non an adjustable rate mortgage and that earned by other investments (such as\r\none- three-, and five-year U.S. Treasury security yields, the monthly average\r\ninterest rate on loans closed by savings and loan institutions, and the monthly\r\naverage costs-of-funds incurred by savings and loans), which is then used to\r\nadjust the interest rate on an adjustable mortgage up or down.</span></p>\r\n\r\n<p ><b><span class="golossary">Interim Financing</span></b><br>\r\n<span class="golossary_def">A construction loan made during\r\ncompletion of a building or a project. A permanent loan usually replaces this\r\nloan after completion.</span></p>\r\n\r\n<p ><b><span class="golossary">Investor</span></b><br>\r\n<span class="golossary_def">A money source for a lender.</span><a\r\nname=J></a></p>\r\n\r\n<p ><b><span class="golossary">Jumbo Loan</span></b><br>\r\n<span class="golossary_def">A loan which is larger (more\r\nthan $214,600 as of </span><st1:date Year="1997" Day="1" Month="1"><span\r\n class="golossary">1/1/97</span></st1:date><span class="golossary">) than\r\nthe limits set by the <em><span style=''font-family:Verdana;mso-bidi-font-family:\r\nArial''>Federal National Mortgage Association</span></em> and the <em><span style=''font-family:Verdana;''>Federal Home Loan\r\nMortgage Corporation.</span></em> Because jumbo loans cannot be funded by these\r\ntwo agencies, they usually carry a higher interest rate. </span><a name=L></a><a\r\nname=K></a></p>\r\n\r\n<p ><b><span class="golossary">Lien</span></b><br>\r\n<span class="golossary_def">A claim upon a piece of\r\nproperty for the payment or satisfaction of a debt or obligation.</span></p>\r\n\r\n<p ><b><span class="golossary">Loan-to-Value Ratio</span></b><br>\r\n<span class="golossary_def">The relationship between the\r\namount of the mortgage loan and the appraised value of the property expressed\r\nas a percentage.</span><a name=M></a></p>\r\n\r\n<p ><b><span class="golossary">Margin</span></b><br>\r\n<span class="golossary_def">The amount a lender adds to the\r\nindex on an adjustable rate mortgage to establish the adjusted interest rate.</span></p>\r\n\r\n<p ><b><span class="golossary">Market Value</span></b><br>\r\n<span class="golossary_def">The highest price that a buyer\r\nwould pay and the lowest price a seller would accept on a property. Market\r\nvalue may be different from the price a property could actually be sold for at\r\na given time.</span></p>\r\n\r\n<p ><b><span class="golossary">MIP (Mortgage Insurance Premium)</span></b><br>\r\n<span class="golossary_def">It is insurance from FHA to the\r\nlender against incurring a loss on account of the borrower''s default.</span></p>\r\n\r\n<p ><b><span class="golossary">Mortgage Insurance</span></b><br>\r\n<span class="golossary_def">Money paid to insure the\r\nmortgage when the down payment is less than 20 percent. See <em><span style=''font-family:Verdana;''>private mortgage\r\ninsurance, FHA mortgage insurance.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Mortgagee</span></b><br>\r\n<span class="golossary_def">The lender.</span></p>\r\n\r\n<p ><b><span class="golossary">Mortgagor</span></b><br>\r\n<span class="golossary_def">The borrower or homeowner.</span><a name=N></a></p>\r\n\r\n<p ><b><span class="golossary">Negative Amortization</span></b><br>\r\n<span class="golossary_def">Occurs when your monthly\r\npayments are not large enough to pay all the interest due on the loan. This\r\nunpaid interest is added to the unpaid balance of the loan. The danger of\r\nnegative amortization is that the home buyer ends up owing more than the\r\noriginal amount of the loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Net Effective Income</span></b><br>\r\n<span class="golossary_def">The borrower''s gross income\r\nminus federal income tax.</span></p>\r\n\r\n<p ><b><span class="golossary">Non Assumption Clause</span></b><br>\r\n<span class="golossary_def">A statement in a mortgage\r\ncontract forbidding the assumption of the mortgage without the prior approval\r\nof the lender. Note: The signed obligation to pay a debt, as a mortgage note.</span><a\r\nname=O></a></p>\r\n\r\n<p ><b><span class="golossary">Office of Thrift Supervision (OTS)</span></b><br>\r\n<span class="golossary_def">The regulatory and supervisory\r\nagency for federally chartered savings institutions. Formally known as <em><span style=''font-family:Verdana;''>Federal Home Loan Bank\r\nBoard.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Origination Fee</span></b><br>\r\n<span class="golossary_def">The fee charged by a lender to\r\nprepare loan documents, make credit checks, inspect and sometimes appraise a\r\nproperty; usually computed as a percentage of the face value of the loan.</span><a\r\nname=P></a></p>\r\n\r\n<p ><b><span class="golossary">Permanent Loan</span></b><br>\r\n<span class="golossary_def">A long term mortgage, usually\r\nten years or more. Also called an &quot;end loan.&quot;</span></p>\r\n\r\n<p ><b><span class="golossary">PITI</span></b><br>\r\n<span class="golossary_def">Principal, Interest, Taxes and\r\nInsurance. Also called monthly housing expense.</span></p>\r\n\r\n<p ><b><span class="golossary">Pledged account Mortgage</span></b><br><span class="golossary"> (PAM):</span></p>\r\n<span class="golossary_def">Money is placed in a pledged\r\nsavings account and this fund plus earned interest is gradually used to reduce\r\nmortgage payments.</span></p>\r\n\r\n<p ><b><span class="golossary">Points</span></b><br><span class="golossary"> (loan discount points)</span></p>\r\n<span class="golossary_def">Prepaid interest assessed at\r\nclosing by the lender. Each point is equal to 1 percent of the loan amount\r\n(e.g., two points on a $100,000 mortgage would cost $2,000).</span></p>\r\n\r\n<p ><b><span class="golossary">Power of Attorney</span></b><br>\r\n<span class="golossary_def">A legal document authorizing\r\none person to act on behalf of another.</span></p>\r\n\r\n<p ><b><span class="golossary">Prepaid Expenses</span></b><br>\r\n<span class="golossary">Necessary to create an escrow account or to adjust the seller''s existing escrow account. Can include taxes,\r\nhazard insurance, private mortgage insurance and special assessments.</span></p>\r\n\r\n<p ><b><span class="golossary">Prepayment</span></b><br>\r\n<span class="golossary_def">A privilege in a mortgage\r\npermitting the borrower to make payments in advance of their due date.</span></p>\r\n\r\n<p ><b><span class="golossary">Prepayment Penalty</span></b><br>\r\n<span class="golossary_def">Money charged for an early\r\nrepayment of debt. Prepayment penalties are allowed in some form (but not\r\nnecessarily imposed) in many states.</span></p>\r\n\r\n<p ><b><span class="golossary">Primary Mortgage Market</span></b><br>\r\n<span class="golossary_def">Lenders making mortgage loans\r\ndirectly to borrower''s such as savings and loan associations, commercial banks,\r\nand mortgage companies. These lenders sometimes sell their mortgages into the\r\nsecondary mortgage markets such as to <em><span style=''font-family:Verdana; ''>FNMA</span></em> or <em><span style=''font-family:Verdana;''>GNMA</span></em>, etc.</span></p>\r\n\r\n<p ><b><span class="golossary">Principal</span></b><br>\r\n<span class="golossary_def">The amount of debt, not\r\ncounting interest, left on a loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Private Mortgage Insurance</span></b><br><span class="golossary"> (PMI)</span></p>\r\n<span class="golossary_def">In the event that you do not\r\nhave a 20 percent down payment, lenders will allow a smaller down payment - as\r\nlow as 5 percent in some cases. With the smaller down payment loans, however,\r\nborrowers are usually required to carry private mortgage insurance. Private\r\nmortgage insurance will usually require an initial premium payment and may\r\nrequire an additional monthly fee depending on you loan''s structure.</span><a\r\nname=R></a><a name=Q></a></p>\r\n\r\n<p ><b><span class="golossary">Realtor</span></b><br>\r\n<span class="golossary_def">A real estate broker or an\r\nassociate holding active membership in a local real estate board affiliated\r\nwith the National Association of Realtors.</span></p>\r\n\r\n<p ><b><span class="golossary">Recision</span></b><br>\r\n<span class="golossary_def">The cancellation of a contract.\r\nWith respect to mortgage refinancing, the law that gives the homeowner three\r\ndays to cancel a contract in some cases once it is signed if the transaction\r\nuses equity in the home as security.</span></p>\r\n\r\n<p ><b><span class="golossary">Recording Fees</span></b><br>\r\n<span class="golossary_def">Money paid to the lender for\r\nrecording a home sale with the local authorities, thereby making it part of the\r\npublic records.</span></p>\r\n\r\n<p ><b><span class="golossary">Refinance</span></b><br>\r\n<span class="golossary_def">Obtaining a new mortgage loan\r\non a property already owned. Often to replace existing loans on the property.</span></p>\r\n\r\n<p ><b><span class="golossary">Renegotiable Rate Mortgage</span></b><br>\r\n<span class="golossary_def">A loan in which the interest\r\nrate is adjusted periodically. See <em><span style=''font-family:Verdana;''>adjustable rate mortgage.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">RESPA</span></b><br>\r\n<span class="golossary_def">Short for the Real Estate\r\nSettlement Procedures Act. RESPA is a federal law that allows consumers to\r\nreview information on known or estimated settlement cost once after application\r\nand once prior to or at a settlement. The law requires lenders to furnish the\r\ninformation after application only.</span></p>\r\n\r\n<p ><b><span class="golossary">Reverse Annuity Mortgage</span></b><br><span class="golossary"> (RAM)</span></p>\r\n<span class="golossary_def">A form of mortgage in which the\r\nlender makes periodic payments to the borrower using the borrower''s equity in\r\nthe home as Satisfaction of Mortgage: The document issued by the mortgagee when\r\nthe mortgage loan is paid in full. Also called a &quot;release of\r\nmortgage.&quot;</span><a name=S></a></p>\r\n\r\n<p ><b><span class="golossary">Second Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage made subsequent to\r\nanother mortgage and subordinate to the first one.</span></p>\r\n\r\n<p ><b><span class="golossary">Secondary Mortgage Market</span></b><br>\r\n<span style=''font-size:7.5pt;  font-family:Verdana;''>The place where primary\r\nmortgage lenders sell the mortgages they make to obtain more funds to originate\r\nmore new loans. It provides liquidity for the lenders. Security.</span></p>\r\n\r\n<p ><b><span class="golossary">Servicing</span></b><br>\r\n<span class="golossary_def">All the steps and operations a\r\nlender performs to keep a loan in good standing, such as collection of\r\npayments, payment of taxes, insurance, property inspections and the like.</span></p>\r\n\r\n<p ><b><span class="golossary">Settlement/Settlement Costs</span></b><br>\r\n<span class="golossary_def">See <em><span style=''font-family:Verdana;''>closing/closing costs.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Shared Appreciation Mortgage (SAM)</span></b><br>\r\n<span class="golossary_def">A mortgage in which a borrower\r\nreceives a below-market interest rate in return for which the lender (or\r\nanother investor such as a family member or other partner) receives a portion\r\nof the future appreciation in the value of the property. May also apply to\r\nmortgage where the borrowers shares the monthly principal and interest payments\r\nwith another party in exchange for part of the appreciation.</span></p>\r\n\r\n<p ><b><span class="golossary">Simple Interest</span></b><br>\r\n<span class="golossary_def">Interest which is computed only\r\non the principle balance.</span></p>\r\n\r\n<p ><b><span class="golossary">Survey</span></b><br>\r\n<span class="golossary_def">A measurement of land, prepared by a registered land surveyor, showing the location of the land with reference to know points, its dimensions, and the location and dimensions of any buildings.</span></p>\r\n\r\n<p ><b><span class="golossary">Sweat Equity</span></b><br>\r\n<span class="golossary_def">Equity created by a purchaser performing work on a property being purchased.</span><a name=T></a></p>\r\n\r\n<p ><b><span class="golossary">Title</span></b><br>\r\n<span class="golossary_def">A document that gives evidence of an individual''s ownership of property.</span></p>\r\n\r\n<p ><b><span class="golossary">Title Insurance</span></b><br>\r\n<span class="golossary_def">A policy, usually issued by a title insurance company, which insures a home buyer against errors in the title search. The cost of the policy is usually a function of the value of the property, and is often borne by the purchaser and/or seller. Policies are also available to protect the lender''s interests.</span></p>\r\n\r\n<p ><b><span class="golossary">Title Search</span></b><br>\r\n<span class="golossary_def">An examination of municipal records to determine the legal ownership of property. Usually is performed by a title company.</span></p>\r\n\r\n<p ><b><span class="golossary">Truth-In-Lending</span></b><br>\r\n<span class="golossary_def">A federal law requiring disclosure of the Annual Percentage Rate to home buyers shortly after they apply for the loan. Also known as Regulation Z.</span></p>\r\n\r\n<p ><b><span class="golossary">Two-Step Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage in which the borrower receives a below-market interest rate for a specified number of years (most often seven or 10), and then receives a new interest rate adjusted (within certain limits) to market conditions at that time. The lender sometimes has the option to call the loan due with 30 days notice at the end of seven or 10 years. Also called &quot;Super Seven&quot; or &quot;Premier&quot; mortgage.</span><a name=U></a></p>\r\n\r\n<span style=''mso-bookmark:U''><b><span class="golossary">Underwriting</span></b><br></span><span style=''mso-bookmark:U''></span></p>\r\n<span style=''mso-bookmark:U''><span class="golossary_def">The decision whether to make a loan to a potential home buyer based on credit, employment, assets, and other factors and the matching of this risk to an appropriate rate and term or loan amount.</span></span><span style=''mso-bookmark: U''></span></p>\r\n\r\n<p ><b><span class="golossary">USURY</span></b><br>\r\n<span class="golossary_def">Interest charged in excess of the legal rate established by law.</span><a name=V></a></p>\r\n\r\n<p ><b><span class="golossary">VA Loan</span></b><br>\r\n<span class="golossary_def">A long-term, low-or no-down payment loan guaranteed by the Department of Veterans Affairs. Restricted to individuals qualified by military service or other entitlements.</span></p>\r\n\r\n<p ><b><span class="golossary">VA Mortgage Funding Fee</span></b><br>\r\n<span class="golossary_def">A premium of up to 1-7/8 percent (depending on the size of the down payment) paid on a VA-backed loan. On a $75,000 fixed-rate mortgage with no down payment, this would amount to $1,406 either paid at closing or added to the amount financed.</span></p>\r\n\r\n<p ><b><span class="golossary">Variable Rate Mortgage (VRM)</span></b><br>\r\n<span class="golossary_def">See <em><span style=''font-family:Verdana;''>adjustable rate mortgage.</span></em></span></p>\r\n\r\n<p ><b><span class="golossary">Verification of Deposit (VOD)</span></b><br>\r\n<span class="golossary_def">A document signed by the borrower''s financial institution verifying the status and balance of his/her financial accounts.</span></p>\r\n\r\n<p ><b><span class="golossary">Verification of Employment (VOE)</span></b><br>\r\n<span class="golossary_def">A document signed by the borrower''s employer verifying his/her position and salary.</span><a name=W></a></p>\r\n\r\n<p ><b><span class="golossary">Warehouse Fee</span></b><br>\r\n<span class="golossary_def">Many mortgage firms must borrow funds on a short term basis in order to originate loans which are to be sold later in the secondary mortgage market (or to investors). When the prime rate of interest is higher on short term loans than on mortgage loans, the mortgage firm has an economic loss which is offset by charging a warehouse fee.</span></p>\r\n\r\n<p ><b><span class="golossary">Wraparound mortgage</span></b><br>\r\n<span class="golossary_def">Results when an existing assumable loan is combined with a new loan, resulting in an interest rate somewhere between the old rate and the current market rate. The payments are made to a second lender or the previous homeowner, who then forwards the payments to the first lender after taking the additional amount off the top.</span><a name=Y></a><a name=X></a></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (170, 108, 2, 'Mortgage Term Glossary', '<b><font class="maintext"><a class="mainlink" href="glossary.php#A">A</a>  |  <a class="mainlink" href="glossary.php#B">B</a> | <a class="mainlink" href="glossary.php#C">C</a> | <a class="mainlink" href="glossary.php#D">D</a> | <a class="mainlink" href="glossary.php#E">E</a> | <a class="mainlink" href="glossary.php#F">F</a> | <a class="mainlink" href="glossary.php#G">G</a> | <a class="mainlink" href="glossary.php#H">H</a> | <a class="mainlink" href="glossary.php#I">I</a> | J | K | <a class="mainlink" href="glossary.php#L">L</a> | <a class="mainlink" href="glossary.php#M">M</a> | <a class="mainlink" href="glossary.php#N">N</a> | <a class="mainlink" href="glossary.php#O">O</a> | <a class="mainlink" href="glossary.php#P">P</a> | Q | <a class="mainlink" href="glossary.php#R">R</a> | <a class="mainlink" href="glossary.php#S">S</a> | <a class="mainlink" href="glossary.php#T">T</a> | <a class="mainlink" href="glossary.php#U">U</a> | V | W | X | Y | Z</font></b><br>\r\n\r\n<p><a name=A></a><b><span class="golossary">APR</span></b><br>\r\n<span class="golossary_def" >APR stands for Annual Percentage Rate. A lender is always required to quote the APR when advertising a loan or borrowing rate. The lender will usually quote the headline rate and the APR next to it. The headline rate states the rate of interest you pay per month or per year on the mortgage, while the APR is based on the total amount that will be paid over the entire period of the loan. It also takes into account any charges that the borrower has to pay during the loan period.</span></p>\r\n\r\n<p ><b><span class="golossary">AVM</span></b><br>\r\n<span class="golossary_def">AVM stands for Automated Valuation Model.  It is a search used by some lenders to establish the value of your property based on recent local sales and value trends.  This is instant and means that they do not have to send a surveyor to your property.</span></p>\r\n\r\n<p ><a name=B></a><b><span class="golossary">Base rate</span></b><br>\r\n<span class="golossary_def">The UK''s core interest rate, set by the Bank of England. The lender''s Standard Variable Rate (SVR) is higher than the Base Rate, but is often adjusted by reference to it.</span></p>\r\n\r\n<p ><b><span class="golossary">Bonding Scheme</span></b><br>\r\n<span class="golossary_def">An agreement by members of a profession or trade to establish a central compensation fund which consumers can draw on in cases of fraud or insolvency.</span></p>\r\n\r\n<p ><b><span class="golossary">Buildings Insurance</span></b><br>\r\n<span class="golossary_def">Insurance cover which protects the holder against damage to the property itself (although it can be linked with contents insurance in a combined policy). The amount insured may vary from the purchase price/valuation of the property depending on the type of location of the property. The valuer will usually provide a rebuild cost for insurance purposes.</span></p>\r\n\r\n<p ><b><span class="golossary">Buy to Let</span></b><br>\r\n<span class="golossary_def">The practice of buying a house or flat for investment purposes. Income is provided by the tenants'' rent, and capital growth (if any) by the property''s increasing resale value.</span></p>\r\n\r\n<p ><a name=C></a><b><span class="golossary">Capital and interest</span></b><br>\r\n<span class="golossary_def">In the context of mortgages, a capital and interest mortgage is also known as a repayment mortgage. It involves paying all of the interest plus repayment of a little of the capital each month; an interest only mortgage involves only paying off the interest.</span></p>\r\n\r\n<p ><b><span class="golossary">Capped Rate</span></b><br>\r\n<span class="golossary_def">A mortgage which allows your interest rate to climb no higher than a specified level, usually for the first few years of the loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Cashback</span></b><br>\r\n<span class="golossary_def">A cash amount paid by a mortgage lender to a customer (typically at the beginning of a contract) as an inducement to enter into a mortgage contract with the mortgage lender.</span></p>\r\n\r\n<p ><b><span class="golossary">Completion</span></b><br>\r\n<span class="golossary_def">The final stage of the house-buying process, which comes after exchange of contracts. The sale must proceed after Exchange, but Completion occurs when the property''s agreed sale price (less any deposit already paid) safely reaches the seller''s bank account.</span></p>\r\n\r\n<p ><b><span class="golossary">Compulsories</span></b><br>\r\n<span class="golossary_def">This is shorthand for compulsory insurances. Some lenders, at least for certain mortgages, insist that you take out their buildings insurance - which needn''t necessarily be the most cost effective on the market. Our Mortgage Wizards allow you to select out these products if you wish to (although sometimes of course, the mortgages can be so good that it outweighs the potential disadvantage of taking the compulsory insurance).</span></p>\r\n\r\n<p ><b><span class="golossary">Contents Insurance</span></b><br>\r\n<span class="golossary_def">Insurance cover which protects the personal belongings your home contains. In the case of rented accommodation, the landlord is responsible for insuring those contents which he owns, but not those owned by his tenants.</span></p>\r\n\r\n<p ><b><span class="golossary">Conveyancing</span></b><br>\r\n<span class="golossary_def">Normally carried out by a solicitor or licensed conveyancer on the buyer''s behalf, conveyancing includes proving the property is really owned by its seller, making sure that all the loans secured on it are discharged, establishing its legal boundaries and searching local planning information for upcoming developments which could affect the property''s value.</span></p>\r\n\r\n<p ><b><span class="golossary">Council Tax</span></b><br>\r\n<span class="golossary_def">A local authority charge which replaced the Community Charge in 1993/94. Generally speaking, the more valuable your property is, the higher your Council Tax bill will be, although the amount for an identical property can vary considerably between different local authorities. In rented or buy to let accommodation, the tenants are usually responsible for the Council tax.</span></p>\r\n\r\n<p ><b><span class="golossary">County Court Judgement (CCJ)</span></b><br>\r\n<span class="golossary_def">If a County Court rules against you for defaulting on a debt, that ruling is listed on your credit record. Having such a judgement listed against you may mean you are turned down for future loans, or be expected to pay a higher rate than other customers. The Scottish equivalent of an English CCJ is a Decree.</span></p>\r\n\r\n<p ><b><span class="golossary">Credit Reference Agency</span></b><br>\r\n<span class="golossary_def">When assessing your application, a mortgage lender will study your credit records. These records are held centrally by credit reference agencies, and contain information from many different aspects of your life.</span></p>\r\n\r\n<p ><b><span class="golossary">Current Account</span></b><br>\r\n<span class="golossary_def">A bank account linked to a cheque book and/or debit card. In exchange for instant access and the ability use cheque or debit facilities, most pay little or no interest on the balance they contain.</span></p>\r\n\r\n<p ><a name=D></a><b><span class="golossary">Deeds</span></b><br>\r\n<span class="golossary_def">The formal written document which lists exactly who owns a property and enables transfer of a property''s ownership from seller to buyer. A mortgage lender will record details of their mortgage on these deeds (which means they can take ownership of the property if you default on the loan payments).</span></p>\r\n\r\n<p ><b><span class="golossary">Deposit</span></b><br>\r\n<span class="golossary_def">In the context of mortgages, the deposit is the initial lump sum payment which the buyer must contribute to the property''s total purchase price. Commonly set at around 5% to 10%.</span></p>\r\n\r\n<p ><b><span class="golossary">Deposit-based Savings</span></b><br>\r\n<span class="golossary_def">A method of saving which pays regular, usually variable interest based on the amount invested (instead of relying, for example, on the unpredictable returns from stock market investment).</span></p>\r\n\r\n<p ><b><span class="golossary">Discounted Rate</span></b><br>\r\n<span class="golossary_def">A mortgage which has an interest rate below the lender''s standard variable rate (SVR), Bank Base Rate or Libor rate, typically for the first few months or years of the loan. The rate payable may move up and down, but the discount on SVR remains constant.</span></p>\r\n\r\n<p ><b><span class="golossary">Distance mortgage mediation contract</span></b><br>\r\n<span class="golossary_def">If a regulated mortgage contract is taken out exclusively using the internet, telephone, email, or fax then it is classed as a distance contract.</span></p>\r\n\r\n<p ><b><span class="golossary">Diversification</span></b><br>\r\n<span class="golossary_def">The principle that wise investors should spread their risk among many different types of investment. A properly balanced portfolio will contain elements of share, deposit-based and property investments. Fund performance and objective achievement are not guaranteed.</span></p>\r\n\r\n<p ><b><span class="golossary">Durable Medium</span></b><br>\r\n<span class="golossary_def">A document which meets the following criteria is said to be in a durable medium:<br><br>\r\n    * Capable of being used by the recipient.<br>\r\n    * Enables the recipient to store the information in a way accessible for future reference for a period of time adequate for the purposes of the information.<br>\r\n    * Allows the unchanged reproduction of the information.</span></p>\r\n\r\n<p ><a name=E></a><b><span class="golossary">Early Repayment Charges (ERC''s)</span></b><br>\r\n<span class="golossary_def">A charge levied by the mortgage lender on the customer in the event that the loan is repaid in full or in part before a date specified in the contract. Fixed-rate, capped-rate, cashback and discount rate mortgages commonly carry early repayment charges that can in some cases persist long after the initial special rate itself has expired. This can make it prohibitively expensive to move to a rival lender in the first few years of the loan. The Charcol web site shows you the size of any early repayment charge and how it changes over time.</span></p>\r\n\r\n<p ><b><span class="golossary">Employment Status</span></b><br>\r\n<span class="golossary_def">A term used by lenders to describe potential borrowers'' working arrangements. Self-employed applicants are sometimes seen as a greater risk than employees are. But many specialist lenders and mortgages have emerged in recent years designed specially for different types of employment status, and the Charcol website has a wide variety of these in its database.</span></p>\r\n\r\n<p ><b><span class="golossary">Endowment Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage funded by an insurance-based savings plan. The borrower only pays interest during the mortgage term and the savings plan is designed to repay the mortgage at the end of the mortgage term. As the returns payable under the savings plan depend on stock market performance, shortfalls and in some instances overpayments can occur.</span></p>\r\n\r\n<p ><b><span class="golossary">Equities</span></b><br>\r\n<span class="golossary_def">Another name for ordinary shares.</span></p>\r\n\r\n<p ><b><span class="golossary">Exchange of Contracts</span></b><br>\r\n<span class="golossary_def">The terms of a property''s purchase become legally binding for both parties when contracts are exchanged. The buyer is then committed to buying, and the seller to selling. As a buyer, you should normally ensure that you are covered by building insurance from this date, because even if the property were damaged badly, you would still have to buy it.</span></p>\r\n\r\n<p ><b><span class="golossary">Execution-only</span></b><br>\r\n<span class="golossary_def">A service which offers no advice, but merely carries out the customer''s orders.</span></p>\r\n\r\n<p ><a name=F></a><b><span class="golossary">Fixed Rate</span></b><br>\r\n<span class="golossary_def">A mortgage which fixes your interest rate at a specified level, typically for the first few years of the loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Fixed rate mortgage</span></b><br>\r\n<span class="golossary_def">A fixed rate mortgage charges a set interest rate over an agreed period of time, which could be anything from 1 year, 3 years, 5 years, or occasionally even longer. At the end of the fixed rate, the mortgage will normally revert to the lender''s standard variable rate.\r\n<br><br>Usually you will find that a fixed rate mortgage offers very favourable terms, but early repayment charges will limit any flexibility to switch away from it.\r\n<br><br>The good thing about a fixed rate mortgage is that you know how much you''ll be repaying each month for the length of the fixed period, which can make budgeting much easier. Where fixed rate mortgages don’t necessarily work is if the standard rates begin to fall - and you end up fixed on a higher rate with prohibitive early repayment charges.</span></p>\r\n\r\n<p ><b><span class="golossary">Flexible Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage which allows borrowers to make overpayments when they have spare cash. Other features could include the option to reduce or miss payments altogether when times are tight, and to reborrow any overpayments. Not all flexible mortgages offer all of these features. Often useful for self-employed people whose income varies from one month to the next. The most flexible form of mortgage is a Current Account Mortgage (CAM), which can potentially save you money by linking your current account and mortgage together.</span></p>\r\n\r\n<p ><a name=G></a><b><span class="golossary">Graduate mortgage</span></b><br>\r\n<span class="golossary_def">There are a number of lenders who offer specialist graduate mortgage products. These tend to require no deposit and in some cases can lend over 100% of the value of the property. If you would like to find a competitively priced graduate mortgage and get out of the renting game, take a look at the options today.</span></p>\r\n\r\n<p ><b><span class="golossary">Gross</span></b><br>\r\n<span class="golossary_def">Before tax.</span></p>\r\n\r\n<p ><b><span class="golossary">Growth</span></b><br>\r\n<span class="golossary_def">A growth strategy is one which seeks to maximise the capital value of your investment without the requirement to generate any minimum level of income. Any income may be reinvested.</span></p>\r\n\r\n<p ><a name=H></a><b><span class="golossary">Higher Lending Charge</span></b><br>\r\n<span class="golossary_def">This is an insurance premium that you have to pay for some mortgages, usually when the Loan To Value is higher than a certain figure. It protects the lender to some extent if you default on the mortgage for any reason. It is important to understand that although you have to pay the premium, the lender benefits from any payout, and that if the payout doesn''t cover their costs they may seek further money from you. With many mortgages you can add the Higher Lender Charge to the loan, unless this takes your Loan To Value over a certain figure. The insurer may pursue the defaulter for reimbursement of any monies which have been paid out in respect of lenders claim.</span></p>\r\n\r\n<p ><b><span class="golossary">Home and Contents Insurance</span></b><br>\r\n<span class="golossary_def">A joint term, referring to both buildings cover and contents cover. The two policies may or may not be bought from the same insurer, but buying them together can sometimes save money or make life simpler.</span></p>\r\n\r\n<p ><a name=I></a><b><span class="golossary">Illustration</span></b><br>\r\n<span class="golossary_def">In the context of mortgages, a lender''s estimate of the monthly payments you would have to make under a particular loan arrangement, together with the costs to set it up.</span></p>\r\n\r\n<p ><b><span class="golossary">Impaired Credit</span></b><br>\r\n<span class="golossary_def">Impaired credit mortgages are specialist loans for customers whose credit problems disqualify them from using mainstream lenders'' standard products. Some lenders specialise in loans like these, which are also known as adverse credit loans.</span></p>\r\n\r\n<p ><b><span class="golossary">Income</span></b><br>\r\n<span class="golossary_def">An income strategy for investments is one which seeks to achieve a minimum level of income from the investment to fund day-to-day spending (often used by retired people).</span></p>\r\n\r\n<p ><b><span class="golossary">Independent Financial Advice</span></b><br>\r\n<span class="golossary_def">The Financial Services Act introduced the concept of "polarisation" - people advising on, or selling, regulated financial products (investments, pensions etc) had to sell either one company''s products, or provide advice about the range of products in the market. Charcol is a leading firm of independent mortgage advisers and as such offers advice across a range of products and companies.</span></p>\r\n\r\n<p ><b><span class="golossary">Independent Mortgage Advisers</span></b><br>\r\n<span class="golossary_def">Someone who can advise you on mortgage that is right for you, taking your circumstances and the full range of products available into account. We can put you in touch with one of Charcol''s Independent Mortgage Advisers who can give you advice on the full range of products available in the market.</span></p>\r\n\r\n<p ><b><span class="golossary">Interest</span></b><br>\r\n<span class="golossary_def">The premium which a borrower must pay a lender in return for use of the lender''s money.</span></p>\r\n\r\n<p ><b><span class="golossary">Interest only mortgage</span></b><br>\r\n<span class="golossary_def">An interest only mortgage or interest only remortgage is where you simply pay the lender the minimum amount to cover the interest on your loan and invest enough each month in an investment vehicle to build up a large enough fund to pay off the capital part of the mortgage, when it becomes due at the end of the agreed term.</span></p>\r\n\r\n<p ><b><span class="golossary">ISA Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage loan funded by contributions to an Individual Savings Account. ISAs provide tax-free growth, generated mainly by stockmarket investment. The ISA aims to repay the loan''s capital at the end of its term, but the interest element must be paid separately as you go along. It''s important to remember that past performance is not necessarily a guide to future performance.</span></p>\r\n\r\n<p ><a name=L></a><b><span class="golossary">Letting Agent</span></b><br>\r\n<span class="golossary_def">A property agent who can help landlords locate suitable properties for purchase, and who finds tenants to occupy those properties and can manages the rental process which follows.</span></p>\r\n\r\n<p ><b><span class="golossary">Loan To Value</span></b><br>\r\n<span class="golossary_def">This is the amount you want to borrow divided by the purchase price. In other words, it reflects the size of your deposit. Generally, the lower the loan to value, the safer the lender will view the loan.</span></p>\r\n\r\n<p ><b><span class="golossary">Local Search</span></b><br>\r\n<span class="golossary_def">See Search.</span></p>\r\n\r\n<p ><b><span class="golossary">London Inter-Bank Offered Rate (LIBOR)</span></b><br>\r\n<span class="golossary_def">The interest rate at which leading banks lend to one another. Sometimes used as an alternative to base rate in setting the benchmark for a tracker mortgage. There are separate LIBOR rates for different periods up to a year but either "1" or "3" months LIBOR is what is normally used in setting mortgage rates.</span></p>\r\n\r\n<p ><a name=M></a><b><span class="golossary">Money Markets</span></b><br>\r\n<span class="golossary_def">The wholesale markets in which banks and other financial institutions lend money to one another. Mortgage lenders often borrow money in these markets, particularly for funding fixed rate mortgages.</span></p>\r\n\r\n<p ><b><span class="golossary">Mortgage Adviser</span></b><br>\r\n<span class="golossary_def">A firm/ individual with permission for advising on regulated mortgage contracts.</span></p>\r\n\r\n<p ><b><span class="golossary">Mortgage refinancing</span></b><br>\r\n<span class="golossary_def">Mortgage refinancing typically refers to using a lower rate mortgage to consolidate other loans and reduce monthly outgoings. The mortgage refinancing rate – as long as you choose carefully – should be a great deal less than you are paying for credit cards, unsecured loans or other finance and can therefore save you a significant amount each month. However, you may pay more over the term of the loan.</span></p>\r\n\r\n<p ><a name=N></a><b><span class="golossary">Net</span></b><br>\r\n<span class="golossary_def">After tax has been deducted.</span></p>\r\n\r\n<p ><b><span class="golossary">Non-Status Loan</span></b><br>\r\n<span class="golossary_def">This is where your income is not disclosed and/or you have some adverse credit.</span></p>\r\n\r\n<p ><a name=O></a><b><span class="golossary">Overpayment</span></b><br>\r\n<span class="golossary_def">A mortgage repayment bigger than the one needed to meet the loan''s minimum requirements. Mortgages that allow these without penalty are often useful for people whose type of employment means that from time to time they receive significant bonuses or other influxes of money.</span></p>\r\n\r\n<p ><a name=P></a><b><span class="golossary">Payment Holiday</span></b><br>\r\n<span class="golossary_def">A short break from regular mortgage repayments, sometimes offered with flexible mortgages. This can sometimes be a useful feature for self-employed people or others with irregular income.</span></p>\r\n\r\n<p ><b><span class="golossary">Pension Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage whose capital repayment is funded by contributions to a personal pension. The generous tax breaks given to pension saving boost contributions by making them gross instead of net of tax. There is an option available to take a lump sum, of up to 25% of the value of the accumulated pension fund. This lump sum aims to repay the loan''s capital at the end of the term. The past performance is not necessarily a guide to future performance.</span></p>\r\n\r\n<p ><b><span class="golossary">Premium</span></b><br>\r\n<span class="golossary_def">In the context of insurance, a premium is the regular sum you pay to keep your cover in force.</span></p>\r\n\r\n<p ><b><span class="golossary">Procurement Fee</span></b><br>\r\n<span class="golossary_def">The total amount paid by the mortgage lender to a mortgage adviser/ intermediary, whether directly or indirectly, in connection with providing applications from customers to enter into regulated mortgage contracts with the mortgage lender.</span></p>\r\n\r\n<p ><a name=Q></a><b><span class="golossary">Remortgaging</span></b><br>\r\n<span class="golossary_def">The process of switching your mortgage loan from one lender to another without moving house.</span></p>\r\n\r\n<p ><b><span class="golossary">Repayment Mortgage</span></b><br>\r\n<span class="golossary_def">A mortgage loan funded by simple monthly repayments, calculated to repay capital and interest usually over a term of 25 years (less if preferred).</span></p>\r\n\r\n<p ><b><span class="golossary">Repayment vehicle</span></b><br>\r\n<span class="golossary_def">The means by which a mortgage loan''s capital is repaid. Examples include endowment policies, ISAs, and personal pensions.</span></p>\r\n\r\n<p ><a name=S></a><b><span class="golossary">Search</span></b><br>\r\n<span class="golossary_def">A local authority search is an examination of local planning records to uncover details of any upcoming developments near the property which could affect its future value or existing restrictions on the site.</span></p>\r\n\r\n<p ><b><span class="golossary">Second-Hand Endowment Policy (SHEP)</span></b><br>\r\n<span class="golossary_def">Endowment policies part-way through their term can sometimes be sold on the open market. Disposing of an unwanted policy in this way often produces a better price than the traditional route of early surrender. Also known as Traded Endowment Policies (TEPS).</span></p>\r\n\r\n<p ><b><span class="golossary">Secured (loan)</span></b><br>\r\n<span class="golossary_def">If you should default on your mortgage, the lender can ultimately repossess your property to recover their money. The loan is hence said to be "secured" on the property.</span></p>\r\n\r\n<p ><b><span class="golossary">Self build mortgage</span></b><br>\r\n<span class="golossary_def">A self build mortgage is designed to help you finance the building and ownership of a house that you are about to build. The UK self build mortgage market is a specialist area, because you are asking lenders to put forward money against an asset which does not exist at the beginning of the project.</span></p>\r\n\r\n<p ><b><span class="golossary">Self-certification</span></b><br>\r\n<span class="golossary_def">Where no proof is available, prospective borrowers are sometimes allowed to vouch for their own income. Self-employed applicants who lack the two years'' record of accounts that lenders would normally require most commonly use this process, known as self-certification. Many lenders charge a small premium on self-certificate business to reflect the extra risk involved.</span></p>\r\n\r\n<p ><b><span class="golossary">Self cert mortgage</span></b><br>\r\n<span class="golossary_def">A self cert mortgage is a self certification mortgage, which describes a mortgage for self-employed people who do not have pay slips or do not necessarily have a regular income to confirm their earnings to a lender. It used to be the case that the UK self certification mortgage rate tended to be substantially higher because lenders perceived this as a more risky sector to deal with. These days, by shopping around, it is possible to get a competitive self-cert mortgage, with just as many of the benefits regularly employed people enjoy. With a self cert mortgage, you declare your annual earnings and in nearly all cases the lender will not require any proof of income.  This can be particularly beneficial to people who are self-employed and might struggle to provide detailed accounts, or people with additional incomes that are not included in traditional income calculations.</span></p>\r\n\r\n<p ><b><span class="golossary">Stamp Duty</span></b><br>\r\n<span class="golossary_def">Stamp Duty is the tax you pay when you buy property or shares. You pay ''Stamp Duty Land Tax'' when you buy property and either ''Stamp Duty'' or ''Stamp Duty Reserve Tax'' when you buy shares. You pay Stamp Duty Land Tax on property like houses, flats, other buildings and land. If the purchase price is ?125,000 or less you don''t pay any Stamp Duty Land Tax at all. If it''s more than ?125,000, you pay between one and four per cent of the whole purchase price, on a sliding scale.</span></p>\r\n\r\n<p ><b><span class="golossary">Standard Variable Rate (SVR)</span></b><br>\r\n<span class="golossary_def">A mortgage lender''s main interest rate. Fixed-rate and discount loans usually switch to SVR when the special offer period expires. Conversely, tracker mortgages switch to a fixed percentage above Bank Of England Base rate (or LIBOR).</span></p>\r\n\r\n<p ><b><span class="golossary">Status</span></b><br>\r\n<span class="golossary_def">A shorthand term for the borrower''s credit record and employment situation. See "Non-Status Loan".</span></p>\r\n\r\n<p ><b><span class="golossary">Surrender</span></b><br>\r\n<span class="golossary_def">The process of cashing in an unwanted endowment policy with the insurer who sold it to you. Doing this often produces a poor return for the money invested to date in the policy''s early years.</span></p>\r\n\r\n<p ><b><span class="golossary">Survey</span></b><br>\r\n<span class="golossary_def">An expert examination of the property you are considering buying, aimed at discovering any structural flaws or repairs needed which you may have failed to notice yourself.</span></p>\r\n\r\n<p ><a name=T></a><b><span class="golossary">Term</span></b><br>\r\n<span class="golossary_def">The period of time over which your mortgage will run. Typically 25 Years or to expected retirement date if that comes first.</span></p>\r\n\r\n<p ><b><span class="golossary">Tracker</span></b><br>\r\n<span class="golossary_def">Tracker mortgages link your interest rate to a benchmark, such as Bank of England base rate. The rate you pay moves up and down in line with the benchmark selected.</span></p>\r\n\r\n<p ><b><span class="golossary">Traded Endowment Policy (TEP)</span></b><br>\r\n<span class="golossary_def">Another name for Second-Hand Endowment Policy (SHEP).</span></p>\r\n\r\n<p ><a name=U></a><b><span class="golossary">Underpayment</span></b><br>\r\n<span class="golossary_def">A mortgage repayment smaller than the regular agreed sum. Some flexible mortgages have this feature, which can be useful for people with irregular income.</span></p>\r\n');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (171, 109, 2, '', '');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (172, 110, 2, '', '');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (173, 111, 2, '', '');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (174, 112, 2, '', '');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (181, 1, 1, 'Contact information', 'We welcome your questions regarding the mortgage process. If you have specific concerns or just want some help deciding which types of mortgages are best for you, please fill out this form and press the submit button. One of our associates will contact you shortly.');
INSERT INTO [db_prefix]page_content (`id`, `id_page`, `id_lang`, `page_name`, `content`) VALUES (182, 1, 2, 'Contact information', '');


DROP TABLE IF EXISTS [db_prefix]page_link;
CREATE TABLE [db_prefix]page_link (
  id int(11) NOT NULL auto_increment,
  page_id varchar(50) NOT NULL default '0',
  link varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (1, 1, 'contactus.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (2, 2, 'callback.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (3, 3, 'about_us.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (4, 4, 'press.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (5, 6, 'faq.php?sel=6');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (6, 7, 'faq.php?sel=7');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (7, 8, 'faq.php?sel=8');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (8, 9, 'faq.php?sel=9');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (9, 10, 'faq.php?sel=10');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (10, 11, 'faq.php?sel=11');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (11, 12, 'faq.php?sel=12');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (12, 41, 'apply_online.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (13, 42, 'rate_finder.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (14, 31, 'rate_watch.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (15, 85, 'tools.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (16, 86, 'closing_costs.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (17, 87, 'products.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (18, 27, 'index.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (19, 88, 'map.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (20, 89, 'prequalify.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (21, 5, 'feedback.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (22, 13, 'product.php?id=13');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (23, 14, 'product.php?id=14');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (24, 15, 'product.php?id=15');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (25, 16, 'product.php?id=16');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (26, 17, 'product.php?id=17');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (27, 18, 'product.php?id=18');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (28, 19, 'product.php?id=19');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (29, 20, 'product.php?id=20');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (30, 29, 'product.php?id=29');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (31, 30, 'product.php?id=30');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (33, 32, 'product.php?id=32');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (34, 33, 'product.php?id=33');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (35, 34, 'product.php?id=34');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (37, 36, 'product.php?id=36');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (38, 37, 'product.php?id=37');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (39, 38, 'product.php?id=38');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (40, 39, 'product.php?id=39');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (41, 40, 'product.php?id=40');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (44, 90, 'newsview.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (45, 35, 'product.php?id=35');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (46, 103, 'myinfo.php');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (47, 104, 'tools.php#calc');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (48, 106, 'tools.php#form');
INSERT INTO [db_prefix]page_link (id, page_id, link) VALUES (49, 107, 'send_form.php');


DROP TABLE IF EXISTS [db_prefix]pages;
CREATE TABLE IF NOT EXISTS [db_prefix]pages (
  id int(11) NOT NULL auto_increment,
  id_section int(11) NOT NULL default '0',
  page_name varchar(255) character set utf8 NOT NULL default '',
  order_followin int(3) NOT NULL default '0',
  sign enum('0','1') NOT NULL default '0',
  visible enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id)
);


INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (1, 1, 'Contact information', 4, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (2, 1, 'Call back form', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (3, 7, 'About us', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (4, 1, 'In the press', 1, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (5, 1, 'Success stories', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (6, 2, 'FAQ', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (7, 2, 'Useful links', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (8, 2, 'Buying home tips', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (9, 2, 'How to get a better mortgage', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (10, 2, 'Unsatisfied with you', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (11, 2, 'The procedure', 6, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (12, 2, 'Loans for non-reside', 7, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (13, 3, 'Fixed rates', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (14, 3, 'Variable rate mortgage', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (15, 3, 'Capped rate mortgage', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (16, 3, 'Remortgage rates', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (17, 3, 'Self certification', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (18, 3, 'Cashback mortgages', 6, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (19, 3, 'Buy-to-let mortgage', 7, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (20, 3, 'Commercial mortgages', 8, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (21, 7, 'Contact us', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (22, 7, 'Call back form', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (23, 7, 'Leave a comment', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (25, 7, 'Registration page', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (26, 7, 'Login page', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (27, 7, 'Borrower homepage', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (28, 7, 'Saved changes confirmation', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (29, 3, 'Arm''s', 9, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (30, 3, 'Jumbo', 10, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (31, 7, 'Rate Watch', 11, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (32, 3, 'Bad Credit Ok', 12, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (33, 3, 'Refinancing', 13, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (34, 3, '125% Ltv', 14, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (35, 3, '100-102% Ltv', 15, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (36, 3, 'Interest Only', 16, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (37, 3, 'Home Equity', 17, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (38, 3, 'No Doc - Limited', 18, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (39, 3, 'Stated Income', 19, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (40, 3, 'Construction', 20, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (41, 7, 'Apply Online', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (42, 7, 'Mortgage Rates', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (43, 4, 'The Mortgage Loan Process', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (44, 4, 'How to shop for a Mortgage', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (45, 4, 'Guide to Self Locks', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (46, 4, 'PMI''s Lowering your Down Payment', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (47, 4, 'Handling Loan Rejection', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (48, 4, 'The Loan Closing', 6, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (49, 4, 'When your Loan is Transferred', 7, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (50, 4, 'Save Big with 15 year Loan', 8, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (51, 4, 'Your Debt exceeds your Home Value', 9, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (52, 4, 'What Happens when Applying?', 10, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (53, 4, 'How much can you Afford?', 11, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (54, 4, 'Mortgage Escrow Accounts', 12, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (55, 4, 'PMI''s Frequently asked Questions', 13, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (56, 4, 'The Loan Settlement', 14, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (57, 4, 'Managing Your Mortgage', 15, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (58, 4, 'VA Loans', 16, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (59, 4, 'Guide to Re-Financing', 17, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (60, 4, 'Deducting your Mortgage', 18, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (61, 4, 'Interest List of Mortgage related Publications', 19, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (62, 7, 'Privacy policy', 0, '1', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (63, 7, 'Electronic Disclosure', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (64, 5, 'Uniform Residential Loan Application', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (65, 5, 'Spanish Uniform Residential Loan Application', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (66, 5, 'Good Faith Estimate', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (67, 5, 'Truth in Lending Disclosure Statement (RegZ)', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (68, 5, 'Credit Report Authorization and Release', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (69, 5, 'Deed of Trust', 6, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (70, 5, 'Itemization of Amount Financed', 7, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (71, 5, 'Mortgage Loan Disclosure/Good Faith Estimate', 8, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (72, 5, 'Loan Submission Sheet', 9, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (73, 5, 'Tax Information Authorization (8821)', 10, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (74, 5, 'Self Employed Income Analysis', 11, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (75, 5, 'Borrowers&quot; Certification and Authorization', 12, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (76, 5, 'Disclosure Notices', 13, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (77, 5, 'Equal Credit Opportunity Act', 14, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (78, 5, 'Fair Lending Notice', 15, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (79, 5, 'Notice Right', 16, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (80, 5, 'Notice of Special Flood Hazard', 17, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (81, 5, 'Owner Occupancy', 18, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (82, 5, 'Appraisal Disclosure', 19, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (83, 5, 'Consumer Handbook on Adjustable Rate Mortgages (ARM)', 20, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (84, 5, 'Borrower Signature Authorization', 21, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (85, 7, 'Tools', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (86, 7, 'Closing Costs', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (87, 7, 'Products', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (88, 7, 'Site map', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (89, 7, 'Get Pre-Qualification Letter', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (90, 7, 'News', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (91, 6, 'How much am I really making an hour', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (92, 6, 'If I save a dollar a day how much would I have in the bank when I retire', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (93, 6, 'How much will that car really cost me', 3, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (94, 6, 'How do I compare different loans', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (95, 6, 'If I buy down my debt how much would I be saving', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (96, 6, 'How do I determine Bi-Weekly mortgage payments', 6, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (97, 6, 'How much will my mortgage payment be', 7, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (98, 6, 'How much will it cost me to operate this appliance', 8, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (99, 6, 'Should I get refinance', 9, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (100, 6, 'Should I rent or buy', 10, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (101, 7, 'Warning page', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (102, 7, 'News View', 0, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (103, 9, 'Profile', 1, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (104, 9, 'Calculators', 2, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (106, 9, 'Download application forms in pdf', 4, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (107, 9, 'Send application form', 5, '0', '1');
INSERT INTO [db_prefix]pages (id, id_section, page_name, order_followin, sign, visible) VALUES (108, 7, 'Mortgage Term Glossary', 0, '1', '1');


DROP TABLE IF EXISTS [db_prefix]prequalify;
CREATE TABLE [db_prefix]prequalify (
  id int(11) NOT NULL auto_increment,
  id_user int(10) NOT NULL default '0',
  loanamount decimal(10,2) default NULL,
  salesprice decimal(10,2) default NULL,
  loantype varchar(20) default NULL,
  ocstatus varchar(40) default NULL,
  proptype varchar(40) default NULL,
  name varchar(40) default NULL,
  email varchar(60) default NULL,
  address varchar(80) default NULL,
  city varchar(50) default NULL,
  state varchar(4) default NULL,
  zip varchar(10) default NULL,
  hphone varchar(15) default NULL,
  wphone varchar(15) default NULL,
  ssn varchar(15) default NULL,
  creditrating varchar(25) default NULL,
  empstatus varchar(25) default NULL,
  employer varchar(80) default NULL,
  yearswcomp decimal(2,0) default NULL,
  monthlyincome decimal(10,2) default NULL,
  liquidassets decimal(10,2) default NULL,
  retirement decimal(10,2) default NULL,
  autopayments decimal(10,2) default NULL,
  creditcardpayments decimal(10,2) default NULL,
  otherpayments decimal(10,2) default NULL,
  propertyaddress varchar(80) default NULL,
  propertycity varchar(50) default NULL,
  propertystate varchar(4) default NULL,
  propertyzip varchar(10) default NULL,
  condoname varchar(50) default NULL,
  currentalance decimal(10,2) default NULL,
  currentrate decimal(10,2) default NULL,
  currentmontpayment decimal(10,2) default NULL,
  annualpropertyTax decimal(10,2) default NULL,
  annualinsurance decimal(10,2) default NULL,
  mortgageinsurance char(3) default NULL,
  lineofcredit char(3) default NULL,
  lineofcreditBalance decimal(10,2) default NULL,
  lineofcreditwithdrawn char(3) default NULL,
  secondmortgage char(3) default NULL,
  secondmortgagebalance decimal(10,2) default NULL,
  keepconsolidate varchar(50) default NULL,
  comments varchar(255) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]rate_watch;
CREATE TABLE [db_prefix]rate_watch (
  id int(11) unsigned NOT NULL auto_increment,
  loan_officer_id int(11) unsigned default '0',
  property_type varchar(20) default '0',
  loan_amount varchar(255) default NULL,
  first_name varchar(255) default NULL,
  last_name varchar(255) default NULL,
  email varchar(255) default NULL,
  html_in_email varchar(30) default NULL,
  address varchar(255) default NULL,
  address2 varchar(255) default NULL,
  city varchar(255) default NULL,
  state varchar(4) default NULL,
  zip varchar(6) default NULL,
  fax varchar(50) default NULL,
  home_phone varchar(50) default NULL,
  work_phone varchar(50) default NULL,
  frequency varchar(15) default NULL,
  subscribed enum('Y','N') default 'Y',
  last_mail datetime default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]reference_lang_spr;
CREATE TABLE IF NOT EXISTS [db_prefix]reference_lang_spr (
  id bigint(11) NOT NULL auto_increment,
  id_section bigint(11) NOT NULL default '0',
  id_references bigint(11) NOT NULL default '0',
  lang_1 tinyblob,
  lang_2 tinyblob,
  PRIMARY KEY  (id)
);


INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (1, 1, 1, 'Contact information', 'Contact information');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (2, 1, 2, 'Call back form', 'Call back form');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (3, 1, 3, 'About us', 'About us');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (4, 1, 4, 'In the press', 'In the press');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (5, 1, 5, 'Success stories', 'Success stories');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (6, 2, 6, 'FAQ', 'FAQ');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (7, 2, 7, 'Useful links', 'Useful links');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (8, 2, 8, 'Buying home tips', 'Buying home tips');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (9, 2, 9, 'How to get a better mortgage', 'How to get a better mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (10, 2, 10, 'Unsatisfied with you', 'Unsatisfied with you');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (11, 2, 11, 'The procedure', 'The procedure');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (12, 2, 12, 'Loans for non-reside', 'Loans for non-reside');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (13, 3, 13, 'Fixed rates', 'Fixed rates');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (14, 3, 14, 'Variable rate mortgage', 'Variable rate mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (15, 3, 15, 'Capped rate mortgage', 'Capped rate mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (16, 3, 16, 'Remortgage rates', 'Remortgage rates');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (17, 3, 17, 'Self certification', 'Self certification');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (18, 3, 18, 'Cashback mortgages', 'Cashback mortgages');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (19, 3, 19, 'Buy-to-let mortgage', 'Buy-to-let mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (20, 3, 20, 'Commercial mortgages', 'Commercial mortgages');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (21, 3, 29, 'Arm''s', 'Arm''s');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (22, 3, 30, 'Jumbo', 'Jumbo');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (23, 3, 31, 'Rate Watch', 'Rate Watch');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (24, 3, 32, 'Bad Credit Ok', 'Bad Credit Ok');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (25, 3, 33, 'Refinancing', 'Refinancing');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (26, 3, 34, '125% Ltv', '125% Ltv');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (27, 3, 35, '100-102% Ltv', '100-102% Ltv');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (28, 3, 36, 'Interest Only', 'Interest Only');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (29, 3, 37, 'Home Equity', 'Home Equity');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (30, 3, 38, 'No Doc - Limited', 'No Doc - Limited');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (31, 3, 39, 'Stated Income', 'Stated Income');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (32, 3, 40, 'Construction', 'Construction');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (33, 4, 43, 'The Mortgage Loan Process', 'The Mortgage Loan Process');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (34, 4, 44, 'How to shop for a Mortgage', 'How to shop for a Mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (35, 4, 45, 'Guide to Self Locks', 'Guide to Self Locks');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (36, 4, 46, 'PMI''s Lowering your Down Payment', 'PMI''s Lowering your Down Payment');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (37, 4, 47, 'Handling Loan Rejection', 'Handling Loan Rejection');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (38, 4, 48, 'The Loan Closing', 'The Loan Closing');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (39, 4, 49, 'When your Loan is Transferred', 'When your Loan is Transferred');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (40, 4, 50, 'Save Big with 15 year Loan', 'Save Big with 15 year Loan');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (41, 4, 51, 'Your Debt exceeds your Home Value', 'Your Debt exceeds your Home Value');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (42, 4, 52, 'What Happens when Applying?', 'What Happens when Applying?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (43, 4, 53, 'How much can you Afford?', 'How much can you Afford?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (44, 4, 54, 'Mortgage Escrow Accounts', 'Mortgage Escrow Accounts');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (45, 4, 55, 'PMI''s Frequently asked Questions', 'PMI''s Frequently asked Questions');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (46, 4, 56, 'The Loan Settlement', 'The Loan Settlement');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (47, 4, 57, 'Managing Your Mortgage', 'Managing Your Mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (48, 4, 58, 'VA Loans', 'VA Loans');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (49, 4, 59, 'Guide to Re-Financing', 'Guide to Re-Financing');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (50, 4, 60, 'Deducting your Mortgage', 'Deducting your Mortgage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (51, 4, 61, 'Interest List of Mortgage related Publications', 'Interest List of Mortgage related Publications');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (52, 5, 64, 'Uniform Residential Loan Application', 'Uniform Residential Loan Application');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (53, 5, 65, 'Spanish Uniform Residential Loan Application', 'Spanish Uniform Residential Loan Application');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (54, 5, 66, 'Good Faith Estimate', 'Good Faith Estimate');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (55, 5, 67, 'Truth in Lending Disclosure Statement (RegZ)', 'Truth in Lending Disclosure Statement (RegZ)');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (56, 5, 68, 'Credit Report Authorization and Release', 'Credit Report Authorization and Release');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (57, 5, 69, 'Deed of Trust', 'Deed of Trust');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (58, 5, 70, 'Itemization of Amount Financed', 'Itemization of Amount Financed');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (59, 5, 71, 'Mortgage Loan Disclosure/Good Faith Estimate', 'Mortgage Loan Disclosure/Good Faith Estimate');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (60, 5, 72, 'Loan Submission Sheet', 'Loan Submission Sheet');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (61, 5, 73, 'Tax Information Authorization (8821)', 'Tax Information Authorization (8821)');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (62, 5, 74, 'Self Employed Income Analysis', 'Self Employed Income Analysis');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (63, 5, 75, 'Borrowers&quot; Certification and Authorization', 'Borrowers&quot; Certification and Authorization');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (64, 5, 76, 'Disclosure Notices', 'Disclosure Notices');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (65, 5, 77, 'Equal Credit Opportunity Act', 'Equal Credit Opportunity Act');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (66, 5, 78, 'Fair Lending Notice', 'Fair Lending Notice');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (67, 5, 79, 'Notice Right', 'Notice Right');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (68, 5, 80, 'Notice of Special Flood Hazard', 'Notice of Special Flood Hazard');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (69, 5, 81, 'Owner Occupancy', 'Owner Occupancy');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (70, 5, 82, 'Appraisal Disclosure', 'Appraisal Disclosure');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (71, 5, 83, 'Consumer Handbook on Adjustable Rate Mortgages', 'Consumer Handbook on Adjustable Rate Mortgages');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (72, 5, 84, 'Borrower Signature Authorization', 'Borrower Signature Authorization');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (73, 6, 91, 'How much am I really making an hour?', 'How much am I really making an hour?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (74, 6, 92, 'If I save a dollar a day how much would I have in the bank when I retire?', 'If I save a dollar a day how much would I have in the bank when I retire?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (75, 6, 93, 'How much will that car really cost me?', 'How much will that car really cost me?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (76, 6, 94, 'How do I compare different loans?', 'How do I compare different loans?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (77, 6, 95, 'If I buy down my debt how much would I be saving?', 'If I buy down my debt how much would I be saving?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (78, 6, 96, 'How do I determine Bi-Weekly mortgage payments?', 'How do I determine Bi-Weekly mortgage payments?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (79, 6, 97, 'How much will my mortgage payment be?', 'How much will my mortgage payment be?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (80, 6, 98, 'How much will it cost me to operate this appliance?', 'How much will it cost me to operate this appliance?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (81, 6, 99, 'Should I get refinance?', 'Should I get refinance?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (82, 6, 100, 'Should I rent or buy?', 'Should I rent or buy?');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (83, 7, 101, 'Warning page', 'Warning page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (84, 8, 1, 'USA', 'USA');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (85, 9, 103, 'My Profile', 'My Profile');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (86, 9, 104, 'Calculators', 'Calculators');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (87, 9, 105, 'My application form', 'My application form');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (88, 9, 106, 'Download application forms', 'Download application forms');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (89, 9, 107, 'Send application form', 'Send application form');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (90, 7, 25, 'Registration', 'Registration');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (91, 7, 41, 'Apply Online', 'Apply Online');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (92, 7, 27, 'Borrower homepage', 'Borrower homepage');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (93, 7, 42, 'Mortgage Rates', 'Mortgage Rates');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (94, 7, 86, 'Customary Closing Costs', 'Customary Closing Costs');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (95, 7, 89, 'Get Pre-Qualification Letter', 'Get Pre-Qualification Letter');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (96, 7, 85, 'Tools', 'Tools');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (97, 7, 21, 'Contact Us', 'Contact Us');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (98, 7, 3, 'About Us', 'About Us');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (99, 7, 108, 'Mortgage Term Glossary', 'Mortgage Term Glossary');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (100, 7, 87, 'Products', 'Products');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (101, 7, 88, 'Site map', 'Site map');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (102, 7, 62, 'Privacy policy', 'Privacy policy');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (103, 7, 102, 'Viewing of news', 'Viewing of news');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (104, 7, 90, 'News', 'News');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (105, 7, 101, 'Warning page', 'Warning page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (107, 8, 2, 'UK', 'UK');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (108, 7, 63, 'Electronic Disclosure', 'Electronic Disclosure');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (109, 7, 22, 'Call back form thanks page', 'Call back form thanks page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (110, 7, 23, 'Success stories thanks page', 'Success stories thanks page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (111, 7, 24, 'Sent application thanks page', 'Sent application thanks page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (112, 7, 26, 'Login page', 'Login page');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (113, 7, 28, 'Saved changes confirmation', 'Saved changes confirmation');
INSERT INTO [db_prefix]reference_lang_spr (id, id_section, id_references, lang_1, lang_2) VALUES (114, 7, 31, 'Rate Watch', 'Rate Watch');


DROP TABLE IF EXISTS [db_prefix]refinance;
CREATE TABLE [db_prefix]refinance (
  id int(11) unsigned NOT NULL auto_increment,
  id_user int(10) NOT NULL default '0',
  property_will_be varchar(10) default NULL,
  prop_type varchar(10) default NULL,
  prop_street varchar(255) default NULL,
  prop_city varchar(255) default NULL,
  loan_state varchar(4) default NULL,
  prop_zipcode int(5) unsigned default NULL,
  prop_value decimal(10,2) default NULL,
  loan_amount decimal(10,2) default NULL,
  loan_type varchar(10) default NULL,
  refi_reason varchar(20) default NULL,
  first_mortgage_balance decimal(10,2) default NULL,
  first_mtg_interest_rate decimal(10,2) default NULL,
  second_mortgage_balance decimal(10,2) default NULL,
  second_mtg_interest_rate decimal(10,2) default NULL,
  b_first_name varchar(255) default NULL,
  b_middle_name varchar(10) default NULL,
  b_last_name varchar(255) default NULL,
  b_suffix varchar(10) default NULL,
  application_type varchar(10) default NULL,
  b_home_telephone varchar(11) default NULL,
  b_home_besttime varchar(20) default NULL,
  b_work_telephone varchar(11) default NULL,
  b_work_besttime varchar(20) default NULL,
  email varchar(255) default NULL,
  ssn varchar(15) default NULL,
  self_grade_credit_score varchar(10) default NULL,
  security_question varchar(255) default NULL,
  security_answer varchar(255) default NULL,
  b_base_income decimal(10,2) default NULL,
  consumer_debt decimal(10,2) default NULL,
  mail_subscribe enum('0','1') default NULL,
  agreement_flag enum('N','Y') default NULL,
  ignore_agreement enum('N','Y') default NULL,
  password varchar(10) default NULL,
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]reminders;
CREATE TABLE [db_prefix]reminders (
  id int(11) NOT NULL auto_increment,
  date date NOT NULL default '0000-00-00',
  time time NOT NULL default '00:00:00',
  descr varchar(255) NOT NULL default '',
  user_id int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]section_page;
CREATE TABLE IF NOT EXISTS [db_prefix]section_page (
  id int(11) NOT NULL auto_increment,
  page_id int(11) NOT NULL default '0',
  name varchar(255) character set utf8 NOT NULL default '',
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (1, 1, 'Contact Us');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (2, 6, 'FAQ');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (3, 87, 'Products');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (4, 85, 'Mortgage Resources');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (5, 85, 'Pdf Forms');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (6, 85, 'Calculators');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (7, 0, 'Other Pages');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (8, 0, 'Location');
INSERT INTO [db_prefix]section_page (id, page_id, name) VALUES (9, 27, 'Homepage');


DROP TABLE IF EXISTS [db_prefix]seo_conf;
CREATE TABLE [db_prefix]seo_conf (
  id int(11) NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  value text NOT NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]seo_conf (id, name, value) VALUES (1, 'Site keywords', 'mortgage');
INSERT INTO [db_prefix]seo_conf (id, name, value) VALUES (2, 'Site Title', 'Mortgage');
INSERT INTO [db_prefix]seo_conf (id, name, value) VALUES (3, 'Site Description', 'Best loan provider in CA. Lowest rates, friendly service');


DROP TABLE IF EXISTS [db_prefix]settings;
CREATE TABLE [db_prefix]settings (
  id int(3) NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  value varchar(255) NOT NULL default '',
  comment varchar(255) default NULL,
  PRIMARY KEY  (id)
);

INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (1, 'default_lang', '2', 'default language');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (2, 'path_lang', '/languages', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (3, 'site_unit_costunit', 'USD', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (4, 'payment_type', '1', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (5, 'rate_email', 'test1-pilot@mail.ru', 'Rate e-mail');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (6, 'site_email', 'test1-pilot@mail.ru', 'Site email');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (7, 'default_image', '/images', '');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (8, 'default_css', '/css', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (9, 'default_icon', '/default.gif', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (10, 'icon_path', '/uploades/icon', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (11, 'signature', 'Yours Sincerely, <br>Administrator', 'The signature of the administrator');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (12, 'aplication_form', '/uploades/app_form', 'Aplication form');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (13, 'date_format', '%Y-%m-%d', 'Format date');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (14, 'admin_theme_path', '/templates/admin', '');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (15, 'index_theme_path', '/templates/pilot_3_theme', '');
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (16, 'site_unit_name', 'Magix', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (17, 'site_unit_cost', '0.01', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (18, 'pilot_mortgage_version', 'MCH_2008_01', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (19, 'login_count', '0', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (20, 'use_registration', '1', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (21, 'use_rate_information', '1', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (22, 'images_path', '/uploades/images', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (23, 'zip_letters', '0', NULL);
INSERT INTO [db_prefix]settings (id, name, value, comment) VALUES (24, 'zip_count', '5', NULL);


DROP TABLE IF EXISTS [db_prefix]site_statistic;
CREATE TABLE [db_prefix]site_statistic (
  id int(11) NOT NULL auto_increment,
  data date NOT NULL default '0000-00-00',
  id_page varchar(20) NOT NULL default '0',
  PRIMARY KEY  (id)
);


DROP TABLE IF EXISTS [db_prefix]templates;
CREATE TABLE IF NOT EXISTS [db_prefix]templates (
  id int(3) NOT NULL auto_increment,
  name varchar (255) NOT NULL,
  path varchar (255) NOT NULL,
  PRIMARY KEY(id)
);
INSERT INTO [db_prefix]templates (id, name, path) VALUES ('1', 'pilot theme', '/templates/pilot_3_theme');


DROP TABLE IF EXISTS [db_prefix]themes;
CREATE TABLE IF NOT EXISTS [db_prefix]themes (
  id int(3) NOT NULL auto_increment,
  id_tpl int(3) NOT NULL,
  name varchar (255) NOT NULL,
  path_css varchar (255) NOT NULL,
  path_images varchar (255) NOT NULL,
  PRIMARY KEY(id)
);
INSERT INTO [db_prefix]themes (id, id_tpl, name, path_css, path_images) VALUES ('1', '1', 'color theme 1', '/css', '/images');
INSERT INTO [db_prefix]themes (id, id_tpl, name, path_css, path_images) VALUES ('2', '1', 'color theme 2', '/theme2/css', '/theme2/images');
INSERT INTO [db_prefix]themes (id, id_tpl, name, path_css, path_images) VALUES ('3', '1', 'color theme 3', '/theme3/css', '/theme3/images');


DROP TABLE IF EXISTS [db_prefix]users;
CREATE TABLE [db_prefix]users (
  id int(11) NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  login varchar(50) NOT NULL default '',
  passw varchar(50) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  hphone varchar(50) NOT NULL default '',
  dphone varchar(50) NOT NULL default '',
  mphone varchar(50) NOT NULL default '',
  country int(10) NOT NULL default '0',
  region int(10) NOT NULL default '0',
  city int(10) NOT NULL default '0',
  addr varchar(50) NOT NULL default '',
  post varchar(50) NOT NULL default '',
  best_cont varchar(50) NOT NULL default '',
  iam varchar(50) NOT NULL default '',
  notice varchar(50) NOT NULL default '',
  photo varchar(50) NOT NULL default '',
  root_user int(1) NOT NULL default '0',
  is_loan enum('0','1') NOT NULL default '0',
  guest_user enum('0','1') NOT NULL DEFAULT '0',
  status enum('0','1','2') NOT NULL default '0',
  date_last_seen datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  date_registration datetime NOT NULL default '0000-00-00 00:00:00',
  login_count int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY  (id),
  KEY id (id)
);

INSERT INTO [db_prefix]users (id, name, login, passw, email, hphone, dphone, mphone, country, region, city, addr, post, best_cont, iam, notice, photo, root_user, is_loan, guest_user, status, date_last_seen, date_registration, login_count) VALUES (1, 'guest', 'guest', '', '', '', '', '', 0, 0, 0, '', '', '', '', '', '', 0, '0', '1', '0', '2008-02-15 13:35:44', '0000-00-00 00:00:00', 0);
INSERT INTO [db_prefix]users (id, name, login, passw, email, hphone, dphone, mphone, country, region, city, addr, post, best_cont, iam, notice, photo, root_user, is_loan, guest_user, status, date_last_seen, date_registration, login_count) VALUES (2, 'Admin Administrator', 'admin', 'e00cf25ad42683b3df678c61f42c6bda', 'test1-pilot@mail.ru', '', '', '', 0, 0, 0, '', '', '', '', '', '', 1, '0', '0', '0', '2008-02-15 14:28:13', '0000-00-00 00:00:00', 0);

DROP TABLE IF EXISTS [db_prefix]users_loans;
CREATE TABLE [db_prefix]users_loans (
  id int(3) NOT NULL auto_increment,
  id_user int(3) NOT NULL default '0',
  status enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id (id)
);